LibGridXC library
-----------------

LibGridXC provides routines to calculate the exchange and correlation
energy and potential in spherical (i.e. an atom) or periodic systems,
using a variety of LDA and GGA functionals, as well as the van der
Waals DFT functionals of Dion et al (PRL 92, 246401 (2004)), Lee et al
(PRB 82, 081101 (2010)), Klimes et al (JPCM 22, 022201 (2009)), and
Vydrov and VanVoorhis (JCP 133, 244103 (2010)) implemented as
described by Roman-Perez and Soler (PRL 103, 096102 (2009))

An interface to the Libxc library is also available.

Documentation, generated by the FORD utility from the source and from
the material in docs/pages, is available in html form
[here](https://siesta-project.github.io/gridxc-docs/page/index.html). It can
also be generated locally.

The INSTALL file contains basic compilation instructions.

Originally (as SiestaXC), this library was part of the SIESTA
distribution. SiestaXC was coded by Jose Soler. The library is now
maintained by Alberto Garcia.

To generate a local copy of the documentation, go to the
top level and invoke the FORD documentation command:

   ford -I $LIBXC_ROOT/include libgridxc.md

where LIBXC_ROOT points to the installation directory for libxc.

You can then open the /tmp/gridxc-docs/index.html file in your
browser.

(You can find information about FORD in
   https://github.com/cmacmackin/ford )

Alternatively, you can browse the documentation online at
the GitHub pages site:

   https://siesta-project.github.io/gridxc-docs/


NOTES FOR DEVELOPERS

The GitHub Pages site can be set up and updated semi-automatically, with
some subtleties:

- There should be a (separate) working directory associated to the
  GitHub repository 

      git@github.com:siesta-project/gridxc-docs.git

- The 'ford' command writes its output to /tmp/gridxc-docs (see
  'libgridxc.md' at the top level). This is so since FORD obliterates
  everthing under the target directory when it runs, including any
  .git directory found there.

- It is then necessary to update the contents of the 'gridxc-docs'
  source working directory. This is done using the 'sync.sh' file
  in that directory, which runs an 'rsync' process. Execute, in
  the working directory:

     sh sync.sh

- Finally, the changes need to be 'git add'ed:

    git add -A

  committed

    git commit -m"Docs update"

  and pushed

    git push

For reference, the contents of the 'sync.sh' file are
reproduced here:
---------------------------------------
#!/bin/sh
#
# Use this file to sync the contents of FORD's target directory
# and the sources for the GitHub Pages documentation
#
# Note the exclusions, to avoid removing the Git control file and this very same file.
#
FORD_TARGET=/tmp/gridxc-docs/   # Note trailing slash
rsync -av --delete --exclude=README.md \
          --exclude=.git \
          --exclude=sync.sh ${FORD_TARGET} .
---------------------------------------

#if defined HAVE_CONFIG_H
#include "config.h"
#endif

!!@LICENSE
!
!     MODULE xc_hybrids
!
! Copyright Honghui Shang, 2010
!           Xinming Qin, 2013
!           Yann Pouillon, 2017, 2018, 2019
!
! This module implements the semi-local part of the HSE06 and PBE0
! exchange-correlation functionals.
!
! Standalone routines written by Honghui Shang, April 01, 2010
! Edited by Xinming Qin, December 12, 2013
! Ported to SIESTA 4.x by Yann Pouillon, 2017-2018
! Refactored into a Fortran module by Yann Pouillon, September, 2019
!-----------------------------------------------------------------------
MODULE gridxc_hybrids

  IMPLICIT NONE

  PRIVATE

  PUBLIC :: hsexc  ! HSE06 XC functional
  PUBLIC :: pbe0xc ! PBE0 XC functional

CONTAINS

  ! ********************************************************************
  ! Implements HSE Generalized-Gradient-Approximation.
  ! Ref: JOURNAL OF CHEMICAL PHYSICS VOLUME 120, NUMBER 16 (2004)
  ! edited from  L.C.Balbas and J.M.Soler. December 1996. Version 0.5.
  ! Coded by shanghui, 2010.04.01
  ! Modified by xmqin, 2013,09.12
  ! Set omega as an input parameter read from .fdf
  ! ******** INPUT *****************************************************
  ! INTEGER IREL           : Relativistic-exchange switch (0=No, 1=Yes)
  ! INTEGER nspin          : Number of spin polarizations (1 or 2)
  ! REAL*8  Dens(nspin)    : Total electron density (if nspin=1) or
  !                           spin electron density (if nspin=2)
  ! REAL*8  GDens(3,nspin) : Total or spin density gradient
  ! ******** OUTPUT ****************************************************
  ! REAL*8  EX             : Exchange energy density
  ! REAL*8  EC             : Correlation energy density
  ! REAL*8  DEXDD(nspin)   : Partial derivative
  !                           d(DensTot*Ex)/dDens(ispin),
  !                           where DensTot = Sum_ispin( Dens(ispin) )
  !                          For a constant density, this is the
  !                          exchange potential
  ! REAL*8  DECDD(nspin)   : Partial derivative
  !                           d(DensTot*Ec)/dDens(ispin),
  !                           where DensTot = Sum_ispin( Dens(ispin) )
  !                          For a constant density, this is the
  !                          correlation potential
  ! REAL*8  DEXDGD(3,nspin): Partial derivative
  !                           d(DensTot*Ex)/d(GradDens(i,ispin))
  ! REAL*8  DECDGD(3,nspin): Partial derivative
  !                           d(DensTot*Ec)/d(GradDens(i,ispin))
  ! ********* UNITS ****************************************************
  ! Lengths in Bohr
  ! Densities in electrons per Bohr**3
  ! Energies in Hartrees
  ! Gradient vectors in cartesian coordinates
  ! ********* ROUTINES CALLED ******************************************
  ! EXCHNG, PW92C
  ! ********************************************************************
  SUBROUTINE HSEXC(Irel, Nspin, Dens, Gdens, Ex, Ec, Dexdd, Decdd, &
               Dexdgd, Decdgd)
 
    USE gridxc_precision, ONLY: dp
    USE gridxc_lda, ONLY: EXCHNG, PW92C
    USE gridxc_xwpbe, ONLY: XWPBE

    IMPLICIT NONE
 
    INTEGER, INTENT(IN) :: Irel, Nspin
    REAL(dp), INTENT(IN) :: Dens(Nspin), Gdens(3,Nspin)
    REAL(dp), INTENT(INOUT) :: Decdd(Nspin), Decdgd(3,Nspin), &
      Dexdd(Nspin), Dexdgd(3,Nspin), Ec, Ex
 
    ! Internal variables
    INTEGER :: is, ix
 
    REAL(dp) :: a, beta, d(2), dadd, decudd, df1dd, &
      df2dd, df3dd, df4dd, df1dgd, df3dgd, df4dgd, &
      dfcdd(2), dfcdgd(3,2), dfdd, dfdgd, dfxdd(2), &
      dfxdgd(3,2), dhdd, dhdgd, dkfdd, dksdd, dpdd, &
      dpdz, drsdd, ds(2), dsdd, dsdgd, dt, dtdd, dtdgd, &
      dzdd(2), ecunif, exunif, f, f1, f2, f3, &
      f4, fc, fx, gamma, gd(3,2), gdm(2), &
      gdms, gdmt, gds, gdt(3), h, kappa, &
      kf, kfs, ks, mu, phi, pi, rs, s, t, &
      vcunif(2), vxunif(2), zeta
    REAL(dp) :: d_left, kfs_left, s_left, fsr_left, d_right, &
      kfs_right, s_right, fsr_right
    REAL(dp) :: fx_pbe, fx_cp2k, dfxdd_cp2k(2), dfxdgd_cp2k(3,2)
 
    ! Lower bounds of density and its gradient to avoid divisions by zero
    REAL(dp), PARAMETER :: DENMIN=1.D-12
    REAL(dp), PARAMETER :: GDMIN=1.D-12
 
    ! Fix some numerical parameters
    REAL(dp), PARAMETER :: FOUTHD=4.D0/3.D0
    REAL(dp), PARAMETER :: HALF=0.5D0
    REAL(dp), PARAMETER :: THD=1.D0/3.D0
    REAL(dp), PARAMETER :: THRHLF=1.5D0
    REAL(dp), PARAMETER :: TWO=2.D0
    REAL(dp), PARAMETER :: TWOTHD=2.D0/3.D0
 
    ! Fix some more numerical constants
    pi = 4*ATAN(1.D0)
    beta = 0.066725D0
    gamma = (1-LOG(TWO))/pi**2
    mu = beta*pi**2/3
    kappa = 0.804D0
 
    ! Translate density and its gradient to new variables
    IF ( Nspin==1 ) THEN
       d(1) = HALF*Dens(1)
       d(2) = d(1)
       dt = MAX(DENMIN,Dens(1))
       DO ix = 1, 3
          gd(ix,1) = HALF*Gdens(ix,1)
          gd(ix,2) = gd(ix,1)
          gdt(ix) = Gdens(ix,1)
       ENDDO
    ELSE
       d(1) = Dens(1)
       d(2) = Dens(2)
       dt = MAX(DENMIN,Dens(1)+Dens(2))
       DO ix = 1, 3
          gd(ix,1) = Gdens(ix,1)
          gd(ix,2) = Gdens(ix,2)
          gdt(ix) = Gdens(ix,1) + Gdens(ix,2)
       ENDDO
    ENDIF
    gdm(1) = SQRT(gd(1,1)**2+gd(2,1)**2+gd(3,1)**2)
    gdm(2) = SQRT(gd(1,2)**2+gd(2,2)**2+gd(3,2)**2)
    gdmt = SQRT(gdt(1)**2+gdt(2)**2+gdt(3)**2)
    gdmt = MAX(GDMIN,gdmt)
 
    ! Find local correlation energy and potential
    CALL PW92C(2, d, ecunif, vcunif)
 
    ! Find total correlation energy
    rs = (3/(4*pi*dt))**THD
    kf = (3*pi**2*dt)**THD
    ks = SQRT(4*kf/pi)
    zeta = (d(1)-d(2))/dt
    zeta = MAX(-1.D0+DENMIN,zeta)
    zeta = MIN(1.D0-DENMIN,zeta)
    phi = HALF*((1+zeta)**TWOTHD+(1-zeta)**TWOTHD)
    t = gdmt/(2*phi*ks*dt)
    f1 = ecunif/gamma/phi**3
    f2 = EXP(-f1)
    a = beta/gamma/(f2-1)
    f3 = t**2 + a*t**4
    f4 = beta/gamma*f3/(1+a*f3)
    h = gamma*phi**3*LOG(1+f4)
    fc = ecunif + h
 
    ! Find correlation energy derivatives
    drsdd = -(THD*rs/dt)
    dkfdd = THD*kf/dt
    dksdd = HALF*ks*dkfdd/kf
    dzdd(1) = 1/dt - zeta/dt
    dzdd(2) = -(1/dt) - zeta/dt
    dpdz = HALF*TWOTHD*(1/(1+zeta)**THD-1/(1-zeta)**THD)
    DO is = 1, 2
       decudd = (vcunif(is)-ecunif)/dt
       dpdd = dpdz*dzdd(is)
       dtdd = (-t)*(dpdd/phi+dksdd/ks+1/dt)
       df1dd = f1*(decudd/ecunif-3*dpdd/phi)
       df2dd = (-f2)*df1dd
       dadd = (-a)*df2dd/(f2-1)
       df3dd = (2*t+4*a*t**3)*dtdd + dadd*t**4
       df4dd = f4*(df3dd/f3-(dadd*f3+a*df3dd)/(1+a*f3))
       dhdd = 3*h*dpdd/phi
       dhdd = dhdd + gamma*phi**3*df4dd/(1+f4)
       dfcdd(is) = vcunif(is) + h + dt*dhdd
 
       DO ix = 1, 3
          dtdgd = (t/gdmt)*gdt(ix)/gdmt
          df3dgd = dtdgd*(2*t+4*a*t**3)
          df4dgd = f4*df3dgd*(1/f3-a/(1+a*f3))
          dhdgd = gamma*phi**3*df4dgd/(1+f4)
          dfcdgd(ix,is) = dt*dhdgd
       ENDDO
    ENDDO
 
    ! Find exchange energy and potential
    CALL XWPBE(Nspin, Dens, Gdens, fx_cp2k, dfxdd_cp2k, dfxdgd_cp2k)
    fx_cp2k = fx_cp2k/dt
 
    ! Find exchange energy and potential
    fx = 0
    DO is = 1, 2
       ds(is) = MAX(DENMIN,2*d(is))
       gdms = MAX(GDMIN,2*gdm(is))
       kfs = (3*pi**2*ds(is))**THD
       s = gdms/(2*kfs*ds(is))
       f1 = 1 + mu*s**2/kappa
       f = 1 + kappa - kappa/f1
       !
       ! Note nspin=1 in call to exchng...
       !
       CALL EXCHNG(Irel, 1, ds(is), exunif, vxunif(is))
       fx = fx + ds(is)*exunif*f
 
       dkfdd = THD*kfs/ds(is)
       dsdd = s*(-(dkfdd/kfs)-1/ds(is))
       df1dd = 2*(f1-1)*dsdd/s
       dfdd = kappa*df1dd/f1**2
       dfxdd(is) = vxunif(is)*f + ds(is)*exunif*dfdd
 
       DO ix = 1, 3
          gds = 2*gd(ix,is)
          dsdgd = (s/gdms)*gds/gdms
          df1dgd = 2*mu*s*dsdgd/kappa
          dfdgd = kappa*df1dgd/f1**2
          dfxdgd(ix,is) = ds(is)*exunif*dfdgd
       ENDDO
    ENDDO
    fx = HALF*fx/dt
 
    ! Set output arguments
    Ex = fx_cp2k
    Ec = fc
    DO is = 1, Nspin
       Dexdd(is) = dfxdd_cp2k(is)
       Decdd(is) = dfcdd(is)
       DO ix = 1, 3
          Dexdgd(ix,is) = dfxdgd_cp2k(ix,is)
          Decdgd(ix,is) = dfcdgd(ix,is)
       ENDDO
    ENDDO
 
  END SUBROUTINE HSEXC

  ! ********************************************************************
  ! Implements Perdew-Burke-Ernzerhof Generalized-Gradient-Approximation.
  ! Ref: J.P.Perdew, K.Burke & M.Ernzerhof, PRL 77, 3865 (1996)
  ! Written by L.C.Balbas and J.M.Soler. December 1996. Version 0.5.
  ! Add an fator=0.75 for Exchange term, Correlaton term is unchanged.
  ! ******** INPUT *****************************************************
  ! INTEGER IREL           : Relativistic-exchange switch (0=No, 1=Yes)
  ! INTEGER nspin          : Number of spin polarizations (1 or 2)
  ! REAL*8  Dens(nspin)    : Total electron density (if nspin=1) or
  !                           spin electron density (if nspin=2)
  ! REAL*8  GDens(3,nspin) : Total or spin density gradient
  ! ******** OUTPUT ****************************************************
  ! REAL*8  EX             : Exchange energy density
  ! REAL*8  EC             : Correlation energy density
  ! REAL*8  DEXDD(nspin)   : Partial derivative
  !                           d(DensTot*Ex)/dDens(ispin),
  !                           where DensTot = Sum_ispin( Dens(ispin) )
  !                          For a constant density, this is the
  !                          exchange potential
  ! REAL*8  DECDD(nspin)   : Partial derivative
  !                           d(DensTot*Ec)/dDens(ispin),
  !                           where DensTot = Sum_ispin( Dens(ispin) )
  !                          For a constant density, this is the
  !                          correlation potential
  ! REAL*8  DEXDGD(3,nspin): Partial derivative
  !                           d(DensTot*Ex)/d(GradDens(i,ispin))
  ! REAL*8  DECDGD(3,nspin): Partial derivative
  !                           d(DensTot*Ec)/d(GradDens(i,ispin))
  ! ********* UNITS ****************************************************
  ! Lengths in Bohr
  ! Densities in electrons per Bohr**3
  ! Energies in Hartrees
  ! Gradient vectors in cartesian coordinates
  ! ********* ROUTINES CALLED ******************************************
  ! EXCHNG, PW92C
  ! ********************************************************************
  SUBROUTINE PBE0XC(Irel, Nspin, Dens, Gdens, Ex, Ec, Dexdd, Decdd, &
               Dexdgd, Decdgd)
 
    USE gridxc_precision, ONLY: dp
    USE gridxc_lda, ONLY: EXCHNG, PW92C

    IMPLICIT NONE

    INTEGER, INTENT(IN) :: Irel, Nspin
    REAL(dp), INTENT(IN) :: Dens(Nspin), Gdens(3,Nspin)
    REAL(dp), INTENT(INOUT) :: Decdd(Nspin), Decdgd(3,Nspin), &
      Dexdd(Nspin), Dexdgd(3,Nspin), Ec, Ex
 
    ! Internal variables
    INTEGER :: is, ix
 
    REAL(dp) :: a, beta, d(2), dadd, decudd, df1dd,    &
      df2dd, df3dd, df4dd, df1dgd, df3dgd, df4dgd,       &
      dfcdd(2), dfcdgd(3,2), dfdd, dfdgd, dfxdd(2),       &
      dfxdgd(3,2), dhdd, dhdgd, dkfdd, dksdd, dpdd,      &
      dpdz, drsdd, ds(2), dsdd, dsdgd, dt, dtdd, dtdgd,&
      dzdd(2), ecunif, exunif, f, f1, f2, f3, &
      f4, fc, fx, gamma, gd(3,2), gdm(2),       &
      gdms, gdmt, gds, gdt(3), h, kappa,  &
      kf, kfs, ks, mu, phi, pi, rs, s, t,       &
      vcunif(2), vxunif(2), zeta
 
    ! Lower bounds of density and its gradient to avoid divisions by zero
    REAL(dp), PARAMETER :: DENMIN=1.D-12
    REAL(dp), PARAMETER :: GDMIN=1.D-12
 
    ! Fix some numerical parameters
    REAL(dp), PARAMETER :: FOUTHD=4.D0/3.D0
    REAL(dp), PARAMETER :: HALF=0.5D0
    REAL(dp), PARAMETER :: THD=1.D0/3.D0
    REAL(dp), PARAMETER :: THRHLF=1.5D0
    REAL(dp), PARAMETER :: TWO=2.D0
    REAL(dp), PARAMETER :: TWOTHD=2.D0/3.D0
 
    ! Exchange factor 3/4---XC_PBE0=3/4*X_PBE+C_PBE+1/4X_HFX
    REAL(dp), PARAMETER :: FACTOR=0.75D0
 
    ! Fix some more numerical constants
    pi = 4*ATAN(1.D0)
    beta = 0.066725D0
    gamma = (1-LOG(TWO))/pi**2
    mu = beta*pi**2/3
    kappa = 0.804D0
 
    ! Translate density and its gradient to new variables
    IF ( Nspin==1 ) THEN
       d(1) = HALF*Dens(1)
       d(2) = d(1)
       dt = MAX(DENMIN,Dens(1))
       DO ix = 1, 3
          gd(ix,1) = HALF*Gdens(ix,1)
          gd(ix,2) = gd(ix,1)
          gdt(ix) = Gdens(ix,1)
       ENDDO
    ELSE
       d(1) = Dens(1)
       d(2) = Dens(2)
       dt = MAX(DENMIN,Dens(1)+Dens(2))
       DO ix = 1, 3
          gd(ix,1) = Gdens(ix,1)
          gd(ix,2) = Gdens(ix,2)
          gdt(ix) = Gdens(ix,1) + Gdens(ix,2)
       ENDDO
    ENDIF
    gdm(1) = SQRT(gd(1,1)**2+gd(2,1)**2+gd(3,1)**2)
    gdm(2) = SQRT(gd(1,2)**2+gd(2,2)**2+gd(3,2)**2)
    gdmt = SQRT(gdt(1)**2+gdt(2)**2+gdt(3)**2)
    gdmt = MAX(GDMIN,gdmt)
 
    ! Find local correlation energy and potential
    CALL PW92C(2,d,ecunif,vcunif)
 
    ! Find total correlation energy
    rs = (3/(4*pi*dt))**THD
    kf = (3*pi**2*dt)**THD
    ks = SQRT(4*kf/pi)
    zeta = (d(1)-d(2))/dt
    zeta = MAX(-1.D0+DENMIN,zeta)
    zeta = MIN(1.D0-DENMIN,zeta)
    phi = HALF*((1+zeta)**TWOTHD+(1-zeta)**TWOTHD)
    t = gdmt/(2*phi*ks*dt)
    f1 = ecunif/gamma/phi**3
    f2 = EXP(-f1)
    a = beta/gamma/(f2-1)
    f3 = t**2 + a*t**4
    f4 = beta/gamma*f3/(1+a*f3)
    h = gamma*phi**3*LOG(1+f4)
    fc = ecunif + h
 
    ! Find correlation energy derivatives
    drsdd = -(THD*rs/dt)
    dkfdd = THD*kf/dt
    dksdd = HALF*ks*dkfdd/kf
    dzdd(1) = 1/dt - zeta/dt
    dzdd(2) = -(1/dt) - zeta/dt
    dpdz = HALF*TWOTHD*(1/(1+zeta)**THD-1/(1-zeta)**THD)
    DO is = 1, 2
       decudd = (vcunif(is)-ecunif)/dt
       dpdd = dpdz*dzdd(is)
       dtdd = (-t)*(dpdd/phi+dksdd/ks+1/dt)
       df1dd = f1*(decudd/ecunif-3*dpdd/phi)
       df2dd = (-f2)*df1dd
       dadd = (-a)*df2dd/(f2-1)
       df3dd = (2*t+4*a*t**3)*dtdd + dadd*t**4
       df4dd = f4*(df3dd/f3-(dadd*f3+a*df3dd)/(1+a*f3))
       dhdd = 3*h*dpdd/phi
       dhdd = dhdd + gamma*phi**3*df4dd/(1+f4)
       dfcdd(is) = vcunif(is) + h + dt*dhdd
 
       DO ix = 1, 3
          dtdgd = (t/gdmt)*gdt(ix)/gdmt
          df3dgd = dtdgd*(2*t+4*a*t**3)
          df4dgd = f4*df3dgd*(1/f3-a/(1+a*f3))
          dhdgd = gamma*phi**3*df4dgd/(1+f4)
          dfcdgd(ix,is) = dt*dhdgd
       ENDDO
    ENDDO
 
    ! Find exchange energy and potential
    fx = 0
    DO is = 1, 2
       ds(is) = MAX(DENMIN,2*d(is))
       gdms = MAX(GDMIN,2*gdm(is))
       kfs = (3*pi**2*ds(is))**THD
       s = gdms/(2*kfs*ds(is))
       f1 = 1 + mu*s**2/kappa
       f = 1 + kappa - kappa/f1
!
!       Note nspin=1 in call to exchng...
!
       CALL EXCHNG(Irel,1,ds(is),exunif,vxunif(is))
       fx = fx + ds(is)*exunif*f
 
       dkfdd = THD*kfs/ds(is)
       dsdd = s*(-(dkfdd/kfs)-1/ds(is))
       df1dd = 2*(f1-1)*dsdd/s
       dfdd = kappa*df1dd/f1**2
       dfxdd(is) = vxunif(is)*f + ds(is)*exunif*dfdd
 
       DO ix = 1, 3
          gds = 2*gd(ix,is)
          dsdgd = (s/gdms)*gds/gdms
          df1dgd = 2*mu*s*dsdgd/kappa
          dfdgd = kappa*df1dgd/f1**2
          dfxdgd(ix,is) = ds(is)*exunif*dfdgd
       ENDDO
    ENDDO
    fx = HALF*fx/dt
 
    ! Set output arguments
    Ex = fx*FACTOR
    Ec = fc
    DO is = 1, Nspin
       Dexdd(is) = dfxdd(is)*FACTOR
       Decdd(is) = dfcdd(is)
       DO ix = 1, 3
          Dexdgd(ix,is) = dfxdgd(ix,is)*FACTOR
          Decdgd(ix,is) = dfcdgd(ix,is)
       ENDDO
    ENDDO
 
  END SUBROUTINE PBE0XC

END MODULE gridxc_hybrids

PROGRAM gridXCtest1

  ! Checks the consistency of the energies and its derivativas, returned by  
  ! the GGA (and LDA) XC routines contained in m_ggaxc and m_ldaxc modules.
  ! Two things are checked for each functional:
  !  That the xc potentials Vx=dEx/dDens and Vc=dEc/dDens are always negative.
  !  That the (analytical) returned values dE/dDens and dE/dGrad(Dens) coincide
  !  with their numerical counterparts, calculated as finite differences.
  ! J.M.Soler. Sept.2009, May.2014

  ! Used module procedures and parameters
  USE gridXC, only: dp
  USE gridXC, only: ggaxc => gridxc_ggaxc
  USE gridXC, only: ldaxc => gridxc_ldaxc

  implicit none

  ! Tester parameters
  integer, parameter:: irel   = 1       ! Relativistic? 0=>no, 1=>yes
  integer, parameter:: nCalls = 100     ! Number of calls to each routine
  integer, parameter:: nfTot  = 18      ! Total number of functionals
  integer, parameter:: nSpin  = 4       ! Number of spin components (1|2|4)
  real(dp),parameter:: kfMax  = 5.0_dp  ! Upper limit to Fermi wavevector
  real(dp),parameter:: kgMax  = 5.0_dp  ! Upper limit to |grad(rho)|/rho
  real(dp),parameter:: deltaLogDens = 1.e-6_dp ! Fract. finite diff. change
  real(dp),parameter:: deltaLogGrad = 1.e-6_dp ! Fract. finite diff. change
  real(dp),parameter:: dEdDensTol = 1.e-6_dp   ! Tolerance error for dE/dDens
  real(dp),parameter:: dEdGradTol = 1.e-6_dp   ! Tol. error for dE/dGadDens
  logical, parameter:: collinear  = .false.    ! Make grad(dens) collinear
                                               ! with density?
  ! List of functionals to be tested
!  integer, parameter:: nf = 1        ! Check a single functional
!  integer:: indexf(nf) = (/7/)      ! Index of a functional below
  integer, parameter:: nf = nfTot    ! Check all functionals
  integer:: indexf(nf) = (/1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18/)

  ! All functionals available
  !                  1,           2,          3,           4,   
  !                  5,           6,          7,           8, 
  !                  9,          10,         11,          12,
  !                 13,          14,         15,          16,
  !                 17,          18
  character(len=3):: &
    func(nfTot)=(/'LDA',       'LDA',       'GGA',       'GGA', &
                  'GGA',       'GGA',       'GGA',       'GGA', &
                  'GGA',       'GGA',       'GGA',       'GGA', &
                  'GGA',       'GGA',       'GGA',       'GGA', &
                  'GGA',       'GGA'       /)
  character(len=10):: &
    auth(nfTot)=(/'PZ        ','PW92      ','PW91      ','PBE       ', &
                  'RPBE      ','revPBE    ','LYP       ','WC        ', &
                  'PBEJsJrLO ','PBEJsJrHEG','PBEGcGxLO ','PBEGcGxHEG', &
                  'PBESOL    ','AM05      ','PW86      ','B88       ', &
                  'C09       ','BH        '/) 

  ! Tester variables and arrays
  complex(dp),parameter:: c0 = (0._dp,0._dp)  ! Complex zero
  complex(dp),parameter:: c1 = (1._dp,0._dp)  ! Complex one
  complex(dp),parameter:: ci = (0._dp,1._dp)  ! Complex i
  complex(dp):: densMat(2,2), gradDensMat(3,2,2), Imat(2,2), &
                pauli(3,2,2), polDirMat(2,2)
  real(dp):: dens(nSpin), dens0(nSpin), &
             dEcdDens(nSpin),  dEcdGrad(3,nSpin), &
             dExdDens(nSpin),  dExdGrad(3,nSpin), &
             dEcdDens0(nSpin), dEcdGrad0(3,nSpin), &
             dExdDens0(nSpin), dExdGrad0(3,nSpin), &
             dEcdDensN(nSpin), dEcdGradN(3,nSpin), &
             dExdDensN(nSpin), dExdGradN(3,nSpin), &
             dVxdDens(nSpin,nSpin), dVcdDens(nSpin,nSpin), &
             gradDens(3,nSpin), gradDens0(3,nSpin), &
             gradDensPol(3), gradDensTot(3)
  real(dp):: cosTheta, deltaDens, deltaGrad, densPol, densTot, &
             Ec, Ex, epsC, epsX, epsC0, epsX0, &
             kFermi, phi, pi, ran(6), sinTheta, theta
  integer :: errorC, errorX, iCall, iDelta, iDeriv, iSpin, ix, &
             jf, jSpin, kf, mSpin, one, two, three, four
  logical :: errorsFound, printedDensity
!!$  integer :: mySeed(12) = (/39302655,65443109,09887367,99836827, &
!!$                            70376268,32727926,46717826,35271017, &
!!$                            63245609,89012831,78116893,10016273/)
  integer, allocatable :: mySeed(:)
  integer :: seed_size, i
  
  ! Initialize random seed
  call random_seed( size=seed_size )
  allocate(mySeed(seed_size))
  ! This is needed to support arbitrary seed sizes in the
  ! implementation.
  ! Seeds do not have any meaning now (did they earlier?)
  mySeed(:) = [ (123456789*abs(sin(1.0*i)), i=1, seed_size) ]
  call random_seed( put=mySeed )

  ! Set Pauli matrices
  Imat(1,:)    = (/c1, c0/)  ! Identity matrix
  Imat(2,:)    = (/c0, c1/)
  pauli(1,1,:) = (/c0, c1/)  ! PauliX
  pauli(1,2,:) = (/c1, c0/)
  pauli(2,1,:) = (/c0,-ci/)  ! PauliY
  pauli(2,2,:) = (/ci, c0/)
  pauli(3,1,:) = (/c1, c0/)  ! PauliZ
  pauli(3,2,:) = (/c0,-c1/)

  ! A silly trick to satisfy the compiler when nSpin<4
  one   = 1
  two   = 2
  three = 3
  four  = 4
  pi = acos(-1._dp)

  ! Loop on calls with different densities
  errorsFound = .false.
  do iCall = 1,nCalls
    printedDensity = .false.

    ! Choose random density
    call random_number( ran(1:2) )
    kFermi = kfMax * ran(1)
    densTot = kFermi**3/3/pi**2
    densPol = densTot * ran(2)
!    densPol = 0                 ! Unpolarized, to compare with nSpin=1
    if (nSpin==1) then                   ! Non spin polarized
      dens0(one) = densTot
    else if (nSpin==2) then              ! Spin polarized
      dens0(one) = (densTot+densPol)/2
      dens0(two) = (densTot-densPol)/2
    else                                 ! Non collinear spin
      call random_number( ran(1:2) )
      cosTheta = 2*ran(1) - 1            ! Random spin direction
!      cosTheta = 0                      ! Point spin along x-y
!      cosTheta = 1                      ! Point spin along z
      sinTheta = sqrt(1-cosTheta**2)
      phi = 2*pi * ran(2)                ! Random spin direction
!      phi = 0                           ! Point spin along x
!      phi = pi/2                        ! Point spin along y
      polDirMat(:,:) = sinTheta*cos(phi)*pauli(1,:,:) &
                     + sinTheta*sin(phi)*pauli(2,:,:) &
                     + cosTheta*         pauli(3,:,:)
      densMat(:,:) = densTot/2 * Imat(:,:) + densPol/2 * polDirMat(:,:)
      dens0(one)   = real(densMat(1,1))
      dens0(two)   = real(densMat(2,2))
      dens0(three) = real(densMat(1,2))
      dens0(four)  = imag(densMat(1,2))
    end if

    ! Choose random gradient of density
    do iSpin = 1,nSpin
      call random_number( ran(1:3) )
      gradDens0(1:3,iSpin) = densTot * kgMax * (2*ran(1:3)-1)
    end do

    ! Choose density gradient collinear with density itself
    if (nSpin==4 .and. collinear) then
      call random_number( ran(1:6) )
      gradDensTot(1:3) = densTot * kgMax * (2*ran(1:3)-1)
      gradDensPol(1:3) = densTot * kgMax * (2*ran(4:6)-1)
      do ix = 1,3
        gradDensMat(ix,:,:) = gradDensTot(ix)/2 * Imat(:,:) &
                            + gradDensPol(ix)/2 * polDirMat(:,:)
        gradDens0(ix,one)   = real(gradDensMat(ix,1,1))
        gradDens0(ix,two)   = real(gradDensMat(ix,2,2))
        gradDens0(ix,three) = real(gradDensMat(ix,1,2))
        gradDens0(ix,four)  = imag(gradDensMat(ix,1,2))
      end do ! ix
    end if ! (nSpin==4)

    ! Print density matrix
!    if (nSpin==4) then
!      print'(a,/,(2f15.9,3x,2f15.9))', 'Density matrix =', &
!        complex(dens0(one),0._dp), complex(dens0(three),dens0(four)), &
!        complex(dens0(three),-dens0(four)), complex(dens0(two),0._dp)
!    else
!      print'(a,/,(2f15.9,3x,2f15.9))', 'Density =', dens0(1:nSpin)
!    end if

    ! Loop on functionals
    do kf = 1,nf
      jf = indexf(kf)

      ! Find energy density and its derivatives
      if (func(jf)=='LDA') then
        call ldaxc( auth(jf), irel, nSpin, dens0, &
                    epsX0, epsC0, dExdDens0, dEcdDens0, dVxdDens, dVcdDens )
      else if (func(jf)=='GGA') then
        call ggaxc( auth(jf), irel, nSpin, dens0, gradDens0, &
                    epsX0, epsC0, dExdDens0, dEcdDens0, dExdGrad0, dEcdGrad0 )
      else
        stop 'ERROR: unknown functional'
      end if

      ! Loop on variable with respect to which derivate
      do iDeriv = 0,4*nSpin-1

        ! Select magnitude to change
        iSpin = iDeriv/4 + 1 ! Spin index: iSpin=1,...,nSpin
        ix = mod(iDeriv,4)   ! Cartes. comp. of grad(dens) (0 for dens itself)

        ! For LDA, do not perform derivative with respect to gradient
        if (ix>0 .and. func(jf)=='LDA') cycle

        ! Perform numerical derivative
        dExdDensN = 0
        dEcdDensN = 0
        dExdGradN = 0
        dEcdGradN = 0
        do iDelta = -1,1,2

          ! Change select magnitude
          dens = dens0
          gradDens = gradDens0
          if (ix==0) then
            deltaDens = dens0(iSpin) * deltaLogDens
            dens(iSpin) = dens0(iSpin) + iDelta * deltaDens
          else
            deltaGrad = gradDens0(ix,iSpin)*deltaLogGrad
            gradDens(ix,iSpin) = gradDens0(ix,iSpin) + iDelta * deltaGrad
          end if

          ! Find energy density at modified density or gradient
          if (func(jf)=='LDA') then
            call ldaxc( auth(jf), irel, nSpin, dens,   &
                        epsX, epsC, dExdDens, dEcdDens, dVxdDens, dVcdDens )
          else
            call ggaxc( auth(jf), irel, nSpin, dens, gradDens, &
                        epsX, epsC, dExdDens, dEcdDens, dExdGrad, dEcdGrad )
          end if

          ! Add to finite-difference derivative
          mSpin = min(nSpin,2)
          densTot = sum(dens(1:mSpin))
          Ex = densTot * epsX           ! Exchange energy per electron
          Ec = densTot * epsC           ! Correlation energy per electron
          if (ix==0) then
            dExdDensN(iSpin) = dExdDensN(iSpin) + iDelta*Ex/(2*deltaDens)
            dEcdDensN(iSpin) = dEcdDensN(iSpin) + iDelta*Ec/(2*deltaDens)
          else
            dExdGradN(ix,iSpin) = dExdGradN(ix,iSpin) + iDelta*Ex/(2*deltaGrad)
            dEcdGradN(ix,iSpin) = dEcdGradN(ix,iSpin) + iDelta*Ec/(2*deltaGrad)
          end if

        end do ! iDelta

        ! Divide by 2 the iSpin=3,4 components for non-collinear spin because 
        ! the two nondiagonal elements of density matrix depend on them
        dExdDensN(mSpin+1:nSpin) = dExdDensN(mSpin+1:nSpin) / 2
        dEcdDensN(mSpin+1:nSpin) = dEcdDensN(mSpin+1:nSpin) / 2
        dExdGradN(:,mSpin+1:nSpin) = dExdGradN(:,mSpin+1:nSpin) / 2
        dEcdGradN(:,mSpin+1:nSpin) = dEcdGradN(:,mSpin+1:nSpin) / 2

        ! Check for errors (positive Vxc or inconsistent derivatives)
        errorX = 0
        errorC = 0
        if (ix==0) then
          if (nSpin<=2 .and. dExdDens0(iSpin)>0._dp) errorX=1
          if (nSpin<=2 .and. dEcdDens0(iSpin)>0._dp) errorC=1
          if (abs(dExdDens0(iSpin)-dExdDensN(iSpin)) > dEdDensTol) errorX=2
          if (abs(dEcdDens0(iSpin)-dEcdDensN(iSpin)) > dEdDensTol) errorC=2
        else
          if (abs(dExdGrad0(ix,iSpin)-dExdGradN(ix,iSpin))>dEdGradTol) errorX=3
          if (abs(dEcdGrad0(ix,iSpin)-dEcdGradN(ix,iSpin))>dEdGradTol) errorC=3
        end if
        if (errorX/=0 .or. errorC/=0) errorsFound = .true.

        if ((iCall==1 .or. errorX/=0 .or. errorC/=0) .and. &
            .not.printedDensity) then
          print'(/,a6,a15,3x,a15)', 'iSpin', 'dens', 'gradDens'
          print'(i6,f15.9,3x,3f15.9)', &
            (jSpin, dens0(jSpin), gradDens0(:,jSpin), jSpin=1,nSpin)
          printedDensity = .true.
        endif

        ! Print comparison of analytical and numerical derivatives
        ! Do it only in first call, or if there is an error
        if (iCall==1 .and. kf==1 .and. iDeriv==0) then   ! Print header
          print'(/,a4,a13,a3,2a6,3a15,a4)', &
            'func', 'auth  ', 'xyz', 'iSpin', 'Ex|Ec', &
            'deriv(anal)', 'deriv(num)', 'diff  ', 'err'
        endif
        if (ix==0) then
          if (iCall==1 .or. errorX/=0) &
            print'(a4,a13,i3,i6,a6,3f15.9,i4)', &
              func(jf), auth(jf), ix, iSpin, 'Ex', &
              dExdDens0(iSpin), dExdDensN(iSpin), &
              abs(dExdDens0(iSpin)-dExdDensN(iSpin)), errorX
          if (iCall==1 .or. errorC/=0) &
            print'(a4,a13,i3,i6,a6,3f15.9,i4)', &
              func(jf), auth(jf), ix, iSpin, 'Ec', &
              dEcdDens0(iSpin), dEcdDensN(iSpin), &
              abs(dEcdDens0(iSpin)-dEcdDensN(iSpin)), errorC
        else
          if (iCall==1 .or. errorX/=0) &
            print'(a4,a13,i3,i6,a6,3f15.9,i4)', &
              func(jf), auth(jf), ix, iSpin, 'Ex', &
              dExdGrad0(ix,iSpin), dExdGradN(ix,iSpin), &
              abs(dExdGrad0(ix,iSpin)-dExdGradN(ix,iSpin)), errorX
          if (iCall==1 .or. errorC/=0) &
            print'(a4,a13,i3,i6,a6,3f15.9,i4)', &
              func(jf), auth(jf), ix, iSpin, 'Ec', &
              dEcdGrad0(ix,iSpin), dEcdGradN(ix,iSpin), &
              abs(dEcdGrad0(ix,iSpin)-dEcdGradN(ix,iSpin)), errorC
        end if

      end do ! iDeriv
      if (iCall==1) print*, ' ' ! Separate functionals for better visualization
    end do ! jf
  end do ! iCall

  ! Print error codes
  if (errorsFound) then
    print'(/,a)', 'Some errors found. Error codes:'
    print'(a)', 'error 1 => V=dE/dDens is positive'
    print'(a)', 'error 2 => analytical and numerical value of dE/dDens differ'
    print'(a)', &
      'error 3 => analytical and numerical value of dE/dGradDens differ'
  else
    print'(/,a)', 'No errors found.'
  end if

END PROGRAM gridXCtest1

#if defined HAVE_CONFIG_H
#include "config.h"
#endif

#ifdef HAVE_LIBXC
#include "xc_version.h"
#endif

!!@LICENSE
!
!******************************************************************************
! MODULE m_ggaxc
! Provides routines for GGA XC functional evaluation
!******************************************************************************
!
!   PUBLIC procedures available from this module:
! ggaxc,       ! General subroutine for all coded GGA XC functionals
! blypxc,      ! Becke-Lee-Yang-Parr (see subroutine blypxc)
! pbexc,       ! Perdew, Burke & Ernzerhof, PRL 77, 3865 (1996)
! pbesolxc,    ! Perdew et al, PRL, 100, 136406 (2008)
! pw91xc,      ! Perdew & Wang, JCP, 100, 1290 (1994)
! revpbexc,    ! GGA Zhang & Yang, PRL 80,890(1998)
! rpbexc,      ! Hammer, Hansen & Norskov, PRB 59, 7413 (1999)
! am05xc,      ! Mattsson & Armiento, PRB, 79, 155101 (2009)
! wcxc,        ! Wu-Cohen (see subroutine wcxc)
! pbeJsJrLOxc  ! Reparametrizations of the PBE functional by
! pbeJsJrHEGxc !   L.S.Pedroza et al, PRB 79, 201106 (2009) and
! pbeGcGxLOxc  !   M.M.Odashima et al, J. Chem. Theory Comp. 5, 798 (2009)
! pbeGcGxHEGxc ! using 4 different combinations of criteria
! pw86x,       ! Perdew & Wang, PRB 33, 8800 (1986) (exchange only)
! pw86rx,      ! pw86x refitted by Murray, Lee & Langreth, JCTC 5, 2754 (2009)
! b88x,        ! Becke, PRA 38, 3098 (1988) (exchange only)
! b88kbmx,     ! Klimes et al, JPCM 22, 022201 (2009) (exchange only)
! c09x,        ! Cooper, PRB 81, 161104 (2010) (exchange only)
! bhx          ! Berland & Hyldgaard, PRB 89, 035412 (2014) (exchange only)
!
!   PUBLIC parameters, types, and variables available from this module:
! none
!
!******************************************************************************
!
!   USED module procedures:
! use gridxc_sys,     only: die     ! Termination routine
! use gridxc_lda, only: exchng  ! Local exchange
! use gridxc_lda, only: pw92c   ! Perdew & Wang, PRB, 45, 13244 (1992) (Corr. only)
!
!   USED module parameters:
! use gridxc_precision,  only: dp   ! Real double precision type
!
!   EXTERNAL procedures used:
! none
!
!******************************************************************************

MODULE gridxc_gga

  ! Used module procedures
  use gridxc_sys,     only: die     ! Termination routine
  USE gridxc_lda, only: exchng  ! Local exchange
  USE gridxc_lda, only: pw92c   ! Perdew & Wang, PRB, 45, 13244 (1992) correl

  ! Used module parameters
  use gridxc_precision, only : dp   ! Double precision real kind

#ifdef HAVE_LIBXC
#if XC_MAJOR_VERSION >= 4
  use xc_f03_lib_m
  use iso_c_binding, only: c_size_t, c_int
#else
  use xc_f90_types_m
  use xc_f90_lib_m
#endif
#endif /* HAVE_LIBXC */

  implicit none

  private  ! everything is private, unless otherwise declared

  public :: ggaxc        ! General subroutine for all coded GGA XC functionals
  public :: blypxc       ! Becke-Lee-Yang-Parr (see subroutine blypxc)
  public :: pbexc        ! Perdew, Burke & Ernzerhof, PRL 77, 3865 (1996)
  public :: pbesolxc     ! Perdew et al, PRL, 100, 136406 (2008)
  public :: pw91xc       ! Perdew & Wang, JCP, 100, 1290 (1994)
  public :: revpbexc     ! GGA Zhang & Yang, PRL 80,890(1998)
  public :: rpbexc       ! Hammer, Hansen & Norskov, PRB 59, 7413 (1999)
  public :: am05xc       ! Mattsson & Armiento, PRB, 79, 155101 (2009)
  public :: wcxc         ! Wu-Cohen (see subroutine wcxc)
  public :: pbeJsJrLOxc  ! Reparametrizations of the PBE functional by
  public :: pbeJsJrHEGxc !   L.S.Pedroza et al, PRB 79, 201106 (2009) and
  public :: pbeGcGxLOxc  !   M.M.Odashima et al, JCTC 5, 798 (2009)
  public :: pbeGcGxHEGxc ! using 4 different combinations of criteria
  public :: pw86x        ! Perdew & Wang, PRB 33, 8800 (1986) (exchange only)
  public :: pw86rx       ! pw86x refit: Murray, Lee & Langreth, JCTC 5, 2754 (2009)
  public :: b88x         ! Becke, PRA 38, 3098 (1988) (exchange only)
  public :: b88kbmx      ! Klimes et al, JPCM 22, 022201 (2009) (exchange only)
  public :: c09x         ! Cooper, PRB 81, 161104 (2010) (exchange only)
  public :: bhx          ! Berland & Hyldgaard, PRB 89, 035412 (2014) (exch. only)

contains

  subroutine GGAXC( AUTHOR, IREL, nSpin, D, GD, &
      EPSX, EPSC, dEXdD, dECdD, dEXdGD, dECdGD &
#ifdef HAVE_LIBXC
      , is_libxc, xc_func, xc_info )
#else
    )
#endif

    use gridxc_hybrids, only: hsexc, pbe0xc

    ! Finds the exchange and correlation energies at a point, and their
    ! derivatives with respect to density and density gradient, in the
    ! Generalized Gradient Correction approximation.
    ! Lengths in Bohr, energies in Hartrees
    ! Written by L.C.Balbas and J.M.Soler, Dec'96.
    ! Modified by V.M.Garcia-Suarez to include non-collinear spin. June 2002
    ! Non collinear part rewritten by J.M.Soler. Sept. 2009
    ! Interface with LibXC added by Micael Oliveira, Jul.2014

    ! Input
    character(len=*),intent(in):: AUTHOR  ! GGA flavour (author initials)
    integer, intent(in) :: IREL           ! Relativistic exchange? 0=no, 1=yes
    integer, intent(in) :: nSpin          ! Number of spin components
    real(dp),intent(in) :: D(nSpin)       ! Local electron (spin) density
    real(dp),intent(in) :: GD(3,nSpin)    ! Gradient of electron density

    ! Output
    real(dp),intent(out):: EPSX           ! Exchange energy per electron
    real(dp),intent(out):: EPSC           ! Correlation energy per electron
    real(dp),intent(out):: dEXdD(nSpin)   ! dEx/dDens, Ex=Int(dens*epsX)
    real(dp),intent(out):: dECdD(nSpin)   ! dEc/dDens
    real(dp),intent(out):: dEXdGD(3,nSpin) ! dEx/dGrad(Dens)
    real(dp),intent(out):: dECdGD(3,nSpin) ! dEc/dGrad(Dens)
#ifdef HAVE_LIBXC
    logical, intent(in), optional    :: is_libxc
#if XC_MAJOR_VERSION >= 4
    type(xc_f03_func_t), optional :: xc_func
    type(xc_f03_func_info_t), optional :: xc_info
# if XC_MAJOR_VERSION >= 5
    integer(c_size_t), parameter :: one = 1
# else
    integer(c_int), parameter :: one = 1
# endif
#else
    type(xc_f90_pointer_t), optional :: xc_func, xc_info
#endif
#endif

    ! Internal variables and arrays
    integer    :: NS, is, ix
    real(dp)   :: DD(2), dECdDD(2), dEXdDD(2), &
        dDDdD(2,4), dDTOTdD(4), dDPOLdD(4), &
        dECdGDD(3,2), dEXdGDD(3,2), &
        dGDDdD(3,2,4), dGDDdGD(2,4), &
        dGDTOTdD(3,4), dGDPOLdD(3,4), &
        dGDTOTdGD(4), dGDPOLdGD(4), &
        DPOL, DTOT, GDD(3,2), GDTOT(3), GDPOL(3), &
        VPOL
    real(dp), parameter :: DENMIN = 1.e-12_dp

    real(dp):: theta, phi, c2, s2, st, ct, cp, sp, dpolz, dpolxy

    logical , parameter :: old_scheme = .true.

#ifdef HAVE_LIBXC
    logical  :: lis_libxc
    integer :: xc_kind
    real(dp) :: eps(1), dedn(nspin), sgm(3), dedsgm(3), dedgd(3, nspin)
#endif

    ! Handle non-collinear spin case
    if (nSpin==4) then
      NS = 2             ! Diagonal spin components

      if ( old_scheme ) then
        DTOT = D(1) + D(2)
        dpolz= D(1) - D(2)
        dpolxy= 2.0d0*sqrt(d(3)**2+d(4)**2)
        dpol  = sqrt( dpolz**2 + dpolxy**2 )
        if ( dpol.gt.1.0d-12 ) then
          theta = atan2(dpolxy,dpolz)
        else
          theta = 0.0_dp
        endif
        C2 = COS(THETA/2.0_dp)
        S2 = SIN(THETA/2.0_dp)
        ST = SIN(THETA)
        CT = COS(THETA)
        PHI = ATAN2(-D(4),D(3))
        CP = COS(PHI)
        SP = SIN(PHI)

        DD(1) = 0.5D0 * ( DTOT + DPOL )
        DD(2) = 0.5D0 * ( DTOT - DPOL )
        DO IX = 1,3
          GDD(IX,1) = GD(IX,1)*C2**2 + GD(IX,2)*S2**2 + &
              2.d0*C2*S2*(GD(IX,3)*CP - GD(IX,4)*SP)
          GDD(IX,2) = GD(IX,1)*S2**2 + GD(IX,2)*C2**2 - &
              2.d0*C2*S2*(GD(IX,3)*CP - GD(IX,4)*SP)
        ENDDO

      else

        ! Find eigenvalues of density matrix Dij (diagonal densities DD, i.e.
        ! up and down densities along the spin direction). Note convention: 
        ! D(1)=D11, D(2)=D22, D(3)=Re(D12)=Re(D21), D(4)=Im(D12)=-Im(D21)
        DTOT = D(1) + D(2)                           ! DensTot (DensUp+DensDn)
        DPOL = SQRT( (D(1)-D(2))**2 &                ! DensPol (DensUp-DensDn)
            + 4*(D(3)**2+D(4)**2) )
        DD(1) = ( DTOT + DPOL ) / 2                  ! DensUp
        DD(2) = ( DTOT - DPOL ) / 2                  ! DensDn
        DPOL = max( DPOL , DENMIN )                  ! Avoid division by zero

        ! Find gradients of up and down densities
        GDTOT(:) = GD(:,1) + GD(:,2)                 ! Grad(DensTot)
        GDPOL(:) = ( (D(1)-D(2))*(GD(:,1)-GD(:,2)) & ! Grad(DensPol)
            + 4*(D(3)*GD(:,3)+D(4)*GD(:,4)) ) / DPOL
        GDD(:,1) = ( GDTOT(:) + GDPOL(:) ) / 2       ! Grad(DensUp)
        GDD(:,2) = ( GDTOT(:) - GDPOL(:) ) / 2       ! Grad(DensDn)

        ! Derivatives of Dup and Ddn with respect to input density matrix
        dDTOTdD(1:2) = 1                             ! dDensTot/dD(i)
        dDTOTdD(3:4) = 0
        dDPOLdD(1) = +( D(1) - D(2) ) / DPOL         ! dDensPol/dD(i)
        dDPOLdD(2) = -( D(1) - D(2) ) / DPOL
        dDPOLdD(3) = 4 * D(3) / DPOL
        dDPOLdD(4) = 4 * D(4) / DPOL
        dDDdD(1,:) = ( dDTOTdD(:) + dDPOLdD(:) ) / 2 ! dDensUp/dD(i)
        dDDdD(2,:) = ( dDTOTdD(:) - dDPOLdD(:) ) / 2 ! dDensDn/dD(i)

        ! Derivatives of grad(Dup) and grad(Ddn) with respect to D(i)
        dGDTOTdD(1:3,1:4) = 0                        ! dGradDensTot/dD(i)
        dGDPOLdD(:,1) = + (GD(:,1)-GD(:,2))/DPOL &   ! dGradDensPol/dD(i)
            - GDPOL(:) * dDPOLdD(1)/DPOL
        dGDPOLdD(:,2) = - (GD(:,1)-GD(:,2))/DPOL &
            - GDPOL(:) * dDPOLdD(2)/DPOL
        dGDPOLdD(:,3) = 4*GD(:,3)/DPOL &
            - GDPOL(:) * dDPOLdD(3)/DPOL
        dGDPOLdD(:,4) = 4*GD(:,4)/DPOL &
            - GDPOL(:) * dDPOLdD(4)/DPOL
        dGDDdD(:,1,:) = ( dGDTOTdD(:,:) &             ! dGradDensUp/dD(i)
            + dGDPOLdD(:,:) ) / 2
        dGDDdD(:,2,:) = ( dGDTOTdD(:,:) &             ! dGradDensDn/dD(i)
            - dGDPOLdD(:,:) ) / 2

        ! Derivatives of grad(Dup) and grad(Ddn) with respect to grad(D(i))
        dGDTOTdGD(1:2) = 1                           ! dGradDensTot/dGradD(i)
        dGDTOTdGD(3:4) = 0
        dGDPOLdGD(1) = +( D(1) - D(2) ) / DPOL       ! dGradDensPol/dGradD(i)
        dGDPOLdGD(2) = -( D(1) - D(2) ) / DPOL
        dGDPOLdGD(3) = 4 * D(3) / DPOL
        dGDPOLdGD(4) = 4 * D(4) / DPOL
        dGDDdGD(1,:) = ( dGDTOTdGD(:) &              ! dGradDensUp/dGradD(i)
            + dGDPOLdGD(:) ) / 2
        dGDDdGD(2,:) = ( dGDTOTdGD(:) &              ! dGradDensDn/dGradD(i)
            - dGDPOLdGD(:) ) / 2
      endif

    else if (nSpin==1 .or. nSpin==2) then ! Normal (collinear) spin
      NS = nSpin
      DD(1:NS) = max( D(1:NS), 0.0_dp ) ! ag: Avoid negative densities
      GDD(1:3,1:NS) = GD(1:3,1:NS)
    else
      call die('ggaxc: ERROR: invalid value of nSpin')
    end if ! (nSpin==4)

    ! Select functional to find energy density and its derivatives
#ifdef HAVE_LIBXC
    if ( present(is_libxc) ) then
      lis_libxc = is_libxc
      if ( lis_libxc ) then
        if ((.not. present(xc_func)) .or. &
            (.not. present(xc_info))) then
          call die("xc_func and xc_info not present")
        endif
      endif
    else
      lis_libxc = .false.
    end if

    if (lis_libxc) then
      sgm(1) = sum(GDD(1:3,1)*GDD(1:3,1))
      IF (nspin == 1) THEN
        ! do nothing
      ELSE
        sgm(2) = sum(GDD(1:3,1)*GDD(1:3,2)) 
        sgm(3) = sum(GDD(1:3,2)*GDD(1:3,2)) 
      ENDIF

      ! Here eps is the energy per particle (electron).
      ! Hence Exc = Int(dens(r)*eps(r)*dV)
      ! dedn is the derivative of the energy per volume (dens*eps)
      !      with respect to dens
      ! dedsgm and dedgd are derivatives of the energy per volume (dens*eps)
      !                  with respect to the gradient of dens.
      ! sgm is a packed gradient (see LibXC docs)
      !
#if XC_MAJOR_VERSION >= 4
      IF ((xc_f03_func_info_get_family(xc_info) /= XC_FAMILY_GGA) .and. &
          (xc_f03_func_info_get_family(xc_info) /= XC_FAMILY_HYB_GGA) ) THEN
        call die('GGAXC: Functional is not a GGA')
      ENDIF
      xc_kind = xc_f03_func_info_get_kind(xc_info)
      call xc_f03_gga_exc_vxc(xc_func, one, DD(1), sgm(1), eps, dedn(1), &
          dedsgm(1))
#else
      IF ((xc_f90_info_family(xc_info) /= XC_FAMILY_GGA) .and. &
          (xc_f90_info_family(xc_info) /= XC_FAMILY_HYB_GGA)) THEN
        call die('GGAXC: Functional is not a GGA')
      ENDIF
      xc_kind = xc_f90_info_kind(xc_info)
      call xc_f90_gga_exc_vxc(xc_func, 1, DD(1), sgm(1), eps(1), dedn(1), &
          dedsgm(1))
#endif      
      IF (nspin == 1) THEN
        dedgd(1:3, 1) = 2.0D0*dedsgm(1)*GDD(1:3, 1)
      ELSE
        dedgd(1:3, 1) = 2.0D0*dedsgm(1)*GDD(1:3, 1) + dedsgm(2)*GDD(1:3, 2)
        dedgd(1:3, 2) = 2.0D0*dedsgm(3)*GDD(1:3, 2) + dedsgm(2)*GDD(1:3, 1)
      ENDIF
      IF (xc_kind == XC_CORRELATION) THEN
        EPSC = eps(1)
        dECdDD(1:nspin) = dedn(1:nspin)
        dECdGDD(1:3, 1:nspin) = dedgd(1:3, 1:nspin)
        EPSX = 0.0_dp
        dEXdDD(1:nspin) = 0.0_dp
        dEXdGDD(1:3, 1:nspin) = 0.0_dp
      ELSE if (xc_kind == XC_EXCHANGE) THEN
        EPSX = eps(1)
        dEXdDD(1:nspin) = dedn(1:nspin)
        dEXdGDD(1:3, 1:nspin) = dedgd(1:3, 1:nspin)
        EPSC = 0.0_dp
        dECdDD(1:nspin) = 0.0_dp
        dECdGDD(1:3, 1:nspin) = 0.0_dp
      ELSE ! combined functional, use an arbitrary 50/50 split
        EPSX = 0.5_dp * eps(1)
        dEXdDD(1:nspin) = 0.5_dp * dedn(1:nspin)
        dEXdGDD(1:3, 1:nspin) = 0.5_dp * dedgd(1:3, 1:nspin)
        !
        EPSC = EPSX
        dECdDD(1:nspin) = dEXdDD(1:nspin)
        dECdGDD(1:3, 1:nspin) = dEXdGDD(1:3,1:nspin)
      ENDIF

    else IF (AUTHOR.EQ.'PBE' .OR. AUTHOR.EQ.'pbe') THEN
#else         
    if (AUTHOR.EQ.'PBE' .OR. AUTHOR.EQ.'pbe') THEN
#endif         
      CALL PBEXC( IREL, NS, DD, GDD, &                 ! JMS
          EPSX, EPSC, dEXdDD, dECdDD, dEXdGDD, dECdGDD )

    ELSE IF (AUTHOR.EQ.'RPBE'.OR.AUTHOR.EQ.'rpbe') THEN
      CALL RPBEXC( IREL, NS, DD, GDD, &                ! MVFS
          EPSX, EPSC, dEXdDD, dECdDD, dEXdGDD, dECdGDD )

    ELSE IF (AUTHOR.EQ.'WC'.OR.AUTHOR.EQ.'wc') THEN
      CALL WCXC( IREL, NS, DD, GDD, &                  ! MVFS
          EPSX, EPSC, dEXdDD, dECdDD, dEXdGDD, dECdGDD )

    ELSE IF (AUTHOR.EQ.'REVPBE'.OR.AUTHOR.EQ.'revpbe' &
        .OR.AUTHOR.EQ.'revPBE') THEN
      CALL REVPBEXC( IREL, NS, DD, GDD, &              ! EA
          EPSX, EPSC, dEXdDD, dECdDD, dEXdGDD, dECdGDD )

    ELSE IF (AUTHOR.EQ.'BLYP'.OR.AUTHOR.EQ.'blyp'.OR. &
        AUTHOR.EQ.'LYP'.OR.AUTHOR.EQ.'lyp') THEN
      CALL BLYPXC( NS, DD, GDD, &                       ! AG
          EPSX, EPSC, dEXdDD, dECdDD, dEXdGDD, dECdGDD )

    ELSEIF (AUTHOR.EQ.'PW91' .OR. AUTHOR.EQ.'pw91') THEN
      CALL PW91XC( IREL, NS, DD, GDD, &                ! AG
          EPSX, EPSC, dEXdDD, dECdDD, dEXdGDD, dECdGDD )

    ELSEIF (AUTHOR.EQ.'PBESOL' .OR. AUTHOR.EQ.'pbesol' .OR. &
        AUTHOR.EQ.'PBEsol') THEN
      CALL PBESOLXC( IREL, NS, DD, GDD, &
          EPSX, EPSC, dEXdDD, dECdDD, dEXdGDD, dECdGDD )

    ELSEIF (AUTHOR.EQ.'AM05' .OR. AUTHOR.EQ.'am05') THEN
      CALL AM05XC( IREL, NS, DD, GDD, &
          EPSX, EPSC, dEXdDD, dECdDD, dEXdGDD, dECdGDD )

    ELSEIF (AUTHOR.EQ.'PBEJsJrLO' .OR. &
        AUTHOR.EQ.'pbejsjrlo' .OR. &
        AUTHOR.EQ.'PBEJSJRLO') THEN
      CALL PBEJsJrLOxc( IREL, NS, DD, GDD, &
          EPSX, EPSC, dEXdDD, dECdDD, dEXdGDD, dECdGDD )

    ELSEIF (AUTHOR.EQ.'PBEJsJrHEG' .OR. &
        AUTHOR.EQ.'pbejsjrheg' .OR. &
        AUTHOR.EQ.'PBEJSJRHEG') THEN
      CALL PBEJsJrHEGxc( IREL, NS, DD, GDD, &
          EPSX, EPSC, dEXdDD, dECdDD, dEXdGDD, dECdGDD )

    ELSEIF (AUTHOR.EQ.'PBEGcGxLO' .OR. &
        AUTHOR.EQ.'pbegcgxlo' .OR. &
        AUTHOR.EQ.'PBEGCGXLO') THEN
      CALL PBEGcGxLOxc( IREL, NS, DD, GDD, &
          EPSX, EPSC, dEXdDD, dECdDD, dEXdGDD, dECdGDD )

    ELSEIF (AUTHOR.EQ.'PBEGcGxHEG' .OR. &
        AUTHOR.EQ.'pbegcgxheg' .OR. &
        AUTHOR.EQ.'PBEGCGXHEG') THEN
      CALL PBEGcGxHEGxc( IREL, NS, DD, GDD, &
          EPSX, EPSC, dEXdDD, dECdDD, dEXdGDD, dECdGDD )

    ELSEIF (AUTHOR.EQ.'PW86' .OR. AUTHOR.EQ.'pw86') THEN
      CALL PW86X( IREL, NS, DD, GDD, &
          EPSX, EPSC, dEXdDD, dECdDD, dEXdGDD, dECdGDD )

    ELSEIF (AUTHOR.EQ.'PW86R' .OR. AUTHOR.EQ.'pw86r') THEN
      CALL PW86RX( IREL, NS, DD, GDD, &
          EPSX, EPSC, dEXdDD, dECdDD, dEXdGDD, dECdGDD )

    ELSEIF (AUTHOR.EQ.'B88' .OR. AUTHOR.EQ.'b88') THEN
      CALL B88X( IREL, NS, DD, GDD, &
          EPSX, EPSC, dEXdDD, dECdDD, dEXdGDD, dECdGDD )

    ELSEIF (AUTHOR.EQ.'B88KBM' .OR. AUTHOR.EQ.'b88kbm') THEN
      CALL B88KBMX( IREL, NS, DD, GDD, &
          EPSX, EPSC, dEXdDD, dECdDD, dEXdGDD, dECdGDD )

    ELSEIF (AUTHOR.EQ.'C09' .OR. AUTHOR.EQ.'c09') THEN
      CALL C09X( IREL, NS, DD, GDD, &
          EPSX, EPSC, dEXdDD, dECdDD, dEXdGDD, dECdGDD )

    ELSEIF (AUTHOR.EQ.'BH' .OR. AUTHOR.EQ.'bh') THEN
      CALL BHX( IREL, NS, DD, GDD, &
          EPSX, EPSC, dEXdDD, dECdDD, dEXdGDD, dECdGDD ) 

    ELSEIF (AUTHOR.EQ.'HSE06' .OR. AUTHOR.EQ.'hse06') THEN
      CALL HSEXC( IREL, NS, DD, GDD, &
          EPSX, EPSC, dEXdDD, dECdDD, dEXdGDD, dECdGDD )

    ELSEIF (AUTHOR.EQ.'PBE0' .OR. AUTHOR.EQ.'pbe0') THEN
      CALL PBE0XC( IREL, NS, DD, GDD, &
          EPSX, EPSC, dEXdDD, dECdDD, dEXdGDD, dECdGDD )

    ELSE
      call die('GGAXC: Unknown author ' // trim(AUTHOR))
    ENDIF

    ! Find dE/dD(i) and dE/dGradD(i). Note convention:
    ! DEDD(1)=dE/dD11, DEDD(2)=dE/dD22, DEDD(3)=Re(dE/dD12)=Re(dE/dD21),
    ! DEDD(4)=Im(dE/dD12)=-Im(dE/D21)
    if (nSpin==4) then  ! Non colinear spin
      ! dE/dD(i) = dE/dDup * dDup/dD(i) + dE/dDdn * dDdn/dD(i)
      !          + dE/dGDup * dGDup/dD(i) + dE/dGDdn * dGDdn/dD(i)
      ! dE/dGradD(i) = dE/dGDup * dGDup/dGD(i) + dE/dGDdn * dGDdn/dGD(i)

      if ( old_scheme ) then
        VPOL  = (dExdDD(1)-dExdDD(2)) * ct
        dExdD(1) = 0.5D0 * ( dExdDD(1) + dExdDD(2) + VPOL )
        dExdD(2) = 0.5D0 * ( dExdDD(1) + dExdDD(2) - VPOL )
        dExdD(3) = 0.5d0 * (dExdDD(1)-dExdDD(2)) * st * cp
        dExdD(4) =-0.5d0 * (dExdDD(1)-dExdDD(2)) * st * sp
        VPOL  = (dEcdDD(1)-dEcdDD(2)) * ct
        dEcdD(1) = 0.5D0 * ( dEcdDD(1) + dEcdDD(2) + VPOL )
        dEcdD(2) = 0.5D0 * ( dEcdDD(1) + dEcdDD(2) - VPOL )
        dEcdD(3) = 0.5d0 * (dEcdDD(1)-dEcdDD(2)) * st * cp
        dEcdD(4) =-0.5d0 * (dEcdDD(1)-dEcdDD(2)) * st * sp
        ! Gradient terms
        DO IX = 1,3
          dExdGD(IX,1) = dExdGDD(IX,1)*C2**2 + dExdGDD(IX,2)*S2**2
          dExdGD(IX,2) = dExdGDD(IX,1)*S2**2 + dExdGDD(IX,2)*C2**2
          dExdGD(IX,3) = 0.5D0*(dExdGDD(IX,1) - dExdGDD(IX,2))*ST*CP
          dExdGD(IX,4) =-0.5D0*(dExdGDD(IX,1) - dExdGDD(IX,2))*ST*SP
          dEcdGD(IX,1) = dEcdGDD(IX,1)*C2**2 + dEcdGDD(IX,2)*S2**2
          dEcdGD(IX,2) = dEcdGDD(IX,1)*S2**2 + dEcdGDD(IX,2)*C2**2
          dEcdGD(IX,3) = 0.5D0*(dEcdGDD(IX,1) - dEcdGDD(IX,2))*ST*CP
          dEcdGD(IX,4) =-0.5D0*(dEcdGDD(IX,1) - dEcdGDD(IX,2))*ST*SP
        enddo

      else

        do is = 1,4
          dEXdD(is) = sum( dEXdDD(:) * dDDdD(:,is) ) &
              + sum( dEXdGDD(:,:) * dGDDdD(:,:,is) )
          dECdD(is) = sum( dECdDD(:) * dDDdD(:,is) ) &
              + sum( dECdGDD(:,:) * dGDDdD(:,:,is) )
          do ix = 1,3
            dEXdGD(ix,is) = sum( dEXdGDD(ix,:) * dGDDdGD(:,is) )
            dECdGD(ix,is) = sum( dECdGDD(ix,:) * dGDDdGD(:,is) )
          end do
        end do
        ! Divide by two the non-diagonal derivatives. This is necessary
        ! because DEDD(3:4) intend to be Re(dE/dD12)=Re(dE/dD21) and 
        ! Im(dE/dD12)=-Im(dE/dD21), respectively. However, both D12 and D21
        ! depend on D(3) and D(4), and we have derived directly dE/dD(3) and
        ! dE/dD(4). Although less trivially, the same applies to dE/dGD(3:4).
        dEXdD(3:4) = dEXdD(3:4) / 2
        dECdD(3:4) = dECdD(3:4) / 2
        dEXdGD(:,3:4) = dEXdGD(:,3:4) / 2
        dECdGD(:,3:4) = dECdGD(:,3:4) / 2

      endif
    else   ! Collinear spin => just copy derivatives to output arrays
      dEXdD(1:nSpin) = dEXdDD(1:nSpin)
      dECdD(1:nSpin) = dECdDD(1:nSpin)
      dEXdGD(:,1:nSpin) = dEXdGDD(:,1:nSpin)
      dECdGD(:,1:nSpin) = dECdGDD(:,1:nSpin)
    end if ! (nSpin==4)

  END SUBROUTINE GGAXC

  
  
  SUBROUTINE PBEformXC( beta, mu, kappa, iRel, nSpin, Dens, GDens, &
      EX, EC, dEXdD, dECdD, dEXdGD, dECdGD )

    ! *********************************************************************
    ! Implements Perdew-Burke-Ernzerhof Generalized-Gradient-Approximation
    ! functional form, but with variable values for parameters beta, mu, and
    ! kappa. Ref: J.P.Perdew, K.Burke & M.Ernzerhof, PRL 77, 3865 (1996)
    ! Written by L.C.Balbas and J.M.Soler. December 1996. 
    ! ******** INPUT ******************************************************
    ! REAL*8  BETA           : Parameter beta of the PBE functional
    ! REAL*8  MU             : Parameter mu of the PBE functional
    ! REAL*8  KAPPA          : Parameter kappa of the PBE functional
    ! INTEGER IREL           : Relativistic-exchange switch (0=No, 1=Yes)
    ! INTEGER nspin          : Number of spin polarizations (1 or 2)
    ! REAL*8  Dens(nspin)    : Total electron density (if nspin=1) or
    !                           spin electron density (if nspin=2)
    ! REAL*8  GDens(3,nspin) : Total or spin density gradient
    ! ******** OUTPUT *****************************************************
    ! REAL*8  EX             : Exchange energy density
    ! REAL*8  EC             : Correlation energy density
    ! REAL*8  DEXDD(nspin)   : Partial derivative
    !                           d(DensTot*Ex)/dDens(ispin),
    !                           where DensTot = Sum_ispin( Dens(ispin) )
    !                          For a constant density, this is the
    !                          exchange potential
    ! REAL*8  DECDD(nspin)   : Partial derivative
    !                           d(DensTot*Ec)/dDens(ispin),
    !                           where DensTot = Sum_ispin( Dens(ispin) )
    !                          For a constant density, this is the
    !                          correlation potential
    ! REAL*8  DEXDGD(3,nspin): Partial derivative
    !                           d(DensTot*Ex)/d(GradDens(i,ispin))
    ! REAL*8  DECDGD(3,nspin): Partial derivative
    !                           d(DensTot*Ec)/d(GradDens(i,ispin))
    ! ********* UNITS ****************************************************
    ! Lengths in Bohr
    ! Densities in electrons per Bohr**3
    ! Energies in Hartrees
    ! Gradient vectors in cartesian coordinates
    ! ********* ROUTINES CALLED ******************************************
    ! EXCHNG, PW92C
    ! ********************************************************************

    ! Input
    real(dp),intent(in) :: beta           ! Parameter of PBE functional
    real(dp),intent(in) :: mu             ! Parameter of PBE functional
    real(dp),intent(in) :: kappa          ! Parameter of PBE functional
    integer, intent(in) :: iRel           ! Relativistic exchange? 0=no, 1=yes
    integer, intent(in) :: nSpin          ! Number of spin components
    real(dp),intent(in) :: Dens(nSpin)    ! Local electron (spin) density
    real(dp),intent(in) :: GDens(3,nSpin) ! Gradient of electron density

    ! Output
    real(dp),intent(out):: EX             ! Exchange energy per electron
    real(dp),intent(out):: EC             ! Correlation energy per electron
    real(dp),intent(out):: dEXdD(nSpin)   ! dEx/dDens, Ex=Int(dens*epsX)
    real(dp),intent(out):: dECdD(nSpin)   ! dEc/dDens
    real(dp),intent(out):: dEXdGD(3,nSpin) ! dEx/dGrad(Dens)
    real(dp),intent(out):: dECdGD(3,nSpin) ! dEc/dGrad(Dens)

    ! Internal variables
    INTEGER :: IS, IX
    real(dp) &
        A, D(2), DADD, DECUDD, DENMIN, &
        DF1DD, DF2DD, DF3DD, DF4DD, DF1DGD, DF3DGD, DF4DGD, &
        DFCDD(2), DFCDGD(3,2), DFDD, DFDGD, DFXDD(2), DFXDGD(3,2), &
        DHDD, DHDGD, DKFDD, DKSDD, DPDD, DPDZ, DRSDD, &
        DS(2), DSDD, DSDGD, DT, DTDD, DTDGD, DZDD(2), &
        ECUNIF, EXUNIF, &
        F, F1, F2, F3, F4, FC, FX, FOUTHD, &
        GAMMA, GD(3,2), GDM(2), GDMIN, GDMS, GDMT, GDS, GDT(3), &
        H, HALF, KF, KFS, KS, PHI, PI, RS, S, &
        T, THD, THRHLF, TWO, TWOTHD, VCUNIF(2), VXUNIF(2), ZETA

    ! Lower bounds of density and its gradient to avoid divisions by zero
    PARAMETER ( DENMIN = 1.D-12 )
    PARAMETER ( GDMIN  = 1.D-12 )

    ! Fix some numerical parameters
    PARAMETER ( FOUTHD=4.D0/3.D0, HALF=0.5D0, &
        THD=1.D0/3.D0, THRHLF=1.5D0, &
        TWO=2.D0, TWOTHD=2.D0/3.D0 )

    ! Fix some more numerical constants
    PI = 4 * ATAN(1.D0)
    GAMMA = (1 - LOG(TWO)) / PI**2

    ! Translate density and its gradient to new variables
    IF (nspin .EQ. 1) THEN
      D(1) = HALF * Dens(1)
      D(2) = D(1)
      DT = MAX( DENMIN, Dens(1) )
      DO IX = 1,3
        GD(IX,1) = HALF * GDens(IX,1)
        GD(IX,2) = GD(IX,1)
        GDT(IX) = GDens(IX,1)
      end DO
    ELSE
      D(1) = Dens(1)
      D(2) = Dens(2)
      DT = MAX( DENMIN, Dens(1)+Dens(2) )
      DO IX = 1,3
        GD(IX,1) = GDens(IX,1)
        GD(IX,2) = GDens(IX,2)
        GDT(IX) = GDens(IX,1) + GDens(IX,2)
      end DO
    ENDIF
    GDM(1) = SQRT( GD(1,1)**2 + GD(2,1)**2 + GD(3,1)**2 )
    GDM(2) = SQRT( GD(1,2)**2 + GD(2,2)**2 + GD(3,2)**2 )
    GDMT   = SQRT( GDT(1)**2  + GDT(2)**2  + GDT(3)**2  )
    GDMT = MAX( GDMIN, GDMT )

    ! Find local correlation energy and potential
    CALL PW92C( 2, D, ECUNIF, VCUNIF )

    ! Find total correlation energy
    RS = ( 3 / (4*PI*DT) )**THD
    KF = (3 * PI**2 * DT)**THD
    KS = SQRT( 4 * KF / PI )
    ZETA = ( D(1) - D(2) ) / DT
    ZETA = MAX( -1.D0+DENMIN, ZETA )
    ZETA = MIN(  1.D0-DENMIN, ZETA )
    PHI = HALF * ( (1+ZETA)**TWOTHD + (1-ZETA)**TWOTHD )
    T = GDMT / (2 * PHI * KS * DT)
    F1 = ECUNIF / GAMMA / PHI**3
    F2 = EXP(-F1)
    A = BETA / GAMMA / (F2-1)
    F3 = T**2 + A * T**4
    F4 = BETA/GAMMA * F3 / (1 + A*F3)
    H = GAMMA * PHI**3 * LOG( 1 + F4 )
    FC = ECUNIF + H

    ! Find correlation energy derivatives
    DRSDD = - (THD * RS / DT)
    DKFDD =   THD * KF / DT
    DKSDD = HALF * KS * DKFDD / KF
    DZDD(1) =   1 / DT - ZETA / DT
    DZDD(2) = - (1 / DT) - ZETA / DT
    DPDZ = HALF * TWOTHD * ( 1/(1+ZETA)**THD - 1/(1-ZETA)**THD )
    DO IS = 1,2
      DECUDD = ( VCUNIF(IS) - ECUNIF ) / DT
      DPDD = DPDZ * DZDD(IS)
      DTDD = (- T) * ( DPDD/PHI + DKSDD/KS + 1/DT )
      DF1DD = F1 * ( DECUDD/ECUNIF - 3*DPDD/PHI )
      DF2DD = (- F2) * DF1DD
      DADD = (- A) * DF2DD / (F2-1)
      DF3DD = (2*T + 4*A*T**3) * DTDD + DADD * T**4
      DF4DD = F4 * ( DF3DD/F3 - (DADD*F3+A*DF3DD)/(1+A*F3) )
      DHDD = 3 * H * DPDD / PHI
      DHDD = DHDD + GAMMA * PHI**3 * DF4DD / (1+F4)
      DFCDD(IS) = VCUNIF(IS) + H + DT * DHDD

      DO IX = 1,3
        DTDGD = (T / GDMT) * GDT(IX) / GDMT
        DF3DGD = DTDGD * ( 2 * T + 4 * A * T**3 )
        DF4DGD = F4 * DF3DGD * ( 1/F3 - A/(1+A*F3) ) 
        DHDGD = GAMMA * PHI**3 * DF4DGD / (1+F4)
        DFCDGD(IX,IS) = DT * DHDGD
      end DO
    end DO

    ! Find exchange energy and potential
    FX = 0
    DO IS = 1,2
      DS(IS)   = MAX( DENMIN, 2 * D(IS) )
      GDMS = MAX( GDMIN, 2 * GDM(IS) )
      KFS = (3 * PI**2 * DS(IS))**THD
      S = GDMS / (2 * KFS * DS(IS))
      F1 = 1 + MU * S**2 / KAPPA
      F = 1 + KAPPA - KAPPA / F1
      !
      !       Note nspin=1 in call to exchng...
      !
      CALL EXCHNG( IREL, 1, DS(IS), EXUNIF, VXUNIF(IS) )
      FX = FX + DS(IS) * EXUNIF * F

      DKFDD = THD * KFS / DS(IS)
      DSDD = S * ( -(DKFDD/KFS) - 1/DS(IS) )
      DF1DD = 2 * (F1-1) * DSDD / S
      DFDD = KAPPA * DF1DD / F1**2
      DFXDD(IS) = VXUNIF(IS) * F + DS(IS) * EXUNIF * DFDD

      DO IX = 1,3
        GDS = 2 * GD(IX,IS)
        DSDGD = (S / GDMS) * GDS / GDMS
        DF1DGD = 2 * MU * S * DSDGD / KAPPA
        DFDGD = KAPPA * DF1DGD / F1**2
        DFXDGD(IX,IS) = DS(IS) * EXUNIF * DFDGD
      end DO
    end DO
    FX = HALF * FX / DT

    ! Set output arguments
    EX = FX
    EC = FC
    DO IS = 1,nspin
      DEXDD(IS) = DFXDD(IS)
      DECDD(IS) = DFCDD(IS)
      DO IX = 1,3
        DEXDGD(IX,IS) = DFXDGD(IX,IS)
        DECDGD(IX,IS) = DFCDGD(IX,IS)
      end DO
    end DO
  END SUBROUTINE PBEformXC



  SUBROUTINE PBEXC( IREL, nspin, Dens, GDens, &
      EX, EC, DEXDD, DECDD, DEXDGD, DECDGD )

    ! *********************************************************************
    ! Implements Perdew-Burke-Ernzerhof Generalized-Gradient-Approximation.
    ! Ref: J.P.Perdew, K.Burke & M.Ernzerhof, PRL 77, 3865 (1996)
    ! Modified to call PBEformXC by J.M.Soler. December 2009.
    ! ******** INPUT ******************************************************
    ! INTEGER IREL           : Relativistic-exchange switch (0=No, 1=Yes)
    ! INTEGER nspin          : Number of spin polarizations (1 or 2)
    ! REAL*8  Dens(nspin)    : Total electron density (if nspin=1) or
    !                           spin electron density (if nspin=2)
    ! REAL*8  GDens(3,nspin) : Total or spin density gradient
    ! ******** OUTPUT *****************************************************
    ! REAL*8  EX             : Exchange energy density
    ! REAL*8  EC             : Correlation energy density
    ! REAL*8  DEXDD(nspin)   : Partial derivative
    !                           d(DensTot*Ex)/dDens(ispin),
    !                           where DensTot = Sum_ispin( Dens(ispin) )
    !                          For a constant density, this is the
    !                          exchange potential
    ! REAL*8  DECDD(nspin)   : Partial derivative
    !                           d(DensTot*Ec)/dDens(ispin),
    !                           where DensTot = Sum_ispin( Dens(ispin) )
    !                          For a constant density, this is the
    !                          correlation potential
    ! REAL*8  DEXDGD(3,nspin): Partial derivative
    !                           d(DensTot*Ex)/d(GradDens(i,ispin))
    ! REAL*8  DECDGD(3,nspin): Partial derivative
    !                           d(DensTot*Ec)/d(GradDens(i,ispin))
    ! ********* UNITS ****************************************************
    ! Lengths in Bohr
    ! Densities in electrons per Bohr**3
    ! Energies in Hartrees
    ! Gradient vectors in cartesian coordinates
    ! ********* ROUTINES CALLED ******************************************
    ! EXCHNG, PW92C
    ! ********************************************************************

    ! Passed arguments
    integer, intent(in) :: IREL, NSPIN
    real(dp),intent(in) :: DENS(NSPIN), GDENS(3,NSPIN)
    real(dp),intent(out):: EX, EC, DECDD(NSPIN), DECDGD(3,NSPIN), &
        DEXDD(NSPIN), DEXDGD(3,NSPIN)

    ! Internal variables
    real(dp):: BETA, KAPPA, MU, PI

    ! Fix values for PBE functional parameters
    PI = 4 * ATAN(1._dp)
    BETA = 0.066725_dp       ! From grad. exp. for correl. rs->0
    MU = BETA * PI**2 / 3    ! From Jell. response for x+c
    KAPPA = 0.804_dp         ! From general Lieb-Oxford bound

    ! Call PBE routine with appropriate values for beta, mu, and kappa.
    CALL PBEformXC( BETA, MU, KAPPA, IREL, nspin, Dens, GDens, &
        EX, EC, DEXDD, DECDD, DEXDGD, DECDGD )

  END SUBROUTINE PBEXC



  SUBROUTINE REVPBEXC( IREL, nspin, Dens, GDens,&
      EX, EC, DEXDD, DECDD, DEXDGD, DECDGD )

    ! *********************************************************************
    ! Implements revPBE: revised Perdew-Burke-Ernzerhof GGA.
    ! Ref: Y. Zhang & W. Yang, Phys. Rev. Lett. 80, 890 (1998).
    ! Same interface as PBEXC.
    ! revPBE parameters introduced by E. Artacho in January 2006
    ! Modified to call PBEformXC by J.M.Soler. December 2009.
    ! ********************************************************************

    ! Passed arguments
    integer, intent(in) :: IREL, NSPIN
    real(dp),intent(in) :: DENS(NSPIN), GDENS(3,NSPIN)
    real(dp),intent(out):: EX, EC, DECDD(NSPIN), DECDGD(3,NSPIN), &
        DEXDD(NSPIN), DEXDGD(3,NSPIN)

    ! Internal variables
    real(dp):: BETA, KAPPA, MU, PI

    ! Fix values for PBE functional parameters
    PI = 4 * ATAN(1._dp)
    BETA = 0.066725_dp       ! From grad. exp. for correl. rs->0
    MU = BETA * PI**2 / 3    ! From Jell. response for x+c
    KAPPA = 1.245_dp         ! From fit of molecular energies

    ! Call PBE routine with appropriate values for beta, mu, and kappa.
    CALL PBEformXC( BETA, MU, KAPPA, IREL, nspin, Dens, GDens, &
        EX, EC, DEXDD, DECDD, DEXDGD, DECDGD )

  END SUBROUTINE REVPBEXC



  SUBROUTINE PBESOLXC( IREL, NSPIN, DENS, GDENS, &
      EX, EC, DEXDD, DECDD, DEXDGD, DECDGD )

    ! *********************************************************************
    ! Implements Perdew-Burke-Ernzerhof Generalized-Gradient-Approximation.
    ! with the revised parameters for solids (PBEsol).
    ! Ref: J.P.Perdew et al, PRL 100, 136406 (2008)
    ! Same interface as PBEXC.
    ! Modified by J.D. Gale for PBEsol. May 2009.
    ! Modified to call PBEformXC by J.M.Soler. December 2009.
    ! ********************************************************************

    ! Passed arguments
    integer, intent(in) :: IREL, NSPIN
    real(dp),intent(in) :: DENS(NSPIN), GDENS(3,NSPIN)
    real(dp),intent(out):: EX, EC, DECDD(NSPIN), DECDGD(3,NSPIN), &
        DEXDD(NSPIN), DEXDGD(3,NSPIN)

    ! Internal variables
    real(dp):: BETA, KAPPA, MU, PI

    ! Fix values for PBE functional parameters
    PI = 4 * ATAN(1._dp)
    BETA = 0.046_dp          ! From fit of Jell. surf. energies
    MU = 10.0_dp / 81.0_dp   ! From grad. exp. for exchange.
    KAPPA = 0.804_dp         ! From general Lieb-Oxford bound

    ! Call PBE routine with appropriate values for beta, mu, and kappa.
    CALL PBEformXC( BETA, MU, KAPPA, IREL, nspin, Dens, GDens, &
        EX, EC, DEXDD, DECDD, DEXDGD, DECDGD )

  END SUBROUTINE PBESOLXC



  SUBROUTINE PBEJsJrLOxc( IREL, NSPIN, DENS, GDENS, &
      EX, EC, DEXDD, DECDD, DEXDGD, DECDGD )

    ! *********************************************************************
    ! Implements Perdew-Burke-Ernzerhof Generalized-Gradient-Approximation
    ! functional form, with revised parameters of Capelle et al:
    !   Js refers to Jellium surface energies, that fix parameter beta
    !   Jr refers to Jellium response, that fixes parameter mu
    !   LO refers to Lieb-Oxford bound, that fixes parameter kappa
    ! Refs: L.S.Pedroza et al, PRB 79, 201106 (2009)
    !       M.M.Odashima et al, J. Chem. Theory Comp. 5, 798 (2009)
    ! Same interface as PBEXC. J.M.Soler. December 2009.
    ! ********************************************************************

    ! Passed arguments
    integer, intent(in) :: IREL, NSPIN
    real(dp),intent(in) :: DENS(NSPIN), GDENS(3,NSPIN)
    real(dp),intent(out):: EX, EC, DECDD(NSPIN), DECDGD(3,NSPIN), &
        DEXDD(NSPIN), DEXDGD(3,NSPIN)

    ! Internal variables
    real(dp):: BETA, KAPPA, MU, PI

    ! Fix values for PBE functional parameters
    PI = 4 * ATAN(1._dp)
    BETA = 0.046_dp          ! From fit of Jell. surf. energies
    MU = BETA * PI**2 / 3    ! From Jell. response for x+c
    KAPPA = 0.804_dp         ! From general Lieb-Oxford bound

    ! Call PBE routine with appropriate values for beta, mu, and kappa.
    CALL PBEformXC( BETA, MU, KAPPA, IREL, nspin, Dens, GDens, &
        EX, EC, DEXDD, DECDD, DEXDGD, DECDGD )

  END SUBROUTINE PBEJsJrLOxc



  SUBROUTINE PBEJsJrHEGxc( IREL, NSPIN, DENS, GDENS, &
      EX, EC, DEXDD, DECDD, DEXDGD, DECDGD )

    ! *********************************************************************
    ! Implements Perdew-Burke-Ernzerhof Generalized-Gradient-Approximation
    ! functional form, with revised parameters of Capelle et al:
    !   Js refers to Jellium surface energies, that fix parameter beta
    !   Jr refers to Jellium response, that fixes parameter mu
    !   HGE refers to the Lieb-Oxford bound for the low-density limit of
    !       the homogeneous electron gas, that fixes parameter kappa
    ! Refs: L.S.Pedroza et al, PRB 79, 201106 (2009)
    !       M.M.Odashima et al, J. Chem. Theory Comp. 5, 798 (2009)
    ! Same interface as PBEXC. J.M.Soler. December 2009.
    ! ********************************************************************

    ! Passed arguments
    integer, intent(in) :: IREL, NSPIN
    real(dp),intent(in) :: DENS(NSPIN), GDENS(3,NSPIN)
    real(dp),intent(out):: EX, EC, DECDD(NSPIN), DECDGD(3,NSPIN), &
        DEXDD(NSPIN), DEXDGD(3,NSPIN)

    ! Internal variables
    real(dp):: BETA, KAPPA, MU, PI

    ! Fix values for PBE functional parameters
    PI = 4 * ATAN(1._dp)
    BETA = 0.046_dp          ! From fit of Jell. surf. energies
    MU = BETA * PI**2 / 3    ! From Jell. response for x+c
    KAPPA = 0.552_dp         ! From Lieb-Oxford bound for HEG

    ! Call PBE routine with appropriate values for beta, mu, and kappa.
    CALL PBEformXC( BETA, MU, KAPPA, IREL, nspin, Dens, GDens, &
        EX, EC, DEXDD, DECDD, DEXDGD, DECDGD )

  END SUBROUTINE PBEJsJrHEGxc



  SUBROUTINE PBEGcGxLOxc( IREL, NSPIN, DENS, GDENS, &
      EX, EC, DEXDD, DECDD, DEXDGD, DECDGD )

    ! *********************************************************************
    ! Implements Perdew-Burke-Ernzerhof Generalized-Gradient-Approximation
    ! functional form, with revised parameters of Capelle et al:
    !   Gc refers to gradient exp. for correl., that fixes parameter beta
    !   Gx refers to grad. expansion for exchange, that fixes parameter mu
    !   LO refers to Lieb-Oxford bound, that fixes parameter kappa
    ! Refs: L.S.Pedroza et al, PRB 79, 201106 (2009)
    !       M.M.Odashima et al, J. Chem. Theory Comp. 5, 798 (2009)
    ! Same interface as PBEXC. J.M.Soler. December 2009.
    ! ********************************************************************

    ! Passed arguments
    integer, intent(in) :: IREL, NSPIN
    real(dp),intent(in) :: DENS(NSPIN), GDENS(3,NSPIN)
    real(dp),intent(out):: EX, EC, DECDD(NSPIN), DECDGD(3,NSPIN), &
        DEXDD(NSPIN), DEXDGD(3,NSPIN)

    ! Internal variables
    real(dp):: BETA, KAPPA, MU, PI

    ! Fix values for PBE functional parameters
    PI = 4 * ATAN(1._dp)
    BETA = 0.066725_dp       ! From grad. exp. for correl. rs->0
    MU = 10._dp / 81._dp     ! From grad. exp. for exchange.
    KAPPA = 0.804_dp         ! From general Lieb-Oxford bound

    ! Call PBE routine with appropriate values for beta, mu, and kappa.
    CALL PBEformXC( BETA, MU, KAPPA, IREL, nspin, Dens, GDens, &
        EX, EC, DEXDD, DECDD, DEXDGD, DECDGD )

  END SUBROUTINE PBEGcGxLOxc



  SUBROUTINE PBEGcGxHEGxc( IREL, NSPIN, DENS, GDENS, &
      EX, EC, DEXDD, DECDD, DEXDGD, DECDGD )

    ! *********************************************************************
    ! Implements Perdew-Burke-Ernzerhof Generalized-Gradient-Approximation
    ! functional form, with revised parameters of Capelle et al:
    !   Gc refers to gradient exp. for correl., that fixes parameter beta
    !   Gx refers to grad. expansion for exchange, that fixes parameter mu
    !   HGE refers to the Lieb-Oxford bound for the low-density limit of
    !       the homogeneous electron gas, that fixes parameter kappa
    ! Refs: L.S.Pedroza et al, PRB 79, 201106 (2009)
    !       M.M.Odashima et al, J. Chem. Theory Comp. 5, 798 (2009)
    ! Same interface as PBEXC. J.M.Soler. December 2009.
    ! ********************************************************************

    ! Passed arguments
    integer, intent(in) :: IREL, NSPIN
    real(dp),intent(in) :: DENS(NSPIN), GDENS(3,NSPIN)
    real(dp),intent(out):: EX, EC, DECDD(NSPIN), DECDGD(3,NSPIN), &
        DEXDD(NSPIN), DEXDGD(3,NSPIN)

    ! Internal variables
    real(dp):: BETA, KAPPA, MU, PI

    ! Fix values for PBE functional parameters
    PI = 4 * ATAN(1._dp)
    BETA = 0.066725_dp       ! From grad. exp. for correl. rs->0
    MU = 10._dp / 81._dp     ! From grad. exp. for exchange.
    KAPPA = 0.552_dp         ! From Lieb-Oxford bound for HEG

    ! Call PBE routine with appropriate values for beta, mu, and kappa.
    CALL PBEformXC( BETA, MU, KAPPA, IREL, nspin, Dens, GDens, &
        EX, EC, DEXDD, DECDD, DEXDGD, DECDGD )

  END SUBROUTINE PBEGcGxHEGxc



  SUBROUTINE PW91XC( IREL, nspin, Dens, GDens, &
      EX, EC, DEXDD, DECDD, DEXDGD, DECDGD )

    ! *********************************************************************
    ! Implements Perdew-Wang91 Generalized-Gradient-Approximation.
    ! Ref: JCP 100, 1290 (1994)
    ! Written by J.L. Martins  August 2000
    ! ******** INPUT ******************************************************
    ! INTEGER IREL           : Relativistic-exchange switch (0=No, 1=Yes)
    ! INTEGER nspin          : Number of spin polarizations (1 or 2)
    ! REAL*8  Dens(nspin)    : Total electron density (if nspin=1) or
    !                           spin electron density (if nspin=2)
    ! REAL*8  GDens(3,nspin) : Total or spin density gradient
    ! ******** OUTPUT *****************************************************
    ! REAL*8  EX             : Exchange energy density
    ! REAL*8  EC             : Correlation energy density
    ! REAL*8  DEXDD(nspin)   : Partial derivative
    !                           d(DensTot*Ex)/dDens(ispin),
    !                           where DensTot = Sum_ispin( Dens(ispin) )
    !                          For a constant density, this is the
    !                          exchange potential
    ! REAL*8  DECDD(nspin)   : Partial derivative
    !                           d(DensTot*Ec)/dDens(ispin),
    !                           where DensTot = Sum_ispin( Dens(ispin) )
    !                          For a constant density, this is the
    !                          correlation potential
    ! REAL*8  DEXDGD(3,nspin): Partial derivative
    !                           d(DensTot*Ex)/d(GradDens(i,ispin))
    ! REAL*8  DECDGD(3,nspin): Partial derivative
    !                           d(DensTot*Ec)/d(GradDens(i,ispin))
    ! ********* UNITS ****************************************************
    ! Lengths in Bohr
    ! Densities in electrons per Bohr**3
    ! Energies in Hartrees
    ! Gradient vectors in cartesian coordinates
    ! ********* ROUTINES CALLED ******************************************
    ! EXCHNG, PW92C
    ! ********************************************************************

    INTEGER           IREL, nspin
    real(dp)          Dens(nspin), DECDD(nspin), DECDGD(3,nspin), &
        DEXDD(nspin), DEXDGD(3,nspin), GDens(3,nspin)

    ! Internal variables
    INTEGER :: IS, IX
    real(dp) &
        A, BETA, D(2), DADD, DECUDD, DENMIN, &
        DF1DD, DF2DD, DF3DD, DF4DD, DF1DGD, DF3DGD, DF4DGD, &
        DFCDD(2), DFCDGD(3,2), DFDD, DFDGD, DFXDD(2), DFXDGD(3,2), &
        DHDD, DHDGD, DKFDD, DKSDD, DPDD, DPDZ, DRSDD, &
        DS(2), DSDD, DSDGD, DT, DTDD, DTDGD, DZDD(2), &
        EC, ECUNIF, EX, EXUNIF, &
        F, F1, F2, F3, F4, FC, FX, FOUTHD, &
        GAMMA, GD(3,2), GDM(2), GDMIN, GDMS, GDMT, GDS, GDT(3), &
        H, HALF, KF, KFS, KS, PHI, PI, RS, S, &
        T, THD, THRHLF, TWO, TWOTHD, VCUNIF(2), VXUNIF(2), ZETA

    real(dp)          F5, F6, F7, F8, ASINHS
    real(dp)          DF5DD,DF6DD,DF7DD,DF8DD
    real(dp)          DF1DS, DF2DS, DF3DS, DFDS, DF7DGD

    ! Lower bounds of density and its gradient to avoid divisions by zero
    PARAMETER ( DENMIN = 1.D-12 )
    PARAMETER ( GDMIN  = 1.D-12 )

    ! Fix some numerical parameters
    PARAMETER ( FOUTHD=4.D0/3.D0, HALF=0.5D0, &
        THD=1.D0/3.D0, THRHLF=1.5D0, &
        TWO=2.D0, TWOTHD=2.D0/3.D0 )

    ! Fix some more numerical constants
    PI = 4.0_dp * ATAN(1.0_dp)
    BETA = 15.75592_dp * 0.004235_dp
    GAMMA = BETA**2 / (2.0_dp * 0.09_dp)

    ! Translate density and its gradient to new variables
    IF (nspin .EQ. 1) THEN
      D(1) = HALF * Dens(1)
      D(2) = D(1)
      DT = MAX( DENMIN, Dens(1) )
      DO IX = 1,3
        GD(IX,1) = HALF * GDens(IX,1)
        GD(IX,2) = GD(IX,1)
        GDT(IX) = GDens(IX,1)
      end DO
    ELSE
      D(1) = Dens(1)
      D(2) = Dens(2)
      DT = MAX( DENMIN, Dens(1)+Dens(2) )
      DO IX = 1,3
        GD(IX,1) = GDens(IX,1)
        GD(IX,2) = GDens(IX,2)
        GDT(IX) = GDens(IX,1) + GDens(IX,2)
      end DO
    ENDIF
    GDM(1) = SQRT( GD(1,1)**2 + GD(2,1)**2 + GD(3,1)**2 )
    GDM(2) = SQRT( GD(1,2)**2 + GD(2,2)**2 + GD(3,2)**2 )
    GDMT   = SQRT( GDT(1)**2  + GDT(2)**2  + GDT(3)**2  )
    GDMT = MAX( GDMIN, GDMT )

    ! Find local correlation energy and potential
    CALL PW92C( 2, D, ECUNIF, VCUNIF )

    ! Find total correlation energy
    RS = ( 3 / (4*PI*DT) )**THD
    KF = (3 * PI**2 * DT)**THD
    KS = SQRT( 4 * KF / PI )
    S = GDMT / (2 * KF * DT)
    T = GDMT / (2 * KS * DT)
    ZETA = ( D(1) - D(2) ) / DT
    ZETA = MAX( -1.D0+DENMIN, ZETA )
    ZETA = MIN(  1.D0-DENMIN, ZETA )
    PHI = HALF * ( (1+ZETA)**TWOTHD + (1-ZETA)**TWOTHD )
    F1 = ECUNIF / GAMMA / PHI**3
    F2 = EXP(-F1)
    A = BETA / GAMMA / (F2-1)
    F3 = T**2 + A * T**4
    F4 = BETA/GAMMA * F3 / (1 + A*F3)
    F5 = 0.002568D0 + 0.023266D0*RS + 7.389D-6*RS**2
    F6 = 1.0D0 + 8.723D0*RS + 0.472D0*RS**2 + 0.07389D0*RS**3
    F7 = EXP(-100.0D0 * S**2 * PHI**4)
    F8 =  15.75592D0*(0.001667212D0 + F5/F6 -0.004235D0 + &
        3.0D0*0.001667212D0/7.0D0)
    H = GAMMA * PHI**3 * LOG( 1 + F4 ) + F8 * T**2 * F7
    FC = ECUNIF + H

    ! Find correlation energy derivatives
    DRSDD = - THD * RS / DT
    DKFDD =   THD * KF / DT
    DKSDD = HALF * KS * DKFDD / KF
    DZDD(1) =   1 / DT - ZETA / DT
    DZDD(2) = - 1 / DT - ZETA / DT
    DPDZ = HALF * TWOTHD * ( 1/(1+ZETA)**THD - 1/(1-ZETA)**THD )
    DO IS = 1,2
      DECUDD = ( VCUNIF(IS) - ECUNIF ) / DT
      DPDD = DPDZ * DZDD(IS)
      DSDD = -S*DKFDD/KF - S/DT    ! JMS: corrected, May.2014
      DTDD = -T*DKSDD/KS - T/DT
      DF1DD = F1 * ( DECUDD/ECUNIF - 3*DPDD/PHI )
      DF2DD = - F2 * DF1DD
      DADD = - A * DF2DD / (F2-1)
      DF3DD = (2*T + 4*A*T**3) * DTDD + DADD * T**4
      DF4DD = F4 * ( DF3DD/F3 - (DADD*F3+A*DF3DD)/(1+A*F3) )
      DF5DD = (0.023266D0 + 2.0D0*7.389D-6*RS)*DRSDD
      DF6DD = (8.723D0 + 2.0D0*0.472D0*RS &
          + 3.0D0*0.07389D0*RS**2)*DRSDD
      DF7DD = -200.0D0 * S * PHI**4 * DSDD * F7 &
          -100.0D0 * S**2 * 4.0D0* PHI**3 * DPDD * F7
      DF8DD = 15.75592D0 * DF5DD/F6 - 15.75592D0*F5*DF6DD / F6**2
      DHDD = 3 * H * DPDD / PHI
      DHDD = DHDD + GAMMA * PHI**3 * DF4DD / (1+F4)
      DHDD = DHDD + DF8DD * T**2 * F7
      DHDD = DHDD + F8 * 2*T*DTDD *F7
      DHDD = DHDD + F8 * T**2 * DF7DD

      DFCDD(IS) = VCUNIF(IS) + H + DT * DHDD
      DO IX = 1,3
        DTDGD = (T / GDMT) * GDT(IX) / GDMT
        DSDGD = (S / GDMT) * GDT(IX) / GDMT
        DF3DGD = DTDGD * ( 2 * T + 4 * A * T**3 )
        DF4DGD = F4 * DF3DGD * ( 1/F3 - A/(1+A*F3) ) 
        DF7DGD = -200.0D0 * S * PHI**4 * DSDGD * F7
        DHDGD = GAMMA * PHI**3 * DF4DGD / (1+F4)
        DHDGD = DHDGD + F8 * 2*T*DTDGD *F7 + F8 * T**2 *DF7DGD
        DFCDGD(IX,IS) = DT * DHDGD
      end DO
    end DO

    ! Find exchange energy and potential
    FX = 0
    DO IS = 1,2
      DS(1) = MAX( DENMIN, 2 * D(IS) )
      GDMS = MAX( GDMIN, 2 * GDM(IS) )
      KFS = (3 * PI**2 * DS(1))**THD
      S = GDMS / (2 * KFS * DS(1))
      F4 = SQRT(1.0D0 + (7.7956D0*S)**2)
      ASINHS = LOG(7.7956D0*S + F4)
      F1 = 1.0D0 + 0.19645D0 * S * ASINHS
      F2 = 0.2743D0 - 0.15084D0*EXP(-100.0D0*S*S)
      F3 = 1.0D0 / (F1 + 0.004D0 * S*S*S*S)
      F = (F1 + F2 * S*S ) * F3
      CALL EXCHNG( IREL, 1, DS, EXUNIF, VXUNIF )
      FX = FX + DS(1) * EXUNIF * F

      DKFDD = THD * KFS / DS(1)
      DSDD = S * ( -DKFDD/KFS - 1/DS(1) )
      DF1DS = 0.19645D0 * ASINHS + &
          0.19645D0 * S * 7.7956D0 / F4
      DF2DS = 0.15084D0*200.0D0*S*EXP(-100.0D0*S*S)
      DF3DS = - F3*F3 * (DF1DS + 4.0D0*0.004D0 * S*S*S)
      DFDS =  DF1DS * F3 + DF2DS * S*S * F3 + 2.0D0 * S * F2 * F3 &
          + (F1 + F2 * S*S ) * DF3DS   
      DFXDD(IS) = VXUNIF(1) * F + DS(1) * EXUNIF * DFDS * DSDD

      DO IX = 1,3
        GDS = 2 * GD(IX,IS)
        DSDGD = (S / GDMS) * GDS / GDMS
        DFDGD = DFDS * DSDGD
        DFXDGD(IX,IS) = DS(1) * EXUNIF * DFDGD
      end DO
    end DO
    FX = HALF * FX / DT

    ! Set output arguments
    EX = FX
    EC = FC
    DO IS = 1,nspin
      DEXDD(IS) = DFXDD(IS)
      DECDD(IS) = DFCDD(IS)
      DO IX = 1,3
        DEXDGD(IX,IS) = DFXDGD(IX,IS)
        DECDGD(IX,IS) = DFCDGD(IX,IS)
      end DO
    end DO

  END SUBROUTINE PW91XC



  subroutine blypxc(nspin,dens,gdens,EX,EC, &
      dEXdd,dECdd,dEXdgd,dECdgd) 
    ! ***************************************************************
    ! Implements Becke gradient exchange functional (A.D. 
    ! Becke, Phys. Rev. A 38, 3098 (1988)) and Lee, Yang, Parr
    ! correlation functional (C. Lee, W. Yang, R.G. Parr, Phys. Rev. B
    ! 37, 785 (1988)), as modificated by Miehlich,Savin,Stoll and Preuss,
    ! Chem. Phys. Lett. 157,200 (1989). See also Johnson, Gill and Pople,
    ! J. Chem. Phys. 98, 5612 (1993). Some errors were detected in this
    ! last paper, so not all of the expressions correspond exactly to those
    ! implemented here.
    ! Written by Maider Machado. July 1998.
    ! **************** INPUT ******************************************** 
    ! integer nspin          : Number of spin polarizations (1 or 2)
    ! real*8  dens(nspin)    : Total electron density (if nspin=1) or
    !                           spin electron density (if nspin=2)
    ! real*8  gdens(3,nspin) : Total or spin density gradient
    ! ******** OUTPUT *****************************************************
    ! real*8  ex             : Exchange energy density
    ! real*8  ec             : Correlation energy density
    ! real*8  dexdd(nspin)   : Partial derivative
    !                           d(DensTot*Ex)/dDens(ispin),
    !                           where DensTot = Sum_ispin( Dens(ispin) )
    !                          For a constant density, this is the
    !                          exchange potential
    ! real*8  decdd(nspin)   : Partial derivative
    !                           d(DensTot*Ec)/dDens(ispin),
    !                           where DensTot = Sum_ispin( Dens(ispin) )
    !                          For a constant density, this is the
    !                          correlation potential
    ! real*8  dexdgd(3,nspin): Partial derivative
    !                           d(DensTot*Ex)/d(GradDens(i,ispin))
    ! real*8  decdgd(3,nspin): Partial derivative
    !                           d(DensTot*Ec)/d(GradDens(i,ispin))
    ! ********* UNITS ****************************************************
    ! Lengths in Bohr
    ! Densities in electrons per Bohr**3
    ! Energies in Hartrees
    ! Gradient vectors in cartesian coordinates
    ! ********************************************************************

    integer nspin
    real(dp)   dens(nspin), gdens(3,nspin), EX, EC, &
        dEXdd(nspin), dECdd(nspin), dEXdgd(3,nspin), &
        dECdgd(3,nspin)

    ! Internal variables
    integer is,ix
    real(dp)   pi, beta, thd, tthd, thrhlf, half, fothd, &
        d(2),gd(3,2),dmin, ash,gdm(2),denmin,dt, &
        g(2),x(2),a,b,c,dd,onzthd,gdmin, &
        ga, gb, gc,becke,dbecgd(3,2), &
        dgdx(2), dgdxa, dgdxb, dgdxc,dgdxd,dbecdd(2), &
        den,omega, domega, delta, ddelta,cf, &
        gam11, gam12, gam22, LYPa, LYPb1, &
        LYPb2,dLYP11,dLYP12,dLYP22,LYP, &
        dd1g11,dd1g12,dd1g22,dd2g12,dd2g11,dd2g22, &
        dLYPdd(2),dg11dd(3,2),dg22dd(3,2), &
        dg12dd(3,2),dLYPgd(3,2)

    ! Lower bounds of density and its gradient to avoid divisions by zero
    parameter ( denmin=1.0e-8_dp )
    parameter ( gdmin=1.0e-8_dp )
    parameter ( dmin=1.0e-5_dp ) 

    ! Fix some numerical parameters 
    parameter ( thd = 1.d0/3.d0, tthd=2.d0/3.d0 )
    parameter ( thrhlf=1.5d0, half=0.5d0, &
        fothd=4.d0/3.d0, onzthd=11.d0/3.d0)

    ! Empirical parameter for Becke exchange functional (a.u.)
    parameter(beta= 0.0042d0) 

    ! Constants for LYP functional (a.u.) 
    parameter(a=0.04918d0, b=0.132d0, c=0.2533d0, dd=0.349d0)

    pi= 4*atan(1.d0)

    ! Translate density and its gradient to new variables
    if (nspin .eq. 1) then
      d(1) = half * dens(1)
      d(1) = max(denmin,d(1))
      d(2) = d(1)
      dt = max( denmin, dens(1) )
      do ix = 1,3
        gd(ix,1) = half * gdens(ix,1)    
        gd(ix,2) = gd(ix,1)
      enddo
    else
      d(1) = dens(1)
      d(2) = dens(2)
      do is=1,2
        d(is) = max (denmin,d(is))
      enddo
      dt = max( denmin, dens(1)+dens(2) )  
      do ix = 1,3
        gd(ix,1) = gdens(ix,1)
        gd(ix,2) = gdens(ix,2)
      enddo
    endif

    gdm(1) = sqrt( gd(1,1)**2 + gd(2,1)**2 + gd(3,1)**2 )
    gdm(2) = sqrt( gd(1,2)**2 + gd(2,2)**2 + gd(3,2)**2 )

    do is=1,2
      gdm(is)= max(gdm(is),gdmin)
    enddo

    ! Find Becke exchange energy
    ga = -thrhlf*(3.d0/4.d0/pi)**thd
    do is=1,2
      if(d(is).lt.dmin) then
        g(is)=ga
      else
        x(is) = gdm(is)/d(is)**fothd
        gb = beta*x(is)**2
        ash=log(x(is)+sqrt(x(is)**2+1)) 
        gc = 1+6*beta*x(is)*ash        
        g(is) = ga-gb/gc
      endif
    enddo

    !   Density of energy 
    becke=(g(1)*d(1)**fothd+g(2)*d(2)**fothd)/dt

    ! Exchange energy derivatives
    do is=1,2
      if(d(is).lt.dmin)then
        dbecdd(is)=0.
        do ix=1,3
          dbecgd(ix,is)=0.
        enddo
      else
        dgdxa=6*beta**2*x(is)**2
        ash=log(x(is)+sqrt(x(is)**2+1))
        dgdxb=x(is)/sqrt(x(is)**2+1)-ash
        dgdxc=-2*beta*x(is)
        dgdxd=(1+6*beta*x(is)*ash)**2
        dgdx(is)=(dgdxa*dgdxb+dgdxc)/dgdxd
        dbecdd(is)=fothd*d(is)**thd*(g(is)-x(is)*dgdx(is))
        do ix=1,3
          dbecgd(ix,is)=d(is)**(-fothd)*dgdx(is)*gd(ix,is)/x(is)
        enddo
      endif
    enddo

    !  Lee-Yang-Parr correlation energy
    den=1+dd*dt**(-thd)
    omega=dt**(-onzthd)*exp(-c*dt**(-thd))/den
    delta=c*dt**(-thd)+dd*dt**(-thd)/den
    cf=3.*(3*pi**2)**tthd/10.
    gam11=gdm(1)**2
    gam12=gd(1,1)*gd(1,2)+gd(2,1)*gd(2,2)+gd(3,1)*gd(3,2)
    gam22=gdm(2)**2
    LYPa=-4*a*d(1)*d(2)/(den*dt)
    LYPb1=2**onzthd*cf*a*b*omega*d(1)*d(2)
    LYPb2=d(1)**(8._dp/3._dp)+d(2)**(8._dp/3._dp)
    dLYP11=-a*b*omega*(d(1)*d(2)/9.*(1.-3.*delta-(delta-11.) &
        *d(1)/dt)-d(2)**2)
    dLYP12=-a*b*omega*(d(1)*d(2)/9.*(47.-7.*delta) &
        -fothd*dt**2)
    dLYP22=-a*b*omega*(d(1)*d(2)/9.*(1.-3.*delta-(delta-11.)* &
        d(2)/dt)-d(1)**2)

    !    Density of energy
    LYP=(LYPa-LYPb1*LYPb2+dLYP11*gam11+dLYP12*gam12 &
        +dLYP22*gam22)/dt

    !   Correlation energy derivatives
    domega=-thd*dt**(-fothd)*omega*(11.*dt**thd-c-dd/den)
    ddelta=thd*(dd**2*dt**(-5._dp/3._dp)/den**2-delta/dt)

    !   Second derivatives with respect to the density
    dd1g11=domega/omega*dLYP11-a*b*omega*(d(2)/9.* &
        (1.-3.*delta-2*(delta-11.)*d(1)/dt)-d(1)*d(2)/9.* &
        ((3.+d(1)/dt)*ddelta-(delta-11.)*d(1)/dt**2))

    dd1g12=domega/omega*dLYP12-a*b*omega*(d(2)/9.* &
        (47.-7.*delta)-7._dp/9._dp*d(1)*d(2)*ddelta-8._dp/3._dp*dt)

    dd1g22=domega/omega*dLYP22-a*b*omega*(1._dp/9._dp*d(2) &
        *(1.-3.*delta-(delta-11.)*d(2)/dt)-d(1)*d(2)/9.* &
        ((3.+d(2)/dt)*ddelta-(delta-11.)*d(2)/dt**2)-2*d(1))

    dd2g22=domega/omega*dLYP22-a*b*omega*(d(1)/9.* &
        (1.-3.*delta-2*(delta-11.)*d(2)/dt)-d(1)*d(2)/9.* &
        ((3+d(2)/dt)*ddelta-(delta-11.)*d(2)/dt**2))

    dd2g12=domega/omega*dLYP12-a*b*omega*(d(1)/9.* &
        (47.-7.*delta)-7._dp/9._dp*d(1)*d(2)*ddelta-8._dp/3._dp*dt)

    dd2g11=domega/omega*dLYP11-a*b*omega*(1._dp/9._dp*d(1) &
        *(1.-3.*delta-(delta-11.)*d(1)/dt)-d(1)*d(2)/9.* &
        ((3.+d(1)/dt)*ddelta-(delta-11.)*d(1)/dt**2)-2*d(2))

    dLYPdd(1)=-4*a/den*d(1)*d(2)/dt* &
        (thd*dd*dt**(-fothd)/den &
        +1./d(1)-1./dt)-2**onzthd*cf*a*b*(domega*d(1)*d(2)* &
        (d(1)**(8._dp/3._dp)+d(2)**(8._dp/3._dp))+omega*d(2)*(onzthd* &
        d(1)**(8._dp/3._dp)+d(2)**(8._dp/3._dp)))+dd1g11*gam11+ &
        dd1g12*gam12+dd1g22*gam22

    dLYPdd(2)=-4*a/den*d(1)*d(2)/dt*(thd*dd*dt**(-fothd)/den &
        +1./d(2)-1./dt)-2**onzthd*cf*a*b*(domega*d(1)*d(2)* &
        (d(1)**(8._dp/3._dp)+d(2)**(8._dp/3._dp))+omega*d(1)*(onzthd* &
        d(2)**(8._dp/3._dp)+d(1)**(8._dp/3._dp)))+dd2g22*gam22+ &
        dd2g12*gam12+dd2g11*gam11

    ! second derivatives with respect to the density gradient
    do is=1,2
      do ix=1,3
        dg11dd(ix,is)=2*gd(ix,is)
        dg22dd(ix,is)=2*gd(ix,is)
      enddo
    enddo
    do ix=1,3
      dLYPgd(ix,1)=dLYP11*dg11dd(ix,1)+dLYP12*gd(ix,2)
      dLYPgd(ix,2)=dLYP22*dg22dd(ix,2)+dLYP12*gd(ix,1)
    enddo

    EX=becke
    EC=LYP
    do is=1,nspin
      dEXdd(is)=dbecdd(is)
      dECdd(is)=dLYPdd(is)
      do ix=1,3
        dEXdgd(ix,is)=dbecgd(ix,is)
        dECdgd(ix,is)=dLYPgd(ix,is)
      enddo
    enddo
  end subroutine blypxc



  SUBROUTINE RPBEXC( IREL, nspin, Dens, GDens, &
      EX, EC, DEXDD, DECDD, DEXDGD, DECDGD )

    ! *********************************************************************
    ! Implements Hammer's RPBE Generalized-Gradient-Approximation (GGA).
    ! A revision of PBE (Perdew-Burke-Ernzerhof) 
    ! Ref: Hammer, Hansen & Norskov, PRB 59, 7413 (1999) and
    ! J.P.Perdew, K.Burke & M.Ernzerhof, PRL 77, 3865 (1996)
    !
    ! Written by M.V. Fernandez-Serra. March 2004. On the PBE routine of
    ! L.C.Balbas and J.M.Soler. December 1996.
    ! ******** INPUT ******************************************************
    ! INTEGER IREL           : Relativistic-exchange switch (0=No, 1=Yes)
    ! INTEGER nspin          : Number of spin polarizations (1 or 2)
    ! REAL*8  Dens(nspin)    : Total electron density (if nspin=1) or
    !                           spin electron density (if nspin=2)
    ! REAL*8  GDens(3,nspin) : Total or spin density gradient
    ! ******** OUTPUT *****************************************************
    ! REAL*8  EX             : Exchange energy density
    ! REAL*8  EC             : Correlation energy density
    ! REAL*8  DEXDD(nspin)   : Partial derivative
    !                           d(DensTot*Ex)/dDens(ispin),
    !                           where DensTot = Sum_ispin( Dens(ispin) )
    !                          For a constant density, this is the
    !                          exchange potential
    ! REAL*8  DECDD(nspin)   : Partial derivative
    !                           d(DensTot*Ec)/dDens(ispin),
    !                           where DensTot = Sum_ispin( Dens(ispin) )
    !                          For a constant density, this is the
    !                          correlation potential
    ! REAL*8  DEXDGD(3,nspin): Partial derivative
    !                           d(DensTot*Ex)/d(GradDens(i,ispin))
    ! REAL*8  DECDGD(3,nspin): Partial derivative
    !                           d(DensTot*Ec)/d(GradDens(i,ispin))
    ! ********* UNITS ****************************************************
    ! Lengths in Bohr
    ! Densities in electrons per Bohr**3
    ! Energies in Hartrees
    ! Gradient vectors in cartesian coordinates
    ! ********* ROUTINES CALLED ******************************************
    ! EXCHNG, PW92C
    ! ********************************************************************

    INTEGER           IREL, nspin
    real(dp)          Dens(nspin), DECDD(nspin), DECDGD(3,nspin), &
        DEXDD(nspin), DEXDGD(3,nspin), GDens(3,nspin)

    ! Internal variables
    INTEGER :: IS, IX

    real(dp) &
        A, BETA, D(2), DADD, DECUDD, DENMIN, &
        DF1DD, DF2DD, DF3DD, DF4DD, DF1DGD, DF3DGD, DF4DGD, &
        DFCDD(2), DFCDGD(3,2), DFDD, DFDGD, DFXDD(2), DFXDGD(3,2), &
        DHDD, DHDGD, DKFDD, DKSDD, DPDD, DPDZ, DRSDD, &
        DS(2), DSDD, DSDGD, DT, DTDD, DTDGD, DZDD(2), &
        EC, ECUNIF, EX, EXUNIF, &
        F, F1, F2, F3, F4, FC, FX, FOUTHD, &
        GAMMA, GD(3,2), GDM(2), GDMIN, GDMS, GDMT, GDS, GDT(3), &
        H, HALF, KAPPA, KF, KFS, KS, MU, PHI, PI, RS, S, &
        T, THD, THRHLF, TWO, TWOTHD, VCUNIF(2), VXUNIF(2), ZETA

    ! Lower bounds of density and its gradient to avoid divisions by zero
    PARAMETER ( DENMIN = 1.D-12 )
    PARAMETER ( GDMIN  = 1.D-12 )

    ! Fix some numerical parameters
    PARAMETER ( FOUTHD=4.D0/3.D0, HALF=0.5D0, &
        THD=1.D0/3.D0, THRHLF=1.5D0, &
        TWO=2.D0, TWOTHD=2.D0/3.D0 )

    ! Fix some more numerical constants
    PI = 4 * ATAN(1.D0)
    BETA = 0.066725D0
    GAMMA = (1 - LOG(TWO)) / PI**2
    MU = BETA * PI**2 / 3
    KAPPA = 0.804D0

    ! Translate density and its gradient to new variables
    IF (nspin .EQ. 1) THEN
      D(1) = HALF * Dens(1)
      D(2) = D(1)
      DT = MAX( DENMIN, Dens(1) )
      DO IX = 1,3
        GD(IX,1) = HALF * GDens(IX,1)
        GD(IX,2) = GD(IX,1)
        GDT(IX) = GDens(IX,1)
      end DO
    ELSE
      D(1) = Dens(1)
      D(2) = Dens(2)
      DT = MAX( DENMIN, Dens(1)+Dens(2) )
      DO IX = 1,3
        GD(IX,1) = GDens(IX,1)
        GD(IX,2) = GDens(IX,2)
        GDT(IX) = GDens(IX,1) + GDens(IX,2)
      end DO
    ENDIF
    GDM(1) = SQRT( GD(1,1)**2 + GD(2,1)**2 + GD(3,1)**2 )
    GDM(2) = SQRT( GD(1,2)**2 + GD(2,2)**2 + GD(3,2)**2 )
    GDMT   = SQRT( GDT(1)**2  + GDT(2)**2  + GDT(3)**2  )
    GDMT = MAX( GDMIN, GDMT )

    ! Find local correlation energy and potential
    CALL PW92C( 2, D, ECUNIF, VCUNIF )

    ! Find total correlation energy
    RS = ( 3 / (4*PI*DT) )**THD
    KF = (3 * PI**2 * DT)**THD
    KS = SQRT( 4 * KF / PI )
    ZETA = ( D(1) - D(2) ) / DT
    ZETA = MAX( -1.D0+DENMIN, ZETA )
    ZETA = MIN(  1.D0-DENMIN, ZETA )
    PHI = HALF * ( (1+ZETA)**TWOTHD + (1-ZETA)**TWOTHD )
    T = GDMT / (2 * PHI * KS * DT)
    F1 = ECUNIF / GAMMA / PHI**3
    F2 = EXP(-F1)
    A = BETA / GAMMA / (F2-1)
    F3 = T**2 + A * T**4
    F4 = BETA/GAMMA * F3 / (1 + A*F3)
    H = GAMMA * PHI**3 * LOG( 1 + F4 )
    FC = ECUNIF + H

    ! Find correlation energy derivatives
    DRSDD = - (THD * RS / DT)
    DKFDD =   THD * KF / DT
    DKSDD = HALF * KS * DKFDD / KF
    DZDD(1) =   1 / DT - ZETA / DT
    DZDD(2) = - (1 / DT) - ZETA / DT
    DPDZ = HALF * TWOTHD * ( 1/(1+ZETA)**THD - 1/(1-ZETA)**THD )
    DO IS = 1,2
      DECUDD = ( VCUNIF(IS) - ECUNIF ) / DT
      DPDD = DPDZ * DZDD(IS)
      DTDD = (- T) * ( DPDD/PHI + DKSDD/KS + 1/DT )
      DF1DD = F1 * ( DECUDD/ECUNIF - 3*DPDD/PHI )
      DF2DD = (- F2) * DF1DD
      DADD = (- A) * DF2DD / (F2-1)
      DF3DD = (2*T + 4*A*T**3) * DTDD + DADD * T**4
      DF4DD = F4 * ( DF3DD/F3 - (DADD*F3+A*DF3DD)/(1+A*F3) )
      DHDD = 3 * H * DPDD / PHI
      DHDD = DHDD + GAMMA * PHI**3 * DF4DD / (1+F4)
      DFCDD(IS) = VCUNIF(IS) + H + DT * DHDD

      DO IX = 1,3
        DTDGD = (T / GDMT) * GDT(IX) / GDMT
        DF3DGD = DTDGD * ( 2 * T + 4 * A * T**3 )
        DF4DGD = F4 * DF3DGD * ( 1/F3 - A/(1+A*F3) ) 
        DHDGD = GAMMA * PHI**3 * DF4DGD / (1+F4)
        DFCDGD(IX,IS) = DT * DHDGD
      end DO
    end DO

    ! Find exchange energy and potential
    FX = 0
    DO IS = 1,2
      DS(IS)   = MAX( DENMIN, 2 * D(IS) )
      GDMS = MAX( GDMIN, 2 * GDM(IS) )
      KFS = (3 * PI**2 * DS(IS))**THD
      S = GDMS / (2 * KFS * DS(IS))
      !ea Hammer's RPBE (Hammer, Hansen & Norskov PRB 59 7413 (99)
      !ea     F1 = DEXP( - MU * S**2 / KAPPA)
      !ea     F = 1 + KAPPA * (1 - F1)
      !ea Following is standard PBE
      !ea     F1 = 1 + MU * S**2 / KAPPA
      !ea     F = 1 + KAPPA - KAPPA / F1
      !ea (If revPBE Zhang & Yang, PRL 80,890(1998),change PBE's KAPPA to 1.245)
      F1 = DEXP( - MU * S**2 / KAPPA)
      F = 1 + KAPPA * (1 - F1)

      !       Note nspin=1 in call to exchng...

      CALL EXCHNG( IREL, 1, DS(IS), EXUNIF, VXUNIF(IS) )
      FX = FX + DS(IS) * EXUNIF * F

      !MVFS   The derivatives of F  also need to be changed for Hammer's RPBE.
      !MVFS   DF1DD = 2 * F1 * DSDD  * ( - MU * S / KAPPA)
      !MVFS   DF1DGD= 2 * F1 * DSDGD * ( - MU * S / KAPPA)
      !MVFS   DFDD  = -1 * KAPPA * DF1DD
      !MVFS   DFDGD = -1 * KAPPA * DFDGD

      DKFDD = THD * KFS / DS(IS)
      DSDD = S * ( -(DKFDD/KFS) - 1/DS(IS) )
      !       DF1DD = 2 * (F1-1) * DSDD / S
      !       DFDD = KAPPA * DF1DD / F1**2
      DF1DD = 2* F1 * DSDD * ( - MU * S / KAPPA)
      DFDD = -1 * KAPPA * DF1DD
      DFXDD(IS) = VXUNIF(IS) * F + DS(IS) * EXUNIF * DFDD

      DO IX = 1,3
        GDS = 2 * GD(IX,IS)
        DSDGD = (S / GDMS) * GDS / GDMS
        !         DF1DGD = 2 * MU * S * DSDGD / KAPPA
        !         DFDGD = KAPPA * DF1DGD / F1**2
        DF1DGD =2*F1 * DSDGD * ( - MU * S / KAPPA)
        DFDGD = -1 * KAPPA * DF1DGD
        DFXDGD(IX,IS) = DS(IS) * EXUNIF * DFDGD
      end DO
    end DO
    FX = HALF * FX / DT

    ! Set output arguments
    EX = FX
    EC = FC
    DO IS = 1,nspin
      DEXDD(IS) = DFXDD(IS)
      DECDD(IS) = DFCDD(IS)
      DO IX = 1,3
        DEXDGD(IX,IS) = DFXDGD(IX,IS)
        DECDGD(IX,IS) = DFCDGD(IX,IS)
      end DO
    end DO
  END SUBROUTINE RPBEXC



  SUBROUTINE WCXC( IREL, nspin, Dens, GDens, &
      EX, EC, DEXDD, DECDD, DEXDGD, DECDGD )

    ! *********************************************************************
    ! Implements Wu-Cohen Generalized-Gradient-Approximation.
    ! Ref: Z. Wu and R. E. Cohen PRB 73, 235116 (2006)
    ! Written by Marivi Fernandez-Serra, with contributions by
    ! Julian Gale and Alberto Garcia,
    ! over the PBEXC subroutine of L.C.Balbas and J.M.Soler.
    ! September, 2006.
    ! ******** INPUT ******************************************************
    ! INTEGER IREL           : Relativistic-exchange switch (0=No, 1=Yes)
    ! INTEGER nspin          : Number of spin polarizations (1 or 2)
    ! REAL*8  Dens(nspin)    : Total electron density (if nspin=1) or
    !                           spin electron density (if nspin=2)
    ! REAL*8  GDens(3,nspin) : Total or spin density gradient
    ! ******** OUTPUT *****************************************************
    ! REAL*8  EX             : Exchange energy density
    ! REAL*8  EC             : Correlation energy density
    ! REAL*8  DEXDD(nspin)   : Partial derivative
    !                           d(DensTot*Ex)/dDens(ispin),
    !                           where DensTot = Sum_ispin( Dens(ispin) )
    !                          For a constant density, this is the
    !                          exchange potential
    ! REAL*8  DECDD(nspin)   : Partial derivative
    !                           d(DensTot*Ec)/dDens(ispin),
    !                           where DensTot = Sum_ispin( Dens(ispin) )
    !                          For a constant density, this is the
    !                          correlation potential
    ! REAL*8  DEXDGD(3,nspin): Partial derivative
    !                           d(DensTot*Ex)/d(GradDens(i,ispin))
    ! REAL*8  DECDGD(3,nspin): Partial derivative
    !                           d(DensTot*Ec)/d(GradDens(i,ispin))
    ! ********* UNITS ****************************************************
    ! Lengths in Bohr
    ! Densities in electrons per Bohr**3
    ! Energies in Hartrees
    ! Gradient vectors in cartesian coordinates
    ! ********* ROUTINES CALLED ******************************************
    ! EXCHNG, PW92C
    ! ********************************************************************

    INTEGER           IREL, nspin
    real(dp)          Dens(nspin), DECDD(nspin), DECDGD(3,nspin), &
        DEXDD(nspin), DEXDGD(3,nspin), GDens(3,nspin)

    ! Internal variables
    INTEGER :: IS, IX

    real(dp) &
        A, BETA, D(2), DADD, DECUDD, DENMIN,  &
        DF1DD, DF2DD, DF3DD, DF4DD, DF1DGD, DF3DGD, DF4DGD, &
        DFCDD(2), DFCDGD(3,2), DFDD, DFDGD, DFXDD(2), DFXDGD(3,2), &
        DHDD, DHDGD, DKFDD, DKSDD, DPDD, DPDZ, DRSDD,  &
        DS(2), DSDD, DSDGD, DT, DTDD, DTDGD, DZDD(2),  &
        XWC, DXWCDS, CWC, &
        EC, ECUNIF, EX, EXUNIF, &
        F, F1, F2, F3, F4, FC, FX, FOUTHD, &
        GAMMA, GD(3,2), GDM(2), GDMIN, GDMS, GDMT, GDS, GDT(3), &
        H, HALF, KAPPA, KF, KFS, KS, MU, PHI, PI, RS, S, &
        TEN81,  &
        T, THD, THRHLF, TWO, TWOTHD, VCUNIF(2), VXUNIF(2), ZETA

    ! Lower bounds of density and its gradient to avoid divisions by zero
    PARAMETER ( DENMIN = 1.D-12 )
    PARAMETER ( GDMIN  = 1.D-12 )

    ! Fix some numerical parameters
    PARAMETER ( FOUTHD=4.D0/3.D0, HALF=0.5D0, &
        THD=1.D0/3.D0, THRHLF=1.5D0, &
        TWO=2.D0, TWOTHD=2.D0/3.D0 )
    PARAMETER ( TEN81 = 10.0d0/81.0d0 )

    ! Fix some more numerical constants
    PI = 4 * ATAN(1.D0)
    BETA = 0.066725D0
    GAMMA = (1 - LOG(TWO)) / PI**2
    MU = BETA * PI**2 / 3
    KAPPA = 0.804D0
    CWC = 0.0079325D0

    ! Translate density and its gradient to new variables
    IF (nspin .EQ. 1) THEN
      D(1) = HALF * Dens(1)
      D(2) = D(1)
      DT = MAX( DENMIN, Dens(1) )
      DO IX = 1,3
        GD(IX,1) = HALF * GDens(IX,1)
        GD(IX,2) = GD(IX,1)
        GDT(IX) = GDens(IX,1)
      end DO
    ELSE
      D(1) = Dens(1)
      D(2) = Dens(2)
      DT = MAX( DENMIN, Dens(1)+Dens(2) )
      DO IX = 1,3
        GD(IX,1) = GDens(IX,1)
        GD(IX,2) = GDens(IX,2)
        GDT(IX) = GDens(IX,1) + GDens(IX,2)
      end DO
    ENDIF
    GDM(1) = SQRT( GD(1,1)**2 + GD(2,1)**2 + GD(3,1)**2 )
    GDM(2) = SQRT( GD(1,2)**2 + GD(2,2)**2 + GD(3,2)**2 )
    GDMT   = SQRT( GDT(1)**2  + GDT(2)**2  + GDT(3)**2  )
    GDMT = MAX( GDMIN, GDMT )

    ! Find local correlation energy and potential
    CALL PW92C( 2, D, ECUNIF, VCUNIF )

    ! Find total correlation energy
    RS = ( 3 / (4*PI*DT) )**THD
    KF = (3 * PI**2 * DT)**THD
    KS = SQRT( 4 * KF / PI )
    ZETA = ( D(1) - D(2) ) / DT
    ZETA = MAX( -1.D0+DENMIN, ZETA )
    ZETA = MIN(  1.D0-DENMIN, ZETA )
    PHI = HALF * ( (1+ZETA)**TWOTHD + (1-ZETA)**TWOTHD )
    T = GDMT / (2 * PHI * KS * DT)
    F1 = ECUNIF / GAMMA / PHI**3
    F2 = EXP(-F1)
    A = BETA / GAMMA / (F2-1)
    F3 = T**2 + A * T**4
    F4 = BETA/GAMMA * F3 / (1 + A*F3)
    H = GAMMA * PHI**3 * LOG( 1 + F4 )
    FC = ECUNIF + H

    ! Find correlation energy derivatives
    DRSDD = - (THD * RS / DT)
    DKFDD =   THD * KF / DT
    DKSDD = HALF * KS * DKFDD / KF
    DZDD(1) =   1 / DT - ZETA / DT
    DZDD(2) = - (1 / DT) - ZETA / DT
    DPDZ = HALF * TWOTHD * ( 1/(1+ZETA)**THD - 1/(1-ZETA)**THD )
    DO IS = 1,2
      DECUDD = ( VCUNIF(IS) - ECUNIF ) / DT
      DPDD = DPDZ * DZDD(IS)
      DTDD = (- T) * ( DPDD/PHI + DKSDD/KS + 1/DT )
      DF1DD = F1 * ( DECUDD/ECUNIF - 3*DPDD/PHI )
      DF2DD = (- F2) * DF1DD
      DADD = (- A) * DF2DD / (F2-1)
      DF3DD = (2*T + 4*A*T**3) * DTDD + DADD * T**4
      DF4DD = F4 * ( DF3DD/F3 - (DADD*F3+A*DF3DD)/(1+A*F3) )
      DHDD = 3 * H * DPDD / PHI
      DHDD = DHDD + GAMMA * PHI**3 * DF4DD / (1+F4)
      DFCDD(IS) = VCUNIF(IS) + H + DT * DHDD

      DO IX = 1,3
        DTDGD = (T / GDMT) * GDT(IX) / GDMT
        DF3DGD = DTDGD * ( 2 * T + 4 * A * T**3 )
        DF4DGD = F4 * DF3DGD * ( 1/F3 - A/(1+A*F3) ) 
        DHDGD = GAMMA * PHI**3 * DF4DGD / (1+F4)
        DFCDGD(IX,IS) = DT * DHDGD
      end DO
    end DO

    ! Find exchange energy and potential
    FX = 0
    DO IS = 1,2
      DS(IS)   = MAX( DENMIN, 2 * D(IS) )
      GDMS = MAX( GDMIN, 2 * GDM(IS) )
      KFS = (3 * PI**2 * DS(IS))**THD
      S = GDMS / (2 * KFS * DS(IS))
      !
      ! For PBE: 
      !
      !       x = MU * S**2
      !       dxds = 2*MU*S
      !
      ! Wu-Cohen form:
      !
      XWC= TEN81 * s**2 + (MU- TEN81) * &
          S**2 * exp(-S**2) + log(1+ CWC * S**4)
      DXWCDS = 2 * TEN81 * S + (MU - TEN81) * exp(-S**2) * &
          2*S * (1 - S*S) + 4 * CWC * S**3 / (1 + CWC * S**4) 

      F1 = 1 +  XWC / KAPPA
      F = 1 + KAPPA - KAPPA / F1
      !
      !       Note nspin=1 in call to exchng...
      !
      CALL EXCHNG( IREL, 1, DS(IS), EXUNIF, VXUNIF(IS) )
      FX = FX + DS(IS) * EXUNIF * F

      DKFDD = THD * KFS / DS(IS)
      DSDD = S * ( -(DKFDD/KFS) - 1/DS(IS) )
      DF1DD = DXWCDS * DSDD / KAPPA 
      DFDD = KAPPA * DF1DD / F1**2
      DFXDD(IS) = VXUNIF(IS) * F + DS(IS) * EXUNIF * DFDD

      DO IX = 1,3
        GDS = 2 * GD(IX,IS)
        DSDGD = (S / GDMS) * GDS / GDMS
        DF1DGD = DXWCDS * DSDGD / KAPPA
        DFDGD = KAPPA * DF1DGD / F1**2
        DFXDGD(IX,IS) = DS(IS) * EXUNIF * DFDGD
      end DO
    end DO
    FX = HALF * FX / DT

    ! Set output arguments
    EX = FX
    EC = FC
    DO IS = 1,nspin
      DEXDD(IS) = DFXDD(IS)
      DECDD(IS) = DFCDD(IS)
      DO IX = 1,3
        DEXDGD(IX,IS) = DFXDGD(IX,IS)
        DECDGD(IX,IS) = DFCDGD(IX,IS)
      end DO
    end DO

  END SUBROUTINE WCXC



  SUBROUTINE AM05XC( IREL, nspin, Dens, GDens, &
      EX, EC, DEXDD, DECDD, DEXDGD, DECDGD )

    ! *********************************************************************
    ! Implements the Armiento Mattsson AM05 GGA.
    ! Ref: R. Armiento and A. E. Mattsson, PRB 72, 085108 (2005)
    ! Written by L.C.Balbas and J.M.Soler originally for PBE. December 1996. 
    ! Modified by J.D. Gale for AM05. May 2009.
    ! ******** INPUT ******************************************************
    ! INTEGER IREL           : Relativistic-exchange switch (0=No, 1=Yes)
    ! INTEGER nspin          : Number of spin polarizations (1 or 2)
    ! REAL*8  Dens(nspin)    : Total electron density (if nspin=1) or
    !                           spin electron density (if nspin=2)
    ! REAL*8  GDens(3,nspin) : Total or spin density gradient
    ! ******** OUTPUT *****************************************************
    ! REAL*8  EX             : Exchange energy density
    ! REAL*8  EC             : Correlation energy density
    ! REAL*8  DEXDD(nspin)   : Partial derivative
    !                           d(DensTot*Ex)/dDens(ispin),
    !                           where DensTot = Sum_ispin( Dens(ispin) )
    !                          For a constant density, this is the
    !                          exchange potential
    ! REAL*8  DECDD(nspin)   : Partial derivative
    !                           d(DensTot*Ec)/dDens(ispin),
    !                           where DensTot = Sum_ispin( Dens(ispin) )
    !                          For a constant density, this is the
    !                          correlation potential
    ! REAL*8  DEXDGD(3,nspin): Partial derivative
    !                           d(DensTot*Ex)/d(GradDens(i,ispin))
    ! REAL*8  DECDGD(3,nspin): Partial derivative
    !                           d(DensTot*Ec)/d(GradDens(i,ispin))
    ! ********* UNITS ****************************************************
    ! Lengths in Bohr
    ! Densities in electrons per Bohr**3
    ! Energies in Hartrees
    ! Gradient vectors in cartesian coordinates
    ! ********* ROUTINES CALLED ******************************************
    ! am05wbs
    ! ********************************************************************

    use gridxc_precision, only : dp
    use gridxc_am05,      only : am05wbs

    integer           irel, nspin
    real(dp)          Dens(nspin), DECDD(nspin), DECDGD(3,nspin), &
        DEXDD(nspin), DEXDGD(3,nspin), GDens(3,nspin)

    ! Internal variables
    integer :: is, ix

    real(dp) &
        D(2), DENMIN, DFXDD(2), DFCDD(2), DFCDGD(3,2), &
        DFXDGD(3,2), DFXDG(2), DFCDG(2), &
        DS(2), DT, EC, EX, FX, FC, &
        GD(3,2), GDM(2), GDMIN, GDMS, GDMT, GDS, GDT(3)

    ! Lower bounds of density and its gradient to avoid divisions by zero
    parameter ( DENMIN = 1.D-12 )
    parameter ( GDMIN  = 1.D-12 )

    ! Translate density and its gradient to new variables
    if (nspin .eq. 1) then
      D(1) = 0.5_dp*Dens(1)
      D(2) = D(1)
      DT = max( DENMIN, Dens(1) )
      do ix = 1,3
        GD(ix,1) = 0.5_dp*GDens(ix,1)
        GD(ix,2) = GD(ix,1)
        GDT(ix) = GDens(ix,1)
      enddo
    else
      D(1) = Dens(1)
      D(2) = Dens(2)
      DT = max( DENMIN, Dens(1)+Dens(2) )
      do ix = 1,3
        GD(ix,1) = GDens(ix,1)
        GD(ix,2) = GDens(ix,2)
        GDT(ix) = GDens(ix,1) + GDens(ix,2)
      enddo
    endif
    GDM(1) = sqrt( GD(1,1)**2 + GD(2,1)**2 + GD(3,1)**2 )
    GDM(2) = sqrt( GD(1,2)**2 + GD(2,2)**2 + GD(3,2)**2 )
    GDMT   = sqrt( GDT(1)**2  + GDT(2)**2  + GDT(3)**2  )
    GDMT = max( GDMIN, GDMT )

    D(1) = max(D(1),denmin)
    D(2) = max(D(2),denmin)

    ! Call AM05 subroutine
    call am05wbs(D(1), D(2), GDM(1), GDM(2), FX, FC, &
        DFXDD(1), DFXDD(2), DFCDD(1), DFCDD(2), &
        DFXDG(1), DFXDG(2), DFCDG(1), DFCDG(2))

    ! Convert gradient terms into vectors
    do is = 1,nspin
      do ix = 1,3
        DFXDGD(ix,is) = DFXDG(is)*GD(ix,is)
        DFCDGD(ix,is) = DFCDG(is)*GD(ix,is)
      enddo
    enddo

    ! Convert FX to form required by SIESTA - note factor of 1/2
    ! is already applied in am05 code.
    FX = FX / DT

    ! Set output arguments
    EX = FX
    EC = FC
    do is = 1,nspin
      DEXDD(is) = DFXDD(is)
      DECDD(is) = DFCDD(is)
      do ix = 1,3
        DEXDGD(ix,is) = DFXDGD(ix,is)
        DECDGD(ix,is) = DFCDGD(ix,is)
      enddo
    enddo

  END SUBROUTINE AM05XC



  SUBROUTINE PW86formX( a, b, c, iRel, nSpin, Dens, GDens, &
      EX, dEXdD, dEXdGD )

    ! *********************************************************************
    ! Implements Perdew-Wang-86 Generalized-Gradient-Approximation exchange-only
    ! functional form, eps_x=eps_x_LDA*(1+15*a*s**2+b*s**4+c*s**6)**(1/15),
    ! but with variable values for parameters a, b, and c
    ! Refs: J.P.Perdew & Y.Wang, PRB 33, 8800 (1986)
    !       E.D.Murray, K.Lee & D.C.Langreth, JCTC 5, 2754 (2009)
    ! Written by J.M.Soler. March 2010.
    ! ******** INPUT ******************************************************
    ! REAL*8  a, b, c        : Parameter a, b, and c of the PW86 functional
    ! INTEGER IREL           : Relativistic-exchange switch (0=No, 1=Yes)
    ! INTEGER nspin          : Number of spin polarizations (1 or 2)
    ! REAL*8  Dens(nspin)    : Total electron density (if nspin=1) or
    !                           spin electron density (if nspin=2)
    ! REAL*8  GDens(3,nspin) : Total or spin density gradient
    ! ******** OUTPUT *****************************************************
    ! REAL*8  EX             : Exchange energy density
    ! REAL*8  DEXDD(nspin)   : Partial derivative
    !                           d(DensTot*Ex)/dDens(ispin),
    !                           where DensTot = Sum_ispin( Dens(ispin) )
    !                          For a constant density, this is the
    !                          exchange potential
    ! REAL*8  DEXDGD(3,nspin): Partial derivative
    !                           d(DensTot*Ex)/d(GradDens(i,ispin))
    ! ********* UNITS ****************************************************
    ! Lengths in Bohr
    ! Densities in electrons per Bohr**3
    ! Energies in Hartrees
    ! Gradient vectors in cartesian coordinates
    ! ********* ROUTINES CALLED ******************************************
    ! EXCHNG
    ! ********************************************************************

    ! Input
    real(dp),intent(in) :: a              ! Parameter of PW86 functional
    real(dp),intent(in) :: b              ! Parameter of PW86 functional
    real(dp),intent(in) :: c              ! Parameter of PW86 functional
    integer, intent(in) :: iRel           ! Relativistic exchange? 0=no, 1=yes
    integer, intent(in) :: nSpin          ! Number of spin components
    real(dp),intent(in) :: Dens(nSpin)    ! Local electron (spin) density
    real(dp),intent(in) :: GDens(3,nSpin) ! Gradient of electron density

    ! Output
    real(dp),intent(out):: EX             ! Exchange energy per electron
    real(dp),intent(out):: dEXdD(nSpin)   ! dEx/dDens, Ex=Int(dens*epsX)
    real(dp),intent(out):: dEXdGD(3,nSpin) ! dEx/dGrad(Dens)

    ! Internal variables
    INTEGER :: IS, IX
    real(dp) &
        D(2), DENMIN, DF1DS, DFDD, DFDGD, DFDS, DFXDD(2), DFXDGD(3,2), &
        DKFDD, DS(2), DSDD, DSDGD, DT, ECUNIF, EXUNIF, F, F1, FX, &
        GD(3,2), GDM(2), GDMIN, GDMS, GDMT, GDS, GDT(3), &
        KFS, PI, S, VXUNIF(2), ZETA

    ! Lower bounds of density and its gradient to avoid divisions by zero
    PARAMETER ( DENMIN = 1.D-12 )
    PARAMETER ( GDMIN  = 1.D-12 )

    ! Fix some more numerical constants
    PI = 4 * ATAN(1.D0)

    ! Translate density and its gradient to new variables
    IF (nspin .EQ. 1) THEN
      D(1) = Dens(1) / 2
      D(2) = D(1)
      DT = MAX( DENMIN, Dens(1) )
      DO IX = 1,3
        GD(IX,1) = GDens(IX,1) / 2
        GD(IX,2) = GD(IX,1)
        GDT(IX) = GDens(IX,1)
      end DO
    ELSE
      D(1) = Dens(1)
      D(2) = Dens(2)
      DT = MAX( DENMIN, Dens(1)+Dens(2) )
      DO IX = 1,3
        GD(IX,1) = GDens(IX,1)
        GD(IX,2) = GDens(IX,2)
        GDT(IX) = GDens(IX,1) + GDens(IX,2)
      end DO
    ENDIF
    GDM(1) = SQRT( GD(1,1)**2 + GD(2,1)**2 + GD(3,1)**2 )
    GDM(2) = SQRT( GD(1,2)**2 + GD(2,2)**2 + GD(3,2)**2 )
    GDMT   = SQRT( GDT(1)**2  + GDT(2)**2  + GDT(3)**2  )
    GDMT = MAX( GDMIN, GDMT )

    ! Find exchange energy and potential
    FX = 0
    DO IS = 1,2
      DS(IS)   = MAX( DENMIN, 2 * D(IS) )
      GDMS = MAX( GDMIN, 2 * GDM(IS) )
      KFS = (3 * PI**2 * DS(IS))**(1._dp/3)
      S = GDMS / (2 * KFS * DS(IS))
      F1 = 1 + 15*a*S**2 + b*S**4 + c*S**6
      F = F1**(1._dp/15)
      !
      !       Note nspin=1 in call to exchng...
      !
      CALL EXCHNG( IREL, 1, DS(IS), EXUNIF, VXUNIF(IS) )
      FX = FX + DS(IS) * EXUNIF * F

      DKFDD = KFS / DS(IS) / 3
      DSDD = S * ( -(DKFDD/KFS) - 1/DS(IS) )
      DF1DS = 30*a*S + 4*b*S**3 + 6*c*S**5
      DFDS = F/F1/15 * DF1DS
      DFDD = DFDS * DSDD
      DFXDD(IS) = VXUNIF(IS) * F + DS(IS) * EXUNIF * DFDD

      DO IX = 1,3
        GDS = 2 * GD(IX,IS)
        DSDGD = (S / GDMS) * GDS / GDMS
        DFDGD = DFDS * DSDGD
        DFXDGD(IX,IS) = DS(IS) * EXUNIF * DFDGD
      end DO
    end DO
    FX = FX / DT / 2

    ! Set output arguments
    EX = FX
    DO IS = 1,nspin
      DEXDD(IS) = DFXDD(IS)
      DO IX = 1,3
        DEXDGD(IX,IS) = DFXDGD(IX,IS)
      end DO
    end DO

  END SUBROUTINE PW86formX



  SUBROUTINE PW86X( IREL, nspin, Dens, GDens, &
      EX, EC, DEXDD, DECDD, DEXDGD, DECDGD )

    ! *********************************************************************
    ! Implements Perdew-Wang-86 Generalized-Gradient-Approximation 
    ! exchange-only functional. Correlation energy returns as zero.
    ! Ref: J.P.Perdew & Y.Wang, PRB 33, 8800 (1986)
    ! Written by J.M.Soler. March 2010.
    ! ******** INPUT ******************************************************
    ! INTEGER IREL           : Relativistic-exchange switch (0=No, 1=Yes)
    ! INTEGER nspin          : Number of spin polarizations (1 or 2)
    ! REAL*8  Dens(nspin)    : Total electron density (if nspin=1) or
    !                           spin electron density (if nspin=2)
    ! REAL*8  GDens(3,nspin) : Total or spin density gradient
    ! ******** OUTPUT *****************************************************
    ! REAL*8  EX             : Exchange energy density
    ! REAL*8  EC             : Correlation energy density
    ! REAL*8  DEXDD(nspin)   : Partial derivative
    !                           d(DensTot*Ex)/dDens(ispin),
    !                           where DensTot = Sum_ispin( Dens(ispin) )
    !                          For a constant density, this is the
    !                          exchange potential
    ! REAL*8  DECDD(nspin)   : Partial derivative
    !                           d(DensTot*Ec)/dDens(ispin),
    !                           where DensTot = Sum_ispin( Dens(ispin) )
    !                          For a constant density, this is the
    !                          correlation potential
    ! REAL*8  DEXDGD(3,nspin): Partial derivative
    !                           d(DensTot*Ex)/d(GradDens(i,ispin))
    ! REAL*8  DECDGD(3,nspin): Partial derivative
    !                           d(DensTot*Ec)/d(GradDens(i,ispin))
    ! ********* UNITS ****************************************************
    ! Lengths in Bohr
    ! Densities in electrons per Bohr**3
    ! Energies in Hartrees
    ! Gradient vectors in cartesian coordinates
    ! ********* ROUTINES CALLED ******************************************
    ! PW86formX
    ! ********************************************************************

    ! Passed arguments
    integer, intent(in) :: IREL, NSPIN
    real(dp),intent(in) :: DENS(NSPIN), GDENS(3,NSPIN)
    real(dp),intent(out):: EX, EC, DECDD(NSPIN), DECDGD(3,NSPIN), &
        DEXDD(NSPIN), DEXDGD(3,NSPIN)

    ! Internal parameters of the PW86 exchange functional
    real(dp),parameter:: a = 0.0864_dp
    real(dp),parameter:: b = 14.0_dp
    real(dp),parameter:: c = 0.2_dp

    ! Call PW86 routine with appropriate values for a, b, and c.
    CALL PW86formX( a, b, c, IREL, nspin, Dens, GDens, &
        EX, DEXDD, DEXDGD )

    ! Set correlation energy and derivatives to zero
    EC = 0
    DECDD(:) = 0
    DECDGD(:,:) = 0

  END SUBROUTINE PW86X



  SUBROUTINE PW86RX( IREL, nspin, Dens, GDens, &
      EX, EC, DEXDD, DECDD, DEXDGD, DECDGD )

    ! *********************************************************************
    ! Implements Perdew-Wang-86 Generalized-Gradient-Approximation 
    ! exchange-only functional with the refitted parameters of
    ! Murray, Lee, and Langreth. Correlation energy returns as zero.
    ! Refs: J.P.Perdew & Y.Wang, PRB 33, 8800 (1986)
    !       E.D.Murray, K.Lee & D.C.Langreth, JCTC 5, 2754 (2009)
    ! Written by J.M.Soler. March 2010.
    ! ******** INPUT ******************************************************
    ! INTEGER IREL           : Relativistic-exchange switch (0=No, 1=Yes)
    ! INTEGER nspin          : Number of spin polarizations (1 or 2)
    ! REAL*8  Dens(nspin)    : Total electron density (if nspin=1) or
    !                           spin electron density (if nspin=2)
    ! REAL*8  GDens(3,nspin) : Total or spin density gradient
    ! ******** OUTPUT *****************************************************
    ! REAL*8  EX             : Exchange energy density
    ! REAL*8  EC             : Correlation energy density
    ! REAL*8  DEXDD(nspin)   : Partial derivative
    !                           d(DensTot*Ex)/dDens(ispin),
    !                           where DensTot = Sum_ispin( Dens(ispin) )
    !                          For a constant density, this is the
    !                          exchange potential
    ! REAL*8  DECDD(nspin)   : Partial derivative
    !                           d(DensTot*Ec)/dDens(ispin),
    !                           where DensTot = Sum_ispin( Dens(ispin) )
    !                          For a constant density, this is the
    !                          correlation potential
    ! REAL*8  DEXDGD(3,nspin): Partial derivative
    !                           d(DensTot*Ex)/d(GradDens(i,ispin))
    ! REAL*8  DECDGD(3,nspin): Partial derivative
    !                           d(DensTot*Ec)/d(GradDens(i,ispin))
    ! ********* UNITS ****************************************************
    ! Lengths in Bohr
    ! Densities in electrons per Bohr**3
    ! Energies in Hartrees
    ! Gradient vectors in cartesian coordinates
    ! ********* ROUTINES CALLED ******************************************
    ! PW86formX
    ! ********************************************************************

    ! Passed arguments
    integer, intent(in) :: IREL, NSPIN
    real(dp),intent(in) :: DENS(NSPIN), GDENS(3,NSPIN)
    real(dp),intent(out):: EX, EC, DECDD(NSPIN), DECDGD(3,NSPIN), &
        DEXDD(NSPIN), DEXDGD(3,NSPIN)

    ! Internal parameters of the refitted PW86 exchange functional
    real(dp),parameter:: a = 0.1234_dp
    real(dp),parameter:: b = 17.33_dp
    real(dp),parameter:: c = 0.163_dp

    ! Call PW86 routine with appropriate values for a, b, and c.
    CALL PW86formX( a, b, c, IREL, nspin, Dens, GDens, &
        EX, DEXDD, DEXDGD )

    ! Set correlation energy and derivatives to zero
    EC = 0
    DECDD(:) = 0
    DECDGD(:,:) = 0

  END SUBROUTINE PW86RX


  SUBROUTINE BHX( IREL, nspin, Dens, GDens, &
      EX, EC, DEXDD, DECDD, DEXDGD, DECDGD )

    ! *********************************************************************
    ! Implements the combination by Berland and Hyldgaard of Perdew-Wang-86 
    ! Generalized-Gradient-Approximation exchange-only functional with the 
    ! refitted parameters of Murray, Lee, and Langreth and Langreth-Vosko 
    ! screened exchange. Correlation energy returns as zero.
    ! Refs: J.P.Perdew & Y.Wang, PRB 33, 8800 (1986)
    !       E.D.Murray, K.Lee & D.C.Langreth, JCTC 5, 2754 (2009)
    !       K.Berland & P.Hyldgaard, PRB 89, 035412 (2014)
    ! Written by Michelle Fritz Feb. 2014.
    ! ******** INPUT ******************************************************
    ! INTEGER IREL           : Relativistic-exchange switch (0=No, 1=Yes)
    ! INTEGER NSPIN          : Number of spin polarizations (1 or 2)
    ! REAL*8  DENS(nspin)    : Total electron density (if nspin=1) or
    !                           spin electron density (if nspin=2)
    ! REAL*8  GDens(3,nspin) : Total or spin density gradient
    ! ******** OUTPUT *****************************************************
    ! REAL*8  EX             : Exchange energy density
    ! REAL*8  EC             : Correlation energy density
    ! REAL*8  DEXDD(nspin)   : Partial derivative
    !                           d(DensTot*Ex)/dDens(ispin),
    !                           where DensTot = Sum_ispin( Dens(ispin) )
    !                          For a constant density, this is the
    !                          exchange potential
    ! REAL*8  DECDD(nspin)   : Partial derivative
    !                           d(DensTot*Ec)/dDens(ispin),
    !                           where DensTot = Sum_ispin( Dens(ispin) )
    !                          For a constant density, this is the
    !                          correlation potential
    ! REAL*8  DEXDGD(3,nspin): Partial derivative
    !                           d(DensTot*Ex)/d(GradDens(i,ispin))
    ! REAL*8  DECDGD(3,nspin): Partial derivative
    !                           d(DensTot*Ec)/d(GradDens(i,ispin))
    ! ********* UNITS ****************************************************
    ! Lengths in Bohr
    ! Densities in electrons per Bohr**3
    ! Energies in Hartrees
    ! Gradient vectors in cartesian coordinates
    ! ********* ROUTINES CALLED ******************************************
    ! EXCHNG
    ! ********************************************************************

    ! Passed arguments
    integer, intent(in) :: IREL, NSPIN
    real(dp),intent(in) :: DENS(NSPIN), GDENS(3,NSPIN)
    real(dp),intent(out):: EX, EC, DECDD(NSPIN), DECDGD(3,NSPIN), &
        DEXDD(NSPIN), DEXDGD(3,NSPIN)

    ! Internal variables
    INTEGER :: IS, IX
    real(dp) &
        D(2), DENMIN, DF1DS, DFDD, DFDGD, DFDS, DFLVDS, DFPW86RDS,  &
        DFXDD(2), DFXDGD(3,2), DKFDD, DS(2), DSDD, DSDGD, DT, ECUNIF, & 
        EXUNIF, FPW86R, FLV, F, F1, FX, GD(3,2), GDM(2), GDMIN, GDMS,  &
        GDMT, GDS, GDT(3), KFS, PI, S, VXUNIF(2), ZETA, MLV

    ! Internal parameters of the refitted PW86 exchange functional
    real(dp),parameter:: a = 0.1234_dp
    real(dp),parameter:: b = 17.33_dp
    real(dp),parameter:: c = 0.163_dp
    real(dp),parameter:: zab = -0.8491_dp
    real(dp),parameter:: alpha = 0.02178_dp
    real(dp),parameter:: beta = 1.15_dp

    ! Lower bounds of density and its gradient to avoid divisions by zero
    PARAMETER ( DENMIN = 1.D-12 )
    PARAMETER ( GDMIN  = 1.D-12 )

    ! Fix some more numerical constants
    PI = 4 * ATAN(1.D0)

    ! Translate density and its gradient to new variables
    IF (NSPIN .EQ. 1) THEN
      D(1) = DENS(1) / 2
      D(2) = D(1)
      DT = MAX( DENMIN, DENS(1) )
      DO IX = 1,3
        GD(IX,1) = GDENS(IX,1) / 2
        GD(IX,2) = GD(IX,1)
        GDT(IX) = GDENS(IX,1)
      end DO
    ELSE
      D(1) = DENS(1)
      D(2) = DENS(2)
      DT = MAX( DENMIN, DENS(1)+DENS(2) )
      DO IX = 1,3
        GD(IX,1) = GDENS(IX,1)
        GD(IX,2) = GDENS(IX,2)
        GDT(IX) = GDENS(IX,1) + GDENS(IX,2)
      end DO
    ENDIF
    GDM(1) = SQRT( GD(1,1)**2 + GD(2,1)**2 + GD(3,1)**2 )
    GDM(2) = SQRT( GD(1,2)**2 + GD(2,2)**2 + GD(3,2)**2 )
    GDMT   = SQRT( GDT(1)**2  + GDT(2)**2  + GDT(3)**2  )
    GDMT = MAX( GDMIN, GDMT )

    ! Find exchange energy and potential
    FX = 0
    DO IS = 1,2
      DS(IS)   = MAX( DENMIN, 2 * D(IS) )
      GDMS = MAX( GDMIN, 2 * GDM(IS) )
      KFS = (3 * PI**2 * DS(IS))**(1._dp/3)
      S = GDMS / (2 * KFS * DS(IS))
      F1 = 1 + 15*a*S**2 + b*S**4 + c*S**6
      FPW86R = F1**(1._dp/15)
      MLV = -zab/9._dp
      FLV = 1 + MLV*S**2
      F = (1 / (1 + alpha*S**6)) * FLV
      F = F + ((alpha*S**6) / (beta + alpha*S**6)) * FPW86R

      !
      !       Note nspin=1 in call to exchng...
      !
      CALL EXCHNG( IREL, 1, DS(IS), EXUNIF, VXUNIF(IS) )
      FX = FX + DS(IS) * EXUNIF * F

      DKFDD = KFS / DS(IS) / 3
      DSDD = S * ( -(DKFDD/KFS) - 1/DS(IS) )
      DF1DS = 30*a*S + 4*b*S**3 + 6*c*S**5
      DFLVDS = 2*MLV*S
      DFPW86RDS = FPW86R/F1/15 * DF1DS
      DFDS = -((6*alpha*S**5) / (1 + alpha*S**6)**2) * FLV
      DFDS = DFDS + (1 / (1 + alpha*S**6)) * DFLVDS
      DFDS = DFDS + ((6*alpha*S**5) / (beta + alpha*S**6)) * FPW86R
      DFDS =DFDS-((6*alpha**2*S**11)/(beta + alpha*S**6)**2)*FPW86R
      DFDS = DFDS + ((alpha*S**6) / (beta + alpha*S**6)) * DFPW86RDS
      DFDD = DFDS * DSDD
      DFXDD(IS) = VXUNIF(IS) * F + DS(IS) * EXUNIF * DFDD

      DO IX = 1,3
        GDS = 2 * GD(IX,IS)
        DSDGD = (S / GDMS) * GDS / GDMS
        DFDGD = DFDS * DSDGD
        DFXDGD(IX,IS) = DS(IS) * EXUNIF * DFDGD
      end DO
    end DO
    FX = FX / DT / 2

    EX = FX
    DO IS = 1,NSPIN
      DEXDD(IS) = DFXDD(IS)
      DO IX = 1,3
        DEXDGD(IX,IS) = DFXDGD(IX,IS)
      end DO
    end DO

    ! Set correlation energy and derivatives to zero
    EC = 0
    DECDD(:) = 0
    DECDGD(:,:) = 0

  END SUBROUTINE BHX


  SUBROUTINE B88formX( beta, mu, c, iRel, nSpin, Dens, GDens, &
      EX, dEXdD, dEXdGD )

    ! *********************************************************************
    ! Implements Becke-88 Generalized-Gradient-Approximation exchange-only
    ! functional form, eps_x=eps_x_LDA*(1+mu*s**2/(1+beta*s*asinh(c*s))),
    ! but with variable values for parameters beta, mu, and c
    ! Refs: A.D.Becke, PRA 38, 3098 (1988)
    !       J.Klimes, D.R.Bowler, and A.Michaelides, JPCM 22, 022201 (2009)
    ! Written by J.M.Soler. April 2010.
    ! ******** INPUT ******************************************************
    ! REAL*8  beta, mu, c    : Parameter beta mu, and c of the B88 functional,
    !                          as formulated by Klimes et al
    ! INTEGER IREL           : Relativistic-exchange switch (0=No, 1=Yes)
    ! INTEGER nspin          : Number of spin polarizations (1 or 2)
    ! REAL*8  Dens(nspin)    : Total electron density (if nspin=1) or
    !                           spin electron density (if nspin=2)
    ! REAL*8  GDens(3,nspin) : Total or spin density gradient
    ! ******** OUTPUT *****************************************************
    ! REAL*8  EX             : Exchange energy density
    ! REAL*8  DEXDD(nspin)   : Partial derivative
    !                           d(DensTot*Ex)/dDens(ispin),
    !                           where DensTot = Sum_ispin( Dens(ispin) )
    !                          For a constant density, this is the
    !                          exchange potential
    ! REAL*8  DEXDGD(3,nspin): Partial derivative
    !                           d(DensTot*Ex)/d(GradDens(i,ispin))
    ! ********* UNITS ****************************************************
    ! Lengths in Bohr
    ! Densities in electrons per Bohr**3
    ! Energies in Hartrees
    ! Gradient vectors in cartesian coordinates
    ! ********* ROUTINES CALLED ******************************************
    ! EXCHNG
    ! ********************************************************************

    ! Input
    real(dp),intent(in) :: beta           ! Parameter of B88 functional
    real(dp),intent(in) :: mu             ! Parameter of B88 functional
    real(dp),intent(in) :: c              ! Parameter of B88 functional
    integer, intent(in) :: iRel           ! Relativistic exchange? 0=no, 1=yes
    integer, intent(in) :: nSpin          ! Number of spin components
    real(dp),intent(in) :: Dens(nSpin)    ! Local electron (spin) density
    real(dp),intent(in) :: GDens(3,nSpin) ! Gradient of electron density

    ! Output
    real(dp),intent(out):: EX             ! Exchange energy per electron
    real(dp),intent(out):: dEXdD(nSpin)   ! dEx/dDens, Ex=Int(dens*epsX)
    real(dp),intent(out):: dEXdGD(3,nSpin) ! dEx/dGrad(Dens)

    ! Internal variables
    INTEGER :: IS, IX
    real(dp) &
        ASINHCS, CS, D(2), DASINHDS, &
        DENMIN, DF1DS, DFDD, DFDGD, DFDS, DFXDD(2), DFXDGD(3,2),  &
        DKFDD, DS(2), DSDD, DSDGD, DT, ECUNIF, EXUNIF, F, F1, FX, &
        GD(3,2), GDM(2), GDMIN, GDMS, GDMT, GDS, GDT(3), &
        KFS, PI, S, VXUNIF(2), ZETA

    ! Lower bounds of density and its gradient to avoid divisions by zero
    PARAMETER ( DENMIN = 1.D-12 )
    PARAMETER ( GDMIN  = 1.D-12 )

    ! Fix some more numerical constants
    PI = 4 * ATAN(1.D0)

    ! Translate density and its gradient to new variables
    IF (nspin .EQ. 1) THEN
      D(1) = Dens(1) / 2
      D(2) = D(1)
      DT = MAX( DENMIN, Dens(1) )
      DO IX = 1,3
        GD(IX,1) = GDens(IX,1) / 2
        GD(IX,2) = GD(IX,1)
        GDT(IX) = GDens(IX,1)
      end DO
    ELSE
      D(1) = Dens(1)
      D(2) = Dens(2)
      DT = MAX( DENMIN, Dens(1)+Dens(2) )
      DO IX = 1,3
        GD(IX,1) = GDens(IX,1)
        GD(IX,2) = GDens(IX,2)
        GDT(IX) = GDens(IX,1) + GDens(IX,2)
      end DO
    ENDIF
    GDM(1) = SQRT( GD(1,1)**2 + GD(2,1)**2 + GD(3,1)**2 )
    GDM(2) = SQRT( GD(1,2)**2 + GD(2,2)**2 + GD(3,2)**2 )
    GDMT   = SQRT( GDT(1)**2  + GDT(2)**2  + GDT(3)**2  )
    GDMT = MAX( GDMIN, GDMT )

    ! Find exchange energy and potential
    FX = 0
    DO IS = 1,2
      DS(IS)   = MAX( DENMIN, 2 * D(IS) )
      GDMS = MAX( GDMIN, 2 * GDM(IS) )
      KFS = (3 * PI**2 * DS(IS))**(1._dp/3)
      S = GDMS / (2 * KFS * DS(IS))
      CS = C * S
      ! Next line is ASINH(CS). See Numerical Recipes
      ASINHCS = log(CS+sqrt(CS**2+1))
      F1 = 1 + beta * S * ASINHCS
      F = 1 + mu * S**2 / F1
      !
      !      Note nspin=1 in call to exchng...
      !
      CALL EXCHNG( IREL, 1, DS(IS), EXUNIF, VXUNIF(IS) )
      FX = FX + DS(IS) * EXUNIF * F

      DKFDD = KFS / DS(IS) / 3
      DSDD = S * ( -(DKFDD/KFS) - 1/DS(IS) )
      DASINHDS = C * (1 + CS/sqrt(CS**2+1)) / (CS+sqrt(CS**2+1))
      DF1DS = beta * ASINHCS + beta * S * DASINHDS
      DFDS = 2*mu*S/F1 - mu*S**2/F1**2 * DF1DS
      DFDD = DFDS * DSDD
      DFXDD(IS) = VXUNIF(IS) * F + DS(IS) * EXUNIF * DFDD

      DO IX = 1,3
        GDS = 2 * GD(IX,IS)
        DSDGD = (S / GDMS) * GDS / GDMS
        DFDGD = DFDS * DSDGD
        DFXDGD(IX,IS) = DS(IS) * EXUNIF * DFDGD
      end DO
    end DO
    FX = FX / DT / 2

    ! Set output arguments
    EX = FX
    DO IS = 1,nspin
      DEXDD(IS) = DFXDD(IS)
      DO IX = 1,3
        DEXDGD(IX,IS) = DFXDGD(IX,IS)
      end DO
    end DO

  END SUBROUTINE B88formX



  SUBROUTINE B88X( IREL, nspin, Dens, GDens, &
      EX, EC, DEXDD, DECDD, DEXDGD, DECDGD )

    ! *********************************************************************
    ! Implements Becke-88 Generalized-Gradient-Approximation 
    ! exchange-only functional. Correlation energy returns as zero.
    ! Refs: A.D.Becke, PRA 38, 3098 (1988)
    !       J.Klimes, D.R.Bowler, and A.Michaelides, JPCM 22, 022201 (2009)
    ! Written by J.M.Soler. April 2010.
    ! ******** INPUT ******************************************************
    ! INTEGER IREL           : Relativistic-exchange switch (0=No, 1=Yes)
    ! INTEGER nspin          : Number of spin polarizations (1 or 2)
    ! REAL*8  Dens(nspin)    : Total electron density (if nspin=1) or
    !                           spin electron density (if nspin=2)
    ! REAL*8  GDens(3,nspin) : Total or spin density gradient
    ! ******** OUTPUT *****************************************************
    ! REAL*8  EX             : Exchange energy density
    ! REAL*8  EC             : Correlation energy density
    ! REAL*8  DEXDD(nspin)   : Partial derivative
    !                           d(DensTot*Ex)/dDens(ispin),
    !                           where DensTot = Sum_ispin( Dens(ispin) )
    !                          For a constant density, this is the
    !                          exchange potential
    ! REAL*8  DECDD(nspin)   : Partial derivative
    !                           d(DensTot*Ec)/dDens(ispin),
    !                           where DensTot = Sum_ispin( Dens(ispin) )
    !                          For a constant density, this is the
    !                          correlation potential
    ! REAL*8  DEXDGD(3,nspin): Partial derivative
    !                           d(DensTot*Ex)/d(GradDens(i,ispin))
    ! REAL*8  DECDGD(3,nspin): Partial derivative
    !                           d(DensTot*Ec)/d(GradDens(i,ispin))
    ! ********* UNITS ****************************************************
    ! Lengths in Bohr
    ! Densities in electrons per Bohr**3
    ! Energies in Hartrees
    ! Gradient vectors in cartesian coordinates
    ! ********* ROUTINES CALLED ******************************************
    ! PW86formX
    ! ********************************************************************

    ! Passed arguments
    integer, intent(in) :: IREL, NSPIN
    real(dp),intent(in) :: DENS(NSPIN), GDENS(3,NSPIN)
    real(dp),intent(out):: EX, EC, DECDD(NSPIN), DECDGD(3,NSPIN), &
        DEXDD(NSPIN), DEXDGD(3,NSPIN)

    ! Internal variables and arrays
    real(dp):: beta, c, mu, pi

    ! Internal parameters of the B88 exchange functional, written as
    ! by Klimes et al
    pi = acos(-1._dp)
    c = 2*(6*pi**2)**(1._dp/3)
    mu = 0.2743_dp
    beta = 9 * mu * (6/pi)**(1._dp/3) / (2*c)

    ! Call PW86 routine with appropriate values for a, b, and c.
    CALL B88formX( beta, mu, c, IREL, nspin, Dens, GDens, &
        EX, DEXDD, DEXDGD )

    ! Set correlation energy and derivatives to zero
    EC = 0
    DECDD(:) = 0
    DECDGD(:,:) = 0

  END SUBROUTINE B88X



  SUBROUTINE B88KBMX( IREL, nspin, Dens, GDens, &
      EX, EC, DEXDD, DECDD, DEXDGD, DECDGD )

    ! *********************************************************************
    ! Implements Becke-88 GGA exchange functional, reparametrized by Klimes
    ! et al for its combined use with vdW-DF nonlocal correlation.
    ! Correlation energy returns as zero.
    ! Refs: A.D.Becke, PRA 38, 3098 (1988)
    !       J.Klimes, D.R.Bowler, and A.Michaelides, JPCM 22, 022201 (2009)
    ! Written by J.M.Soler. April 2010.
    ! ******** INPUT ******************************************************
    ! INTEGER IREL           : Relativistic-exchange switch (0=No, 1=Yes)
    ! INTEGER nspin          : Number of spin polarizations (1 or 2)
    ! REAL*8  Dens(nspin)    : Total electron density (if nspin=1) or
    !                           spin electron density (if nspin=2)
    ! REAL*8  GDens(3,nspin) : Total or spin density gradient
    ! ******** OUTPUT *****************************************************
    ! REAL*8  EX             : Exchange energy density
    ! REAL*8  EC             : Correlation energy density
    ! REAL*8  DEXDD(nspin)   : Partial derivative
    !                           d(DensTot*Ex)/dDens(ispin),
    !                           where DensTot = Sum_ispin( Dens(ispin) )
    !                          For a constant density, this is the
    !                          exchange potential
    ! REAL*8  DECDD(nspin)   : Partial derivative
    !                           d(DensTot*Ec)/dDens(ispin),
    !                           where DensTot = Sum_ispin( Dens(ispin) )
    !                          For a constant density, this is the
    !                          correlation potential
    ! REAL*8  DEXDGD(3,nspin): Partial derivative
    !                           d(DensTot*Ex)/d(GradDens(i,ispin))
    ! REAL*8  DECDGD(3,nspin): Partial derivative
    !                           d(DensTot*Ec)/d(GradDens(i,ispin))
    ! ********* UNITS ****************************************************
    ! Lengths in Bohr
    ! Densities in electrons per Bohr**3
    ! Energies in Hartrees
    ! Gradient vectors in cartesian coordinates
    ! ********* ROUTINES CALLED ******************************************
    ! PW86formX
    ! ********************************************************************

    ! Passed arguments
    integer, intent(in) :: IREL, NSPIN
    real(dp),intent(in) :: DENS(NSPIN), GDENS(3,NSPIN)
    real(dp),intent(out):: EX, EC, DECDD(NSPIN), DECDGD(3,NSPIN), &
        DEXDD(NSPIN), DEXDGD(3,NSPIN)

    ! Internal variables and arrays
    real(dp):: beta, c, mu, pi

    ! Klimes et al parameters for the B88 exchange functional
    pi = acos(-1._dp)
    c = 2*(6*pi**2)**(1._dp/3)
    mu = 0.22_dp
    beta = mu / 1.2_dp

    ! Call PW86 routine with appropriate values for a, b, and c.
    CALL B88formX( beta, mu, c, IREL, nspin, Dens, GDens, &
        EX, DEXDD, DEXDGD )

    ! Set correlation energy and derivatives to zero
    EC = 0
    DECDD(:) = 0
    DECDGD(:,:) = 0

  END SUBROUTINE B88KBMX


  SUBROUTINE C09X( IREL, nspin, Dens, GDens, &
      EX, EC, DEXDD, DECDD, DEXDGD, DECDGD )

    ! *********************************************************************
    ! Implements Cooper-09 exchange-only GGA (for use with vdW-DF1 correlation). 
    ! Correlation energy returns as zero.
    ! Ref: V.R.Cooper, PRB 81, 161104(R) (2010)
    ! Written by J.M.Soler. April 2010.
    ! ******** INPUT ******************************************************
    ! INTEGER IREL           : Relativistic-exchange switch (0=No, 1=Yes)
    ! INTEGER nspin          : Number of spin polarizations (1 or 2)
    ! REAL*8  Dens(nspin)    : Total electron density (if nspin=1) or
    !                           spin electron density (if nspin=2)
    ! REAL*8  GDens(3,nspin) : Total or spin density gradient
    ! ******** OUTPUT *****************************************************
    ! REAL*8  EX             : Exchange energy density
    ! REAL*8  EC             : Correlation energy density
    ! REAL*8  DEXDD(nspin)   : Partial derivative
    !                           d(DensTot*Ex)/dDens(ispin),
    !                           where DensTot = Sum_ispin( Dens(ispin) )
    !                          For a constant density, this is the
    !                          exchange potential
    ! REAL*8  DECDD(nspin)   : Partial derivative
    !                           d(DensTot*Ec)/dDens(ispin),
    !                           where DensTot = Sum_ispin( Dens(ispin) )
    !                          For a constant density, this is the
    !                          correlation potential
    ! REAL*8  DEXDGD(3,nspin): Partial derivative
    !                           d(DensTot*Ex)/d(GradDens(i,ispin))
    ! REAL*8  DECDGD(3,nspin): Partial derivative
    !                           d(DensTot*Ec)/d(GradDens(i,ispin))
    ! ********* UNITS ****************************************************
    ! Lengths in Bohr
    ! Densities in electrons per Bohr**3
    ! Energies in Hartrees
    ! Gradient vectors in cartesian coordinates
    ! ********* ROUTINES CALLED ******************************************
    ! none
    ! ********************************************************************

    ! Passed arguments
    integer, intent(in) :: IREL, NSPIN
    real(dp),intent(in) :: DENS(NSPIN), GDENS(3,NSPIN)
    real(dp),intent(out):: EX, EC, DECDD(NSPIN), DECDGD(3,NSPIN), &
        DEXDD(NSPIN), DEXDGD(3,NSPIN)

    ! Internal variables and arrays (V.R.Cooper, PRB 81, 161104(R) (2010))
    real(dp),parameter:: alpha = 0.0483_dp
    real(dp),parameter:: kappa = 1.245_dp
    real(dp),parameter:: mu    = 0.0617

    ! Internal variables
    INTEGER :: IS, IX
    real(dp) &
        D(2), DENMIN, DES2DS, DF1DS, DFDD, DFDGD, DFDS,   &
        DFXDD(2), DFXDGD(3,2), DKFDD, DS(2), DSDD, DSDGD, DT,  &
        ECUNIF, ES2, EXUNIF, F, FX, &
        GD(3,2), GDM(2), GDMIN, GDMS, GDMT, GDS, GDT(3), &
        KFS, PI, S, S2, VXUNIF(2)

    ! Lower bounds of density and its gradient to avoid divisions by zero
    PARAMETER ( DENMIN = 1.D-12 )
    PARAMETER ( GDMIN  = 1.D-12 )

    ! Fix some more numerical constants
    PI = 4 * ATAN(1.D0)

    ! Translate density and its gradient to new variables
    IF (nspin .EQ. 1) THEN
      D(1) = Dens(1) / 2
      D(2) = D(1)
      DT = MAX( DENMIN, Dens(1) )
      DO IX = 1,3
        GD(IX,1) = GDens(IX,1) / 2
        GD(IX,2) = GD(IX,1)
        GDT(IX) = GDens(IX,1)
      end DO
    ELSE
      D(1) = Dens(1)
      D(2) = Dens(2)
      DT = MAX( DENMIN, Dens(1)+Dens(2) )
      DO IX = 1,3
        GD(IX,1) = GDens(IX,1)
        GD(IX,2) = GDens(IX,2)
        GDT(IX) = GDens(IX,1) + GDens(IX,2)
      end DO
    ENDIF
    GDM(1) = SQRT( GD(1,1)**2 + GD(2,1)**2 + GD(3,1)**2 )
    GDM(2) = SQRT( GD(1,2)**2 + GD(2,2)**2 + GD(3,2)**2 )
    GDMT   = SQRT( GDT(1)**2  + GDT(2)**2  + GDT(3)**2  )
    GDMT = MAX( GDMIN, GDMT )

    ! Find exchange energy and potential
    FX = 0
    DO IS = 1,2
      DS(IS) = MAX( DENMIN, 2 * D(IS) )
      GDMS = MAX( GDMIN, 2 * GDM(IS) )
      KFS = (3 * PI**2 * DS(IS))**(1._dp/3)
      S = GDMS / (2 * KFS * DS(IS))
      S2 = S**2

      ! Next lines are the core of the C09 functional
      ES2 = exp(-alpha*S2/2)
      F = 1 + mu*S2*ES2**2 + kappa*(1-ES2)
      DES2DS = -alpha*S*ES2
      DFDS = 2*mu*S*ES2**2 + 2*mu*S2*ES2*DES2DS - kappa*DES2DS

      ! Note nspin=1 in call to exchng...
      CALL EXCHNG( IREL, 1, DS(IS), EXUNIF, VXUNIF(IS) )
      FX = FX + DS(IS) * EXUNIF * F

      DKFDD = KFS / DS(IS) / 3
      DSDD = S * ( -(DKFDD/KFS) - 1/DS(IS) )
      DFDD = DFDS * DSDD
      DFXDD(IS) = VXUNIF(IS) * F + DS(IS) * EXUNIF * DFDD

      DO IX = 1,3
        GDS = 2 * GD(IX,IS)
        DSDGD = (S / GDMS) * GDS / GDMS
        DFDGD = DFDS * DSDGD
        DFXDGD(IX,IS) = DS(IS) * EXUNIF * DFDGD
      end DO
    end DO
    FX = FX / DT / 2

    ! Set output arguments
    EX = FX
    DO IS = 1,nspin
      DEXDD(IS) = DFXDD(IS)
      DO IX = 1,3
        DEXDGD(IX,IS) = DFXDGD(IX,IS)
      end DO
    end DO
    ! Set correlation energy and derivatives to zero
    EC = 0
    DECDD(:) = 0
    DECDGD(:,:) = 0

  END SUBROUTINE C09X

END MODULE gridxc_gga

program test6

! Writes the xc energy density eps_xc for all available functionals
! J.M.Soler, May.2014

  use gridxc, only: dp      ! double precision kind
  use gridxc, only: ldaxc => gridxc_ldaxc   ! LDA xc
  use gridxc, only: ggaxc => gridxc_ggaxc   ! GGA xc

! Set mesh parameters
  implicit none
  integer, parameter::   &
    irel = 0,            &! relativistic exchange? 0=>no, 1=>yes
    nspin = 2,           &! number of spin polarization components (1|2)
    nz  = 2,             &! number of spin polarization values
    nsx = 20,            &! number of s mesh values for Fx(s)
    nkf = 20,            &! number of kf mesh values for epsc(kf,kg)
    nkg = 30              ! number of kg mesh values for epsc(kf,kg)
  real(dp),parameter::   &
    smin = 0.0_dp,       &! min. value of s in Fx(s) interpol.
    smax = 1.e2_dp,      &! max. value of s in Fx(s) interpol.
    kfmin = 1.e-3_dp,    &! min. value of kf in epsc(kf,kg) interpol.
    kfmax = 10.0_dp,     &! max. value of kf in epsc(kf,kg) interpol.
    kgmin =  0.0_dp,     &! min. value of kg in epsc(kf,kg) interpol.
    kgmax = 10.0_dp,     &! max. value of kg in epsc(kf,kg) interpol.
    dsnds1 = 1.e3_dp,    &! (s(n)-s(n-1))/(s(2)-s(1))
    dkfndkf1 = 1.e3_dp,  &! (kf(n)-kf(n-1))/(kf(2)-kf(1))
    dkgndkg1 = 2.0_dp     ! (kg(n)-kg(n-1))/(kg(2)-kg(1))

  ! List of functionals to be tested
  integer, parameter:: nfTot = 18      ! total number of functionals
  integer, parameter:: nf = nfTot-2    ! GGA functionals
  integer:: indexf(nf) = (/3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18/)

  ! All functionals available
  !                  1,           2,          3,           4,   
  !                  5,           6,          7,           8, 
  !                  9,          10,         11,          12,
  !                 13,          14,         15,          16,
  !                 17,          18
  character(len=3):: &
    func(nfTot)=(/'LDA',       'LDA',       'GGA',       'GGA', &
                  'GGA',       'GGA',       'GGA',       'GGA', &
                  'GGA',       'GGA',       'GGA',       'GGA', &
                  'GGA',       'GGA',       'GGA',       'GGA', &
                  'GGA',       'GGA'       /)
  character(len=10):: &
    auth(nfTot)=(/'PZ        ','PW92      ','PW91      ','PBE       ', &
                  'RPBE      ','revPBE    ','LYP       ','WC        ', &
                  'PBEJsJrLO ','PBEJsJrHEG','PBEGcGxLO ','PBEGcGxHEG', &
                  'PBESOL    ','AM05      ','PW86      ','B88       ', &
                  'C09       ','BH        '/) 

  integer:: &
    ifunc, ikf, ikg, isx, iz, jf, mspin
  real(dp):: &
    a, b, dExdD(nspin), dEcdD(nspin), dExdGD(3,nspin), dEcdGD(3,nspin), &
    dVcdD(nspin,nspin), dVxdD(nspin,nspin), &
    epsc(nkf,nkg,nz,nf), epsc0, epsc1, epsx(nkf,nkg,nz,nf), epsx0, epsx1, &
    fx(nsx,nf), fxc(nkf,nkg,nz,nf), grho(3,nspin), &
    kf, kfmesh(nkf), kg, kgmesh(nkg), &
    pi, rho(nspin), rhoTot, s, smesh(nsx), zeta, zmesh(nz)

! Set mesh values
  do iz = 1,nz
    zmesh(iz) = real(iz-1,dp)/(nz-1)
  enddo
  a = log(dsnds1) / (nsx-1)
  b = smax / (exp(a*(nsx-1)) - 1)
  do isx = 1,nsx
    smesh(isx) = b*exp(a*(isx-1)) - b
  enddo
  a = log(dkfndkf1) / (nkf-1)
  b = (kfmax-kfmin) / (exp(a*(nkf-1)) - 1)
  do ikf = 1,nkf
    kfmesh(ikf) = kfmin + b*exp(a*(ikf-1)) - b
  enddo
  a = log(dkgndkg1) / (nkg-1)
  b = (kgmax-kgmin) / (exp(a*(nkg-1)) - 1)
  do ikg = 1,nkg
    kgmesh(ikg) = b*exp(a*(ikg-1)) - b
  enddo

! Loop on functionals
  do jf = 1,nf
    ifunc = indexf(jf)

    ! Find exchange enhancement factors at s mesh values
    pi = acos(-1.0_dp)
    kf = 1                                ! Fermi wavevector
    rho(1) = kf**3/3/pi**2                ! electron density
    epsx0 = -3*kf/4/pi                    ! LDA exchange energy
    do isx = 1,nsx
      s = smesh(isx)                      ! |grad(rho)|/(2*rho*kf)
      kg = 2*kf*s                         ! |grad(rho)|/rho
      grho = 0                            ! grad(rho)
      grho(3,1) = rho(1)*kg
      mspin = 1                           ! unpolarized to call ggaxc
      call ggaxc( auth(ifunc), irel, mspin, rho, grho, &
                  epsx1, epsc1, dEXdD, dECdD, dEXdGD, dECdGD )
      fx(isx,jf) = epsx1/epsx0            ! exchange enhancement factor
    enddo

    ! Find exchange-correlation energies at (kf,kg) mesh
    do ikf = 1,nkf
      do ikg = 1,nkg
        do iz = 1,nz
          kf = kfmesh(ikf)
          kg = kgmesh(ikg)
          zeta = zmesh(iz)
          rhoTot = kf**3/3/pi**2
          rho(1) = rhoTot*(1+zeta)/2
          rho(2) = rhoTot*(1-zeta)/2
          grho = 0
          grho(3,1:nspin) = rho(1:nspin)*kg
          call ldaxc( 'PW92', irel, nspin, rho, &
                      epsx0, epsc0, dEXdD, dECdD, dVxdD, dVcdD )
          call ggaxc( auth(ifunc), irel, nspin, rho, grho, &
                      epsx1, epsc1, dEXdD, dECdD, dEXdGD, dECdGD )
          epsx(ikf,ikg,iz,jf) = epsx1
          epsc(ikf,ikg,iz,jf) = epsc1
          fxc(ikf,ikg,iz,jf) = (epsx1+epsc1)/epsx0
        enddo
      enddo
    enddo

  enddo ! jf

! Write results
  open(2,file='funcs.out')
  write(2,'(20a14)') (trim(auth(indexf(jf))),jf=1,nf)
  close(2)

  open(2,file='fx.out')
!  write(2,'(a14,2x,20a14)') 's',(trim(auth(indexf(jf))),jf=1,nf)
  do isx = 1,nsx
    write(2,'(e14.6,2x,20e14.6)') smesh(isx),(fx(isx,jf),jf=1,nf)
  enddo
  close(2)

  open(2,file='epsx.out')
!  write(2,'(3a14,2x,20a14)') 'kf','kg','zeta',(trim(auth(indexf(jf))),jf=1,nf)
  do iz = 1,nz
    do ikg = 1,nkg
      do ikf = 1,nkf
        write(2,'(3e14.6,2x,20e14.6)') &
          kfmesh(ikf), kgmesh(ikg), zmesh(iz), (epsx(ikf,ikg,iz,jf),jf=1,nf)
      enddo
    enddo
  enddo
  close(2)

  open(2,file='epsc.out')
!  write(2,'(3a14,2x,20a14)') 'kf','kg','zeta',(trim(auth(indexf(jf))),jf=1,nf)
  do iz = 1,nz
    do ikg = 1,nkg
      do ikf = 1,nkf
        write(2,'(3e14.6,2x,20e14.6)') &
          kfmesh(ikf), kgmesh(ikg), zmesh(iz), (epsc(ikf,ikg,iz,jf),jf=1,nf)
      enddo
    enddo
  enddo
  close(2)

  open(2,file='fxc.out')
!  write(2,'(3a14,2x,20a14)') 'kf','kg','zeta',(trim(auth(indexf(jf))),jf=1,nf)
  do iz = 1,nz
    do ikg = 1,nkg
      do ikf = 1,nkf
        write(2,'(3e14.6,2x,20e14.6)') &
          kfmesh(ikf), kgmesh(ikg), zmesh(iz), (fxc(ikf,ikg,iz,jf),jf=1,nf)
      enddo
    enddo
  enddo
  close(2)

end program test6

program test_bessph_update

  ! One should get the bessph.f file from r39 and older
  use m_bessph_old, only: bessph_old => bessph
  ! This is the new bessph module
  use gridxc_bessph
  
  integer, parameter :: dp = kind(1.d0)
  integer :: l, i
  real(dp) :: x, dx, b1, b2
  
  dx = 0.00001_dp
  do l = 0, 10
    do i = 1, 10000000
      x = (i-1) * dx
      b1 = bessph_old(l, x)
      b2 = bessph(l, x)
      
      if ( abs(b1 - b2) > 1.e-17_dp ) then
        print *, 'Different: ', l, x, b1, b2
      end if
      
    end do
  end do
  
end program test_bessph_update

#if defined HAVE_CONFIG_H
#include "config.h"
#endif

!!@LICENSE
!
! ==============================================================================
! MODULE interpolation
! ==============================================================================
! Cubic spline interpolation utilities
! ==============================================================================
! Public types in this module:
!   spline_t     : derived type to hold spline info of a function
! Public parameters, variables and arrays in this module:
!   none
! Public procedures provided by this module:
!   generate_spline : generate spline interpolation info of a function
!   evaluate_spline : evaluate a function at given point(s) using splines
! ==============================================================================
! SUBROUTINE generate_spline( dat, x, y, n, dydx1, dydxn, d2ydx2, stat )
!   Generate data required to interpolate a 1D function with cubic splines
! Required input:
!   real(dp) x(n)  : independent variable at each point
!   real(dp) y(n)  : function values at each point
!   integer  n     : number of points
! Optional input:
!   real(dp) dydx1 : dy/dx at x(1) (if not present, assumes d2y/dx2=0 at x(1))
!   real(dp) dydxn : dy/dx at x(n) (if not present, assumes d2y/dx2=0 at x(n))
! Output:
!   type(spline_t) dat : spline info of function y(x)
! Optional output:
!   real(dp) d2ydx2(n) : d2y/dx2 at mesh points
!   integer  stat      : error status
! Behaviour:
!   If dydx1 and/or dydxn are not present, assumes d2y/dx2=0 at x(1) and/or x(n)
!   Returns with stat=-1 if mesh is not monotonic, without any other output
!   Returns with stat=-2 if n<2, without any other output
! Algorithm:
!   Computes d2y/dx2 at each point, to make y(x) and dy/dx continuous.
!   The x values are analyzed to check if the mesh is linear, logarithmic,
!   or general. This is used by evaluate_spline to find the mesh interval at
!   which the evaluation points lie.
! Ref: "Numerical Recipes", W.H. Press et al, Cambridge U.P.
! ==============================================================================
! SUBROUTINE evaluate_spline( dat, x, y )
!   Evaluate function at given point(s) using spline data info
! Input:
!   type(spline_t) dat  : spline info of function y(x), from generate_spline
!   real(dp)       x(:) : point(s) at which function must be evaluated
! Output:
!   real(dp)       y(:) : value of function at given point(s)
! Behaviour:
!   Single- and multiple-point evaluators are overloaded with the same name,
!   so that x and y may be also scalar values
!   Stops with an error message if any point x is out of the interp. interval
! ==============================================================================
! subroutine clean_spline(dat)
!   type(spline_t), intent(inout) :: dat
! Behavior: 
!     Deallocates the array components and resets %n to zero
! end subroutine clean_spline
! ==============================================================================
! SUBROUTINE spline( x, y, n, dydx1, dydxn, d2ydx2 )
!   Included for compatibility with Numerical Recipes interface
! Input:
!   real(dp) x(n)      ! mesh points
!   real(dp) y(n)      ! function value at mesh points
!   integer  n         ! number of mesh points
!   real(dp) dydx1     ! dy/dx at x(1). If >1.e30, assumes d2y/dx2=0 at x(1)
!   real(dp) dydxn     ! dy/dx at x(n). If >1.e30, assumes d2y/dx2=0 at x(n)
! Output:
!   real(dp) d2ydx2(n) ! d2y/dx2 at mesh points
! ==============================================================================
! SUBROUTINE spline( dx, y, n, dydx1, dydxn, d2ydx2 )
!   Included for compatibility with interface used in siesta
! Input:
!   real(dp) dx        ! mesh interval of a uniform mesh starting at x=0
!   real(dp) y(n)      ! function value at mesh points
!   integer  n         ! number of mesh points
!   real(dp) dydx1     ! dy/dx at x(1). If >1.e30, assumes d2y/dx2=0 at x(1)
!   real(dp) dydxn     ! dy/dx at x(n). If >1.e30, assumes d2y/dx2=0 at x(n)
! Output:
!   real(dp) d2ydx2(n) ! d2y/dx2 at mesh points
! ==============================================================================
! SUBROUTINE splint( xi, yi, d2ydx2, n, x, y, dydx )
!   Included for compatibility with Numerical Recipes interface
! Input:
!   real(dp) xi(n)     ! mesh points
!   real(dp) yi(n)     ! function value at mesh points
!   real(dp) d2ydx2(n) ! second derivative at mesh points
!   integer  n         ! number of mesh points
!   real(dp) x         ! point at which function is needed
! Output:
!   real(dp) y         ! function value at point x
!   real(dp) dydx      ! function derivative at point x
! ==============================================================================
! SUBROUTINE splint( dx, yi, d2ydx2, n, x, y, dydx )
!   Included for compatibility with interface used in siesta
! Input:
!   real(dp) dx        ! mesh interval of a uniform mesh starting at x=0
!   real(dp) yi(n)     ! function value at mesh points
!   real(dp) d2ydx2(n) ! second derivative at mesh points
!   integer  n         ! number of mesh points
!   real(dp) x         ! point at which function is needed
! Output:
!   real(dp) y         ! function value at point x
!   real(dp) dydx      ! function derivative at point x
! ==============================================================================
! SUBROUTINE polint(XA,YA,N,X,Y,DYDX) 
!   Lagrange interpolation
! Input:
!   real*8  XA(N) : x values of the function y(x) to interpolate
!   real*8  YA(N) : y values of the function y(x) to interpolate
!   integer N     : Number of data points
!   real*8  X     : x value at which the interpolation is desired
! Output:
!   real*8  Y     : interpolated value of y(x) at X
!   real*8  DYDX  : interpolated derivative dy/dx at X
!                   Notice: this argument has a different meaning
!                   in the Numerical Recipes' polint subroutine
! Ref:
!   W.H.Press et al, Numerical Recipes, Cambridge U.P.
! ==============================================================================
! Written by J.M.Soler and A.Garcia. May.2015
! ==============================================================================
!
! This module calls a subroutine 'die', with interface
!
!     interface
!      subroutine die(str)
!      character(len=*), intent(in)  :: str
!      end subroutine die
!     end interface

MODULE gridxc_interpolation

  use gridxc_sys, only: die
  
  implicit none

  integer, parameter :: dp = selected_real_kind(10,100)


PUBLIC :: &
  spline_t,        &! derived type to hold spline info of a function
  generate_spline, &! generate spline info
  evaluate_spline, &! evaluate a function at given point(s)
  clean_spline,    &! deallocate the components of a spline_t object
  spline,          &! compatible with Numerical Recipes interface
  splint,          &! compatible with Numerical Recipes interface
  polint            ! Lagrange polynomial interpolation

PRIVATE ! nothing is declared public beyond this point

! Derived type to hold spline info of a function
type spline_t
  private
  character(len=3):: mesh          ! mesh type ('lin'|'log'|'gen')
  real(dp)        :: xmin          ! x(1)-xtol
  real(dp)        :: xmax          ! x(n)+xtol
  real(dp)        :: x1            ! x(1)
  real(dp)        :: dx            ! linear mesh interval
  real(dp)        :: a,b           ! log-mesh parameters x(k)=b*[exp(a*(k-1))-1]
  integer         :: n             ! number of points
  real(dp),allocatable:: x(:)      ! mesh points
  real(dp),allocatable:: y(:)      ! function value at mesh points
  real(dp),allocatable:: d2ydx2(:) ! 2nd derivative at mesh points
end type

! Overloaded spline generators and evaluators
interface generate_spline
  module procedure generate_spline_master    ! new interface
  module procedure generate_spline_x  ! Numerical Recipes interface
  module procedure generate_spline_dx ! older interface
end interface generate_spline
interface evaluate_spline
  module procedure evaluate_spline    ! evaluate function at single point
  module procedure evaluate_spline_n  ! evaluate function at multiple points
  module procedure evaluate_spline_x  ! Numerical Recipes interface
  module procedure evaluate_spline_dx ! siesta interface
end interface evaluate_spline
interface spline
  module procedure generate_spline_x  ! Numerical Recipes interface
  module procedure generate_spline_dx ! siesta interface
end interface spline
interface splint
  module procedure evaluate_spline_x  ! Numerical Recipes interface
  module procedure evaluate_spline_dx ! siesta interface
end interface splint

! Internal module parameters
real(dp),parameter:: dydxMax = 0.99e30_dp  ! max. dy/dx at x(1) and x(n)
real(dp),parameter:: tol = 1.e-6_dp   ! tolerance for 'within range' condition

CONTAINS  

!-------------------------------------------------------------------------------

SUBROUTINE generate_spline_master( dat, x, y, n, dydx1, dydxn, d2ydx2, store, stat )

! Generate data for cubic spline interpolation of a function

implicit none
type(spline_t),   intent(out):: dat    ! spline interpolation info
integer,          intent(in) :: n      ! number of mesh points
real(dp),         intent(in) :: x(n)   ! independent variable at mesh points
real(dp),         intent(in) :: y(n)   ! function value at mesh points
real(dp),optional,intent(in) :: dydx1  ! dy/dx at x(1)
real(dp),optional,intent(in) :: dydxn  ! dy/dx at x(n)
real(dp),optional,intent(out):: d2ydx2(n) ! d2y/dx2 at mesh points
logical, optional, intent(in):: store  ! Store data in the spline object
integer, optional,intent(out):: stat   ! error status:
                                       !  (-1 if nonmonotonic mesh)
                                       !  (-2 if n < 2)

! Internal variables and arrays
character(len=*),parameter:: myName = 'generate_spline_master '
real(dp):: a, b, dx, dx1, dx2, dxn, dxm, dxp, dy1, dyn, dym, dyp, &
           p, s, u(n), v(n), xtol, ypp(n)
integer :: flag, k
character(len=3):: meshType

! Check that mesh is monotonic
if (n<2) then
  flag = -2   ! single-point
elseif (n>2 .and. any( (x(2:n-1)-x(1:n-2)) * (x(3:n)-x(2:n-1)) <= 0.0_dp )) then
  flag = -1   ! non-monotonic mesh
else
  flag = 0
endif
if (present(stat)) stat = flag
if (flag<0) return

! Find if mesh is linear (a=0) or logarithmic
!   x(k)=x(1)+b*[exp(a*(k-1))-1] => (x(k+1)-x(k))/(x(k)-x(k-1))=exp(a)
if (n<3) then
  meshType = 'lin'
  dx = x(2)-x(1)
else
  a = log( (x(3)-x(2)) / (x(2)-x(1)) )
  if (all(abs( (x(3:n)-x(2:n-1))/(x(2:n-1)-x(1:n-2))-exp(a) ) < 1.e-12_dp)) then
    if (abs(a)<1.e-12_dp) then
      meshType = 'lin'
      dx = x(2)-x(1)
    else  ! try x(k) = x(1) + b*[exp(a*(k-1))-1]
      meshType = 'log'
      b = (x(2)-x(1)) / (exp(a)-1._dp)
    endif
  else
    meshType = 'gen'
  endif
endif

! Set boundary conditions at end points
if (present(dydx1)) then
    dx1 = x(2)-x(1)
    dy1 = y(2)-y(1)
    v(1) = -0.5_dp
    u(1) = (3.0_dp/dx1)*(dy1/dx1-dydx1)
else
    v(1) = 0._dp
    u(1) = 0._dp
endif
if (present(dydxn)) then
    dxn = x(n)-x(n-1)
    dyn = y(n)-y(n-1)
    v(n) = 0.5_dp
    u(n) = (3.0_dp/dxn)*(dydxn-dyn/dxn)
else
    v(n) = 0.0_dp
    u(n) = 0.0_dp
endif

! Decomposition loop of the tridiagonal equations
do k = 2,n-1
    dxm = x(k)-x(k-1)
    dym = y(k)-y(k-1)
    dxp = x(k+1)-x(k)
    dyp = y(k+1)-y(k)
    s = dxm / (dxm+dxp)
    p = s*v(k-1) + 2.0_dp
    v(k) = (s-1.0_dp)/p
    u(k) = ( 6.0_dp*(dyp/dxp-dym/dxm)/(dxm+dxp) - s*u(k-1) )/p
enddo

! Backsubstitution loop of the tridiagonal equations
ypp(n) = (u(n)-v(n)*u(n-1)) / (v(n)*v(n-1)+1.0_dp)
do k = n-1,1,-1
  ypp(k) = v(k)*ypp(k+1) + u(k)
enddo

! Store output, if requested
if (present(d2ydx2)) d2ydx2 = ypp

if ( present(store) ) then
  if ( .not. store ) return
end if

! Store spline info in output variable
allocate(dat%x(n), dat%y(n), dat%d2ydx2(n))

dx = (x(n)-x(1))/(n-1)
xtol = abs(dx)*tol
dat%mesh = meshType
dat%xmin = min(x(1),x(n)) - xtol
dat%xmax = max(x(1),x(n)) + xtol
dat%x1 = x(1)
dat%dx = dx
dat%a = a
if (dat%mesh == 'log') dat%b = b
dat%n = n
dat%x(:) = x(:)
dat%y(:) = y(:)
dat%d2ydx2(:) = ypp(:)

end subroutine generate_spline_master

!-------------------------------------------------------------------------------

SUBROUTINE evaluate_spline( dat, x, y, dydx ) ! Evaluate function at one point

implicit none
type(spline_t),   intent(in) :: dat  ! info for spline interpolation of y(x)
real(dp),         intent(in) :: x    ! point at which function is needed
real(dp),         intent(out):: y    ! function value at point x
real(dp),optional,intent(out):: dydx ! function derivative at point x

! Internal variables
integer :: kh, kl
real(dp):: xh, xl

! Find mesh interval of point x
call find_interval( dat, dat%x, x, kl, kh, xl, xh )

! Find interpolation within given interval
call interpolate_interval( xl, xh, dat%y(kl), dat%y(kh), &
                           dat%d2ydx2(kl), dat%d2ydx2(kh), x, y, dydx ) 

END SUBROUTINE evaluate_spline

!-------------------------------------------------------------------------------

SUBROUTINE find_interval( dat, xi, x, kl, kh, xl, xh )

! Find interpolation interval

implicit none
type(spline_t),   intent(in) :: dat   ! spline info
real(dp),         intent(in) :: xi(:) ! mesh points
real(dp),         intent(in) :: x     ! point at which function is needed
integer,          intent(out):: kl    ! lower interval index
integer,          intent(out):: kh    ! higher interval index
real(dp),         intent(out):: xl    ! lower interval mesh point
real(dp),         intent(out):: xh    ! higher interval mesh point

! Internal variables
character(len=*),parameter:: myName = 'evaluate_spline/find_interval '
real(dp)::  a, b, dx, h, x1, xmin, xmax, xtol
integer ::  k, n

! Get some parameters
xmin = dat%xmin
xmax = dat%xmax
n = size(xi)

! Check that point is within interpolation range
if (x<dat%xmin .or. x>dat%xmax) &
  call die(myName//'ERROR: x out of range')

! Find mesh interval of point x
select case(dat%mesh)
case('lin')      ! linear mesh
  x1 = dat%x1
  dx = dat%dx
  kl = 1+floor((x-x1)/dx)
  kl = min(n-1,max(1,kl))
  kh = kl+1
  xl = x1+(kl-1)*dx
  xh = x1+(kh-1)*dx
case ('log')     ! logarithmic mesh
  x1 = dat%x1
  a  = dat%a
  b  = dat%b
  kl = 1+floor(log(1+(x-x1)/b)/a)
  kl = min(n-1,max(1,kl))
  kh = kl+1
  xl = x1+b*(exp((kl-1)*a)-1)
  xh = x1+b*(exp((kh-1)*a)-1)
case('gen')      ! general mesh => use bisection
  kl = 1
  kh = n
  do while(kh-kl>1)
    k = (kh+kl)/2
    if (xi(k)>x) then
      kh = k
    else
      kl = k
    endif
  enddo
  xl = xi(kl)
  xh = xi(kh)
case default
  call die(myName//'ERROR: unknown mesh type')
end select

END SUBROUTINE find_interval

!-------------------------------------------------------------------------------

SUBROUTINE interpolate_interval( xl, xh, yl, yh, d2ydx2l, d2ydx2h, x, y, dydx )

! Evaluate function at point x, within a given interval

implicit none
real(dp),         intent(in) :: xl      ! lower interval point
real(dp),         intent(in) :: xh      ! higher interval point
real(dp),         intent(in) :: yl      ! function value at xl
real(dp),         intent(in) :: yh      ! function value at xh
real(dp),         intent(in) :: d2ydx2l ! d2y/dx2 at at xl
real(dp),         intent(in) :: d2ydx2h ! d2y/dx2 at at xh
real(dp),         intent(in) :: x       ! point at which function is needed
real(dp),         intent(out):: y       ! function value at point x
real(dp),optional,intent(out):: dydx    ! function derivative at point x

! Internal variables
real(dp)::  A, B, dAdx, dBdx, dx

! Find interpolated value
dx = xh-xl
A = (xh-x)/dx
B = (x-xl)/dx
y = A*yl + B*yh + ( (A**3-A)*d2ydx2l + (B**3-B)*d2ydx2h ) * (dx**2)/6.0_dp

! Find interpolated derivative
if (present(dydx)) then
  dAdx = -1._dp/dx
  dBdx = +1._dp/dx
  dydx = dAdx*yl + dBdx*yh + ( dAdx*(3*A**2-1._dp)*d2ydx2l + & 
                               dBdx*(3*B**2-1._dp)*d2ydx2h ) * (dx**2)/6.0_dp
endif

END SUBROUTINE interpolate_interval

!-------------------------------------------------------------------------------

SUBROUTINE evaluate_spline_n( dat, x, y, dydx )

! Evaluate a function at several points

implicit none
type(spline_t),   intent(in) :: dat     ! info for spline interpolation of y(x)
real(dp),         intent(in) :: x(:)    ! point at which function is needed
real(dp),         intent(out):: y(:)    ! function value at point x
real(dp),optional,intent(out):: dydx(:) ! function derivative at point x

integer:: ix, nx

nx = size(x)
do ix = 1,nx
  call evaluate_spline( dat, x(ix), y(ix), dydx(ix) )
enddo

END SUBROUTINE evaluate_spline_n

!-------------------------------------------------------------------------------

SUBROUTINE generate_spline_x( x, y, n, dydx1, dydxn, d2ydx2 )

! Included for compatibility with an older interface

implicit none
integer, intent(in) :: n         ! number of mesh points
real(dp),intent(in) :: x(n)      ! mesh of independent variable
real(dp),intent(in) :: y(n)      ! function value at mesh points
real(dp),intent(in) :: dydx1     ! dy/dx at x(1)
real(dp),intent(in) :: dydxn     ! dy/dx at x(n)
real(dp),intent(out):: d2ydx2(n) ! d2y/dx2 at mesh points

! Internal variables
integer :: stat
type(spline_t):: dat

! Generate spline dat
if (dydx1>dydxMax .and. dydxn>dydxMax) then
  call generate_spline_master( dat, x, y, n, d2ydx2=d2ydx2, store=.false., stat=stat)
elseif (dydxn>dydxMax) then
  call generate_spline_master( dat, x, y, n, dydx1=dydx1, d2ydx2=d2ydx2, store=.false., stat=stat)
elseif (dydx1>dydxMax) then
  call generate_spline_master( dat, x, y, n, dydxn=dydxn, d2ydx2=d2ydx2, store=.false., stat=stat)
else
  call generate_spline_master( dat, x, y, n, dydx1, dydxn, d2ydx2=d2ydx2, store=.false., stat=stat)
endif

! If the status is faulty the resulting d2y/dx2 will be
! forcefully set to 0
! Then the user has to do something differently
if ( stat /= 0 ) d2ydx2(:) = 0._dp

! Deallocate arrays in the spline data-structure
call clean_spline(dat)

END SUBROUTINE generate_spline_x

!-------------------------------------------------------------------------------

SUBROUTINE generate_spline_dx( dx, y, n, dydx1, dydxn, d2ydx2 )

! Included for compatibility with an older interface

implicit none
integer, intent(in) :: n         ! number of mesh points
real(dp),intent(in) :: dx        ! mesh interval
real(dp),intent(in) :: y(n)      ! function value at mesh points
real(dp),intent(in) :: dydx1     ! dy/dx at x(1)
real(dp),intent(in) :: dydxn     ! dy/dx at x(n)
real(dp),intent(out):: d2ydx2(n) ! d2y/dx2 at mesh points

! Internal variables
integer :: ix
real(dp):: x(n)

! Generate spline data
x = (/( (ix-1)*dx, ix=1,n )/)
call generate_spline_x( x, y, n, dydx1, dydxn, d2ydx2 )

END SUBROUTINE generate_spline_dx

!-------------------------------------------------------------------------------

SUBROUTINE evaluate_spline_x( xi, yi, d2ydx2, n, x, y, dydx )

! Included for compatibility with an older interface

implicit none
integer,          intent(in) :: n         ! number of mesh points
real(dp),         intent(in) :: xi(n)     ! mesh of independent variable
real(dp),         intent(in) :: yi(n)     ! function value at mesh points
real(dp),         intent(in) :: d2ydx2(n) ! function value at point x
real(dp),         intent(in) :: x         ! point at which function is needed
real(dp),         intent(out):: y         ! function value at point x
real(dp),optional,intent(out):: dydx      ! function derivative at point x

integer :: kh, kl
real(dp):: xh, xl, xtol
type(spline_t):: dat

! Find mesh interval of point x (warning: no check that x is within range)
dat%mesh = 'gen'
dat%x1 = xi(1)
dat%dx = (xi(n)-xi(1))/(n-1)
xtol = abs(dat%dx)*tol
dat%xmin = min(xi(1),xi(n)) - xtol
dat%xmax = max(xi(1),xi(n)) + xtol
call find_interval( dat, xi, x, kl, kh, xl, xh )

! Find interpolation within given interval
call interpolate_interval( xl, xh, yi(kl), yi(kh), &
                           d2ydx2(kl), d2ydx2(kh), x, y, dydx ) 

END SUBROUTINE evaluate_spline_x

!-------------------------------------------------------------------------------

SUBROUTINE evaluate_spline_dx( dx, yi, d2ydx2, n, x, y, dydx )

! Included for compatibility with an older interface

implicit none
integer,          intent(in) :: n         ! number of mesh points
real(dp),         intent(in) :: dx        ! mesh interval
real(dp),         intent(in) :: yi(n)     ! function value at mesh points
real(dp),         intent(in) :: d2ydx2(n) ! function value at point x
real(dp),         intent(in) :: x         ! point at which function is needed
real(dp),         intent(out):: y         ! function value at point x
real(dp),optional,intent(out):: dydx      ! function derivative at point x

integer :: kh, kl
real(dp):: xh, xl, xmax, xtol

! Check that point is within interpolation range
xmax = (n-1)*dx
xtol = dx*tol
if (x<-xtol .or. x>xmax+xtol) &
  call die('evaluate_spline ERROR: x out of range')

! Find mesh interval of point x (warning: no check that x is within range)
kl = 1+floor(x/dx)
kl = min(n-1,max(1,kl))
kh = kl+1
xl = (kl-1)*dx
xh = (kh-1)*dx

! Find interpolation within given interval
call interpolate_interval( xl, xh, yi(kl), yi(kh), &
                           d2ydx2(kl), d2ydx2(kh), x, y, dydx ) 

END SUBROUTINE evaluate_spline_dx

!-------------------------------------------------------------------------------

SUBROUTINE polint( xi, yi, n, x, y, dydx )  ! Lagrange interpolation

  implicit none
  integer, intent(in) :: n     ! number of mesh points
  real(dp),intent(in) :: xi(*) ! mesh points
  real(dp),intent(in) :: yi(*) ! function values at mesh points
  real(dp),intent(in) :: x     ! point at which function is required
  real(dp),intent(out):: y     ! function value at point x
  real(dp),intent(out):: dydx  ! function derivative at point x

  integer :: i0, m, nm
  real(dp):: c(n), d(n), e(n), dcdx(n), dddx(n), dedx(n), dx1(n), dx2(n), dxi(n)

! Neville's algorithm, as described in NR
  c = yi(1:n)
  d = yi(1:n)
  dcdx = 0._dp
  dddx = 0._dp
  dydx = 0._dp
  i0 = n/2
  y = yi(i0)
  do m = 1,n-1               ! loop on increasing polynomial order
    nm = n-m
    dxi(1:nm) = xi(1:nm)-xi(m+1:n)
    if (any(dxi(1:nm)==0.0_dp)) &
      call die('polint: ERROR: two mesh points are equal')
    dx1(1:nm) = xi(1:nm)-x
    dx2(1:nm) = xi(m+1:n)-x
    e(1:nm) = (c(2:nm+1)-d(1:nm))/dxi(1:nm)
    c(1:nm) = dx1(1:nm)*e(1:nm)
    d(1:nm) = dx2(1:nm)*e(1:nm)
    dedx(1:nm) = (dcdx(2:nm+1) - dddx(1:nm)) / dxi(1:nm)
    dcdx(1:nm) = - e(1:nm) + dx1(1:nm)*dedx(1:nm)
    dddx(1:nm) = - e(1:nm) + dx2(1:nm)*dedx(1:nm)
    i0 = i0-1
    if (2*i0 < nm) then
      i0 = i0+1
      y = y+c(i0)
      dydx = dydx+dcdx(i0)
    else
      y = y+d(i0)
      dydx = dydx+dddx(i0)
    endif
  end do

END SUBROUTINE polint

subroutine clean_spline(dat)
type(spline_t), intent(inout) :: dat

integer :: n

n = dat%n
if (allocated(dat%x)) then
   deallocate(dat%x, dat%y, dat%d2ydx2)
endif
dat%n = 0
end subroutine clean_spline

END MODULE gridxc_interpolation

#if defined HAVE_CONFIG_H
#include "config.h"
#endif

!!@LICENSE
!
!******************************************************************************
! MODULE array
! Provides utilities for copying data from one array shape to another
! array shape.
! Written by Nick R. Papior, Feb.2017
!******************************************************************************
!
!   PUBLIC procedures available from this module:
! array_copy    : Copies an array from one dimension to another array with another dimension
! array_add     : Adds an array from one dimension to another array with another dimension
!
!   PUBLIC parameters, types, and variables available from this module:
! none
!
! The intent of this module is to bypass the use of the intrinsic reshape
! function.
! Sadly many compilers implement the reshape with a guard on pointers such
! that a temporary array is created upon reshaping. For very large segments
! this turns out to be a substantial memory consumption on the heap which
! may easily be circumvented by doing explicit copying.
! These routines are extremely simple and does nothing but copy data from
! one shape to another.
!
! Currently only these copies and adds are implemented:
!
!   1D -> 2D [integer, real(sp), real(dp)]
!   1D -> 3D [integer, real(sp), real(dp)]
!   2D -> 1D [integer, real(sp), real(dp)]
!   3D -> 1D [integer, real(sp), real(dp)]

module gridxc_array

  use gridxc_precision, only: sp, dp
  use gridxc_sys,       only: die       ! Termination routine

  private

  public :: array_copy
  public :: array_add

  interface array_copy
     module procedure ac_1d_2d_ip, ac_1d_2d_sp, ac_1d_2d_dp
     module procedure ac_1d_3d_ip, ac_1d_3d_sp, ac_1d_3d_dp
     module procedure ac_2d_1d_ip, ac_2d_1d_sp, ac_2d_1d_dp
     module procedure ac_3d_1d_ip, ac_3d_1d_sp, ac_3d_1d_dp
     module procedure ac_4d_1d_ip, ac_4d_1d_sp, ac_4d_1d_dp
  end interface array_copy

  interface array_add
     module procedure aa_1d_2d_ip, aa_1d_2d_sp, aa_1d_2d_dp
     module procedure aa_1d_3d_ip, aa_1d_3d_sp, aa_1d_3d_dp
     module procedure aa_1d_4d_ip, aa_1d_4d_sp, aa_1d_4d_dp
     module procedure aa_2d_1d_ip, aa_2d_1d_sp, aa_2d_1d_dp
     module procedure aa_3d_1d_ip, aa_3d_1d_sp, aa_3d_1d_dp
     module procedure aa_4d_1d_ip, aa_4d_1d_sp, aa_4d_1d_dp
  end interface array_add

contains

  ! Copies a 1D array to a 2D array
  subroutine ac_1d_2d_ip(from_1D, to_1D, in1D, from_2D, to_2D, out2D)
    integer, intent(in) :: from_1D, to_1D
    integer, intent(in) :: in1D(:)
    integer, intent(in) :: from_2D(2), to_2D(2)
    integer, intent(inout) :: out2D(:,:)

    ! Local variables for copying
    integer :: i1D, i2D, j2D

    i2D = from_2D(1)
    j2D = from_2D(2)
    do i1D = from_1D, to_1D
       out2D(i2D, j2D) = in1D(i1D)
       i2D = i2D + 1
       if ( i2D > to_2D(1) ) then
          i2D = from_2D(1)
          j2D = j2D + 1
       end if
    end do

    if ( i2D /= from_2D(1) ) &
         call die("integer: 1D->2D failed (i)")
    if ( j2D <= to_2D(2) ) &
         call die("integer: 1D->2D failed (j)")

  end subroutine ac_1d_2d_ip
  subroutine ac_1d_2d_sp(from_1D, to_1D, in1D, from_2D, to_2D, out2D)
    integer, intent(in) :: from_1D, to_1D
    real(sp), intent(in) :: in1D(:)
    integer, intent(in) :: from_2D(2), to_2D(2)
    real(sp), intent(inout) :: out2D(:,:)

    ! Local variables for copying
    integer :: i1D, i2D, j2D

    i2D = from_2D(1)
    j2D = from_2D(2)
    do i1D = from_1D, to_1D
       out2D(i2D, j2D) = in1D(i1D)
       i2D = i2D + 1
       if ( i2D > to_2D(1) ) then
          i2D = from_2D(1)
          j2D = j2D + 1
       end if
    end do

    if ( i2D /= from_2D(1) ) &
         call die("real: 1D->2D failed (i)")
    if ( j2D <= to_2D(2) ) &
         call die("real: 1D->2D failed (j)")

  end subroutine ac_1d_2d_sp
  subroutine ac_1d_2d_dp(from_1D, to_1D, in1D, from_2D, to_2D, out2D)
    integer, intent(in) :: from_1D, to_1D
    real(dp), intent(in) :: in1D(:)
    integer, intent(in) :: from_2D(2), to_2D(2)
    real(dp), intent(inout) :: out2D(:,:)

    ! Local variables for copying
    integer :: i1D, i2D, j2D

    i2D = from_2D(1)
    j2D = from_2D(2)
    do i1D = from_1D, to_1D
       out2D(i2D, j2D) = in1D(i1D)
       i2D = i2D + 1
       if ( i2D > to_2D(1) ) then
          i2D = from_2D(1)
          j2D = j2D + 1
       end if
    end do

    if ( i2D /= from_2D(1) ) &
         call die("double: 1D->2D failed (i)")
    if ( j2D <= to_2D(2) ) &
         call die("double: 1D->2D failed (j)")

  end subroutine ac_1d_2d_dp

  ! Copies a 1D array to a 3D array
  subroutine ac_1d_3d_ip(from_1D, to_1D, in1D, from_3D, to_3D, out3D)
    integer, intent(in) :: from_1D, to_1D
    integer, intent(in) :: in1D(:)
    integer, intent(in) :: from_3D(3), to_3D(3)
    integer, intent(inout) :: out3D(:,:,:)

    ! Local variables for copying
    integer :: i1D, i3D, j3D, k3D

    i3D = from_3D(1)
    j3D = from_3D(2)
    k3D = from_3D(3)
    do i1D = from_1D, to_1D
       out3D(i3D, j3D, k3D) = in1D(i1D)
       i3D = i3D + 1
       if ( i3D > to_3D(1) ) then
          i3D = from_3D(1)
          j3D = j3D + 1
       end if
       if ( j3D > to_3D(2) ) then
          j3D = from_3D(2)
          k3D = k3D + 1
       end if
    end do

    if ( i3D /= from_3D(1) ) &
         call die("integer: 1D->3D failed (i)")
    if ( j3D /= from_3D(2) ) &
         call die("integer: 1D->3D failed (j)")
    if ( k3D <= to_3D(3) ) &
         call die("integer: 1D->3D failed (k)")

  end subroutine ac_1d_3d_ip
  subroutine ac_1d_3d_sp(from_1D, to_1D, in1D, from_3D, to_3D, out3D)
    integer, intent(in) :: from_1D, to_1D
    real(sp), intent(in) :: in1D(:)
    integer, intent(in) :: from_3D(3), to_3D(3)
    real(sp), intent(inout) :: out3D(:,:,:)

    ! Local variables for copying
    integer :: i1D, i3D, j3D, k3D

    i3D = from_3D(1)
    j3D = from_3D(2)
    k3D = from_3D(3)
    do i1D = from_1D, to_1D
       out3D(i3D, j3D, k3D) = in1D(i1D)
       i3D = i3D + 1
       if ( i3D > to_3D(1) ) then
          i3D = from_3D(1)
          j3D = j3D + 1
       end if
       if ( j3D > to_3D(2) ) then
          j3D = from_3D(2)
          k3D = k3D + 1
       end if
    end do

    if ( i3D /= from_3D(1) ) &
         call die("real: 1D->3D failed (i)")
    if ( j3D /= from_3D(2) ) &
         call die("real: 1D->3D failed (j)")
    if ( k3D <= to_3D(3) ) &
         call die("real: 1D->3D failed (k)")

  end subroutine ac_1d_3d_sp
  subroutine ac_1d_3d_dp(from_1D, to_1D, in1D, from_3D, to_3D, out3D)
    integer, intent(in) :: from_1D, to_1D
    real(dp), intent(in) :: in1D(:)
    integer, intent(in) :: from_3D(3), to_3D(3)
    real(dp), intent(inout) :: out3D(:,:,:)

    ! Local variables for copying
    integer :: i1D, i3D, j3D, k3D

    i3D = from_3D(1)
    j3D = from_3D(2)
    k3D = from_3D(3)
    do i1D = from_1D, to_1D
       out3D(i3D, j3D, k3D) = in1D(i1D)
       i3D = i3D + 1
       if ( i3D > to_3D(1) ) then
          i3D = from_3D(1)
          j3D = j3D + 1
       end if
       if ( j3D > to_3D(2) ) then
          j3D = from_3D(2)
          k3D = k3D + 1
       end if
    end do

    if ( i3D /= from_3D(1) ) &
         call die("double: 1D->3D failed (i)")
    if ( j3D /= from_3D(2) ) &
         call die("double: 1D->3D failed (j)")
    if ( k3D <= to_3D(3) ) &
         call die("double: 1D->3D failed (k)")

  end subroutine ac_1d_3d_dp

  ! Copies a 2D array to a 1D array
  subroutine ac_2d_1d_ip(from_2D, to_2D, in2D, from_1D, to_1D, out1D)
    integer, intent(in) :: from_2D(2), to_2D(2)
    integer, intent(in) :: in2D(:,:)
    integer, intent(in) :: from_1D, to_1D
    integer, intent(inout) :: out1D(:)

    ! Local variables for copying
    integer :: i2D, j2D, i1D

    i1D = from_1D
    do j2D = from_2D(2), to_2D(2)
       do i2D = from_2D(1), to_2D(1)
          out1D(i1D) = in2D(i2D, j2D)
          i1D = i1D + 1
       end do
    end do

    if ( i1D <= to_1D ) &
         call die("integer: 2D->1D failed")

  end subroutine ac_2d_1d_ip
  subroutine ac_2d_1d_sp(from_2D, to_2D, in2D, from_1D, to_1D, out1D)
    integer, intent(in) :: from_2D(2), to_2D(2)
    real(sp), intent(in) :: in2D(:,:)
    integer, intent(in) :: from_1D, to_1D
    real(sp), intent(inout) :: out1D(:)

    ! Local variables for copying
    integer :: i2D, j2D, i1D

    i1D = from_1D
    do j2D = from_2D(2), to_2D(2)
       do i2D = from_2D(1), to_2D(1)
          out1D(i1D) = in2D(i2D, j2D)
          i1D = i1D + 1
       end do
    end do

    if ( i1D <= to_1D ) &
         call die("real: 2D->1D failed")

  end subroutine ac_2d_1d_sp
  subroutine ac_2d_1d_dp(from_2D, to_2D, in2D, from_1D, to_1D, out1D)
    integer, intent(in) :: from_2D(2), to_2D(2)
    real(dp), intent(in) :: in2D(:,:)
    integer, intent(in) :: from_1D, to_1D
    real(dp), intent(inout) :: out1D(:)

    ! Local variables for copying
    integer :: i2D, j2D, i1D

    i1D = from_1D
    do j2D = from_2D(2), to_2D(2)
       do i2D = from_2D(1), to_2D(1)
          out1D(i1D) = in2D(i2D, j2D)
          i1D = i1D + 1
       end do
    end do

    if ( i1D <= to_1D ) &
         call die("double: 2D->1D failed")

  end subroutine ac_2d_1d_dp
  
  ! Copies a 3D array to a 1D array
  subroutine ac_3d_1d_ip(from_3D, to_3D, in3D, from_1D, to_1D, out1D)
    integer, intent(in) :: from_3D(3), to_3D(3)
    integer, intent(in) :: in3D(:,:,:)
    integer, intent(in) :: from_1D, to_1D
    integer, intent(inout) :: out1D(:)

    ! Local variables for copying
    integer :: i3D, j3D, k3D, i1D

    i1D = from_1D
    do k3D = from_3D(3), to_3D(3)
       do j3D = from_3D(2), to_3D(2)
          do i3D = from_3D(1), to_3D(1)
             out1D(i1D) = in3D(i3D, j3D, k3D)
             i1D = i1D + 1
          end do
       end do
    end do

    if ( i1D <= to_1D ) &
         call die("integer: 3D->1D failed")

  end subroutine ac_3d_1d_ip
  subroutine ac_3d_1d_sp(from_3D, to_3D, in3D, from_1D, to_1D, out1D)
    integer, intent(in) :: from_3D(3), to_3D(3)
    real(sp), intent(in) :: in3D(:,:,:)
    integer, intent(in) :: from_1D, to_1D
    real(sp), intent(inout) :: out1D(:)

    ! Local variables for copying
    integer :: i3D, j3D, k3D, i1D

    i1D = from_1D
    do k3D = from_3D(3), to_3D(3)
       do j3D = from_3D(2), to_3D(2)
          do i3D = from_3D(1), to_3D(1)
             out1D(i1D) = in3D(i3D, j3D, k3D)
             i1D = i1D + 1
          end do
       end do
    end do

    if ( i1D <= to_1D ) &
         call die("real: 3D->1D failed")

  end subroutine ac_3d_1d_sp
  subroutine ac_3d_1d_dp(from_3D, to_3D, in3D, from_1D, to_1D, out1D)
    integer, intent(in) :: from_3D(3), to_3D(3)
    real(dp), intent(in) :: in3D(:,:,:)
    integer, intent(in) :: from_1D, to_1D
    real(dp), intent(inout) :: out1D(:)

    ! Local variables for copying
    integer :: i3D, j3D, k3D, i1D

    i1D = from_1D
    do k3D = from_3D(3), to_3D(3)
       do j3D = from_3D(2), to_3D(2)
          do i3D = from_3D(1), to_3D(1)
             out1D(i1D) = in3D(i3D, j3D, k3D)
             i1D = i1D + 1
          end do
       end do
    end do

    if ( i1D <= to_1D ) &
         call die("double: 3D->1D failed")

  end subroutine ac_3d_1d_dp

  ! Copies a 4D array to a 1D array
  subroutine ac_4d_1d_ip(from_4D, to_4D, in4D, from_1D, to_1D, out1D)
    integer, intent(in) :: from_4D(4), to_4D(4)
    integer, intent(in) :: in4D(:,:,:,:)
    integer, intent(in) :: from_1D, to_1D
    integer, intent(inout) :: out1D(:)

    ! Local variables for copying
    integer :: i4D, j4D, k4D, m4D, i1D

    i1D = from_1D
    do m4D = from_4D(4), to_4D(4)
       do k4D = from_4D(3), to_4D(3)
          do j4D = from_4D(2), to_4D(2)
             do i4D = from_4D(1), to_4D(1)
                out1D(i1D) = in4D(i4D, j4D, k4D, m4D)
                i1D = i1D + 1
             end do
          end do
       end do
    end do

    if ( i1D <= to_1D ) &
         call die("integer: 4D->1D failed")

  end subroutine ac_4d_1d_ip
  subroutine ac_4d_1d_sp(from_4D, to_4D, in4D, from_1D, to_1D, out1D)
    integer, intent(in) :: from_4D(4), to_4D(4)
    real(sp), intent(in) :: in4D(:,:,:,:)
    integer, intent(in) :: from_1D, to_1D
    real(sp), intent(inout) :: out1D(:)

    ! Local variables for copying
    integer :: i4D, j4D, k4D, m4D, i1D

    i1D = from_1D
    do m4D = from_4D(4), to_4D(4)
       do k4D = from_4D(3), to_4D(3)
          do j4D = from_4D(2), to_4D(2)
             do i4D = from_4D(1), to_4D(1)
                out1D(i1D) = in4D(i4D, j4D, k4D, m4D)
                i1D = i1D + 1
             end do
          end do
       end do
    end do
    
    if ( i1D <= to_1D ) &
         call die("real: 4D->1D failed")

  end subroutine ac_4d_1d_sp
  subroutine ac_4d_1d_dp(from_4D, to_4D, in4D, from_1D, to_1D, out1D)
    integer, intent(in) :: from_4D(4), to_4D(4)
    real(dp), intent(in) :: in4D(:,:,:,:)
    integer, intent(in) :: from_1D, to_1D
    real(dp), intent(inout) :: out1D(:)

    ! Local variables for copying
    integer :: i4D, j4D, k4D, m4D, i1D

    i1D = from_1D
    do m4D = from_4D(4), to_4D(4)
       do k4D = from_4D(3), to_4D(3)
          do j4D = from_4D(2), to_4D(2)
             do i4D = from_4D(1), to_4D(1)
                out1D(i1D) = in4D(i4D, j4D, k4D, m4D)
                i1D = i1D + 1
             end do
          end do
       end do
    end do
    
    if ( i1D <= to_1D ) &
         call die("double: 4D->1D failed")

  end subroutine ac_4d_1d_dp
  

  ! Adds a 1D array to a 2D array
  subroutine aa_1d_2d_ip(from_1D, to_1D, a1D, from_2D, to_2D, out2D)
    integer, intent(in) :: from_1D, to_1D
    integer, intent(in) :: a1D(:)
    integer, intent(in) :: from_2D(2), to_2D(2)
    integer, intent(inout) :: out2D(:,:)

    ! Local variables for copying
    integer :: i1D, i2D, j2D

    i2D = from_2D(1)
    j2D = from_2D(2)
    do i1D = from_1D, to_1D
       out2D(i2D, j2D) = out2D(i2D, j2D) + a1D(i1D)
       i2D = i2D + 1
       if ( i2D > to_2D(1) ) then
          i2D = from_2D(1)
          j2D = j2D + 1
       end if
    end do

    if ( i2D /= from_2D(1) ) &
         call die("integer: 1D+>2D failed (i)")
    if ( j2D <= to_2D(2) ) &
         call die("integer: 1D+>2D failed (j)")

  end subroutine aa_1d_2d_ip
  subroutine aa_1d_2d_sp(from_1D, to_1D, a1D, from_2D, to_2D, out2D)
    integer, intent(in) :: from_1D, to_1D
    real(sp), intent(in) :: a1D(:)
    integer, intent(in) :: from_2D(2), to_2D(2)
    real(sp), intent(inout) :: out2D(:,:)

    ! Local variables for copying
    integer :: i1D, i2D, j2D

    i2D = from_2D(1)
    j2D = from_2D(2)
    do i1D = from_1D, to_1D
       out2D(i2D, j2D) = out2D(i2D, j2D) + a1D(i1D)
       i2D = i2D + 1
       if ( i2D > to_2D(1) ) then
          i2D = from_2D(1)
          j2D = j2D + 1
       end if
    end do

    if ( i2D /= from_2D(1) ) &
         call die("real: 1D+>2D failed (i)")
    if ( j2D <= to_2D(2) ) &
         call die("real: 1D+>2D failed (j)")

  end subroutine aa_1d_2d_sp
  subroutine aa_1d_2d_dp(from_1D, to_1D, a1D, from_2D, to_2D, out2D)
    integer, intent(in) :: from_1D, to_1D
    real(dp), intent(in) :: a1D(:)
    integer, intent(in) :: from_2D(2), to_2D(2)
    real(dp), intent(inout) :: out2D(:,:)

    ! Local variables for copying
    integer :: i1D, i2D, j2D

    i2D = from_2D(1)
    j2D = from_2D(2)
    do i1D = from_1D, to_1D
       out2D(i2D, j2D) = out2D(i2D, j2D) + a1D(i1D)
       i2D = i2D + 1
       if ( i2D > to_2D(1) ) then
          i2D = from_2D(1)
          j2D = j2D + 1
       end if
    end do

    if ( i2D /= from_2D(1) ) &
         call die("double: 1D+>2D failed (i)")
    if ( j2D <= to_2D(2) ) &
         call die("double: 1D+>2D failed (j)")

  end subroutine aa_1d_2d_dp

  ! Adds a 1D array to a 3D array
  subroutine aa_1d_3d_ip(from_1D, to_1D, a1D, from_3D, to_3D, out3D)
    integer, intent(in) :: from_1D, to_1D
    integer, intent(in) :: a1D(:)
    integer, intent(in) :: from_3D(3), to_3D(3)
    integer, intent(inout) :: out3D(:,:,:)

    ! Local variables for copying
    integer :: i1D, i3D, j3D, k3D

    i3D = from_3D(1)
    j3D = from_3D(2)
    k3D = from_3D(3)
    do i1D = from_1D, to_1D
       out3D(i3D, j3D, k3D) = out3D(i3D, j3D, k3D) + a1D(i1D)
       i3D = i3D + 1
       if ( i3D > to_3D(1) ) then
          i3D = from_3D(1)
          j3D = j3D + 1
       end if
       if ( j3D > to_3D(2) ) then
          j3D = from_3D(2)
          k3D = k3D + 1
       end if
    end do

    if ( i3D /= from_3D(1) ) &
         call die("integer: 1D+>3D failed (i)")
    if ( j3D /= from_3D(2) ) &
         call die("integer: 1D+>3D failed (j)")
    if ( k3D <= to_3D(3) ) &
         call die("integer: 1D+>3D failed (k)")

  end subroutine aa_1d_3d_ip
  subroutine aa_1d_3d_sp(from_1D, to_1D, a1D, from_3D, to_3D, out3D)
    integer, intent(in) :: from_1D, to_1D
    real(sp), intent(in) :: a1D(:)
    integer, intent(in) :: from_3D(3), to_3D(3)
    real(sp), intent(inout) :: out3D(:,:,:)

    ! Local variables for copying
    integer :: i1D, i3D, j3D, k3D

    i3D = from_3D(1)
    j3D = from_3D(2)
    k3D = from_3D(3)
    do i1D = from_1D, to_1D
       out3D(i3D, j3D, k3D) = out3D(i3D, j3D, k3D) + a1D(i1D)
       i3D = i3D + 1
       if ( i3D > to_3D(1) ) then
          i3D = from_3D(1)
          j3D = j3D + 1
       end if
       if ( j3D > to_3D(2) ) then
          j3D = from_3D(2)
          k3D = k3D + 1
       end if
    end do

    if ( i3D /= from_3D(1) ) &
         call die("real: 1D+>3D failed (i)")
    if ( j3D /= from_3D(2) ) &
         call die("real: 1D+>3D failed (j)")
    if ( k3D <= to_3D(3) ) &
         call die("real: 1D+>3D failed (k)")

  end subroutine aa_1d_3d_sp
  subroutine aa_1d_3d_dp(from_1D, to_1D, a1D, from_3D, to_3D, out3D)
    integer, intent(in) :: from_1D, to_1D
    real(dp), intent(in) :: a1D(:)
    integer, intent(in) :: from_3D(3), to_3D(3)
    real(dp), intent(inout) :: out3D(:,:,:)

    ! Local variables for copying
    integer :: i1D, i3D, j3D, k3D

    i3D = from_3D(1)
    j3D = from_3D(2)
    k3D = from_3D(3)
    do i1D = from_1D, to_1D
       out3D(i3D, j3D, k3D) = out3D(i3D, j3D, k3D) + a1D(i1D)
       i3D = i3D + 1
       if ( i3D > to_3D(1) ) then
          i3D = from_3D(1)
          j3D = j3D + 1
       end if
       if ( j3D > to_3D(2) ) then
          j3D = from_3D(2)
          k3D = k3D + 1
       end if
    end do

    if ( i3D /= from_3D(1) ) &
         call die("double: 1D+>3D failed (i)")
    if ( j3D /= from_3D(2) ) &
         call die("double: 1D+>3D failed (j)")
    if ( k3D <= to_3D(3) ) &
         call die("double: 1D+>3D failed (k)")

  end subroutine aa_1d_3d_dp

  ! Adds a 1D array to a 4D array
  subroutine aa_1d_4d_ip(from_1D, to_1D, a1D, from_4D, to_4D, out4D)
    integer, intent(in) :: from_1D, to_1D
    integer, intent(in) :: a1D(:)
    integer, intent(in) :: from_4D(4), to_4D(4)
    integer, intent(inout) :: out4D(:,:,:,:)

    ! Local variables for copying
    integer :: i1D, i4D, j4D, k4D, m4D

    i4D = from_4D(1)
    j4D = from_4D(2)
    k4D = from_4D(3)
    m4D = from_4D(4)
    do i1D = from_1D, to_1D
       out4D(i4D, j4D, k4D, m4D) = out4D(i4D, j4D, k4D, m4D) + a1D(i1D)
       i4D = i4D + 1
       if ( i4D > to_4D(1) ) then
          i4D = from_4D(1)
          j4D = j4D + 1
       end if
       if ( j4D > to_4D(2) ) then
          j4D = from_4D(2)
          k4D = k4D + 1
       end if
       if ( k4D > to_4D(3) ) then
          k4D = from_4D(3)
          m4D = m4D + 1
       end if
    end do

    if ( i4D /= from_4D(1) ) &
         call die("integer: 1D+>4D failed (i)")
    if ( j4D /= from_4D(2) ) &
         call die("integer: 1D+>4D failed (j)")
    if ( k4D /= from_4D(3) ) &
         call die("integer: 1D+>4D failed (k)")
    if ( m4D <= to_4D(4) ) &
         call die("integer: 1D+>4D failed (m)")

  end subroutine aa_1d_4d_ip
  subroutine aa_1d_4d_sp(from_1D, to_1D, a1D, from_4D, to_4D, out4D)
    integer, intent(in) :: from_1D, to_1D
    real(sp), intent(in) :: a1D(:)
    integer, intent(in) :: from_4D(4), to_4D(4)
    real(sp), intent(inout) :: out4D(:,:,:,:)

    ! Local variables for copying
    integer :: i1D, i4D, j4D, k4D, m4D

    i4D = from_4D(1)
    j4D = from_4D(2)
    k4D = from_4D(3)
    m4D = from_4D(4)
    do i1D = from_1D, to_1D
       out4D(i4D, j4D, k4D, m4D) = out4D(i4D, j4D, k4D, m4D) + a1D(i1D)
       i4D = i4D + 1
       if ( i4D > to_4D(1) ) then
          i4D = from_4D(1)
          j4D = j4D + 1
       end if
       if ( j4D > to_4D(2) ) then
          j4D = from_4D(2)
          k4D = k4D + 1
       end if
       if ( k4D > to_4D(3) ) then
          k4D = from_4D(3)
          m4D = m4D + 1
       end if
    end do

    if ( i4D /= from_4D(1) ) &
         call die("real: 1D+>4D failed (i)")
    if ( j4D /= from_4D(2) ) &
         call die("real: 1D+>4D failed (j)")
    if ( k4D /= from_4D(3) ) &
         call die("real: 1D+>4D failed (k)")
    if ( m4D <= to_4D(4) ) &
         call die("real: 1D+>4D failed (m)")

  end subroutine aa_1d_4d_sp
  subroutine aa_1d_4d_dp(from_1D, to_1D, a1D, from_4D, to_4D, out4D)
    integer, intent(in) :: from_1D, to_1D
    real(dp), intent(in) :: a1D(:)
    integer, intent(in) :: from_4D(4), to_4D(4)
    real(dp), intent(inout) :: out4D(:,:,:,:)

    ! Local variables for copying
    integer :: i1D, i4D, j4D, k4D, m4D

    i4D = from_4D(1)
    j4D = from_4D(2)
    k4D = from_4D(3)
    m4D = from_4D(4)
    do i1D = from_1D, to_1D
       out4D(i4D, j4D, k4D, m4D) = out4D(i4D, j4D, k4D, m4D) + a1D(i1D)
       i4D = i4D + 1
       if ( i4D > to_4D(1) ) then
          i4D = from_4D(1)
          j4D = j4D + 1
       end if
       if ( j4D > to_4D(2) ) then
          j4D = from_4D(2)
          k4D = k4D + 1
       end if
       if ( k4D > to_4D(3) ) then
          k4D = from_4D(3)
          m4D = m4D + 1
       end if
    end do

    if ( i4D /= from_4D(1) ) &
         call die("double: 1D+>4D failed (i)")
    if ( j4D /= from_4D(2) ) &
         call die("double: 1D+>4D failed (j)")
    if ( k4D /= from_4D(3) ) &
         call die("double: 1D+>4D failed (k)")
    if ( m4D <= to_4D(4) ) &
         call die("double: 1D+>4D failed (m)")

  end subroutine aa_1d_4d_dp
  
  ! Adds a 2D array to a 1D array
  subroutine aa_2d_1d_ip(from_2D, to_2D, in2D, from_1D, to_1D, out1D)
    integer, intent(in) :: from_2D(2), to_2D(2)
    integer, intent(in) :: in2D(:,:)
    integer, intent(in) :: from_1D, to_1D
    integer, intent(inout) :: out1D(:)

    ! Local variables for copying
    integer :: i2D, j2D, i1D

    i1D = from_1D
    do j2D = from_2D(2), to_2D(2)
       do i2D = from_2D(1), to_2D(1)
          out1D(i1D) = out1D(i1D) + in2D(i2D, j2D)
          i1D = i1D + 1
       end do
    end do

    if ( i1D <= to_1D ) &
         call die("integer: 2D+>1D failed")

  end subroutine aa_2d_1d_ip
  subroutine aa_2d_1d_sp(from_2D, to_2D, in2D, from_1D, to_1D, out1D)
    integer, intent(in) :: from_2D(2), to_2D(2)
    real(sp), intent(in) :: in2D(:,:)
    integer, intent(in) :: from_1D, to_1D
    real(sp), intent(inout) :: out1D(:)

    ! Local variables for copying
    integer :: i2D, j2D, i1D

    i1D = from_1D
    do j2D = from_2D(2), to_2D(2)
       do i2D = from_2D(1), to_2D(1)
          out1D(i1D) = out1D(i1D) + in2D(i2D, j2D)
          i1D = i1D + 1
       end do
    end do

    if ( i1D <= to_1D ) &
         call die("real: 2D+>1D failed")

  end subroutine aa_2d_1d_sp
  subroutine aa_2d_1d_dp(from_2D, to_2D, in2D, from_1D, to_1D, out1D)
    integer, intent(in) :: from_2D(2), to_2D(2)
    real(dp), intent(in) :: in2D(:,:)
    integer, intent(in) :: from_1D, to_1D
    real(dp), intent(inout) :: out1D(:)

    ! Local variables for copying
    integer :: i2D, j2D, i1D

    i1D = from_1D
    do j2D = from_2D(2), to_2D(2)
       do i2D = from_2D(1), to_2D(1)
          out1D(i1D) = out1D(i1D) + in2D(i2D, j2D)
          i1D = i1D + 1
       end do
    end do

    if ( i1D <= to_1D ) &
         call die("double: 2D+>1D failed")

  end subroutine aa_2d_1d_dp
  
  ! Adds a 3D array to a 1D array
  subroutine aa_3d_1d_ip(from_3D, to_3D, in3D, from_1D, to_1D, out1D)
    integer, intent(in) :: from_3D(3), to_3D(3)
    integer, intent(in) :: in3D(:,:,:)
    integer, intent(in) :: from_1D, to_1D
    integer, intent(inout) :: out1D(:)

    ! Local variables for copying
    integer :: i3D, j3D, k3D, i1D

    i1D = from_1D
    do k3D = from_3D(3), to_3D(3)
       do j3D = from_3D(2), to_3D(2)
          do i3D = from_3D(1), to_3D(1)
             out1D(i1D) = out1D(i1D) + in3D(i3D, j3D, k3D)
             i1D = i1D + 1
          end do
       end do
    end do

    if ( i1D <= to_1D ) &
         call die("integer: 3D+>1D failed")

  end subroutine aa_3d_1d_ip
  subroutine aa_3d_1d_sp(from_3D, to_3D, in3D, from_1D, to_1D, out1D)
    integer, intent(in) :: from_3D(3), to_3D(3)
    real(sp), intent(in) :: in3D(:,:,:)
    integer, intent(in) :: from_1D, to_1D
    real(sp), intent(inout) :: out1D(:)

    ! Local variables for copying
    integer :: i3D, j3D, k3D, i1D

    i1D = from_1D
    do k3D = from_3D(3), to_3D(3)
       do j3D = from_3D(2), to_3D(2)
          do i3D = from_3D(1), to_3D(1)
             out1D(i1D) = out1D(i1D) + in3D(i3D, j3D, k3D)
             i1D = i1D + 1
          end do
       end do
    end do

    if ( i1D <= to_1D ) &
         call die("real: 3D+>1D failed")

  end subroutine aa_3d_1d_sp
  subroutine aa_3d_1d_dp(from_3D, to_3D, in3D, from_1D, to_1D, out1D)
    integer, intent(in) :: from_3D(3), to_3D(3)
    real(dp), intent(in) :: in3D(:,:,:)
    integer, intent(in) :: from_1D, to_1D
    real(dp), intent(inout) :: out1D(:)

    ! Local variables for copying
    integer :: i3D, j3D, k3D, i1D

    i1D = from_1D
    do k3D = from_3D(3), to_3D(3)
       do j3D = from_3D(2), to_3D(2)
          do i3D = from_3D(1), to_3D(1)
             out1D(i1D) = out1D(i1D) + in3D(i3D, j3D, k3D)
             i1D = i1D + 1
          end do
       end do
    end do

    if ( i1D <= to_1D ) &
         call die("double: 3D+>1D failed")

  end subroutine aa_3d_1d_dp

  ! Adds a 4D array to a 1D array
  subroutine aa_4d_1d_ip(from_4D, to_4D, in4D, from_1D, to_1D, out1D)
    integer, intent(in) :: from_4D(4), to_4D(4)
    integer, intent(in) :: in4D(:,:,:,:)
    integer, intent(in) :: from_1D, to_1D
    integer, intent(inout) :: out1D(:)

    ! Local variables for copying
    integer :: i4D, j4D, k4D, m4D, i1D

    i1D = from_1D
    do m4D = from_4D(4), to_4D(4)
       do k4D = from_4D(3), to_4D(3)
          do j4D = from_4D(2), to_4D(2)
             do i4D = from_4D(1), to_4D(1)
                out1D(i1D) = out1D(i1D) + in4D(i4D, j4D, k4D, m4D)
                i1D = i1D + 1
             end do
          end do
       end do
    end do
    
    if ( i1D <= to_1D ) &
         call die("integer: 4D+>1D failed")

  end subroutine aa_4d_1d_ip
  subroutine aa_4d_1d_sp(from_4D, to_4D, in4D, from_1D, to_1D, out1D)
    integer, intent(in) :: from_4D(4), to_4D(4)
    real(sp), intent(in) :: in4D(:,:,:,:)
    integer, intent(in) :: from_1D, to_1D
    real(sp), intent(inout) :: out1D(:)

    ! Local variables for copying
    integer :: i4D, j4D, k4D, m4D, i1D

    i1D = from_1D
    do m4D = from_4D(4), to_4D(4)
       do k4D = from_4D(3), to_4D(3)
          do j4D = from_4D(2), to_4D(2)
             do i4D = from_4D(1), to_4D(1)
                out1D(i1D) = out1D(i1D) + in4D(i4D, j4D, k4D, m4D)
                i1D = i1D + 1
             end do
          end do
       end do
    end do
    
    if ( i1D <= to_1D ) &
         call die("real: 4D+>1D failed")

  end subroutine aa_4d_1d_sp
  subroutine aa_4d_1d_dp(from_4D, to_4D, in4D, from_1D, to_1D, out1D)
    integer, intent(in) :: from_4D(4), to_4D(4)
    real(dp), intent(in) :: in4D(:,:,:,:)
    integer, intent(in) :: from_1D, to_1D
    real(dp), intent(inout) :: out1D(:)

    ! Local variables for copying
    integer :: i4D, j4D, k4D, m4D, i1D

    i1D = from_1D
    do m4D = from_4D(4), to_4D(4)
       do k4D = from_4D(3), to_4D(3)
          do j4D = from_4D(2), to_4D(2)
             do i4D = from_4D(1), to_4D(1)
                out1D(i1D) = out1D(i1D) + in4D(i4D, j4D, k4D, m4D)
                i1D = i1D + 1
             end do
          end do
       end do
    end do

    if ( i1D <= to_1D ) &
         call die("double: 4D+>1D failed")

  end subroutine aa_4d_1d_dp

end module gridxc_array
    

#if defined HAVE_CONFIG_H
#include "config.h"
#endif

!!@LICENSE
!
!******************************************************************************
! MODULE m_fft3d
! 3-D fast complex Fourier transform
! Written by J.M.Soler (Feb.2008).
!******************************************************************************
!
!   PUBLIC procedures available from this module:
! fft3d : 3-D complex FFT
!
!   PUBLIC parameters, types, and variables available from this module:
! none
!
!******************************************************************************
!
!   USED module procedures:
! use gridxc_sys,    only: die           ! Termination routine
! use gridxc_alloc,  only: de_alloc      ! De-allocation routine
! use gridxc_alloc,  only: re_alloc      ! Re-allocation routine
! use gridxc_fft_gpfa,  only: gpfa          ! 1-D fast Fourier transform
! use gridxc_fft_gpfa,  only: setgpfa=>setgpfa_check ! Initializes gpfa routine
! use gridxc_mesh3D, only: copyMeshData  ! Copies data in a box of mesh points
! use gridxc_mesh3D, only: fftMeshDistr  ! Sets a mesh distr. for FFTs
! use gridxc_mesh3D, only: myMeshBox     ! Returns the mesh box of my processor
! use gridxc_mesh3D, only: redistributeMeshData ! Changes data distribution
!
!   USED module parameters:
! use gridxc_precision,  only: dp              ! Real double precision type
! use gridxc_precision,  only: gp=>grid_p      ! Real precision type of mesh arrays
!
!   EXTERNAL procedures used:
! gpfa    : 1D complex FFT
! setgpfa : Initializes gpfa
!
!******************************************************************************
!
! SUBROUTINE fft3d( dat, meshDistr, nMesh, r2k )
!
! 3D complex FFT
!------------------------------ INPUT -----------------------------------------
! integer meshDistr : Mesh distribution ID of dat array
! integer nMesh(3)  : Mesh divisions of each cell axis
! integer r2k       : Direction of Fourier transform:
!                       r2k=+1 => r->k; r2k=-1 => k->r
!----------------------- INPUT and OUTPUT -------------------------------------
! real(gp) dat(:,:,:,:) : Complex data to be Fourier transformed:
!                           dat(:,:,:,1) = Real part
!                           dat(:,:,:,2) = Imaginary part
!                         The dat array must be declared target.
!----------------------------- UNITS ------------------------------------------
! Units of dat are arbitrary
!----------------------------- USAGE ------------------------------------------
! use gridxc_precision, only: gp=>grid_p
! use gridxc_mesh3D,    only: fftMeshDistr, myMeshBox, setMeshDistr
! use gridxc_fft3d,   only: fft3d
! integer:: myBox(2,3), myDistr, nMesh(3)
! real(gp),allocatable:: dat(:,:,:,:)
! ...Find nMesh
! call setMeshDistr( myDistr, nMesh )
!    Or, alternatively
! call fftMeshDistr( nMesh, myDistr )
! call myMeshBox( nMesh, myDistr, myBox )
! allocate( dat(myBox(1,1):myBox(2,1),   &
!               myBox(1,2):myBox(2,2),   &
!               myBox(1,3):myBox(2,3),2) )
! ...Find dat in myBox
! call fft3d( dat, myDistr, nMesh, +1 )
!---------------------------- BEHAVIOUR ---------------------------------------
! It stops with an error message in the following cases:
! - The dimension of dat array in indexes 1-3 is not enough to contain myBox 
!   in meshDistr
! - The dimension of dat in index 4 is different from 2
!--------------------------- ALGORITHMS ---------------------------------------
! 1) dat array is redistributed into kDistr, as returned by fftMeshDistr. 
! 2) dat array is redistributed again into axisDistr(1), as returned from 
!    fftMeshDistr. In this mesh distribution, each processor's box spans the
!    whole x axis (or, more properly, the whole first cell vector).
! 3) dat is Fourier transformed in the x axis
! 4) dat is redistributed again into kDistr
! 5) Steps 2-4 are repeated for the y and z axes.
! 6) dat is redistributed bak into the input meshDistr.
! In serial execution, none of these data redistributions really occur. 
!   Rather, pointers are used to point the 'redistributed' arrays to the
!   original ones.
!
!******************************************************************************

MODULE gridxc_fft3d

  ! Used module procedures
  use gridxc_sys,    only: die          ! Terminates execution
  use gridxc_alloc,  only: de_alloc     ! Deallocates arrays
  use gridxc_alloc,  only: re_alloc     ! (Re)allocates arrays
  use gridxc_fft_gpfa,  only: gpfa          ! 1-D fast Fourier transform
  use gridxc_fft_gpfa,  only: setgpfa=>setgpfa_check ! Initializes gpfa routine
  use gridxc_mesh3D, only: associateMeshTask ! Associates commun. tasks to distr.
  use gridxc_mesh3D, only: copyMeshData ! Copies a box of mesh data
  use gridxc_mesh3D, only: fftMeshDistr ! Sets mesh distributions for FFTs
  use gridxc_mesh3D, only: myMeshBox    ! Returns the mesh box of my node
  use gridxc_mesh3D, only: redistributeMeshData ! Changes data distribution

  ! To pass info to the external user
  use gridxc_sys,only: timer_start=>gridxc_timer_start  ! Start counting CPU time
  use gridxc_sys,only: timer_stop=>gridxc_timer_stop   ! Stop counting CPU time

  ! Used module parameters
  use gridxc_precision,    only: dp           ! Real double precision type
  use gridxc_precision,    only: gp=>grid_p   ! Real type of mesh array data
#ifdef DEBUG_XC
  use gridxc_debugXC,      only: udebug    ! File unit for debug output
#endif /* DEBUG_XC */

  implicit none

PUBLIC:: &
  fft3d   ! 3D complex FFT

PRIVATE ! Nothing is declared public beyond this point

CONTAINS

!******************************************************************************

subroutine fft3d( dat, meshDistr, nMesh, r2k )

  use iso_c_binding, only : c_loc, c_f_pointer
  
  implicit none

  ! Passed arguments
  real(gp),target,intent(inout):: dat(0:,0:,0:,:) ! Data to be Fourier 
                                 ! transformed (one complex function):
                                 !   dat(:,:,:,1) = Real part
                                 !   dat(:,:,:,2) = Imaginary part
  integer,intent(in):: meshDistr ! Mesh distribution ID of dat array
  integer,intent(in):: nMesh(3)  ! Mesh divisions of each cell axis
  integer,intent(in):: r2k       ! Direction of Fourier transform:
                                 ! r2k=+1 => r->k; r2k=-1 => k->r

  ! Internal parameters, variables, and arrays
  character(len=*),parameter:: myName = 'fft3d '
  character(len=*),parameter:: errHead = myName//'ERROR: '
  integer,save:: a2my(3)=-1, aDistr(3)=-1, io2my=-1, my2a(3)=-1, &
                 myDistr=-1, my2io=-1, oldMesh(3)=0
  logical:: finished, newMesh
  integer:: aBox(2,3), aMesh(3), datShape(4), i1, i2, i3, ia, iter, &
            maxTrigs, meshBox(2,3), myBox(2,3), nTrigs(3)
  real(dp),pointer,save:: trigs(:,:)=>null()
  real(gp),pointer:: myDat(:,:,:,:)=>null(), aDat(:,:,:,:)=>null()

  real(gp), pointer :: aux1(:), aux2(:)  ! For FFT calls
  
  ! Start time counter
  call timer_start( myName )

  ! Get my node's mesh box in input mesh distribution
  call myMeshBox( nMesh, meshDistr, meshBox )

  ! Check dat array shape
  datShape = shape(dat)
  if (any(datShape(1:3) < meshBox(2,:)-meshBox(1,:)+1)) &
    call die(errHead//'dat shape inconsistent with meshDistr')
  if (datShape(4)/=2) &
    call die(errHead//'incorrect shape of dat array')

  ! Check if this is a new mesh and store it for later calls
  newMesh = any(nMesh/=oldMesh)
  oldMesh = nMesh

  ! Set trigs array, used by 1D-FFT routine gpfa
  if (newMesh) then
    maxTrigs = 256
    do iter = 1,2
      call re_alloc( trigs, 1,maxTrigs, 1,3, myName//'trigs' )
      do ia=1,3  ! Loop on cell axes
        call setgpfa( trigs(:,ia), maxTrigs, nTrigs(ia), nMesh(ia) )
      end do ! ia
      if (all(nTrigs<=maxTrigs)) then
        finished = .true.
        exit ! iter loop
      else
        finished = .false.
        maxTrigs = maxval(nTrigs)
      end if
    end do ! iter
    if (.not.finished) &
      call die(errHead//'trigs iteration not converged')
  end if ! (newMesh)

  ! (Re)set FFT mesh distributions myDistr and aDistr.
  ! myDistr is a homogeneous 3D mesh distribution.
  ! aDistr(1:3) are three homogen. 2D distribs. In each one,
  ! all the node's mesh boxes span one of the whole cell axes
  if (newMesh) call fftMeshDistr( nMesh, myDistr, aDistr )

#ifdef DEBUG_XC
  ! Check that aDistr mesh boxes span whole cell axes
  if (newMesh) then
    do ia = 1,3
      call myMeshBox( nMesh, aDistr(ia), aBox )
      aMesh(:) = aBox(2,:) - aBox(1,:) + 1
      if (aMesh(ia)/=nMesh(ia)) call die(errHead//'incorrect aBox')
    end do ! ia
  end if ! (newMesh)
#endif /* DEBUG_XC */

  ! Associate communication tasks to distributions
  call associateMeshTask( io2my, meshDistr, myDistr )
  call associateMeshTask( my2io, meshDistr, myDistr )
  do ia = 1,3
    call associateMeshTask( my2a(ia), myDistr, aDistr(ia) )
    call associateMeshTask( a2my(ia), myDistr, aDistr(ia) )
  end do ! ia

  ! Redistribute data over myDistr
  ! Notice: if (meshDistr==myDistr) redistributeMeshData may
  ! just direct pointer myDat=>dat, without reallocating it
  call redistributeMeshData( meshDistr, dat, myDistr, &
                             dstData=myDat, task=io2my)

  ! FFT in first axis. Arguments of gpfa are:
  ! gpfa( realData(*), imagData(*), trigs(*),  
  !       dataSpan, vectorSpan, vectorSize, numVectors, fftDir )
  call myMeshBox( nMesh, aDistr(1), aBox )
  aMesh(:) = aBox(2,:) - aBox(1,:) + 1
  call redistributeMeshData( myDistr, myDat, aDistr(1), &
                             dstData=aDat, task=my2a(1) )

  call c_f_pointer(c_loc(aDat(:,:,:,1)),aux1,[aMesh(1)*aMesh(2)*aMesh(3)])
  call c_f_pointer(c_loc(aDat(:,:,:,2)),aux2,[aMesh(1)*aMesh(2)*aMesh(3)])

!  call gpfa( aDat(:,:,:,1), aDat(:,:,:,2), trigs(:,1), &
  call gpfa( aux1, aux2, trigs(:,1), &
             1, aMesh(1), aMesh(1), aMesh(2)*aMesh(3), -r2k )
  call redistributeMeshData( aDistr(1), aDat, myDistr, &
                             dstData=myDat, task=a2my(1) )
      
  ! FFT in second axis
  call myMeshBox( nMesh, aDistr(2), aBox )
  aMesh(:) = aBox(2,:) - aBox(1,:) + 1
  call redistributeMeshData( myDistr, myDat, aDistr(2), &
                             dstData=aDat, task=my2a(2) )
  do i3 = 0,aMesh(3)-1
     call c_f_pointer(c_loc(aDat(:,:,i3,1)),aux1,[aMesh(1)*aMesh(2)])
     call c_f_pointer(c_loc(aDat(:,:,i3,2)),aux2,[aMesh(1)*aMesh(2)])
!    call gpfa( aDat(:,:,i3,1), aDat(:,:,i3,2), trigs(:,2), &
    call gpfa( aux1, aux2, trigs(:,2), &
               aMesh(1), 1, aMesh(2), aMesh(1), -r2k )
  end do ! i3
  call redistributeMeshData( aDistr(2), aDat, myDistr, &
                             dstData=myDat, task=a2my(2) )
      
  ! FFT in third axis
  call myMeshBox( nMesh, aDistr(3), aBox )
  aMesh(:) = aBox(2,:) - aBox(1,:) + 1
  call redistributeMeshData( myDistr, myDat, aDistr(3), &
                             dstData=aDat, task=my2a(3) )
  call c_f_pointer(c_loc(aDat(:,:,:,1)),aux1,[aMesh(1)*aMesh(2)*aMesh(3)])
  call c_f_pointer(c_loc(aDat(:,:,:,2)),aux2,[aMesh(1)*aMesh(2)*aMesh(3)])

  !  call gpfa( aDat(:,:,:,1), aDat(:,:,:,2), trigs(:,3), &
  call gpfa( aux1, aux2, trigs(:,3), &
             aMesh(1)*aMesh(2), 1, aMesh(3), aMesh(1)*aMesh(2), -r2k )
  call redistributeMeshData( aDistr(3), aDat, myDistr, &
                             dstData=myDat, task=a2my(3) )
      
  ! Copy data to output distr. (unless myDat and dat are the same array)
  if (.not.associated(myDat,dat)) &
    call copyMeshData( nMesh, myDistr, myDat, meshBox, dat, my2io )

  ! Divide by number of points
  if (r2k>0) dat = dat / product(nMesh)

  ! Deallocate internal arrays (possibly allocated within redistributeMeshData)
  if (associated(aDat,myDat)) then
    nullify(aDat)
  else
    call de_alloc( aDat,  name='redistributeMeshData dstData' )
  end if
  if (associated(myDat,dat)) then
    nullify(myDat)
  else
    call de_alloc( myDat, name='redistributeMeshData dstData' )
  end if
        
  ! Stop time counter
  call timer_stop( myName )

end subroutine fft3d

END MODULE gridxc_fft3d

#if defined HAVE_CONFIG_H
#include "config.h"
#endif

!!@LICENSE
!
!     MODULE m_io
!
! Copyright Alberto Garcia, 1996, 1997, 1998
!
! This module implements an interface to the FORTRAN logical unit
! system. Based on code by Richard Maine.
!
! Alberto Garcia, December 30, 1996
! Rewritten as a single subroutine 
! with multiple entry points, March 7, 1998
! Now hybrid to comply with Siesta "die" interface.
! Converted to a module by J.M.Soler. Aug. 2009
! Convert to F90 by Nick R. Papior, Feb, 2018
!---------------------------------------------------------------
!
MODULE gridxc_io
  !
  !-----------------------------------------------------------------
  !
  !     Used module procedures
  !
  USE gridxc_sys, only: die   ! Termination routine

  implicit none
  !
  !-----------------------------------------------------------------
  !
  !     Public procedures provided by this module
  !
  PUBLIC :: io_seterr  ! Set standard error unit
  PUBLIC :: io_setout  ! Set standard output unit
  PUBLIC :: io_geterr  ! Get standard error unit
  PUBLIC :: io_getout  ! Get standard output unit
  PUBLIC :: io_assign  ! Get some available IO unit and reserve it
  PUBLIC :: io_reserve ! Reserve a specific IO unit
  PUBLIC :: io_close   ! Close and free a given IO unit
  PUBLIC :: io_status   ! Print all used IO units

  PRIVATE ! Nothing is declared public below this point
  !
  !----------------------------------------------------------------
  !
  !     Module variables
  !
  !     Logical unit management. Units 0 to min_lun-1 are "reserved",
  !     since most of the "typical" files (output, etc) use them.
  !
  !     Logical units min_lun to min_max are managed by this module.
  !
  integer, parameter:: min_lun = 10
  integer, parameter:: max_lun = 99
  integer, parameter:: nunits = max_lun-min_lun+1
  integer, save:: stdout = 6
  integer, save:: stderr = 0
  logical, save:: lun_is_free(min_lun:max_lun) = .true.
  !
  !-----------------------------------------------------------------
  !
  !     Internal and dummy variables
  !
  integer  :: i, iostat
  logical  :: used, named, opened
  character:: filename*50, form*11
  !
CONTAINS
  !
  !-----------------------------------------------------------------
  !
  !     Simple interfaces to modify standard units
  !
  subroutine io_seterr(unit)
    integer,intent(in):: unit
    stderr = unit
  end subroutine io_seterr
  !
  !-----------------------------------------------------------------
  !
  subroutine io_setout(unit)
    integer,intent(in):: unit
    stdout = unit
  end subroutine io_setout
  !
  !-----------------------------------------------------------------
  !
  subroutine io_geterr(unit)
    integer,intent(out):: unit
    unit = stderr
  end subroutine io_geterr
  !
  !-----------------------------------------------------------------
  !
  subroutine io_getout(unit)
    integer,intent(out):: unit
    unit = stdout
  end subroutine io_getout
  !
  !------------------------------------------------------------------     
  !
  !     Logical unit management
  !
  subroutine io_assign(lun)
    integer,intent(out):: lun
    !
    !     Looks for a free unit and assigns it to lun
    !
    do lun= min_lun, max_lun
      if (lun_is_free(lun)) then
        inquire(unit=lun, opened=used, iostat=iostat)
        if (iostat .ne. 0) used = .true.
        lun_is_free(lun) = .false.
        if (.not. used) return
      endif
    enddo
    call die('No luns available in io_assign')

  end subroutine io_assign
  !
  !------------------------------------------------------------------     
  !
  subroutine io_reserve(lun)
    integer,intent(in):: lun
    !
    !     Useful to specify that one needs to use a particular unit number
    !
    !     For example, assume some legacy code expects to work with unit 15:
    !
    !     call io_reserve(15)   ! this call at the beginning of the program
    !     ...
    !     open(15,....)
    !
    inquire(unit=lun, opened=used, iostat=iostat)
    if (iostat .ne. 0) used = .true.
    if (used) call die('Cannot reserve unit. Already connected')
    if (lun .ge. min_lun .and. lun .le. max_lun) &
        lun_is_free(lun) = .false.

  end subroutine io_reserve
  !
  !------------------------------------------------------------------     
  !
  subroutine io_close(lun)
    integer,intent(in):: lun
    !
    !     Use this routine instead of a simple close!!
    !
    close(lun)
    if (lun .ge. min_lun .and. lun .le. max_lun) &
        lun_is_free(lun) = .true.

  end subroutine io_close
  !
  !------------------------------------------------------------------     
  !
  subroutine io_status
    !
    !     Prints a list of the connected logical units and the names of
    !     the associated files
    !

    write(stdout,'(a)') '******** io_status ********'
    do i = 0, max_lun
      inquire(i,opened=opened,named=named,name=filename, &
          form=form,iostat=iostat)
      if (iostat .eq. 0) then
        if (opened) then
          if (named) then
            write(stdout,'(i4,5x,a,5x,a)') i, form, filename
          else
            write(stdout,'(i4,5x,a,5x,a)') i, form, 'No name available'
          endif
        endif
      else
        write(stdout,'(i4,5x,a,5x,a)') i, 'Iostat error'
      endif
    enddo
    write(stdout,'(a)') '********           ********'

  end subroutine io_status

END MODULE gridxc_io

PROGRAM siestaXCtest5

  ! Finds and writes the integrand of the nonlocal vdW functional
  ! for fixed kf2 and kg2=grad(n2)/n2 in a mesh of kf1, kg1, and r12. 
  ! J.M.Soler. Jul.2012

  ! Used module procedures
  USE gridxc, only: setXC => gridxc_setXC
  USE gridxc_vdwxc,  only: phiofr
  USE gridxc_vdwxc,  only: vdw_get_qmesh
  USE gridxc_vdwxc,  only: vdw_set_kcut
  USE gridxc_vdwxc,  only: vdw_theta
  USE gridxc_vv_vdwxc, only: vv_vdw_phi_val

  ! Used module parameters
  USE gridxc, only: dp
  USE gridxc, only: gp => grid_p

  implicit none

  ! Tester parameters
  integer, parameter:: nspin = 1      ! Number of spin components
  integer, parameter:: nfunc = 1      ! Number of functionals
  integer, parameter:: nr    = 6      ! Number of radial points
  real(dp),parameter:: r(nr) = (/0.1_dp, 1.0_dp, 2.0_dp, 5.0_dp, &
                                 10._dp, 20._dp/) ! |r1-r2| distances
  real(dp),parameter:: kcut  = 15._dp ! Planewave vector cutoff
  real(dp),parameter:: kf2   = 1.0_dp ! Fermi wavevector at point 2
  real(dp),parameter:: kg2   = 2.5_dp ! grad(n)/n at point 2
  real(dp),parameter:: kfmax = 5._dp  ! Max. Fermi wavevector at point 1
  real(dp),parameter:: kgmax = 5._dp  ! Max. grad(n)/n at point 1
  real(dp),parameter:: dkf   = 0.1_dp ! Fermi wavevector mesh interval
  real(dp),parameter:: dkg   = 0.1_dp ! grad(n)/n mesh interval
  character(len=*),parameter:: func = 'VDW'
  character(len=*),parameter:: auth = 'VV'  ! 'DRSLL'|'LMKLL'|'VV'
                                      ! KBM, C09, and BH use DRSLL kernel

  ! Tester variables and arrays
  integer :: ik, ikf, ikg, ir, nk, nkf, nkg
  real(dp):: kf1, kg1, gn1(3,nspin), gn2(3,nspin), n1(nspin), n2(nspin), &
             n1n2phi_exact, n1n2phi_interp, pi, r12, wc(nfunc), wx(nfunc)
  real(dp),allocatable:: &
             dtdn1(:,:), dtdn2(:,:), dtdgn1(:,:,:), dtdgn2(:,:,:), &
             n1phi(:), phi(:,:), theta1(:), theta2(:)

  ! Initialize XC functional
  wx = 1._dp/nfunc
  wc = 1._dp/nfunc
  call setXC( nfunc, func, auth, wx, wc )

  ! Set planewave cutoff
  call vdw_set_kcut( kcut )

  ! Find number of interpolation points and allocate interpolation arrays
  call vdw_get_qmesh( nk )
  allocate( dtdn1(nk,nspin), dtdn2(nk,nspin) )
  allocate( dtdgn1(3,nk,nspin), dtdgn2(3,nk,nspin) )
  allocate( n1phi(nk), phi(nk,nk), theta1(nk), theta2(nk) )

  ! Open file for output
  open(1,file='n1n2phi.table')

  ! Iterate on kf1, kg1, and r12
  nkf = nint(kfmax/dkf)
  nkg = nint(kgmax/dkg)
  do ir = 1,nr
    r12 = r(ir)
    call phiofr( r12, phi )
!    print'(a,/,(6f12.6))','phi(:,13)=',phi(:,13)
!    print'(a,/,(6f12.6))','phi(13,:)=',phi(13,:)
    do ikf = 0,nkf
      do ikg = 0,nkg
        kf1 = ikf*dkf
        kg1 = ikg*dkg
        kf1 = max(kf1,1.e-6)
        pi = acos(-1._dp)
        n1 = 0
        n2 = 0
        gn1 = 0
        gn2 = 0
        n1(1) = kf1**3/(3*pi**2)
        n2(1) = kf2**3/(3*pi**2)
        gn1(1,1) = n1(1)*kg1
        gn2(1,1) = n2(1)*kg2
        call vdw_theta( nspin, n1, gn1, theta1, dtdn1, dtdgn1 )
        call vdw_theta( nspin, n2, gn2, theta2, dtdn2, dtdgn2 )
!        if (ir==1 .and. ikf==0) then
!          print'(a,6f12.6)','r12,kf1,kg1=',r12,kf1,kg1
!          print'(a,/,(6f12.6))','theta1=',theta1
!        endif
        do ik = 1,nk
          n1phi(ik) = sum(theta1(:)*phi(:,ik))
        end do

        ! Assume phi_val returns phi, with which we want to compare
!        n1n2phi_interp = sum(n1phi*theta2)/n1(1)/n2(1)

        ! Assume phi_val returns sqrt(n1*n2)*phi
!        n1n2phi_interp = sum(n1phi*theta2) /sqrt(n1(1)*n2(1))

        ! Assume phi_val returns kf1*kf2*phi
!        n1n2phi_interp = sum(n1phi*theta2) *kf1*kf2/n1(1)/n2(1)

        ! Assume phi_val returns (kf1*kf2)**2*phi
        n1n2phi_interp = sum(n1phi*theta2) *(kf1*kf2)**2/n1(1)/n2(1)

        ! Assume phi_val returns n1*n2*phi
!        n1n2phi_interp = sum(n1phi*theta2)

        n1n2phi_exact = vv_vdw_phi_val( kf1, kf2, kg1, kg2, r12 )
        write(1,'(3f9.3,3e15.6)') r12, kf1, kg1, &
          n1n2phi_exact, n1n2phi_interp, n1n2phi_interp-n1n2phi_exact
      end do
    end do
  end do

  close(1)

END PROGRAM siestaXCtest5

#if defined HAVE_CONFIG_H
#include "config.h"
#endif

module ldaxc_basket

  use gridxc_precision, only: dp

  use fruit
  use gridxc_ldaxc

  implicit none

  ! Number of grid points
  integer, parameter, private :: npts = 45

  ! Grid extension: from -grid_max to grid_max
  real(dp), parameter, private :: grid_max = 6.0_dp

  ! Normal distribution width for spin up and down (must be < grid_max / 6)
  real(dp), parameter, private :: sigma(2) = (0.6_dp, 0.5_dp)

  ! Tolerance (square root of machine precision should be fine)
  real(dp), parameter, private :: ldaxc_tol = sqrt(epsilon(1.0_dp))

  ! Arrays to store the density values (rhov) and gradients (rhog)
  real(dp), allocatable, private :: rhog(:,:,:), rhov(:,:,:)

  ! Internal functions and subroutines
  private :: idx_to_pos

contains

  ! Translate array indices to coordinates between -grid_max and +grid_max
  function idx_to_pos(index, offset) result(pos)

    implicit none

    integer, intent(in) :: index
    real(dp),intent(in), optional :: offset
    real(dp) :: pos

    pos = ((2.0_dp * real(index, dp) - real(npts, dp) - 1.0_dp) * grid_max) / &
&         (real(npts, dp) - 1.0_dp)
    if ( present(offset) ) then
      pos = pos - offset
    end if

  end function idx_to_pos

  ! Initialize rhov as a pair of normal probability density functions
  ! for spin up and spin down and calculate its gradient rhog
  subroutine setup_ldaxc

    implicit none

    integer :: is, ix, iy, iz
    real(dp) :: a, b(2), r2

    allocate(rhog(npts, npts, npts, 2))
    allocate(rhov(npts, npts, npts, 2))

    ! Spin-polarized density (1=up, 2=down)
    do is=1,2

      ! Normal distribution prefactor: (sigma*sqrt(2*pi))^-1
      a = 1.0_dp / (sigma(is) * sqrt(8.0_dp * atan(1.0_dp))

      ! Distribution centers:
      !   - positive third of x grid for spin up (+2*grid_max/3)
      !   - negative third of x grid for spin down (-2*grid_max/3)
      b =  real(3 - 2*is, dp) * 2.0_dp * grid_max / 3.0_dp

      do iz=1,npts
        do iy=1,npts
          do ix=1,npts
            r2 = idx_to_pos(ix, b)**2 + &
&                idx_to_pos(iy)**2 + &
&                idx_to_pos(iz)**2
            rhov(ix,iy,iz,is) = a * exp(-0.5_dp * r2 / sigma(is)**2)
            rhog(ix,iy,iz,is) = -sqrt(r2) * rhov(ix,iy,iz) / sigma(is)
          end do
        end do
      end do

    end do

  end subroutine setup_ldaxc

  ! Free memory
  subroutine teardown_ldaxc

    deallocate(rhog)
    deallocate(rhov)

  end subroutine teardown_ldaxc

  subroutine test_ldaxc_exchng_irel0

    implicit none

  end subroutine test_ldaxc_exchng_irel0

  subroutine test_ldaxc_exchng_irel1

    implicit none

  end subroutine test_ldaxc_exchng_irel1

  subroutine test_ldaxc_exchng_nspin1

    implicit none

  end subroutine test_ldaxc_exchng_nspin1

  subroutine test_ldaxc_exchng_nspin2

    implicit none

  end subroutine test_ldaxc_exchng_nspin2

  subroutine test_ldaxc_pw92c_nspin1

    implicit none

  end subroutine test_ldaxc_pw92c_nspin1

  subroutine test_ldaxc_pw92c_nspin2

    implicit none

  end subroutine test_ldaxc_pw92c_nspin2

  subroutine test_ldaxc_pw92xc_irel0

    implicit none

  end subroutine test_ldaxc_pw92xc_irel0

  subroutine test_ldaxc_pw92xc_irel1

    implicit none

  end subroutine test_ldaxc_pw92xc_irel1

  subroutine test_ldaxc_pw92xc_nspin1

    implicit none

  end subroutine test_ldaxc_pw92xc_nspin1

  subroutine test_ldaxc_pw92xc_nspin2

    implicit none

  end subroutine test_ldaxc_pw92xc_nspin2

  subroutine test_ldaxc_pzxc_irel0

    implicit none

  end subroutine test_ldaxc_pzxc_irel0

  subroutine test_ldaxc_pzxc_irel1

    implicit none

  end subroutine test_ldaxc_pzxc_irel1

  subroutine test_ldaxc_pzxc_nspin1

    implicit none

  end subroutine test_ldaxc_pzxc_nspin1

  subroutine test_ldaxc_pzxc_nspin2

    implicit none

  end subroutine test_ldaxc_pzxc_nspin2

  subroutine test_ldaxc_main_nolibxc

    implicit none

  end subroutine test_ldaxc_main_nolibxc

#ifdef HAVE_LIBXC
  subroutine test_ldaxc_main_libxc

    implicit none

  end subroutine test_ldaxc_main_libxc
#endif

  subroutine fruit_basket

    implicit none

    call setup_ldaxc

    call test_ldaxc_exchng_irel0
    call test_ldaxc_exchng_irel1
    call test_ldaxc_exchng_nspin1
    call test_ldaxc_exchng_nspin2
    call test_ldaxc_pw92c_nspin1
    call test_ldaxc_pw92c_nspin2
    call test_ldaxc_pw92xc_irel0
    call test_ldaxc_pw92xc_irel1
    call test_ldaxc_pw92xc_nspin1
    call test_ldaxc_pw92xc_nspin2
    call test_ldaxc_pzxc_irel0
    call test_ldaxc_pzxc_irel1
    call test_ldaxc_pzxc_nspin1
    call test_ldaxc_pzxc_nspin2

    call test_ldaxc_main_nolibxc
#ifdef HAVE_LIBXC
    call test_ldaxc_main_libxc
#endif

    call teardown_ldaxc

  end subroutine fruit_basket

end module ldaxc_basket

#if defined HAVE_CONFIG_H
#include "config.h"
#endif

!!@LICENSE
!
! ==================================================================
! Allocation, reallocation, and deallocation utility routines
! for pointers
!
! Written by J.M.Soler. May 2000.
! Re-organized by A. Garcia, June 2015.
! ==================================================================
! SUBROUTINE alloc_default( old, new, restore, &
!                           copy, shrink, imin, routine )
!   Sets defaults for allocation
! INPUT (optional):
!   type(allocDefaults) restore : default settings to be restored
!   logical             copy    : Copy old array to new array?
!   logical             shrink  : Reduce array size?
!   integer             imin    : First index (typically 1 in Fortan,
!                                              0 in C)
!   character(len=*)    routine : Name of calling routine
! OUTPUT (optional):
!   type(allocDefaults) old     : default settings before the call
!   type(allocDefaults) new     : default settings after the call
! BEHAVIOR:
!   All these defaults can be superseeded by optional arguments in
!     each call to re_alloc.
!   Initial default values: copy    = .true.
!                           shrink  = .true.
!                           imin    = 1
!                           routine = 'unknown'
!   If restore is present together with any of copy, shrink, imin, or
!   routine, these are applied AFTER resetting the restore defaults.
! USAGE:
!   In order to restore the allocation defaults possibly set by the
! calling routine, the suggested construction is:
!   use gridxc_alloc_module
!   type(allocDefaults) oldDefaults
!   call alloc_default( old=oldDefaults, routine=..., &
!                       copy=..., shrink=... )
!   call re_alloc(...)
!   call alloc_default( restore=oldDefaults )
! Notice that, if the restore call is skipped, the new defaults will
! stay in effect until a new call to alloc_dafault is made.
! ==================================================================
! SUBROUTINE re_alloc( array, [i1min,] i1max,
!                      [[i2min,] i2max, [[i3min,] i3max]],
!                      name, routine, copy, shrink )
! INPUT:
!   integer       :: i1min        : Lower bound of first dimension
!                                   If not present, it is fixed by 
!                                   the last call to alloc_default.
!                                   If present and the rank is 2(3),
!                                   then i2min(&i3min) must also be
!                                   present
!   integer       :: i1max        : Upper bound of first dimension
!   integer       :: i2min,i2max  : Bounds of second dimension, if
!                                   applicable
!   integer       :: i3min,i3max  : Bounds of third dimension, if appl.
!
! INPUT (optional):
!   character*(*) :: name         : Actual array name or a label for it
!   character*(*) :: routine      : Name of the calling routine
!                                     or routine section
!   logical       :: copy         : Save (copy) contents of old array 
!                                   to new array?
!   logical       :: shrink       : Reallocate if the new array bounds 
!                                   are contained within the old ones? 
!                                   If not present, copy and/or shrink
!                                      are fixed by the last call to
!                                      alloc_default. 
! INPUT/OUTPUT:
!   TYPE, pointer :: array : Array to be allocated or reallocated.
!                            Implemented types and ranks are:
!                              integer,    rank 1, 2, 3
!                              integer*8,  rank 1
!                              real*4,     rank 1, 2, 3, 4
!                              real*8,     rank 1, 2, 3, 4
!                              complex*16, rank 1, 2
!                              logical,    rank 1, 2, 3
!                              character(len=*), rank 1
! BEHAVIOR:
!   Pointers MUST NOT enter in an undefined state. Before using them
! for the first time, they must be nullified explicitly. Alternatively,
! in f95, they can be initialized as null() upon declaration.
!   If argument array is not associated on input, it is just allocated.
!   If array is associated and has the same bounds (or smaller bonds
! and shrink is false) nothing is done. Thus, it is perfectly safe and
! efficient to call re_alloc repeatedly without deallocating the array.
! However, subroutine dealloc is provided to eliminate large arrays
! when they are not needed.
!   In order to save (copy) the contents of the old array, the new array
! needs to be allocated before deallocating the old one. Thus, if the
! contents are not needed, or if reducing memory is a must, calling
! re_alloc with copy=.false. makes it to deallocate before allocating.
!   The elements that are not copied (because copy=.false. or because
! they are outside the bounds of the input array) return with value
! zero (integer and real), .false. (logical), or blank (character).
!   If imin>imax for any dimension, the array pointer returns
! associated to a zero-size array.
!
!   Besides allocating or reallocating the array, re_alloc calls
! the external routine 'alloc_memory_event' with the number
! of bytes involved in the allocation and a string identifier
! built from the 'routine' and 'name' arguments: 'routine@name'.
! Clients of this module can process this information at will.
!
!   Error conditions are reported via a callback to the external
! routine 'alloc_error_report', with a string message and an
! integer code.
! Clients of this module can process this information at will.
!
! In future, an extra 'stat' argument might be included in the calls
! to re_alloc and de_alloc for finer control.
!
! ==================================================================---
! SUBROUTINE de_alloc( array, name, routine )
! INPUT (optional):
!   character*(*) :: name    : Actual array name or a label for it
!   character*(*) :: routine : Name of the calling routine
!                                or routine section
! INPUT/OUTPUT:
!   TYPE, pointer :: array : Array be deallocated (same types and
!                            kinds as in re_alloc).
! BEHAVIOR:
!   Besides deallocating the array, re_alloc decreases the count of
! memory usage previously counted by re_alloc. Thus, dealloc should 
! not be called to deallocate an array not allocated by re_alloc.
! Equally, arrays allocated or reallocated by re_alloc should be 
! deallocated by dealloc.
! ==================================================================---
MODULE gridxc_alloc
!
! This module has no external build dependencies
! Final executables must resolve the symbols for the two handlers
!   alloc_memory_event
!   alloc_error_report
! with interfaces specified below
!
  implicit none

PUBLIC ::             &
  alloc_default,      &! Sets allocation defaults
  re_alloc,           &! Allocation/reallocation
  de_alloc,           &! Deallocation
  allocDefaults        ! Derived type to hold allocation defaults

PRIVATE      ! Nothing is declared public beyond this point

integer, parameter :: sp = selected_real_kind(5,10)
integer, parameter :: dp = selected_real_kind(10,100)

! Interfaces to handlers that can be provided
! by the calling program
!
interface
   ! Error message and integer code
   ! If 'code' is 0, this is the last call in a series
   ! (see below for usage)
   subroutine alloc_error_report_interf(str,code)
     character(len=*), intent(in) :: str
     integer, intent(in)          :: code
   end subroutine alloc_error_report_interf
   !
   ! Logger for memory events
   !
   subroutine alloc_memory_event_interf(bytes,name)
     integer, intent(in)          :: bytes
     character(len=*), intent(in) :: name
   end subroutine alloc_memory_event_interf
end interface

! These initializations are possible in F2008 and onwards

procedure(alloc_error_report_interf), pointer ::  &
     alloc_error_report => dummy_alloc_error_report

procedure(alloc_memory_event_interf), pointer ::  &
     alloc_memory_event => dummy_alloc_memory_event

  interface de_alloc
    module procedure &
      dealloc_i1, dealloc_i2, dealloc_i3,             &
      dealloc_E1,                                     &
      dealloc_r1, dealloc_r2, dealloc_r3, dealloc_r4, &
      dealloc_d1, dealloc_d2, dealloc_d3, dealloc_d4, &
      dealloc_z1, dealloc_z2,                         &
      dealloc_l1, dealloc_l2, dealloc_l3,             &
      dealloc_s1
  end interface

  interface re_alloc
    module procedure &
      realloc_i1, realloc_i2, realloc_i3,             &
      realloc_E1,                                     &
      realloc_r1, realloc_r2, realloc_r3, realloc_r4, &
      realloc_d1, realloc_d2, realloc_d3, realloc_d4, &
      realloc_z1, realloc_z2,                         &
      realloc_l1, realloc_l2, realloc_l3,             &
      realloc_s1
!    module procedure & ! AG: Dangerous!!!
!      realloc_i1s, realloc_i2s, realloc_i3s,              &
!      realloc_r1s, realloc_r2s, realloc_r3s, realloc_r4s, &
!      realloc_d1s, realloc_d2s, realloc_d3s, realloc_d4s, &
!      realloc_l1s, realloc_l2s, realloc_l3s
  end interface

  ! Initial default values
  character(len=*), parameter :: &
    DEFAULT_NAME = 'unknown_name'         ! Array name default
  character(len=*), parameter :: &
    DEFAULT_ROUTINE = 'unknown_routine'   ! Routine name default

  ! Derived type to hold allocation default options
  type allocDefaults
    private
    logical ::          copy = .true.              ! Copy default
    logical ::          shrink = .true.            ! Shrink default
    integer ::          imin = 1                   ! Imin default
    character(len=32):: routine = DEFAULT_ROUTINE  ! Routine name default
  end type allocDefaults

  ! Object to hold present allocation default options
  type(allocDefaults), save :: DEFAULT

  ! Other common variables
  integer :: IERR
  logical :: ASSOCIATED_ARRAY, NEEDS_ALLOC, NEEDS_COPY, NEEDS_DEALLOC

  public :: set_alloc_event_handler
  public :: set_alloc_error_handler
  
CONTAINS

! ----------------
  subroutine set_alloc_event_handler(func)
    procedure(alloc_memory_event_interf) :: func
    alloc_memory_event => func
  end subroutine set_alloc_event_handler

  subroutine set_alloc_error_handler(func)
    procedure(alloc_error_report_interf) :: func
    alloc_error_report => func
  end subroutine set_alloc_error_handler

  subroutine dummy_alloc_memory_event(bytes,name)
    integer, intent(in) :: bytes
    character(len=*), intent(in) :: name
    !write(*,*) "gridxc alloc: allocated ", bytes, "bytes for "//trim(name)
  end subroutine dummy_alloc_memory_event

  subroutine dummy_alloc_error_report(name,code)
    character(len=*), intent(in) :: name
    integer, intent(in) :: code
    write(*,*) "gridxc: "//trim(name)
    if (code == 0) then
       STOP
    endif
  end subroutine dummy_alloc_error_report

! ==================================================================

SUBROUTINE alloc_default( old, new, restore,          &
                          routine, copy, shrink, imin )
implicit none
type(allocDefaults), optional, intent(out) :: old, new
type(allocDefaults), optional, intent(in)  :: restore
character(len=*),    optional, intent(in)  :: routine
logical,             optional, intent(in)  :: copy, shrink
integer,             optional, intent(in)  :: imin

if (present(old))     old = DEFAULT
if (present(restore)) DEFAULT = restore
if (present(copy))    DEFAULT%copy   = copy
if (present(shrink))  DEFAULT%shrink = shrink
if (present(imin))    DEFAULT%imin   = imin
if (present(routine)) DEFAULT%routine = routine
if (present(new))     new = DEFAULT

END SUBROUTINE alloc_default

! ==================================================================
! Integer array reallocs
! ==================================================================

SUBROUTINE realloc_i1( array, i1min, i1max, &
                       name, routine, copy, shrink )
! Arguments
implicit none
integer, dimension(:),      pointer    :: array
integer,                    intent(in) :: i1min
integer,                    intent(in) :: i1max
character(len=*), optional, intent(in) :: name
character(len=*), optional, intent(in) :: routine
logical,          optional, intent(in) :: copy
logical,          optional, intent(in) :: shrink

! Internal variables and arrays
character, parameter           :: type='I'
integer, parameter             :: rank=1
integer, dimension(:), pointer :: old_array
integer, dimension(2,rank)     :: b, c, new_bounds, old_bounds

! Get old array bounds
ASSOCIATED_ARRAY = associated(array)
if (ASSOCIATED_ARRAY) then
  old_array => array          ! Keep pointer to old array
  old_bounds(1,:) = lbound(old_array)
  old_bounds(2,:) = ubound(old_array)
end if

! Copy new requested array bounds
new_bounds(1,:) = (/ i1min /)
new_bounds(2,:) = (/ i1max /)

! Find if it is a new allocation or a true reallocation,
! and if the contents need to be copied (saved)
! Argument b returns common bounds
! Options routine also reads common variable ASSOCIATED_ARRAY,
! and it sets NEEDS_ALLOC, NEEDS_DEALLOC, and NEEDS_COPY
call options( b, c, old_bounds, new_bounds, copy, shrink )
! Deallocate old space
if (NEEDS_DEALLOC .and. .not.NEEDS_COPY) then
  call alloc_count( -size(old_array), type, name, routine )
  deallocate(old_array,stat=IERR)
end if

! Allocate new space
if (NEEDS_ALLOC) then
  allocate( array(b(1,1):b(2,1)), stat=IERR )
  call alloc_err( IERR, name, routine, new_bounds )
  call alloc_count( size(array), type, name, routine )
  array = 0
end if

! Copy contents and deallocate old space
if (NEEDS_COPY) then
  array(c(1,1):c(2,1)) = old_array(c(1,1):c(2,1))
  call alloc_count( -size(old_array), type, name, routine )
  deallocate(old_array,stat=IERR)
  call alloc_err( IERR, name, routine, old_bounds )
end if
END SUBROUTINE realloc_i1

! ==================================================================
SUBROUTINE realloc_i2( array, i1min,i1max, i2min,i2max,       &
                       name, routine, copy, shrink )
implicit none
character, parameter                   :: type='I'
integer, parameter                     :: rank=2
integer, dimension(:,:),    pointer    :: array, old_array
integer,                    intent(in) :: i1min, i1max, i2min, i2max
character(len=*), optional, intent(in) :: name, routine
logical,          optional, intent(in) :: copy, shrink
integer, dimension(2,rank)             :: b, c, new_bounds, old_bounds
ASSOCIATED_ARRAY = associated(array)
if (ASSOCIATED_ARRAY) then
  old_array => array
  old_bounds(1,:) = lbound(old_array)
  old_bounds(2,:) = ubound(old_array)
end if
new_bounds(1,:) = (/ i1min, i2min /)
new_bounds(2,:) = (/ i1max, i2max /)
call options( b, c, old_bounds, new_bounds, copy, shrink )
if (NEEDS_DEALLOC .and. .not.NEEDS_COPY) then
  call alloc_count( -size(old_array), type, name, routine ) 
  deallocate(old_array,stat=IERR)
  call alloc_err( IERR, name, routine, old_bounds )
end if
if (NEEDS_ALLOC) then
  allocate( array(b(1,1):b(2,1),b(1,2):b(2,2)), stat=IERR )
  call alloc_err( IERR, name, routine, new_bounds )
  call alloc_count( size(array), type, name, routine )
  array = 0
end if
if (NEEDS_COPY) then
      array(c(1,1):c(2,1),c(1,2):c(2,2)) =  &
  old_array(c(1,1):c(2,1),c(1,2):c(2,2))
  call alloc_count( -size(old_array), type, name, routine ) 
  deallocate(old_array,stat=IERR)
  call alloc_err( IERR, name, routine, old_bounds )
end if
END SUBROUTINE realloc_i2
! ==================================================================

SUBROUTINE realloc_i3( array, i1min,i1max, i2min,i2max, i3min,i3max, &
                       name, routine, copy, shrink )
implicit none
character, parameter                   :: type='I'
integer, parameter                     :: rank=3
integer, dimension(:,:,:),  pointer    :: array, old_array
integer,                    intent(in) :: i1min,i1max, i2min,i2max, &
                                          i3min,i3max
character(len=*), optional, intent(in) :: name, routine
logical,          optional, intent(in) :: copy, shrink
integer, dimension(2,rank)             :: b, c, new_bounds, old_bounds
ASSOCIATED_ARRAY = associated(array)
if (ASSOCIATED_ARRAY) then
  old_array => array 
  old_bounds(1,:) = lbound(old_array)
  old_bounds(2,:) = ubound(old_array)
end if
new_bounds(1,:) = (/ i1min, i2min, i3min /)
new_bounds(2,:) = (/ i1max, i2max, i3max /)
call options( b, c, old_bounds, new_bounds, copy, shrink )
if (NEEDS_DEALLOC .and. .not.NEEDS_COPY) then
  call alloc_count( -size(old_array), type, name, routine ) 
  deallocate(old_array,stat=IERR)
  call alloc_err( IERR, name, routine, old_bounds )
end if
if (NEEDS_ALLOC) then
  allocate( array(b(1,1):b(2,1),b(1,2):b(2,2),b(1,3):b(2,3)),stat=IERR)
  call alloc_err( IERR, name, routine, new_bounds )
  call alloc_count( size(array), type, name, routine )
  array = 0
end if
if (NEEDS_COPY) then
      array(c(1,1):c(2,1),c(1,2):c(2,2),c(1,3):c(2,3)) =  &
  old_array(c(1,1):c(2,1),c(1,2):c(2,2),c(1,3):c(2,3))
  call alloc_count( -size(old_array), type, name, routine ) 
  deallocate(old_array,stat=IERR)
  call alloc_err( IERR, name, routine, old_bounds )
end if
END SUBROUTINE realloc_i3
! ==================================================================
SUBROUTINE realloc_E1( array, i1min, i1max, &
                       name, routine, copy, shrink )
! Arguments
  implicit none
  integer, parameter :: i8b = selected_int_kind(18)
integer(i8b), dimension(:), pointer    :: array
integer,                    intent(in) :: i1min
integer,                    intent(in) :: i1max
character(len=*), optional, intent(in) :: name
character(len=*), optional, intent(in) :: routine
logical,          optional, intent(in) :: copy
logical,          optional, intent(in) :: shrink

! Internal variables and arrays
character, parameter                   :: type='I'
integer, parameter                     :: rank=1
integer(i8b), dimension(:), pointer    :: old_array
integer, dimension(2,rank)             :: b, c, new_bounds, old_bounds

! Get old array bounds
ASSOCIATED_ARRAY = associated(array)
if (ASSOCIATED_ARRAY) then
  old_array => array          ! Keep pointer to old array
  old_bounds(1,:) = lbound(old_array)
  old_bounds(2,:) = ubound(old_array)
end if

! Copy new requested array bounds
new_bounds(1,:) = (/ i1min /)
new_bounds(2,:) = (/ i1max /)

! Find if it is a new allocation or a true reallocation,
! and if the contents need to be copied (saved)
! Argument b returns common bounds
! Options routine also reads common variable ASSOCIATED_ARRAY,
! and it sets NEEDS_ALLOC, NEEDS_DEALLOC, and NEEDS_COPY
call options( b, c, old_bounds, new_bounds, copy, shrink )

! Deallocate old space
if (NEEDS_DEALLOC .and. .not.NEEDS_COPY) then
  call alloc_count( -size(old_array), type, name, routine ) 
  deallocate(old_array,stat=IERR)
  call alloc_err( IERR, name, routine, old_bounds )
end if

! Allocate new space
if (NEEDS_ALLOC) then
  allocate( array(b(1,1):b(2,1)), stat=IERR )
  call alloc_err( IERR, name, routine, new_bounds )
  call alloc_count( size(array), type, name, routine )
  array = 0
end if

! Copy contents and deallocate old space
if (NEEDS_COPY) then
  array(c(1,1):c(2,1)) = old_array(c(1,1):c(2,1))
  call alloc_count( -size(old_array), type, name, routine ) 
  deallocate(old_array,stat=IERR)
  call alloc_err( IERR, name, routine, old_bounds )
end if

END SUBROUTINE realloc_E1

! ==================================================================
! Single precision real array reallocs
! ==================================================================
SUBROUTINE realloc_r1( array, i1min, i1max,        &
                       name, routine, copy, shrink )
implicit none
character, parameter                   :: type='R'
integer, parameter                     :: rank=1
real(SP), dimension(:),     pointer    :: array, old_array
integer,                    intent(in) :: i1min, i1max
character(len=*), optional, intent(in) :: name, routine
logical,          optional, intent(in) :: copy, shrink
integer, dimension(2,rank)             :: b, c, new_bounds, old_bounds
ASSOCIATED_ARRAY = associated(array)
if (ASSOCIATED_ARRAY) then
  old_array => array 
  old_bounds(1,:) = lbound(old_array)
  old_bounds(2,:) = ubound(old_array)
end if
new_bounds(1,:) = (/ i1min /)
new_bounds(2,:) = (/ i1max /)
call options( b, c, old_bounds, new_bounds, copy, shrink )
if (NEEDS_DEALLOC .and. .not.NEEDS_COPY) then
  call alloc_count( -size(old_array), type, name, routine ) 
  deallocate(old_array,stat=IERR)
  call alloc_err( IERR, name, routine, old_bounds )
end if
if (NEEDS_ALLOC) then
  allocate( array(b(1,1):b(2,1)), stat=IERR )
  call alloc_err( IERR, name, routine, new_bounds )
  call alloc_count( size(array), type, name, routine )
  array = 0._sp
end if
if (NEEDS_COPY) then
  array(c(1,1):c(2,1)) = old_array(c(1,1):c(2,1))
  call alloc_count( -size(old_array), type, name, routine ) 
  deallocate(old_array,stat=IERR)
  call alloc_err( IERR, name, routine, old_bounds )
end if
END SUBROUTINE realloc_r1
! ==================================================================
SUBROUTINE realloc_r2( array, i1min,i1max, i2min,i2max, &
                       name, routine, copy, shrink )
implicit none
character, parameter             :: type='R'
integer, parameter               :: rank=2
real(SP), dimension(:,:),   pointer    :: array, old_array
integer,                    intent(in) :: i1min, i1max, i2min, i2max
character(len=*), optional, intent(in) :: name, routine
logical,          optional, intent(in) :: copy, shrink
integer, dimension(2,rank)             :: b, c, new_bounds, old_bounds
ASSOCIATED_ARRAY = associated(array)
if (ASSOCIATED_ARRAY) then
  old_array => array 
  old_bounds(1,:) = lbound(old_array)
  old_bounds(2,:) = ubound(old_array)
end if
new_bounds(1,:) = (/ i1min, i2min /)
new_bounds(2,:) = (/ i1max, i2max /)
call options( b, c, old_bounds, new_bounds, copy, shrink )
if (NEEDS_DEALLOC .and. .not.NEEDS_COPY) then
  call alloc_count( -size(old_array), type, name, routine ) 
  deallocate(old_array,stat=IERR)
  call alloc_err( IERR, name, routine, old_bounds )
end if
if (NEEDS_ALLOC) then
  allocate( array(b(1,1):b(2,1),b(1,2):b(2,2)), stat=IERR )
  call alloc_err( IERR, name, routine, new_bounds )
  call alloc_count( size(array), type, name, routine )
  array = 0._sp
end if
if (NEEDS_COPY) then
      array(c(1,1):c(2,1),c(1,2):c(2,2)) =  &
  old_array(c(1,1):c(2,1),c(1,2):c(2,2))
  call alloc_count( -size(old_array), type, name, routine ) 
  deallocate(old_array,stat=IERR)
  call alloc_err( IERR, name, routine, old_bounds )
end if
END SUBROUTINE realloc_r2
! ==================================================================
SUBROUTINE realloc_r3( array, i1min,i1max, i2min,i2max, i3min,i3max, &
                       name, routine, copy, shrink )
implicit none
character, parameter                   :: type='R'
integer, parameter                     :: rank=3
real(SP), dimension(:,:,:), pointer    :: array, old_array
integer,                    intent(in) :: i1min,i1max, i2min,i2max, &
                                          i3min,i3max
character(len=*), optional, intent(in) :: name, routine
logical,          optional, intent(in) :: copy, shrink
integer, dimension(2,rank)             :: b, c, new_bounds, old_bounds
ASSOCIATED_ARRAY = associated(array)
if (ASSOCIATED_ARRAY) then
  old_array => array          ! Keep pointer to old array
  old_bounds(1,:) = lbound(old_array)
  old_bounds(2,:) = ubound(old_array)
end if
new_bounds(1,:) = (/ i1min, i2min, i3min /)
new_bounds(2,:) = (/ i1max, i2max, i3max /)
call options( b, c, old_bounds, new_bounds, copy, shrink )
if (NEEDS_DEALLOC .and. .not.NEEDS_COPY) then
  call alloc_count( -size(old_array), type, name, routine ) 
  deallocate(old_array,stat=IERR)
  call alloc_err( IERR, name, routine, old_bounds )
end if
if (NEEDS_ALLOC) then
  allocate( array(b(1,1):b(2,1),b(1,2):b(2,2),b(1,3):b(2,3)),stat=IERR)
  call alloc_err( IERR, name, routine, new_bounds )
  call alloc_count( size(array), type, name, routine )
  array = 0._sp
end if
if (NEEDS_COPY) then
      array(c(1,1):c(2,1),c(1,2):c(2,2),c(1,3):c(2,3)) =  &
  old_array(c(1,1):c(2,1),c(1,2):c(2,2),c(1,3):c(2,3))
  call alloc_count( -size(old_array), type, name, routine ) 
  deallocate(old_array,stat=IERR)
  call alloc_err( IERR, name, routine, old_bounds )
end if
END SUBROUTINE realloc_r3
! ==================================================================
SUBROUTINE realloc_r4( array, i1min,i1max, i2min,i2max, &
                              i3min,i3max, i4min,i4max, &
                       name, routine, copy, shrink )
implicit none
character, parameter                   :: type='R'
integer, parameter                     :: rank=4
real(SP), dimension(:,:,:,:), pointer  :: array, old_array
integer,                    intent(in) :: i1min,i1max, i2min,i2max, &
                                          i3min,i3max, i4min,i4max
character(len=*), optional, intent(in) :: name, routine
logical,          optional, intent(in) :: copy, shrink
integer, dimension(2,rank)             :: b, c, new_bounds, old_bounds
ASSOCIATED_ARRAY = associated(array)
if (ASSOCIATED_ARRAY) then
  old_array => array 
  old_bounds(1,:) = lbound(old_array)
  old_bounds(2,:) = ubound(old_array)
end if
new_bounds(1,:) = (/ i1min, i2min, i3min, i4min /)
new_bounds(2,:) = (/ i1max, i2max, i3max, i4max /)
call options( b, c, old_bounds, new_bounds, copy, shrink )
if (NEEDS_DEALLOC .and. .not.NEEDS_COPY) then
  call alloc_count( -size(old_array), type, name, routine ) 
  deallocate(old_array,stat=IERR)
  call alloc_err( IERR, name, routine, old_bounds )
end if
if (NEEDS_ALLOC) then
  allocate( array(b(1,1):b(2,1),b(1,2):b(2,2), &
                 b(1,3):b(2,3),b(1,4):b(2,4)),stat=IERR)
  call alloc_err( IERR, name, routine, new_bounds )
  call alloc_count( size(array), type, name, routine )
  array = 0._sp
end if
if (NEEDS_COPY) then
      array(c(1,1):c(2,1),c(1,2):c(2,2),c(1,3):c(2,3),c(1,4):c(2,4))= &
  old_array(c(1,1):c(2,1),c(1,2):c(2,2),c(1,3):c(2,3),c(1,4):c(2,4))
  call alloc_count( -size(old_array), type, name, routine ) 
  deallocate(old_array,stat=IERR)
  call alloc_err( IERR, name, routine, old_bounds )
end if
END SUBROUTINE realloc_r4
! ==================================================================
! Double precision real array reallocs
! ==================================================================
SUBROUTINE realloc_d1( array, i1min, i1max,        &
                       name, routine, copy, shrink )
implicit none
character, parameter                   :: type='D'
integer, parameter                     :: rank=1
real(DP), dimension(:),     pointer    :: array, old_array
integer,                    intent(in) :: i1min, i1max
character(len=*), optional, intent(in) :: name, routine
logical,          optional, intent(in) :: copy, shrink
integer, dimension(2,rank)             :: b, c, new_bounds, old_bounds
ASSOCIATED_ARRAY = associated(array)
if (ASSOCIATED_ARRAY) then
  old_array => array
  old_bounds(1,:) = lbound(old_array)
  old_bounds(2,:) = ubound(old_array)
end if
new_bounds(1,:) = (/ i1min /)
new_bounds(2,:) = (/ i1max /)
call options( b, c, old_bounds, new_bounds, copy, shrink )
if (NEEDS_DEALLOC .and. .not.NEEDS_COPY) then
  call alloc_count( -size(old_array), type, name, routine ) 
  deallocate(old_array,stat=IERR)
  call alloc_err( IERR, name, routine, old_bounds )
end if
if (NEEDS_ALLOC) then
  allocate( array(b(1,1):b(2,1)), stat=IERR )
  call alloc_err( IERR, name, routine, new_bounds )
  call alloc_count( size(array), type, name, routine )
  array = 0._dp
end if
if (NEEDS_COPY) then
  array(c(1,1):c(2,1)) = old_array(c(1,1):c(2,1))
  call alloc_count( -size(old_array), type, name, routine ) 
  deallocate(old_array,stat=IERR)
  call alloc_err( IERR, name, routine, old_bounds )
end if
END SUBROUTINE realloc_d1
! ==================================================================
SUBROUTINE realloc_d2( array, i1min,i1max, i2min,i2max, &
                       name, routine, copy, shrink )
implicit none
character, parameter                   :: type='D'
integer, parameter                     :: rank=2
real(DP), dimension(:,:),   pointer    :: array, old_array
integer,                    intent(in) :: i1min, i1max, i2min, i2max
character(len=*), optional, intent(in) :: name, routine
logical,          optional, intent(in) :: copy, shrink
integer, dimension(2,rank)             :: b, c, new_bounds, old_bounds
integer                                :: i1, i2
ASSOCIATED_ARRAY = associated(array)
if (ASSOCIATED_ARRAY) then
  old_array => array 
  old_bounds(1,:) = lbound(old_array)
  old_bounds(2,:) = ubound(old_array)
end if
new_bounds(1,:) = (/ i1min, i2min /)
new_bounds(2,:) = (/ i1max, i2max /)
call options( b, c, old_bounds, new_bounds, copy, shrink )
if (NEEDS_DEALLOC .and. .not.NEEDS_COPY) then
  call alloc_count( -size(old_array), type, name, routine ) 
  deallocate(old_array,stat=IERR)
  call alloc_err( IERR, name, routine, old_bounds )
end if
if (NEEDS_ALLOC) then
  allocate( array(b(1,1):b(2,1),b(1,2):b(2,2)), stat=IERR )
  call alloc_err( IERR, name, routine, new_bounds )
  call alloc_count( size(array), type, name, routine )
  array = 0._dp
end if
if (NEEDS_COPY) then
!      array(c(1,1):c(2,1),c(1,2):c(2,2)) =  &
!  old_array(c(1,1):c(2,1),c(1,2):c(2,2))
  do i2 = c(1,2),c(2,2)
  do i1 = c(1,1),c(2,1)
    array(i1,i2) = old_array(i1,i2)
  end do
  end do
  call alloc_count( -size(old_array), type, name, routine ) 
  deallocate(old_array,stat=IERR)
  call alloc_err( IERR, name, routine, old_bounds )
end if
END SUBROUTINE realloc_d2
! ==================================================================
SUBROUTINE realloc_d3( array, i1min,i1max, i2min,i2max, i3min,i3max, &
                       name, routine, copy, shrink )
implicit none
character, parameter                   :: type='D'
integer, parameter                     :: rank=3
real(DP), dimension(:,:,:), pointer    :: array, old_array
integer,                    intent(in) :: i1min,i1max, i2min,i2max, &
                                          i3min,i3max
character(len=*), optional, intent(in) :: name, routine
logical,          optional, intent(in) :: copy, shrink
integer, dimension(2,rank)             :: b, c, new_bounds, old_bounds
integer                                :: i1, i2, i3
ASSOCIATED_ARRAY = associated(array)
if (ASSOCIATED_ARRAY) then
  old_array => array 
  old_bounds(1,:) = lbound(old_array)
  old_bounds(2,:) = ubound(old_array)
end if
new_bounds(1,:) = (/ i1min, i2min, i3min /)
new_bounds(2,:) = (/ i1max, i2max, i3max /)
call options( b, c, old_bounds, new_bounds, copy, shrink )
if (NEEDS_DEALLOC .and. .not.NEEDS_COPY) then
  call alloc_count( -size(old_array), type, name, routine ) 
  deallocate(old_array,stat=IERR)
  call alloc_err( IERR, name, routine, old_bounds )
end if
if (NEEDS_ALLOC) then
  allocate( array(b(1,1):b(2,1),b(1,2):b(2,2),b(1,3):b(2,3)),stat=IERR)
  call alloc_err( IERR, name, routine, new_bounds )
  call alloc_count( size(array), type, name, routine )
  array = 0._dp
end if
if (NEEDS_COPY) then
!      array(c(1,1):c(2,1),c(1,2):c(2,2),c(1,3):c(2,3)) =  &
!  old_array(c(1,1):c(2,1),c(1,2):c(2,2),c(1,3):c(2,3))
  do i3 = c(1,3),c(2,3)
  do i2 = c(1,2),c(2,2)
  do i1 = c(1,1),c(2,1)
    array(i1,i2,i3) = old_array(i1,i2,i3)
  end do
  end do
  end do
  call alloc_count( -size(old_array), type, name, routine ) 
  deallocate(old_array,stat=IERR)
  call alloc_err( IERR, name, routine, old_bounds )
end if
END SUBROUTINE realloc_d3
! ==================================================================
SUBROUTINE realloc_d4( array, i1min,i1max, i2min,i2max, &
                              i3min,i3max, i4min,i4max, &
                       name, routine, copy, shrink )
implicit none
character, parameter                   :: type='D'
integer, parameter                     :: rank=4
real(DP), dimension(:,:,:,:), pointer  :: array, old_array
integer,                    intent(in) :: i1min,i1max, i2min,i2max, &
                                          i3min,i3max, i4min,i4max
character(len=*), optional, intent(in) :: name, routine
logical,          optional, intent(in) :: copy, shrink
integer, dimension(2,rank)             :: b, c, new_bounds, old_bounds
ASSOCIATED_ARRAY = associated(array)
if (ASSOCIATED_ARRAY) then
  old_array => array 
  old_bounds(1,:) = lbound(old_array)
  old_bounds(2,:) = ubound(old_array)
end if
new_bounds(1,:) = (/ i1min, i2min, i3min, i4min /)
new_bounds(2,:) = (/ i1max, i2max, i3max, i4max /)
call options( b, c, old_bounds, new_bounds, copy, shrink )
if (NEEDS_DEALLOC .and. .not.NEEDS_COPY) then
  call alloc_count( -size(old_array), type, name, routine ) 
  deallocate(old_array,stat=IERR)
  call alloc_err( IERR, name, routine, old_bounds )
end if
if (NEEDS_ALLOC) then
  allocate( array(b(1,1):b(2,1),b(1,2):b(2,2), &
                 b(1,3):b(2,3),b(1,4):b(2,4)),stat=IERR)
  call alloc_err( IERR, name, routine, new_bounds )
  call alloc_count( size(array), type, name, routine )
  array = 0._dp
end if
if (NEEDS_COPY) then
      array(c(1,1):c(2,1),c(1,2):c(2,2),c(1,3):c(2,3),c(1,4):c(2,4))= &
  old_array(c(1,1):c(2,1),c(1,2):c(2,2),c(1,3):c(2,3),c(1,4):c(2,4))
  call alloc_count( -size(old_array), type, name, routine ) 
  deallocate(old_array,stat=IERR)
  call alloc_err( IERR, name, routine, old_bounds )
end if
END SUBROUTINE realloc_d4
! ==================================================================
! Double precision complex array reallocs
! ==================================================================
SUBROUTINE realloc_z1( array, i1min, i1max,        &
                       name, routine, copy, shrink )
implicit none
character, parameter                   :: type='D'
integer, parameter                     :: rank=1
complex(DP), dimension(:),  pointer    :: array, old_array
integer,                    intent(in) :: i1min, i1max
character(len=*), optional, intent(in) :: name, routine
logical,          optional, intent(in) :: copy, shrink
integer, dimension(2,rank)             :: b, c, new_bounds, old_bounds
ASSOCIATED_ARRAY = associated(array)
if (ASSOCIATED_ARRAY) then
  old_array => array
  old_bounds(1,:) = lbound(old_array)
  old_bounds(2,:) = ubound(old_array)
end if
new_bounds(1,:) = (/ i1min /)
new_bounds(2,:) = (/ i1max /)
call options( b, c, old_bounds, new_bounds, copy, shrink )
if (NEEDS_DEALLOC .and. .not.NEEDS_COPY) then
  call alloc_count( -2*size(old_array), type, name, routine ) 
  deallocate(old_array,stat=IERR)
  call alloc_err( IERR, name, routine, old_bounds )
end if
if (NEEDS_ALLOC) then
  allocate( array(b(1,1):b(2,1)), stat=IERR )
  call alloc_err( IERR, name, routine, new_bounds )
  call alloc_count( 2*size(array), type, name, routine )
  array = 0._dp
end if
if (NEEDS_COPY) then
  array(c(1,1):c(2,1)) = old_array(c(1,1):c(2,1))
  call alloc_count( -2*size(old_array), type, name, routine ) 
  deallocate(old_array,stat=IERR)
  call alloc_err( IERR, name, routine, old_bounds )
end if
END SUBROUTINE realloc_z1
! ==================================================================
SUBROUTINE realloc_z2( array, i1min,i1max, i2min,i2max, &
                       name, routine, copy, shrink )
implicit none
character, parameter                   :: type='D'
integer, parameter                     :: rank=2
complex(DP), dimension(:,:),  pointer  :: array, old_array
integer,                    intent(in) :: i1min, i1max, i2min, i2max
character(len=*), optional, intent(in) :: name, routine
logical,          optional, intent(in) :: copy, shrink
integer, dimension(2,rank)             :: b, c, new_bounds, old_bounds
integer                                :: i1, i2
ASSOCIATED_ARRAY = associated(array)
if (ASSOCIATED_ARRAY) then
  old_array => array 
  old_bounds(1,:) = lbound(old_array)
  old_bounds(2,:) = ubound(old_array)
end if
new_bounds(1,:) = (/ i1min, i2min /)
new_bounds(2,:) = (/ i1max, i2max /)
call options( b, c, old_bounds, new_bounds, copy, shrink )
if (NEEDS_DEALLOC .and. .not.NEEDS_COPY) then
  call alloc_count( -2*size(old_array), type, name, routine ) 
  deallocate(old_array,stat=IERR)
  call alloc_err( IERR, name, routine, old_bounds )
end if
if (NEEDS_ALLOC) then
  allocate( array(b(1,1):b(2,1),b(1,2):b(2,2)), stat=IERR )
  call alloc_err( IERR, name, routine, new_bounds )
  call alloc_count( 2*size(array), type, name, routine )
  array = 0._dp
end if
if (NEEDS_COPY) then
!      array(c(1,1):c(2,1),c(1,2):c(2,2)) =  &
!  old_array(c(1,1):c(2,1),c(1,2):c(2,2))
  do i2 = c(1,2),c(2,2)
  do i1 = c(1,1),c(2,1)
    array(i1,i2) = old_array(i1,i2)
  end do
  end do
  call alloc_count( -2*size(old_array), type, name, routine ) 
  deallocate(old_array,stat=IERR)
  call alloc_err( IERR, name, routine, old_bounds )
end if
END SUBROUTINE realloc_z2
! ==================================================================
! Logical array reallocs
! ==================================================================
SUBROUTINE realloc_l1( array, i1min,i1max,  &
                       name, routine, copy, shrink )
implicit none
character, parameter                   :: type='L'
integer, parameter                     :: rank=1
logical, dimension(:),      pointer    :: array, old_array
integer,                    intent(in) :: i1min,i1max
character(len=*), optional, intent(in) :: name, routine
logical,          optional, intent(in) :: copy, shrink
integer, dimension(2,rank)             :: b, c, new_bounds, old_bounds
ASSOCIATED_ARRAY = associated(array)
if (ASSOCIATED_ARRAY) then
  old_array => array 
  old_bounds(1,:) = lbound(old_array)
  old_bounds(2,:) = ubound(old_array)
end if
new_bounds(1,:) = (/ i1min /)
new_bounds(2,:) = (/ i1max /)
call options( b, c, old_bounds, new_bounds, copy, shrink )
if (NEEDS_DEALLOC .and. .not.NEEDS_COPY) then
  call alloc_count( -size(old_array), type, name, routine ) 
  deallocate(old_array,stat=IERR)
  call alloc_err( IERR, name, routine, old_bounds )
end if
if (NEEDS_ALLOC) then
  allocate( array(b(1,1):b(2,1)), stat=IERR )
  call alloc_err( IERR, name, routine, new_bounds )
  call alloc_count( size(array), type, name, routine )
  array = .false.
end if
if (NEEDS_COPY) then
  array(c(1,1):c(2,1)) = old_array(c(1,1):c(2,1))
  call alloc_count( -size(old_array), type, name, routine ) 
  deallocate(old_array,stat=IERR)
  call alloc_err( IERR, name, routine, old_bounds )
end if
END SUBROUTINE realloc_l1
! ==================================================================
SUBROUTINE realloc_l2( array, i1min,i1max, i2min,i2max, &
                       name, routine, copy, shrink )
implicit none
character, parameter                   :: type='L'
integer, parameter                     :: rank=2
logical, dimension(:,:),    pointer    :: array, old_array
integer,                    intent(in) :: i1min,i1max, i2min,i2max
character(len=*), optional, intent(in) :: name, routine
logical,          optional, intent(in) :: copy, shrink
integer, dimension(2,rank)             :: b, c, new_bounds, old_bounds
ASSOCIATED_ARRAY = associated(array)
if (ASSOCIATED_ARRAY) then
  old_array => array 
  old_bounds(1,:) = lbound(old_array)
  old_bounds(2,:) = ubound(old_array)
end if
new_bounds(1,:) = (/ i1min, i2min /)
new_bounds(2,:) = (/ i1max, i2max /)
call options( b, c, old_bounds, new_bounds, copy, shrink )
if (NEEDS_DEALLOC .and. .not.NEEDS_COPY) then
  call alloc_count( -size(old_array), type, name, routine ) 
  deallocate(old_array,stat=IERR)
  call alloc_err( IERR, name, routine, old_bounds )
end if
if (NEEDS_ALLOC) then
  allocate( array(b(1,1):b(2,1),b(1,2):b(2,2)), stat=IERR )
  call alloc_err( IERR, name, routine, new_bounds )
  call alloc_count( size(array), type, name, routine )
  array = .false.
end if
if (NEEDS_COPY) then
      array(c(1,1):c(2,1),c(1,2):c(2,2)) = &
  old_array(c(1,1):c(2,1),c(1,2):c(2,2))
  call alloc_count( -size(old_array), type, name, routine ) 
  deallocate(old_array,stat=IERR)
  call alloc_err( IERR, name, routine, old_bounds )
end if
END SUBROUTINE realloc_l2
! ==================================================================
SUBROUTINE realloc_l3( array, i1min,i1max, i2min,i2max, i3min,i3max, &
                       name, routine, copy, shrink )
implicit none
character, parameter                   :: type='L'
integer, parameter                     :: rank=3
logical, dimension(:,:,:),  pointer    :: array, old_array
integer,                    intent(in) :: i1min,i1max, i2min,i2max, &
                                          i3min,i3max
character(len=*), optional, intent(in) :: name, routine
logical,          optional, intent(in) :: copy, shrink
integer, dimension(2,rank)             :: b, c, new_bounds, old_bounds
ASSOCIATED_ARRAY = associated(array)
if (ASSOCIATED_ARRAY) then
  old_array => array 
  old_bounds(1,:) = lbound(old_array)
  old_bounds(2,:) = ubound(old_array)
end if
new_bounds(1,:) = (/ i1min, i2min, i3min /)
new_bounds(2,:) = (/ i1max, i2max, i3max /)
call options( b, c, old_bounds, new_bounds, copy, shrink )
if (NEEDS_DEALLOC .and. .not.NEEDS_COPY) then
  call alloc_count( -size(old_array), type, name, routine ) 
  deallocate(old_array,stat=IERR)
  call alloc_err( IERR, name, routine, old_bounds )
end if
if (NEEDS_ALLOC) then
  allocate( array(b(1,1):b(2,1),b(1,2):b(2,2),b(1,3):b(2,3)),stat=IERR)
  call alloc_err( IERR, name, routine, new_bounds )
  call alloc_count( size(array), type, name, routine )
  array = .false.
end if
if (NEEDS_COPY) then
      array(c(1,1):c(2,1),c(1,2):c(2,2),c(1,3):c(2,3)) = &
  old_array(c(1,1):c(2,1),c(1,2):c(2,2),c(1,3):c(2,3))
  call alloc_count( -size(old_array), type, name, routine ) 
  deallocate(old_array,stat=IERR)
  call alloc_err( IERR, name, routine, old_bounds )
end if
END SUBROUTINE realloc_l3
! ==================================================================
! Realloc routines with assumed lower bound = 1
!AG: Extremely dangerous -- do not use.
! ==================================================================
SUBROUTINE realloc_i1s( array, i1max, &
                        name, routine, copy, shrink )
! Arguments
implicit none
integer, dimension(:),      pointer    :: array
integer,                    intent(in) :: i1max
character(len=*), optional, intent(in) :: name
character(len=*), optional, intent(in) :: routine
logical,          optional, intent(in) :: copy
logical,          optional, intent(in) :: shrink

call realloc_i1( array, DEFAULT%imin, i1max, &
                 name, routine, copy, shrink )

END SUBROUTINE realloc_i1s
! ==================================================================
SUBROUTINE realloc_i2s( array, i1max, i2max,  &
                        name, routine, copy, shrink )
implicit none
integer, dimension(:,:),    pointer    :: array
integer,                    intent(in) :: i1max, i2max
character(len=*), optional, intent(in) :: name, routine
logical,          optional, intent(in) :: copy, shrink
call realloc_i2( array, DEFAULT%imin, i1max, DEFAULT%imin, i2max, &
                 name, routine, copy, shrink )
END SUBROUTINE realloc_i2s
! ==================================================================
SUBROUTINE realloc_i3s( array, i1max, i2max, i3max,  &
                        name, routine, copy, shrink )
implicit none
integer, dimension(:,:,:),  pointer    :: array
integer,                    intent(in) :: i1max, i2max, i3max
character(len=*), optional, intent(in) :: name, routine
logical,          optional, intent(in) :: copy, shrink
call realloc_i3( array, DEFAULT%imin, i1max, DEFAULT%imin, i2max, &
                 DEFAULT%imin, i3max,                             &
                 name, routine, copy, shrink )
END SUBROUTINE realloc_i3s
! ==================================================================
SUBROUTINE realloc_r1s( array, i1max, &
                        name, routine, copy, shrink )
implicit none
real(SP), dimension(:),     pointer    :: array
integer,                    intent(in) :: i1max
character(len=*), optional, intent(in) :: name, routine
logical,          optional, intent(in) :: copy, shrink
call realloc_r1( array, DEFAULT%imin, i1max, &
                 name, routine, copy, shrink )
END SUBROUTINE realloc_r1s
! ==================================================================
SUBROUTINE realloc_r2s( array, i1max, i2max, &
                        name, routine, copy, shrink )
implicit none
real(SP), dimension(:,:),   pointer    :: array
integer,                    intent(in) :: i1max, i2max
character(len=*), optional, intent(in) :: name, routine
logical,          optional, intent(in) :: copy, shrink
call realloc_r2( array, DEFAULT%imin, i1max, DEFAULT%imin, i2max, &
                 name, routine, copy, shrink )
END SUBROUTINE realloc_r2s
! ==================================================================
SUBROUTINE realloc_r3s( array, i1max, i2max, i3max, &
                        name, routine, copy, shrink )
implicit none
real(SP), dimension(:,:,:), pointer    :: array
integer,                    intent(in) :: i1max, i2max, i3max
character(len=*), optional, intent(in) :: name, routine
logical,          optional, intent(in) :: copy, shrink
call realloc_r3( array, DEFAULT%imin, i1max, DEFAULT%imin, i2max, &
                 DEFAULT%imin, i3max,                             &
                 name, routine, copy, shrink )
END SUBROUTINE realloc_r3s
! ==================================================================
SUBROUTINE realloc_r4s( array, i1max, i2max, i3max, i4max, &
                        name, routine, copy, shrink )
implicit none
real(SP), dimension(:,:,:,:), pointer  :: array
integer,                    intent(in) :: i1max, i2max, i3max, i4max
character(len=*), optional, intent(in) :: name, routine
logical,          optional, intent(in) :: copy, shrink
call realloc_r4( array, DEFAULT%imin, i1max, DEFAULT%imin, i2max, &
                        DEFAULT%imin, i3max, DEFAULT%imin, i4max, &
                 name, routine, copy, shrink )
END SUBROUTINE realloc_r4s
! ==================================================================
SUBROUTINE realloc_d1s( array, i1max, &
                        name, routine, copy, shrink )
implicit none
real(DP), dimension(:),     pointer    :: array
integer,                    intent(in) :: i1max
character(len=*), optional, intent(in) :: name, routine
logical,          optional, intent(in) :: copy, shrink
call realloc_d1( array, DEFAULT%imin, i1max, &
                 name, routine, copy, shrink )
END SUBROUTINE realloc_d1s
! ==================================================================
SUBROUTINE realloc_d2s( array, i1max, i2max, &
                        name, routine, copy, shrink )
implicit none
real(DP), dimension(:,:),   pointer    :: array
integer,                    intent(in) :: i1max, i2max
character(len=*), optional, intent(in) :: name, routine
logical,          optional, intent(in) :: copy, shrink
call realloc_d2( array, DEFAULT%imin, i1max, DEFAULT%imin, i2max, &
                 name, routine, copy, shrink )
END SUBROUTINE realloc_d2s
! ==================================================================
SUBROUTINE realloc_d3s( array, i1max, i2max, i3max, &
                        name, routine, copy, shrink )
implicit none
real(DP), dimension(:,:,:), pointer    :: array
integer,                    intent(in) :: i1max, i2max, i3max
character(len=*), optional, intent(in) :: name, routine
logical,          optional, intent(in) :: copy, shrink
call realloc_d3( array, DEFAULT%imin, i1max, DEFAULT%imin, i2max, &
                 DEFAULT%imin, i3max,                             &
                 name, routine, copy, shrink )
END SUBROUTINE realloc_d3s
! ==================================================================
SUBROUTINE realloc_d4s( array, i1max, i2max, i3max, i4max, &
                        name, routine, copy, shrink )
implicit none
real(DP), dimension(:,:,:,:), pointer  :: array
integer,                    intent(in) :: i1max, i2max, i3max, i4max
character(len=*), optional, intent(in) :: name, routine
logical,          optional, intent(in) :: copy, shrink
call realloc_d4( array, DEFAULT%imin, i1max, DEFAULT%imin, i2max, &
                        DEFAULT%imin, i3max, DEFAULT%imin, i4max, &
                 name, routine, copy, shrink )
END SUBROUTINE realloc_d4s
! ==================================================================
SUBROUTINE realloc_l1s( array, i1max, &
                        name, routine, copy, shrink )
implicit none
logical, dimension(:),      pointer    :: array
integer,                    intent(in) :: i1max
character(len=*), optional, intent(in) :: name
character(len=*), optional, intent(in) :: routine
logical,          optional, intent(in) :: copy
logical,          optional, intent(in) :: shrink
call realloc_l1( array, DEFAULT%imin, i1max, &
                 name, routine, copy, shrink )
END SUBROUTINE realloc_l1s
! ==================================================================
SUBROUTINE realloc_l2s( array, i1max, i2max, &
                        name, routine, copy, shrink )
implicit none
logical, dimension(:,:),    pointer    :: array
integer,                    intent(in) :: i1max, i2max
character(len=*), optional, intent(in) :: name
character(len=*), optional, intent(in) :: routine
logical,          optional, intent(in) :: copy
logical,          optional, intent(in) :: shrink
call realloc_l2( array, DEFAULT%imin, i1max, DEFAULT%imin, i2max, &
                 name, routine, copy, shrink )
END SUBROUTINE realloc_l2s
! ==================================================================
SUBROUTINE realloc_l3s( array, i1max, i2max, i3max, &
                        name, routine, copy, shrink )
implicit none
logical, dimension(:,:,:),  pointer    :: array
integer,                    intent(in) :: i1max, i2max, i3max
character(len=*), optional, intent(in) :: name
character(len=*), optional, intent(in) :: routine
logical,          optional, intent(in) :: copy
logical,          optional, intent(in) :: shrink
call realloc_l3( array, DEFAULT%imin, i1max, DEFAULT%imin, i2max, &
                 DEFAULT%imin, i3max, name, routine, copy, shrink )
END SUBROUTINE realloc_l3s
! ==================================================================
! Character vector realloc
! ==================================================================
SUBROUTINE realloc_s1( array, i1min, i1max, &
                       name, routine, copy, shrink )
! Arguments
implicit none
character(len=*), dimension(:),      pointer    :: array
integer,                    intent(in) :: i1min
integer,                    intent(in) :: i1max
character(len=*), optional, intent(in) :: name
character(len=*), optional, intent(in) :: routine
logical,          optional, intent(in) :: copy
logical,          optional, intent(in) :: shrink

! Internal variables and arrays
character, parameter           :: type='S'
integer, parameter             :: rank=1
character(len=len(array)), dimension(:), pointer :: old_array
integer, dimension(2,rank)     :: b, c, new_bounds, old_bounds

! Get old array bounds
ASSOCIATED_ARRAY = associated(array)
if (ASSOCIATED_ARRAY) then
  old_array => array          ! Keep pointer to old array
  old_bounds(1,:) = lbound(old_array)
  old_bounds(2,:) = ubound(old_array)
end if

! Copy new requested array bounds
new_bounds(1,:) = (/ i1min /)
new_bounds(2,:) = (/ i1max /)

! Find if it is a new allocation or a true reallocation,
! and if the contents need to be copied (saved)
! Argument b returns common bounds
! Options routine also reads common variable ASSOCIATED_ARRAY,
! and it sets NEEDS_ALLOC, NEEDS_DEALLOC, and NEEDS_COPY
call options( b, c, old_bounds, new_bounds, copy, shrink )

! Deallocate old space
if (NEEDS_DEALLOC .and. .not.NEEDS_COPY) then
  call alloc_count( -size(old_array)*len(old_array), type, name, routine ) 
  deallocate(old_array,stat=IERR)
  call alloc_err( IERR, name, routine, old_bounds )
end if

! Allocate new space
if (NEEDS_ALLOC) then
  allocate( array(b(1,1):b(2,1)), stat=IERR )
  call alloc_err( IERR, name, routine, new_bounds )
  call alloc_count( size(array)*len(array), type, name, routine )
  array = ''
end if

! Copy contents and deallocate old space
if (NEEDS_COPY) then
  array(c(1,1):c(2,1)) = old_array(c(1,1):c(2,1))
  call alloc_count( -size(old_array)*len(old_array), type, name, routine ) 
  deallocate(old_array,stat=IERR)
  call alloc_err( IERR, name, routine, old_bounds )
end if

END SUBROUTINE realloc_s1
! ==================================================================
! Dealloc routines
! ==================================================================
SUBROUTINE dealloc_i1( array, name, routine )

! Arguments
implicit none
integer, dimension(:),      pointer    :: array
character(len=*), optional, intent(in) :: name
character(len=*), optional, intent(in) :: routine

if (associated(array)) then
  call alloc_count( -size(array), 'I', name, routine )
  deallocate(array,stat=IERR)
  call alloc_err( IERR, name, routine )
end if

END SUBROUTINE dealloc_i1

! ==================================================================
SUBROUTINE dealloc_i2( array, name, routine )
implicit none
integer, dimension(:,:),    pointer    :: array
character(len=*), optional, intent(in) :: name, routine
if (associated(array)) then
  call alloc_count( -size(array), 'I', name, routine ) 
  deallocate(array,stat=IERR)
  call alloc_err( IERR, name, routine )

end if
END SUBROUTINE dealloc_i2
! ==================================================================
SUBROUTINE dealloc_i3( array, name, routine )
implicit none
integer, dimension(:,:,:),  pointer    :: array
character(len=*), optional, intent(in) :: name, routine
if (associated(array)) then
  call alloc_count( -size(array), 'I', name, routine ) 
  deallocate(array,stat=IERR)
  call alloc_err( IERR, name, routine )

end if
END SUBROUTINE dealloc_i3
! ==================================================================
SUBROUTINE dealloc_E1( array, name, routine )

! Arguments
implicit none
integer, parameter :: i8b = selected_int_kind(18)
integer(i8b), dimension(:),      pointer    :: array
character(len=*), optional, intent(in) :: name
character(len=*), optional, intent(in) :: routine

if (associated(array)) then
  call alloc_count( -size(array), 'I', name, routine ) 
  deallocate(array,stat=IERR)
  call alloc_err( IERR, name, routine )

end if

END SUBROUTINE dealloc_E1

! ==================================================================
SUBROUTINE dealloc_r1( array, name, routine )
implicit none
real(SP), dimension(:),     pointer    :: array
character(len=*), optional, intent(in) :: name, routine
if (associated(array)) then
  call alloc_count( -size(array), 'R', name, routine ) 
  deallocate(array,stat=IERR)
  call alloc_err( IERR, name, routine )
end if
END SUBROUTINE dealloc_r1
! ==================================================================
SUBROUTINE dealloc_r2( array, name, routine )
implicit none
real(SP), dimension(:,:),   pointer    :: array
character(len=*), optional, intent(in) :: name, routine
if (associated(array)) then
  call alloc_count( -size(array), 'R', name, routine ) 
  deallocate(array,stat=IERR)
  call alloc_err( IERR, name, routine )
end if
END SUBROUTINE dealloc_r2
! ==================================================================
SUBROUTINE dealloc_r3( array, name, routine )
implicit none
real(SP), dimension(:,:,:), pointer    :: array
character(len=*), optional, intent(in) :: name, routine
if (associated(array)) then
  call alloc_count( -size(array), 'R', name, routine ) 
  deallocate(array,stat=IERR)
  call alloc_err( IERR, name, routine )
end if
END SUBROUTINE dealloc_r3
! ==================================================================
SUBROUTINE dealloc_r4( array, name, routine )
implicit none
real(SP), dimension(:,:,:,:), pointer  :: array
character(len=*), optional, intent(in) :: name, routine
if (associated(array)) then
  call alloc_count( -size(array), 'R', name, routine ) 
  deallocate(array,stat=IERR)
  call alloc_err( IERR, name, routine )
end if
END SUBROUTINE dealloc_r4
! ==================================================================
SUBROUTINE dealloc_d1( array, name, routine )
implicit none
real(DP), dimension(:),     pointer    :: array
character(len=*), optional, intent(in) :: name, routine
if (associated(array)) then
  call alloc_count( -size(array), 'D', name, routine ) 
  deallocate(array,stat=IERR)
  call alloc_err( IERR, name, routine )
end if
END SUBROUTINE dealloc_d1
! ==================================================================
SUBROUTINE dealloc_d2( array, name, routine )
implicit none
real(DP), dimension(:,:),   pointer    :: array
character(len=*), optional, intent(in) :: name, routine
if (associated(array)) then
  call alloc_count( -size(array), 'D', name, routine ) 
  deallocate(array,stat=IERR)
  call alloc_err( IERR, name, routine )
end if
END SUBROUTINE dealloc_d2
! ==================================================================
SUBROUTINE dealloc_d3( array, name, routine )
implicit none
real(DP), dimension(:,:,:), pointer    :: array
character(len=*), optional, intent(in) :: name, routine
if (associated(array)) then
  call alloc_count( -size(array), 'D', name, routine ) 
  deallocate(array,stat=IERR)
  call alloc_err( IERR, name, routine )
end if
END SUBROUTINE dealloc_d3
! ==================================================================
SUBROUTINE dealloc_d4( array, name, routine )
implicit none
real(DP), dimension(:,:,:,:), pointer  :: array
character(len=*), optional, intent(in) :: name, routine
if (associated(array)) then
  call alloc_count( -size(array), 'D', name, routine ) 
  deallocate(array,stat=IERR)
  call alloc_err( IERR, name, routine )
end if
END SUBROUTINE dealloc_d4
! ==================================================================
! COMPLEX versions
!
SUBROUTINE dealloc_z1( array, name, routine )
implicit none
complex(DP), dimension(:),   pointer   :: array
character(len=*), optional, intent(in) :: name, routine
if (associated(array)) then
  call alloc_count( -2*size(array), 'D', name, routine ) 
  deallocate(array,stat=IERR)
  call alloc_err( IERR, name, routine )
end if
END SUBROUTINE dealloc_z1
! ==================================================================
SUBROUTINE dealloc_z2( array, name, routine )
implicit none
complex(DP), dimension(:,:),  pointer  :: array
character(len=*), optional, intent(in) :: name, routine
if (associated(array)) then
  call alloc_count( -2*size(array), 'D', name, routine ) 
  deallocate(array,stat=IERR)
  call alloc_err( IERR, name, routine )
end if
END SUBROUTINE dealloc_z2
! ==================================================================
SUBROUTINE dealloc_l1( array, name, routine )
implicit none
logical, dimension(:),      pointer    :: array
character(len=*), optional, intent(in) :: name, routine
if (associated(array)) then
  call alloc_count( -size(array), 'L', name, routine ) 
  deallocate(array,stat=IERR)
  call alloc_err( IERR, name, routine )
end if
END SUBROUTINE dealloc_l1
! ==================================================================
SUBROUTINE dealloc_l2( array, name, routine )
implicit none
logical, dimension(:,:),    pointer    :: array
character(len=*), optional, intent(in) :: name, routine
if (associated(array)) then
  call alloc_count( -size(array), 'L', name, routine ) 
  deallocate(array,stat=IERR)
  call alloc_err( IERR, name, routine )
end if
END SUBROUTINE dealloc_l2
! ==================================================================
SUBROUTINE dealloc_l3( array, name, routine )
implicit none
logical, dimension(:,:,:),  pointer    :: array
character(len=*), optional, intent(in) :: name, routine
if (associated(array)) then
  call alloc_count( -size(array), 'L', name, routine ) 
  deallocate(array,stat=IERR)
  call alloc_err( IERR, name, routine )
end if
END SUBROUTINE dealloc_l3
! ==================================================================
SUBROUTINE dealloc_s1( array, name, routine )
implicit none
character(len=*), dimension(:), pointer :: array
character(len=*), optional, intent(in)  :: name, routine
if (associated(array)) then
  call alloc_count( -size(array)*len(array), 'S', name, routine ) 
  deallocate(array,stat=IERR)
  call alloc_err( IERR, name, routine )
end if
END SUBROUTINE dealloc_s1

! ==================================================================
! Internal subroutines
! ==================================================================

SUBROUTINE options( final_bounds, common_bounds, &
                    old_bounds, new_bounds, copy, shrink )
! Arguments
integer, dimension(:,:), intent(out) :: final_bounds
integer, dimension(:,:), intent(out) :: common_bounds
integer, dimension(:,:), intent(in)  :: old_bounds
integer, dimension(:,:), intent(in)  :: new_bounds
logical,       optional, intent(in)  :: copy
logical,       optional, intent(in)  :: shrink

! Internal variables and arrays
logical want_shrink


!! AG*****
!  It might be worthwhile to check whether the user
!  atttemps to use bounds which do not make sense,
!  such as zero, or with upper<lower...
!!***

! Find if it is a new allocation or a true reallocation,
! and if the contents need to be copied (saved)
if (ASSOCIATED_ARRAY) then

  ! Check if array bounds have changed
  if ( all(new_bounds==old_bounds) ) then
    ! Old and new arrays are equal. Nothing needs to be done
    NEEDS_ALLOC   = .false. 
    NEEDS_DEALLOC = .false.
    NEEDS_COPY    = .false.
  else 

    ! Want to shrink?
    if (present(shrink)) then
      want_shrink = shrink
    else
      want_shrink = DEFAULT%shrink
    end if

    if (.not. want_shrink  &
        .and. all(new_bounds(1,:)>=old_bounds(1,:)) &
        .and. all(new_bounds(2,:)<=old_bounds(2,:)) ) then
      ! Old array is already fine. Nothing needs to be done
      NEEDS_ALLOC   = .false. 
      NEEDS_DEALLOC = .false.
      NEEDS_COPY    = .false.
    else
      ! Old array needs to be substituted by a new array
      NEEDS_ALLOC   = .true.
      NEEDS_DEALLOC = .true.
      if (present(copy)) then
        NEEDS_COPY = copy
      else
        NEEDS_COPY = DEFAULT%copy
      end if

      ! Ensure that bounds shrink only if desired
      if (want_shrink) then
        final_bounds(1,:) = new_bounds(1,:)
        final_bounds(2,:) = new_bounds(2,:)
      else
        final_bounds(1,:) = min( old_bounds(1,:), new_bounds(1,:) )
        final_bounds(2,:) = max( old_bounds(2,:), new_bounds(2,:) )
      end if

      ! Find common section of old and new arrays
      common_bounds(1,:) = max( old_bounds(1,:), final_bounds(1,:) )
      common_bounds(2,:) = min( old_bounds(2,:), final_bounds(2,:) )
    end if

  end if

else
  ! Old array does not exist. Allocate new one
  NEEDS_ALLOC   = .true. 
  NEEDS_DEALLOC = .false.
  NEEDS_COPY    = .false.
  final_bounds(1,:) = new_bounds(1,:)
  final_bounds(2,:) = new_bounds(2,:)
end if

END SUBROUTINE options

! ==================================================================

SUBROUTINE alloc_err( ierr, name, routine, bounds )
implicit none

integer,                    intent(in) :: ierr
character(len=*), optional, intent(in) :: name
character(len=*), optional, intent(in) :: routine
integer, dimension(:,:), optional, intent(in) :: bounds

integer i
character(len=128) :: msg

if (ierr/=0) then
   write(msg,*) 'alloc_err: allocate status error', ierr
   call alloc_error_report(trim(msg),1)
  if (present(name).and.present(routine)) then
     write(msg,*) 'alloc_err: array ', name, &
               ' requested by ', routine
     call alloc_error_report(trim(msg),2)
  elseif (present(name)) then
     write(msg,*) 'alloc_err: array ', name, &
               ' requested by unknown'
     call alloc_error_report(trim(msg),3)
  elseif (present(routine)) then
     write(msg,*) 'alloc_err: array unknown', &
               ' requested by ', routine
     call alloc_error_report(trim(msg),4)
  endif
  if (present(bounds)) then
    write(msg,'(a)') 'alloc_err: dim, lbound, ubound:'
    call alloc_error_report(trim(msg),5)
    do i=1,size(bounds,dim=2)
       write(msg,'(i3,a,2i10)')  i, ':', bounds(1,i),bounds(2,i)
       call alloc_error_report(trim(msg),5)
    enddo
  endif
  call alloc_error_report("alloc_err: end of error report",0)
end if

END SUBROUTINE alloc_err

! ==================================================================

SUBROUTINE alloc_count( delta_size, type, name, routine )

!
!  This version simply computes the total size and calls
!  the external routine  alloc_memory_event with the size
!  in bytes and a string identifier of the form 'routine@name'.
!
implicit none

integer, intent(in)          :: delta_size  ! +/-size(array)
character, intent(in)        :: type        ! 'I' => integer
                                            ! 'E' => integer*8
                                            ! 'R' => real*4
                                            ! 'D' => real*8
                                            ! 'L' => logical
                                            ! 'S' => character (string)
character(len=*), optional, intent(in) :: name
character(len=*), optional, intent(in) :: routine

character(len=32)   :: aname
integer             :: bytes

! Compound routine+array name
if (present(name) .and. present(routine)) then
  aname = trim(routine)//'@'//name
else if (present(name) .and. DEFAULT%routine/=DEFAULT_ROUTINE) then
  aname = trim(DEFAULT%routine)//'@'//name
else if (present(name)) then
  aname = trim(DEFAULT_ROUTINE)//'@'//name
else if (present(routine)) then
  aname = trim(routine)//'@'//DEFAULT_NAME
else if (DEFAULT%routine/=DEFAULT_ROUTINE) then
  aname = trim(DEFAULT%routine)//'@'//DEFAULT_NAME
else
  aname = DEFAULT_ROUTINE//'@'//DEFAULT_NAME
end if

! Find memory increment and total allocated memory
bytes = delta_size * type_mem(type)

call alloc_memory_event(bytes,trim(aname))

CONTAINS

  INTEGER FUNCTION type_mem( var_type )
!
! It is not clear that the sizes assumed are universal for
! non-Cray machines...
!
implicit none
character, intent(in) :: var_type
character(len=40)     :: message

select case( var_type )
#ifdef OLD_CRAY
  case('I')
    type_mem = 8
  case('R')
    type_mem = 8
  case('L')
    type_mem = 8
#else
  case('I')
    type_mem = 4
  case('R')
    type_mem = 4
  case('L')
    type_mem = 4
#endif
case('E')
  type_mem = 8
case('D')
  type_mem = 8
case('S')
  type_mem = 1
case default
  write(message,"(2a)") &
    'alloc_count: ERROR: unknown type = ', var_type
  call alloc_error_report(trim(message),0)
end select

END FUNCTION type_mem

END SUBROUTINE alloc_count

END MODULE gridxc_alloc

#ifdef __TEST__MODULE__ALLOC__
! Optional test code
!
program testalloc
use gridxc_alloc, only: re_alloc, de_alloc
use gridxc_alloc, only: set_alloc_event_handler
use gridxc_alloc, only: set_alloc_error_handler

external :: custom_alloc_memory_event
external :: custom_alloc_error_report

real, pointer :: x(:) => null()
real(kind=kind(1.d0)), pointer :: y(:,:) => null()
real(kind=kind(1.d0)), allocatable :: z(:,:)
integer :: iostat
character(len=256) :: errmsg = "-------------------"

call set_alloc_event_handler(custom_alloc_memory_event)
call set_alloc_error_handler(custom_alloc_error_report)

call re_alloc(x,1,10,"x","testalloc")
call re_alloc(y,-3,4,1,3,"y","testalloc")
print *, "Shape of x: ", shape(x)
print *, "Shape of y: ", shape(y)
call de_alloc(x,"x","testalloc")
call de_alloc(y,"y","testalloc")


allocate(z(10000000,10000000),stat=iostat,errmsg=errmsg)
write(*,*) 'Iostat for large z allocation: ', iostat
write(*,*) 'Msg large z allocation: ', trim(errmsg)
write(*,*) 'Size of z: ', size(z)

write(*,*) "This should trigger an error:"
call re_alloc(y,1,100000,1,100000,"y large","testalloc")
write(*,*) 'Size of y: ', size(y)

end program testalloc
!
! Handlers
!
subroutine custom_alloc_memory_event(bytes,name)
integer, intent(in) :: bytes
character(len=*), intent(in) :: name
if (bytes > 0) then
   write(*,*) "Custom alloc event: +   allocated ", bytes, "bytes for "//trim(name)
else
   write(*,*) "Custom alloc event: - deallocated ", -bytes, "bytes for "//trim(name)
endif
end subroutine custom_alloc_memory_event

subroutine custom_alloc_error_report(name,code)
character(len=*), intent(in) :: name
integer, intent(in) :: code
write(*,*) "Custom alloc error: "//trim(name)
if (code == 0) then
   stop
endif
end subroutine custom_alloc_error_report

#endif

#if defined HAVE_CONFIG_H
#include "config.h"
#endif

!!@LICENSE
!
!******************************************************************************
! MODULE moreParallelSubs
! Provides some utility routines for parallel execution
! Written by J.M.Soler. Feb.2008-Jul.2009
!******************************************************************************
!
!   PUBLIC procedures available from this module:
! copyFile      : Copies a formatted file from one node to another
! miscAllReduce : Reduces a miscellaneous set of variables and arrays
! nodeString    : Returns a string with a node number
!
!   PUBLIC parameters, types, and variables available from this module:
! none
!
!******************************************************************************
!
!   USED module procedures:
! use gridxc_alloc,      only: de_alloc        ! De-allocation routine
! use gridxc_alloc,      only: re_alloc        ! Re-allocation routine
! use gridxc_sys,        only: die             ! Termination routine
! use gridxc_io,       only: io_assign, io_close  ! Get and reserve an available IO unit
!
!   USED module parameters:
! use gridxc_precision,  only: dp              ! Real double precision type
!
!   EXTERNAL procedures used:
! none
!
!******************************************************************************
!
! SUBROUTINE copyFile( srcNode, srcFile, dstNode, dstFile, writeOption )
!
! Copies a formatted file from one node to another
!------------------------------ INPUT -----------------------------------------
! integer,        :: srcNode   ! Source processor index in range (0:nNodes-1)
! character(len=*):: srcFile   ! Source file name
! integer,        :: dstNode   ! Destination processor index
! character(len=*):: dstFile   ! Destination file name
! character(len=*):: writeOption  ! ('append'|'overwrite')
!----------------------------- USAGE ------------------------------------------
! Sample usage to send each node's file into the file system of the root node
!   use mpi, only: MPI_Comm_Size
!   use gridxc_moreParallelSubs, only: copyFile, nodeString
!   integer:: node, nNodes, MPIerror
!   character(len=32):: myFile
!   call MPI_Comm_Size( MPI_Comm_World, nNodes, MPIerror )
!   myFile = 'node'//trim(nodeString())//'.out'  ! e.g. myFile='node021.out'
!   do node = 0,nNodes-1   ! The whole loop must be executed in each node
!     call copyFile( node, myFile, 0, myFile, 'overwrite' )
!   end do
!
! Sample usage to copy each node's file into the same destination file
!   use mpi, only: MPI_Comm_Size, MPI_Comm_World
!   use gridxc_moreParallelSubs, only: copyFile
!   integer:: node, nNodes, MPIerror
!   call MPI_Comm_Size( MPI_Comm_World, nNodes, MPIerror )
!   do node = 0,nNodes-1   ! The whole loop must be executed in each node
!     call copyFile( node, 'myNode.out', 0, 'allNodes.out', 'append' )
!   end do
!
! IMPORTANT: copyFile should be called from ALL nodes, even if they are neither
! the sending nor the receiving node, because there is an MPI_Barrier inside
!---------------------------- BEHAVIOUR ---------------------------------------
! If srcNode==dstNode and srcFile==dstFile, it does nothing
! If srcNode==dstNode but srcFile/=dstFile, it just copies the files, without
!   using MPI communications
! It allows copying several node's files sequentially into the same
!   destination file, in a given order, or to copy just one. But see
!   the note at the end of the USAGE section
!--------------------------- ALGORITHMS ---------------------------------------
! In srcNode, it reads srcFile into a character buffer, then sends it through
! MPI to dstNode, where it is writen into dstFile.
! An internal MPI_Barrier is used to impose that calls to copyFile from
! different nodes are executed in the required order.
!
!******************************************************************************
!
! SUBROUTINE miscAllReduce( op, a0, b0, c0, d0, e0, f0, &
!                               a1, b1, c1, &
!                               a2, b2, &
!                               a3 )
!
! Reduces a miscellaneous set of variables and arrays
!------------------------------ INPUT -----------------------------------------
! character(len=*) op  ! Operation to be applied ('sum'|'prod'|'max'|'min')
!-------------------- OPTIONAL INPUT and OUTPUT -------------------------------
! type                 :: a0, b0, c0, d0, e0, f0  ! Scalar arguments
! type,dimension(:)    :: a1, b1, c1              ! Vector arguments
! type,dimension(:,:)  :: a2, b2                  ! Rank-2 array arguments
! type,dimension(:,:,:):: a3                      ! Rank-3 array arguments
!   Where type=(integer|double precision)
!   All arguments must be of the same type
!----------------------------- UNITS ------------------------------------------
! Units of all arguments are arbitrary
!----------------------------- USAGE ------------------------------------------
! use gridxc_precision,        only: dp
! use gridxc_moreParallelSubs, only: miscAllReduce
! real(dp):: Ek, Eh, polarization(3), stress(3,3)
! real(dp),allocatable:: force(:,:)
! ... Find Ek, Eh, polarization, and stress. Allocate and find force.
! call miscAllReduce( 'sum', Ek, Eh, a1=polarization, a2=force, b2=stress )
!---------------------------- BEHAVIOUR ---------------------------------------
! In serial execution, it does nothing.
! If op/=('sum'|'prod'|'max'|'min'), it stops with an error message.
!--------------------------- ALGORITHMS ---------------------------------------
! All present variables and arrays are packed consecutively in a buffer vector
! The buffer is reduced with MPI_AllReduce and unpacked back into the present
!   variables and arrays.
!
!******************************************************************************
!
! character(len=6) function nodeString( node )
!
! Returns a string with a node number, or blank if nNodes<2, i.e. 00,01,...,63
! If node is not present, it assumes node=myNode
!------------------------------ INPUT -----------------------------------------
! integer,optional:: node  ! a valid node index: 0 <= node <= nNodes-1
!----------------------------- USAGE ------------------------------------------
! use gridxc_moreParallelSubs, only: nodeString
! character(len=30):: fileName
! fileName = 'atoms.node'//trim(nodeString())//'.out'
!---------------------------- BEHAVIOUR ---------------------------------------
! If node is not present, it assumes node=myNode
! If node<0 or node>=nNodes, it stops with an error message
! In serial execution, it returns a blank string
! The string length is the same for all nodes (i.e. '0','1',...,'7', or 
!    '000','001',...,'131'), but as short as possible for the highest node
! The strings are left-justified, with right-hand blanks, i.e. '00    '
!
!******************************************************************************

MODULE gridxc_moreParallelSubs

! Used module procedures
  use gridxc_alloc,     only: de_alloc  ! De-allocation routine
  use gridxc_alloc,     only: re_alloc  ! Re-allocation routine
  use gridxc_sys,       only: die       ! Termination routine
  use gridxc_io,      only: io_assign, io_close ! Get and reserve an available IO unit

! Used module parameters
  use gridxc_precision, only: dp              ! Real double precision type

! Used MPI procedures and types
#ifdef HAVE_MPI
  use gridxc_config, only : comm => gridxc_comm  ! MPI communicator
#endif

#ifdef HAVE_MPI
  use mpi
#endif

  implicit none

! All public procedures (there are no public types, parameters, or variables):
PUBLIC:: &
  copyFile,         &! Copies a formatted file from one node to another
  miscAllReduce,    &! Reduces a miscellaneous set of variables and arrays
  miscAllReduceInt, &! Integer version
  nodeString         ! Returns a character string with a node index

PRIVATE ! Nothing is declared public beyond this point

! Overload procedure name
! Note: a compiler warning may occur because calling miscAllReduce without any
!       optional arguments would not allow to resolve the right module proced.
!       But such a call would make no sense and it will never happen.
  interface miscAllReduce
    module procedure      &
!      miscAllReduceInt,   &! Integer version
      miscAllReduceDouble  ! Double precision real version
  end interface miscAllReduce

#ifdef HAVE_MPI
  integer:: MPIerror, MPIstatus(MPI_STATUS_SIZE), MPItag
#endif

CONTAINS

!******************************************************************************

SUBROUTINE copyFile( srcNode, srcFile, dstNode, dstFile, writeOption)

  implicit none
  integer,         intent(in):: srcNode      ! Source processor index
                                             ! in range (0:nNodes-1)
  character(len=*),intent(in):: srcFile      ! Source file name
  integer,         intent(in):: dstNode      ! Destination processor index
  character(len=*),intent(in):: dstFile      ! Destination file name
  character(len=*),intent(in):: writeOption  ! ('append'|'overwrite')

! Internal parameters
  character(len=*),parameter:: myName  = 'copyFile '
  character(len=*),parameter:: errHead = myName//'ERROR: '
  integer, parameter:: minLines =      10000  ! Initial number of file lines
  integer, parameter:: maxLines =     100000  ! Maximum number of file lines
  integer, parameter:: minBuffers =       10  ! Initial number of buffers
  integer, parameter:: maxBuffers =     1000  ! Maximum number of buffers
  integer, parameter:: bufferSize =    10000  ! Size of each buffer, in chars.
  real(dp),parameter:: incrFactor =   1.5_dp  ! Increment factor for re_alloc

! Internal variables and arrays
  integer,pointer:: lineBuf(:)=>null()! Which buffer contains each input line
  integer,pointer:: lineEnd(:)=>null()! Last character of each line in buffer
  character(len=bufferSize),pointer:: buffer(:)=>null()! Buffers to store input
  character(len=bufferSize):: line               ! One input line
  integer:: ib, iBuffer(2), il, iu, lineBegin, lineLength, &
            mBuffers, mLines, nBuffers, nLines, two
  integer :: myNode

#ifdef HAVE_MPI
  call MPI_Comm_Rank( comm, myNode, MPIerror)
#else
  myNode = 0
#endif

! Check whether source and destination are the same
  if (srcNode==dstNode .and. srcFile==dstFile) then
    if (writeOption=='APPEND' .or. writeOption=='append') then
      call die(errHead//'trying to append file to itself')
    else   ! (writeOption=='overwrite') => do nothing
      return
    end if ! (writeOption=='append')
  end if ! (srcNode==dstNode .and. srcFile==dstFile)

! Read source file
  if (myNode == srcNode) then

    ! Allocate buffers and line pointers
    mBuffers = minBuffers
    mLines   = minLines
    call re_alloc( buffer,  1,mBuffers, name=myName//'buffer'  )
    call re_alloc( lineBuf, 0,mLines,   name=myName//'lineBuf' )
    call re_alloc( lineEnd, 0,mLines,   name=myName//'lineEnd' )

    ! Find an available IO unit and open source file
    call io_assign( iu )
    open( unit=iu, file=srcFile, form='formatted', status='unknown' )

    ! Read source lines sequentially and store them in buffers
    lineBuf(0) = 1
    lineEnd(0) = 0
    do il = 1,maxLines

      ! Place source and destination file names in first two lines
      if (il==1) then
        line = srcFile
      else if (il==2) then
        line = dstFile
      else
        ! Read one input line. Exit il loop at end of file.
        read(iu,'(a)',end=1) line
      end if
      nLines = il

      ! Increase array sizes if necessary
      if (nLines > mLines) then
        if (mLines >= maxLines) &
            call die(errHead//'too many input lines')
        mLines = min(int(mLines*incrFactor),maxLines)
        call re_alloc( lineBuf, 0,mLines, name=myName//'lineBuff',copy=.true.)
        call re_alloc( lineEnd, 0,mLines, name=myName//'lineEnd' ,copy=.true.)
      end if ! (mLines >= maxLines)

      ! Find begining and end of line within present buffer
      lineLength  = len(trim(line))
      lineBegin   = lineEnd(il-1) + 1
      lineEnd(il) = lineEnd(il-1) + lineLength
      lineBuf(il) = lineBuf(il-1)

      ! Switch to new buffer if line does not fit within present one
      if (lineEnd(il) > bufferSize) then
        lineBegin   = 1
        lineEnd(il) = lineLength
        lineBuf(il) = lineBuf(il-1) + 1

        ! Increase number of buffers if necessary
        if (lineBuf(il) > mBuffers) then
          if (mBuffers >= maxBuffers) &
            call die(errHead//'parameter maxBuffers too small')
          mBuffers = min(int(mBuffers*incrFactor),maxBuffers)
          call re_alloc( buffer, 1,mBuffers, name=myName//'buffer',copy=.true.)
        end if ! (mBuffers >= maxBuffers)

      end if ! (lineEnd(il) > bufferSize)

      ! Copy input line into buffer
      buffer(lineBuf(il))(lineBegin:lineEnd(il)) = trim(line)
      nBuffers = lineBuf(il)

    end do ! il
    call die(errHead//'too many lines in source file')
1   continue  ! Jump here when reaching end of input file
    call io_close( iu )

  end if ! (myNode == srcNode)

#ifdef HAVE_MPI
! Transmit data from source to destination nodes, if they are different
  if (myNode==srcNode .and. myNode/=dstNode) then  ! Send data

     iBuffer(1) = nLines
     iBuffer(2) = nBuffers
     call MPI_Send( iBuffer, 2, MPI_Integer, &
                    dstNode, 0, COMM, MPIerror )
     call MPI_Send( lineBuf(0:nLines), nLines+1, MPI_Integer, &
                    dstNode, 0, COMM, MPIerror )
     call MPI_Send( lineEnd(0:nLines), nLines+1, MPI_Integer, &
                    dstNode, 0, COMM, MPIerror )
     call MPI_Send( buffer(1:nBuffers), nBuffers*bufferSize, MPI_Character, &
                    dstNode, 0, COMM, MPIerror )

  else if (myNode/=srcNode .and. myNode==dstNode) then  ! Receive data

! DEBUG
!    print*, 'copyFile: receiving iBuffer from node ', srcNode
! END DEBUG

    ! Receive the sizes of the required arrays
    call MPI_Recv( iBuffer, 2, MPI_Integer, &
                   srcNode, MPItag, COMM, MPIstatus, MPIerror )
    nLines   = iBuffer(1)
    nBuffers = iBuffer(2)

! DEBUG
!    print*, 'copyFile: nLines, nBuffers =', nLines, nBuffers
! END DEBUG

    ! Allocate arrays to receive data
    call re_alloc( buffer,  1,nBuffers, name=myName//'buffer'  )
    call re_alloc( lineBuf, 0,nLines,   name=myName//'lineBuf' )
    call re_alloc( lineEnd, 0,nLines,   name=myName//'lineEnd' )

    ! Receive data
    call MPI_Recv( lineBuf(0:nLines), nLines+1, MPI_Integer, &
                   srcNode, MPItag, COMM, MPIstatus, MPIerror )
    call MPI_Recv( lineEnd(0:nLines), nLines+1, MPI_Integer, &
                   srcNode, MPItag, COMM, MPIstatus, MPIerror )
! DEBUG
!    print'(a,/,3a8,/,(3i8))', &
!      'copyFile:', '    line', ' lineBuf', ' lineEnd', &
!      (il,lineBuf(il),lineEnd(il),il=0,nLines)
! END DEBUG
    call MPI_Recv( buffer(1:nBuffers), nBuffers*bufferSize, MPI_Character, &
                   srcNode, MPItag, COMM, MPIstatus, MPIerror )
! DEBUG
!    do il = 1,nLines
!      print'(i4,2x,a)', il, buffer(1)(lineEnd(il-1)+1:lineEnd(il))
!    end do
! END DEBUG

  end if ! (myNode==srcNode .and. myNode/=dstNode)

  ! All nodes must wait here
  call MPI_Barrier( Comm, MPIerror )
#endif

! Write buffer into destination file
  if (myNode == dstNode) then

! DEBUG
!    if (srcNode==dstNode) then
!      print*, 'copyFile: nLines, nBuffers =', nLines, nBuffers
!      print'(a,/,3a8,/,(3i8))', &
!        'copyFile:', '    line', ' lineBuf', ' lineEnd', &
!        (il,lineBuf(il),lineEnd(il),il=0,nLines)
!      do il = 1,nLines
!        print'(i4,2x,a)', il, buffer(1)(lineEnd(il-1)+1:lineEnd(il))
!      end do
!    end if
! END DEBUG

    ! Find an available IO unit and open destination file
    call io_assign( iu )
    if (writeOption=='append' .or. writeOption=='APPEND') then
      open( unit=iu, file=dstFile, form='formatted', status='unknown', &
            position='append' )
    else if (writeOption=='overwrite' .or. writeOption=='OVERWRITE') then
      open( unit=iu, file=dstFile, form='formatted', status='unknown' )
    else
      call die(errHead//'unknown writeOption = '//writeOption)
    end if ! (writeOption == 'append')

    ! Write lines sequentially
    lineBuf(0) = 0
    do il = 1,nLines

      ! Check if switching to new buffer is required
      if (lineBuf(il)==lineBuf(il-1)) then
        lineBegin = lineEnd(il-1) + 1
      else
        lineBegin = 1
      end if

      ! Copy line from buffer
      lineLength = lineEnd(il) - lineBegin + 1
      line(1:lineLength) = buffer(lineBuf(il))(lineBegin:lineEnd(il))

      ! Check that source and destination files are equal in both nodes
      if (il==1) then
        if (line(1:lineLength) /= trim(srcFile)) &
          call die(errHead//'srcFile mismatch: ' &
                   //line(1:lineLength)//' '//trim(srcFile))
      else if (il==2) then
        if (line(1:lineLength) /= trim(dstFile)) &
          call die(errHead//'dstFile mismatch: ' &
                   //line(1:lineLength)//' '//trim(dstFile))
      else
        ! Copy line from buffer to destination file
        write(iu,'(a)') line(1:lineLength)
      end if

    end do ! il

    call io_close( iu )
  end if ! (myNode == dstNode)

! Deallocations
  if (myNode==srcNode .or. myNode==dstNode) then
    call de_alloc( buffer,  name=myName//'buffer'  )
    call de_alloc( lineBuf, name=myName//'lineBuf' )
    call de_alloc( lineEnd, name=myName//'lineEnd' )
  end if

END SUBROUTINE copyFile

!******************************************************************************

SUBROUTINE miscAllReduceInt( op, a0, b0, c0, d0, e0, f0, &
                                 a1, b1, c1, &
                                 a2, b2, &
                                 a3 )
  use gridxc_array, only: array_copy
  implicit none
  character(len=*),intent(in)    :: op  ! ('sum'|'prod'|'max'|'min')
  integer,optional,intent(inout)                 :: a0, b0, c0, d0, e0, f0
  integer,optional,intent(inout),dimension(:)    :: a1, b1, c1
  integer,optional,intent(inout),dimension(:,:)  :: a2, b2
  integer,optional,intent(inout),dimension(:,:,:):: a3

  character(len=*),parameter:: myName  = 'miscAllReduceInt '
  character(len=*),parameter:: errHead = myName//'ERROR: '
  integer:: MPIerror, m, n
  integer,pointer:: recvBuff(:)=>null(), sendBuff(:)=>null()

! Do nothing unless execution is parallel
#ifdef HAVE_MPI

! Find total size of variables and arrays to be gathered
  n = 0
  if (present(a0)) n = n + 1
  if (present(b0)) n = n + 1
  if (present(c0)) n = n + 1
  if (present(d0)) n = n + 1
  if (present(e0)) n = n + 1
  if (present(f0)) n = n + 1
  if (present(a1)) n = n + size(a1)
  if (present(b1)) n = n + size(b1)
  if (present(c1)) n = n + size(c1)
  if (present(a2)) n = n + size(a2)
  if (present(b2)) n = n + size(b2)
  if (present(a3)) n = n + size(a3)

! Allocate buffers to send and receive
  call re_alloc( sendBuff, 1,n, name=myName//'sendBuff' )
  call re_alloc( recvBuff, 1,n, name=myName//'recvBuff' )

! Pack all variables and arrays into sendBuff
  n = 0
  if (present(a0)) then
    sendBuff(n+1) = a0
    n = n + 1
  end if
  if (present(b0)) then
    sendBuff(n+1) = b0
    n = n + 1
  end if
  if (present(c0)) then
    sendBuff(n+1) = c0
    n = n + 1
  end if
  if (present(d0)) then
    sendBuff(n+1) = d0
    n = n + 1
  end if
  if (present(e0)) then
    sendBuff(n+1) = e0
    n = n + 1
  end if
  if (present(f0)) then
    sendBuff(n+1) = f0
    n = n + 1
  end if
  if (present(a1)) then
    m = size(a1)
    sendBuff(n+1:n+m) = a1
    n = n + m
  end if
  if (present(b1)) then
    m = size(b1)
    sendBuff(n+1:n+m) = b1
    n = n + m
  end if
  if (present(c1)) then
    m = size(c1)
    sendBuff(n+1:n+m) = c1
    n = n + m
  end if
  if (present(a2)) then
    m = size(a2)
    call array_copy(lbound(a2), ubound(a2), a2(:,:), &
         n+1, n+m, sendBuff(:))
    !sendBuff(n+1:n+m) = reshape( a2, (/m/) )
    n = n + m
  end if
  if (present(b2)) then
    m = size(b2)
    call array_copy(lbound(b2), ubound(b2), b2(:,:), &
         n+1, n+m, sendBuff(:))
    !sendBuff(n+1:n+m) = reshape( b2, (/m/) )
    n = n + m
  end if
  if (present(a3)) then
    m = size(a3)
    call array_copy(lbound(a3), ubound(a3), a3(:,:,:), &
         n+1, n+m, sendBuff(:))
    !sendBuff(n+1:n+m) = reshape( a3, (/m/) )
    n = n + m
  end if

! Reduce sendBuff into recvBuff
  if (op=='sum' .or. op=='Sum' .or. op=='SUM') then
    call MPI_AllReduce( sendBuff, recvBuff, n, MPI_Integer, &
                        MPI_Sum, Comm, MPIerror )
  else if (op=='prod' .or. op=='Prod' .or. op=='PROD') then
    call MPI_AllReduce( sendBuff, recvBuff, n, MPI_Integer, &
                        MPI_Prod, Comm, MPIerror )
  else if (op=='max' .or. op=='Max' .or. op=='MAX') then
    call MPI_AllReduce( sendBuff, recvBuff, n, MPI_Integer, &
                        MPI_Max, Comm, MPIerror )
  else if (op=='min' .or. op=='Min' .or. op=='MIN') then
    call MPI_AllReduce( sendBuff, recvBuff, n, MPI_Integer, &
                        MPI_Min, Comm, MPIerror )
  else
    call die(errHead//'unknown operator: '//trim(op))
  end if

! Unpack recvBuff
  n = 0
  if (present(a0)) then
    a0 = recvBuff(n+1)
    n = n + 1
  end if
  if (present(b0)) then
    b0 = recvBuff(n+1)
    n = n + 1
  end if
  if (present(c0)) then
    c0 = recvBuff(n+1)
    n = n + 1
  end if
  if (present(d0)) then
    d0 = recvBuff(n+1)
    n = n + 1
  end if
  if (present(e0)) then
    e0 = recvBuff(n+1)
    n = n + 1
  end if
  if (present(f0)) then
    f0 = recvBuff(n+1)
    n = n + 1
  end if
  if (present(a1)) then
    m = size(a1)
    a1 = recvBuff(n+1:n+m)
    n = n + m
  end if
  if (present(b1)) then
    m = size(b1)
    b1 = recvBuff(n+1:n+m)
    n = n + m
  end if
  if (present(c1)) then
    m = size(c1)
    c1 = recvBuff(n+1:n+m)
    n = n + m
  end if
  if (present(a2)) then
    m = size(a2)
    call array_copy(n+1, n+m, recvBuff(:), &
         lbound(a2), ubound(a2), a2(:,:))
    !a2 = reshape( recvBuff(n+1:n+m), shape(a2) )
    n = n + m
  end if
  if (present(b2)) then
    m = size(b2)
    call array_copy(n+1, n+m, recvBuff(:), &
         lbound(b2), ubound(b2), b2(:,:))
    !b2 = reshape( recvBuff(n+1:n+m), shape(b2) )
    n = n + m
  end if
  if (present(a3)) then
    m = size(a3)
    call array_copy(n+1, n+m, recvBuff(:), &
         lbound(a3), ubound(a3), a3(:,:,:))
    !a3 = reshape( recvBuff(n+1:n+m), shape(a3) )
    n = n + m
  end if

  call de_alloc( recvBuff, name=myName//'recvBuff' )
  call de_alloc( sendBuff, name=myName//'sendBuff' )

#endif

END SUBROUTINE miscAllReduceInt

!******************************************************************************

SUBROUTINE miscAllReduceDouble( op, a0, b0, c0, d0, e0, f0, &
                                    a1, b1, c1, &
                                    a2, b2, &
                                    a3 )
  use gridxc_array, only: array_copy
  implicit none
  character(len=*),intent(in)    :: op  ! ('sum'|'prod'|'max'|'min')
  real(dp),optional,intent(inout)                 :: a0, b0, c0, d0, e0, f0
  real(dp),optional,intent(inout),dimension(:)    :: a1, b1, c1
  real(dp),optional,intent(inout),dimension(:,:)  :: a2, b2
  real(dp),optional,intent(inout),dimension(:,:,:):: a3

  character(len=*),parameter:: myName  = 'miscAllReduceInt '
  character(len=*),parameter:: errHead = myName//'ERROR: '
  integer:: MPIerror, m, n
  real(dp),pointer:: recvBuff(:)=>null(), sendBuff(:)=>null()

! Do nothing unless execution is parallel
#ifdef HAVE_MPI

! Find total size of variables and arrays to be reduced
  n = 0
  if (present(a0)) n = n + 1
  if (present(b0)) n = n + 1
  if (present(c0)) n = n + 1
  if (present(d0)) n = n + 1
  if (present(e0)) n = n + 1
  if (present(f0)) n = n + 1
  if (present(a1)) n = n + size(a1)
  if (present(b1)) n = n + size(b1)
  if (present(c1)) n = n + size(c1)
  if (present(a2)) n = n + size(a2)
  if (present(b2)) n = n + size(b2)
  if (present(a3)) n = n + size(a3)

! Allocate buffers to send and receive
  call re_alloc( sendBuff, 1,n, name=myName//'sendBuff' )
  call re_alloc( recvBuff, 1,n, name=myName//'recvBuff' )

! Pack all variables and arrays into sendBuff
  n = 0
  if (present(a0)) then
    sendBuff(n+1) = a0
    n = n + 1
  end if
  if (present(b0)) then
    sendBuff(n+1) = b0
    n = n + 1
  end if
  if (present(c0)) then
    sendBuff(n+1) = c0
    n = n + 1
  end if
  if (present(d0)) then
    sendBuff(n+1) = d0
    n = n + 1
  end if
  if (present(e0)) then
    sendBuff(n+1) = e0
    n = n + 1
  end if
  if (present(f0)) then
    sendBuff(n+1) = f0
    n = n + 1
  end if
  if (present(a1)) then
    m = size(a1)
    sendBuff(n+1:n+m) = a1
    n = n + m
  end if
  if (present(b1)) then
    m = size(b1)
    sendBuff(n+1:n+m) = b1
    n = n + m
  end if
  if (present(c1)) then
    m = size(c1)
    sendBuff(n+1:n+m) = c1
    n = n + m
  end if
  if (present(a2)) then
    m = size(a2)
    call array_copy(lbound(a2), ubound(a2), a2(:,:), &
         n+1, n+m, sendBuff(:))
    !sendBuff(n+1:n+m) = reshape( a2, (/m/) )
    n = n + m
  end if
  if (present(b2)) then
    m = size(b2)
    call array_copy(lbound(b2), ubound(b2), b2(:,:), &
         n+1, n+m, sendBuff(:))
    !sendBuff(n+1:n+m) = reshape( b2, (/m/) )
    n = n + m
  end if
  if (present(a3)) then
    m = size(a3)
    call array_copy(lbound(a3), ubound(a3), a3(:,:,:), &
         n+1, n+m, sendBuff(:))
    !sendBuff(n+1:n+m) = reshape( a3, (/m/) )
    n = n + m
  end if

! Reduce sendBuff into recvBuff
  if (op=='sum' .or. op=='Sum' .or. op=='SUM') then
    call MPI_AllReduce( sendBuff, recvBuff, n, MPI_double_precision, &
                        MPI_Sum, Comm, MPIerror )
  else if (op=='prod' .or. op=='Prod' .or. op=='PROD') then
    call MPI_AllReduce( sendBuff, recvBuff, n, MPI_double_precision, &
                        MPI_Prod, Comm, MPIerror )
  else if (op=='max' .or. op=='Max' .or. op=='MAX') then
    call MPI_AllReduce( sendBuff, recvBuff, n, MPI_double_precision, &
                        MPI_Max, Comm, MPIerror )
  else if (op=='min' .or. op=='Min' .or. op=='MIN') then
    call MPI_AllReduce( sendBuff, recvBuff, n, MPI_double_precision, &
                        MPI_Min, Comm, MPIerror )
  else
    call die(errHead//'unknown operator: '//trim(op))
  end if

! Unpack recvBuff
  n = 0
  if (present(a0)) then
    a0 = recvBuff(n+1)
    n = n + 1
  end if
  if (present(b0)) then
    b0 = recvBuff(n+1)
    n = n + 1
  end if
  if (present(c0)) then
    c0 = recvBuff(n+1)
    n = n + 1
  end if
  if (present(d0)) then
    d0 = recvBuff(n+1)
    n = n + 1
  end if
  if (present(e0)) then
    e0 = recvBuff(n+1)
    n = n + 1
  end if
  if (present(f0)) then
    f0 = recvBuff(n+1)
    n = n + 1
  end if
  if (present(a1)) then
    m = size(a1)
    a1 = recvBuff(n+1:n+m)
    n = n + m
  end if
  if (present(b1)) then
    m = size(b1)
    b1 = recvBuff(n+1:n+m)
    n = n + m
  end if
  if (present(c1)) then
    m = size(c1)
    c1 = recvBuff(n+1:n+m)
    n = n + m
  end if
  if (present(a2)) then
    m = size(a2)
    call array_copy(n+1, n+m, recvBuff(:), &
         lbound(a2), ubound(a2), a2(:,:))
    !a2 = reshape( recvBuff(n+1:n+m), shape(a2) )
    n = n + m
  end if
  if (present(b2)) then
    m = size(b2)
    call array_copy(n+1, n+m, recvBuff(:), &
         lbound(b2), ubound(b2), b2(:,:))
    !b2 = reshape( recvBuff(n+1:n+m), shape(b2) )
    n = n + m
  end if
  if (present(a3)) then
    m = size(a3)
    call array_copy(n+1, n+m, recvBuff(:), &
         lbound(a3), ubound(a3), a3(:,:,:))
    !a3 = reshape( recvBuff(n+1:n+m), shape(a3) )
    n = n + m
  end if

  call de_alloc( recvBuff, name=myName//'recvBuff' )
  call de_alloc( sendBuff, name=myName//'sendBuff' )

#endif

END SUBROUTINE miscAllReduceDouble

!******************************************************************************

character(len=6) function nodeString( node )
! Returns a string with node index, or blank if nNodes<2

  implicit none

  integer,optional:: node  ! a valid node index 0 <= node <= nNodes-1

  character(len=20):: numName
  character(len=80):: errMsg
  integer:: fileLen, iNode, maxLen, numLen
  integer :: myNode, totNodes

#ifdef HAVE_MPI
  integer :: MPIerror

  call MPI_Comm_Size( comm, totNodes, MPIerror)
  call MPI_Comm_Rank( comm, myNode, MPIerror)
#else
  totNodes = 1
  myNode = 0
#endif

  if (totNodes<2) then   ! Serial execution
    nodeString = ' '
  else                   ! Parallel execution
    if (present(node)) then
      if (0<=node .and. node<totNodes) then ! Valid node index
        iNode = node
      else                                  ! Invalid node index
        write(errMsg,*) 'nodeString: ERROR: invalid argument: node =', node
        call die( trim(errMsg) )
      end if ! (0<=node<totNodes)
    else ! (.not.present(node))
      iNode = myNode
    end if ! (present(node))

    ! Find maximum name length of node numbers
    write(numName,*) totNodes-1   ! 0 <= node <= Nodes-1
    numName = adjustl(numName)
    maxLen = len_trim(numName)

    ! Find name of this node's number, and its name length
    write(numName,*) iNode
    numName = adjustl(numName)
    numLen = len_trim(numName)

    ! Set node number string, e.g. 00, 01, ... 63
    nodeString = '000000000'
    nodeString(maxLen-numLen+1:maxLen) = trim(numName)
    nodeString(maxLen+1:) = ' '

  end if ! (totNodes<2)
  
end function nodeString

END MODULE gridxc_moreParallelSubs

#if defined HAVE_CONFIG_H
#include "config.h"
#endif
#ifdef HAVE_LIBXC
#include "xc_version.h"
#endif

MODULE gridxc_cell

  implicit none

  PUBLIC:: cellXC  ! Exchange and correlation in a periodic unit cell

  PRIVATE ! Nothing is declared public beyond this point

CONTAINS ! nothing else but public routine cellXC

!< Finds total exchange-correlation energy and potential in a periodic cell.
!```
! This version implements the Local (spin) Density Approximation and
!   the Generalized-Gradient-Aproximation with the 'explicit mesh 
!   functional' approach of White & Bird, PRB 50, 4954 (1994).
! Gradients are 'defined' by numerical derivatives, using 2*nn+1 mesh
!   points, where nn is a parameter defined below
! Ref: L.C.Balbas et al, PRB 64, 165110 (2001)
! Written by J.M.Soler using algorithms developed by 
!   L.C.Balbas, J.L.Martins and J.M.Soler, Dec.1996 - Aug.1997
! Parallel version written by J.Gale. June 1999.
! Argument dVxcdD added by J.Junquera. November 2000.
! Adapted for multiple functionals in the same run by J.Gale 2005
! Van der Waals functional added by J.M.Soler, Jan.2008, as explained in
!   G.Roman-Perez and J.M.Soler, PRL 103, 096102 (2009)
! ************************* INPUT ***********************************
! integer  irel        : Relativistic exchange? (0=>no, 1=>yes)
! real(dp) cell(3,3)   : Unit cell vectors cell(ixyz,ivector)
! integer  nMesh(3)    : Total mesh divisions of each cell vector
! integer  lb1,lb2,lb3 : Lower bounds of arrays dens, Vxc, dVxcdD
! integer  ub1,ub2,ub3 : Upper bounds of arrays dens, Vxc, dVxcdD
! integer  nSpin       : nSpin=1 => unpolarized; nSpin=2 => polarized;
!                        nSpin>2 => non-collinear polarization
! real(grid_p) dens(lb1:ub1,lb2:ub2,lb3:ub3,nSpin) : Total (nSpin=1) or 
!                        spin (nSpin=2) electron density at mesh points
!                        For non-collinear polarization, the density
!                        matrix is given by: dens(1)=D11, dens(2)=D22,
!                        dens(3)=Real(D12), dens(4)=Im(D12)
! ************************* OUTPUT **********************************
! real(dp) Ex             : Total exchange energy per unit cell
! real(dp) Ec             : Total correlation energy per unit cell
! real(dp) Dx             : IntegralOf( rho * (eps_x - v_x) ) in unit cell
! real(dp) Dc             : IntegralOf( rho * (eps_c - v_c) ) in unit cell
! real(dp) stress(3,3)    : xc contribution to the stress tensor, in unit
!                           cell, assuming constant density (not charge),
!                           i.e. r->r' => rho'(r') = rho(r)
!                           For plane-wave and grid (finite diff) basis
!                           sets, density rescaling gives an extra term
!                           (not included) (Dx+Dc-Ex-Ec)/cell_volume for
!                           the diagonal elements of stress. For other
!                           basis sets, the extra term is, in general:
!                           IntegralOf(v_xc * d_rho/d_strain) / cell_vol
! real(grid_p) Vxc(lb1:ub1,lb2:ub2,lb3:ub3,nSpin) : (Spin) xc potential
! ************************* OPTIONAL INPUT *************************
! logical keep_input_distribution :  Avoid internal load-balancer and lock
!                                    the passed parallel distribution
! ************************* OPTIONAL OUTPUT *************************
! real(grid_p) dVxcdD(lb1:ub1,lb2:ub2,lb3:ub3,nSpin*nSpin) : Derivatives
!                           of xc potential respect to charge density
!                           Available only for LDA (libxc + built-in CA/PZ)
!                           and collinear-spin
! *** OPTIONAL OUTPUT (must set keep_input_distribution=.true.) *****
! real(grid_p) epsxc(lb1:ub1,lb2:ub2,lb3:ub3) : XC energy density per electron
! real(grid_p) dexcdGD(lb1:ub1,lb2:ub2,lb3:ub3,3,nspin) 
!                                 d(n*epsxc)/dGradD  (Notation: exc = n*epsxc)
! ************************ UNITS ************************************
! Distances in atomic units (Bohr).
! Densities in atomic units (electrons/Bohr**3)
! Energy unit depending of parameter EUnit below (currently Rydberg)
! Stress in EUnit/Bohr**3
!```

!< IMPORTANT NOTE:
!```
! Arrays dens, Vxc, and dVxcdD may be alternatively 
! allocated and initialized with indexes beginning in 0 or 1, 
! or even use a single-index array, e.g.:
!   real(grid_p),allocatable :: dens(:,:), Vxc(:,:)
!   myMesh(1:3) = myBox(2,:) - myBox(1,:) + 1
!   myPoints = myMesh(1)*myMesh(2)*myMesh(3)
!   allocate( dens(myPoints,nSpin), Vxc(myPoints,nSpin) )
!   iPoint = 0
!   do i3 = myBox(1,3),myBox(2,3)
!   do i2 = myBox(1,2),myBox(2,2)
!   do i1 = myBox(1,1),myBox(2,1)
!     iPoint = iPoint + 1
!     do iSpin = 1,nSpin
!       dens(iPoint,iSpin) = (spin)density at point (i1,i2,i3)
!     end do
!   end do
!   end do
!   end do
! but the call to cellXC must still be as given above, i.e. the
! arguments lb1,ub1,... must be the lower and upper bounds of the
! mesh box stored by each processor (not the allocated array bounds).
! However, the arrays size MUST be (ub1-lb1+1)*(ub2-lb2+1)*(ub3-lb3+1)
! The processor mesh boxes must not overlap, and they must cover the 
! entire unit cell mesh. This is NOT checked inside cellXC.
!
! ********* BEHAVIOUR ***********************************************
! - Stops and prints a warning if functl is not one of LDA, GGA, or VDW
! - The output values of Ex, Ec, Dx, Dc, and stress, are integrals over
!   the whole unit cell, not over the mesh box of the local processor
! - Since the exchange and correlation part is usually a small fraction
!   of a typical electronic structure calculation, this routine has
!   been coded with emphasis on simplicity and functionality, not in
!   efficiency.
!```
  
SUBROUTINE cellXC( irel, cell, nMesh, lb1, ub1, lb2, ub2, lb3, ub3, &
                   nSpin, dens, Ex, Ec, Dx, Dc, stress, Vxc, dVxcdD, &
                   epsxc, dexcdGD, keep_input_distribution )
  ! Module routines

  use gridxc_config,  only: nodes=>gridxc_totNodes ! Number of processor nodes
  use gridxc_config,  only: myNode=>gridxc_myNode ! My node
  use gridxc_mesh3D,  only: addMeshData   ! Accumulates a mesh array
  use gridxc_alloc,   only: alloc_default ! Sets (re)allocation defaults
  use gridxc_mesh3D,  only: associateMeshTask ! Associates mesh tasks & distr.
  use gridxc_mesh3D,  only: copyMeshData  ! Copies a box of a mesh array
  use gridxc_alloc,   only: de_alloc      ! Deallocates arrays
  use gridxc_sys,     only: die           ! Termination routine
  use gridxc_fftr,    only: fftk2r        ! Inverse real Fourier transform
  use gridxc_fftr,    only: fftr2k        ! Direct real Fourier transform
  use gridxc_mesh3D,  only: fftMeshDistr  ! Sets/gets distribution for FFTs
  use gridxc_mesh3D,  only: freeMeshDistr ! Frees a mesh distribution ID
  use gridxc_moreParallelSubs, only: miscAllReduce ! Adds variables from all processes
  use gridxc_xcmod,   only: getXC         ! Returns the XC functional to be used
  use gridxc_gga,     only: ggaxc         ! General GGA XC routine
  use gridxc_lda,     only: ldaxc         ! General LDA XC routine
  use gridxc_chkgmx,only: meshKcut      ! Returns the planewave cutoff of a mesh
  use gridxc_mesh3D,  only: myMeshBox     ! Returns the mesh box of my processor
#ifdef DEBUG_XC
! use gridxc_moreParallelSubs, only: nodeString ! Returns a string with my node number
  use gridxc_vdwxc, only: qofrho        ! For debugging only
#endif /* DEBUG_XC */
  use gridxc_alloc,   only: re_alloc      ! Reallocates arrays
  use gridxc_cellsubs,only: reclat        ! Finds reciprocal unit cell vectors
  use gridxc_mesh3D,  only: sameMeshDistr ! Finds if two mesh distr. are equal
  use gridxc_mesh3D,  only: setMeshDistr  ! Defines a new mesh distribution
#ifdef DEBUG_XC
  use gridxc_debugXC, only: setDebugOutputUnit ! Sets udebug variable
#endif /* DEBUG_XC */
  ! To pass info to the caller
  use gridxc_sys, only: timer_start=>gridxc_timer_start       ! Starts counting time
  use gridxc_sys, only: timer_stop=>gridxc_timer_stop        ! Stops counting time

  use gridxc_vdwxc, only: vdw_localxc   ! Local LDA/GGA xc apropriate for vdW flavour
  use gridxc_vdwxc, only: vdw_decusp    ! Cusp correction to VDW energy
  use gridxc_vdwxc, only: vdw_get_qmesh ! Returns q-mesh for VDW integrals
  use gridxc_vdwxc, only: vdw_phi       ! Returns VDW functional kernel
  use gridxc_vdwxc, only: vdw_set_kcut  ! Fixes k-cutoff in VDW integrals
  use gridxc_vdwxc, only: vdw_theta     ! Returns VDW theta function
  use gridxc_cellsubs,only: volcel        ! Finds volume of unit cell

  ! Module types and variables
  use gridxc_alloc,     only: allocDefaults ! Derived type for allocation defaults
  use gridxc_precision, only: dp            ! Double precision real type
  use gridxc_precision, only: gp=>grid_p    ! Real precision type of mesh arrays
#ifdef DEBUG_XC
  use gridxc_debugXC,   only: udebug        ! Output file unit for debug info
#endif /* DEBUG_XC */

#ifdef HAVE_LIBXC
#if XC_MAJOR_VERSION >= 4
    use xc_f03_lib_m
#else 
    use xc_f90_types_m
    use xc_f90_lib_m
#endif
#endif

  implicit none

  ! Argument types and dimensions
  integer, intent(in) :: irel        ! Relativistic exchange? (0=>no, 1=>yes)
  real(dp),intent(in) :: cell(3,3)   ! Unit cell vectors cell(ixyz,ivector)
  integer, intent(in) :: nMesh(3)    ! Total mesh divisions of each cell vector
  integer, intent(in) :: lb1,lb2,lb3 ! Lower bounds of dens, Vxc, and dVxcdD
  integer, intent(in) :: ub1,ub2,ub3 ! Upper bounds of dens, Vxc, and dVxcdD
  integer, intent(in) :: nSpin       ! Number of spin components (1, 2, or 4 [non-coll spin])
!< Total (nSpin=1) or spin (nSpin=2) electron density at mesh points.
!  For non-collinear polarization (nSpin=4), the density matrix is given by: dens(1)=D11, dens(2)=D22,
!  dens(3)=Real(D12), dens(4)=Im(D12)
  real(gp),intent(in) :: dens(0:ub1-lb1,0:ub2-lb2,0:ub3-lb3,1:nSpin)
                                     ! (spin) Density at mesh points
  real(dp),intent(out):: Ex          ! Total exchange energy in unit cell
  real(dp),intent(out):: Ec          ! Total correlation energy in unit cell
  real(dp),intent(out):: Dx          ! IntegralOf(rho*(eps_x-v_x)) in unit cell
  real(dp),intent(out):: Dc          ! IntegralOf(rho*(eps_c-v_c)) in unit cell
  real(dp),intent(out):: stress(3,3) ! xc contribution to stress in unit cell
  real(gp),intent(out):: Vxc(0:ub1-lb1,0:ub2-lb2,0:ub3-lb3,1:nSpin) 
                                     ! (spin) xc potential
  real(gp),intent(out),optional:: &  ! dVxc/dDens (LDA,nspin<=2 only: libxc + built-in CA/PZ)
                         dVxcdD(0:ub1-lb1,0:ub2-lb2,0:ub3-lb3,1:nSpin**2) 
  logical, intent(in),optional::  keep_input_distribution ! Avoid internal load-balancer
!< XC energy density per electron (Notation: exc = n*epsxc is the XC energy density)
  real(gp),intent(out),optional :: &  ! exc(r): XC energy density per electron
       epsxc(0:ub1-lb1,0:ub2-lb2,0:ub3-lb3)
!< d(n*epsxc)/dGradD  (Derivative of exc with respect to the gradient of n)
  real(gp),intent(out),optional :: &  ! d(n*epsxc)/dGradD  (Notation: exc = n*epsxc)
                         dexcdGD(0:ub1-lb1,0:ub2-lb2,0:ub3-lb3,3,nspin) 


  ! Fix the order of the numerical derivatives
  ! nn is the number of points used in each coordinate and direction,
  ! i.e. a total of 6*nn neighbour points is used to find the gradients
  integer,parameter  :: nn = 3

  ! Fix energy unit:  Eunit=1.0 => Hartrees,
  !                   Eunit=0.5 => Rydbergs,
  !                   Eunit=0.03674903 => eV
  real(dp),parameter :: Eunit = 0.5_dp

  ! Fix the maximum allowed dispersion in CPU-time among different processors
  real(dp),parameter :: maxUnbalance = 0.10_dp

  ! Fix density threshold below which it will be taken as zero
  real(dp),parameter :: Dmin = 1.0e-15_dp

  ! Fix density threshold below which we make Vxc=0
  real(dp),parameter :: Dcut = 1.0e-9_dp

  ! Fix a minimum value of k vectors to avoid division by zero
  real(dp),parameter :: kmin = 1.0e-15_dp

  ! Fix the maximum number of functionals to be combined
  integer, parameter :: maxFunc = 10

  ! Subroutine name
  character(len=*),parameter :: myName = 'cellXC '
  character(len=*),parameter :: errHead = myName//'ERROR: '

  ! Static internal variables
  integer,save::   &
     io2my=-1,     &! ID of communications task between ioDistr and myDistr
     ioDistr=-1,   &! ID of input mesh distribution
     kDistr=-1,    &! ID of mesh distribution used for FFTs
     left2my(3)=-1,&! ID of commun. task from left-border boxes and myBox
     my2io=-1,     &! ID of commun. task between myDistr and ioDistr
     my2left(3)=-1,&! ID of commun. task from myBox to left-border boxes
     my2rght(3)=-1,&! ID of commun. task from myBox to right-border boxes
     myDistr=-1,   &! ID of mesh distrib. used internally in this routine
     oldMesh(3)=-1,&! Total number of mesh points in previous call
     rght2my(3)=-1  ! ID of commun. task from right-border boxes and myBox
  real(dp),save::  &
     myTime=1,     &! CPU time in this routine and processor in last iteration
     timeAvge=1,   &! Average over processors of CPU time
     timeDisp=huge(1.0_dp)  ! Dispersion over processors of CPU time

  ! Internal pointers for dynamical allocation
  real(dp), pointer:: &
     dphidk(:,:)=>null(), dtdgd(:,:,:)=>null(), dtdd(:,:)=>null(), &
     dudk(:)=>null(), phi(:,:)=>null(), tk(:)=>null(), tr(:)=>null(), &
     ur(:)=>null(), uk(:)=>null()
  real(gp), pointer:: &
     tvac(:)=>null(), tvdw(:,:)=>null(), uvdw(:,:)=>null(), &
     Vj(:)=>null(), workload(:,:,:)=>null()
  real(gp), dimension(:,:,:,:), pointer:: &
     Dleft=>null(), Dleft1=>null(), Dleft2=>null(), Dleft3=>null(), &
     Drght=>null(), Drght1=>null(), Drght2=>null(), Drght3=>null(), &
     myDens=>null(), mydVxcdD=>null(), myVxc=>null(), &
     tq=>null(), uq=>null(), &
     Vleft=>null(), Vleft1=>null(), Vleft2=>null(), Vleft3=>null(), &
     Vrght=>null(), Vrght1=>null(), Vrght2=>null(), Vrght3=>null()
  
  logical, pointer:: &
     nonempty(:,:,:)=>null()

  ! Other internal variables and arrays
  integer :: &
     boxLeft(2,3), boxRght(2,3), &
     i1, i2, i3, ic, ii1, ii2, ii3, ik, in, &
     ioBox(2,3), ip, iq, is, ix, iuvdw,  &
     jj(3), jn, jp, js, jx, kBox(2,3), kMesh(3), kPoints, ks,  &
     l11, l12, l13, l21, l22, l23, &
     m11, m12, m13, m21, m22, m23, maxPoints, mesh(3), &
     myBox(2,3), myMesh(3), myOldDistr, myPoints, &
     ndSpin, nf, nonemptyPoints, nPoints, nq, ns, nXCfunc, &
     r11, r12, r13, r21, r22, r23
  real(dp):: &
     comTime, D(nSpin), dedk, dEcdD(nSpin), dEcdGD(3,nSpin), &
     dEcidDj, dEcuspdD(nSpin), dEcuspdGD(3,nSpin),  &
     dExdD(nSpin), dExdGD(3,nSpin), dExidDj, &
     dGdM(-nn:nn), dGidFj(3,3,-nn:nn), Dj(nSpin), &
     dMdX(3,3), DV, dVol, Dtot, dXdM(3,3), &
     dVcdD(nSpin*nSpin), dVxdD(nSpin*nSpin), &
     EcuspVDW, Enl, epsC, epsCusp, epsNL, epsX, f1, f2, &  
     GD(3,nSpin), k, kcell(3,3), kcut, kvec(3),  &
     stressVDW(3,3), sumTime, sumTime2, totTime, VDWweightC, volume, &
     XCweightC(maxFunc), XCweightVDW, XCweightX(maxFunc)
#ifdef DEBUG_XC
  integer :: iip, jjp, jq
  real(dp):: rmod, rvec(3)
  integer,save:: myIter=0
#endif /* DEBUG_XC */
  logical :: &
     LDA, GGA, GGAfunctl, VDW, VDWfunctl
  character(len=20):: &
     XCauth(maxFunc), XCfunc(maxFunc)
  character(len=80):: &
     errMsg
  type(allocDefaults):: &
     prevAllocDefaults

  logical :: keep_input_distr

#ifdef DEBUG_XC
  ! Variables for debugging
  real(dp):: GDtot(3), q, dqdD, dqdGD(3)
#endif /* DEBUG_XC */

#ifdef HAVE_LIBXC
#if XC_MAJOR_VERSION >= 4
  type(xc_f03_func_t), allocatable :: xc_func(:)
  type(xc_f03_func_info_t), allocatable :: xc_info(:)
#else
  type(xc_f90_pointer_t), allocatable :: xc_func(:), xc_info(:)
#endif
  logical, allocatable :: is_libxc(:)
  integer :: xc_ispin, xc_id, iostat
#endif

  ! Start time counter
  call timer_start( myName )

  keep_input_distr = .false.
  if (present(keep_input_distribution)) then
     keep_input_distr =   keep_input_distribution
  endif
     
#ifdef DEBUG_XC
  ! Initialize udebug variable
  call setDebugOutputUnit(myNode)
#endif /* DEBUG_XC */

  ! Get the functional(s) to be used
  call getXC( nXCfunc, XCfunc, XCauth, XCweightX, XCweightC )

  ! Set routine name for allocations
  call alloc_default( old=prevAllocDefaults, copy=.true., shrink=.true. )

  ! Find number of diagonal spin components
  ndSpin = min( nSpin, 2 )

  ! Find total number of mesh points in unit cell
  nPoints = nMesh(1) * nMesh(2) * nMesh(3)

  ! Find the cell volume and the volume per mesh point
  volume = volcel( cell )
  dVol = volume / nPoints

  ! Set family switches and perform checks
  LDA = .false.
  GGA = .false.
  VDW = .false.
  XCweightVDW = 0
  do nf = 1,nXCfunc
    if ( XCfunc(nf).eq.'LDA' .or. XCfunc(nf).eq.'lda' .or. &
         XCfunc(nf).eq.'LSD' .or. XCfunc(nf).eq.'lsd' ) then
       ! Implementation check
       if ( XCauth(nf)=='PW92' .OR. XCauth(nf)=='pw92' ) then
          if (present(dVxcdD)) then
             write(errMsg,*) errHead//' d2Exc/dn2 not implemented for built-in ', &
             XCauth(nf)
             call die( trim(errMsg) )
          endif
       endif
       LDA = .true.
       cycle ! nf loop
    else if ( XCfunc(nf).eq.'GGA' .or. XCfunc(nf).eq.'gga') then
      GGA = .true.
    else if ( XCfunc(nf).eq.'VDW' .or. XCfunc(nf).eq.'vdw') then
      GGA = .true.
      VDW = .true.
      XCweightVDW = XCweightVDW + XCweightC(nf)
    else
      write(errMsg,*) errHead//'Unknown functional ', XCfunc(nf)
      call die( trim(errMsg) )
    endif
  enddo

  ! Set the possible libxc objects to avoid call overhead in grid
#ifdef HAVE_LIBXC
  allocate(is_libxc(nXCfunc))
  is_libxc(:) = .false.
  allocate(xc_func(nXCfunc), xc_info(nXCfunc))
#endif
  
  do nf = 1,nXCfunc
      if ( XCauth(nf)(1:5) == 'LIBXC') then
#ifdef HAVE_LIBXC
      read(XCauth(nf)(7:11),iostat=iostat,fmt=*) xc_id
      if (iostat /= 0) call die("Bad libxc code in " // XCauth(nf))
        IF (nspin == 1) THEN
          xc_ispin = XC_UNPOLARIZED
        ELSE
          xc_ispin = XC_POLARIZED
        ENDIF

#if    XC_MAJOR_VERSION >= 4           
        if ((irel == 1) .and. (xc_id == 1)) then
           ! Change LDA_X to LDA_X_REL (532)
           ! This was introduced in libXC v4
           xc_id = 532
        endif
        call xc_f03_func_init(xc_func(nf), xc_id, xc_ispin)
        xc_info(nf) = xc_f03_func_get_info(xc_func(nf))
#else
        call xc_f90_func_init(xc_func(nf), xc_info(nf), xc_id, xc_ispin)
        if ((irel == 1) .and. (xc_id == 1)) then
          ! To set the relativistic flag we need to call this
          ! general function, and include the default 4/3 factor
          ! that gives standard exchange (implicit in the above
          ! initialization call)
           call xc_f90_lda_x_set_par(xc_func(nf), 4.0_dp/3.0_dp,   &
                                    XC_RELATIVISTIC, 0.0_dp)
        endif
#endif
        is_libxc(nf) = .true.
#else
        call die("Libxc not compiled in. Cannot handle "// trim(XCauth(nf)))
#endif /* HAVE_LIBXC */
     endif
  enddo ! nf

  ! Check argument dVxcdD
  if (present(dVxcdD) .and. (.not. LDA)) &
    call die(errHead//'dVxcdD available only for LDA')
  if (present(dVxcdD) .and. nspin>2) &
    call die(errHead//'dVxcdD available only for collinear spin')

  ! Find my mesh box in I/O distribution of mesh points
  ioBox(1,1)=lb1;  ioBox(1,2)=lb2;  ioBox(1,3)=lb3
  ioBox(2,1)=ub1;  ioBox(2,2)=ub2;  ioBox(2,3)=ub3
  myMesh(:) = ioBox(2,:) - ioBox(1,:) + 1
  myPoints = product(myMesh)

  ! Get ID of the I/O distribution of mesh points
  call setMeshDistr( ioDistr, nMesh, ioBox )

  if (keep_input_distr) then

     myDistr = ioDistr

  else

     ! Sanity check to avoid complicated code
     if (present(dexcdGD)) then
        call die("Have to lock input distribution for dexcdGD output")
     endif
     if (present(epsxc)) then
        call die("Have to lock input distribution for epsxc output")
     endif
     
  ! If nMesh has changed, use input distribution also initially as myDistr
  if (any(nMesh/=oldMesh)) call setMeshDistr( myDistr, nMesh, ioBox )
  oldMesh = nMesh

  ! Find new mesh distribution, if previous iteration was too unbalanced
  if (nodes>1 .and. timeDisp/timeAvge>maxUnbalance) then
    ! Find my node's mesh box using myDistr
    call myMeshBox( nMesh, myDistr, myBox )
    ! Allocate arrays for the density and workload per point in my box
    call re_alloc( myDens, myBox(1,1),myBox(2,1), &
                           myBox(1,2),myBox(2,2), &
                           myBox(1,3),myBox(2,3), 1,ndSpin, myName//'myDens' )
    call re_alloc(workload,myBox(1,1),myBox(2,1), &
                           myBox(1,2),myBox(2,2), &
                           myBox(1,3),myBox(2,3), myName//'workload' )
    ! Copy density to my box 
    call associateMeshTask( io2my, ioDistr, myDistr )
    call copyMeshData( nMesh, ioDistr, dens(:,:,:,1:ndSpin), &
                              myBox, myDens(:,:,:,1:ndSpin), io2my )
!    call copyMeshData( nMesh, ioDistr, dens(:,:,:,1:ndSpin), &
!                              myBox, myDens(:,:,:,1:ndSpin) )
    ! Find initial expected workload (zero if dens=0, one otherwise)
    do i3 = myBox(1,3),myBox(2,3)
    do i2 = myBox(1,2),myBox(2,2)
    do i1 = myBox(1,1),myBox(2,1)
      Dtot = sum( myDens(i1,i2,i3,1:ndSpin) )
      if (Dtot>Dmin) then
         workload(i1,i2,i3) = 1
      else
         workload(i1,i2,i3) = 0
      end if
    end do
    end do
    end do
    ! Modify workload according to previous CPU time
    workload = workload * myTime/timeAvge
!    workload = workload * (myTime/myPoints) / (nodes*timeAvge/nPoints)
    ! Find new distribution
    call setMeshDistr( myDistr, nMesh, wlDistr=myDistr, workload=workload )
    ! Deallocate temporary arrays
    call de_alloc( workload, myName//'workload' )
    call de_alloc( myDens,   myName//'myDens' )
#ifdef DEBUG_XC
    myIter = myIter+1
    call myMeshBox( nMesh, myDistr, myBox )
    write(udebug,'(a,i6,1x,3i5,3(1x,2i5))') &
      myName//'Iter,nMesh,myBox=', myIter, nMesh, myBox
#endif /* DEBUG_XC */
  end if ! (nodes>1 .and. timeDisp/timeAvge>maxUnbalance)

  endif
#ifdef DEBUG_XC
  ! Keep input distribution for the time being
!  myDistr = ioDistr
#endif /* DEBUG_XC */

  ! Find the box of mesh points that belong to this node
  call myMeshBox( nMesh, myDistr, myBox )

  ! Find local number of mesh points along each axis
  myMesh(:) = myBox(2,:) - myBox(1,:) + 1
  myPoints = product(myMesh)

  ! Allocate myDens and myVxc arrays if either:
  ! - The parallel mesh distribution is changed internally (even with LDA)
  !   This is needed to perform the calculations in the new distribution.
  ! - We need finite differences (GGA) and have a distributed mesh
  !   In this case there is no extra distribution, but for the bookeeping
  !   of boundaries it is advantageous to have new arrays with absolute indexes.
  
  if (.not.sameMeshDistr(myDistr,ioDistr) .or. (GGA .and. myDistr/=0)) then

    m11=myBox(1,1); m12=myBox(1,2); m13=myBox(1,3)
    m21=myBox(2,1); m22=myBox(2,2); m23=myBox(2,3)
    ns = nSpin  ! Just a shorter name
    call re_alloc( myDens, m11,m21, m12,m22, m13,m23, 1,ns, myName//'myDens' )
    call re_alloc( myVxc,  m11,m21, m12,m22, m13,m23, 1,ns, myName//'myVxc'  )
    if (present(dVxcdD)) &
      call re_alloc( mydVxcdD, m11,m21, m12,m22, m13,m23, 1,ns**2, &
                     myName//'mydVxcdD'  )
    
    ! Allocate arrays for density and potential in neighbor regions
    if (GGA) then
      l11=m11-nn;     l12=m12-nn;     l13=m13-nn
      l21=m11-1;      l22=m12-1;      l23=m13-1
      r11=m21+1;      r12=m22+1;      r13=m23+1
      r21=m21+nn;     r22=m22+nn;     r23=m23+nn
      call re_alloc( Dleft1, l11,l21, m12,m22, m13,m23, 1,ns, myName//'Dleft1' )
      call re_alloc( Drght1, r11,r21, m12,m22, m13,m23, 1,ns, myName//'Drght1' )
      call re_alloc( Dleft2, m11,m21, l12,l22, m13,m23, 1,ns, myName//'Dleft2' )
      call re_alloc( Drght2, m11,m21, r12,r22, m13,m23, 1,ns, myName//'Drght2' )
      call re_alloc( Dleft3, m11,m21, m12,m22, l13,l23, 1,ns, myName//'Dleft3' )
      call re_alloc( Drght3, m11,m21, m12,m22, r13,r23, 1,ns, myName//'Drght3' )
      call re_alloc( Vleft1, l11,l21, m12,m22, m13,m23, 1,ns, myName//'Vleft1' )
      call re_alloc( Vrght1, r11,r21, m12,m22, m13,m23, 1,ns, myName//'Vrght1' )
      call re_alloc( Vleft2, m11,m21, l12,l22, m13,m23, 1,ns, myName//'Vleft2' )
      call re_alloc( Vrght2, m11,m21, r12,r22, m13,m23, 1,ns, myName//'Vrght2' )
      call re_alloc( Vleft3, m11,m21, m12,m22, l13,l23, 1,ns, myName//'Vleft3' )
      call re_alloc( Vrght3, m11,m21, m12,m22, r13,r23, 1,ns, myName//'Vrght3' )
    end if ! (GGA)
  end if ! (myDistr/=ioDistr .or. GGA)

  ! Redistribute dens data
  ! This is a no-op if we have not changed the distribution
  if (associated(myDens)) then
    call associateMeshTask( io2my, ioDistr, myDistr )
    call copyMeshData( nMesh, ioDistr, dens, myBox, myDens, io2my )
!    call copyMeshData( nMesh, ioDistr, dens, myBox, myDens )
  end if

  ! If mesh arrays are distributed, find density of neighbor regions
  if (GGA .and. myDistr/=0) then ! Distributed Dens data
    ! Find density of neighbor regions
    do ic = 1,3  ! Loop on cell axes
      if (ic==1) then
        Dleft => Dleft1
        Drght => Drght1
      else if (ic==2) then 
        Dleft => Dleft2
        Drght => Drght2
      else ! (ic==3)
        Dleft => Dleft3
        Drght => Drght3
      end if ! (ic==1)
      boxLeft = myBox
      boxLeft(1,ic) = myBox(1,ic)-nn
      boxLeft(2,ic) = myBox(1,ic)-1
      boxRght = myBox
      boxRght(1,ic) = myBox(2,ic)+1
      boxRght(2,ic) = myBox(2,ic)+nn
      call associateMeshTask( my2left(ic), myDistr )
      call associateMeshTask( my2rght(ic), myDistr )
      call copyMeshData( nMesh, myDistr, myDens, boxLeft, Dleft, my2left(ic) )
      call copyMeshData( nMesh, myDistr, myDens, boxRght, Drght, my2rght(ic) )
!      call copyMeshData( nMesh, myDistr, myDens, boxLeft, Dleft )
!      call copyMeshData( nMesh, myDistr, myDens, boxRght, Drght )
    end do ! ic
  end if ! (GGA .and. myDistr/=0)

  ! Find Jacobian matrix dx/dmesh and gradient coeficients dGrad_i/dDens_j
  if (GGA) then

    ! Find mesh unit vectors dx/dmesh
    do ic = 1,3
      dXdM(:,ic) = cell(:,ic) / nMesh(ic)
    enddo

    ! Find reciprocal mesh vectors dmesh/dx
    call reclat( dXdM, dMdX, 0 )

    ! Find weights of numerical derivation from Lagrange interp. formula
    do in = -nn,nn
      f1 = 1.0_dp
      f2 = 1.0_dp
      do jn = -nn,nn
        if (jn/=in .and. jn/=0) f1 = f1 * (0  - jn)
        if (jn/=in)             f2 = f2 * (in - jn)
      enddo
      dGdM(in) = f1 / f2
    enddo
    dGdM(0) = 0.0_dp

    ! Find the weights for the derivative d(gradF(i))/d(F(j)) of
    ! the gradient at point i with respect to the value at point j
    do in = -nn,nn
      do ic = 1,3
        dGidFj(:,ic,in) = dMdX(:,ic) * dGdM(in)
      enddo
    enddo

  endif ! (GGA)

  ! Initialize output
  Ex = 0.0_dp
  Ec = 0.0_dp
  Dx = 0.0_dp
  Dc = 0.0_dp
  stress(:,:) = 0.0_dp
  Vxc(:,:,:,:) = 0.0_gp
  if (present(dVxcdD)) dVxcdD(:,:,:,:) = 0.0_gp
  if (present(epsxc)) epsxc(:,:,:) = 0.0_gp
  if (present(dexcdGD)) dexcdGD(:,:,:,:,:) = 0.0_gp

  ! VdW initializations -------------------------------------------------------
  if (VDW) then

    ! Find mask of nonempty points
    call re_alloc( nonempty, 0,myMesh(1)-1, 0,myMesh(2)-1, 0,myMesh(3)-1, &
                   myName//'nonempty' )
    if (associated(myDens)) then
      do i3 = myBox(1,3),myBox(2,3)
      do i2 = myBox(1,2),myBox(2,2)
      do i1 = myBox(1,1),myBox(2,1)
        Dtot = sum( myDens(i1,i2,i3,1:ndSpin) )
        if ( Dtot >= Dmin ) then
          nonempty(i1-myBox(1,1),i2-myBox(1,2),i3-myBox(1,3)) = .true.
        else
          nonempty(i1-myBox(1,1),i2-myBox(1,2),i3-myBox(1,3)) = .false.
        end if
      end do
      end do
      end do
    else
      do i3 = 0, myMesh(3)-1
      do i2 = 0, myMesh(2)-1
      do i1 = 0, myMesh(1)-1
        Dtot = sum( dens(i1,i2,i3,1:ndSpin) )
        if ( Dtot >= Dmin ) then
          nonempty(i1,i2,i3) = .true.
        else
          nonempty(i1,i2,i3) = .false.
        end if
      end do
      end do
      end do
    end if
    nonemptyPoints = count( nonempty )

    ! Find distribution of k-mesh points
    call fftMeshDistr( nMesh, kDistr )

    ! Find my node's box of k-mesh points
    call myMeshBox( nMesh, kDistr, kBox )
    kMesh(:) = kBox(2,:) - kBox(1,:) + 1
    kPoints = product( kMesh )

    ! Find a size large enough for both real and reciprocal points
    maxPoints = max( nonemptyPoints, kPoints )
    mesh = max( myMesh, kMesh )

    ! Allocate VdW arrays
    call vdw_get_qmesh( nq )
    call re_alloc( dudk,  1,nq,                   myName//'dudk' )
    call re_alloc( dtdd,  1,nq, 1,nSpin,          myName//'dtdd' )
    call re_alloc( dtdgd,  1,3,    1,nq, 1,nSpin, myName//'dtdgd')
    call re_alloc( dphidk,1,nq,    1,nq,          myName//'dphidk')
    call re_alloc( phi,   1,nq,    1,nq,          myName//'phi'  )
    call re_alloc( tk,    1,nq,                   myName//'tk'   )
    call re_alloc( tr,    1,nq,                   myName//'tr'   )
    call re_alloc( tvac,  1,nq,                   myName//'tvac' )
    call re_alloc( ur,    1,nq,                   myName//'ur'   )
    call re_alloc( uk,    1,nq,                   myName//'uk'   )
    call re_alloc( tvdw, 1,maxPoints, 1,nq,       myName//'tvdw' )
    call re_alloc( tq, 0,mesh(1)-1, 0,mesh(2)-1, 0,mesh(3)-1, 1,1, &
                   myName//'tq' )

    ! Assign another name to these arrays (but be careful!!!)
    uvdw => tvdw
    uq   => tq

    ! Set mesh cutoff to filter VdW kernel
    kcut = meshKcut( cell, nMesh )
    call vdw_set_kcut( kcut )

    ! Find vacuum value of theta
    D = 0._dp
    GD = 0._dp
    call vdw_theta( nSpin, D, GD, tr, dtdd, dtdgd )
    tvac = tr

#ifdef DEBUG_XC
!    call timer_start( 'cellXC1' )
#endif /* DEBUG_XC */

    ! Loop on mesh points to find theta_q(r)
    ip = 0
    do i3 = 0,myMesh(3)-1
    do i2 = 0,myMesh(2)-1
    do i1 = 0,myMesh(1)-1

      ! Skip point if density=0
      if (.not.nonempty(i1,i2,i3)) cycle
      ip = ip + 1

      ! Find mesh indexes relative to cell origin
      ii1 = i1 + myBox(1,1)  
      ii2 = i2 + myBox(1,2)
      ii3 = i3 + myBox(1,3)

      ! Find density at this point. Notice that mesh indexes of dens and myDens 
      ! are relative to box and cell origins, respectively
      if (associated(myDens)) then
        D(:) = myDens(ii1,ii2,ii3,:)
      else
        D(:) = dens(i1,i2,i3,:)
      end if

      ! Avoid negative densities
      D(1:ndSpin) = max( D(1:ndSpin), 0._dp )

      !  Find gradient of density at this point
      call getGradDens( ii1, ii2, ii3, GD )   ! This subr. is contained below

      ! Find expansion of theta(q(r)) for VdW
      call vdw_theta( nSpin, D, GD, tr, dtdd, dtdgd )
      tvdw(ip,1:nq) = tr(1:nq)

#ifdef DEBUG_XC
!      ! Write q(r) for debugging
!      if (i3==myBox(1,3)) then
!        if (i1==myBox(1,1) .and. i2==myBox(1,2)) then
!          open(unit=47,file='qvdw.out')
!        else if (i1==myBox(2,1) .and. i2==myBox(2,2)) then
!          close(unit=47)
!        end if
!        Dtot = sum(D(1:ndSpin))
!        do ix = 1,3
!          GDtot(ix) = sum(GD(ix,1:ndSpin))
!        end do
!        call qofrho( Dtot, GDtot, q, dqdD, dqdGD )
!        if (i1==myBox(1,1)) write(47,*) ' '
!        write(47,*) q
!      end if
#endif /* DEBUG_XC */

    enddo ! i1
    enddo ! i2
    enddo ! i3  (End of loop on mesh points to find theta_q(r))

#ifdef DEBUG_XC
!    call timer_stop( 'cellXC1' )
!    call timer_start( 'cellXC2' )
!    call timer_start( 'cellXC2.1' )
#endif /* DEBUG_XC */

    ! Fourier-tranform theta_iq(r)
    do iq = 1,nq
      ! Unpack nonempty points into a full-mesh array
      ! Last index (=1) is just because gridxc_fftr2k expects a rank 4 array
!      tq(0:myMesh(1)-1,0:myMesh(2)-1,0:myMesh(3)-1,1) = &  ! Slower!!!
!        unpack( tvdw(1:nonemptyPoints,iq), mask=nonempty, field=tvac(iq) )
      ip = 0
      do i3 = 0,myMesh(3)-1
      do i2 = 0,myMesh(2)-1
      do i1 = 0,myMesh(1)-1
        if (nonempty(i1,i2,i3)) then
          ip = ip+1
          tq(i1,i2,i3,1) = tvdw(ip,iq)
        else
          tq(i1,i2,i3,1) = tvac(iq)
        end if
      end do
      end do
      end do
      ! Peform Fourier transform
      call fftr2k( nMesh, myDistr, tq(:,:,:,1:1) )
      ! Store all reciprocal space points
!      tvdw(1:kPoints,iq) = &   ! Slower!!!
!        reshape( tq(0:kMesh(1)-1,0:kMesh(2)-1,0:kMesh(3)-1,1), (/kPoints/) )
      ik = 0
      do i3 = 0,kMesh(3)-1
      do i2 = 0,kMesh(2)-1
      do i1 = 0,kMesh(1)-1
        ik = ik+1
        tvdw(ik,iq) = tq(i1,i2,i3,1)
      end do
      end do
      end do
    end do ! iq

#ifdef DEBUG_XC
!    call timer_stop( 'cellXC2.1' )
!    call timer_start( 'cellXC2.2' )
#endif /* DEBUG_XC */

    ! Find reciprocal unit vectors
    call reclat( cell, kcell, 1 )

    ! Initialize nonlocal parts of VdW correlation energy and stress
    Enl = 0.0_dp
    EcuspVDW = 0.0_dp
    stressVDW = 0.0_dp

    ! Loop on k-mesh points
    ik = 0
    do i3 = 0,kMesh(3)-1   ! Mesh indexes relative to my k-box origin
    do i2 = 0,kMesh(2)-1
    do i1 = 0,kMesh(1)-1
      ik = ik + 1

      ! Find k vector
      ii1 = i1 + kBox(1,1)  ! Mesh indexes relative to reciprocal cell origin
      ii2 = i2 + kBox(1,2)
      ii3 = i3 + kBox(1,3)
      if (ii1 > nMesh(1)/2) ii1 = ii1 - nMesh(1)
      if (ii2 > nMesh(2)/2) ii2 = ii2 - nMesh(2)
      if (ii3 > nMesh(3)/2) ii3 = ii3 - nMesh(3)
      kvec(:) = kcell(:,1)*ii1 + kcell(:,2)*ii2 + kcell(:,3)*ii3
      k = sqrt( sum(kvec**2) )

      if (k<kcut) then

        ! Find Fourier transform of VdW kernel phi(r,r')
        call vdw_phi( k, phi, dphidk )

        ! Find Fourier transform of Int_dr'*phi(r,r')*rho(r')
        ! Warning: tvdw and uvdw are the same array
        tk(1:nq) = tvdw(ik,1:nq)
        uk(1:nq) = matmul( tk(1:nq), phi(1:nq,1:nq) )
        uvdw(ik,1:nq) = uk(1:nq)

#ifdef DEBUG_XC
!        ! Find contribution to 0.5*Int_dr*Int_dr'*rho(r)*phi(r,r')*rho(r')
!        ! Factor 0.5 in the integral cancels with a factor 2 required 
!        ! because tk and uk contain only the real or imaginary parts
!        ! of the Fourier components (see fftr2k) 
!        Enl = Enl + volume * sum(uk*tk)
#endif /* DEBUG_XC */

        ! Find contribution to stress from change of k vectors with strain
        if (k > kmin) then  ! Avoid k=0 (whose contribution is zero)
          dudk(1:nq) = matmul( tk(1:nq), dphidk(1:nq,1:nq) )
          ! See note above on cancelation of factors 0.5 and 2 in Enl
          dedk = sum(dudk*tk) * (volume / k)
          do jx = 1,3
            do ix = 1,3
              stressVDW(ix,jx) = stressVDW(ix,jx) - dedk * kvec(ix) * kvec(jx)
            end do
          end do
        end if ! (k>kmin)

      else
        uvdw(ik,1:nq) = 0.0_gp
      end if ! (k<kcut)

    end do ! i1
    end do ! i2
    end do ! i3  End of loop on k-mesh points

#ifdef DEBUG_XC
!    call timer_stop( 'cellXC2.2' )
!    call timer_start( 'cellXC2.3' )
#endif /* DEBUG_XC */

#ifdef DEBUG_XC
!    print'(a,3f12.6)','cellXC: Ex,Ec,Enl (eV) =', &
!      Ex/0.03674903_dp, Ec/0.03674903_dp, Enl/0.03674903_dp
#endif /* DEBUG_XC */

    ! Fourier-tranform u_q(k) back to real space
    do iq = 1,nq
!      uq(0:kMesh(1)-1,0:kMesh(2)-1,0:kMesh(3)-1,1) = &    ! Slower!!!
!        reshape( uvdw(1:kPoints,iq), kMesh )
      ik = 0
      do i3 = 0,kMesh(3)-1
      do i2 = 0,kMesh(2)-1
      do i1 = 0,kMesh(1)-1
        ik = ik+1
        uq(i1,i2,i3,1) = uvdw(ik,iq)
      end do
      end do
      end do
      call fftk2r( nMesh, myDistr, uq(:,:,:,1:1) )
!      uvdw(1:nonemptyPoints,iq) = &    ! Slower!!!
!        pack( uq(0:myMesh(1)-1,0:myMesh(2)-1,0:myMesh(3)-1,1), mask=nonempty )
      ip = 0
      do i3 = 0,myMesh(3)-1
      do i2 = 0,myMesh(2)-1
      do i1 = 0,myMesh(1)-1
        if (nonempty(i1,i2,i3)) then
          ip = ip+1
          uvdw(ip,iq) = uq(i1,i2,i3,1)
        end if
      end do
      end do
      end do
    end do

#ifdef DEBUG_XC
!    call timer_stop( 'cellXC2.3' )
!    call timer_stop( 'cellXC2' )
#endif /* DEBUG_XC */

#ifdef DEBUG_XC
!    ! Re-initialize Enl if it has been calculated in reciprocal space
!    Enl = 0.0_dp
#endif /* DEBUG_XC */

  end if ! (VDW) End of VdW initializations------------------------------------

#ifdef DEBUG_XC
!  call timer_start( 'cellXC3' )
#endif /* DEBUG_XC */

  
  ! Loop on mesh points -------------------------------------------------------
  ip = 0
  do i3 = 0,myMesh(3)-1   ! Mesh indexes relative to my box origin
  do i2 = 0,myMesh(2)-1
  do i1 = 0,myMesh(1)-1
    ii1 = i1 + myBox(1,1) ! Mesh indexes relative to cell origin
    ii2 = i2 + myBox(1,2)
    ii3 = i3 + myBox(1,3)

    ! Find density at this point. Notice that mesh indexes of dens and myDens 
    ! are relative to box and cell origins, respectively
    if (associated(myDens)) then
      D(:) = myDens(ii1,ii2,ii3,:)
    else
      D(:) = dens(i1,i2,i3,:)
    end if

    ! Skip point if density=0
    Dtot = sum(D(1:ndSpin))
    if (Dtot < Dmin) cycle ! i1 loop on mesh points
    ip = ip + 1

    ! Avoid negative densities
    D(1:ndSpin) = max( D(1:ndSpin), 0._dp )

    ! Find gradient of density at this point
    if (GGA) call getGradDens( ii1, ii2, ii3, GD )

    ! Loop over all functionals
    do nf = 1,nXCfunc

      ! Is this a VDW or GGA?
      if (XCfunc(nf).eq.'VDW' .or. XCfunc(nf).eq.'vdw') then
        VDWfunctl = .true.
        GGAfunctl = .true.
      else if (XCfunc(nf).eq.'GGA' .or. XCfunc(nf).eq.'gga') then
        VDWfunctl = .false.
        GGAfunctl = .true.
      else
        VDWfunctl = .false.
        GGAfunctl = .false.
      endif

      ! Find exchange and correlation energy densities and their 
      ! derivatives with respect to density and density gradient
      if (VDWfunctl) then

        ! Local exchange-corr. part from the apropriate LDA/GGA functional
        call vdw_localxc( irel, nSpin, D, GD, epsX, epsC, &
                          dExdD, dEcdD, dExdGD, dEcdGD )

#ifdef DEBUG_XC
!        ! Select only non local correlation energy and potential
!        epsX = 0
!        epsC = 0
!        dExdD = 0
!        dEcdD = 0
!        dExdGD = 0
!        dEcdGD = 0
#endif /* DEBUG_XC */

        ! Local cusp correction to nonlocal VdW energy integral
        call vdw_decusp( nSpin, D, GD, epsCusp, dEcuspdD, dEcuspdGD )

#ifdef DEBUG_XC
!        ! Select only non local correlation energy and potential
!        epsCusp = 0
!        dEcuspdD = 0
!        dEcuspdGD = 0
#endif /* DEBUG_XC */

        ! Find expansion of theta(q(r)) for VdW
        call vdw_theta( nSpin, D, GD, tr, dtdd, dtdgd )

        ! Add nonlocal VdW energy contribution and its derivatives
        Dtot = sum(D(1:ndSpin))
        ur(1:nq) = uvdw(ip,1:nq)
        epsNL = epsCusp + 0.5_dp*sum(ur*tr)/(Dtot+tiny(Dtot))
        epsC = epsC + epsNL
        do is = 1,nSpin
          dEcdD(is) = dEcdD(is) + dEcuspdD(is) + sum(ur(1:nq)*dtdd(1:nq,is))
          do ix = 1,3
            dEcdGD(ix,is) = dEcdGD(ix,is) + dEcuspdGD(ix,is) + &
                            sum(ur(1:nq)*dtdgd(ix,1:nq,is))
          end do
        end do

        ! Sum nonlocal VdW contributions for debugging
        EcuspVDW = EcuspVDW + dVol * Dtot * epsCusp
        Enl = Enl + dVol * Dtot * epsNL

#ifdef DEBUG_XC
!        if (i1==0 .and. i2==0 .and. i3==0) then
!          open( unit=33, file='epsNL'//trim(nodeString()), form='formatted' )
!          write(33,'(3f12.6,i6)') (cell(:,ix),nMesh(ix),ix=1,3)
!        end if
!        write(33,'(3i6,3e15.6)') ii1, ii2, ii3, Dtot, epsNL, epsX+epsC
!        ! Alternatively, write x,y,z instead of i1,i2,i3
!        write(33,'(3f12.6,2e15.6)') &
!          ii1*cell(:,1)/nMesh(1), &
!          ii2*cell(:,2)/nMesh(2), &
!          ii3*cell(:,3)/nMesh(3), Dtot, epsNL
#endif /* DEBUG_XC */

      else if (GGAfunctl) then
        call ggaxc( XCauth(nf), irel, nSpin, D, GD, &
                    epsX, epsC, dExdD, dEcdD, dExdGD, dEcdGD  &
#ifdef HAVE_LIBXC
                    , is_libxc(nf), xc_func(nf), xc_info(nf) )
#else
                    )
#endif
      else ! (.not.VDWfunctl .and. .not.GGAfunctl)
        call ldaxc( XCauth(nf), irel, nSpin, D, &
                    epsX, epsC, dExdD, dEcdD, dVxdD, dVcdD  &
#ifdef HAVE_LIBXC
                    , is_libxc(nf), xc_func(nf), xc_info(nf) )
#else
                    )
#endif
      endif ! (VDWfunctl)

      ! Scale return values by weight for this functional
      epsX = XCweightX(nf)*epsX
      epsC = XCweightC(nf)*epsC
      dExdD(:) = XCweightX(nf)*dExdD(:)
      dEcdD(:) = XCweightC(nf)*dEcdD(:)
      if (GGAfunctl) then
        dExdGD(:,:) = XCweightX(nf)*dExdGD(:,:)
        dEcdGD(:,:) = XCweightC(nf)*dEcdGD(:,:)
      endif
      if (present(dVxcdD)) then
        dVxdD(:) = XCweightX(nf)*dVxdD(:)
        dVcdD(:) = XCweightC(nf)*dVcdD(:)
      endif

      ! Add contributions to exchange-correlation energy and its
      ! derivatives with respect to density at this point
      Ex = Ex + dVol * Dtot * epsX
      Ec = Ec + dVol * Dtot * epsC

      if (present(epsxc)) then
         epsxc(i1,i2,i3) = epsX + epsC
      endif
      if (present(dexcdGD)) then
         dexcdGD(i1,i2,i3,:,:) = dExdGD(:,:) + dEcdGD(:,:)
      endif

      Dx = Dx + dVol * Dtot * epsX
      Dc = Dc + dVol * Dtot * epsC
      Dx = Dx - dVol * sum(D(:)*dExdD(:))
      Dc = Dc - dVol * sum(D(:)*dEcdD(:))
      if (associated(myVxc)) then
        myVxc(ii1,ii2,ii3,:) = myVxc(ii1,ii2,ii3,:) + dExdD(:) + dEcdD(:)
      else  ! Add directly to output array Vxc
        Vxc(i1,i2,i3,:) = Vxc(i1,i2,i3,:) + dExdD(:) + dEcdD(:)
      end if ! (associated(myVxc))

      if (present(dVxcdD)) then
        if (associated(mydVxcdD)) then
          mydVxcdD(ii1,ii2,ii3,:) = mydVxcdD(ii1,ii2,ii3,:) + dVxdD(:)+dVcdD(:)
        else
          dVxcdD(i1,i2,i3,:) = dVxcdD(i1,i2,i3,:) + dVxdD(:) + dVcdD(:)
        end if
      end if ! (present(dVxcdD))

      ! Add contributions to exchange-correlation potential
      ! with respect to density at neighbor points
      if (GGAfunctl) then
        if (myDistr==0) then   ! dens data not distributed
          do ic = 1,3          ! Loop on cell axes
            do in = -nn,nn     ! Loop on finite difference index
              ! Find mesh indexes of neighbor point
              jj(1) = ii1
              jj(2) = ii2
              jj(3) = ii3
              jj(ic) = modulo( jj(ic)+in, nMesh(ic) )
              ! Add contributions from dE/dGradDi * dGradDi/dDj
              ! Notice: for myDistr==0, box and cell origins are equal
              do is = 1,nSpin  ! Loop on spin component
                dExidDj = sum( dExdGD(:,is) * dGidFj(:,ic,in) )
                dEcidDj = sum( dEcdGD(:,is) * dGidFj(:,ic,in) )
                Dx = Dx - dVol * dens(jj(1),jj(2),jj(3),is) * dExidDj
                Dc = Dc - dVol * dens(jj(1),jj(2),jj(3),is) * dEcidDj
                Vxc(jj(1),jj(2),jj(3),is) = Vxc(jj(1),jj(2),jj(3),is) + &
                                            dExidDj + dEcidDj
              end do ! is
            end do ! in
          end do ! ic
        else ! (myDistr/=0)      Distributed dens data
          do ic = 1,3          ! Loop on cell axes
            if (ic==1) then
              Dleft => Dleft1
              Drght => Drght1
              Vleft => Vleft1
              Vrght => Vrght1
            else if (ic==2) then 
              Dleft => Dleft2
              Drght => Drght2
              Vleft => Vleft2
              Vrght => Vrght2
            else ! (ic==3)
              Dleft => Dleft3
              Drght => Drght3
              Vleft => Vleft3
              Vrght => Vrght3
            end if ! (ic==1)
            do in = -nn,nn     ! Loop on finite difference index
              ! Find indexes jj(:) of neighbor point
              jj(1) = ii1  ! Warning: jj(:)=(/ii1,ii2,ii3/) is VERY slow!!!
              jj(2) = ii2
              jj(3) = ii3
              jj(ic) = jj(ic) + in
              ! Point Dj and Vj to the apropriate array
              if (jj(ic)<myBox(1,ic)) then ! Left neighbor region
                Dj =  Dleft(jj(1),jj(2),jj(3),1:nSpin)
                Vj => Vleft(jj(1),jj(2),jj(3),1:nSpin)
              else if (jj(ic)>myBox(2,ic)) then ! Right region
                Dj =  Drght(jj(1),jj(2),jj(3),1:nSpin)
                Vj => Vrght(jj(1),jj(2),jj(3),1:nSpin)
              else ! j within myBox
                Dj = myDens(jj(1),jj(2),jj(3),1:nSpin)
                Vj => myVxc(jj(1),jj(2),jj(3),1:nSpin)
              end if
              ! Add contributions from dE/dGradDi * dGradDi/dDj
              do is = 1,nSpin  ! Loop on spin component
                dExidDj = sum( dExdGD(:,is) * dGidFj(:,ic,in) )
                dEcidDj = sum( dEcdGD(:,is) * dGidFj(:,ic,in) )
                Dx = Dx - dVol * Dj(is) * dExidDj
                Dc = Dc - dVol * Dj(is) * dEcidDj
                Vj(is) = Vj(is) + dExidDj + dEcidDj
              end do ! is
            end do ! in
          end do ! ic
        end if ! (myDistr==0)
      end if ! (GGAfunctl)

      ! Add contribution to stress due to change in gradient of density
      ! originated by the deformation of the mesh with strain
      if (GGAfunctl) then
        do jx = 1,3
          do ix = 1,3
            do is = 1,nSpin
              stress(ix,jx) = stress(ix,jx) - dVol * GD(ix,is) * &
                               ( dExdGD(jx,is) + dEcdGD(jx,is) )
            enddo
          enddo
        enddo
      endif ! (GGAfunctl)

    enddo ! nf (End of loop over functionals)

  enddo ! i1
  enddo ! i2
  enddo ! i3  (End of loop over mesh points)-----------------------------------

#ifdef HAVE_LIBXC
  do nf = 1,nXCfunc
    if (is_libxc(nf)) then
#if XC_MAJOR_VERSION >= 4
      call xc_f03_func_end(xc_func(nf))
#else
      call xc_f90_func_end(xc_func(nf))
#endif
    endif
  enddo
  deallocate(xc_func,xc_info,is_libxc)
#endif
  
#ifdef DEBUG_XC
  close( unit=33 )
#endif /* DEBUG_XC */

  ! If mesh arrays are distributed, add Vxc contribution from neighbor regions
  if (GGA .and. myDistr/=0) then ! Distributed Vxc data
    ! Add neighbor regions contribution to myVxc array
    do ic = 1,3  ! Loop on cell axes
      if (ic==1) then
        Vleft => Vleft1
        Vrght => Vrght1
      else if (ic==2) then 
        Vleft => Vleft2
        Vrght => Vrght2
      else ! (ic==3)
        Vleft => Vleft3
        Vrght => Vrght3
      end if ! (ic==1)
      boxLeft = myBox
      boxLeft(1,ic) = myBox(1,ic)-nn
      boxLeft(2,ic) = myBox(1,ic)-1
      boxRght = myBox
      boxRght(1,ic) = myBox(2,ic)+1
      boxRght(2,ic) = myBox(2,ic)+nn
      call associateMeshTask( left2my(ic), myDistr )
      call associateMeshTask( rght2my(ic), myDistr )
      call addMeshData( nMesh, boxLeft, Vleft, myDistr, myVxc, left2my(ic) )
      call addMeshData( nMesh, boxRght, Vrght, myDistr, myVxc, rght2my(ic) )
!      call addMeshData( nMesh, boxLeft, Vleft, myDistr, myVxc )
!      call addMeshData( nMesh, boxRght, Vrght, myDistr, myVxc )
    end do ! ic
  end if ! (GGA .and. myDistr/=0)

  ! Make Vxc=0 if VDWfunctl and Dens<Dcut, to avoid singularities
  if (VDWfunctl) then
    do i3 = 0,myMesh(3)-1   ! Mesh indexes relative to my box origin
    do i2 = 0,myMesh(2)-1
    do i1 = 0,myMesh(1)-1
      ii1 = i1 + myBox(1,1) ! Mesh indexes relative to cell origin
      ii2 = i2 + myBox(1,2)
      ii3 = i3 + myBox(1,3)
      if (associated(myDens)) then
        Dtot = sum( myDens(ii1,ii2,ii3,1:ndSpin) )
      else
        Dtot = sum( dens(i1,i2,i3,1:ndSpin) )
      end if
      if (Dtot<Dcut) then
        if (associated(myVxc)) then
          myVxc(ii1,ii2,ii3,:) = 0
        else
          Vxc(i1,i2,i3,:) = 0
        end if
        if (present(dVxcdD)) then
          if (associated(mydVxcdD)) then
            mydVxcdD(ii1,ii2,ii3,:) = 0
          else
            dVxcdD(i1,i2,i3,:) = 0
          end if
        end if ! (present(dVxcdD))
      end if ! (Dtot<Dcut)
    end do
    end do
    end do
  end if ! (VDWfunctl)

  ! Copy Vxc data to output arrays
  if (associated(myVxc)) then  ! Distributed Vxc array
    if (sameMeshDistr(ioDistr,myDistr)) then ! Just copy myVxc to output array
      Vxc = myVxc
      if (present(dVxcdD)) dVxcdD = mydVxcdD
    else ! Redistribution required
      ! Copy myVxc and dVxcdD to output box
      call associateMeshTask( my2io, myDistr )
      call copyMeshData( nMesh, myDistr, myVxc, ioBox, Vxc, my2io )
      if (present(dVxcdD)) &
        call copyMeshData( nMesh, myDistr, mydVxcdD, ioBox, dVxcdD, my2io )
    end if ! (sameMeshDistr(ioDistr,myDistr))
  end if ! (associated(myVxc))

#ifdef DEBUG_XC
!  call timer_stop( 'cellXC3' )
#endif /* DEBUG_XC */

#ifdef DEBUG_XC
!  ! Some printout for debugging
!  if (VDW) then
!    print'(a,f12.6)', &
!         'cellXC: EcuspVDW (eV) =', EcuspVDW/0.03674903_dp
!    print'(a,3f12.6)','cellXC: Ex,Ecl,Ecnl (eV) =', &
!         Ex/0.03674903_dp, (Ec-Enl)/0.03674903_dp, Enl/0.03674903_dp
!  end if
#endif /* DEBUG_XC */

  ! Add contribution to stress from the change of volume with strain
  forall(ix=1:3) stress(ix,ix) = stress(ix,ix) + Ex + Ec

  ! Add contribution to stress from change of k vectors with strain
  if (VDW) stress = stress + stressVDW * XCweightVDW

  ! Divide by volume to get correct stress definition (dE/dStrain)/Vol
  stress = stress / volume

  ! Divide by energy unit
  Ex = Ex / Eunit
  Ec = Ec / Eunit
  Dx = Dx / Eunit
  Dc = Dc / Eunit
  Vxc = Vxc / Eunit
  stress = stress / Eunit
  if (present(dVxcdD)) dVxcdD = dVxcdD / Eunit
  if (present(epsxc)) epsxc = epsxc / Eunit
  if (present(dexcdGD)) dexcdGD = dexcdGD / Eunit

  ! Deallocate VDW-related arrays
  if (VDW) then
    call de_alloc( tq,       myName//'tq' )
    call de_alloc( tvdw,     myName//'tvdw' )
    call de_alloc( uk,       myName//'uk' )
    call de_alloc( ur,       myName//'ur' )
    call de_alloc( tvac,     myName//'tvac' )
    call de_alloc( tr,       myName//'tr' )
    call de_alloc( tk,       myName//'tk' )
    call de_alloc( phi,      myName//'phi' )
    call de_alloc( dphidk,   myName//'dphidk' )
    call de_alloc( dtdgd,    myName//'dtdgd' )
    call de_alloc( dtdd,     myName//'dtdd' )
    call de_alloc( dudk,     myName//'dudk' )
    call de_alloc( nonempty, myName//'nonempty' )
  end if

  ! Deallocate GGA-related arrays
  if (associated(myDens)) then
    if (GGA) then
      call de_alloc( Vrght3, myName//'Vrght3' )
      call de_alloc( Vleft3, myName//'Vleft3' )
      call de_alloc( Vrght2, myName//'Vrght2' )
      call de_alloc( Vleft2, myName//'Vleft2' )
      call de_alloc( Vrght1, myName//'Vrght1' )
      call de_alloc( Vleft1, myName//'Vleft1' )
      call de_alloc( Drght3, myName//'Drght3' )
      call de_alloc( Dleft3, myName//'Dleft3' )
      call de_alloc( Drght2, myName//'Drght2' )
      call de_alloc( Dleft2, myName//'Dleft2' )
      call de_alloc( Drght1, myName//'Drght1' )
      call de_alloc( Dleft1, myName//'Dleft1' )
    end if
    if (present(dVxcdD)) call de_alloc( mydVxcdD, myName//'mydVxcdD'  )
    call de_alloc( myVxc,  myName//'myVxc'  )
    call de_alloc( myDens, myName//'myDens' )
  end if ! (associated(myDens))

  ! Restore previous allocation defaults
  call alloc_default( restore=prevAllocDefaults )


  ! Get local calculation time (excluding communications?)
  ! cpu or walltime?
  ! deactivated for now
  !  call timer_get( myName, lastTime=totTime, lastCommTime=comTime )
  !  myTime = totTime - comTime

  myTime = 0.0_dp
  sumTime  = myTime
  sumTime2 = myTime**2

  ! Add integrated magnitudes from all processors
  call miscAllReduce( 'sum', Ex, Ec, Dx, Dc, sumTime, sumTime2, a2=stress)

  ! Find average and dispersion of CPU time
  timeAvge = sumTime / nodes
  timeDisp = sqrt( max( sumTime2/nodes - timeAvge**2, 0._dp ) )

#ifdef DEBUG_XC
  write(udebug,'(a,3f12.6,/)') &
    myName//'My CPU time, avge, rel.disp =', &
    myTime, timeAvge, timeDisp/timeAvge
#endif /* DEBUG_XC */

  ! Stop time counter
  call timer_stop( myName )

CONTAINS !---------------------------------------------------------------------

  subroutine getGradDens( ii1, ii2, ii3, GD )

  ! Finds the density gradient at one mesh point

  ! Arguments
  integer, intent(in) :: ii1, ii2, ii3  ! Global mesh point indexes
  real(dp),intent(out):: GD(3,nSpin) ! Density gradient

  ! Variables and arrays accessed from parent subroutine:
  !   dens, Dleft1, Dleft2, Dleft3, 
  !   Drght1, Drght2, Drght3, DGiDFj,
  !   myBox, myDistr, nn, nSpin

  ! Local variables and arrays
  integer :: ic, in, is, jj(3)
  real(dp):: Dj(nSpin)
  real(gp),pointer:: Dleft(:,:,:,:), Drght(:,:,:,:)

  GD(:,:) = 0
  if (myDistr==0) then   ! dens data not distributed
    do ic = 1,3          ! Loop on cell axes
      do in = -nn,nn     ! Loop on finite difference index
        ! Find index jp of neighbor point
        jj(1) = ii1  ! Warning: jj(:)=(/ii1,ii2,ii3/) is VERY slow!!!
        jj(2) = ii2
        jj(3) = ii3
        jj(ic) = modulo( jj(ic)+in, nMesh(ic) )
        ! Find contribution of density at j to gradient at i
        do is = 1,nSpin
          do ix = 1,3  ! Warning: GD(:,is)=GD(:,is)+... is slower!!!
            GD(ix,is) = GD(ix,is) + DGiDFj(ix,ic,in) * &
                                    dens(jj(1),jj(2),jj(3),is)
          end do ! ix
        end do ! is
      end do ! in
    end do ! ic
  else                   ! Distributed dens data
    do ic = 1,3          ! Loop on cell axes
      if (ic==1) then
        Dleft => Dleft1
        Drght => Drght1
      else if (ic==2) then 
        Dleft => Dleft2
        Drght => Drght2
      else ! (ic==3)
        Dleft => Dleft3
        Drght => Drght3
      end if ! (ic==1)
      do in = -nn,nn     ! Loop on finite difference index
        ! Find indexes jj(:) of neighbor point
        jj(1) = ii1
        jj(2) = ii2
        jj(3) = ii3
        jj(ic) = jj(ic) + in
        ! Find density Dj at neighbor point j
        if (jj(ic)<myBox(1,ic)) then ! Left neighbor region
          Dj(1:nSpin) = Dleft(jj(1),jj(2),jj(3),1:nSpin)
        else if (jj(ic)>myBox(2,ic)) then ! Right region
          Dj(1:nSpin) = Drght(jj(1),jj(2),jj(3),1:nSpin)
        else ! j within myBox
          Dj(1:nSpin) = myDens(jj(1),jj(2),jj(3),1:nSpin)
        end if
        ! Find contribution of density at j to gradient at i
        do is = 1,nSpin  ! Loop on spin component
          do ix = 1,3    ! Warning: GD(:,is)=GD(:,is)+... is slower!!!
            GD(ix,is) = GD(ix,is) + DGiDFj(ix,ic,in) * Dj(is)
          end do ! ix
        end do ! is
      end do ! in
    end do ! ic
  end if ! (myDistr==0)

  end subroutine getGradDens

END SUBROUTINE cellXC

END MODULE gridxc_cell

#if defined HAVE_CONFIG_H
#include "config.h"
#endif

!!@LICENSE
!
! *********************************************************************
! MODULE m_radfft
!
!   Public procedures provided:
! subroutine radfft              ! Radial fast Fourier transform
! 
!   Public parameters, variables, and arrays:
! none
!
!   Used module procedures:
! use gridxc_bessph,  only: bessph    ! Spherical Bessel functions
! use gridxc_fft_gpfa,only: fft_gpfa_ez ! Fourier transform
! use gridxc_alloc,     only: de_alloc  ! Deallocation routines
! use gridxc_alloc,     only: re_alloc  ! (Re)allocation routines
!
!   Used module parameters:
! use gridxc_precision, only: dp        ! Double precision real kind
!
! *********************************************************************
! SUBROUTINE RADFFT( L, NR, RMAX, F, G )
! *********************************************************************
! Makes a fast Fourier transform of a radial function.
! If function f is of the form
!   f(r_vec) = F(r_mod) * Ylm(theta,phi)
! where Ylm is a spherical harmonic with l = argument L, and
! argument F contains on input the real function F(r_mod), in a uniform
! radial grid:
!   r_mod = ir * RMAX / NR,  ir = 0,1,...,NR,
! and if g is the 3-dimensional Fourier transform of f:
!   g(k_vec) = 1/(2*pi)**(3/2) *
!              Integral( d3_r_vec * exp(-i * k_vec * r_vec) * f(r_vec) )
! then g has the form
!   g(k_vec) = (-i)**L * G(k_mod) * Ylm(theta,phi)
! where argument G contains on output the real function G(k_mod) in
! a uniform radial grid:
!   k_mod = ik * k_max / NR, ik = 0,1,...,NR,  k_max = NR*pi/RMAX
! Ref: J.M.Soler notes of 16/08/95.
! *************** INPUT ***********************************************
! INTEGER L       : Angular momentum quantum number
! INTEGER NR      : Number of radial intervals.
!                   2*NR must be an acceptable number of points for the
!                   FFT routine used.
! REAL*8  RMAX    : Maximum radius
! REAL*8  F(0:NR) : Function to be tranformed, in a radial mesh
! *************** OUTPUT **********************************************
! REAL*8  G(0:NR) : Fourier transform of F (but see point 5 below)
! *************** UNITS ***********************************************
! Units of RMAX and F are arbitrary.
! Units of k_max and G are related with those of RMAX and F in the
!   obvious way (see above).
! *************** BEHAVIOUR *******************************************
! 1) F and G may be the same physical array, i.e. it is allowed:
!      CALL RADFFT( L, NR, RMAX, F, F )
! 2) It also works in the opposite direction, but then the factor
!    multiplying the output is (+i)**L. Thus, the following two calls
!      CALL RADFFT( L, NR, RMAX, F, G )
!      CALL RADFFT( L, NR, NR*PI/RMAX, G, H )
!    make H = F
! 3) If you will divide the output by q**l, truncation errors may be
!    quite large for small k's if L and NR are large. Therefore, these
!    components are calculated by direct integration rather than FFT.
!    Parameter ERRFFT is the typical truncation error in the FFT, and
!    controls which k's are integrated directly. A good value is 1e-8.
!    If you will not divide by k**l, make ERRFFT=1.e-30.
! 4) The function F is assumed to be zero at and beyond RMAX. The last
!    point F(NR) is not used to find G, except G(0) for L=0 (see 5)
! 5) Because of the 'uncertainty principle', if f(r) is strictly zero
!    for r>RMAX, then g(k) cannot be strictly zero for k>kmax.
!    Therefore G(NR), which should be exactly zero, is used (for L=0)
!    as a 'reminder' term for the integral of G beyond kmax, to ensure 
!    that F(0)=Sum[4*pi*r**2*dr*G(IR)] (this allows to recover F(0)
!    when called again in the inverse direction). Thus, the last value
!    G(NR) should be replaced by zero for any other use. NOTICE: this
!    is commented out in this version!
! *********************************************************************
! Written by J.M.Soler. August 1996.
! Work arrays handling by Rogeli Grima, ca 2009
! *********************************************************************

      MODULE gridxc_radfft

      USE gridxc_precision, only: dp        ! Double precision real kind
      USE gridxc_bessph,  only: bessph    ! Spherical Bessel functions
      use gridxc_fft_gpfa,only: fft_gpfa_ez     ! 1D fast Fourier transform
      USE gridxc_alloc,     only: re_alloc, de_alloc

      implicit none

      PUBLIC :: radfft               ! Radial fast Fourier transform
      PUBLIC :: reset_radfft         ! Deallocates work arrays

      PRIVATE

      ! Work arrays held in module to minimize reallocations
      ! Note that we avoid "automatic" arrays, which may cause stack problems
      real(dp), pointer :: GG(:)
      real(dp), pointer :: FN(:,:)
      real(dp), pointer :: P(:,:,:)
      integer           :: MAXL = -1
      integer           :: MAXNR = -1

      CONTAINS

      SUBROUTINE RADFFT( L, NR, RMAX, F, G )

        use iso_c_binding, only : c_loc, c_f_pointer
        
! Declare argument types and dimensions -----------------------------
      INTEGER, intent(in) :: L       ! Angular momentum of function
      INTEGER, intent(in) :: NR      ! Number of radial points
      real(dp),intent(in) :: RMAX    ! Radius of last point
      real(dp),intent(in) :: F(0:NR) ! Function to Fourier-transform
      real(dp),intent(out):: G(0:NR) ! Fourier transform of F(r)
! -------------------------------------------------------------------

! ERRFFT is the typical truncation error in the FFT routine ---------
      real(dp),   PARAMETER ::    ERRFFT = 1.0E-8_dp
! -------------------------------------------------------------------

! Internal variable types and dimensions ----------------------------
      INTEGER  ::  I, IQ, IR, JR, M, MQ, N, NQ
      real(dp) ::  C, DQ, DR, FR, PI, R, RN, Q, QMAX
!!      real(dp) ::  GG(0:2*NR), FN(2,0:2*NR), P(2,0:L,0:L)
! -------------------------------------------------------------------

      real(dp), pointer :: fn_real_1d(:)
!
!     Allocate local memory 
      if (MAXL.eq.-1) nullify(P)
      if (L.GT.MAXL) then
        call re_alloc( P, 1, 2, 0, L, 0, L, 'P', 'RADFFT' )
        MAXL=L
      endif
      if (MAXNR.eq.-1) nullify(FN,GG)
      if (NR.GT.MAXNR) then
        call re_alloc( FN, 1, 2, 0, 2*NR, 'FN', 'RADFFT' )
        call re_alloc( GG, 0, 2*NR, 'GG', 'RADFFT' )
        MAXNR=NR
      endif

! Find some constants -----------------------------------------------
      PI = 4.D0 * ATAN( 1.D0 )
      NQ = NR
      DR = RMAX / NR
      DQ = PI / RMAX
      QMAX = NQ * DQ
      C = DR / SQRT( 2.D0*PI )
! -------------------------------------------------------------------

! Set up a complex polynomial such that the spherical Bessel function:
!   j_l(x) = Real( Sum_n( P(n,l) * x**n ) * exp(i*x) ) / x**(l+1)
      P(1,0,0) =  0.D0
      P(2,0,0) = -1.D0
      if (l.gt.0) then
        P(1,0,1) =  0.D0
        P(2,0,1) = -1.D0
        P(1,1,1) = -1.D0
        P(2,1,1) =  0.D0
        if (l.gt.1) then
          DO M = 2,L
          DO N = 0,M
          DO I = 1,2
            P(I,N,M) = 0.D0
            IF (N .LT. M) P(I,N,M) = P(I,N,M) + (2*M-1) * P(I,N,M-1)
            IF (N .GE. 2) P(I,N,M) = P(I,N,M) - P(I,N-2,M-2)
          ENDDO
          ENDDO
          ENDDO
        endif
      endif
! -------------------------------------------------------------------

! Initialize accumulation array -------------------------------------
      DO IQ = 0,NQ
        GG(IQ) = 0.D0
      ENDDO
! -------------------------------------------------------------------

! Iterate on terms of the j_l(q*r) polynomial -----------------------
      DO N = 0,L

!       Set up function to be fast fourier transformed
        FN(1,0) = 0.D0
        FN(2,0) = 0.D0
        DO JR = 1, 2*NR-1

          IF (JR .LT. NR) THEN
            IR = JR
            R = IR * DR
            FR = F(IR)
          ELSEIF (JR .EQ. NR) THEN
            IR = JR
            R = IR * DR
            FR = 0.D0
          ELSE
            IR = 2*NR - JR
            R = - (IR * DR)
            FR = F(IR) * (-1.D0)**L
          ENDIF

!         Find  r**2 * r**n / r**(l+1)
          RN = R**(N-L+1)

          FN(1,JR) = C * FR * RN * P(1,N,L)
          FN(2,JR) = C * FR * RN * P(2,N,L)
        ENDDO

!       Perform one-dimensional complex FFT
!
!       Only the elements from 0 to 2*NR-1 of FN are used.
!       (a total of 2*NR). The fft routine will receive a one-dimensional
!       array of size 2*NR.
!
        call c_f_pointer(c_loc(FN(1,0)),fn_real_1d,[4*NR])
        CALL fft_gpfa_ez( fn_real_1d, 2*NR, +1 )

!       Accumulate contribution
        DO IQ = 1,NQ
          Q = IQ * DQ
          GG(IQ) = ( GG(IQ) + FN(1,IQ) ) / Q
        ENDDO

      ENDDO
! -------------------------------------------------------------------

! Special case for Q=0 ---------------------------------------------
      GG(0) = 0.D0
      IF ( L .EQ. 0 ) THEN
        DO IR = 1,NR
          R = IR * DR
          GG(0) = GG(0) + R*R * F(IR)
        ENDDO
        GG(0) = GG(0) * 2.D0 * C
      ENDIF
! -------------------------------------------------------------------

! Direct integration for the smallest Q's ---------------------------
      IF (L.EQ.0) THEN
        MQ = 0
      ELSE
        MQ = NQ * ERRFFT**(1.D0/L)
      ENDIF
      DO IQ = 1,MQ
        Q = IQ * DQ
        GG(IQ) = 0.D0
        DO IR = 1,NR
          R = IR * DR
          GG(IQ) = GG(IQ) + R*R * F(IR) * BESSPH(L,Q*R)
        ENDDO
        GG(IQ) = GG(IQ) * 2.D0 * C
      ENDDO
! -------------------------------------------------------------------

! Special case for Q=QMAX -------------------------------------------
!     IF (L.EQ.0) THEN
!       GSUM = 0.D0
!       DO IQ = 1,NQ-1
!         Q = IQ * DQ
!         GSUM = GSUM + Q*Q * GG(IQ)
!       ENDDO
!       GSUM = GSUM * 4.D0 * PI * DQ
!       GG(NQ) = (2.D0*PI)**1.5D0 * F(0) - GSUM
!       GG(NQ) = GG(NQ) / (4.D0 * PI * DQ * QMAX**2)
!     ENDIF
! -------------------------------------------------------------------

! Copy from local to output array -----------------------------------
      DO IQ = 0,NQ
        G(IQ) = GG(IQ)
      ENDDO
! -------------------------------------------------------------------

      END SUBROUTINE radfft

      SUBROUTINE RESET_RADFFT( )
      call de_alloc( P, 'P', 'RADFFT' )
      call de_alloc( FN, 'FN', 'RADFFT' )
      call de_alloc( GG, 'GG', 'RADFFT' )
      MAXL  = -1
      MAXNR = -1
      END SUBROUTINE RESET_RADFFT

      END MODULE gridxc_radfft

#if defined HAVE_CONFIG_H
#include "config.h"
#endif

PROGRAM gridXCtest2

  ! Compares potential and the numerical derivative of the energy 
  ! calculated by atomXC. J.M.Soler. Sept.2009

  ! Used module procedures
  USE gridXC, only: atomXC => gridxc_atomXC
  USE gridXC, only: setXC  => gridxc_setXC
  USE gridXC, only: gridxc_init

  ! Used module parameters
  USE gridXC, only: dp

! Used MPI procedures and types
! Note that current MPI modules do not include the actual
! routines
#ifdef HAVE_MPI
  USE mpi
#endif

  implicit none

  ! Tester parameters
  integer, parameter:: irel  =  0 ! Relativistic? 0=>no, 1=>yes
  integer, parameter:: nSpin =  2 ! Number of spin components
  integer, parameter:: nfTot = 19 ! Number of functionals
  integer, parameter:: nr    = 101 ! Number of radial points
  integer, parameter:: n1cut =  8 ! Cutoff parameter
  integer, parameter:: n2cut =  2 ! Cutoff parameter:
                                  !    fCut(r)=(1-(r/rMax)**n1cut)**n2cut
  real(dp),parameter:: dWidth = 2._dp ! Width of density distribution, in Bohr
  real(dp),parameter:: Qtot = 10._dp  ! Integral of density distribution
  real(dp),parameter:: spinPol= 2._dp ! Integral of densUp - densDown
  real(dp),parameter:: rMax = 20._dp  ! Cutoff radius, in Bohr
  real(dp),parameter:: deltaDens = 1.e-8_dp  ! Finite diff. change
  real(dp),parameter:: densMin  = 1.e-9_dp  ! Min. density to proceed

  ! List of functionals to be tested
!  integer, parameter:: nf = nfTot-4   ! Number of tested functionals
!  integer:: indexf(nf) = (/1,2,3,4,5,6,7,8,9,10,11,12,13,14,  18/) 
!                         ! Indexes from list below (only one VDW allowed)

  ! Same to test a single functional
  integer, parameter:: nf = 1        ! Number of tested functionals
  integer:: indexf(nf) = (/18/)      ! Indexes from list below

  ! All functionals available
  !                  1,           2,          3,           4,   
  !                  5,           6,          7,           8, 
  !                  9,          10,         11,          12,
  !                 13,          14,         15,          16,
  !                 17,          18,         19
  character(len=3):: &
    func(nfTot)=(/'LDA',       'LDA',       'GGA',       'GGA', &
                  'GGA',       'GGA',       'GGA',       'GGA', &
                  'GGA',       'GGA',       'GGA',       'GGA', &
                  'GGA',       'GGA',       'VDW',       'VDW', &
                  'VDW',       'VDW',       'VDW'       /)
  character(len=10):: &
    auth(nfTot)=(/'PZ        ','PW92      ','PW91      ','PBE       ', &
                  'RPBE      ','revPBE    ','LYP       ','WC        ', &
                  'PBEJsJrLO ','PBEJsJrHEG','PBEGcGxLO ','PBEGcGxHEG', &
                  'PBESOL    ','AM05      ','DRSLL     ','LMKLL     ', &
                  'C09       ','BH        ','VV        '/) 

  ! Tester variables and arrays
  integer :: iDelta, ir, irmax, ismax, iSpin, one, two
  real(dp):: avgDiffVxc, dDensdr, dens(nr,nSpin), dens0(nr,nSpin), &
             d0tot, d0(nSpin), dEdDens, dDens, diffVxc, &
             Dc, Dc0, dr, dVol, Dx, Dx0, Ec, Ec0, Ex, Ex0, &
             kf, kg, maxDiffVxc, pi, r, rMesh(nr), &
             Vxc(nr,nSpin), Vxc0(nr,nSpin), wc(nfTot), wr, wx(nfTot)

#ifdef HAVE_MPI
  ! Initialize MPI, even though this test is intended to be run serially
  integer:: MPIerror, myNode, nNodes
  call MPI_Init( MPIerror )
  call MPI_Comm_Rank( MPI_Comm_World, myNode, MPIerror )
  call MPI_Comm_Size( MPI_Comm_World, nNodes, MPIerror )
#endif

  ! Initialize cocktail XC functional with all tested functionals
  wx = 1._dp / nf
  wc = 1._dp / nf
  call setXC( nf, func(indexf), auth(indexf), wx(indexf), wc(indexf) )

  ! Find radial mesh points and gaussian density
  pi = acos(-1._dp)
  d0tot = Qtot / (2*pi*dWidth**2)**1.5_dp    ! Total density at origin
  if (nSpin==1) then
    d0(1) = d0tot
  else
    one = 1   ! A silly thing to satisfy the compiler when nSpin=1
    two = 2
    d0(one) = d0tot * (Qtot + spinPol) / Qtot / 2 ! Spin up density at origin
    d0(two) = d0tot * (Qtot - spinPol) / Qtot / 2 ! Spin down density at origin
  end if
  dr = rmax / (nr-1)                      ! Interval between radial points
  do ir = 1,nr
    rMesh(ir) = dr * (ir-1)               ! Radial point values
    dens0(ir,:) = DensOfR( d0(:), rMesh(ir) )
  end do

  ! Find exchange and correlation energy and potential from radial density
  call atomXC( irel, nr, nr, rMesh, nSpin, dens0, Ex0, Ec0, Dx0, Dc0, Vxc0 )

  ! Print parameters
  print'(/,a,10(a3,4x))', 'funcs= ', func(indexf)
  print  '(a,10(a6,1x))', 'auths= ', auth(indexf)
  print'(a,2f12.6)', 'dr, rMax = ', dr, rMax

  ! Calculate finite-difference derivatives
  open( unit=44, file='test2.Vxc' )
  avgDiffVxc = 0
  maxDiffVxc = 0
  do iSpin = 1,nSpin
    do ir = 2,nr
      if (dens0(ir,iSpin)<densMin) cycle ! Do nothing if dens=0
      dVol = 4*pi*rMesh(ir)**2 * dr
      dDens = min( deltaDens, dens0(ir,iSpin)/100 )
      dEdDens = 0
      do iDelta = -1,1,2
        dens = dens0
        dens(ir,iSpin) = dens0(ir,iSpin) + iDelta*dDens
        call atomXC( irel, nr, nr, rMesh, nSpin, dens, Ex, Ec, Dx, Dc, Vxc )
        dEdDens = dEdDens + iDelta * (Ex+Ec) / (2*dDens) / dVol
      end do ! iDelta
      diffVxc = Vxc0(ir,iSpin) - dEdDens
      avgDiffVxc = avgDiffVxc + diffVxc**2
      if (abs(diffVxc) > maxDiffVxc) then
        maxDiffVxc = abs(diffVxc)
        irMax = ir
        isMax = iSpin
      end if
      kf = (3*pi**2*sum(dens0(ir,:)))**(1.0_dp/3)
      dDensdr = sum(dens0(ir+1,:)-dens0(ir-1,:))/(rMesh(ir+1)-rMesh(ir-1))
      kg = abs(dDensdr)/sum(dens0(ir,:))
      if (ir==2) then
        print'(a5,a9,4a15)','iSpin','r','dens','Vxc','dExc/dDens','diff'
        print'(i5,f9.3,4f15.9)', &
          ispin, rMesh(1), dens0(1,iSpin), Vxc0(1,iSpin)
!        print'(a5,a9,6a15)','iSpin','r','dens','kf','kg','Vxc', &
!                            'dExc/dDens','diff'
!        print'(i5,f9.3,6f15.9)', &
!          ispin, rMesh(1), dens0(1,iSpin), kf, kg, Vxc0(1,iSpin)
      end if
      print'(i5,f9.3,4f15.9)', &
        ispin, rMesh(ir), dens0(ir,iSpin), Vxc0(ir,iSpin), dEdDens, diffVxc
!      print'(i5,f9.3,6f15.9)', &
!        ispin, rMesh(ir), dens0(ir,iSpin), kf, kg, &
!        Vxc0(ir,iSpin), dEdDens, diffVxc
      write(44,'(f9.3,4f15.9)') &
        rMesh(ir), dens0(ir,iSpin), Vxc0(ir,iSpin), dEdDens, diffVxc
    end do ! ir
  end do ! iSpin
  avgDiffVxc = sqrt( avgDiffVxc / nSpin / nr )
  print'(a,2f15.9)', 'avgDiffVxc, maxDiffVxc = ', avgDiffVxc, maxDiffVxc
!  print'(a,2i6)', 'irMax, iSpinMax = ', irmax, ismax
  close( unit=44 )

! Finalize MPI
#ifdef HAVE_MPI
  call MPI_Finalize( MPIerror )
#endif

CONTAINS

FUNCTION DensOfR( d0, r )

  ! Returns a radial density distribution

  implicit none
  real(dp),intent(in):: d0(nSpin)  ! Density at center of charge distribution
  real(dp),intent(in):: r          ! Distance to center of charge distribution
  real(dp)           :: DensOfR(nSpin)  ! Electron density

  ! Use a simple gaussian distribution
  DensOfR = d0 * exp(-r**2/2/dWidth**2)

  ! Impose a smooth radial cutoff
  DensOfR = DensOfR * ( 1 - (r/rMax)**n1cut )**n2cut

END FUNCTION DensOfR

END PROGRAM gridXCtest2

#if defined HAVE_CONFIG_H
#include "config.h"
#endif

!!@LICENSE

module gridxc_chkgmx

  ! Used module procedures
  use gridxc_sys,       only: die     ! Termination routine
  use gridxc_minvec,  only: minvec  ! Finds a lattice basis of minimal length
  use gridxc_cellsubs,  only: reclat  ! Finds reciprocal unit cell

  ! Used module parameters and variables
  use gridxc_precision, only: dp      ! Double precision real kind

  implicit none

  private ! Nothing is declared public beyond this point

  ! Public procedures provided:
  public :: chkgmx  ! Checks that a given cutoff is consistent with a mesh
  public :: meshKcut ! Returns the planewave cutoff of a periodic mesh

contains

  subroutine chkgmx(K,BG,MESH,G2MAX)

    real(dp),intent(in) :: K(3)    ! Vector in reciprocal unit cell (BZ)
    real(dp),intent(in) :: BG(3,3) ! Reciprocal lattice vectors BG(ixyz,ivec)
    integer, intent(in) :: MESH(3) ! Number of mesh point divisions of each 
    ! real-space lattice vector.
    real(dp),intent(inout):: G2MAX ! Planewave cutoff, which is reduced to
    ! the maximum value supported by the mesh
    ! (without aliasing), if this is smaller.

    real(dp), parameter :: ZERO=0.0_dp,HALF=0.5_dp, &
        TINY=1.0e-8_dp, BIG=1.0e20_dp

    integer :: i, j, i1, i2, i3
    real(dp):: bm(3,3), baux(3,3), ctransf(3,3), &
        g(3), gmod, gmax, g2msh, r
    
    DO I=1,3
      DO J=1,3
        BM(J,I)=BG(J,I)*MESH(I)
        Baux(J,I)=BG(J,I)*MESH(I)
      END DO
    END DO
    !
    !     Use Baux to avoid aliasing of arguments, as one is intent(in)
    !     and the other intent(out)...
    !
    CALL MINVEC (Baux,BM, ctransf)
    GMAX=BIG
    DO I3=-1,1
      DO I2=-1,1
        DO I1=-1,1
          IF (I1.EQ.0.AND.I2.EQ.0.AND.I3.EQ.0) cycle
          G(1)=BM(1,1)*I1+BM(1,2)*I2+BM(1,3)*I3
          G(2)=BM(2,1)*I1+BM(2,2)*I2+BM(2,3)*I3
          G(3)=BM(3,1)*I1+BM(3,2)*I2+BM(3,3)*I3
          GMOD=SQRT(SUM(G**2))
          R=HALF*GMOD-SUM(K*G)/GMOD
          GMAX=MIN(GMAX,R)
        END DO
      END DO
    END DO
    IF (GMAX.LT.ZERO) call die('CHKGMX: K NOT IN FIRST BZ')
    G2MSH=GMAX*GMAX-TINY
    IF (G2MSH.LT.G2MAX) THEN
      !       if (Node.eq.0) then
      !         WRITE(6,*) 'CHKGMX: MESH TOO SPARSE. GMAX HAS BEEN REDUCED'
      !         WRITE(6,*) 'CHKGMX: OLD G2MAX =',G2MAX
      !         WRITE(6,*) 'CHKGMX: NEW G2MAX =',G2MSH
      !       endif
      G2MAX=G2MSH
    ENDIF
  end subroutine chkgmx

  !----------------------------------------------------------------------

  function meshKcut( cell, nMesh )

    ! Finds mesh planewave cutoff
    real(dp),intent(in) :: cell(3,3) ! Unit cell vectors cell(iXYZ,iVector)
    integer, intent(in) :: nMesh(3)  ! Mesh divisions of each vector
    real(dp)           :: meshKcut  ! Mesh wavevector cutoff

    real(dp) :: g2max, k0(3), kcell(3,3)

    ! Find reciprocal cell vectors
    call reclat( cell, kcell, 1 )

    ! Initialize arguments to call chkgmx
    k0(1:3) = 0._dp
    g2max = huge(g2max)

    ! chkgmx will reduce g2max to square of mesh cutoff
    call chkgmx( k0, kcell, nMesh, g2max )

    ! Return wavevector cutoff
    meshKcut = sqrt(g2max)

  end function meshKcut

end module gridxc_chkgmx

#if defined HAVE_CONFIG_H
#include "config.h"
#endif

!!@LICENSE
!
module gridxc_walltime
!
! Implements a wall_time routine to return the wall time, instead of
! the cpu time. It tries to deal with possible wraparounds of the system
! clock's counter.
!
implicit none

public :: wall_time

integer, parameter, private :: dp = selected_real_kind(14,200)
integer, parameter, private :: i8 = selected_int_kind(12)

integer(i8), private, save     :: last_count
integer(i8), private, save     :: max_count
real(dp), private, save    :: last_time
real(dp), private, save    :: count_rate
logical, private, save     :: first = .true.


private

CONTAINS

subroutine wall_time(t)
real(dp), intent(out)  :: t

real(dp)  :: elapsed_time

integer(i8)       :: count_rate_int
integer(i8)       :: count

      if (first) then
         CALL system_clock (count_rate=count_rate_int)
         CALL system_clock (count_max=max_count)
         count_rate = real(count_rate_int,kind=dp)
         first = .false.
         CALL system_clock (last_count)
         t = 0.0_dp
         last_time = t
         RETURN
      endif

CALL system_clock (count)

! Watch out for wrap-around...
! This works if the system counter wrapped around just once...
! ... be liberal in your use of this routine.

if (count < last_count) then
   elapsed_time = (max_count - last_count + count)/count_rate
else
   elapsed_time = (count-last_count)/count_rate
endif

t = last_time + elapsed_time
last_time = t
last_count = count

end subroutine wall_time

end module gridxc_walltime

#if defined HAVE_CONFIG_H
#include "config.h"
#endif

!!@LICENSE
!
!******************************************************************************
! MODULE mesh3D
! Defines and handles different parallel distributions of a 3D mesh of points.
! Written by J.M.Soler. Jan-July.2008
!******************************************************************************
!
!   PUBLIC procedures available from this module:
! addMeshData   : Adds the data in a box array to the equiv. unit-cell points
! associateMeshTask : Associates a communication task to mesh distr.
! copyMeshData  : Copies data in a unit-cell array to another mesh box array
! fftMeshDistr  : Sets four mesh distributions to perform FFTs 
! freeMeshDistr : Frees a distribution index (they are limited to maxDistr)
! freeMeshTask  : Frees a task index (they are limited to maxTasks)
! myMeshBox     : Returns mesh box of my processor node
! nodeMeshBox   : Returns mesh box of any given processor node
! redistributeMeshData : Copies data between different mesh distributions
! sameMeshDistr : Finds if two mesh distributions are equal
! setMeshDistr  : Defines a distribution of mesh points over parallel nodes
!
!   PUBLIC parameters, types, and variables available from this module:
! none
!
!******************************************************************************
!
!   USED module procedures:
! use gridxc_alloc,      only: de_alloc        ! De-allocation routine
! use gridxc_alloc,      only: re_alloc        ! Re-allocation routine
! use gridxc_sys,        only: die             ! Termination routine
! use gridxc_sorting,    only: ordix           ! Finds the sorting index of a vector
! use gridxc_array, only: array_copy         ! Copies flattened arrays (instead of reshaping)
! use gridxc_array, only: array_add          ! Adds flattened arrays (instead of reshaping)
!
!   USED module parameters:
! use gridxc_precision,  only: dp              ! Real double precision type
! use gridxc_precision,  only: gp=>grid_p      ! Grid-data real precision type
! use parallel,   only: myNode=>node    ! This process node
! use parallel,   only: totNodes=>nodes ! Total number of processor nodes
!
!   EXTERNAL procedures used:
! none
!
!   Private fixed module parameters (see/set values in code):
! integer maxDistr      : Max. mesh distributions allocated at any given time
! integer maxTasks      : Max. communication tasks allocated at any given time
! integer maxDistrID    : Max. IDs assigned to the same distrib.
! integer maxTaskID     : Max. IDs assigned to the same task
! integer maxParts      : Max. parts of a mesh box, in different unit cells
! integer maxDistrTasks : Max. commun. tasks associated to a mesh distribution
!
!******************************************************************************
!
! SUBROUTINE addMeshData( nMesh, srcBox, srcData, dstDistr, dstData, task )
!
! Adds (reduces) the values defined in a 3D mesh box to the equivalent mesh 
!   points in a periodic unit cell. The input box may be entirely inside, or
!   partially or totally outside the the unit cell, and it is folded to add 
!   all its values to the corresponding unit-cell points.
! In parallel execution, the routine handles the interprocessor transfers
!   needed to send the box data to the nodes that will store them.
!------------------------------ INPUT -----------------------------------------
! integer nMesh(3)    : Global mesh size in each axis
! integer srcBox(2,3) : Source mesh box: box(1,iAxis)=lower box limits
!                                        box(2,iAxis)=upper box limits
!                       The box may be partially or totally outside the first
!                       unit cell (FUC). It is folded to the FUC in order to
!                       assign the values of srcData to those of dstData.
! real(gp) srcData(0:,0:,0:,:) : Source data values to be copied. 
!                       The first three upper array bounds must be equal or 
!                       larger than srcBox(2,iAxis)-src(1,iAxis). Real type gp 
!                       is identical to grid_p, defined in module precision.
! integer dstDistr    : Distrib. ID of destination data, or zero for serial
!                       execution
!----------------------- INPUT and OUTPUT -------------------------------------
! real(gp) dstData(0:,0:,0:,:) : Destination data array. Its upper array bounds
!                       must be enough to contain the node box in the dstDistr
!                       parallel distrib or nMesh(iAxis)-1 in serial execution
!                       It is NOT initialized: its input values are incremented
!                       with the source array values.
!-------------------- OPTIONAL INPUT and OUTPUT -------------------------------
! integer task : ID of communication task. It allows to save information on an
!                optimized interprocessor communication pattern, required to
!                exchange data between source and destination mesh boxes.
!                This info is used in future calls with the same srcBox and
!                dstDistr. task value must be saved between calls. See also
!                associateMeshTask.
!----------------------------- UNITS ------------------------------------------
! Units of srcData and dstData are arbitrary but they must be equal
!----------------------------- USAGE ------------------------------------------
!   Typical usage for parallel execution is:
! use gridxc_precision,    only: gp=>grid_p
! use gridxc_mesh3D, only: addMeshData, associateMeshTask, myMeshBox, setMeshDistr
! integer:: box1(2,3), box2(2,3), myBox(2,3), nData, nMesh(3)
! integer,save:: myDistr=-1, task1=-1, task2=-1
! real(gp),allocatable:: myData(:,:,:,:), data1(:,:,:,:), data2(:,:,:,:)
! ... Find/define nMesh
! call setMeshDistr( myDistr, nMesh )
! call myMeshBox( nMesh, myDistr, myBox )
! allocate( myData(myBox(1,1):myBox(2,1), &
!                  myBox(1,2):myBox(2,2), &
!                  myBox(1,3):myBox(2,3),1:nData) )
! myData = 0
! ... Find/define box1 and box2
! allocate( data1(box1(1,1):box1(2,1), &
!                 box1(1,2):box1(2,2), &
!                 box1(1,3):box1(2,3),1:nData) )
! allocate( data2(box2(1,1):box2(2,1), &
!                 box2(1,2):box2(2,2), &
!                 box2(1,3):box2(2,3),1:nData) )
! ... Find data1 and data2
! call associateMeshTask( task1, myDistr )
! call associateMeshTask( task2, myDistr )
! call addMeshData( nMesh, box1, data1, myDistr, myData, task1 )
! call addMeshData( nMesh, box2, data2, myDistr, myData, task2 )
!   This usage is also valid in serial execution, although it could be
! simplified in this case (e.g. the call to setMeshDistr could be replaced by
! myDistr=0).
!   The optimization of the communication task is done at the end of the first
! call with given srcBox and dstDistr. Therefore, the use of the task argument
! is not advised unless the same srcBox and dstDistr are used repeatedly.
!
! In using some mesh3D routines, it is essential to understand that, in
!   fortran90, assumed-shape array arguments (like srcData and dstData in 
!   addMeshData) are passed with their shape (i.e. their dimension in each
!   index) but NOT with the lower or upper bounds of these indexes. Thus,
!   element a(6,1) of an array dimensioned as a(5:10,2) in the calling program,
!   and as a(0:,0:) in the called subroutine, will be accessed as a(1,0) in the
!   latter. This is why arrays dimensioned as srcData(0:,0:,0:,:) may be (and
!   are expected to be) dimensioned in the calling program as 
!   srcData(box(1,1):box(2,1),box(1,2):box(2,2),box(1,3):box(2,3),nData)
!---------------------------- BEHAVIOUR ---------------------------------------
! If dstDistr==0, it assumes serial execution, i.e. that dstData contains the
!   destination data values at all the mesh points in the unit-cell.
! It stops with an error message in any of these cases:
! - size(srcData,1:3) < srcBox(2,1:3)-srcBox(1,1:3)+1
! - size(dstData,1:3) < dstBox(2,1:3)-dstBox(1,1:3)+1, with dstBox as 
!   returned by call myMeshBox(nMesh,dstDistr,dstBox)
! - size(srcData,4) /= size(dstData,4)
! If task is present, it is automatically associated to dstDistr (see
!   associateMeshDistr). If dstDistr changes between calls (see freeMeshDistr),
!   task info is automatically erased.
! If task is present and it contains a predefined value (returned by a previous
!   call to addMeshData or copyMeshData), but srcBox has changed, it stops with
!   an error message (since the communication task has also changed). To avoid
!   this, reset task to a negative value. If srcBox derives from a defined
!   mesh distribution, and task had been associated to it, task info will be 
!   automatically deleted when the distrib changes, and no error will occur.
!--------------------------- ALGORITHMS ---------------------------------------
! The same as in copyMeshData, except that the destination boxes, rather than
!   the source boxes, are previously obtained from dstDistr.
!
!******************************************************************************
!
! SUBROUTINE associateMeshTask( taskID, distrID1, distrID2 )
!
! Associates a communication task to one or two parallel mesh distributions
!------------------------------ INPUT -----------------------------------------
! integer distrID1 : ID of first distribution to be associated with task
!-------------------------- OPTIONAL INPUT ------------------------------------
! integer distrID2 : ID of second distrribution to be associated
!----------------------- INPUT and OUTPUT -------------------------------------
! integer taskID   : ID of task to be associated with distribution(s)
!----------------------------- USAGE ------------------------------------------
! use gridxc_mesh3D, only: associateMeshTask, setMeshDistr
! integer:: nMesh(3)
! integer,save:: distr1=-1, distr2=-1, task1=-1, task2=-1, task12=-1, task21=-1
! real(gp),allocatable:: workload(:,:,:)
! ... Find nMesh. Allocate and find workload
! call setMeshDistr( distr1, nMesh )
! call setMeshDistr( distr2, nMesh, workload )
! call associateMeshTask( task1, distr1 )
! call associateMeshTask( task2, distr2 )
! call associateMeshTask( task12, distr1, distr2 )
! call associateMeshTask( task21, distr1, distr2 )
!---------------------------- BEHAVIOUR ---------------------------------------
! In serial execution (totNodes==1) it does nothing
! If taskID is already associated with distrID1 (and distrID2, if present),
!   nothing is done. Thus, it is safe (and not inefficient) to make the same
!   call repeatedly.
! If the taskID value has not been defined nor associated with any distribution,
!   it is initialized before associating it, and it returns changed.
! If taskID is defined, but it is associated with two distributions different
!   from distrID1 (or from distrID1 and distrID2, if the latter is present),
!   the taskID is erased (freed) and reinitialized.
! It stops with an error message in the following cases:
!   - If distrID1 (or distrID2 if present) has not been defined or if it has
!     been erased (freed).
!   - If the available maxDistrTasks slots, for tasks associated to distrID1
!     (or distrID2, if present), is overflooded.
!--------------------------- ALGORITHMS ---------------------------------------
! The taskID is an identifier for a parallel communication "task", defined as
!   a set of source and destination mesh boxes that belong to each processor.
! The same task can be identified by different IDs (for example by different
!   calling programs, but the information is stored only once. This is ensured
!   by comparing the boxes of a new taskID with those of all previously defined
!   tasks. If they coincide, the taskID is simply assigned to that task.
! When a taskID is erased (freed), the task itself is not erased, unless all 
!   its IDs have been erased. There may be up to maxTasks possible simultaneous 
!   tasks, each with up to maxTaskID IDs.
! A task may be associated with up to two mesh distributions. This association 
!   state is stored in both the task and the distribution(s) info. The 
!   association means that the task's source or destination boxes are linked
!   to the distribution. This does not necessarily mean that the boxes are the 
!   node's boxes in the distribution. For example, they might be "wings" to
!   the left or to the right of those boses. The key point is that the task
!   boxes will change when the distribution changes.
! The purpose of the task-distribution association is to erase automatically
!   the task when the distribution is erased (freed). This is convenient
!   (and safer) because it allows not to have to free the task explicitly.
!
!******************************************************************************
!
! SUBROUTINE copyMeshData( nMesh, srcDistr, srcData, dstBox, dstData, task )
!
! Copies a box of values defined in a 3D mesh of a periodic unit cell.
! The box limits may be entirely inside, or partially or totally outside 
!   the unit cell, which is periodically repeated to fill the box.
! In parallel execution, the routine handles the interprocessor transfers
!   needed to bring the requested box data from the nodes that store them.
!------------------------------ INPUT -----------------------------------------
! integer nMesh(3)    : Global mesh size in each axis
! integer srcDistr    : Distrib. ID of source data, or zero for serial exec.
! real(gp) srcData(0:,0:,0:,:) : Source data values to be copied. Its upper
!                       array bounds must be enough to contain the node box in
!                       the srcDistr parallel distrib, or nMesh(iAxis)-1 in
!                       serial execution. Real type gp is identical to grid_p, 
!                       defined in module precision.
! integer dstBox(2,3) : Destination mesh box: box(1,iAxis)=lower box limits
!                                             box(2,iAxis)=upper box limits
!                       The box may be partially or totally outside the first
!                       unit cell (FUC). It is folded to the FUC in order to
!                       assign the values of srcData to those of dstData.
!----------------------------- OUTPUT -----------------------------------------
! real(gp) dstData(0:,0:,0:,:) : Destination data array (different from srcData)
!                       The first three upper array bounds must be equal or 
!                       larger than dstBox(2,iAxis)-dst(1,iAxis). 
!-------------------- OPTIONAL INPUT and OUTPUT -------------------------------
! integer task : ID of communication task. It allows to save information on an
!                optimized interprocessor communication pattern, required to
!                exchange data between source and destination mesh boxes.
!                This info is used in future calls with the same srcBox and
!                dstDistr. task value must be saved between calls. See also
!                associateMeshTask.
!----------------------------- UNITS ------------------------------------------
! Units of srcData and dstData are arbitrary but they must be equal
!----------------------------- USAGE ------------------------------------------
!   A typical usage for data redistribution in parallel execution is:
! use gridxc_precision,    only: gp=>grid_p
! use gridxc_mesh3D, only: associateMeshTask, copyMeshData, myMeshBox, setMeshDistr
! integer:: box1(2,3), box2(2,3), nData, nMesh(3)
! integer,save:: distr1=-1, distr2=-1, task=-1
! real(gp),allocatable:: data1(:,:,:,:), data2(:,:,:,:)
! ... Find/define nMesh, box1 and box2 (so that they are two partitions of mesh)
! call setMeshDistr( distr1, nMesh, box1 )
! call setMeshDistr( distr2, nMesh, box2 )
! allocate( data1(box1(1,1):box1(2,1), &
!                 box1(1,2):box1(2,2), &
!                 box1(1,3):box1(2,3),1:nData) )
! allocate( data2(box2(1,1):box2(2,1), &
!                 box2(1,2):box2(2,2), &
!                 box2(1,3):box2(2,3),1:nData) )
! ... Find data1 in box1
! call associateMeshTask( task, distr1, distr2 )
! call copyMeshData( nMesh, distr1, data1, box2, data2, task )
!   This usage is still valid in serial execution, although it makes little 
! sense in this case, since both mesh distributions would be identical.
!   The optimization of the communication task is done at the end of the first
! call with given srcDistr and dstBox. Therefore, the use of the task argument
! is not advised unless the same srcDistr and dstBox are used repeatedly.
!---------------------------- BEHAVIOUR ---------------------------------------
! If srcDistr==0, it assumes serial execution, i.e. that srcData contains the
!   source data values at all the mesh points in the unit-cell.
! It stops with an error message in any of these cases:
! - size(srcData,1:3) < srcBox(2,1:3)-srcBox(1,1:3)+1, with srcBox as 
!   returned by call myMeshBox(nMesh,srcDistr,srcBox)
! - size(dstData,1:3) < dstBox(2,1:3)-dstBox(1,1:3)+1
! - size(srcData,4) /= size(dstData,4)
! If task is present, it is automatically associated to srcDistr (see
!   associateMeshDistr). If srcDistr changes between calls (see freeMeshDistr),
!   task info is automatically erased.
! If task is present and it contains a predefined value (returned by a previous
!   call to addMeshData or copyMeshData), but dstBox has changed, it stops with
!   an error message (since the communication task has also changed). To avoid
!   this, reset task to a negative value. If dstBox derives from a defined
!   mesh distribution (as in the example above), and task had been associated
!   to it, task info will be automatically deleted when the distrib changes,
!   and no error will occur.
!--------------------------- ALGORITHMS ---------------------------------------
! - The source boxes are first obtained from srcDistr.
! - All the nodes' source and destination boxes are gathered, redistributed, 
!   and stored in each other node. These boxes are also identified by a taskID,
!   which is returned, for retrieval in future calls with the same task 
!   (defined by all the source and destination boxes themselves).
! - A universal (dependent only on totNodes) ordered sequence of all-to-all
!   inter-node communication transfers is found. It is designed to minimize
!   communication collisions. It is based on timing together transfers
!   between processors separated by a given index span. 
! - In the first call, the true, nonempty transfers for a given task are 
!   selected. Then, the order of the true transfers is (will be) reoptimized 
!   based on a graph-theory algorithm. This optimized sequence is then stored 
!   as part of the task information.
! - For each transfer (true or temptative):
!   - The source box (my node's in sending transfers, or that of the sending 
!     node, in receiving transfers) and the destination box (mine when 
!     receiving, or the receiving node's when sending) are each divided in
!     nParts, each in a different periodic unit cell. These part boxes are 
!     then shifted to the first unit cell (FUC).
!   - For each pair of the partial source and destination boxes, the
!     intersection between their FUC images is found. If the intersection is
!     empty (only happens if task info is not available), nothing is done.
!   - When sending, the corresponding source data values are added to a buffer,
!     that is finally sent with all parts together. When receiving, the buffer
!     is splitted in the corresponding intersection parts and added to the
!     destination data array.
!
!******************************************************************************
!
! SUBROUTINE fftMeshDistr( nMesh, fftDistr, axisDistr )
!
! Creates and returns a homogeneaous 3D mesh distribution fftDistr, and three
! 2D distributions axisDistr, whose boxes extend wholly over one of the three
! cell axes. These axisDistr allow fully local 1D FFTs in one of the axes.
! The fftDistr and axisDistr are designed to make already optimal (without any
! collisions) the default sequence of inter-node communications, returned by
! all2allTransferOrder. This is beacause all simultaneous communications occur
! between nodes separated by the same span (difference between node indexes).
! Thus, no task arguments are required to optimize such communications.
!------------------------------ INPUT -----------------------------------------
! integer nMesh(3) : Mesh divisions in each axis (including siesta "subpoints")
!------------------------- INPUT and OUTPUT -----------------------------------
! integer fftDistr : ID of parallel 3D mesh distribution to be used in 3D FFTs
!--------------------- OPTIONAL INPUT and OUTPUT ------------------------------
! integer axisDistr(3) : 2D distributions for the 1D FFTs required in 3D FFTs
!----------------------------- USAGE ------------------------------------------
!   Typical usage to find my box of k points:
! use gridxc_mesh3D, only: fftMeshDistr, myMeshBox
! integer:: kBox(2,3), nMesh(3)
! integer,save:: fftDistr=-1
! ...Find nMesh
! call fftMeshDistr( nMesh, fftDistr )
! call myMeshBox( nMesh, fftDistr, kBox )
!---------------------------- BEHAVIOUR ---------------------------------------
! In serial execution (totNodes==1) it simply returns fftDistr=0.
! If the input value of fftDistr (and axisDistr, if present) are already 
!   defined for that nMesh, it returns without changing them. In this case, it
!   does NOT check that the distributions are suited for FFTs.
! Since it calls setMeshDistr, some of the behaviour of that routine is
!   inherited by fftMeshDistr.
!--------------------------- ALGORITHMS ---------------------------------------
! First, it uses setMeshDistr, with default input parameters, to create an 
!   optimized uniform 3D distr fftDistr. 
! Then, if axisDistr is present: for the x axis, it divides each row of node
!   boxes along that axis (say nNodeX boxes) uniformly in the other two axes.
!   Then it assigns one of these new long boxes (that extend along the whole x
!   axis) to each of the nNodeX processors, that owned the primitive 3D boxes.
!   This new boxes define axisDistr(1). The same is done for the y and z axes
!   (stricly, the axes are the cell axes, not x, y, and z).
!
!******************************************************************************
!
! SUBROUTINE freeMeshDistr( distrID )
!
! Erases a mesh distribution ID and frees the distribution slot if 
! no other IDs are assigned to it
!
!------------------------------ INPUT -----------------------------------------
! integer distrID  ! ID of an allocated distribution
!----------------------------- USAGE ------------------------------------------
! use gridxc_mesh3D, only: free MeshDistr, setMeshDistr
! integer:: nMesh(3)
! integer,save:: myDistr=-1
! ...Find nMesh
! call setMeshDistr( nMesh, myDistr )
! ...Use myDistr
! call freeMeshDistr( myDistr )
!---------------------------- BEHAVIOUR ---------------------------------------
! If distrID is not defined, it returns without doing anything
! If the distribution has only that distrID, its information is erased.
!   Otherwise, only that particular ID is removed from it. 
!--------------------------- ALGORITHMS ---------------------------------------
! See setMeshDistr
!
!******************************************************************************
!
! SUBROUTINE myMeshBox( nMesh, distrID, box )

! Finds the mesh box of the local processor in a parallel mesh distribution.
! Equivalent to nodeMeshBox with node=myNode
!------------------------------ INPUT -----------------------------------------
! integer nMesh(3) : Mesh divisions in each axis
! integer distrID  : Mesh-distribution ID
!----------------------------- OUTPUT -----------------------------------------
! integer box(2,3) : Mesh box: box(1,:)=lower bounds, box(2,:)=upper bounds
!----------------------------- USAGE ------------------------------------------
! Same as nodeMeshBox but without need of using myNode
!---------------------------- BEHAVIOUR ---------------------------------------
! Same as nodeMeshBox
!--------------------------- ALGORITHMS ---------------------------------------
! It simply calls nodeMeshBox with node=myNode
!
!******************************************************************************
!
! SUBROUTINE nodeMeshBox( nMesh, distrID, node, box )
!
! Finds the mesh box belonging to any node in a parallel mesh distribution,
!------------------------------ INPUT -----------------------------------------
! integer nMesh(3) : Mesh divisions in each axis
! integer distrID  : Mesh-distribution ID
!----------------------------- OUTPUT -----------------------------------------
! integer box(2,3) : Mesh box: box(1,:)=lower bounds, box(2,:)=upper bounds
!----------------------------- USAGE ------------------------------------------
!   Typical usage to find my box of mesh points:
! use gridxc_mesh3D, only: nodeMeshBox
! use parallel,     only: myNode=>node
! integer:: myBox(2,3), nMesh(3)
! integer,save:: myDistr=-1
! ...Find nMesh and myDistr
! call nodeMeshBox( nMesh, myDistr, myNode, myBox )
!---------------------------- BEHAVIOUR ---------------------------------------
! If iDistr=0, it returns box(1,:)=0 and  box(2,:)=nMesh(:)-1 
!   Note: although nMesh is available from the distr. data, it is also included
!   in the routine arguments, to handle directly the case iDistr=0.
! If node stores no mesh points, its (empty) box returns with box(1,:)>box(2,:)
!--------------------------- ALGORITHMS ---------------------------------------
! The corresponding box is simply retrived from the ditrib. data stored.
!
!******************************************************************************
!
! SUBROUTINE redistributeMeshData( srcDistr, srcData, dstDistr, dstData, task )
!
! Copies data values on the mesh with a new mesh distribution among nodes
!------------------------------ INPUT -----------------------------------------
! integer  srcDistr          : Distrib. ID of srcData
! real(gp) srcData(:,:,:,:)  : Source data. Must be declared target or pointer.
! integer  dstDistr          : Distrib. ID of dstData
!------------------------- OUTPUT POINTER -------------------------------------
! real(gp) dstData(:,:,:,:)  : Output destination array 
!                            : (it must be different from srcData)
!--------------------- OPTIONAL INPUT and OUTPUT ------------------------------
! integer, task              : ID of communication task
!----------------------------- UNITS ------------------------------------------
! Units of srcData and dstData are arbitrary but they must be equal
!----------------------------- USAGE ------------------------------------------
!   Typical usage to 'translate' between two distributions:
! use gridxc_precision,    only: gp=>grid_p
! use gridxc_mesh3D, only: associateMeshTask, redistributeMeshData
! integer:: nData, newBox(2,3), nMesh(3)
! integer,save:: newDistr=-1, old2new=-1, oldDistr=-1
! real(gp),pointer:: newData(:,:,:,:), oldData(:,:,:,:)
! ...Find nMesh, nData, oldDistr. Allocate and find oldData
! call setMeshBox( newDistr, nMesh )
! call myMeshBox( nMesh, newDistr, newBox )
! allocate( newData( newBox(1,1):newBox(2,1), &
!                    newBox(1,2):newBox(2,2), &
!                    newBox(1,3):newBox(2,3), nData )
! call associateMeshTask( old2new, oldDistr, newDistr )
! call redistributeMeshData( oldDistr, oldData, newDistr, newData, old2new )
!
!   In serial execution, srcData and dstData will be the same physical array
! upon return. This allows to write a common serial-parallel code, without
! increasing the required memory in the serial case. But this must be handled
! with much care, to avoid erasing or overwritting dstData inadvertently.
! Therefore, the use of copyMeshData is prefferable in most other situations.
!---------------------------- BEHAVIOUR ---------------------------------------
! If srcDistr==0 and dstDistr==0 (serial execution) it simply makes dstData 
!   point to srcData. This allows to save memory, but it must be handled with 
!   care in calling program.
! If the two distributions are equal (sameMeshDistr(srcDistr,dstDistr)==.true.)
!   it simply (re)allocates dstData and copies dstData=srcData. Othewise,
!   it calls copyMeshData after the (re)allocation of dstData.
!--------------------------- ALGORITHMS ---------------------------------------
! First, the dstDistr mesh box is obtained, then dstData is (re)allocated and
!   finally, copyMeshData is used to obtain dstData from srcData
!
!******************************************************************************
!
! logical FUNCTION sameMeshDistr( ID1, ID2 )
!
! Compares two distribution IDs
!------------------------------ INPUT -----------------------------------------
! integer ID1, ID2  ! Mesh distribution IDs to be compared
!----------------------------- USAGE ------------------------------------------
! use gridxc_mesh3D, only: sameMeshDistr
! integer,save:: oldDistr=-1, newDistr=-1
! ... Find oldDistr and newDistr
! if (.not.sameMeshDistr(oldDistr,newDistr)) do something
!---------------------------- BEHAVIOUR ---------------------------------------
! In serial execution (ID1=ID2=0), it returns .true.
! If ID1 and ID2 are equal, but not defined distributions, it returns .false.
!--------------------------- ALGORITHMS ---------------------------------------
! In parallel execution, it looks for the distributions that own the given IDs,
!   then it checks whether all their mesh boxes are the same.
!
!******************************************************************************
!
! SUBROUTINE setMeshDistr( distrID, nMesh, box, firstNode, nNodes, &
!                          nNodesX, nNodesY, nNodesZ, nBlock, &
!                          wlDistr, workload )
!
! Defines a parallel distribution of mesh points over processor nodes.
!------------------------------ INPUT -----------------------------------------
! integer nMesh(3)  : Mesh divisions in each axis (including siesta "subpoints")
!------------------------- OPTIONAL INPUT -------------------------------------
! integer box(2,3)  : Mesh box of my processor node: 
!                     box(1,iAxis)=lower box limits, in range (0:nMesh(iAxis)-1)
!                     box(2,iAxis)=upper box limits, in same range
! integer firstNode : First node in the mesh distr.
! integer nNodes    : Total nodes in the mesh distr
! integer nNodesX   : Nodes in the X (first) axis.
!                     Must be present if present(nNodesYZ)
! integer nNodesY   : Nodes in the Y (second) axis.
!                     Must be present if present(nNodesZ)
! integer nNodesZ   : Nodes in the Z (third) axis
! integer nBlock    : Size of blocks of mesh points, in each axis, which are
!                     not splitted in different nodes. It must be a factor of
!                     all of nMesh(1:3). If box is also present, nBlock must be
!                     a factor of all box(1,1:3) and box(2,1:3)+1.
!                     nBlock corresponds to nsm (lateral size of "superpoints")
!                     in siesta mesh terminology.
! integer wlDistr   : Distr. index of workload array
! real(gp) workload(0:,0:,0:) ! Approx. relative workload of mesh points. 
!                     Must be nonnegative at all points and have nonzero sum.
!-------------------------- INPUT and OUTPUT ----------------------------------
! integer distrID : ID assigned to the mesh distrib.
!----------------------------- USAGE ------------------------------------------
!    Arguments box, firstNode, nNodes, nNodesXYZ, and nBlock are provided to
! force compatibility with user distributions, but they should be avoided
! otherwise, since they difficult the optimal distribution of mesh points.
!
!    Typical usage to create a uniform 3D mesh distribution:
! use gridxc_mesh3D, only: setMeshDistr
! integer:: nMesh(3)
! integer,save:: myDistr=-1
! ... Find nMesh
! call setMeshDistr( myDistr, nMesh )
!
!    Typical usage to distribute evenly the workload of each node:
! use gridxc_mesh3D, only: setMeshDistr
! integer:: nMesh(3)
! integer,save:: newDistr=-1, oldDistr=-1
! real(gp),allocatable:: workload(:,:,:)
! ... Find nMesh
! call setMeshDistr( oldDistr, nMesh )
! call myMeshBox( oldDistr, nMesh, box )
! allocate( workload(box(1,1):box(2,1), &
!                    box(1,2):box(2,2), &
!                    box(1,3):box(2,3)) )
! ... Find approximate CPU workload associated to each point of box
! call setMeshDistr( newDistr, nMesh, wlDistr=oldDistr, workload=workload )
! 
!   The mesh distribution of J.D.Gale, used up to siesta-2.5, is set by:
! use parallel, only: ProcessorY
! use mesh,     only: nsm
! use gridxc_mesh3D,   only: setMeshDistr
! integer:: nMesh(3)
! integer,save:: JDGdistr=-1
! call setMeshDistr( JDGdistr, nMesh, nNodesX=1, nNodesY=ProcessorY, 
!                    nBlock=nsm )
!---------------------------- BEHAVIOUR ---------------------------------------
! In serial execution (totNodes==1) it simply returns distrID=0, irrespective
!   of all arguments. Parameter totNodes is obtained from module parallel.
! If the input distribution ID is still valid (i.e. consistent with the other
!   input arguments), the same value is returned. If it points to an existing
!   distribution that is no longer consistent, the old distribution ID is 
!   freed before returning with a new distrID. This makes it convenient to 
!   make succesive calls with the same distrID but different other arguments
!   (e.g. different workloads in different iterations).
! New IDs are never repeated, even if they identify the same distribution.
! If box is present, all other optional arguments are ignored. The different
!   node mesh boxes should be a nonoverlapping partition of all the mesh 
!   points, but this is NOT checked.
! If firstNode is not present, firstNode=0 is assumed.
! If nNodes is not present all nodes are used (nNodes=totNodes).
! It stops with an error message in the following cases:
!   - nNodes is present and it is smaller than 1 or larger than totNodes.
!   - nNodesZ is present but either nNodesX or nNodesY are not present.
!   - nNodesY is present but nNodesX is not present.
!   - nBlock is present and it is not a factor of one of nMesh(1:3).
!   - box and nBlock are present, and nBlock is not a factor of any of 
!     box(1,1:3) or box(2,1:3)+1.
!   - workload is present but wlDistr is not present.
!   - workload is present and negative at any mesh point, or zero at all 
!     points of the unit cell mesh.
! If nNodesXYZ are not present, the distribution of nodes over each axis is
!   optimized, in the sense of leading to node mesh boxes as cubic as possible. 
!   If only nNodesX is present, it is optimized over the Y and Z axes.
! If nBlock is not present, nBlock=1 is assumed.
! If workload is present, its distribution over processors is optimized, in the
!   sense of load balance. If it is not present, the even distribution of mesh 
!   points is optimized (equivalent to using the same workload for all points).
!--------------------------- ALGORITHMS ---------------------------------------
! For uniform distributions (workload not present):
! - nNodes is first fatorized in its prime factors.
! - All possible distributions of (products of) factors over axes are tried,
!   and that with lowest dispersion of nMesh(axis)/factor(axis) is selected.
!   This is done only over axes not constrained by nNodesXYZ, if present, and
!   respecting that axis factors must be multiples of nBlock, if present.
! - nMesh(axis) is divided in nNodes(axis) boxes. If there is a rest, the first
!   rest(axis) of the nNodes(axis) are given an extra point. Again, this is 
!   done with blocks of nBlock points (if present) rather than single points.
!
! For nonuniform distributions (workload present):
! - nNodes is first fatorized in its prime factors.
! - Beginning with a box of the entire cell size, each box is divided in 
!   nParts=factor (in order of decreasing factors). The division axis is that
!   along which the spatial dispersion of the box workload is maximum. The 
!   division surfaces are chosen to split the workload as evenly as possible.
!   If the division surface is in a void region (with zero workload), it is
!   placed at the midpoint between the nonzero workload regions. 
! - The divided boxes are assigned to a contiguous set of 
!   boxNodes=boxNodes/nParts. This process is repeated until boxNodes=1.
!
! A stored distribution is defined by nMesh and its node boxes. There may be up
!   to maxDistr distributions defined simultaneously. Each distribution may be
!   identified simultaneously by up to maxDistrID identifiers (for example by 
!   different calling routines), but its information is stored only once. 
!   This is ensured by comparing the boxes of a new distrID with those of all
!   previously defined distributions. If they coincide, the distrID is simply
!   added to the existing distribution.
! Each distrID is never repeated. When a distrID is erased (freed), the
!   distribution itself is not erased, unless all its IDs have been erased.
!   This prevents that a calling routine may erase a distribution that is
!   still being used by other routines.
!
!******************************************************************************

MODULE gridxc_mesh3D

! Used module procedures
  use gridxc_alloc,     only: de_alloc        ! De-allocation routine
  use gridxc_alloc,     only: re_alloc        ! Re-allocation routine
  use gridxc_sys,       only: die             ! Termination routine
  use gridxc_sorting,   only: ordix           ! Sorting routine

! Used module parameters
  use gridxc_precision, only: dp              ! Real double precision type
  use gridxc_precision, only: gp=>grid_p      ! Grid-data real precision type
!  use parallel,  only: myNode=>node    ! This process node
!  use parallel,  only: totNodes=>nodes ! Total number of processor nodes
#ifdef DEBUG_XC
  use gridxc_debugXC,   only: udebug          ! Output file unit for debug info
#endif /* DEBUG_XC */

  ! Copy and add for limiting temporary arrays
  use gridxc_array, only: array_copy, array_add

! Used MPI procedures and types
#ifdef HAVE_MPI
  use mpi
  use gridxc_precision, only: MPI_grid_real
#endif

  ! MPI variables
#ifdef HAVE_MPI
  use gridxc_config, only: comm => gridxc_comm
#endif
  use gridxc_config, only: myNode => gridxc_myNode 
  use gridxc_config, only: totNodes => gridxc_totNodes

  implicit none

! Public procedures
PUBLIC:: &
  addMeshData,   &! Adds the data in a box array to the equiv. unit-cell points
  associateMeshTask, &! Associates a communication task to mesh distr.
  copyMeshData,  &! Copies data in a unit-cell array to another mesh box array
  fftMeshDistr,  &! Sets four mesh distributions to perform FFTs 
  freeMeshDistr, &! Frees a distribution index (they are limited to maxDistr)
  freeMeshTask,  &! Frees a task index (they are limited to maxTasks)
  myMeshBox,     &! Returns mesh box of my processor node
  nodeMeshBox,   &! Returns mesh box of any given processor node
  redistributeMeshData, &! Copies data between different mesh distributions
  sameMeshDistr, &! Finds if two mesh distributions are equal
  setMeshDistr    ! Defines a distribution of mesh points over parallel nodes

! Public types, parameters, or variables:
! none

PRIVATE ! Nothing is declared public beyond this point

  ! Private module parameters
  character(len=*),parameter:: moduleName = 'mesh3D '
  integer,parameter:: maxDistr   = 20 ! Max. number of mesh distributions
                                      !   allocated at any given time
  integer,parameter:: maxTasks  = 100 ! Max. number of communication tasks
                                      !   allocated at any given time
  integer,parameter:: maxDistrID = 20 ! Max. IDs assigned to the same distrib.
  integer,parameter:: maxTaskID  = 10 ! Max. IDs assigned to the same task
  integer,parameter:: maxParts  = 125 ! Max. parts of a mesh box
  integer,parameter:: maxDistrTasks = 50 ! Max. communication tasks associated
                                         !   to a parallel mesh distribution

  ! Private type to hold mesh distribution data
  type distrType
    private
    logical:: defined=.false.   ! Has this distribution been defined?
    integer:: ID(maxDistrID)=-1 ! ID numbers assigned to the distribution
    integer:: nNodes=-1         ! Number of nodes participating in the distrib.
    integer:: firstNode=-1      ! First of the consecutive nNodes in the distr.
    integer:: nMesh(3)=-1       ! Number of total mesh divisions in each axis
    integer:: task(maxDistrTasks)=-1 ! Communic. tasks associated to distr.
    integer,pointer:: box(:,:,:)=>null() ! Mesh box bounds of each node:
                                         ! box(1,iAxis,iNode)=lower bounds
                                         ! box(2,iAxis,iNode)=upper bounds
  end type distrType

  ! Private type to hold a mesh communication task
  type taskType
    private
    logical:: defined=.false.    ! Has this task been defined?
    logical:: optimized=.false.  ! Has the transfer order been optimized?
    logical:: associated=.false. ! Has this task been associated to any distr?
    integer:: ID(maxTaskID)=-1   ! ID numbers assigned to the distribution
    integer:: distr(2)=-1        ! Distr. indexes to which task is associated
    integer:: nTrsf=0            ! Number of needed communication transfers
    integer,pointer:: srcBox(:,:,:)=>null() ! Source mesh box of each node.
    integer,pointer:: dstBox(:,:,:)=>null() ! Destination mesh box of each node.
    integer,pointer:: trsfNode(:) ! Sequence of to/from transfer nodes
    integer,pointer:: trsfDir(:) ! Sequence of to/from transfer directions
  end type taskType

  ! Private array that will hold the different distributions data
  type(distrType),target,save:: storedMeshDistr(maxDistr)

  ! Private array that will hold the different communication tasks
  type(taskType),target,save:: storedMeshTask(maxTasks)

  ! Private counters
  integer,save:: nDistrID = 0  ! Number of assigned distribution IDs
  integer,save:: nTaskID = 0  ! Number of assigned mesh communication task IDs


#ifdef HAVE_MPI
  integer:: MPIerror, MPIstatus(MPI_STATUS_SIZE)
#endif

CONTAINS

!----------------------------------------------------------------------------

subroutine addMeshData( nMesh, srcBox, srcData, dstDistr, dstData, task )

! Adds (reduces) the values defined in a 3D mesh box to the equivalent mesh 
! points in a periodic unit cell. 

  implicit none
  integer, intent(in) :: nMesh(3)          ! Global mesh size in each axis
  integer, intent(in) :: srcBox(2,3)       ! Source mesh box:
                                           ! box(1,iAxis)=lower box limits
                                           ! box(2,iAxis)=upper box limits
                                           ! Box may be larger than the
                                           ! (0:nMesh-1) unit-cell range
  real(gp),intent(in) :: srcData(0:,0:,0:,:) ! Source data values to be copied.
                                           ! The first three upper array bounds 
                                           ! must be equal or larger than
                                           ! srcBox(2,iAxis)-src(1,iAxis)
  integer, intent(in) :: dstDistr          ! Distrib. ID of destination data
                                           ! or zero for serial execution
  real(gp),intent(inout):: dstData(0:,0:,0:,:) ! Destination data array
                                           ! Its upper array bounds must be
                                           ! enough to contain the node box in
                                           ! the dstDistr parallel distrib.
                                           ! or nMesh(iAxis)-1 in serial exe
  integer,intent(inout),optional:: task    ! ID of communication task

  integer :: dstBox(2,3)

! Associate task to distribution
  if (present(task)) call associateMeshTask( task, dstDistr )

! Find box limits of destination data in this node
  call myMeshBox( nMesh, dstDistr, dstBox )

! Add srcData to dstData
  call reduceData( nMesh, srcBox, srcData, dstBox, dstData, taskID=task )

end subroutine addMeshData

!-------------------------------------------------------------------------------

subroutine all2allTransferOrder( nNodes, node, nTrsf, trsfNode, trsfDir )

! Finds an ordered sequence of matching all-to-all send-receive transfers
! that avoids collisions and that approximately minimizes total transfer time
! Algorithm:
! At any given 'time' (index of the ordered sequence), half of the nodes send
! right-wards (to higher nodes) and the other half receives from leftwards,
! with a fixed internode span, modulo nNodes2 (defined below). The sending/
! receiving nodes belong to odd/even blocks (or viceversa) of consecutive nodes,
! whose blockSize is the power-of-two factor of the span (i.e. span is the
! product of the blocSize times an odd number). nNodes2 is the smallest 
! multiple of 2*blockSize equal to, or larger than nNodes. This ensures opposite
! parities of the blocks of sendNode and recvNode=modulo(sendNode+span,nNodes2).

  implicit none
  integer,intent(in) :: nNodes   ! Number of parallel processor nodes. The
                                 ! number of transfers per node is 2*nNodes-1
  integer,intent(in) :: node     ! Local processor node, in range (0:nNodes-1)
  integer,intent(out):: nTrsf    ! Number of required transfers
  integer,intent(out):: trsfNode(0:2*(nNodes-1)) ! To/from transfer node.
                                 ! First 'transfer' is local: trsfNode(0)=node
  integer,intent(out):: trsfDir(0:2*(nNodes-1))  ! Transfer direction:
                                 ! trsfDir=+1 => from node to trsfNode
                                 ! trsfDir=-1 => from trsfNode to node
                                 ! trsfDir=0  => local 'transfer' within node

  integer:: blockSize, iTrsf, nNodes2, nodePar, oddFac, pow2, span, trsfPar

  ! Set num. of transfers needed (a send and a receive to/from each other node)
  nTrsf = 2*(nNodes-1)

  ! Special local transfer
  trsfNode(0) = node
  trsfDir(0)  = 0
  if (nNodes==1) return

  ! Loop on block sizes (powers of 2). iTrsf is the transfer-order index.
  iTrsf = 1
  do pow2 = 0,int(log(real(nNodes))/log(2.))+1
    blockSize = 2**pow2
    ! Find smallest multiple of 2*blockSize equal to, or larger than nNodes
    nNodes2 = ((nNodes-1)/(2*blockSize)+1) * (2*blockSize)
    ! Find parity of node's block
    nodePar = mod(node/blockSize,2)
    ! Loop on odd factors of span. Maximum span is nNodes2-1
    ! Fake nodes are 'added' between nNodes and nNodes2-1
    do oddFac = 1,nNodes2/blockSize,2
      span = blockSize * oddFac
      ! Loop on transfer 'parity' (direction)
      do trsfPar = 0,1
        ! Find transfer sense, and the node sending/receiving to/from node
        ! All transfers are rightwards, with transfer node modulo mNodes2
        if (nodePar==trsfPar) then ! node sends
          trsfNode(iTrsf) = modulo( node+span, nNodes2 )
          trsfDir(iTrsf) = +1
        else ! node receives
          trsfNode(iTrsf) = modulo( node-span, nNodes2 )
          trsfDir(iTrsf) = -1
        end if ! (nodePar==trsfPar)
        ! If trsfNode is within range (not a fake node), accept this transfer
        if (trsfNode(iTrsf)<nNodes) iTrsf = iTrsf + 1
        ! Finish when all transfers have been found
        if (iTrsf>2*(nNodes-1)) return
      end do ! trsfPar
    end do ! oddFact
  end do ! pow2

end subroutine all2allTransferOrder

!-------------------------------------------------------------------------------

subroutine associateMeshTask( taskID, distrID1, distrID2 )

! Associates a communication task to one or two parallel mesh distributions

  implicit none
  integer,         intent(inout):: taskID   ! ID of task to be associated
  integer,         intent(in)   :: distrID1 ! ID of first distr, to be assoc.
  integer,optional,intent(in)   :: distrID2 ! ID of second distr. to be assoc.

  character(len=*),parameter:: myName = 'associateMeshTask '
  character(len=*),parameter:: errHead = myName//'ERROR: '
  logical:: found
  integer:: iDistr1, iDistr2, it, iTask
  type(taskType), pointer :: task
  type(distrType), pointer :: distr1, distr2

! In serial execution, do nothing
  if (totNodes<2) return

! Find distribution(s)
  iDistr1 = indexDistr( distrID1 )
  if (iDistr1<0) call die(errHead//'distrID1 not defined')
  distr1 => storedMeshDistr(iDistr1)  ! Just a shorter name
  if (present(distrID2)) then
    iDistr2 = indexDistr( distrID2 )
    if (iDistr2<0) call die(errHead//'distrID2 not defined')
    distr2 => storedMeshDistr(iDistr2)
  end if ! (present(distrID2))

! Find task
  found = .false.
  iTask = indexTask( taskID )
  if (iTask>0) then  ! Task exists already
    task => storedMeshTask(iTask)  ! Just a shorter name
    found = .true.
    if (.not.any(iDistr1==task%distr)) found = .false.
    if (present(distrID2)) then
      if (.not.any(iDistr2==task%distr)) found = .false.
    end if
    if (.not.found) & ! Free existing task ID, since it has new associations
      call freeMeshTask( taskID )
  end if ! (iTask>0)

! Create new task, if necessary
  if (found) then
    return  ! Since task is alredy associated to same distribution(s)
  else      ! Task did not exist or has been eliminated => create it
    call initTask( taskID )
    iTask = indexTask( taskID )
    task => storedMeshTask(iTask)
  end if ! (found)

! Store association to first distribution
  task%distr(1) = iDistr1  ! Associate distribution to task
  if (.not.any(distr1%task==iTask)) then  ! Associate task to distribution
    found = .false.
    do it = 1,maxDistrTasks
      if (distr1%task(it)<0) then  ! Empty slot
        distr1%task(it) = iTask
        found = .true.
        exit ! it loop
      end if
    end do ! it
    if (.not.found) call die(errHead//'parameter maxDistrTasks too small')
  end if ! (.not.any(distr1%task==iTask))

! Store association to second distribution, if different from first one
  if (present(distrID2) .and. iDistr1/=iDistr2) then
    task%distr(2) = iDistr2
    if (.not.any(distr2%task==iTask)) then
      found = .false.
      do it = 1,maxDistrTasks
        if (distr2%task(it)<0) then  ! Empty slot
          distr2%task(it) = iTask
          found = .true.
          exit ! it loop
        end if
      end do ! it
      if (.not.found) call die(errHead//'parameter maxDistrTasks too small')
    end if ! (.not.any(distr2%task==iTask))
  end if ! (present(distrID2))

! Mark task as already associated
  task%associated = .true.

#ifdef DEBUG_XC
!  if (present(distrID2)) then
!    write(udebug,'(a,2i4,2(2x,2i4))') &
!      myName//'taskID,iTask,distrID,iDistr=', &
!      taskID, iTask, distrID1, iDistr1, distrID2, iDistr2
!    write(udebug,'(a,i3,2x,25i3,/,(36x,25i3))') myName//'iDistr,tasks=', &
!      iDistr1, pack(distr1%task,distr1%task>0)
!    write(udebug,'(a,i3,2x,25i3,/,(36x,25i3))') myName//'iDistr,tasks=', &
!      iDistr2, pack(distr2%task,distr2%task>0)
!  else
!    write(udebug,'(a,2i4,2x,2i4)') &
!      myName//'taskID,iTask,distrID,iDistr=', &
!      taskID, iTask, distrID1, iDistr1
!    write(udebug,'(a,i3,2x,25i3,/,(36x,25i3))') myName//'iDistr,tasks=', &
!      iDistr1, pack(distr1%task,distr1%task>0)
!  end if
#endif /* DEBUG_XC */

end subroutine associateMeshTask

!-------------------------------------------------------------------------------

subroutine commonBox( nMesh, aBox, bBox, aComBox, bComBox, sizeSum, nParts )

! Finds the common intersection(s) of two mesh boxes, not necessarily contained
! in first unit cell (FUC). Each box is folded in parts contained in FUC.
! Then the intersection is obtained between each part or the folded aBox and
! each part of the folded bBox and returned in nParts intersection parts.

  implicit none
  integer,intent(in) :: nMesh(3)       ! Mesh divisions in each axis
  integer,intent(in) :: aBox(2,3)      ! First box, not necessarily within FUC
  integer,intent(in) :: bBox(2,3)      ! Second box, not necessarily within FUC
  integer,intent(out):: aComBox(:,:,:) ! Partial intersection boxes, each one
                                       ! contained in a single periodic cell, 
                                       ! relative to the aBox origin
  integer,intent(out):: bComBox(:,:,:) ! Same partial intersection boxes, but 
                                       ! relative to the bBox origin
  integer,intent(out):: sizeSum(0:)    ! Sum of the sizes of the partial boxes
  integer,intent(out):: nParts         ! Number of partial boxes

  character(len=*),parameter:: myName = moduleName//'commonBox '
  character(len=*),parameter:: errHead = myName//'ERROR: '
  integer:: aPart, aParts, aPartBox(2,3,maxParts), aPartBoxFUC(2,3,maxParts), &
            bPart, bParts, bPartBox(2,3,maxParts), bPartBoxFUC(2,3,maxParts), &
            comBox(2,3), comSize, mxParts

! Find maximum number of parts allowed by size of output arrays
  mxParts = min( size(aComBox,3), size(bComBox,3), size(sizeSum)-1 )

! Divide aBox and bBox in parts contained in a single unit cell, as well as
! the equivalent part boxes in first unit cell (FUC)
  call unitCellParts( nMesh, aBox, aPartBox, aPartBoxFUC, aParts )
  call unitCellParts( nMesh, bBox, bPartBox, bPartBoxFUC, bParts )

! Find intersection boxes common to aBox and bBox
#ifdef DEBUG_XC
!  write(udebug,'(a,3(2i4,2x))') myName//'       aBox=', aBox
!  write(udebug,'(a,3(2i4,2x))') myName//'       bBox=', bBox
#endif /* DEBUG_XC */
  nParts = 0
  sizeSum(0) = 0
  do bPart = 1,bParts
  do aPart = 1,aParts
    comBox(1,:) = max( aPartBoxFUC(1,:,aPart), bPartBoxFUC(1,:,bPart) )
    comBox(2,:) = min( aPartBoxFUC(2,:,aPart), bPartBoxFUC(2,:,bPart) )
    if (all(comBox(1,:)<=comBox(2,:))) then ! Nonempty intersection box
      nParts = nParts + 1
      if (nParts > mxParts) &
        call die(errHead//'size of aComBox, bComBox, or sizeSum too small')
      ! Sum size of common box
      comSize = product(comBox(2,:)-comBox(1,:)+1)
      sizeSum(nParts) = sizeSum(nParts-1) + comSize
      ! Find common box in the unfolded unit cell of aPartBox
      aComBox(:,:,nParts) = comBox(:,:) + &
                            aPartBox(:,:,aPart) - aPartBoxFUC(:,:,aPart)
      ! Find common box in aBox origin. Index=1 in srcBox in both lines!!!
      aComBox(1,:,nParts) = aComBox(1,:,nParts) - aBox(1,:)
      aComBox(2,:,nParts) = aComBox(2,:,nParts) - aBox(1,:)
      ! Find common box in bBox origin
      bComBox(:,:,nParts) = comBox(:,:) + &
                            bPartBox(:,:,bPart) - bPartBoxFUC(:,:,bPart)
      bComBox(1,:,nParts) = bComBox(1,:,nParts) - bBox(1,:)
      bComBox(2,:,nParts) = bComBox(2,:,nParts) - bBox(1,:)
#ifdef DEBUG_XC
!      write(udebug,'(a,3(2i4,2x))') myName//'   aPartBox=', &
!                                                   aPartBox(:,:,aPart)
!      write(udebug,'(a,3(2i4,2x))') myName//'     comBox=', &
!        comBox(:,:) - aPartBox(:,:,aPart) + aPartBoxFUC(:,:,aPart)
!      write(udebug,'(a,3(2i4,2x))') myName//'    aComBox=', &
!                                                    aComBox(:,:,nParts)
!      write(udebug,'(a,3(2i4,2x))') myName//'    bComBox=', &
!                                                    bComBox(:,:,nParts)
#endif /* DEBUG_XC */
    end if
  end do ! aPart
  end do ! bPart

end subroutine commonBox

!-------------------------------------------------------------------------------

subroutine copyMeshData( nMesh, srcDistr, srcData, dstBox, dstData, task )

! Copies a box of values defined in a 3D mesh of a periodic unit cell.

  implicit none
  integer, intent(in) :: nMesh(3)          ! Global mesh size in each axis
  integer, intent(in) :: srcDistr          ! Distrib. ID of source data
                                           ! or zero for serial execution
  real(gp),intent(in) :: srcData(0:,0:,0:,:) ! Source data values to be copied
                                           ! Its upper array bounds must be
                                           ! enough to contain the node box in
                                           ! the srcDistr parallel distrib.
                                           ! or nMesh(iAxis)-1 in serial exe
  integer, intent(in) :: dstBox(2,3)       ! Destination mesh box:
                                           ! box(1,iAxis)=lower box limits
                                           ! box(2,iAxis)=upper box limits
                                           ! Box may be larger than the
                                           ! (0:nMesh-1) unit-cell range
  real(gp),intent(out):: dstData(0:,0:,0:,:) ! Destination data values.
                                           ! The upper array bounds must be 
                                           ! dstBox(2,iAxis)-dst(1,iAxis)
                                           ! srcData and dstData must be 
                                           ! different arrays
  integer,intent(inout),optional:: task    ! ID of communication task

  integer :: srcBox(2,3)

! Associate task to distribution
  if (present(task)) call associateMeshTask( task, srcDistr )

! Find box limits of source data in this node
  call myMeshBox( nMesh, srcDistr, srcBox )

! Check that srcData and dstData are not identical already
!  Avoid this in parallel, since different nodes might do different things
!  if (all(srcBox==dstBox) .and. all(shape(srcData)==shape(dstData))) then
!    if (all(srcData==dstData)) return
!  end if

! Copy data
  dstData = 0
  call reduceData( nMesh, srcBox, srcData, dstBox, dstData, taskID=task )

end subroutine copyMeshData

!-------------------------------------------------------------------------------

subroutine divideBox1D( box, nParts, partBox, blockSize, workload )

! Divides a 1D box according to workload (or uniformly if workload is absent)

  implicit none
  integer,          intent(in) :: box(2)
  integer,          intent(in) :: nParts
!
! Avoid the creation of a temporary array by passing descriptor info
!!!  integer,          intent(out):: partBox(2,nParts)
  integer,          intent(out):: partBox(:,:)  
!
  integer, optional,intent(in) :: blockSize
  real(gp),optional,intent(in) :: workload(0:)

  character(len=*),parameter:: myName = moduleName//'divideBox1D '
  character(len=*),parameter:: errHead = myName//'ERROR: '
  logical :: nextPart
  integer :: blckSize, boxSize, i, iPart, largerSize, last, &
             nBlocks, nLargerParts, partSize
  real(dp):: partWkld, wlSum

! Trap a trivial case
  if (nParts==1) then
    partBox(:,1) = box
    return
  end if

! Find box size
  boxSize = box(2) - box(1) + 1

! Set block size
  if (present(blockSize)) then
    if (mod(boxSize,blockSize)/=0) &
      call die(errHead//'boxSize not a multiple of blockSize')
    blckSize = blockSize
  else
    blckSize = 1
  end if

! Choose division mode
  if (present(workload)) then ! Divide box according to workload

    ! Check size of workload array
    if (size(workload)/=boxSize) call die(errHead//'size(workload)/=boxSize')

    ! Find intended workload of each part
    wlSum = sum(workload)
    partWkld = wlSum / nParts

    ! Loop on parts
    partBox(1,1) = box(1)
    do iPart = 1,nParts-1
      last = 0  ! Last point with nonzero workload (or zero if none yet)
      do i = 0,boxSize-1
        if ( sum(workload(0:i)) > iPart*partWkld ) then  ! Limit surpassed
          if (i==0 .or. last < i-1) then   ! Place limit at center of vacuum
            partBox(2,iPart) = box(1) + (last+i)/2
          else if ( i==boxSize-1 .or. &
                    abs(sum(workload(0:i-1))-iPart*partWkld) &
                  < abs(sum(workload(0:i))  -iPart*partWkld) ) then
            partBox(2,iPart) = box(1) + i-1
          else
            partBox(2,iPart) = box(1) + i
          end if
          partBox(1,iPart+1) = partBox(2,iPart) + 1
          ! Avoid dividing blocks: parts must begin in a multiple of blockSize
          partBox(1,iPart+1) = partBox(1,iPart+1) &
                             - mod( partBox(1,iPart+1), blckSize )
          ! Prevent that iPart and iPart+1 overlap
          partBox(1,iPart+1) = max( partBox(1,iPart+1), &
                                    partBox(1,iPart)+blckSize )
          partBox(2,iPart) = partBox(1,iPart+1) - 1
          ! Go to next part
          nextPart = .true.
        else ! Limit not surpassed
          nextPart = .false.
        end if ! ( sum(workload(axis,0:i)) > iPart*partWkld )
        if (workload(i)>0._gp) last = i
        if (nextPart) exit ! i loop
      end do ! i
    end do ! iPart
    partBox(2,nParts) = box(2)

  else ! (.not.present(workload)) => Divide box uniformly

    nBlocks = boxSize / blckSize              ! Number of blocks of points
    partSize = nBlocks / nParts               ! Blocks per part
    nLargerParts = nBlocks - partSize*nParts  ! Number of larger parts
    partSize = partSize * blckSize            ! Points per part
    largerSize = partSize + blckSize ! One more block for larger parts
    partBox(1,1) = box(1)
    do iPart = 1,nLargerParts        ! largerParts of size partSize+blockSize
      if (iPart>1) partBox(1,iPart) = partBox(2,iPart-1) + 1
      partBox(2,iPart) = partBox(1,iPart) + largerSize - 1
    end do
    do iPart = nLargerParts+1,nParts  ! remaining parts of size partSize
      if (iPart>1) partBox(1,iPart) = partBox(2,iPart-1) + 1
      partBox(2,iPart) = partBox(1,iPart) + partSize - 1
    end do

  end if ! (present(workload))

end subroutine divideBox1D

!-------------------------------------------------------------------------------

subroutine divideBox3D( nMesh, wlDistr, workload, box, &
                        nParts, blockSize, axis, partBox )

! Divides a mesh box according to a given workload and axis. If axis<1 on
! input, it is chosen to maximize the spatial dispersion of workload

  implicit none
  integer, intent(in)   :: nMesh(3)  ! Global mesh size in each axis
  integer, intent(in)   :: wlDistr   ! Mesh distribution ID of workload array
  real(gp),intent(in)   :: workload(0:,0:,0:) ! Work load of each mesh point
  integer, intent(in)   :: box(2,3)  ! Mesh box to be divided
  integer, intent(in)   :: nParts    ! Number of parts of the divided box
  integer, intent(in)   :: blockSize ! Size of blocks of mesh points in each 
                                     ! axis that cannot be split among nodes
  integer, intent(inout):: axis      ! Axis along which division is made
  integer, intent(out)  :: partBox(2,3,nParts) ! Divided part boxes

  character(len=*),parameter:: myName = moduleName//'divideBox3D '
  character(len=*),parameter:: errHead = myName//'ERROR: '
  integer :: boxShape(3), i, iPart, ix, maxShape
  real(dp):: maxDisp, wlDisp, wlSum, wlSum1, wlSum2
!  logical :: nextPart
!  integer :: largerSize, last, nBlocks, nLargerParts, partSize
!  real(dp):: partWkld
  real(gp),allocatable:: prjWkld(:,:)

! Initialize part boxes as total box
  forall (iPart=1:nParts) partBox(:,:,iPart) = box(:,:)

! Trap a trivial case
  if (nParts<2) return

! Check that nMesh and box are consistent with blockSize
  if (any(mod(nMesh,blockSize)/=0)) &
    call die(errHead//'nMesh and blockSize are not consistent')
  if (any(mod(box(1,:),blockSize)/=0) .or. &
      any(mod(box(2,:)+1,blockSize)/=0))   &
    call die(errHead//'box and blockSize are not consistent')

! Check that workload is nonnegative
  if (any(workload<0._gp)) call die(errHead//'negative workload')

! Allocate array for the projection of workload along each axis
  boxShape(:) = box(2,:) - box(1,:) + 1
  allocate( prjWkld(3,0:maxval(boxShape)-1) )

! Find projection of workload along each axis
  prjWkld = 0
  call projectMeshData( nMesh, wlDistr, workload, box, prjWkld )

#ifdef DEBUG_XC
!  write(udebug,*) myName//'projected workload:'
!  write(udebug,'(i4,3f15.6)') (i,prjWkld(:,i),i=0,maxval(boxShape)-1)
#endif /* DEBUG_XC */

! Find total workload in box
  wlSum = sum(prjWkld) / 3  ! Since the sum of each projection must be equal

! Select axis for division
  if (axis<1 .or. axis>3) then ! Otherwise, accept input axis 
    if (wlSum==0._dp) then  ! Choose longest axis
      maxShape = maxval(boxShape)
      do ix = 3,1,-1  ! If equivalent, take largest ix (z better than x)
        if (boxShape(ix) == maxShape) then
          axis = ix
          exit ! ix loop
        end if
      end do
    else ! Choose axis with maximum spatial dispersion of workload
      maxDisp = 0
      do ix = 3,1,-1
        wlSum1 = 0
        wlSum2 = 0
        do i = 0,boxShape(ix)-1
          wlSum1 = wlSum1 + prjWkld(ix,i) * i
          wlSum2 = wlSum2 + prjWkld(ix,i) * i**2
        end do
        wlDisp = wlSum2/wlSum - (wlSum1/wlSum)**2
        if (wlDisp>maxDisp) then
          axis = ix
          maxDisp = wlDisp
        end if
      end do ! ix
    end if ! (wlSum==0._gp)
  end if ! (axis<1 .or. axis>3)

! Divide box along axis
  if (wlSum==0._dp) then  ! Divide box uniformly
    call divideBox1D( box(:,axis), nParts, partBox(:,axis,:), blockSize )
  else                    ! Divide projected workload uniformly
    call divideBox1D( box(:,axis), nParts, partBox(:,axis,:), blockSize, &
                      prjWkld(axis,0:boxShape(axis)-1) )
  end if ! (wlSum==0._dp)

#ifdef DEBUG_XC
! Check that all box limits are consistent
  if ( any(box(1,axis) > partBox(1,axis,:)) .or. &
       any(partBox(2,axis,1:nParts-1) >= partBox(1,axis,2:nParts)) .or. &
       any(partBox(1,axis,:) > partBox(2,axis,:)) .or. &
       any(partBox(2,axis,:) > box(2,axis)) ) then
    write(udebug,'(a,3(2i6,2x))') errHead//'box=', box
    write(udebug,'(a,/,(3(2i6,2x)))') errHead//'partBox=', partBox
    call die(errHead//'inconsistent partBox limits')
  end if
#endif /* DEBUG_XC */

  deallocate( prjWkld )

end subroutine divideBox3D

!-------------------------------------------------------------------------------

subroutine fftMeshDistr( nMesh, fftDistr, axisDistr )

! Creates and returns a homogeneaous 3D mesh distribution fftDistr, and three
! 2D distributions axisDistr, whose boxes extend wholly over one of the three
! cell axes. These axisDistr allow fully local 1D FFTs in one of the axes.
! The fftDistr and axisDistr are designed to make already optimal (without any
! collisions) the default sequence of inter-node communications, returned by
! all2allTransferOrder. This is beacause all simultaneous communications occur
! between nodes separated by the same span (difference between node indexes).
! Thus, no task arguments are required to optimize such communications.

  implicit none
  integer,         intent(in)   :: nMesh(3)     ! Mesh divisions of each axis
  integer,         intent(inout):: fftDistr     ! 3D mesh distr. used in 3D FFT
  integer,optional,intent(inout):: axisDistr(3) ! 2D distr. used for the 1D FFTs

  character(len=*),parameter:: myName = 'fftMeshDistr '
  character(len=*),parameter:: errHead = myName//'ERROR: '
  integer:: axis, axis1, axis2, axis3, axisNodes(3), box0(2,3), boxNodes(3), &
            iDistr, iNode, iNode1, iNode2, iNode3, jNode2, jNode3, &
            node0, nodeSpan(3), oldDistr, rowMesh(3), rowNodes
  integer,allocatable:: subBox(:,:,:)
  logical:: found
  type(distrType),pointer:: distr

! Trap the serial case (totNodes available from module parallel)
  if (totNodes==1) then
    fftDistr = 0
    if (present(axisDistr)) axisDistr(:) = 0
    return
  end if

! Check if the input FFT distribution IDs are already defined as such
  iDistr = indexDistr( fftDistr )
  if (iDistr>0 .and. iDistr<=maxDistr) then
    distr => storedMeshDistr(iDistr)
    if (distr%defined .and. all(distr%nMesh==nMesh)) then
      found = .true.  ! But now check the axis distributions
      if (present(axisDistr)) then
        do axis = 1,3
          iDistr = indexDistr( axisDistr(axis) )
          if (iDistr>0 .and. iDistr<=maxDistr) then
            distr => storedMeshDistr(iDistr)
            if (.not.distr%defined .or. any(distr%nMesh/=nMesh)) &
              found = .false.
          else
            found = .false.
          end if
        end do ! axis
      end if ! (present(axisDistr))
      if (found) return ! Since the input values are still valid
    end if ! (distr%defined .and. ...)
  end if ! (iDistr>0)

! Find optimal distribution of nodes on axes
  call optimizeNodeDistr( nMesh, totNodes, axisNodes )

! Create homogeneous 3D distribution
#ifdef DEBUG_XC
!  write(udebug,*) myName//'calling setMeshDistr with fftDistr'
#endif /* DEBUG_XC */
  call setMeshDistr( fftDistr, nMesh, nNodesX=axisNodes(1), &
                     nNodesY=axisNodes(2), nNodesZ=axisNodes(3) )

! Return already if axis distributions are not required
  if (.not.present(axisDistr)) return

! Find span between nodes along each axis
!  nodeSpan(1) = 1
!  nodeSpan(2) = axisNodes(1)
!  nodeSpan(3) = axisNodes(1) * axisNodes(2)
! Third axis is innermost for node distribution (see setMeshDistr)
  nodeSpan(3) = 1
  nodeSpan(2) = axisNodes(3)
  nodeSpan(1) = axisNodes(3) * axisNodes(2)

#ifdef DEBUG_XC
!    write(udebug,'(a,3i4)') myName//'axisNodes=', axisNodes
!    write(udebug,'(a,3i4)') myName//'nodeSpan=', nodeSpan
#endif /* DEBUG_XC */

! Allocate a small temporary array
  allocate( subBox(2,0:maxval(axisNodes)-1,3) )

! Loop on the three cell axes
  do axis1 = 1,3

    ! (Re)initialize the axis distribution for the 1D FFT transforms
    oldDistr = axisDistr(axis1)
    call freeMeshDistr( axisDistr(axis1) )
    call initDistr( axisDistr(axis1), nMesh, 0, totNodes )

    ! Find the two other axes
    axis2 = modulo(axis1,3) + 1
    axis3 = modulo(axis2,3) + 1

    ! Point towards the apropriate axis distribution
    iDistr = indexDistr( axisDistr(axis1) )
    distr => storedMeshDistr(iDistr)

    ! Loop on the node boxes over the two other axes
    do iNode3 = 0,axisNodes(axis3)-1
    do iNode2 = 0,axisNodes(axis2)-1

      ! Find the first node in the row of nodes along axis1
      node0 = nodeSpan(axis2)*iNode2 + nodeSpan(axis3)*iNode3

      ! Find the box limits along axis2 and axis3
      call nodeMeshBox( nMesh, fftDistr, node0, box0 )

      ! Find the total box of a row of nodes along axis1
      rowNodes = axisNodes(axis1)
      rowMesh(1) = nMesh(axis1)
      rowMesh(2) = box0(2,axis2) - box0(1,axis2) + 1
      rowMesh(3) = box0(2,axis3) - box0(1,axis3) + 1

      ! Find an optimal (re)distribution of rowNodes along axis2 and/or axis3
      boxNodes(1) = 1
      call optimizeNodeDistr( rowMesh(2:3), rowNodes, boxNodes(2:3) )

      ! Divide the row box along axis2 and/or axis3
      subBox(1,0,1) = 0
      subBox(2,0,1) = nMesh(axis1) - 1
      call divideBox1D( box0(:,axis2), boxNodes(2), subBox(:,0:boxNodes(2)-1,2))
      call divideBox1D( box0(:,axis3), boxNodes(3), subBox(:,0:boxNodes(3)-1,3))

      ! Set the new boxes
      iNode = node0
      do jNode3 = 0,boxNodes(3)-1
      do jNode2 = 0,boxNodes(2)-1
        distr%box(1,axis1,iNode) = 0
        distr%box(2,axis1,iNode) = nMesh(axis1)-1
        distr%box(:,axis2,iNode) = subBox(:,jNode2,2)
        distr%box(:,axis3,iNode) = subBox(:,jNode3,3)
        iNode = iNode + nodeSpan(axis1)
      end do ! jNode2
      end do ! jNode3

#ifdef DEBUG_XC
!      write(udebug,'(a,2i4,3(2x,2i4))') &
!        myName//'axis1,node0,box0=', axis1, node0, box0
!      write(udebug,'(a,3i4)') myName//'boxNodes=', boxNodes
!      do jNode2 = 0,boxNodes(2)-1
!        write(udebug,'(a,i4,2x,3i4)') &
!          myName//'axis2,subBox=', axis2, subBox(:,jNode2,2)
!      end do
!      do jNode3 = 0,boxNodes(3)-1
!        write(udebug,'(a,i4,2x,3i4)') &
!          myName//'axis3,subBox=', axis3, subBox(:,jNode3,3)
!      end do
#endif /* DEBUG_XC */

    end do ! iNode2
    end do ! iNode3

    ! Check if this distribution was already defined
    call reduceDistr( axisDistr(axis1) )

#ifdef DEBUG_XC
    iDistr = indexDistr( axisDistr(axis1) )
    distr => storedMeshDistr(iDistr)
!    write(udebug,'(a,3i4)') myName//'axis1,axis2,axis3=', axis1, axis2, axis3
    write(udebug,'(a,6x,3i4,3(2x,2i4))') &
      myName//'    old/newDistrID,iDistr,myBox=', &
      oldDistr, axisDistr(axis1), iDistr, distr%box(:,:,myNode)
#endif /* DEBUG_XC */

  end do ! axis1

! Deallocate temporary array
  deallocate( subBox )

end subroutine fftMeshDistr

!-------------------------------------------------------------------------------

subroutine freeMeshDistr( distrID )

! Erases a mesh distribution ID and frees the distribution slot if 
! no other IDs are assigned to it

  implicit none
  integer,intent(in):: distrID  ! ID of an allocated distribution

  character(len=*),parameter:: myName = 'freeMeshDistr '
  character(len=*),parameter:: errHead = myName//'ERROR: '
  integer:: iDistr, iID, iNode, it, iTask, taskID
  logical:: found
  type(distrType),pointer :: distr
  type(taskType),pointer :: task

! Find internal distribution index
  iDistr = indexDistr( distrID )

! Check that distribution exists
  if (iDistr<1 .or. iDistr>maxDistr) return
  distr => storedMeshDistr(iDistr) ! Just a shorter name

! Erase ID from the distribution
  do iID = 1,maxDistrID
    if (distr%ID(iID)==distrID) then
      distr%ID(iID) = -1
      exit ! iID loop
    end if
  end do ! iID

! Free distribution if no other IDs are assigned to it
  if (all(distr%ID<0)) then
    ! First free all distribution tasks
#ifdef DEBUG_XC
!    if (any(distr%task>0)) &
!      write(udebug,'(a,i3,2x,25i3,/,(32x,25i3))') &
!        myName//'iDistr,tasks=', iDistr, pack(distr%task,distr%task>0)
#endif /* DEBUG_XC */
    do it = 1,maxDistrTasks
      iTask = distr%task(it)
      if (iTask>0) then
        task => storedMeshTask(iTask)
        found = .false.
        do iID = 1,maxTaskID  ! Find a valid ID of task, to call freeMeshTask
          taskID = task%ID(iID)
          if (taskID>0) then
            found = .true.
            call freeMeshTask( taskID )
            exit ! iID loop
          end if ! (taskID>0)
        end do ! iID
        if (.not.found) call die(myName//'ERROR: no valid task ID found')
      end if ! (iTask>0)
    end do ! it
    ! Finally free distribution itself
    deallocate( distr%box )
    distr%defined = .false.
  end if

end subroutine freeMeshDistr

!-------------------------------------------------------------------------------

subroutine freeMeshTask( taskID )

! Erases a mesh task ID and frees the task slot if 
! no other IDs are assigned to it

  implicit none
  integer,intent(in):: taskID  ! ID of an allocated task

  character(len=*),parameter:: myName = 'freeMeshTask '
  character(len=*),parameter:: errHead = myName//'ERROR: '
  integer:: distrID, i, iDistr, it, iTask, iID
  logical:: found
  type(distrType),pointer :: distr
  type(taskType),pointer :: task

! Find internal task index
  iTask = indexTask( taskID )

! Check that task exists
  if (iTask<1 .or. iTask>maxTasks) return
  task => storedMeshTask(iTask) ! Just a shorter name

#ifdef DEBUG_XC
!  write(udebug,'(a,2i4,2x,2i4)') &
!    myName//'taskID,iTask,task%distr=', taskID, iTask, task%distr
#endif /* DEBUG_XC */

! Erase ID from the task ID list
  do iID = 1,maxTaskID
    if (task%ID(iID)==taskID) then
      task%ID(iID) = -1
      exit ! iID loop
    end if
  end do ! iID

! Free task if no other IDs are assigned to it
  if (all(task%ID<0)) then
    ! First eliminate task from all its associated distributions
    do i = 1,2
      iDistr = task%distr(i)
      if (iDistr>0) then
        distr => storedMeshDistr(iDistr)
        found = .false.
        do it = 1,maxDistrTasks
          if (distr%task(it)==iTask) then
            distr%task(it) = -1
            found = .true.
          end if
        end do ! it
        if (.not.found) call die(errHead//'task-distr association not found')
      end if ! (iDistr>0)
    end do ! i
    ! Finally free task itself
    deallocate( task%trsfDir, task%trsfNode, task%dstBox, task%srcBox )
    task%associated = .false.
    task%optimized = .false.
    task%defined = .false.
    task%distr = -1
    task%ID = -1
  end if

end subroutine freeMeshTask

!-------------------------------------------------------------------------------

subroutine gatherBoxes( box, boxes )

! Gathers the mesh boxes of all processors

  implicit none
  integer,intent(in) :: box(2,3)                 ! My node's mesh box
  integer,intent(out):: boxes(2,3,0:totNodes-1)  ! All node's boxes

#ifdef HAVE_MPI
! Gather the boxes of all nodes
  call MPI_AllGather( box(1,1) , 6, MPI_Integer, &
                      boxes(1,1,0), 6, MPI_Integer, COMM, MPIerror )
#else
! Copy the only node's box
  boxes(:,:,0) = box(:,:)
#endif

end subroutine gatherBoxes

!-------------------------------------------------------------------------------

integer function indexDistr( distrID )

! Returns the internal memory position in which a distribution is stored or
!   0 if distrID==0
!  -1 if there is no allocated distribution with that ID

  implicit none
  integer,intent(in):: distrID ! Distribution ID

  integer:: iDistr

  indexDistr = -1

  if (distrID==0) then
    indexDistr = 0
  else if (distrID>0) then
    do iDistr = 1,maxDistr
      if ( storedMeshDistr(iDistr)%defined .and. &
           any(storedMeshDistr(iDistr)%ID==distrID) ) then
        indexDistr = iDistr
        return
      end if
    end do ! iDistr
  end if

end function indexDistr

!-------------------------------------------------------------------------------

integer function indexTask( taskID )

! Returns the internal memory position in which a task is stored or
!  -1 if there is no allocated task with that ID

  implicit none
  integer,intent(in):: taskID ! Task ID

  integer:: iTask

  indexTask = -1

  if (taskID>0) then
    do iTask = 1,maxTasks
      if ( any(storedMeshTask(iTask)%ID==taskID) ) then
        indexTask = iTask
        return
      end if
    end do ! iTask
  end if

end function indexTask

!-------------------------------------------------------------------------------

subroutine initDistr( distrID, nMesh, firstNode, nNodes )

! Initializes a parallel distribution of mesh points among processor nodes.
! In serial execution (totNodes==1) it simply returns distrID=0.

  implicit none
  integer,intent(out):: distrID   ! ID assigned to the mesh distrib.
  integer,intent(in) :: nMesh(3)  ! Mesh divisions in each axis
                                  ! (including "subpoints")
  integer,intent(in) :: firstNode ! First node in the mesh distr.
  integer,intent(in) :: nNodes    ! Total nodes in the mesh distr
                                  ! If not present all nodes are used

  character(len=*),parameter:: myName = moduleName//'initDistr '
  character(len=*),parameter:: errHead = myName//'ERROR: '
  type(distrType),pointer:: distr
  integer:: iDistr, iID
  logical:: found

! Trap the serial case (totNodes available from module parallel)
  if (totNodes==1) then
    distrID = 0
    return
  end if

! Find an available internal distribution slot
  found = .false.
  do iDistr = 1,maxDistr
    if (all(storedMeshDistr(iDistr)%ID<0)) then  ! Available (empty) slot
      found = .true.
      exit ! iDistr loop
    end if
  end do ! iDistr
  if (.not.found) call die(errHead//'parameter maxDistr too small')

! Increase private distribution ID counter and assign it to new distribution
  nDistrID = nDistrID + 1
  distrID = nDistrID

! Set distribution parameters, except box
  distr => storedMeshDistr(iDistr)  ! Just a shorter name
  distr%defined = .true.
  distr%firstNode = firstNode
  distr%nNodes = nNodes
  distr%nMesh = nMesh
  distr%task = -1
  distr%ID(:) = -1
  distr%ID(1) = distrID

! Allocate box array
  allocate( distr%box(2,3,0:totNodes-1) )

! Initialize node boxes so that lower bound > upper bound (null box)
  distr%box(1,:,:) = 0
  distr%box(2,:,:) = -1

#ifdef DEBUG_XC
! write(udebug,'(a,2i6)') myName//'distrID,iDistr=', distrID, iDistr
#endif /* DEBUG_XC */

end subroutine initDistr

!-------------------------------------------------------------------------------

subroutine initTask( taskID )

! Initializes the ID of a communication task of mesh data

  implicit none
  integer,intent(out):: taskID

  character(len=*),parameter:: myName = moduleName//'initTask '
  character(len=*),parameter:: errHead = myName//'ERROR: '
  logical:: found
  integer:: iTask
  type(taskType),pointer:: task

! Trap the serial case (totNodes available from module parallel)
  if (totNodes==1) then
    taskID = 0
    return
  end if

! Find an available internal distribution slot
  found = .false.
  do iTask = 1,maxTasks
    if (all(storedMeshTask(iTask)%ID<0)) then ! Available (empty) slot
      found = .true.
      exit ! iTask loop
    end if
  end do ! iTask
  if (.not.found) call die(errHead//'parameter maxTasks too small')

! Increase private distribution ID counter and assign it to new distribution
  nTaskID = nTaskID + 1
  taskID = nTaskID

! Set task parameters, except boxes
  task => storedMeshTask(iTask)  ! Just a shorter name
  task%defined = .false.
  task%optimized = .false.
  task%associated = .false.
  task%distr = -1
  task%nTrsf = 0
  task%ID = -1
  task%ID(1) = taskID

! Allocate transfer sequence (a send and a receive to/from each other node)
  allocate( task%trsfNode(0:2*(totNodes-1)) )
  allocate( task%trsfDir(0:2*(totNodes-1)) )

! Allocate box arrays
  allocate( task%srcBox(2,3,0:totNodes-1) )
  allocate( task%dstBox(2,3,0:totNodes-1) )

! Initialize boxes so that lower bound > upper bound (null box)
  task%srcBox(1,:,:) = 0
  task%srcBox(2,:,:) = -1
  task%dstBox(1,:,:) = 0
  task%dstBox(2,:,:) = -1

#ifdef DEBUG_XC
! write(udebug,'(a,2i6)') myName//'taskID, iTask=', taskID, iTask
#endif /* DEBUG_XC */

end subroutine initTask

!-------------------------------------------------------------------------------

subroutine myMeshBox( nMesh, distrID, box )

! Finds the mesh box belonging to a node in a parallel mesh distribution,
! If iDistr=0, it returns box(1,:)=0 and  box(2,:)=nMesh(:)-1 
! If node stores no mesh points, its (empty) box returns with box(1,:)>box(2,:)
! Note: although nMesh is available from the distr. data, it is also included
! in the routine arguments, to handle directly the case iDistr=0.

  implicit none
  integer, intent(in) :: nMesh(3)  ! Mesh divisions in each axis
  integer, intent(in) :: distrID   ! Mesh-distribution ID
  integer, intent(out):: box(2,3)  ! Mesh box: box(1,:) = lower bounds
                                   !           box(2,:) = upper bounds

  call nodeMeshBox( nMesh, distrID, myNode, box )

end subroutine myMeshBox

!-------------------------------------------------------------------------------

subroutine nodeMeshBox( nMesh, distrID, node, box )

! Finds the mesh box belonging to a node in a parallel mesh distribution,
! If iDistr=0, it returns box(1,:)=0 and  box(2,:)=nMesh(:)-1 
! If node stores no mesh points, its (empty) box returns with box(1,:)>box(2,:)
! Note: although nMesh is available from the distr. data, it is also included
! in the routine arguments, to handle directly the case iDistr=0.

  implicit none
  integer,intent(in) :: nMesh(3)  ! Mesh divisions in each axis
  integer,intent(in) :: distrID   ! Mesh-distribution ID
  integer,intent(in) :: node      ! Processor node whose box is needed
                                  ! If not present, node=myNode
  integer,intent(out):: box(2,3)  ! Mesh box: box(1,:) = lower bounds
                                  !           box(2,:) = upper bounds

  character(len=*),parameter:: myName = 'nodeMeshBox '
  character(len=*),parameter:: errHead = myName//'ERROR: '

  integer:: iDistr

  if (distrID==0) then ! Data not distributed
    box(1,:) = 0
    box(2,:) = nMesh(:)-1
  else
    iDistr = indexDistr( distrID )
    if (iDistr>0 .and. iDistr<=maxDistr) then
      if (any(nMesh/=storedMeshDistr(iDistr)%nMesh)) &
        call die(errHead//'nMesh/=distr%nMesh')
      box(:,:) = storedMeshDistr(iDistr)%box(:,:,node)
    else
      call die(errHead//'undefined mesh distribution')
    end if
  end if

end subroutine nodeMeshBox

!-------------------------------------------------------------------------------

subroutine optimizeNodeDistr( nMesh, nNodes, axisNodes )

! Finds a reasonably optimal distribution of nodes over the different axes.
! Optimal here means that it leads to most cubic mesh boxes for each node.

  implicit none
  integer,intent(in) :: nMesh(:)     ! Mesh points in each axis
  integer,intent(in) :: nNodes       ! Total number of processor nodes
  integer,intent(out):: axisNodes(:) ! Number of nodes in each axis

  character(len=*),parameter:: myName = moduleName//'optimizeNodeDistr '
  character(len=*),parameter:: errHead = myName//'ERROR: '
  integer,parameter:: maxFac = 1000
  integer :: fac(maxFac), i2, i3, i5, iFac1, iFac2, iRem, &
             n, n2, n3, n5, nAxes, nFac, nod1, nod2, nod3, nRem, remFac
  real(dp):: box1, box2, box3, boxAvg, boxErr, minErr

! Find number of axes and handle the trivial single-axis case
  nAxes = size(nMesh)
  if (nAxes<1) then
    return
  else if (nAxes==1) then
    axisNodes(1) = nNodes
    return
  else if (nAxes>3) then
    call die(errHead//'not prepared for nAxes>3')
  end if

! Find prime factors of nNodes (only 2, 3, and 5 coded presently) so that
!   nNodes = 2**n2 * 3**n3 * 5**n5 * remFac**nRem
  n = nNodes
  n2 = 0
  n3 = 0
  n5 = 0
  do
    if (mod(n,2)==0) then
      n2 = n2 + 1
      n = n / 2
    else if (mod(n,3)==0) then
      n3 = n3 + 1
      n = n / 3
    else if (mod(n,5)==0) then
      n5 = n5 + 1
      n = n / 5
    else
      exit ! do loop
    end if
  end do
  remFac = n
  if (remFac==1) then
    nRem = 0
  else
    nRem = 1
  end if

! Find all possible factors of nNodes
  nFac = 0
  do i2 = 0,n2
    do i3 = 0,n3
      do i5 = 0,n5
        do iRem = 0,nRem
          nFac = nFac + 1
          if (nFac>maxFac) call die(errHead//'parameter maxFac too small')
          fac(nFac) = 2**i2 * 3**i3 * 5**i5 * remFac**iRem
        end do ! iRem
      end do ! i5
    end do ! i3
  end do ! i2

! Try all possible combinations of factors on each axis and select that with
! most cubic boxes
  minErr = huge(minErr)
  do iFac1 = 1,nFac
    nod1 = fac(iFac1)
    box1 = nMesh(1) / real(nod1,dp)
    if (nAxes==2) then
      nod2 = nNodes / nod1
      box2 = nMesh(2) / real(nod2,dp)
      boxAvg = (box1 + box2) / 2
      boxErr = log(box1/boxAvg)**2 + log(box2/boxAvg)**2
      if (boxErr<minErr) then
        axisNodes(1) = nod1
        axisNodes(2) = nod2
        minErr = boxErr
      end if
    else ! (nAxes==3)
      do iFac2 = 1,nFac
        nod2 = fac(iFac2)
        if (mod(nNodes,nod1*nod2) /= 0) cycle ! iFac2 loop
        nod3 = nNodes / (nod1*nod2)
        box2 = nMesh(2) / real(nod2,dp)
        box3 = nMesh(3) / real(nod3,dp)
        boxAvg = (box1 + box2 + box3) / 3
        boxErr = log(box1/boxAvg)**2 + log(box2/boxAvg)**2 + log(box3/boxAvg)**2
        if (boxErr<minErr) then
          axisNodes(1) = nod1
          axisNodes(2) = nod2
          axisNodes(3) = nod3
          minErr = boxErr
        end if
      end do ! iFac2
    end if ! (nAxes==2)
  end do ! iFac1

end subroutine optimizeNodeDistr

!-------------------------------------------------------------------------------

subroutine optimizeTransferOrder( nNodes, node, nTrsf, trsfNode, trsfDir )

! Searches an optimal order of transfer communications


  implicit none
  integer,intent(in) :: nNodes   ! Number of parallel processor nodes. The
                                 ! number of transfers per node is 2*nNodes-1
  integer,intent(in) :: node     ! Local processor node, in range (0:nNodes-1)
  integer,intent(in) :: nTrsf    ! Number of required transfers
  integer,intent(inout):: trsfNode(nTrsf) ! To/from transfer node.
                                 ! First 'transfer' is local: trsfNode(0)=node
  integer,intent(inout):: trsfDir(nTrsf)  ! Transfer direction:
                                 ! trsfDir=+1 => from node to trsfNode
                                 ! trsfDir=-1 => from trsfNode to node

  character(len=*),parameter:: myName = moduleName//'optimizeTransferOrder '
  character(len=*),parameter:: errHead = myName//'ERROR: '
  real(dp),        parameter:: incrFact = 2.0_dp ! Memory increase factor >1
  integer:: dir12, i1, i2, iter, iTrsf, maxTime, maxTrsf, MPIerror, &
            myNode, node1, node2, nTrsfNode1, time, trsf12
  integer:: orderNode1(nNodes), orderNode2(2*nNodes)
  logical:: found
  real(dp):: nTrsfNode(2*nNodes)
  integer, pointer:: inTrsf(:,:)=>null(), &
                    myTrsf(:)=>null(), outTrsf(:,:)=>null()

! In serial execution, do nothing
#ifdef HAVE_MPI

! Find the maximun number of transfers of any node
  call MPI_AllReduce( nTrsf, maxTrsf, 1, MPI_Integer, &
                      MPI_Max, Comm, MPIerror )

! Trap a trivial case, in which there is nothing to optimize
  if (maxTrsf < 2) return

#ifdef DEBUG_XC
!  write(udebug,'(a,2i6)') myName//'nTrsf,maxTrsf=', nTrsf, maxTrsf
!  if (maxTrsf > 2*nNodes) call die(errHead//'too many transfers per node')
#endif /* DEBUG_XC */

! Allocate arrays for the input transfer sequences of all nodes
  call re_alloc( myTrsf, 1,maxTrsf, name=myName//'myTrsf' )
  call re_alloc( inTrsf, 1,maxTrsf, 1,nNodes, name=myName//'inTrsf' )

! Copy transfer sequence of my node to a different format
! Absolute value stores transfer node. Sign stores transfer direction.
! Internally, we use range (1:nNodes) rather than (0:nNodes-1)
  myNode = node + 1
  myTrsf(1:nTrsf) = trsfDir(:)*(trsfNode(:)+1)

! Gather initial transfer sequence of all nodes
  call MPI_AllGather( myTrsf, maxTrsf, MPI_Integer, &
                      inTrsf(1,1), maxTrsf, MPI_Integer, COMM, MPIerror )

! Find the number of transfers of each node
  nTrsfNode(1:nNodes) = count( inTrsf(:,1:nNodes)/=0, dim=1 )

! Find the order of nodes by increasing number of transfers
  call ordix( nTrsfNode, 1, nNodes, orderNode1 )

! Allocate array for the optimized transfer times of all nodes
  maxTime = maxTrsf * incrFact
  call re_alloc( outTrsf, 1,maxTime, 1,nNodes, name=myName//'outTrsf' )

! Schedule the transfers of each node
  do i1 = nNodes,1,-1  ! Give priority to busiest nodes
    node1 = orderNode1(i1)

    ! Find the number of transfers of node 1
    nTrsfNode1 = count( inTrsf(:,node1)/=0 )

    ! Find the number of transfers of each node2, that transfers to/from node1
    do i2 = 1,nTrsfNode1
      node2 = abs( inTrsf(i2,node1) )
      nTrsfNode(i2) = count( inTrsf(:,node2)/=0 )
    end do

    ! Order node2 by increasing number of transfers
    call ordix( nTrsfNode, 1, nTrsfNode1, orderNode2 )

    ! Assign a time to each unassigned transfer of node1
    do iTrsf = nTrsfNode1,1,-1  ! Give priority to busiest node2
      i2 = orderNode2(iTrsf)

      trsf12 = inTrsf(i2,node1)
      node2 = abs( trsf12 )
      dir12 = sign( 1, trsf12 )

      ! Check that this transfer is not already assigned
      if (any(outTrsf(:,node1)==trsf12)) cycle ! iTrsf loop

      ! Look for the first available transfer time and assign it
      found = .false.
      realloc_loop: do iter = 1,2  ! Loop for case that maxTime is too small
        do time = 1,maxTime
          if (outTrsf(time,node1)==0 .and. outTrsf(time,node2)==0) then
            outTrsf(time,node1) =  dir12*node2
            outTrsf(time,node2) = -dir12*node1
            found = .true.
            exit realloc_loop
          end if
        end do ! iTime
        ! If no available time found, increase maxTime
        maxTime = maxTime*incrFact + 1
        call re_alloc( outTrsf, 1,maxTime, 1,nNodes, &
                       name=myName//'outTrsf', copy=.true. )
      end do realloc_loop

#ifdef DEBUG_XC
      if (.not.found) call die(errHead//'parameter incrFact too small')
#endif /* DEBUG_XC */
    end do ! iTrsf

    ! Copy transfer sequence to output arrays
    if (node1==myNode) then
      ! Pack transfer sequence, removing idle times for myNode
      myTrsf(1:nTrsf) = pack( outTrsf(:,myNode), outTrsf(:,myNode)/=0 )
      ! The -1 is to change back from node range (1:nNodes) to (0:nNodes-1)
      trsfNode = abs( myTrsf(1:nTrsf) ) - 1
      trsfDir = sign( 1, myTrsf(1:nTrsf) )
#ifdef DEBUG_XC
!      write(udebug,'(a,20i4)') myName//' inTrsf=', inTrsf(1:nTrsf,myNode)
!      write(udebug,'(a,20i4)') myName//'outTrsf=', myTrsf(1:nTrsf)
#endif /* DEBUG_XC */
      exit ! i1 loop
    end if

  end do ! i1

! Deallocate arrays
  call de_alloc( outTrsf, name=myName//'outTrsf' )
  call de_alloc( inTrsf, name=myName//'inTrsf' )
  call de_alloc( myTrsf, name=myName//'myTrsf' )

#endif

end subroutine optimizeTransferOrder

!-------------------------------------------------------------------------------

subroutine primeFactors( n, factor, power, nFactors )

! Finds prime factors of n

  implicit none
  integer,intent(in) :: n          ! Number to be factorized
  integer,intent(out):: factor(:)  ! Different prime factors in ascending order
  integer,intent(out):: power(:)   ! Power of each prime factor
  integer,intent(out):: nFactors   ! Number of different factors found

  integer:: i, m

  nFactors = 0
  m = n
  do i = 2,n  ! This is crude, but simple!
    if (mod(m,i)==0) then  ! i is a factor o m
      nFactors = nFactors + 1
      if (nFactors>size(factor)) &
        call die(moduleName//'primeFactors: ERROR: size(factor) too small')
      factor(nFactors) = i
      power(nFactors) = 0
      do ! loop to find power
        if (mod(m,i)==0) then
          power(nFactors) = power(nFactors) + 1
          m = m / i
        else
          exit ! power loop
        end if ! (mod(m,i)==0)
      end do ! power loop
    end if ! (mod(m,i)==0)
    if (m==1) exit ! i loop
  end do ! i

end subroutine primeFactors

!-------------------------------------------------------------------------------

subroutine projection( nMesh, srcBox, srcData, prjBox, prjData )

! Projects a box of values, defined in a 3D mesh of a periodic unit cell,
! onto each of the three mesh axes. The projected box must be entirely 
! inside the source box.

  implicit none
  integer, intent(in) :: nMesh(3)          ! Global mesh size in each axis
  integer, intent(in) :: srcBox(2,3)       ! Source data mesh box:
                                           ! srcBox(1,iAxis)=lower box limits
                                           ! srcBox(2,iAxis)=upper box limits
  real(gp),intent(in) :: srcData(0:,0:,0:) ! Source data values to be copied
                                           ! Its upper array bounds must be
                                           ! srcBox(2,iAxis)-srcBox(1,iAxis)
  integer, intent(in) :: prjBox(2,3)       ! Projection mesh box. Must be
                                           ! prjBox(1,:)>=srcBox(1,:) and
                                           ! prjBox(2,:)<=srcBox(2,:)
  real(gp),intent(out):: prjData(:,0:)     ! Projected data values:
                          ! prjData(iAxis,0:prjBox(2,iAxis)-prjBox(1,iAxis))

  character(len=*),parameter:: myName = moduleName//'projection '
  character(len=*),parameter:: errHead = myName//'ERROR: '
  integer:: i1, i1max, i1min, i2, i2max, i2min, i3, i3max, i3min

! Check box limits
  if (any(prjBox(1,:)<srcBox(1,:)) .or. &
      any(prjBox(2,:)>srcBox(2,:)) )    &
    call die(errHead//'prjBox outside srcBox')

! Check array sizes
  if (any( shape(srcData) /= srcBox(2,:)-srcBox(1,:)+1 )) &
    call die(errHead//'shape of array srcData inconsistent with srcBox')
  if (size(prjData,2) < maxval(prjBox(2,:)-prjBox(1,:)+1)) &
    call die(errHead//'size of array prjData too small')

! Find prjBox limits relative to srcBox origin
  i1min = prjBox(1,1) - srcBox(1,1)
  i1max = prjBox(2,1) - srcBox(1,1)
  i2min = prjBox(1,2) - srcBox(1,2)
  i2max = prjBox(2,2) - srcBox(1,2)
  i3min = prjBox(1,3) - srcBox(1,3)
  i3max = prjBox(2,3) - srcBox(1,3)

! Find projection along each axis
  prjData = 0
  do i1 = i1min,i1max
    prjData(1,i1-i1min) = sum( srcData(i1,i2min:i2max,i3min:i3max) )
  end do
  do i2 = i2min,i2max
    prjData(2,i2-i2min) = sum( srcData(i1min:i1max,i2,i3min:i3max) )
  end do
  do i3 = i3min,i3max
    prjData(3,i3-i3min) = sum( srcData(i1min:i1max,i2min:i2max,i3) )
  end do

end subroutine projection

!-------------------------------------------------------------------------------

subroutine projectMeshData( nMesh, srcDistr, srcData, prjBox, prjData, task )

! Projects a box of values, defined in a 3D mesh of a periodic unit cell,
! onto each of the three mesh axes.
! The box limits may be partly or entirely outside the first unit cell.
! In parallel execution, the routine handles the interprocessor transfers
! needed to bring the requested box data from the nodes that store them.

  implicit none
  integer, intent(in) :: nMesh(3)          ! Global mesh size in each axis
  integer, intent(in) :: srcDistr          ! Distribution ID of source data
                                           ! or zero for serial execution
  real(gp),intent(in) :: srcData(0:,0:,0:) ! Source data values to be copied
                                           ! Its upper array bounds must be
                                           ! those assigned to the node by
                                           ! the srcDistr parallel distrib.
                                           ! or nMesh(iAxis)-1 in serial exe
  integer, intent(in) :: prjBox(2,3)       ! Projection mesh box:
                                           ! box(1,iAxis)=lower box limits
                                           ! box(2,iAxis)=upper box limits
                                           ! Box needs not be within the
                                           ! (0:nMesh-1) unit-cell range
  real(gp),intent(out):: prjData(:,0:)     ! Projected data values:
                          ! prjData(iAxis,0:prjBox(2,iAxis)-prjBox(1,iAxis))
  integer,intent(inout),optional:: task    ! ID of communication task

  character(len=*),parameter:: myName = moduleName//'projectMeshData '
  character(len=*),parameter:: errHead = myName//'ERROR: '
  integer :: srcBox(2,3), srcMesh(3)
  real(gp),pointer:: mySrcData(:,:,:,:)=>null()

! Associate task to distributions
  if (present(task)) call associateMeshTask( task, srcDistr )

! Find box limits of source data in this node
  call myMeshBox( nMesh, srcDistr, srcBox )
  srcMesh = srcBox(2,:) - srcBox(1,:) + 1

! Check array shapes
!  if (any( shape(srcData) /= srcMesh )) &
!    call die( errHead//'incorrect shape of srcData array' )
  if (any( shape(srcData) /= srcMesh )) then
#ifdef DEBUG_XC
    write(udebug,'(a,i6,3(2x,2i4))') &
      errHead//'srcDistr,srcBox =', srcDistr, srcBox
    write(udebug,'(a,3i6,3x,3i6)') &
      errHead//'shape(srcData),srcMesh =', shape(srcData), srcMesh
#endif /* DEBUG_XC */
    call die( errHead//'incorrect shape of srcData array' )
  end if
  if (size(prjData,2) < maxval(prjBox(2,:)-prjBox(1,:)+1)) &
    call die( errHead//'size of prjData array too small' )

! Copy srcData into a rank-4 array to call reduceData
  call re_alloc( mySrcData, 0,srcMesh(1)-1, 0,srcMesh(2)-1, 0,srcMesh(3)-1, &
                 1,1, myName//'mySrcData' )
  mySrcData(0:srcMesh(1)-1,0:srcMesh(2)-1,0:srcMesh(3)-1,1) = &
    srcData(0:srcMesh(1)-1,0:srcMesh(2)-1,0:srcMesh(3)-1)

! Find projection
  call reduceData( nMesh, srcBox, mySrcData, prjBox, prjData=prjData, &
                       taskID=task )

! Deallocate temporary array
  call de_alloc( mySrcData, myName//'mySrcData' )

end subroutine projectMeshData

!-------------------------------------------------------------------------------

subroutine redistributeMeshData( srcDistr, srcData, dstDistr, dstData, task )

! Copies data values on the mesh with a new mesh distribution among nodes

  implicit none
  integer,        intent(in) :: srcDistr            ! Distrib. ID of srcData
  real(gp),target,intent(in) :: srcData(0:,0:,0:,:) ! Input source data
  integer,        intent(in) :: dstDistr            ! Distrib. ID of dstData
  real(gp),pointer           :: dstData(:,:,:,:)    ! Output destination array 
                                          ! (it must be different from srcData)
  integer,intent(inout),optional:: task   ! ID of communication task

  character(len=*),parameter:: myName = 'redistributeMeshData '
  character(len=*),parameter:: errHead = myName//'ERROR: '
  integer:: dstBox(2,3), dstMesh(3), iDistr, nData, nMesh(3)
  integer:: i1, i2, i3, idat   ! provisional addition. JMS, June 2013

! For serial execution, avoid allocating a new array
  if (srcDistr==0 .and. dstDistr==0) then
    dstData => srcData
    return
  else if (srcDistr<=0 .or. dstDistr<=0) then
    call die(errHead//'invalid srcDistr or dstDistr')
  end if

! Find mesh box of node in new distribution
  iDistr = indexDistr( dstDistr )
  if (iDistr<=0 .or. iDistr>maxDistr) call die(errHead//'invalid dstDistr')
  nMesh = storedMeshDistr(iDistr)%nMesh
  call myMeshBox( nMesh, dstDistr, dstBox )
  dstMesh(:) = dstBox(2,:) - dstBox(1,:) + 1

! Allocate destination data array
  nData = size(srcData,4)
  call re_alloc( dstData, 0,dstMesh(1)-1, 0,dstMesh(2)-1, 0,dstMesh(3)-1, &
                 1,nData, name=myName//'dstData', copy=.false., shrink=.true. )

! Copy srcData to dstData
  if ( sameMeshDistr(srcDistr,dstDistr) ) then
    ! Provisional loops to circunvent an apparent compiler bug. JMS, June 2013.
    do idat = 1,nData
      do i3 = 0,dstMesh(3)-1
      do i2 = 0,dstMesh(2)-1
      do i1 = 0,dstMesh(1)-1
        dstData(i1,i2,i3,idat) = srcData(i1,i2,i3,idat)
      end do
      end do
      end do
    end do
!    dstData = srcData   ! original code
  else
    call copyMeshData( nMesh, srcDistr, srcData, dstBox, dstData, task )
  end if

end subroutine redistributeMeshData

!-------------------------------------------------------------------------------

subroutine reduceData( nMesh, srcBox, srcData, dstBox, dstData, prjData, &
                       taskID )

! Reduces (adds) a box of values defined in a 3D mesh of a periodic unit cell.
! The box limits may be entirely inside, or partially or totally outside 
! the unit cell, which is periodically repeated to fill the box.
! In parallel execution, the routine handles the interprocessor transfers
! needed to bring the requested box data from the nodes that store them.

  implicit none
  integer, intent(in) :: nMesh(3)          ! Global mesh size in each axis
  integer, intent(in) :: srcBox(2,3)       ! Source mesh box:
                                           ! box(1,iAxis)=lower box limits
                                           ! box(2,iAxis)=upper box limits
                                           ! Boxes may be larger than the
                                           ! (0:nMesh-1) unit-cell range
  real(gp),intent(in) :: srcData(0:,0:,0:,:) ! Source data values to be copied
                                           ! Its upper array bounds must be
                                           ! enough to contain the node box in
                                           ! the srcDistr parallel distrib.
                                           ! or nMesh(iAxis)-1 in serial exe
  integer, intent(in) :: dstBox(2,3)       ! Destination mesh box
  real(gp),intent(inout),optional:: dstData(0:,0:,0:,:)
                                           ! Destination data values.
                                           ! The upper array bounds must be 
                                           ! dstBox(2,iAxis)-dst(1,iAxis)
                                           ! dstData is NOT initialized
  real(gp),intent(out),optional:: prjData(:,0:) ! Projected data values:
                          ! prjData(iAxis,0:prjBox(2,iAxis)-prjBox(1,iAxis))
                          ! Only srcData(:,:,:,1) is projected
  integer,intent(inout),optional:: taskID  ! ID of communication task

  character(len=*),parameter:: myName = moduleName//'reduceData '
  character(len=*),parameter:: errHead = myName//'ERROR: '
  integer,allocatable:: dstBoxes(:,:,:), srcBoxes(:,:,:), &
                        trsfDir(:), trsfNode(:)
  integer :: comBox(2,3), arrayS(4,2), &
             dstComBox(2,3,maxParts), dstNode, dstSize, &
             i, ic, ix, iNode, iPart, iTask, iTrsf, &
             maxMesh, nData, nParts, nTrsf, partSize, &
             sizeSum(0:maxParts), srcComBox(2,3,maxParts), &
             srcNode, srcSize, trsfSize, trueTrsf
  logical :: taskDefined, taskOptimized
  real(gp),allocatable:: prjBuff(:,:)
  real(gp),pointer:: trsfBuff(:)=>null()
  type(taskType),pointer:: task

#ifdef DEBUG_XC
!  write(udebug,'(a,i4,3(2x,2i4),2x,3(2x,2i4))') &
!    myName//'myNode+1,srcBox,dstBox=', myNode+1, srcBox, dstBox
#endif /* DEBUG_XC */

! Check that one of dstData or prjData is present
  if (.not.present(dstData) .and. .not.present(prjData)) return

! Check array shapes
  nData = size(srcData,4)
  do ic = 1,3
    if (size(srcData,ic) < srcBox(2,ic)-srcBox(1,ic)+1) &
      call die( errHead//'incorrect array shape of srcData' )
  end do
  if (present(dstData)) then
    do ic = 1,3
      if (size(dstData,ic) < dstBox(2,ic)-dstBox(1,ic)+1) &
        call die( errHead//'incorrect array shape of dstData' )
    end do
    if (size(dstData,4) /= nData) &
      call die( errHead//'inconsistent size of srcData and dstData' )
  end if
  if (present(prjData)) then
    if (size(prjData,2) < maxval(dstBox(2,:)-dstBox(1,:)+1)) &
      call die( errHead//'size of prjData array too small' )
  end if

! Allocate buffer for projection data transfer
  if (present(prjData)) then
    maxMesh = maxval(nMesh)
    allocate( prjBuff(3,0:maxMesh-1) )
  end if

! Find common intersection between srcBox and dstBox
  call commonBox( nMesh, srcBox, dstBox, srcComBox, dstComBox, sizeSum, nParts )

! Copy local data from each part of source box
  if (present(dstData)) then
    do iPart = 1,nParts
      dstData(dstComBox(1,1,iPart):dstComBox(2,1,iPart),     &
              dstComBox(1,2,iPart):dstComBox(2,2,iPart),     &
              dstComBox(1,3,iPart):dstComBox(2,3,iPart),:) = &
      dstData(dstComBox(1,1,iPart):dstComBox(2,1,iPart),     &
              dstComBox(1,2,iPart):dstComBox(2,2,iPart),     &
              dstComBox(1,3,iPart):dstComBox(2,3,iPart),:) + &
      srcData(srcComBox(1,1,iPart):srcComBox(2,1,iPart),     &
              srcComBox(1,2,iPart):srcComBox(2,2,iPart),     &
              srcComBox(1,3,iPart):srcComBox(2,3,iPart),:)
    end do ! iPart
  end if ! (present(dstData))

! Project local data onto axes of projection box
  if (present(prjData)) then
    prjData(:,:) = 0
    do iPart = 1,nParts
      ! Find common box relative to origin of unit cell
      comBox(1,:) = srcComBox(1,:,iPart) + srcBox(1,:)
      comBox(2,:) = srcComBox(2,:,iPart) + srcBox(1,:)
      ! Find projection of srcData in comBox
      call projection( nMesh, srcBox, srcData(:,:,:,1), comBox, prjBuff )
      ! Accumulate projection onto output array
      do ix = 1,3
        prjData(ix,dstComBox(1,ix,iPart):dstComBox(2,ix,iPart)) = &
        prjData(ix,dstComBox(1,ix,iPart):dstComBox(2,ix,iPart)) + &
          prjBuff(ix,0:comBox(2,ix)-comBox(1,ix))
      end do
    end do ! iPart
  end if ! (present(prjData))

! If totNodes=1 => serial case (all data are local) => all is done
  if (totNodes==1) return

! Else we need MPI code
#ifdef HAVE_MPI

! Find the stored data about this communication task
  taskDefined = .false.
  taskOptimized = .false.
  if (present(taskID)) then
    iTask = indexTask( taskID )
    if (iTask<0) then  ! Create a new task
      call initTask( taskID )
      iTask = indexTask( taskID )
    end if ! (iTask<0)
    task => storedMeshTask(iTask)
    taskDefined = task%defined
    taskOptimized = task%optimized
  end if ! (present(task))

! Check task boxes
  if (taskDefined) then
    if (any( task%srcBox(:,:,myNode) /= srcBox )) &
      call die( errHead//'srcBox inconsistent with taskID' )
    if (any( task%dstBox(:,:,myNode) /= dstBox )) &
      call die( errHead//'dstBox inconsistent with taskID' )
  end if

! Find the box limits of all nodes
  allocate( srcBoxes(2,3,0:totNodes-1), dstBoxes(2,3,0:totNodes-1) )
  if (taskDefined) then
    srcBoxes(:,:,:) = task%srcBox(:,:,:)
    dstBoxes(:,:,:) = task%dstBox(:,:,:)
  else  ! Gather the boxes from all nodes
    call gatherBoxes( srcBox, srcBoxes )
    call gatherBoxes( dstBox, dstBoxes )
    if (present(taskID)) then  ! Store boxes for future calls
      task%srcBox(:,:,:) = srcBoxes(:,:,:)
      task%dstBox(:,:,:) = dstBoxes(:,:,:)
      task%defined = .true.
#ifdef DEBUG_XC
!      write(udebug,'(a,2i4,3(2x,2i4))') &
!        myName//'taskID,iTask,srcBox=', taskID, iTask, srcBox
!      write(udebug,'(31x,a,2i4,3(2x,2i4))') &
!                             'dstBox=', taskID, iTask, dstBox
#endif /* DEBUG_XC */
    end if
  end if

#ifdef DEBUG_XC
!  do iNode = 0,totNodes-1
!    call nodeMeshBox( nMesh, srcDistr, iNode, srcBox )
!    write(udebug,'(a,i4,2x,3(2i4,2x),3(2i4,2x))') &
!      myName//'node,srcBox,dstBox=', &
!      iNode, srcBoxes(:,:,iNode), dstBoxes(:,:,iNode)
!  end do
#endif /* DEBUG_XC */

! Find the order of inter-node transfers
  nTrsf = 2*(totNodes-1) ! One send and one receive to/from each other node
  allocate( trsfDir(0:nTrsf), trsfNode(0:nTrsf) )
  if (taskOptimized) then
    nTrsf = task%nTrsf
    trsfDir(:) = task%trsfDir(:)
    trsfNode(:) = task%trsfNode(:)
  else ! (.not.taskOptimized)
    call all2allTransferOrder( totNodes, myNode, nTrsf, trsfNode, trsfDir )
  end if ! (taskOptimized)

#ifdef DEBUG_XC
!  write(udebug,'(a,i4,2x,20i4)') myName//'myNode+1,Trsfs=', &
!    myNode+1, trsfDir(1:nTrsf)*(trsfNode(1:nTrsf)+1)
#endif /* DEBUG_XC */

! Find required size of buffer to transfer data
  trsfSize = 0
  if (present(dstData)) then
    do iTrsf = 1,nTrsf
      iNode = trsfNode(iTrsf)
      if (trsfDir(iTrsf)==+1) then ! Size required to send
        srcSize = product( srcBox(2,:)-srcBox(1,:)+1 )
        dstSize = product( dstBoxes(2,:,iNode)-dstBoxes(1,:,iNode)+1 )
        trsfSize = max( trsfSize, min(srcSize,dstSize) )
      else ! Size required to receive
        srcSize = product( srcBoxes(2,:,iNode)-srcBoxes(1,:,iNode)+1 )
        dstSize = product( dstBox(2,:)-dstBox(1,:)+1 )
        trsfSize = max( trsfSize, min(srcSize,dstSize) )
      end if ! (trsfDir(iTrsf)==+1)
    end do ! iTrsf
    trsfSize = trsfSize*nData
  end if
  if (present(prjData)) trsfSize = trsfSize + 3*maxMesh*maxParts

! Allocate buffer to transfer data
  call re_alloc( trsfBuff, 1, trsfSize, name=myName//'trsfBuff' )

! Loop on transfer sequence
  trueTrsf = 0
  do iTrsf = 1,nTrsf

    if (trsfDir(iTrsf)==+1) then ! My node will send data

      ! Find destination node
      dstNode = trsfNode(iTrsf)

      ! Find common intersection between srcBox and dstBox
      call commonBox( nMesh, srcBox, dstBoxes(:,:,dstNode), &
                      srcComBox, dstComBox, sizeSum, nParts )
      sizeSum = sizeSum * nData

      ! Select this transfer only if it is needed
      if (nParts>0) then
        trueTrsf = trueTrsf + 1
        trsfDir(trueTrsf) = trsfDir(iTrsf)
        trsfNode(trueTrsf) = trsfNode(iTrsf)
      else ! (nParts==0)
        cycle ! iTrsf loop
      end if ! (nParts>0)

#ifdef DEBUG_XC
      ! Check buffer size
      if (present(dstData) .and. sizeSum(nParts) > size(trsfBuff)) &
        call die(errHead//'size(trsfBuff) too small')
#endif /* DEBUG_XC */

#ifdef DEBUG_XC
!      if (nParts>0) then
!        write(udebug,'(a,2i6)') myName//'srcNode,dstNode=', myNode, dstNode
!        write(udebug,'(a,2i6)') myName//'        sizeSum=',sizeSum(0:nParts)
!        write(udebug,'(a,3(2i4,2x))') myName//'   srcBox=', srcBox
!        write(udebug,'(a,3(2i4,2x))') myName//'   dstBox=', &
!                                         dstBoxes(:,:,dstNode)
!      end if

!      do iPart = 1,nParts
!        write(udebug,'(a,3(2i4,2x))') myName//'srcComBox=', &
!          ((srcComBox(i,ix,iPart),i=1,2),ix=1,3)
!        write(udebug,'(a,3(2i4,2x))') myName//'dstComBox=', &
!          ((dstComBox(i,ix,iPart),i=1,2),ix=1,3)
!      end do ! iPart
#endif /* DEBUG_XC */

      ! Copy data from each part of common box to a transfer buffer
      if (present(dstData)) then
        do iPart = 1,nParts
          !partSize = sizeSum(iPart) - sizeSum(iPart-1)
          arrayS(1:3,1) = srcComBox(1,:,iPart) + 1
          arrayS(4,1) = 1
          arrayS(1:3,2) = srcComBox(2,:,iPart) + 1
          arrayS(4,2) = nData
          call array_copy(arrayS(:,1), arrayS(:,2), srcData(:,:,:,:), &
               sizeSum(iPart-1)+1, sizeSum(iPart), trsfBuff(:) )
          !trsfBuff(sizeSum(iPart-1)+1:sizeSum(iPart)) =                    &
          !  reshape( srcData(srcComBox(1,1,iPart):srcComBox(2,1,iPart),    &
          !                   srcComBox(1,2,iPart):srcComBox(2,2,iPart),    &
          !                   srcComBox(1,3,iPart):srcComBox(2,3,iPart),:), &
          !           (/partSize/) )
        end do ! iPart
        trsfSize = sizeSum(nParts)
      else ! (.not.present(dstData))
        trsfSize = 0
      end if ! (present(dstData))

      ! Project data from each part of common box onto the transfer buffer
      if (present(prjData)) then
        do iPart = 1,nParts
          ! Find common box relative to origin of first unit cell
          comBox(1,:) = srcComBox(1,:,iPart) + srcBox(1,:)
          comBox(2,:) = srcComBox(2,:,iPart) + srcBox(1,:)
          ! Find projection of srcData in comBox
          call projection( nMesh, srcBox, srcData(:,:,:,1), comBox, prjBuff )
          ! Copy projection data onto a transfer buffer
          call array_copy([1, 1], [3, maxMesh], prjBuff(:,:), &
               trsfSize+1, trsfSize+3*maxMesh, trsfBuff(:))
          ! AG: Work around gfortran bug: specify 0 lbound in reshape
          !trsfBuff(trsfSize+1:trsfSize+3*maxMesh) = &
          !   reshape( prjBuff(:,0:), (/3*maxMesh/) )
          trsfSize = trsfSize + 3*maxMesh
        end do ! iPart
      end if ! (present(prjData))

#ifdef DEBUG_XC
!      write(udebug,'(a,2i4,3(2x,2i4),2x,3(2x,2i4),i8)') &
!        myName//' myNode,dstNode, myBox,dstBox,trsfSize=', &
!        myNode+1, dstNode+1, srcBox, dstBoxes(:,:,dstNode), trsfSize
#endif /* DEBUG_XC */

      ! Send data buffer
      if (trsfSize>0) &
        call MPI_Send( trsfBuff(1:trsfSize), trsfSize, MPI_grid_real, &
                       dstNode, 0, COMM, MPIerror )

    else ! My node will receive data

      ! Find source node and its mesh box
      srcNode = trsfNode(iTrsf)

      ! Find common intersection between srcBox and dstBox
      call commonBox( nMesh, srcBoxes(:,:,srcNode), dstBox, &
                      srcComBox, dstComBox, sizeSum, nParts )
      sizeSum = sizeSum * nData

      ! Select this transfer only if it is needed
      if (nParts>0) then
        trueTrsf = trueTrsf + 1
        trsfDir(trueTrsf) = trsfDir(iTrsf)
        trsfNode(trueTrsf) = trsfNode(iTrsf)
      else ! (nParts==0)
        cycle ! iTrsf loop
      end if ! (nParts>0)

#ifdef DEBUG_XC
      ! Check buffer size
      if (present(dstData) .and. sizeSum(nParts)>size(trsfBuff)) &
        call die(errHead//'size(trsfBuff) too small')
#endif /* DEBUG_XC */

#ifdef DEBUG_XC
!      if (nParts>0) then
!        write(udebug,'(a,2i6)') myName//'srcNode,dstNode=', srcNode, myNode
!        write(udebug,'(a,2i6)') myName//'        sizeSum=',sizeSum(0:nParts)
!        write(udebug,'(a,3(2i4,2x))') myName//'   srcBox=', srcBox
!        write(udebug,'(a,3(2i4,2x))') myName//'   dstBox=', dstBox
!      end if

!      do iPart = 1,nParts
!        write(udebug,'(a,3(2i4,2x))') myName//'srcComBox=', &
!          ((srcComBox(i,ix,iPart),i=1,2),ix=1,3)
!        write(udebug,'(a,3(2i4,2x))') myName//'dstComBox=', &
!          ((dstComBox(i,ix,iPart),i=1,2),ix=1,3)
!      end do ! iPart
#endif /* DEBUG_XC */

      ! Receive data buffer
      trsfSize = 0
      if (present(dstData)) trsfSize = trsfSize + sizeSum(nParts)
      if (present(prjData)) trsfSize = trsfSize + 3*maxMesh*nParts
      if (trsfSize>0) &
        call MPI_Recv( trsfBuff(1:trsfSize), trsfSize, MPI_grid_real, &
                       srcNode, 0, COMM, MPIstatus, MPIerror )

#ifdef DEBUG_XC
!      write(udebug,'(a,2i4,3(2x,2i4),2x,3(2x,2i4),i8)') &
!        myName//'srcNode, myNode,srcBox, myBox,trsfSize=', &
!        srcNode+1, myNode+1, srcBoxes(:,:,srcNode), dstBox, trsfSize
#endif /* DEBUG_XC */

      ! Copy buffer data for each part of common box to destination array
      if (present(dstData)) then
        do iPart = 1,nParts
          arrayS(1:3,1) = dstComBox(1,:,iPart) + 1
          arrayS(4,1) = 1
          arrayS(1:3,2) = dstComBox(2,:,iPart) + 1
          arrayS(4,2) = nData
          call array_add(sizeSum(iPart-1)+1, sizeSum(iPart), trsfBuff(:), &
               arrayS(:,1), arrayS(:,2), dstData(:,:,:,:))
          !comShape(1:3) = dstComBox(2,:,iPart) - dstComBox(1,:,iPart) + 1
          !comShape(4) = nData
          !dstData(dstComBox(1,1,iPart):dstComBox(2,1,iPart),     &
          !        dstComBox(1,2,iPart):dstComBox(2,2,iPart),     &
          !        dstComBox(1,3,iPart):dstComBox(2,3,iPart),:) = &
          !dstData(dstComBox(1,1,iPart):dstComBox(2,1,iPart),     &
          !        dstComBox(1,2,iPart):dstComBox(2,2,iPart),     &
          !        dstComBox(1,3,iPart):dstComBox(2,3,iPart),:) + &
          !  reshape( trsfBuff(sizeSum(iPart-1)+1:sizeSum(iPart)), comShape )
        end do ! iPart
        trsfSize = sizeSum(nParts)
      else ! (.not.present(dstData))
        trsfSize = 0
      end if ! (present(dstData))

      ! Copy buffer data for each part of common box to destination array
      if (present(prjData)) then
        do iPart = 1,nParts
          ! Find common box relative to origin of first unit cell
          comBox(1,:) = srcComBox(1,:,iPart) + srcBox(1,:)
          comBox(2,:) = srcComBox(2,:,iPart) + srcBox(1,:)
          ! Copy transfer buffer onto a projection buffer
          call array_copy(trsfSize+1, trsfSize+3*maxMesh, trsfBuff(:), &
               [1, 1], [3, maxMesh], prjBuff(:,:))
          !prjBuff(:,:) = &
          !  reshape( trsfBuff(trsfSize+1:trsfSize+3*maxMesh), (/3,maxMesh/) )
          ! Add projection of common box to output array
          do ix = 1,3
            prjData(ix,dstComBox(1,ix,iPart):dstComBox(2,ix,iPart)) = &
            prjData(ix,dstComBox(1,ix,iPart):dstComBox(2,ix,iPart)) + &
              prjBuff(ix,0:comBox(2,ix)-comBox(1,ix))
          end do
          trsfSize = trsfSize + 3*maxMesh
        end do ! iPart
      end if ! (present(prjData))

    end if ! (iDir(iTrsf)==+1)

  end do ! iTrsf

  ! Optimize transfer sequence and store it
  if (present(taskID) .and. .not.taskOptimized) then
    nTrsf = trueTrsf
    call optimizeTransferOrder( totNodes, myNode, nTrsf, &
                                trsfNode(1:nTrsf), trsfDir(1:nTrsf) )
    task%nTrsf = nTrsf
    task%trsfNode = trsfNode
    task%trsfDir = trsfDir
    task%optimized = .true.
#ifdef DEBUG_XC
!    write(udebug,'(a,4i4,/,(20i4))') &
!      myName//'taskID,iTask,distr1,distr2,Trsfs=', &
!      taskID, iTask, task%distr, trsfDir(1:nTrsf)*trsfNode(1:nTrsf)
#endif /* DEBUG_XC */
  end if

  ! Deallocations
  call de_alloc( trsfBuff, name=myName//'trsfBuff' )
  deallocate( trsfDir, trsfNode, dstBoxes, srcBoxes )

#endif
! End of MPI code

  if (present(prjData)) deallocate( prjBuff )

end subroutine reduceData

!-------------------------------------------------------------------------------

subroutine reduceDistr( distrID )

! Find if this distribution was already defined, and resets it if so

  implicit none
  integer,intent(inout):: distrID  ! Distribution ID

  character(len=*),parameter:: myName = moduleName//'reduceDistr '
  character(len=*),parameter:: errHead = myName//'ERROR: '
  logical:: found
  integer:: iDistr, iID, jDistr
  type(distrType),pointer:: newDistr, oldDistr

! Find the new distribution
  iDistr = indexDistr( distrID )
  if (iDistr==0) then
    return
  else if (iDistr<0 .or. iDistr>maxDistr) then
    call die(errHead//'invalid distrID')
  end if
  newDistr => storedMeshDistr(iDistr)

! Compare it with all previous distributions
  do jDistr = 1,maxDistr

    ! Check that everything agrees, otherwise cycle
    if (jDistr==iDistr) cycle ! jDistr loop
    oldDistr => storedMeshDistr(jDistr)
    if (.not.oldDistr%defined) cycle
    if (oldDistr%nNodes/=newDistr%nNodes) cycle
    if (oldDistr%firstNode/=newDistr%firstNode) cycle
    if (any(oldDistr%nMesh(:)/=newDistr%nMesh(:))) cycle
    if (any(oldDistr%box(:,:,:)/=newDistr%box(:,:,:))) cycle
    ! If this point is reached, both distributions are equal.

#ifdef DEBUG_XC
!    write(udebug,'(a,3i4)') &
!      myName//'distrID,oldDistr,newDistr=', distrID, jDistr, iDistr
#endif /* DEBUG_XC */

    ! Free new distribution
    call freeMeshDistr( distrID )

    ! Assign new ID to oldDistr
    found = .false.
    do iID = 1,maxDistrID  ! Loop on ID slots of oldDistr
      if (oldDistr%ID(iID)<0) then ! Empty ID slot
        oldDistr%ID(iID) = distrID
        found = .true.
        exit ! iID loop
      end if
    end do ! iID
    if (.not.found) call die(errHead//'parameter maxDistrID too small')

    exit ! jDistr loop
  end do ! jDistr

end subroutine reduceDistr

!-------------------------------------------------------------------------------

logical function sameMeshDistr( ID1, ID2 )

  implicit none
  integer,intent(in):: ID1, ID2  ! Mesh distribution IDs

  integer:: i1, i2
  type(distrType),pointer:: distr1, distr2

  if (ID1==ID2) then           ! Same IDs => same distr.
    sameMeshDistr = .true.
  else                         ! Different IDs
    i1 = indexDistr(ID1)
    i2 = indexDistr(ID2)
    if (i1<0 .or. i2<0) then   ! One or both distr. are not defined
      sameMeshDistr = .false.
    else                       ! Both distr. are defined
      if (i1==i2) then         ! Different IDs but same distr.
        sameMeshDistr = .true.
      else if (i1==0 .or. i2==0) then ! Since 0 is valid only in serial mode
        sameMeshDistr = .false.
      else                     ! Different but possibly equivalent distr.
        distr1 => storedMeshDistr(i1)
        distr2 => storedMeshDistr(i2)
        if (all(distr1%box==distr2%box)) then
          sameMeshDistr = .true.
        else
          sameMeshDistr = .false.
        end if ! (all(distr1%box==distr2%box))
      end if ! (i1==i2)
    end if ! (i1>0 .and. i2>0)
  end if ! (ID1==ID2)

end function sameMeshDistr

!-------------------------------------------------------------------------------

subroutine setMeshDistr( distrID, nMesh, box, firstNode, nNodes, &
                         nNodesX, nNodesY, nNodesZ, nBlock, &
                         wlDistr, workload )

! Defines a parallel distribution of mesh points among processor nodes.
! In serial execution (totNodes==1) it simply returns distrID=0.
! If the input distribution ID is still valid, the same value is returned.
! Otherwise, it is freed. New IDs are never repeated.

  implicit none
  integer,       intent(inout):: distrID   ! ID assigned to the mesh distrib.
  integer,         intent(in) :: nMesh(3)  ! Mesh divisions in each axis
                                           ! (including "subpoints")
  integer,optional,intent(in) :: box(2,3)  ! Mesh box of my processor node
                                           ! If present(box), all other  
                                           ! optional arguments are ignored
  integer,optional,intent(in) :: firstNode ! First node in the mesh distr.
  integer,optional,intent(in) :: nNodes    ! Total nodes in the mesh distr
                                           ! If not present all nodes are used
  integer,optional,intent(in) :: nNodesX   ! Nodes in the X (first) axis. Must
                                           ! be present if present(nNodesYZ)
  integer,optional,intent(in) :: nNodesY   ! Nodes in the Y (second) axis
                                           ! Must be present if present(nNodesZ)
  integer,optional,intent(in) :: nNodesZ   ! Nodes in the Z (third) axis
                                           ! If nNodesXYZ are not present,
                                           ! the distribution of nodes on all
                                           ! axes is optimized by setMeshDistr.
                                           ! If only nNodesX is present, it is
                                           ! optimized in Y and Z axes
  integer,optional,intent(in) :: nBlock    ! Size of blocks of mesh points, in
                                           ! each axis, which are not splitted
                                           ! in different nodes
  integer,optional,intent(in) :: wlDistr   ! Distr. index of workload array
  real(gp),optional,intent(in):: workload(0:,0:,0:) ! Approx. relative workload
                                           ! of mesh points. Must be nonnegative
                                           ! at all points and have nonzero sum

  character(len=*),parameter:: myName = 'setMeshDistr '
  character(len=*),parameter:: errHead = myName//'ERROR: '
  integer,         parameter:: maxFactors = 100  ! Max prime factors in nNodes
  type(distrType),pointer:: distr, newDistr, oldDistr
  integer,allocatable:: axisBox(:,:,:), partBox(:,:,:)
  integer:: axis, axisNodes(3), blockSize, boxSize, &
            factor(maxFactors), groupSize, &
            i1, i2, i3, iAxis, iBox, iDistr, iFac, iID, iNode, iPow, &
            jDistr, largerBoxSize, lastNode, &
            maxFactor, meshNodes, myGroup, myBox(2,3), myPart, &
            nFactors, node0, nParts, nRem, nBlocks, newDistrID, &
            oldDistrID, partSize, power(maxFactors)
  logical:: found
  character(len=5):: dat

! Trap the serial case 
  if (totNodes==1) then
    distrID = 0
    return
  end if

! Find number of mesh nodes
  if (present(nNodes)) then
    if (nNodes<1 .or. nNodes>totNodes) then
      call die(errHead//'nNodes out of range')
    else
      meshNodes = nNodes
    end if
  else ! Assume that all nodes participate in the mesh distribution
    meshNodes = totNodes
  end if

! Find first node in mesh distribution
  if (present(firstNode)) then
    lastNode = firstNode + meshNodes - 1
    if (firstNode<0 .or. lastNode>totNodes-1) then
      call die(errHead//'firstNode/nNodes out of range')
    else 
      node0 = firstNode
    end if
  else ! (.not.present(firstNode)) => use firstNode=0
    node0 = 0
  end if

! Find size of blocks of points and check that nMesh is a multiple of it
  if (present(nBlock)) then
    blockSize = nBlock
  else
    blockSize = 1
  end if
  if (any(mod(nMesh,blockSize)/=0)) &
    call die(errHead//'nMesh inconsistent with nBlock')

! Store input distribution ID for later comparison
  oldDistrID = distrID

! Initialize new distribution
  call initDistr( newDistrID, nMesh, node0, meshNodes )
  iDistr = indexDistr( newDistrID )
  distr => storedMeshDistr(iDistr)  ! Just a shorter name

! Handle box argument with priority
  if (present(box)) then
    ! Collect all node boxes and store them
    call gatherBoxes( box, distr%box )
    goto 999  ! Exit, since no other arguments must be considered in this case
  end if ! (present(box))

! Find box sizes
  if (present(workload)) then

    ! Check that the distribution of workload array is available
    if (.not.present(wlDistr)) call die(errHead//'workload without wlDistr')

    ! Check that myNode (available from module parallel) contains some points
    if (myNode>=node0 .and. myNode<node0+meshNodes) then

      ! Find prime factors of meshNodes, in ascending order
      call primeFactors( meshNodes, factor, power, nFactors )

      ! Allocate a small temporary array
      maxFactor = maxval( factor(1:nFactors) )
      allocate( partBox(2,3,0:maxFactor-1) )

      ! Iteratively divide full box and select my node's part
      myBox(1,:) = 0           ! Initialize all boxes with full box
      myBox(2,:) = nMesh(:)-1
      groupSize = meshNodes    ! Group = set of nodes assigned to present box
      do iFac = nFactors,1,-1  ! Use larger factors first (for larger boxes)
        do iPow = 1,power(iFac)
          nParts = factor(iFac) ! Number of parts to divide present box
          partSize = groupSize / nParts  ! Nodes that will be assigned to part
          myGroup = (myNode - node0) / groupSize  ! My group for present box
          myPart = (myNode-node0-myGroup*groupSize) / partSize ! My part within 
                                                               ! my group
          axis = 0  ! So that it will be chosen by divideBox3D
#ifdef DEBUG_XC
!          write(udebug,'(a,3(2x,2i4))') myName//'dividing box=', myBox
#endif /* DEBUG_XC */
          call divideBox3D( nMesh, wlDistr, workload, myBox, &
                              nParts, blockSize, axis, partBox )
          myBox(:,:) = partBox(:,:,myPart)  ! Select my part of the box
          groupSize = partSize              ! Reduce group size
#ifdef DEBUG_XC
!          write(udebug,'(a,3(2x,2i4))') myName//' my part box=', myBox
#endif /* DEBUG_XC */
        end do ! iPow
      end do ! iFac

      deallocate( partBox )

    else ! my node contains no mesh points
      myBox(1,:) = 0
      myBox(2,:) = -1
    end if ! (myNode>=node0 .and. myNode<node0+meshNodes)

    ! Gather the box limits of all nodes
    call gatherBoxes( myBox, distr%box )

  else ! (.not.present(workload)) => distribute nodes homogeneously in space

    ! Find distribution of nodes along each axis
    if (present(nNodesX)) then
      axisNodes(1) = nNodesX
      if (present(nNodesY)) then
        axisNodes(2) = nNodesY
        if (present(nNodesZ)) then
          axisNodes(3) = nNodesZ
        else
          axisNodes(3) = meshNodes / (nNodesX*nNodesY)
        end if
      else if (present(nNodesZ)) then
        call die(errHead//'nNodesZ present without nNodesY')
      else ! (.not.present(nNodesYZ)) => optimize distribution in Y and Z axes
        call optimizeNodeDistr( nMesh(2:3), meshNodes/nNodesX, axisNodes(2:3) )
      end if ! (present(nNodesY))
    else if (present(nNodesY).or.present(nNodesZ)) then
      call die(errHead//'nNodesY or nNodesZ present without nNodesX')
    else ! (.not.present(nNodesXYZ)) => optimize distribution in all three axes
      call optimizeNodeDistr( nMesh(1:3), meshNodes, axisNodes(1:3) )
    end if ! (present(nNodesX))

    ! Adjust number of nodes to that along the axes
    if (product(axisNodes) > meshNodes) then
      call die(errHead//'inconsistent nNodesXYZ')
    else
      meshNodes = product(axisNodes)
    end if

    ! Allocate a small temporary array
    allocate( axisBox(2,3,-1:maxval(axisNodes)-1) )

    ! Find mesh partition along each axis
    do iAxis = 1,3
      nBlocks = nMesh(iAxis) / blockSize         ! Blocks along axis
      boxSize = nBlocks / axisNodes(iAxis)       ! Blocks per node
      nRem = nBlocks - boxSize*axisNodes(iAxis)  ! Remaining blocks
      largerBoxSize = (boxSize+1)*blockSize      ! Mesh points per node
      boxSize = boxSize*blockSize                ! Mesh points per node
      axisBox(2,iAxis,-1) = -1             ! So that axisBox(1,ix,0)=0
      do iBox = 0,axisNodes(iAxis)-1
        axisBox(1,iAxis,iBox) = axisBox(2,iAxis,iBox-1) + 1
        if (iBox < nRem) then ! First nRem boxes of larger size
          axisBox(2,iAxis,iBox) = axisBox(2,iAxis,iBox-1) + largerBoxSize
        else                    ! Rest of boxes of normal size
          axisBox(2,iAxis,iBox) = axisBox(2,iAxis,iBox-1) + boxSize
        end if
      end do ! iBox
    end do ! iAxis

    ! Find box bounds of each node
    ! Innermost loop is i3 for compatibility with JDG distribution
    iNode = node0
    do i1 = 0,axisNodes(1)-1
    do i2 = 0,axisNodes(2)-1
    do i3 = 0,axisNodes(3)-1
      distr%box(:,1,iNode) = axisBox(:,1,i1)
      distr%box(:,2,iNode) = axisBox(:,2,i2)
      distr%box(:,3,iNode) = axisBox(:,3,i3)
      iNode = iNode + 1
    end do ! i3
    end do ! i2
    end do ! i1

    ! Deallocate temporary array
    deallocate( axisBox )
    
  end if ! (present(workload))

! Exit point
999 continue

! Find if the old (input) distrID is still valid
  if (sameMeshDistr(oldDistrID,newDistrID)) then  ! Old distr. is still valid
    call freeMeshDistr( newDistrID )
    distrID = oldDistrID
  else   ! Old distribution is no longer valid
    call freeMeshDistr( oldDistrID )
    ! Reset newDistrID if this distribution was already defined
    call reduceDistr( newDistrID )
    distrID = newDistrID
#ifdef DEBUG_XC
    iDistr = indexDistr( distrID )
    distr => storedMeshDistr(iDistr)
    if (present(box)) then
      dat = 'box'
    elseif (present(workload)) then
      dat = 'wkld'
    elseif (present(nNodesX)) then
      dat = 'xNod'
    else
      dat = 'none'
    endif
    write(udebug,'(a,a6,3i4,3(2x,2i4))') &
      myName//'dat,old/newDistrID,iDistr,myBox=', &
      dat, oldDistrID, newDistrID, iDistr, distr%Box(:,:,myNode)
#endif /* DEBUG_XC */
  end if

end subroutine setMeshDistr

!-------------------------------------------------------------------------------

subroutine unitCellParts( nMesh, fullBox, partBox, partBox0, nParts )

! Divides a mesh box into parts, each within a single periodic cell
! and returns the equivalent partial boxes within the first unit cell

  implicit none
  integer,intent(in) :: nMesh(3)        ! Number of mesh points in each axis
                                        ! of the periodic unit cell
  integer,intent(in) :: fullBox(2,3)    ! Box to be partitioned, possibly
                                        ! extending over several unit cells
  integer,intent(out):: partBox(:,:,:)  ! Partitioned boxes, each within a
                                        ! single unit cell:
                                        ! box(1,iAxis,iPart)=lower bounds
                                        ! box(2,iAxis,iPart)=upper bounds
  integer,intent(out):: partBox0(:,:,:) ! Equivalent part boxes in the first
                                        ! unit cell
  integer,intent(out):: nParts          ! Number of parts found

  character(len=*),parameter:: myName = moduleName//'unitCellParts '
  character(len=*),parameter:: errHead = myName//'ERROR: '
  integer:: iDiv, iPart, ix, maxParts
  real(dp):: rMesh(3)

  maxParts = size(partBox,3)
  rMesh = nMesh   ! Real version of nMesh, so that partBox/rMesh is real
  partBox(:,:,1) = fullBox
  nParts = 1
  divideLoop: do ! Until no part can be further divided
    do iPart = 1,nParts  ! Loop on already existing parts
      do ix = 1,3        ! Axis loop
        ! iDiv is the highest surface, separating two unit cells, below the
        ! upper bound of partBox
        iDiv = floor(partBox(2,ix,iPart)/rMesh(ix)) * nMesh(ix)
        if (partBox(1,ix,iPart) < iDiv) then ! iDiv is between lower and
                                             ! upper bounds of partBox
          nParts = nParts + 1
          if (nParts > maxParts) call die(errHead//'maxParts too small')
          partBox(:,:,nParts) = partBox(:,:,iPart)
          partBox(1,ix,nParts) = iDiv       ! New part is upper one
          partBox(2,ix,iPart) = iDiv - 1    ! Old part reduced to lower one
          cycle divideLoop
        endif
      end do ! ix
    end do ! iPart
    exit divideLoop ! since no part can be further divided
  end do divideLoop

  ! Find equivalent boxes in first unit cell
  forall(ix=1:3) &
    partBox0(:,ix,1:nParts) = modulo( partBox(:,ix,1:nParts), nMesh(ix) )

end subroutine unitCellParts

!-------------------------------------------------------------------------------

END MODULE gridxc_mesh3D

#if defined HAVE_CONFIG_H
#include "config.h"
#endif

!
! *******************************************************************
! module mesh1D
!-----------------------------------------------------------------
! Contains utility routines to manipulate one-dimensional functions defined 
! in a mesh, and to solve some differential equations by Numerov's method
!-----------------------------------------------------------------
! Used module procedures:
!   interpolation, only: polint  ! Polynomial (Lagrange) interpolation
!   interpolation, only: spline  ! Sets spline interpolation
!   interpolation, only: splint  ! Finds spline interpolation
! Used module types and variables:
!   precision, only: dp        ! Real double precision type
!-----------------------------------------------------------------
! Public module procedures:
!   derivative,        &! Returns function derivatives the same mesh points
!   get_mesh,          &! Returns a previously-set 1D mesh
!   get_n,             &! Returns the number of mesh points
!   integral,          &! Returns the integral of a function defined in a mesh
!   interpolation,     &! Returns interpolated values at arbitrary points
!   locate,            &! Given x0, it returns real value i0 such that x(i0)=x0
!   numerov,           &! Solves d2y/dx2 = f(x,y) = f0(x) + f1(x)*y
!   set_interpolation, &! Sets interpolation method (lagrange|spline)
!   set_mesh            ! Sets a uniform, logarithmic, or arbitrary 1D mesh
! Public module types and variables: none
!-----------------------------------------------------------------
! get_n: returns the number of mesh points required to meet some conditions
! Usage:
!   n = get_n( xmin, xmax, dxmin, dxmax )
!     integer  n     ! Number of logarithmic-mesh points
!     real(dp) xmin  ! First mesh point
!     real(dp) xmax  ! Last mesh point
!     real(dp) dxmin ! First mesh interval: x(2)-x(1)
!     real(dp) dxmax ! Next to last mesh interval: x(n+1)-x(n)
! Notes:
! - All arguments are input and required
! - No mesh needs to have been previously set. Instead, this
!   function is to help to find the argument n needed to set it.
!-----------------------------------------------------------------
! set_mesh: sets a uniform, logarithmic, or arbitrary 1D mesh
! Usage:
!   call set_mesh( n, x, xmin, xmax, a, dxndx1 )
!     integer  n     : Number of mesh points
!     real(dp) x(n)  : Mesh point values
!     real(dp) xmin  : Value of first mesh point
!     real(dp) xmax  : Value of last mesh point
!     real(dp) a     : Fractional increment of succesive mesh 
!                      intervals of a logarithmic mesh:
!                        x(i) = b * (exp(a*(i-1)) - 1)
!     real(dp) dxndx1: Ratio between last and first intervals
!                      in a logarithmic mesh
! Notes:
! - All arguments are input
! - All the arguments, except n, are optional.
! - If x is present, no other optional arguments may be present
! - If x is not present, xmax must be present, and only one of
!   a or dxndx1 may be present
! - If xmin is not present, xmin=0 is assumed
! - If only xmax (and optionally xmin) is present, a regular mesh 
!   is generated
! - Stops with an error message if x is present but x(i) is not monotonic
! - If x is present and it is a uniform or a logarithmic mesh, it will be
!   identified as such, and analytic formulas will be used accordingly.
!   However, this takes extra time, so it is preferable to use the
!   other arguments to set a uniform or a logarithmic mesh.
! Examples:
! - To initialize a previously generated mesh:
!      call set_mesh( n, x=x_mesh(1:n) )
! - To generate a regular mesh:
!      call set_mesh( n, xmax=x_max )
! - To generate a logarithmic mesh:
!      call set_mesh( n, dxndx1=delta_x_max/delta_x_min )
! Warning:
! - One should not fix parameter a while increasing nx to 
!   convergence, because this may easily lead to an extremely  
!   small dx1 and to roundoff errors. Generally, it is safer
!   and easier to fix dxndx1, specially for this purpose.
!-----------------------------------------------------------------
! get_mesh: returns a previously-set 1D mesh
! Usage:
!   call get_mesh( n, nx, x, dxdi, d2xdi2, d3xdi3, d4xdi4 )
!     integer  n         : Size of array arguments (input)
!     integer  nx        : Number of mesh points (ouput)
!     real(dp) x(n)      : Mesh point values
!     real(dp) dxdi(n)   : dx/di
!     real(dp) d2xdi2(n) : d2x/di2
!     real(dp) d3xdi3(n) : d3x/di3
!     real(dp) d4xdi4(n) : d4x/di4
! Notes:
! - All arguments are output, except n
! - All the arguments, except n and nx, are optional.
! - If any optional array is present, nx is limited by its size, 
!   i.e. nx.le.n
! - If no optional array is present,  present, nx is the number 
!   of mesh points stored
! Examples:
! - To get the first derivatives:
!      call get_mesh( n, nx, dxdi=dxdi(1:n) )
!----------------------------------------------------------------
! set_interpolation: sets interpolation method and end-point derivatives
! Usage:
!   call set_interpolation( method, ypleft, ypright )
!     character(len=*) method  : Interpolation method (lagrange|spline)
!     real(dp) ypleft, ypright : dy/dx values at end points
! Notes:
! - Stops with an error message if method /= ('lagrange'|'spline')
! - Arguments ypleft and ypright are optional and they are used only 
!   when method='spline'. If absent, natural spline conditions (zero  
!   second derivative at corresponding end points) are used.
! Examples:
! - To set natural spline at left and zero derivative at right point:
!      call set_interpolation( 'spline', ypright=0._dp )
!----------------------------------------------------------------
! locate: given x0, returns real value i0 such that x(i0)=x0
! Usage:
!   i0 = locate( x0 )
!     real(dp) x0 : point to locate, within range x(1):x(n)
!     real(dp) i0 : real value such taht interpolated x(i0)=x0
! Notes:
! - Stops with an error message if mesh is not defined
! - For numeriacal meshes stops with an error message if x0 is out of 
!   range x(1):x(n). For uniform and logarithmic meshes it returns an
!   extrapolated value.
!----------------------------------------------------------------
! interpolation: returns the interpolation of a function at one 
! or several points
! Usage:
!   ynew = interpolation( nnew, xnew, n, y, x, dx )
!     real(dp) interpolation(nnew) : Interpolated function values
!     integer  nnew          : Number of interpolation points
!     real(dp) xnew(nnew)    : Interpolation points
!     integer  n             : Number of mesh points
!     real(dp) y(n)          : Values of function to interpolate
!     real(dp) x(n)          : Mesh values (optional)
!     real(dp) dx            : Mesh interval (optional)
! Notes:
! - All arguments are input but the function is not pure because,
!   if x or dx are present, they change the default mesh.
! - The two optional arguments x and dx are incompatible.
!   If none of them is present, the last defined mesh is used.
! Examples:
! - To change the interpoltion mesh of y(x):
!      y(1:n) = interpolation( n, xnew(1:n), n, y(1:n), xold(1:n) )
!----------------------------------------------------------------
! derivative: returns the derivative of a function at the same
! mesh points
! Usage:
!   dydx = derivative( n, y, x, dx, order )
!     real(dp) derivative(n) : Return function derivative
!     integer  n             : Number of points
!     real(dp) y(n)          : Values of function to derivate
!     real(dp) x(n)          : Mesh values (optional)
!     real(dp) dx            : Mesh interval (optional)
!     integer  order         : order of the derivative (optional)
! Notes:
! - All arguments are input but the function is not pure because,
!   if x or dx are present, they change the default mesh.
! - The two optional arguments x and dx are incompatible. They
!   are used as in routine numerov. If none is present, the last
!   defined mesh is used.
! - If order is not present, order=1 is assumed.
! - If n is smaller than the number of mesh points stored, the
!   first n of them are used.
! Examples:
! - To find the Laplacian of y(x), using a previously defined mesh:
!      d2ydx2(1:n) = derivative( n, y(1:n), order=2 )
!----------------------------------------------------------------
! integral: returns the integral of a function defined in a mesh
! Usage:
!   the_integral = integral( n, y, x, dx )
!     real(dp) integral : Return value
!     integer  n        : Number of points
!     real(dp) y(n)     : Values of function to integrate
!     real(dp) x(n)     : Mesh values (optional)
!     real(dp) dx       : Mesh interval (optional)
! Notes:
! - All arguments are input but the function is not pure because,
!   if x or dx are present, they change the default mesh.
! - The two optional arguments x and dx are incompatible. They
!   are used as in routine numerov. If none is present, the last
!   defined mesh is used.
! - If n is smaller than the number of mesh points stored, the
!   first n of them are used.
! Examples:
! - To find the norm of psi, using a previously defined mesh:
!      norm = integral( n, y=psi(1:n)**2 )
!-----------------------------------------------------------------
! numerov: solves an ordinary differential equation of the form
!    d2y/dx2 = f(x,y) = f0(x) + f1(x)*y
! by the Numerov method:
!    (y(x+dx)-2*y(x)+y(x-dx))/dx2 = (f(x+dx)+10*f(x)+f(x-dx))/12
! from which y(x+dx) can be solved from y(x) and y(x-dx).
! Typical cases are f0=-4*pi*rho(x), f1=0 (Poisson eq.) 
!               and f0=0, f1(x)=2*(V(x)-E) (Schroedinger equation)
! Notice that f must not depend on y' (first derivative)
! Usage:
!   call numerov( n, y, yp, ypp, f0, f1, x, dx, norm )
!     integer  n     : Number of mesh points
!     real(dp) y(n)  : Solution
!     real(dp) yp(n) : First derivative y' = dy/dx
!     real(dp) ypp(n): Second derivative y'' = d2y/dx2 = f(x,y)
!     real(dp) f0(n) : Component of f(x,y) independent of y
!     real(dp) f1(n) : Componnet of f(x,y) proportional to y
!     real(dp) x(n)  : Mesh points
!     real(dp) dx    : Mesh interval (only x OR dx allowed)
!     real(dp) norm  : Norm for solution of homogeneous eqs.
! Notes:
! - All arguments, except y and ypp, are input.
! - All the arguments, except n, are optional.
! - If y is not present, only the mesh is initialized. If the
!   differential equation is solved repeatedly with the same mesh,
!   it is recommended to initialize it only once, making further
!   calls without x or dx present. In that case, the mesh used is
!   defined by the last call to any routine (set_mesh, numerov,
!   derivative, or integral) with a mesh-setting argument
! - If n is smaller than the number of mesh points stored, the
!   first n of them are used.
! - Only one of x OR dx are allowed to define the mesh
! - If f0 or f1 are not present, they are assumed to be zero.
! - The first two values of y must be given on input, to specify 
!   the boundary condition. If f0=0 (homogeneous equation), at
!   least one of them must be nonzero.
! - For f0 not present (homogeneous equation) the normalization
!   of the solution (integral of y**2) is fixed by argument norm.
! - If norm is not present, the norm of y is fixed by the input 
!   values of y(1) and y(2)
! - Output array yp is useful to normalize unbound states
! - Output array ypp is useful for a spline interpolation of y(x)
! Examples:
! - To initialize a variable radial mesh for inwards integration
!     call numerov( n+1, x=r_mesh(n:0:-1) )
! - To solve Poisson's equation with the previously defined mesh:
!     call numerov( n+1, y=rV(n:0:-1), f0=-4*pi*rrho(n:0:-1) )
!   with rV=r*V, rrho=r*rho. rV(n) and rV(n-1) may be initialized
!   to Q (integral of rho) to set the zero of potential at infty.
! - To integrate Schroedinger's equation with a regular mesh
!   (psi(1) and psi(2) required on input):
!     call numerov( n, y=psi(1:n), f1=V(1:n)-E, &
!                   dx=delta_x, norm=1.d0 )
!----------------------------------------------------------------
! Units: 
! Units of x and y in all routines are arbitrary, but they must be
! consistent for all arguments within the same call. Units of x 
! must be also consistent in different calls with the same mesh.
!----------------------------------------------------------------
! Algorithms:
! Interpolation of y(n) is performed in the uniform mesh n=1,2,...,
! independently of the x(n) mesh. To this purpose, function
! locate is used to find n0 such that x(n0)=x0, where x0 is the
! interpolation point. If x(n) is a uniform or logarithmic mesh,
! n0 is obtained analytically. Otherwise, bisection is used to
! locate n0, with a 6-point Lagrange interpolation for x(n).
! Interpolation in the uniform mesh n, rather than in the nonuniform
! mesh xn, is preferred because y(n) is usually better behaved than
! y(x), as well as for consistency with the algorithms used to find
! derivatives and integrals.
!
! For uniform and logarithmic meshes, the derivatives of x(n) are 
! calculated analytically. Otherwise they are approximated by a 
! 5-point formula:
! from   x(n+m) = x(n) + x'(n)*m + x''(n)*m^2/2 +
!                 x'''(n)*m^3/6 + x''''(n)*m^4/24
! we find
!   x'(n)   = ( x(n-2) - 8*x(n-1)          + 8*x(n+1) -x(n+2) )/12
!   x''(n)  = (-x(n-2) +16*x(n-1) -30*x(n) +16*x(n+1) -x(n+2) )/12
!   x'''(n) = (-x(n-2) + 2*x(n-1) -          2*x(n+1) +x(n+2) )/2
!   x''''(n)= ( x(n-2) - 4*x(n-1) + 6*x(n) - 4*x(n+1) +x(n+2  )
!
! Two algorithms are implemented for function derivatives and 
! integrals. The first one uses Lagrange interpolation to define 
! the function between mesh points. The second uses cubic splines. 
! Which method is actually used is determined by the interface 
! settings at the beginning of the module. In the Lagrange version, 
! dy/dn is obtained by the same formula as x'(n) above and we then 
! find dy/dx = (dy/dn)/(dx/dn). 
! The integral is approximated by:
!  3-point formula for first and last intervals:
!    integral_from(1)_to(2) y*dn = ( 5*y(1) + 8*y(2) - y(3) )/12
!  4-point formula for 'interior' intervals: 
!    integral_from(n)_to(n+1) f*dn = 
!       ( -y(n-1) + 13*y(n) + 13*y(n+1) - y(n+2) )/24
! In the spline version, d2y/dn2 is first obtained by imposing the
! matching of y, dy/dn, and d2y/dn2 at each mesh point. Derivatives
! and integrals are then obtained staightforwardly from the cubic
! interpolation polynomials at each point and interval:
!   dy(n)/dn = y(n) - y(n-1) + (2*d2y(n)/dn2 + d2y(n-1)/dn2)/6
!            = y(n+1) - y(n) - (d2y(n+1)/dn2 + 2*d2y(n)/dn2)/6
!            = (y(n+1) - y(n-1))/2 - (d2y(n+1)/dn2 - d2y(n-1)/dn2)/12
!   integral_from(x(n))_to(x(n+1)) y(x)*dx = 
!   integral_from(n)_to(n+1) f(n)*dn = 
!      (f(n)+f(n+1))/2 - (d2f(n)/dn2 + d2f(n+1)/dn2)/24
! with f(n)=y(x(n))*dx(n)/dn. In both versions, higher order 
! derivatives of y(x) are obtained by repeated derivation.
!
! The origin of the 1,10,1 coefs of Numerov's formula 
!    (y(x+dx)-2*y(x)+y(x-dx))/dx2 = (f(x+dx)+10*f(x)+f(x-dx))/12
! is as follows:
!   y(x+dx) = y(x) + y'(x)*dx + y''(x)*dx2/2 + 
!             y'''(x)*dx3/6 + y''''(x)*dx4/24 + O(dx5)
! Then: 
!   (y(x+dx)-2*y(x)+y(x-dx))/dx2 = y''(x) + y''''(x)*dx2/12 + O(dx4)
!                                = f(x) + f''(x)*dx2/12 + O(dx4)
! We now approximate
!   f''(x) = (f(x+dx)-2*f(x)+f(x-dx))/dx2 + O(dx2)
! to find the Numerov formula plus O(dx4) corrections.
! For variable meshes x(n), n=1,2,...,N, we define a new function
!   z(n) = y(x(n)) / (x'(n))^(1/2), where x'=dx/dn. Then, after
! some algebra, it can be shown that
!   d2z/dn2 = g(n,z) = g0(n) + g1(n)*z, where
!   g0(n) = f0(x(n))*(x')^(3/2)
!   g1(n) = f1(x(n))*(x')^2 + [3*(x'')^2/x'-2*x''']/(2*x')^2
! If x decreases with n, we can define a new variable -x and 
!   x' --> -x', what amounts to using |x'|^(1/2) and |x'|^(3/2)
! Within the numerov routine, the derivatives yp and ypp are found
! by a special algorithm, using that y''=f and
!   y(x+dx) - y(x-dx) = 2*y'(x) + y'''(x)/3 + O(dx5) = 
!                       2*y'(x) + f'(x)/3 + O(dx5) =
!                       2*y'(x) + (f(x+dx) - f(x-dx))/(6*dx) + O()
! from which y'(x) is solved. The first and last points are 
! special: taking x = xmax-dx and ignoring O(dx5) errors:
!   y'(x+dx) = y'(x) + y''(x)*dx + y'''(x)*dx2/2 + y''''(x)*dx3/6
!            = y'(x) + f(x)*dx + f'(x)*dx2/2 + f''(x)*dx3/6
!            = y'(x) + f(x)*dx + (f(x+dx)-f(x-dx))*dx/4 +
!              (f(x+dx)-2*f(x)+f(x-dx))*dx/6
!            = y'(x) + (5*f(x+dx) + 8*f(x) - f(x-dx)) * dx/12
! similarly, taking x = xmin+dx:
!   y'(x-dx) = y'(x) - (5*f(x-dx) + 8*f(x) - f(x+dx)) * dx/12
! For a variable mesh, these formulas are used to find z'(n). Then
! y'(x) is found from z' and x', using chain's rule as before
!
! Ref: J.M.Soler notes of Jan.12,1998, Nov.28,2001, Dec.4,2001,
!      Jan.16,2002, Jul.29,2002, Jun.21,2007, and Jul.5,2007.
!-----------------------------------------------------------------
! Implementation details:
! - The routines use straightforward formulas and are optimized
!   for simplicity, clarity, and ease of use, NOT for efficiency.
!-----------------------------------------------------------------
! Written by J.M.Soler. Nov.2001, Jul.2002, Jul.2007, and Jul.2008
!************************************************************************

module gridxc_mesh1D

! Used module procedures
use gridxc_interpolation, only: polint  ! Polynomial (Lagrange) interpolation
use gridxc_interpolation, only: spline  ! Sets spline interpolation
use gridxc_interpolation, only: splint  ! Finds spline interpolation

! Used module types and variables
use gridxc_precision, only: dp      ! Real double precision type
use gridxc_sys,       only: die     ! Termination routine

implicit none

! Public module procedures
PUBLIC :: &
  derivative,        &! Returns function derivatives the same mesh points
  get_mesh,          &! Returns a previously-set 1D mesh
  get_n,             &! Returns the number of mesh points
  integral,          &! Returns the integral of a function defined in a mesh
  interpolation_local,     &! Returns interpolated values at arbitrary points
  locate,            &! Given x0, it returns real value i0 such that x(i0)=x0
  numerov,           &! Solves d2y/dx2 = f(x,y) = f0(x) + f1(x)*y
  set_interpolation, &! Sets interpolation method (lagrange|spline)
  set_mesh            ! Sets a uniform, logarithmic, or arbitrary 1D mesh

! Public types and variables: none

PRIVATE   ! Nothing is declared public beyond this point

!  integer, parameter :: dp = kind(1.d0)

! Internal parameters
  real(dp),parameter :: amax = 1.e-6_dp  ! Min. exponent coef. in log. mesh
  real(dp),parameter :: xtol = 1.e-8_dp  ! Tol. for mesh type identification
  real(dp),parameter :: itol = 1.e-12_dp ! Tolerance for interpolation of x(i)

! Saved internal variables and arrays
  character(len=11),save:: mesh_type='unknown'
  character(len=10),save:: interpolation_method='spline'
  logical,  save:: defined_mesh=.false.  ! Has a mesh been defined?
  real(dp), save:: aa, b ! Log-mesh coefs: x(i)=x(1)+b*(exp(aa*(i-1))-1)
  real(dp), save:: d     ! Uniform mesh interval: x(i)=x(1)+d*(i-1)
  real(dp), save:: yp1=huge(yp1) ! dy/dx at x(1) for spline interp.
  real(dp), save:: ypn=huge(ypn) ! dy/dx at x(n) for spline interp.
  real(dp), save, dimension(:), allocatable :: &
    ivec,  &! Auxiliary vector to call polint: ivec(i)=i
    sqrxp, &! Sqrt(dx/di) at mesh points x(i). Used by numerov.
    s0,    &! (dx/di)**(3/2) at mesh points. Used by numerov.
    s1,    &! (dx/di)**2 at mesh points. Used by numerov.
    s2,    &! (3*xp2**2 - 2*xp1*xp3) / (4*xp1**2). Used by numerov.
    xi,    &! Mesh points x(i)
    xp1,   &! dx/di at mesh points
    xp2,   &! d2x/di2 at mesh points
    xp3,   &! d3x/di3 at mesh points
    xp4     ! d4x/di4 at mesh points

CONTAINS

!----------------------------------------------------------------

function get_n( xmin, xmax, dxmin, dxmax )

  implicit none
  integer              :: get_n
  real(dp), intent(in) :: xmin
  real(dp), intent(in) :: xmax
  real(dp), intent(in) :: dxmin
  real(dp), intent(in) :: dxmax

  real(dp) :: a, b

! Check signs of arguments
  if (dxmax*dxmin<=0._dp .or. (xmax-xmin)*dxmax<=0._dp) &
    call die('get_n: ERROR: Bad arguments')

! Find required number of points
  if (dxmax==dxmin) then  ! Linear mesh
    get_n = nint( (xmax-xmin) / dxmax )
  else
    b = (xmax-xmin) * dxmin / (dxmax-dxmin)
    a = log( 1 + dxmin/b )
    get_n = 1 + nint( log(1+(xmax-xmin)/b) / a )
  endif

end function get_n

!----------------------------------------------------------------

subroutine set_mesh( n, x, xmin, xmax, a, dxndx1 )

  implicit none
  integer,            intent(in) :: n
  real(dp), optional, intent(in) :: x(n)
  real(dp), optional, intent(in) :: xmin
  real(dp), optional, intent(in) :: xmax
  real(dp), optional, intent(in) :: a
  real(dp), optional, intent(in) :: dxndx1

  integer  :: i
  real(dp) :: e, dx, dd, x1, ea

! Check consistency of optional arguments
  if (present(x) .and. (present(xmin) .or. present(xmax) .or. &
                        present(a) .or. present(dxndx1))) &
    call die('set_mesh: ERROR: x not compatible with other optional arguments')
  if (present(a) .and. present(dxndx1)) &
    call die('set_mesh: ERROR: arguments a and dxndx1 are not compatible')

! Check the number of points
  if (n<3) call die('set_mesh: ERROR: at least three points required')

! Check that mesh is monotonic
  if (present(x)) then
    if (any((x(2:n)-x(1:n-1))*(x(n)-x(1)) <= 0._dp)) &
      call die('set_mesh: ERROR: mesh not monotonic')
  end if

! Allocate internal tables
  if (defined_mesh) deallocate( ivec, sqrxp, s0, s1, s2, &
                                xi, xp1, xp2, xp3, xp4 )
  allocate( ivec(n), sqrxp(n), s0(n), s1(n), s2(n),  &
            xi(n), xp1(n), xp2(n), xp3(n), xp4(n) )

! Set auxiliary array ivec
  forall(i=1:n) ivec(i) = i

! Set first point
  if (present(x)) then
    x1 = x(1)
  else if (present(xmin)) then
    x1 = xmin
  else
    x1 = 0
  endif

! Set mesh type
  if (present(x)) then

    ! Find temptative values of a and b (log. mesh), or d (uniform mesh)
    aa = log( (x(n)-x(n-1)) / (x(2)-x(1))) / (n-2)
    if (aa < 1.e-6_dp) then
      mesh_type = 'uniform'
      d = (x(n)-x(1)) / (n-1)
    else
      mesh_type = 'logarithmic'
      b = (x(n)-x(1)) / (exp(aa*(n-1)) - 1)
    end if
    ! Check if mesh is really uniform or logarithmic
    if (mesh_type=='uniform') then
      do i = 2,n
        dx = x(i) - x(i-1)
        if (abs(dx/d-1) > xtol) then
          mesh_type = 'numerical'
          exit
        end if
      end do
    else if (mesh_type=='logarithmic') then
       ea = exp(aa)       ! auxiliary variable
       dd = b*(ea-1.0_dp) ! log spacing at i=2
       do i = 2,n
          dx = x(i) - x(i-1)
          !  dd = b*( exp(aa*(i-1)) - exp(aa*(i-2)) )  ! losses precision
          if (abs(dx/dd-1) > xtol) then
             mesh_type = 'numerical'
             exit
          end if
          dd = ea * dd   ! Update canonical log spacing
       end do
    end if ! (mesh_type=='uniform')

  elseif (present(xmax)) then

    if (present(a)) then
      aa = a
    elseif (present(dxndx1)) then
      aa = log(dxndx1) / (n-1)
    else
      aa = 0
    endif
    if (aa < amax) then
      mesh_type = 'uniform'
      d = (xmax-x1) / (n-1)
    else ! (aa > amax)
      mesh_type = 'logarithmic'
      b = (xmax-x1) / (exp(aa*(n-1)) - 1)
    end if

  else ! (.not.present(x) .and. .not.present(xmax))
    call die('set_mesh: undefined mesh')
  end if ! (present(x))

! DEBUG
!  if (mesh_type=='uniform') then
!    print*, 'set_mesh: mesh_type = ', mesh_type, '   d =', d
!  else if (mesh_type=='logarithmic') then
!    print*, 'set_mesh: mesh_type = ', mesh_type, '   a, b =', aa, b
!  else
!    print*, 'set_mesh: mesh_type = ', mesh_type
!  end if
! END DEBUG

! Set the mesh points and the derivatives of x(i)
  if (mesh_type=='numerical') then
    xi(:) = x(:)

!   Centered 5-point derivatives for all but first/last two points
    do i = 3,n-2
      xp1(i)=( xi(i-2)- 8*xi(i-1)         + 8*xi(i+1)-xi(i+2))/12
      xp2(i)=(-xi(i-2)+16*xi(i-1)-30*xi(i)+16*xi(i+1)-xi(i+2))/12
      xp3(i)=(-xi(i-2)+ 2*xi(i-1)         - 2*xi(i+1)+xi(i+2))/2
      xp4(i)=  xi(i-2)- 4*xi(i-1)+ 6*xi(i)- 4*xi(i+1)+xi(i+2)
    enddo

!   Use first/last 5 points for derivatives of two extreme points
    xp1(1) = xp1(3) - 2*xp2(3) + 4*xp3(3)/2 - 8*xp4(3)/6
    xp1(2) = xp1(3) - 1*xp2(3) + 1*xp3(3)/2 - 1*xp4(3)/6
    xp2(1) = xp2(3) - 2*xp3(3) + 4*xp4(3)/2
    xp2(2) = xp2(3) - 1*xp3(3) + 1*xp4(3)/2
    xp3(1) = xp3(3) - 2*xp4(3)
    xp3(2) = xp3(3) - 1*xp4(3)
    xp4(1) = xp4(3)
    xp4(2) = xp4(3)
    xp1(n)   = xp1(n-2) + 2*xp2(n-2) + 4*xp3(n-2)/2 + 8*xp4(n-2)/6
    xp1(n-1) = xp1(n-2) + 1*xp2(n-2) + 1*xp3(n-2)/2 + 1*xp4(n-2)/6
    xp2(n)   = xp2(n-2) + 2*xp3(n-2) + 4*xp4(n-2)/2
    xp2(n-1) = xp2(n-2) + 1*xp3(n-2) + 1*xp4(n-2)/2
    xp3(n)   = xp3(n-2) + 2*xp4(n-2)
    xp3(n-1) = xp3(n-2) + 1*xp4(n-2)
    xp4(n)   = xp4(n-2)
    xp4(n-1) = xp4(n-2)

  elseif (mesh_type=='logarithmic') then
    ea = exp(aa)
    e = b
    do i = 1,n
      !e = b * exp(aa*(i-1))
      xi(i) = x1 + e - b
      xp1(i) = aa * e
      xp2(i) = aa**2 * e
      xp3(i) = aa**3 * e
      xp4(i) = aa**4 * e
      e = e * ea
    enddo
  elseif (mesh_type=='uniform') then
    do i = 1,n
      xi(i) = x1 + (i-1) * d
      xp1(i) = d
      xp2(i) = 0
      xp3(i) = 0
      xp4(i) = 0
    enddo
  else ! ( mesh_type /= ('numerical'|'logarithmic'|'uniform') )
    call die('set_mesh: ERROR: unknown mesh_type')
  endif ! (mesh_type=='numerical')

! Make sure that first and last points are exactly right
  if (.not.present(x)) xi(1) = x1
  if (present(xmax)) xi(n) = xmax

! Find auxiliary functions associated to the mesh
  sqrxp(:) = abs(xp1)**0.5_dp
  s0(:) = abs(xp1)**1.5_dp
  s1(:) = xp1**2
  s2(:) = (3._dp*xp2**2 - 2._dp*xp1*xp3) / 4._dp / xp1**2

  defined_mesh = .true.

end subroutine set_mesh

!----------------------------------------------------------------

subroutine set_interpolation( method, ypleft, ypright )

  implicit none
  character(len=*), intent(in):: method
  real(dp),optional,intent(in):: ypleft, ypright

  if (method=='spline' .or. method=='spline' .or. &
      method=='SPLINE') then
    interpolation_method = 'spline'
  else if (method=='lagrange' .or. method=='lagrange' .or. &
           method=='LAGRANGE') then
    interpolation_method = 'lagrange'
  else
    call die('set_interpolation: ERROR: unknown method')
  end if

  if (present(ypleft)) then 
    yp1 = ypleft
  else
    yp1 = huge(1._dp)
  end if

  if (present(ypright)) then 
    ypn = ypright
  else
    ypn = huge(1._dp)
  end if

end subroutine set_interpolation

!----------------------------------------------------------------

subroutine get_mesh( n, nx, x, dxdi, d2xdi2, d3xdi3, d4xdi4 )

  implicit none
  integer, intent(in)  :: n   ! size of argument arrays
  integer, intent(out) :: nx  ! number of points
  real(dp), optional, dimension(:), intent(out) :: &
    x, dxdi, d2xdi2, d3xdi3, d4xdi4

  if (.not.defined_mesh) call die('get_mesh: ERROR: mesh not defined')
  nx = size(xi)
  if (present(x) .or. present(dxdi) .or. present(d2xdi2) .or. &
      present(d3xdi3) .or. present(d4xdi4)) then
    nx = max( nx, n )
  end if

  if (present(x))      x(1:nx)      = xi(1:nx)
  if (present(dxdi))   dxdi(1:nx)   = xp1(1:nx)
  if (present(d2xdi2)) d2xdi2(1:nx) = xp2(1:nx)
  if (present(d3xdi3)) d3xdi3(1:nx) = xp3(1:nx)
  if (present(d4xdi4)) d4xdi4(1:nx) = xp4(1:nx)

end subroutine get_mesh

!----------------------------------------------------------------

function locate( x0 )

  implicit none
  real(dp)             :: locate  ! Value i0 such that x(i0)=x0
  real(dp), intent(in) :: x0      ! x point

  integer :: i, i1, i2, iter, n
  real(dp):: dx, il, incr, ir, ic, xc
  logical :: found

  if (.not.defined_mesh) &
    call die('mesh1D locate: ERROR: mesh not defined')

! Find number of mesh points
  n = size(xi)

! Trap easy cases
  if (mesh_type=='uniform') then
    locate = 1 + (x0-xi(1)) / d
    return
  else if (mesh_type=='logarithmic') then
    if (x0 <= xi(1)-b) call die('mesh1D locate: ERROR: x0 out of range')
    locate = 1 + log(1+(x0-xi(1))/b) / aa
    return
  else if (mesh_type/='numerical') then
    call die('mesh1D locate: ERROR: unknown mesh type')
  end if

! Find if x(i) is increasing or decreasing
  if (xi(1) < xi(n)) then
    incr = +1
  else
    incr = -1
  end if

! Find interval x(i):x(i+1) containing x0
  found = .false.
  do i = 1,n-1
    if ((x0-xi(i))*incr>=0._dp .and. (xi(i+1)-x0)*incr>=0._dp) then
      found = .true.
      exit
    end if
  end do
  if (.not.found) call die('mesh1D locate: ERROR: x0 out of range')

! Set range of points for Lagrange interpolation
  ! Use up to 3 neighbor points on each side
  i1 = max( i-2, 1 )
  i2 = min( i+3, n )
  ! Alternatively: use always 6 points
  if (i1==1) i2 = min( 1+5, n )
  if (i2==n) i1 = max( n-5, 1 )

! Find i0 within interval x(i):x(i+1) using bisection
! This is inefficient but it is expected to be used rarely
  il = i
  ir = i+1
  do iter = 1,1000
    ! Interpolate xi(i) at midpoint of bisection interval: xc=xi(ic)
    ic = (il+ir) / 2
    call polint( ivec(i1:i2), xi(i1:i2), i2-i1+1, ic, xc, dx )
    ! Check convergence and perform bisection
    if (abs(ir-il)<itol) then
      locate = ic
      return
    else if ((xc-x0)*incr > 0._dp) then
      ir = ic
    else
      il = ic
    end if
  end do ! iter
  call die('mesh1D locate: ERROR: bisection not converged')

end function locate

!----------------------------------------------------------------

function interpolation_local( nnew, xnew, n, y, x, dx ) &
          result(interpolation)

  implicit none
  integer,            intent(in) :: nnew
  real(dp),           intent(in) :: xnew(nnew)
  integer,            intent(in) :: n
  real(dp),           intent(in) :: y(n)
  real(dp), optional, intent(in) :: x(n)
  real(dp), optional, intent(in) :: dx
  real(dp)                       :: interpolation(nnew)

  integer  :: i, i1, i2, inew
  real(dp) :: d2ydi2(n), dy, dydi, iofxnew, ynew

! Mesh-initialization
  if (present(x)) then
    call set_mesh( n, x=x )
  elseif (present(dx)) then
    call set_mesh( n, xmax=(n-1)*dx )
  endif

! Find interpolation
  if (interpolation_method=='spline') then

    ! Set spline interpolation of y(i) in the uniform mesh i
!    call spline( 1._dp, y, n, yp1*xp1(1), ypn*xp1(n), d2ydi2 )
    call spline( 1._dp, y, n, huge(y), huge(y), d2ydi2 )

    ! Find interpolation at xnew points
    do inew = 1,nnew
      ! Find iofxnew such that x(iofxnew)=xnew
      iofxnew = locate( xnew(inew) )
      ! Make sure that iofxnew is within range [1:n)
      if (iofxnew<1-xtol .or. iofxnew>n+xtol) then
        call die('interpolation: ERROR: xnew out of range')
      else
        iofxnew = max( iofxnew, 1._dp )
        iofxnew = min( iofxnew, n*(1-epsilon(iofxnew)) )
      end if
      ! Interpolate y(i) at iofxnew
      ! Notice: iofxnew range is [1:n) but splint expects [0:n-1)
      call splint( 1._dp, y, d2ydi2, n, iofxnew-1, ynew, dydi )
      interpolation(inew) = ynew
    end do ! inew

  else if (interpolation_method=='lagrange') then

    ! Loop on xnew points
    do inew = 1,nnew
      ! Find iofxnew such that xi(iofxnew)=xnew
      iofxnew = locate( xnew(inew) )
      i = int(iofxnew)
      ! Use up to 3 neighbor points on each side
      i1 = max( i-2, 1 )
      i2 = min( i+3, n )
      ! Alternatively: use always 6 points
      if (i1==1) i2 = min( 1+5, n )
      if (i2==n) i1 = max( n-5, 1 )
      ! Now interpolate y(iofxnew) in the uniform mesh ivec=i
      call polint( ivec(i1:i2), y(i1:i2), i2-i1+1, iofxnew, ynew, dy )
      interpolation(inew) = ynew
    end do ! inew

  else
    call die('interpolation: ERROR: bad interpolation_method parameter')
  end if ! (interpolation_method)

end function interpolation_local

!----------------------------------------------------------------

recursive function derivative( n, y, x, dx, order ) result(dydx)

  implicit none
  integer,            intent(in) :: n
  real(dp),           intent(in) :: y(n)
  real(dp), optional, intent(in) :: x(n)
  real(dp), optional, intent(in) :: dx
  integer,  optional, intent(in) :: order
  real(dp)                       :: dydx(n)

  integer  :: i, nx, ord
  real(dp) :: dxdi(n), dydi(n), d2ydi2(n)

! Mesh-initialization
  if (present(x)) then
    call set_mesh( n, x=x )
  elseif (present(dx)) then
    call set_mesh( n, xmax=(n-1)*dx )
  endif

! Fix order of the derivative
  if (present(order)) then
    ord = order
  else
    ord = 1
  endif

! Iterate over order for order>1
  if (ord > 1) then
    dydx = derivative( n, derivative(n,y), order=ord-1 )
  elseif (ord == 1) then

    if (interpolation_method=='spline') then

      call spline( 1._dp, y, n, yp1, ypn, d2ydi2 )
!      call spline( 1._dp, y, n, yp1*xp1(1), ypn*xp1(n), d2ydi2 )

      dydi(1) = y(2) - y(1) - (2*d2ydi2(1) + d2ydi2(2)) / 6
      dydi(n) = y(n) - y(n-1) + (d2ydi2(n-1) + 2*d2ydi2(n)) / 6
      dydi(2:n-1) = (y(3:n) - y(1:n-2)) / 2 &
                  - (d2ydi2(3:n) - d2ydi2(1:n-2)) / 12

    else if (interpolation_method=='lagrange') then

!     Find derivative of y with respect to i
!     Centered 5-point formulas for all but first/last two points
      do i = 3,n-2
        dydi(i)=(y(i-2)-8*y(i-1)+8*y(i+1)-y(i+2))/12
      enddo

!     Find derivative at first/last two points
      if (n<=1) then
        dydi = 0
      else if (n==2) then
        dydi = -y(1) + y(2)
      else if (n==3) then
        dydi(1) = (-3*y(1) + 4*y(2) -   y(3)) / 2
        dydi(3) = (   y(1) - 4*y(2) + 3*y(3)) / 2
        dydi(2) = (-  y(1)          +   y(3)) / 2
      else if (n==4) then
        ! Use up to 2 neighbor points on each side
!        dydi(1) = ( -3*y(1) + 4*y(2) -   y(3)) / 2
!        dydi(4) = (    y(2) - 4*y(3) + 3*y(4)) / 2
!        dydi(2) = (- 2*y(1) - 3*y(2) + 6*y(3) -   y(4)) / 6
!        dydi(3) = (    y(1) - 6*y(2) + 3*y(3) + 2*y(4)) / 6
        ! Alternatively: use all available points
        dydi(1) = (-11*y(1) +18*y(2) - 9*y(3) + 2*y(4)) / 6
        dydi(4) = (- 2*y(1) + 9*y(2) -18*y(3) +11*y(4)) / 6
      else
        ! Use up to 2 neighbor points on each side
!        dydi(1) = ( -3*y(1)   + 4*y(2)   -   y(3)) / 2
!        dydi(n) = (    y(n-2) - 4*y(n-1) + 3*y(n)) / 2
!        dydi(2)   = (- 2*y(1)   - 3*y(2)   + 6*y(3)   -   y(4)) / 6
!        dydi(n-1) = (    y(n-3) - 6*y(n-2) + 3*y(n-1) + 2*y(n)) / 6
        ! Alternatively: use always 5 points
        dydi(1)=(-25*y(1)+48*y(2)  -36*y(3)  +16*y(4)  -3*y(5)  )/12
        dydi(n)=(+25*y(n)-48*y(n-1)+36*y(n-2)-16*y(n-3)+3*y(n-4))/12
        dydi(2)  =(-3*y(1)-10*y(2)  +18*y(3)  -6*y(4)  +y(5)    )/12
        dydi(n-1)=(+3*y(n)+10*y(n-1)-18*y(n-2)+6*y(n-3)-y(n-4)  )/12
      end if ! (n)

    else
      call die('derivative: ERROR: bad interpolation_method parameter')
    end if ! (interpolation_method)

!   Find derivative of x with respect to i
    call get_mesh( n, nx, dxdi=dxdi )

!   Find derivative of y with respect to x
    dydx = dydi / dxdi

  endif

end function derivative

!----------------------------------------------------------------

function integral( n, y, x, dx )

  implicit none
  real(dp)                       :: integral
  integer,            intent(in) :: n
  real(dp),           intent(in) :: y(n)
  real(dp), optional, intent(in) :: x(n)
  real(dp), optional, intent(in) :: dx

  real(dp):: d2fdi2(n), f(n)

! Mesh-initialization
  if (present(x)) then
    call set_mesh( n, x=x )
  elseif (present(dx)) then
    call set_mesh( n, xmax=(n-1)*dx )
  endif

! Find integral
  if (interpolation_method=='spline') then

    f = y * xp1(1:n)
    call spline( 1._dp, f, n, yp1, ypn, d2fdi2 )
!    call spline( 1._dp, y, n, yp1*xp1(1), ypn*xp1(n), d2ydi2 )

    integral = (f(1) + f(n))/2 - (d2fdi2(1) + d2fdi2(n)) / 24 &
             + sum(f(2:n-1)) - sum(d2fdi2(2:n-1)) / 12

  else if (interpolation_method=='lagrange') then

    if (n<=1) then
      integral = 0
    else if (n==2) then
      integral = ( y(1)*xp1(1) + y(2)*xp1(2) ) / 2
    else if (n==3) then
      integral = ( y(1)*xp1(1) + 4*y(2)*xp1(2) + y(3)*xp1(3) ) / 3
    else if (n==4) then
      integral = (   3 * (y(1)*xp1(1) + y(n)  *xp1(n)  )      &
                  +  9 * (y(2)*xp1(2) + y(n-1)*xp1(n-1)) )/8
    else if (n==5) then
      integral = (   9 * (y(1)*xp1(1) + y(n)  *xp1(n)  )      &
                  + 28 * (y(2)*xp1(2) + y(n-1)*xp1(n-1))      &
                  + 22 *  y(3)*xp1(3)                    )/24
    else
      integral = (   9 * (y(1)*xp1(1) + y(n)  *xp1(n)  )      &
                  + 28 * (y(2)*xp1(2) + y(n-1)*xp1(n-1))      &
                  + 23 * (y(3)*xp1(3) + y(n-2)*xp1(n-2)) )/24 &
               + sum( y(4:n-3)*xp1(4:n-3) )
    end if

  else
    call die('integral: ERROR: bad interpolation_method parameter')
  end if ! (interpolation_method)

end function integral

!----------------------------------------------------------------

subroutine numerov( n, y, yp, ypp, f0, f1, x, dx, norm )

  implicit none
  integer,            intent(in)    :: n
  real(dp), optional, intent(inout) :: y(n)
  real(dp), optional, intent(out)   :: yp(n)
  real(dp), optional, intent(out)   :: ypp(n)
  real(dp), optional, intent(in)    :: f0(n)
  real(dp), optional, intent(in)    :: f1(n)
  real(dp), optional, intent(in)    :: x(n)
  real(dp), optional, intent(in)    :: dx
  real(dp), optional, intent(in)    :: norm

  integer                :: i
  real(dp)               :: ynorm
  real(dp), dimension(n) :: g, g0, g1, z, zp

! Mesh-initialization
  if (present(x)) then
    call set_mesh( n, x=x )
  elseif (present(dx)) then
    call set_mesh( n, xmax=(n-1)*dx )
  endif
  if (.not.present(y)) return

! Check that y has been initialized in left boundary
  if (.not.present(f0)      & ! Homogeneous equation
      .and.abs(y(1))==0._dp &
      .and.abs(y(2))==0._dp) then
     call die('numerov: ERROR: first two values of y needed')
  endif

! Find g0 and g1
  g0 = 0._dp
  g1 = s2
  if (present(f0)) g0 = s0 * f0
  if (present(f1)) g1 = s1 * f1 + g1

! Integrate differential equation
  z(1) = y(1) / sqrxp(1)
  z(2) = y(2) / sqrxp(2)

  do i = 2,n-1
    z(i+1) = ( (g0(i-1)+10._dp*g0(i)+g0(i+1))/12._dp +   &
               (-1._dp+g1(i-1)/12._dp)*z(i-1)        +   &
               (2._dp+(10._dp/12._dp)*g1(i))*z(i)    ) / &
                  (1._dp-g1(i+1)/12._dp)
  enddo
  y = z * sqrxp

! Find first derivative y'=dy/dx
  if (present(yp)) then
    g = g0 + g1*z
    zp(2:n-1) = (z(3:n) - z(1:n-2))/2 + (g(3:n) - g(1:n-2))/6
    zp(n) = zp(n-1) + (5*g(n) + 8*g(n-1) - g(n-2))/12
    zp(1) = zp(2)   - (5*g(1) + 8*g(2)   - g(3)  )/12
    yp = ( zp + z*xp2/(2*xp1) )/sqrxp
  endif

! Find second derivative y''=d2y/dx2
  if (present(ypp)) then
    ypp = 0
    if (present(f0)) ypp = f0
    if (present(f1)) ypp = ypp + f1*y
  endif

! Normalize solution
  if (present(norm)) then
    if (present(f0)) then
      call die('numerov: ERROR: cannot normalize inhomogeneous solutions')
    elseif (norm <= 0._dp) then
       block
         character(len=60) :: msg
         write(msg,"(a,g20.6)") 'numerov: ERROR: nonpositive norm =', norm
         call die(trim(msg))
       end block
    endif
    ynorm = integral( n, y=y*y )
    y = y * sqrt(norm/ynorm)
    if (present(yp))  yp  = yp  * sqrt(norm/ynorm)
    if (present(ypp)) ypp = ypp * sqrt(norm/ynorm)
  endif

end subroutine numerov

end module gridxc_mesh1D

#if defined HAVE_CONFIG_H
#include "config.h"
#endif

#ifdef HAVE_LIBXC
#include "xc_version.h"
#endif

!!@LICENSE
!
!******************************************************************************
! MODULE m_ldaxc
! Provides routines for LDA XC functional evaluation
!******************************************************************************
!
!   PUBLIC procedures available from this module:
! ldaxc   ! General subroutine for all coded LDA XC functionals
! exchng  ! Local exchange
! pw92c   ! Perdew & Wang, PRB, 45, 13244 (1992) (Correlation only)
! pw92xc  ! Perdew & Wang, PRB, 45, 13244 (1992)
! pzxc    ! Perdew & Zunger, PRB 23, 5075 (1981)
!
!   PUBLIC parameters, types, and variables available from this module:
! none
!
!******************************************************************************
!
!   USED module procedures:
! use gridxc_sys,        only: die             ! Termination routine
!
!   USED module parameters:
! use gridxc_precision,  only: dp              ! Real double precision type
!
!   EXTERNAL procedures used:
! none
!
!******************************************************************************

module gridxc_lda

  implicit none

  private

  public :: ldaxc   ! General subroutine for all coded LDA XC functionals
  public :: exchng  ! Local exchange
  public :: pw92c   ! Perdew & Wang, PRB, 45, 13244 (1992) (Correlation only)
  public :: pw92xc  ! Perdew & Wang, PRB, 45, 13244 (1992)
  public :: pzxc    ! Perdew & Zunger, PRB 23, 5075 (1981)

contains

  SUBROUTINE LDAXC( AUTHOR, IREL, nspin, D, EPSX, EPSC, VX, VC, &
      DVXDN, DVCDN &
#ifdef HAVE_LIBXC
      , is_libxc, xc_func, xc_info )
#else
    )
#endif

    ! ******************************************************************
    ! Finds the exchange and correlation energies and potentials, in the
    ! Local (spin) Density Approximation.
    ! Written by L.C.Balbas and J.M.Soler, Dec'96.
    ! Non-collinear spin added by J.M.Soler, May'98
    ! Interface with LibXC added by Micael Oliveira, Jul.2014
    ! *********** INPUT ************************************************
    ! CHARACTER*(*) AUTHOR : Parametrization desired:
    !     'CA' or 'PZ' => LSD Perdew & Zunger, PRB 23, 5075 (1981)
    !     'PW92' => LSD Perdew & Wang, PRB, 45, 13244 (1992)
    !     A check is made first for libxc identifiers (strings of the
    !     form "GGA_C_PBE", which are morphologically identical to the
    !     functional id macros but in string form.
    !     If the check fails the routine falls back on the built-in cases
    !     CA/PZ or PW92.
    !                     Uppercase is optional
    ! INTEGER IREL     : Relativistic exchange? (0=>no, 1=>yes)
    ! INTEGER nspin    : nspin=1 => unpolarized; nspin=2 => polarized;
    !                    nspin=4 => non-collinear polarization
    ! REAL*8  D(nspin) : Local (spin) density. For non-collinear
    !                    polarization, the density matrix is given by:
    !                    D(1)=D11, D(2)=D22, D(3)=Real(D12), D(4)=Im(D12)
    !
    !     Optional arguments if Libxc is compiled in (-DLIBXC):
    !     logical :: is_libxc    ! flag that determines whether it is a libxc functional
    !     type(xc_f90_pointer_t) :: xc_func, xc_info ! pre-initialized libxc objects
    
    !*********** OUTPUT ***********************************************
    ! REAL*8 EPSX, EPSC : Exchange and correlation energy densities
    ! REAL*8 VX(nspin), VC(nspin) : Exchange and correlation potentials,
    !                               defined as dExc/dD(ispin)
    ! REAL*8 DVXDN(nspin,nspin)  :  Derivative of exchange potential with
    !                               respect the charge density, defined 
    !                               as DVx(spin1)/Dn(spin2)
    ! REAL*8 DVCDN(nspin,nspin)  :  Derivative of correlation potential
    !                               respect the charge density, defined 
    !                               as DVc(spin1)/Dn(spin2)
    ! *********** UNITS ************************************************
    ! Lengths in Bohr, energies in Hartrees
    ! ******************************************************************
    
    use gridxc_precision, only : dp
    use gridxc_sys,       only : die

#ifdef HAVE_LIBXC
#if XC_MAJOR_VERSION >= 4
    use xc_f03_lib_m
    use iso_c_binding, only: c_size_t, c_int
#else
    use xc_f90_types_m
    use xc_f90_lib_m
#endif
#endif /* HAVE_LIBXC */

    CHARACTER*(*),intent(in) :: AUTHOR ! LDA flavour ('PZ'|'PW92')
    INTEGER, intent(in) :: IREL        ! Relativistic exchange? 0=>no, 1=>yes
    INTEGER, intent(in) :: nspin       ! Number of spin components
    real(dp),intent(in) :: D(nspin)    ! Electron density (matrix)
    real(dp),intent(out):: EPSX        ! Exchange energy per electron
    real(dp),intent(out):: EPSC        ! Correlation energy per electron
    real(dp),intent(out):: VX(nspin)   ! Exchange potential
    real(dp),intent(out):: VC(nspin)   ! Correlation potential
    real(dp),intent(out):: DVXDN(nspin,nspin) ! dVX(spin1)/dDens(spin2)
    real(dp),intent(out):: DVCDN(nspin,nspin) ! dVC(spin1)/dDens(spin2)
#ifdef HAVE_LIBXC
    logical, intent(in), optional    :: is_libxc
#if XC_MAJOR_VERSION >= 4
    type(xc_f03_func_t), optional :: xc_func
    type(xc_f03_func_info_t), optional :: xc_info
# if XC_MAJOR_VERSION >= 5
    integer(c_size_t), parameter :: one = 1
# else
    integer(c_int), parameter :: one = 1
# endif
#else
    type(xc_f90_pointer_t), optional :: xc_func, xc_info
#endif
#endif

    INTEGER           IS, NS, ISPIN1, ISPIN2
    real(dp)          DD(2), DPOL, DTOT, TINY, VCD(2), VPOL, VXD(2)

#ifdef HAVE_LIBXC
    logical  :: lis_libxc
    integer :: xc_kind
    real(dp) :: eps(1), ldedn(nspin), fxc(3), kxc(4), v4xc(5)
#endif

    PARAMETER ( TINY = 1.D-12 )

    IF (nspin .EQ. 4) THEN
      ! Find eigenvalues of density matrix (up and down densities
      ! along the spin direction)
      ! Note: D(1)=D11, D(2)=D22, D(3)=Real(D12), D(4)=Im(D12)
      NS = 2
      DTOT = D(1) + D(2)
      DPOL = SQRT( (D(1)-D(2))**2 + 4.D0*(D(3)**2+D(4)**2) )
      DD(1) = 0.5D0 * ( DTOT + DPOL )
      DD(2) = 0.5D0 * ( DTOT - DPOL )
    ELSE
      NS = nspin
      DO IS = 1,nspin
        !ag       Avoid negative densities
        DD(IS) = max(D(IS),0.0d0)
      end DO
    ENDIF


    DO ISPIN2 = 1, nspin
      DO ISPIN1 = 1, nspin
        DVXDN(ISPIN1,ISPIN2) = 0.D0
        DVCDN(ISPIN1,ISPIN2) = 0.D0
      ENDDO
    ENDDO

#ifdef HAVE_LIBXC
    if ( present(is_libxc) ) then
      lis_libxc = is_libxc
      if ( lis_libxc ) then
        if ((.not. present(xc_func)) .or. &
            (.not. present(xc_info))) then
          call die("xc_func and xc_info not present")
        endif
      endif
    else
      lis_libxc = .false.
    end if

    if (lis_libxc) then

      !     pass the arrays as assumed-size
      ! '1' is the number of grid points: the current approach is
      ! wasteful since it initializes and cleans the functional object
      ! at every grid point.
      !      call xc_f90_lda_exc_vxc(xc_func, 1, DD(1), eps, ldedn(1))
      ! Use general LDA libxc call to get fxc
#if XC_MAJOR_VERSION >= 4
      IF (xc_f03_func_info_get_family(xc_info) /= XC_FAMILY_LDA) THEN
        call die('LDAXC: Functional is not an LDA')
      ENDIF
      xc_kind = xc_f03_func_info_get_kind(xc_info)
# if XC_MAJOR_VERSION >= 5
      call xc_f03_lda_exc_vxc_fxc( xc_func, one, DD, eps, ldedn, fxc)
# else
      call xc_f03_lda( xc_func, one, DD, eps, ldedn, fxc, kxc)
# endif
#else
      IF (xc_f90_info_family(xc_info) /= XC_FAMILY_LDA) THEN
        call die('LDAXC: Functional is not an LDA')
      ENDIF
      xc_kind = xc_f90_info_kind(xc_info)
      call xc_f90_lda( xc_func, 1, DD(1), eps(1), ldedn(1), fxc(1), kxc(1))
#endif
      IF (xc_kind == XC_CORRELATION) THEN
        EPSC = eps(1)
        VCD(1:nspin) = ldedn(1:nspin)
        EPSX = 0.0_dp
        VXD(1:nspin) = 0.0_dp
        DVXDN(:,:) = 0.0_dp
        if (nspin == 1) then
           DVCDN(1,1) = fxc(1)
        else
           DVCDN(1,1) = fxc(1)
           DVCDN(2,2) = fxc(3)
           DVCDN(1,2) = fxc(2)
           DVCDN(2,1) = fxc(2)
        endif
      ELSE if (xc_kind == XC_EXCHANGE) THEN
        EPSX = eps(1)
        VXD(1:nspin) = ldedn(1:nspin)
        EPSC = 0.0_dp
        VCD(1:nspin) = 0.0_dp
        DVCDN(:,:) = 0.0_dp
        if (nspin == 1) then
           DVXDN(1,1) = fxc(1)
        else
           DVXDN(1,1) = fxc(1)
           DVXDN(2,2) = fxc(3)
           DVXDN(1,2) = fxc(2)
           DVXDN(2,1) = fxc(2)
        endif
      ELSE  ! combined functional, use an arbitrary 50/50 split
        EPSX = 0.5_dp * eps(1)
        EPSC = 0.5_dp * eps(1)
        VXD(1:nspin) = 0.5_dp * ldedn(1:nspin)
        VCD(1:nspin) = 0.5_dp * ldedn(1:nspin)
        if (nspin == 1) then
           DVXDN(1,1) = 0.5_dp * fxc(1)
        else
           DVXDN(1,1) = 0.5_dp * fxc(1)
           DVXDN(2,2) = 0.5_dp * fxc(3)
           DVXDN(1,2) = 0.5_dp * fxc(2)
           DVXDN(2,1) = 0.5_dp * fxc(2)
        endif
        DVCDN(:,:) = DVXDN(:,:)
      ENDIF

    ELSE IF ( AUTHOR.EQ.'CA' .OR. AUTHOR.EQ.'ca' .OR. &
#else
    IF ( AUTHOR.EQ.'CA' .OR. AUTHOR.EQ.'ca' .OR. &
#endif
      AUTHOR.EQ.'PZ' .OR. AUTHOR.EQ.'pz') THEN
      CALL PZXC( IREL, NS, DD, EPSX, EPSC, VXD, VCD, DVXDN, DVCDN )

    ELSEIF ( AUTHOR.EQ.'PW92' .OR. AUTHOR.EQ.'pw92' ) THEN
       ! Note that DV{XC}DN is not implemented for this flavor.
       ! Better use libxc
       CALL PW92XC( IREL, NS, DD, EPSX, EPSC, VXD, VCD )

    ELSE
      call die('LDAXC: Unknown author ' // trim(AUTHOR))
    ENDIF

    IF (nspin .EQ. 4) THEN
      ! NOTE: dE2/DN2 is not back-converted !
      ! Find dE/dD(ispin) = dE/dDup * dDup/dD(ispin) +
      !                     dE/dDdown * dDown/dD(ispin)
      VPOL  = (VXD(1)-VXD(2)) * (D(1)-D(2)) / (DPOL+TINY)
      VX(1) = 0.5D0 * ( VXD(1) + VXD(2) + VPOL )
      VX(2) = 0.5D0 * ( VXD(1) + VXD(2) - VPOL )
      VX(3) = (VXD(1)-VXD(2)) * D(3) / (DPOL+TINY)
      VX(4) = (VXD(1)-VXD(2)) * D(4) / (DPOL+TINY)
      VPOL  = (VCD(1)-VCD(2)) * (D(1)-D(2)) / (DPOL+TINY)
      VC(1) = 0.5D0 * ( VCD(1) + VCD(2) + VPOL )
      VC(2) = 0.5D0 * ( VCD(1) + VCD(2) - VPOL )
      VC(3) = (VCD(1)-VCD(2)) * D(3) / (DPOL+TINY)
      VC(4) = (VCD(1)-VCD(2)) * D(4) / (DPOL+TINY)
    ELSE
      DO IS = 1,nspin
        VX(IS) = VXD(IS)
        VC(IS) = VCD(IS)
      end do
    ENDIF
  END SUBROUTINE LDAXC


  subroutine exchng( IREL, NSP, DS, EX, VX )

    ! *****************************************************************
    !  Finds local exchange energy density and potential
    !  Adapted by J.M.Soler from routine velect of Froyen's 
    !    pseudopotential generation program. Madrid, Jan'97. Version 0.5.
    !  Relativistic exchange modified by JMS, May.2014
    ! **** Input ******************************************************
    ! INTEGER IREL    : relativistic-exchange switch (0=no, 1=yes)
    ! INTEGER NSP     : spin-polarizations (1=>unpolarized, 2=>polarized)
    ! REAL*8  DS(NSP) : total (nsp=1) or spin (nsp=2) electron density
    ! **** Output *****************************************************
    ! REAL*8  EX      : exchange energy density
    ! REAL*8  VX(NSP) : (spin-dependent) exchange potential
    ! **** Units ******************************************************
    ! Densities in electrons/Bohr**3
    ! Energies in Hartrees
    ! *****************************************************************

    use gridxc_precision, only: dp
    implicit none

    integer, intent(in) :: nsp, irel
    real(dp), intent(in)             :: DS(NSP)
    real(dp), intent(out)            :: VX(NSP)
    real(dp), intent(out)            :: EX

    real(dp), parameter :: zero = 0.0_dp, one = 1.0_dp
    real(dp), parameter :: pfive = 0.5_dp, opf = 1.5_dp
    !      real(dp), parameter :: c = 137.035999_dp       ! speed of light in a.u.
    !      real(dp), parameter :: C014 = 0.014_dp         ! (9*pi/4)^(1/3)/c
    real(dp), parameter :: C014 = 0.0140047747_dp  ! updated JMS, May.2014

    real(dp) :: a0, alp, sb, rs
    real(dp) :: pi, trd, ftrd, tftm
    real(dp) :: d1, d2, d, z, fz, fzp, vxp, exp_var
    real(dp) :: beta, vxf, exf, alb
    real(dp) :: dBETAdD, dETAdD, dGAMMAdD, dPHIdD, dKFdD
    real(dp) :: ETA, GAMMA, KF, PHI

    PI=4*ATAN(ONE)
    TRD = ONE/3
    FTRD = 4*TRD
    TFTM = 2._dp**FTRD-2

    IF (NSP .EQ. 2) THEN
      D1 = MAX(DS(1),ZERO)
      D2 = MAX(DS(2),ZERO)
      D = D1 + D2
      IF (D .LE. ZERO) THEN
        EX = ZERO
        VX(1) = ZERO
        VX(2) = ZERO
        RETURN
      ENDIF
      Z = (D1 - D2) / D
      FZ = ((1+Z)**FTRD+(1-Z)**FTRD-2)/TFTM
      FZP = FTRD*((1+Z)**TRD-(1-Z)**TRD)/TFTM 
    ELSE
      D = DS(1)
      IF (D .LE. ZERO) THEN
        EX = ZERO
        VX(1) = ZERO
        RETURN
      ENDIF
      Z = ZERO
      FZ = ZERO
      FZP = ZERO
    ENDIF

    A0 = (4/(9*PI))**TRD 
    ALP = 2 * TRD                      ! X-alpha parameter
    RS = (3 / (4*PI*D) )**TRD
    VXP = -(3*ALP/(2*PI*A0*RS))        ! VX=-KF/PI
    EXP_VAR = 3*VXP/4                  ! epsX=-3*KF/4/PI
    IF (IREL .EQ. 1) THEN
      ! Ref: MacDonald and Vosco, J.Phys C 12, 2977 (1979)
      BETA = C014/RS                   ! ratio of Fermi to light speed
      SB = SQRT(1+BETA*BETA)
      ALB = LOG(BETA+SB)
      VXP = VXP * (-PFIVE + OPF * ALB / (BETA*SB))
      EXP_VAR = EXP_VAR * (ONE-OPF*((BETA*SB-ALB)/BETA**2)**2) 
    ENDIF

    IF (NSP .EQ. 2) THEN
      VXF = 2**TRD*VXP
      EXF = 2**TRD*EXP_VAR
      VX(1) = VXP + FZ*(VXF-VXP) + (1-Z)*FZP*(EXF-EXP_VAR)
      VX(2) = VXP + FZ*(VXF-VXP) - (1+Z)*FZP*(EXF-EXP_VAR)
      EX    = EXP_VAR + FZ*(EXF-EXP_VAR)
    ELSE
      VX(1) = VXP
      EX    = EXP_VAR
    ENDIF
  END subroutine exchng



  SUBROUTINE PW92C( nspin, Dens, EC, VC )

    ! ********************************************************************
    ! Implements the Perdew-Wang'92 local correlation (beyond RPA).
    ! Ref: J.P.Perdew & Y.Wang, PRB, 45, 13244 (1992)
    ! Written by L.C.Balbas and J.M.Soler. Dec'96.  Version 0.5.
    ! ********* INPUT ****************************************************
    ! INTEGER nspin       : Number of spin polarizations (1 or 2)
    ! REAL*8  Dens(nspin) : Local (spin) density
    ! ********* OUTPUT ***************************************************
    ! REAL*8  EC        : Correlation energy density
    ! REAL*8  VC(nspin) : Correlation (spin) potential
    ! ********* UNITS ****************************************************
    ! Densities in electrons per Bohr**3
    ! Energies in Hartrees
    ! ********* ROUTINES CALLED ******************************************
    ! None
    ! ********************************************************************

    use gridxc_precision, only : dp

    ! Next line is nonstandard but may be supressed
    implicit          none

    ! Argument types and dimensions
    INTEGER           nspin
    real(dp)          Dens(nspin), EC, VC(nspin)

    ! Internal variable declarations
    INTEGER           IG
    real(dp)          A(0:2), ALPHA1(0:2), B, BETA(0:2,4), C, &
                      DBDRS, DECDD(2), DECDRS, DECDZ, DENMIN, DFDZ, &
                      DGDRS(0:2), DCDRS, DRSDD, DTOT, DZDD(2), &
                      F, FPP0, FOUTHD, G(0:2), HALF, ONE, &
                     P(0:2), PI, RS, THD, THRHLF, ZETA

    ! Add tiny numbers to avoid numerical errors
    PARAMETER ( DENMIN = 1.D-12 )
    PARAMETER ( ONE    = 1.D0 + 1.D-12 )

    ! Fix some numerical constants
    PARAMETER ( FOUTHD=4.D0/3.D0, HALF=0.5D0, &
                    THD=1.D0/3.D0, THRHLF=1.5D0 )

    ! Parameters from Table I of Perdew & Wang, PRB, 45, 13244 (92)
    DATA P      / 1.00d0,     1.00d0,     1.00d0     /
    DATA A      / 0.031091d0, 0.015545d0, 0.016887d0 /
    DATA ALPHA1 / 0.21370d0,  0.20548d0,  0.11125d0  /
    DATA BETA   / 7.5957d0,  14.1189d0,  10.357d0, &
                      3.5876d0,   6.1977d0,   3.6231d0, &
                  1.6382d0,   3.3662d0,   0.88026d0, &
                  0.49294d0,  0.62517d0,  0.49671d0 /

    ! Find rs and zeta
    PI = 4 * ATAN(1.D0)
    IF (nspin .EQ. 1) THEN
      DTOT = MAX( DENMIN, Dens(1) )
      ZETA = 0
      RS = ( 3 / (4*PI*DTOT) )**THD
      !       Find derivatives dRs/dDens and dZeta/dDens
      DRSDD = (- RS) / DTOT / 3
      DZDD(1) = 0
    ELSE
      DTOT = MAX( DENMIN, Dens(1)+Dens(2) )
      ZETA = ( Dens(1) - Dens(2) ) / DTOT
      RS = ( 3 / (4*PI*DTOT) )**THD
      DRSDD = (- RS) / DTOT / 3
      DZDD(1) =   (ONE - ZETA) / DTOT
      DZDD(2) = - (ONE + ZETA) / DTOT
    ENDIF

    ! Find eps_c(rs,0)=G(0), eps_c(rs,1)=G(1) and -alpha_c(rs)=G(2)
    ! using eq.(10) of cited reference (Perdew & Wang, PRB, 45, 13244 (92))
    DO IG = 0,2
      B = BETA(IG,1) * RS**HALF   + &
          BETA(IG,2) * RS         + &
          BETA(IG,3) * RS**THRHLF + &
          BETA(IG,4) * RS**(P(IG)+1)
      DBDRS = BETA(IG,1) * HALF      / RS**HALF + &
          BETA(IG,2)                         + &
          BETA(IG,3) * THRHLF    * RS**HALF + &
          BETA(IG,4) * (P(IG)+1) * RS**P(IG)
      C = 1 + 1 / (2 * A(IG) * B)
      DCDRS = - ( (C-1) * DBDRS / B )
      G(IG) = (- 2) * A(IG) * ( 1 + ALPHA1(IG)*RS ) * LOG(C)
      DGDRS(IG) = (- 2) *A(IG) * ( ALPHA1(IG) * LOG(C) + &
          (1+ALPHA1(IG)*RS) * DCDRS / C )
    end do

    ! Find f''(0) and f(zeta) from eq.(9)
    C = 1 / (2**FOUTHD - 2)
    FPP0 = 8 * C / 9
    F = ( (ONE+ZETA)**FOUTHD + (ONE-ZETA)**FOUTHD - 2 ) * C
    DFDZ = FOUTHD * ( (ONE+ZETA)**THD - (ONE-ZETA)**THD ) * C

    ! Find eps_c(rs,zeta) from eq.(8)
    EC = G(0) - G(2) * F / FPP0 * (ONE-ZETA**4) + &
        (G(1)-G(0)) * F * ZETA**4
    DECDRS = DGDRS(0) - DGDRS(2) * F / FPP0 * (ONE-ZETA**4) + &
        (DGDRS(1)-DGDRS(0)) * F * ZETA**4
    DECDZ = (- G(2)) / FPP0 * ( DFDZ*(ONE-ZETA**4) - F*4*ZETA**3 ) + &
        (G(1)-G(0)) * ( DFDZ*ZETA**4 + F*4*ZETA**3 )

    ! Find correlation potential
    IF (nspin .EQ. 1) THEN
      DECDD(1) = DECDRS * DRSDD
      VC(1) = EC + DTOT * DECDD(1)
    ELSE
      DECDD(1) = DECDRS * DRSDD + DECDZ * DZDD(1)
      DECDD(2) = DECDRS * DRSDD + DECDZ * DZDD(2)
      VC(1) = EC + DTOT * DECDD(1)
      VC(2) = EC + DTOT * DECDD(2)
    ENDIF

  END SUBROUTINE PW92C



  SUBROUTINE PW92XC( IREL, nspin, Dens, EPSX, EPSC, VX, VC )

    ! ********************************************************************
    ! Implements the Perdew-Wang'92 LDA/LSD exchange correlation
    ! Ref: J.P.Perdew & Y.Wang, PRB, 45, 13244 (1992)
    ! Written by L.C.Balbas and J.M.Soler. Dec'96. Version 0.5.
    ! ********* INPUT ****************************************************
    ! INTEGER IREL        : Relativistic-exchange switch (0=No, 1=Yes)
    ! INTEGER nspin       : Number of spin polarizations (1 or 2)
    ! REAL*8  Dens(nspin) : Local (spin) density
    ! ********* OUTPUT ***************************************************
    ! REAL*8  EPSX       : Exchange energy density
    ! REAL*8  EPSC       : Correlation energy density
    ! REAL*8  VX(nspin)  : Exchange (spin) potential
    ! REAL*8  VC(nspin)  : Correlation (spin) potential
    ! ********* UNITS ****************************************************
    ! Densities in electrons per Bohr**3
    ! Energies in Hartrees
    ! ********* ROUTINES CALLED ******************************************
    ! EXCHNG, PW92C
    ! ********************************************************************

    use gridxc_precision, only : dp

    INTEGER           IREL, nspin
    real(dp)          Dens(nspin), EPSX, EPSC, VC(nspin), VX(nspin)

    CALL EXCHNG( IREL, nspin, Dens, EPSX, VX )
    CALL PW92C( nspin, Dens, EPSC, VC )
    
  END SUBROUTINE PW92XC



  SUBROUTINE PZXC( IREL, NSP, DS, EX, EC, VX, VC, DVXDN, DVCDN )

    ! *****************************************************************
    !  Perdew-Zunger parameterization of Ceperley-Alder exchange and 
    !  correlation. Ref: Perdew & Zunger, Phys. Rev. B 23 5075 (1981).
    !  Adapted by J.M.Soler from routine velect of Froyen's 
    !    pseudopotential generation program. Madrid, Jan'97.
    ! **** Input *****************************************************
    ! INTEGER IREL    : relativistic-exchange switch (0=no, 1=yes)
    ! INTEGER NSP     : spin-polarizations (1=>unpolarized, 2=>polarized)
    ! REAL*8  DS(NSP) : total (nsp=1) or spin (nsp=2) electron density
    ! **** Output *****************************************************
    ! REAL*8  EX            : exchange energy density
    ! REAL*8  EC            : correlation energy density
    ! REAL*8  VX(NSP)       : (spin-dependent) exchange potential
    ! REAL*8  VC(NSP)       : (spin-dependent) correlation potential
    ! REAL*8  DVXDN(NSP,NSP): Derivative of the exchange potential
    !                         respect the charge density, 
    !                         Dvx(spin1)/Dn(spin2)
    ! REAL*8  DVCDN(NSP,NSP): Derivative of the correlation potential
    !                         respect the charge density, 
    !                         Dvc(spin1)/Dn(spin2)
    ! **** Units *******************************************************
    ! Densities in electrons/Bohr**3
    ! Energies in Hartrees
    ! *****************************************************************

    use gridxc_precision, only: dp

    implicit none

    integer  :: nsp, irel, isp1, isp2, isp
    real(dp) :: DS(NSP), VX(NSP), VC(NSP), &
        DVXDN(NSP,NSP), DVCDN(NSP,NSP)
    real(dp), parameter :: &
        ZERO=0.D0,ONE=1.D0,PFIVE=.5D0,OPF=1.5D0,PNN=.99D0, &
        PTHREE=0.3D0,PSEVF=0.75D0,C0504=0.0504D0, &
        C0254=0.0254D0,C014=0.014D0,C0406=0.0406D0, &
        C15P9=15.9D0,C0666=0.0666D0,C11P4=11.4D0, &
        C045=0.045D0,C7P8=7.8D0,C88=0.88D0,C20P59=20.592D0, &
        C3P52=3.52D0,C0311=0.0311D0,C0014=0.0014D0, &
        C0538=0.0538D0,C0096=0.0096D0,C096=0.096D0, &
        C0622=0.0622D0,C004=0.004D0,C0232=0.0232D0, &
        C1686=0.1686D0,C1P398=1.3981D0,C2611=0.2611D0, &
        C2846=0.2846D0,C1P053=1.0529D0,C3334=0.3334D0

    !    Ceperly-Alder 'ca' constants. Internal energies in Rydbergs.
    real(dp), parameter :: &
        CON1=1.D0/6, CON2=0.008D0/3, CON3=0.3502D0/3, &
        CON4=0.0504D0/3, CON5=0.0028D0/3, CON6=0.1925D0/3, &
        CON7=0.0206D0/3, CON8=9.7867D0/6, CON9=1.0444D0/3, &
        CON10=7.3703D0/6, CON11=1.3336D0/3

    !      X-alpha parameter:
    real(dp), PARAMETER :: ALP = 2.D0 / 3.D0 

    !      Other variables converted into parameters by J.M.Soler
    real(dp), parameter :: &
        TINY = 1.D-6 , &
        PI   = 3.14159265358979312_dp, &
        TWO  = 2.0D0, &
        HALF = 0.5D0, &
        TRD  = 1.D0 / 3.D0, &
        FTRD = 4.D0 / 3.D0, &
        TFTM = 0.51984209978974638D0, &
        A0   = 0.52106176119784808D0, &
        CRS  = 0.620350490899400087D0, &
        CXP  = (- 3.D0) * ALP / (PI*A0), &
        CXF  = 1.25992104989487319D0 

    real(dp)  :: d1, d2, d, z, fz, fzp
    real(dp)  :: ex, ec, dfzpdn, rs, vxp, exp_var
    real(dp)  :: beta, sb, alb, vxf, exf, dvxpdn
    real(dp)  :: dvxfdn, sqrs, te, be, ecp, vcp
    real(dp)  :: dtedn, be2, dbedn, dvcpdn, decpdn
    real(dp)  :: ecf, vcf, dvcfdn, decfdn, rslog


    !      Find density and polarization
    IF (NSP .EQ. 2) THEN
      D1 = MAX(DS(1),ZERO)
      D2 = MAX(DS(2),ZERO)
      D = D1 + D2
      IF (D .LE. ZERO) THEN
        EX = ZERO
        EC = ZERO
        VX(1) = ZERO
        VX(2) = ZERO
        VC(1) = ZERO
        VC(2) = ZERO
        RETURN
      ENDIF
      !
      !        Robustness enhancement by Jose Soler (August 2002)
      !
      Z = (D1 - D2) / D
      IF (Z .LE. -ONE) THEN
        FZ = (TWO**FTRD-TWO)/TFTM
        FZP = -FTRD*TWO**TRD/TFTM
        DFZPDN = FTRD*TRD*TWO**(-ALP)/TFTM
      ELSEIF (Z .GE. ONE) THEN
        FZ = (TWO**FTRD-TWO)/TFTM
        FZP = FTRD*TWO**TRD/TFTM
        DFZPDN = FTRD*TRD*TWO**(-ALP)/TFTM
      ELSE
        FZ = ((ONE+Z)**FTRD+(ONE-Z)**FTRD-TWO)/TFTM
        FZP = FTRD*((ONE+Z)**TRD-(ONE-Z)**TRD)/TFTM 
        DFZPDN = FTRD*TRD*((ONE+Z)**(-ALP) + (ONE-Z)**(-ALP))/TFTM
      ENDIF
    ELSE
      D = DS(1)
      IF (D .LE. ZERO) THEN
        EX = ZERO
        EC = ZERO
        VX(1) = ZERO
        VC(1) = ZERO
        RETURN
      ENDIF
      Z = ZERO
      FZ = ZERO
      FZP = ZERO
    ENDIF
    RS = CRS / D**TRD

    !      Exchange
    VXP = CXP / RS
    EXP_VAR = 0.75D0 * VXP
    IF (IREL .EQ. 1) THEN
      BETA = C014/RS
      IF (BETA .LT. TINY) THEN
        SB = ONE + HALF*BETA**2
        ALB = BETA
      ELSE
        SB = SQRT(1+BETA*BETA)
        ALB = LOG(BETA+SB)
      ENDIF
      VXP = VXP * (-PFIVE + OPF * ALB / (BETA*SB))
      EXP_VAR = EXP_VAR *(ONE-OPF*((BETA*SB-ALB)/BETA**2)**2) 
    ENDIF
    VXF = CXF * VXP
    EXF = CXF * EXP_VAR
    DVXPDN = TRD * VXP / D
    DVXFDN = TRD * VXF / D

    !      Correlation 
    IF (RS .GT. ONE) THEN  
      SQRS=SQRT(RS)
      TE = ONE+CON10*SQRS+CON11*RS
      BE = ONE+C1P053*SQRS+C3334*RS
      ECP = -(C2846/BE)
      VCP = ECP*TE/BE
      DTEDN = ((CON10 * SQRS *HALF) + CON11 * RS)*(-TRD/D)
      BE2 = BE * BE
      DBEDN = ((C1P053 * SQRS *HALF) + C3334 * RS)*(-TRD/D)
      DVCPDN = -(C2846/BE2)*(DTEDN - 2.0D0 * TE * DBEDN/BE)
      DECPDN = (C2846/BE2)*DBEDN
      TE = ONE+CON8*SQRS+CON9*RS
      BE = ONE+C1P398*SQRS+C2611*RS
      ECF = -(C1686/BE)
      VCF = ECF*TE/BE
      DTEDN = ((CON8 * SQRS * HALF) + CON9 * RS)*(-TRD/D)
      BE2 = BE * BE
      DBEDN = ((C1P398 * SQRS * HALF) + C2611 * RS)*(-TRD/D)
      DVCFDN = -(C1686/BE2)*(DTEDN - 2.0D0 * TE * DBEDN/BE)
      DECFDN = (C1686/BE2)*DBEDN
    ELSE
      RSLOG=LOG(RS)
      ECP=(C0622+C004*RS)*RSLOG-C096-C0232*RS
      VCP=(C0622+CON2*RS)*RSLOG-CON3-CON4*RS
      DVCPDN = (CON2*RS*RSLOG + (CON2-CON4)*RS + C0622)*(-TRD/D)
      DECPDN = (C004*RS*RSLOG + (C004-C0232)*RS + C0622)*(-TRD/D)
      ECF=(C0311+C0014*RS)*RSLOG-C0538-C0096*RS
      VCF=(C0311+CON5*RS)*RSLOG-CON6-CON7*RS
      DVCFDN = (CON5*RS*RSLOG + (CON5-CON7)*RS + C0311)*(-TRD/D)
      DECFDN = (C0014*RS*RSLOG + (C0014-C0096)*RS + C0311)*(-TRD/D)
    ENDIF

    ISP1 = 1
    ISP2 = 2

    !      Find up and down potentials
    IF (NSP .EQ. 2) THEN
      EX    = EXP_VAR + FZ*(EXF-EXP_VAR)
      EC    = ECP + FZ*(ECF-ECP)
      VX(1) = VXP + FZ*(VXF-VXP) + (ONE-Z)*FZP*(EXF-EXP_VAR)
      VX(2) = VXP + FZ*(VXF-VXP) - (ONE+Z)*FZP*(EXF-EXP_VAR)
      VC(1) = VCP + FZ*(VCF-VCP) + (ONE-Z)*FZP*(ECF-ECP)
      VC(2) = VCP + FZ*(VCF-VCP) - (ONE+Z)*FZP*(ECF-ECP)

      !        Derivatives of exchange potential respect the density

      DVXDN(ISP1,ISP1) = &
          DVXPDN &
          +  FZP*(VXF-VXP-EXF+EXP_VAR)*( 2.D0*D2/(D*D) ) &
          +  FZ*(DVXFDN-DVXPDN)+(1-Z)*FZP*(VXF-VXP)/(4.D0*D) &
          +  (1-Z)*DFZPDN*(EXF-EXP_VAR)*( 2.D0*D2/(D*D) )
      DVXDN(ISP1,ISP2) = &
          DVXPDN &
          +  FZP*(VXF-VXP-EXF+EXP_VAR)*(-2.D0*D1/(D*D) ) &
          +  FZ*(DVXFDN-DVXPDN)+(1-Z)*FZP*(VXF-VXP)/(4.D0*D) &
          +  (1-Z)*DFZPDN*(EXF-EXP_VAR)*( -2.D0*D1/(D*D) )
      DVXDN(ISP2,ISP1) = &
          DVXPDN &
          +  FZP*(VXF-VXP-EXF+EXP_VAR)*( 2.D0*D2/(D*D) ) &
          +  FZ*(DVXFDN-DVXPDN)-(1+Z)*FZP*(VXF-VXP)/(4.D0*D) &
          -  (1+Z)*DFZPDN*(EXF-EXP_VAR)*( 2.D0*D2/(D*D) )
      DVXDN(ISP2,ISP2) = &
          DVXPDN &
          +  FZP*(VXF-VXP-EXF+EXP_VAR)*(-2.D0*D1/(D*D) ) &
          +  FZ*(DVXFDN-DVXPDN)-(1+Z)*FZP*(VXF-VXP)/(4.D0*D) &
          -  (1+Z)*DFZPDN*(EXF-EXP_VAR)*( -2.D0*D1/(D*D) )

      !        Derivatives of correlation potential respect the density

      DVCDN(ISP1,ISP1) = &
          DVCPDN &
          + FZP*(VCF-VCP-ECF+ECP)*( 2.D0*D2/(D*D) ) &
          + FZ*(DVCFDN-DVCPDN)+ (1-Z)*FZP*(DECFDN-DECPDN) &
          + (1-Z)*DFZPDN*(ECF-ECP)*( 2.D0*D2/(D*D) )
      DVCDN(ISP1,ISP2) = &
          DVCPDN &
          + FZP*(VCF-VCP-ECF+ECP)*(-2.D0*D1/(D*D) ) &
          + FZ*(DVCFDN-DVCPDN)+ (1-Z)*FZP*(DECFDN-DECPDN) &
          + (1-Z)*DFZPDN*(ECF-ECP)*( -2.D0*D1/(D*D) )
      DVCDN(ISP2,ISP1) = &
          DVCPDN &
          + FZP*(VCF-VCP-ECF+ECP)*( 2.D0*D2/(D*D) ) &
          + FZ*(DVCFDN-DVCPDN)- (1+Z)*FZP*(DECFDN-DECPDN) &
          - (1+Z)*DFZPDN*(ECF-ECP)*( 2.D0*D2/(D*D) )
      DVCDN(ISP2,ISP2) = &
          DVCPDN &
          + FZP*(VCF-VCP-ECF+ECP)*(-2.D0*D1/(D*D) ) &
          + FZ*(DVCFDN-DVCPDN)- (1+Z)*FZP*(DECFDN-DECPDN) &
          - (1+Z)*DFZPDN*(ECF-ECP)*( -2.D0*D1/(D*D) )

    ELSE
      EX    = EXP_VAR
      EC    = ECP
      VX(1) = VXP
      VC(1) = VCP
      DVXDN(1,1) = DVXPDN
      DVCDN(1,1) = DVCPDN
    ENDIF

    !      Change from Rydbergs to Hartrees
    EX = HALF * EX
    EC = HALF * EC
    DO ISP = 1,NSP
      VX(ISP) = HALF * VX(ISP)
      VC(ISP) = HALF * VC(ISP)
      DO ISP2 = 1,NSP
        DVXDN(ISP,ISP2) = HALF * DVXDN(ISP,ISP2)
        DVCDN(ISP,ISP2) = HALF * DVCDN(ISP,ISP2)
      end DO
    end DO
  END SUBROUTINE PZXC

END MODULE gridxc_lda

#if defined HAVE_CONFIG_H
#include "config.h"
#endif

!!@LICENSE
!
! *******************************************************************
! MODULE m_minvec
!   Just wraps subroutine minvec
! *******************************************************************
! SUBROUTINE minvec(B0,BMIN,C)
!   FINDS THE LATTICE BASIS OF MINIMUM LENGTH, I.E. SUCH TAHT ANY 
!   OTHER BASIS (NOT EQUIVALENT BY SYMMETRY) HAS ONE VECTOR LONGER.
!   WRITTEN BY J.MORENO AND J.SOLER. AUGUST 1989 AND OCTOBER 1997.
! --------- INPUT ---------------------------------------------------
! REAL*8 B0(3,3)   : Cell vectors B0(xyj,vector)
! --------- OUTPUT --------------------------------------------------
! REAL*8 BMIN(3,3) : Minimum cell vectors B0(xyj,vector)
! REAL*8 C(3,3)    : Transformation matrix: BMIN=MATMUL(B0,C)
! *******************************************************************

MODULE gridxc_minvec

  ! Module procedures:
  USE gridxc_sys,     only: die    ! Termination routine
  USE gridxc_sorting, only: order  ! Orders a vector increasingly
  USE gridxc_sorting, only: ordix  ! Increasing order index of a vector
  USE gridxc_cellsubs,only: reclat ! Reciprocal lattice vectors
  USE gridxc_cellsubs,only: volcel ! Unit cell volume

  ! Module parameters:
  USE gridxc_precision, only: dp   ! Double precision real kind

  implicit none

  ! Public module procedures:
  PUBLIC :: minvec          ! Lattice vectors of minimal length

  ! Public parameters, variables, and arrays:
  !     none

  PRIVATE  ! Nothing is declared public below this point

CONTAINS
  !-------------------------------------------------------------------

  SUBROUTINE minvec(B0,BMIN,C)

    real(dp), intent(in)  ::        B0(3,3)
    real(dp), intent(out) ::        BMIN(3,3)
    real(dp), intent(out) ::        C(3,3)

    integer          I,I1,I2,I3,ITER,J,NITER,IAUX(3)
    real(dp)         AUX(3,3),B(3,3),B2(1,3),BNEW(3),BNEW2, &
        EPS,VNEW,V0

    parameter (EPS=1.D-8,NITER=100)

    V0=ABS(VOLCEL(B0))
    IF (V0.LT.EPS) &
        call die('MINVEC: BASIS VECTORS ARE LINEARLY DEPENDENT')
    DO I=1,3
      DO J=1,3
        B(J,I)=B0(J,I)
      END DO
      B2(1,I)=SUM(B(:,I)**2)
    END DO

    iter_loop: DO ITER=1,NITER
      CALL ORDIX(B2,1,3,IAUX)
      CALL ORDER(B2,1,3,IAUX)
      CALL ORDER(B ,3,3,IAUX)
      DO I1=0,1
        DO I2=-1,1
          i3_loop: DO I3=-1,1
            IF (I1.EQ.0.AND.I2.NE.1) cycle i3_loop
            IF (I2.EQ.0.AND.I3.EQ.0) cycle i3_loop
            BNEW(1)=B(1,1)*I1+B(1,2)*I2+B(1,3)*I3
            BNEW(2)=B(2,1)*I1+B(2,2)*I2+B(2,3)*I3
            BNEW(3)=B(3,1)*I1+B(3,2)*I2+B(3,3)*I3
            BNEW2=SUM(BNEW**2)
            DO I=3,1,-1
              IF (BNEW2+EPS.GE.B2(1,I)) cycle i3_loop
              CALL VOLNEW(B,BNEW,I,VNEW)
              IF (ABS((VNEW-V0)/V0).LT.EPS) THEN
                B(1,I)=BNEW(1)
                B(2,I)=BNEW(2)
                B(3,I)=BNEW(3)
                B2(1,I)=BNEW2
                cycle iter_loop
              END IF
            end do
          end do i3_loop
        end do
      end do
      GOTO 55
    end do iter_loop

    call die('MINVEC: ERROR: Iteration has not converged')

55  CONTINUE

    IF (VOLCEL(B).LT.0.D0) THEN
      B(1,3)=-B(1,3)
      B(2,3)=-B(2,3)
      B(3,3)=-B(3,3)
    ENDIF
    CALL RECLAT(B0,AUX,0)
    DO I=1,3
      DO J=1,3
        C(J,I)=NINT(SUM(AUX(:,J)*B(:,I)))
      ENDDO
    ENDDO
    DO I=1,3
      DO J=1,3
        B(J,I)=B0(J,1)*C(1,I)+B0(J,2)*C(2,I)+B0(J,3)*C(3,I)
      ENDDO
    ENDDO
    DO I=1,3
      DO J=1,3
        BMIN(J,I)=B(J,I)
      ENDDO
    ENDDO

  END SUBROUTINE minvec

  !-------------------------------------------------------------------

  subroutine volnew(A,ANEW,INEW,VOL)
    integer          INEW
    real(dp)         A(3,3),ANEW(3),AUX(3,3),VOL
    AUX(1:3,1:3)=A(1:3,1:3)
    AUX(1:3,INEW)=ANEW(1:3)
    VOL=ABS(VOLCEL(AUX))
  end subroutine volnew

END MODULE gridxc_minvec

#if defined HAVE_CONFIG_H
#include "config.h"
#endif

!     1d fft routine based on Clive Temperton's GPFA package

! Explanation of the module structure:
!
! First come two modules implementing the sp and dp versions of the
! 'gpfa' main routine in Clive Temperton's package. Each exports a
! 'gpfa' interface.

! Then, a wrapper module 'gridxc_fft_gpfa' imports both interfaces and
! re-exports 'gpfa', and also contains the precision-independent parts
! of the GPFA package (setgpfa) and two wrapper routines:
!
!     fft_gpfa
!     fft_gpfa_ez, for packed arrays
!
!     These wrapper routines avoid the explicit use of the 'trigs'
!     twiddle factors argument, which is instead generated as needed.
!
! NOTES for building-system developers:
!
!   While there is only one source file, three* modules need to be accounted for:
!
!      gridxc_fft_gpfa.mod
!      gridxc_gpfa_core_sp.mod
!      gridxc_gpfa_core_dp.mod
!
!   If this is uwieldly, the auxiliary modules could be eliminated, and the code inserted
!   in one big module. In that case, however, all the routines would need to be disambiguated.
!   (For example, gpfa2f --> gpfa2f_sp / gpfa2f_dp)

module gridxc_gpfa_core_sp
  use gridxc_sys, only: die
!
!     1d fft routine based on Clive Temperton's GPFA package
!
! Vectors to be transformed are in SINGLE precision (wp=sp)

  implicit none

! In this module, trigs twiddle factors and intermediate
! variables are kept in double precision.
! (This was the standard approach in Siesta. In other codes the Temperton code
!  is simply converted wholesale to sp or dp)

integer, parameter :: dp = selected_real_kind(10,100)
integer, parameter :: sp = selected_real_kind(6,10)
integer, parameter :: wp = sp

interface gpfa
   module procedure gpfa_
end interface gpfa

public :: gpfa
private

CONTAINS

!--------------------------------------------------------------
!
!  What follows is the original code by Temperton (save setgpfa)
!  with explicit declarations of variables
!
! In this module, trigs twiddle factors and intermediate
! variables are kept in double precision.

!  For arbitrary-precision support the parameter constants might
!  be computed instead of inserted explicitly.
!
!  For example: sin60 = sin(2.0_wp*pi/3.0_wp), where wp is the working
!                       precision, and
!               pi = 4.0_wp * atan(1.0_wp), or
!               twopi = 4.0_wp * asin(1.0_wp)
!
!*********************************************************************

!        SUBROUTINE 'GPFA'
!        SELF-SORTING IN-PLACE GENERALIZED PRIME FACTOR (COMPLEX) FFT
!
!        *** THIS IS THE ALL-FORTRAN VERSION ***
!            -------------------------------
!
!        CALL GPFA(A,B,TRIGS,INC,JUMP,N,LOT,ISIGN)
!
!        A IS FIRST REAL INPUT/OUTPUT VECTOR
!        B IS FIRST IMAGINARY INPUT/OUTPUT VECTOR
!        TRIGS IS A TABLE OF TWIDDLE FACTORS, PRECALCULATED
!              BY CALLING SUBROUTINE 'SETGPFA'
!        INC IS THE INCREMENT WITHIN EACH DATA VECTOR
!        JUMP IS THE INCREMENT BETWEEN DATA VECTORS
!        N IS THE LENGTH OF THE TRANSFORMS:
!          -----------------------------------
!            N = (2**IP) * (3**IQ) * (5**IR)
!          -----------------------------------
!        LOT IS THE NUMBER OF TRANSFORMS
!        ISIGN = +1 FOR FORWARD TRANSFORM
!              = -1 FOR INVERSE TRANSFORM
!
!        WRITTEN BY CLIVE TEMPERTON
!        RECHERCHE EN PREVISION NUMERIQUE
!        ATMOSPHERIC ENVIRONMENT SERVICE, CANADA
!
!----------------------------------------------------------------------
!
!        DEFINITION OF TRANSFORM
!        -----------------------
!
!        X(J) = SUM(K=0,...,N-1)(C(K)*EXP(ISIGN*2*I*J*K*PI/N))
!
!---------------------------------------------------------------------
!
!        FOR A MATHEMATICAL DEVELOPMENT OF THE ALGORITHM USED,
!        SEE:
!
!        C TEMPERTON : "A GENERALIZED PRIME FACTOR FFT ALGORITHM
!          FOR ANY N = (2**P)(3**Q)(5**R)",
!          SIAM J. SCI. STAT. COMP., MAY 1992.
!

SUBROUTINE GPFA_(A,B,TRIGS,INC,JUMP,N,LOT,ISIGN)

IMPLICIT NONE
!
! NOTE: The original declaration of these arguments (here and below)
! was: A(*), B(*)
REAL(wp) ::     A(:), B(:) 
REAL(dp)  TRIGS(*)
INTEGER INC, JUMP, N, LOT, ISIGN
!
INTEGER &
  NJ(3), NN, IFAC, LL, KK, IP, IQ, IR, I

character(len=20) :: msg
!     
!     DECOMPOSE N INTO FACTORS 2,3,5
!     ------------------------------
NN = N
IFAC = 2
!
DO 30 LL = 1 , 3
KK = 0
10 CONTINUE
IF (MOD(NN,IFAC).NE.0) GO TO 20
KK = KK + 1
NN = NN / IFAC
GO TO 10
20 CONTINUE
NJ(LL) = KK
IFAC = IFAC + LL
30 CONTINUE
!
IF (NN.NE.1) THEN
   write(msg,"(i0)") N
   call die('GPFA: '//trim(msg)//' IS NOT A LEGAL VALUE OF N')
ENDIF
!
IP = NJ(1)
IQ = NJ(2)
IR = NJ(3)
!
!     COMPUTE THE TRANSFORM
!     ---------------------
I = 1
IF (IP.GT.0) THEN
   CALL GPFA2F(A,B,TRIGS,INC,JUMP,N,IP,LOT,ISIGN)
   I = I + 2 * ( 2**IP)
ENDIF
IF (IQ.GT.0) THEN
   CALL GPFA3F(A,B,TRIGS(I),INC,JUMP,N,IQ,LOT,ISIGN)
   I = I + 2 * (3**IQ)
ENDIF
IF (IR.GT.0) THEN
   CALL GPFA5F(A,B,TRIGS(I),INC,JUMP,N,IR,LOT,ISIGN)
ENDIF
!
RETURN
END SUBROUTINE GPFA_


!*********************************************************************

!     fortran version of *gpfa2* -
!     radix-2 section of self-sorting, in-place, generalized pfa
!     central radix-2 and radix-8 passes included
!      so that transform length can be any power of 2
!

subroutine gpfa2f(a,b,trigs,inc,jump,n,mm,lot,isign)

real(wp) ::     a(*), b(*)
real(dp)     ::     trigs(*)
integer inc, jump, n, mm, lot, isign

integer  n2, inq, jstepx, ninc, ink, m2, m8, &
         m, mh, nblox, left, istart, nb, nvex, &
         la, mu, ipass, jstep, jstepl, jjj, ja, &
         nu, jb, jc, jd, j, l, kk, k, je, jf, &
         jg, jh, laincl, ll, ji, jj, jk, jl, jm, &
         jn, jo, jp

real(dp) :: s, aja, ajc, t0, t2, ajb, ajd, &
                t1, t3, bja, bjc, u0, u2, bjb, &
                bjd, u1, u3, co1, si1, co2, si2, &
                co3, si3, ss, c1, c2, c3, aje, &
                ajf, ajg, ajh, bje, bjf, bjg, &
                bjh, co4, si4, co5, si5, co6, si6, &
                co7, si7, aji, bjm, ajj, bjj, ajk, &
                ajl, bji, bjk, ajo, bjl, bjo, ajm, &
                ajn, ajp, bjn, bjp

#ifdef OLD_CRAY
integer, parameter :: lvr = CRAY_LVR_PARAMETER
#else
integer, parameter :: lvr = 1024
#endif
!
!     ***************************************************************
!     *                                                             *
!     *  N.B. LVR = LENGTH OF VECTOR REGISTERS, SET TO 128 FOR C90. *
!     *  RESET TO 64 FOR OTHER CRAY MACHINES, OR TO ANY LARGE VALUE *
!     *  (GREATER THAN OR EQUAL TO LOT) FOR A SCALAR COMPUTER.      *
!     *                                                             *
!     ***************************************************************
!
n2 = 2**mm
inq = n/n2
jstepx = (n2-n) * inc
ninc = n * inc
ink = inc * inq
!
m2 = 0
m8 = 0
if (mod(mm,2).eq.0) then
   m = mm/2
else if (mod(mm,4).eq.1) then
   m = (mm-1)/2
   m2 = 1
else if (mod(mm,4).eq.3) then
   m = (mm-3)/2
   m8 = 1
endif
mh = (m+1)/2
!
nblox = 1 + (lot-1)/lvr
left = lot
s = real(isign,kind=dp)
istart = 1
!
!  loop on blocks of lvr transforms
!  --------------------------------
do 500 nb = 1 , nblox
!
if (left.le.lvr) then
   nvex = left
else if (left.lt.(2*lvr)) then
   nvex = left/2
   nvex = nvex + mod(nvex,2)
else
   nvex = lvr
endif
left = left - nvex
!
la = 1
!
!  loop on type I radix-4 passes
!  -----------------------------
mu = mod(inq,4)
if (isign.eq.-1) mu = 4 - mu
ss = 1.0_dp
if (mu.eq.3) ss = -1.0_dp
!
if (mh.eq.0) go to 200
!
do 160 ipass = 1 , mh
jstep = (n*inc) / (4*la)
jstepl = jstep - ninc
!
!  k = 0 loop (no twiddle factors)
!  -------------------------------
do 120 jjj = 0 , (n-1)*inc , 4*jstep
ja = istart + jjj
!
!     "transverse" loop
!     -----------------
do 115 nu = 1 , inq
jb = ja + jstepl
if (jb.lt.istart) jb = jb + ninc
jc = jb + jstepl
if (jc.lt.istart) jc = jc + ninc
jd = jc + jstepl
if (jd.lt.istart) jd = jd + ninc
j = 0
!
!  loop across transforms
!  ----------------------
#ifdef OLD_CRAY
!dir$ ivdep, shortloop
#endif
do 110 l = 1 , nvex
aja = a(ja+j)
ajc = a(jc+j)
t0 = aja + ajc
t2 = aja - ajc
ajb = a(jb+j)
ajd = a(jd+j)
t1 = ajb + ajd
t3 = ss * ( ajb - ajd )
bja = b(ja+j)
bjc = b(jc+j)
u0 = bja + bjc
u2 = bja - bjc
bjb = b(jb+j)
bjd = b(jd+j)
u1 = bjb + bjd
u3 = ss * ( bjb - bjd )
a(ja+j) = t0 + t1
a(jc+j) = t0 - t1
b(ja+j) = u0 + u1
b(jc+j) = u0 - u1
a(jb+j) = t2 - u3
a(jd+j) = t2 + u3
b(jb+j) = u2 + t3
b(jd+j) = u2 - t3
j = j + jump
110 continue
ja = ja + jstepx
if (ja.lt.istart) ja = ja + ninc
115 continue
120 continue
!
!  finished if n2 = 4
!  ------------------
if (n2.eq.4) go to 490
kk = 2 * la
!
!  loop on nonzero k
!  -----------------
do 150 k = ink , jstep-ink , ink
co1 = trigs(kk+1)
si1 = s*trigs(kk+2)
co2 = trigs(2*kk+1)
si2 = s*trigs(2*kk+2)
co3 = trigs(3*kk+1)
si3 = s*trigs(3*kk+2)
!
!  loop along transform
!  --------------------
do 140 jjj = k , (n-1)*inc , 4*jstep
ja = istart + jjj
!
!     "transverse" loop
!     -----------------
do 135 nu = 1 , inq
jb = ja + jstepl
if (jb.lt.istart) jb = jb + ninc
jc = jb + jstepl
if (jc.lt.istart) jc = jc + ninc
jd = jc + jstepl
if (jd.lt.istart) jd = jd + ninc
j = 0
!
!  loop across transforms
!  ----------------------
#ifdef OLD_CRAY
!dir$ ivdep, shortloop
#endif
do 130 l = 1 , nvex
aja = a(ja+j)
ajc = a(jc+j)
t0 = aja + ajc
t2 = aja - ajc
ajb = a(jb+j)
ajd = a(jd+j)
t1 = ajb + ajd
t3 = ss * ( ajb - ajd )
bja = b(ja+j)
bjc = b(jc+j)
u0 = bja + bjc
u2 = bja - bjc
bjb = b(jb+j)
bjd = b(jd+j)
u1 = bjb + bjd
u3 = ss * ( bjb - bjd )
a(ja+j) = t0 + t1
b(ja+j) = u0 + u1
a(jb+j) = co1*(t2-u3) - si1*(u2+t3)
b(jb+j) = si1*(t2-u3) + co1*(u2+t3)
a(jc+j) = co2*(t0-t1) - si2*(u0-u1)
b(jc+j) = si2*(t0-t1) + co2*(u0-u1)
a(jd+j) = co3*(t2+u3) - si3*(u2-t3)
b(jd+j) = si3*(t2+u3) + co3*(u2-t3)
j = j + jump
130 continue
!-----( end of loop across transforms )
ja = ja + jstepx
if (ja.lt.istart) ja = ja + ninc
135 continue
140 continue
!-----( end of loop along transforms )
kk = kk + 2*la
150 continue
!-----( end of loop on nonzero k )
la = 4*la
160 continue
!-----( end of loop on type I radix-4 passes)
!
!  central radix-2 pass
!  --------------------
200 continue
if (m2.eq.0) go to 300
!
jstep = (n*inc) / (2*la)
jstepl = jstep - ninc
!
!  k=0 loop (no twiddle factors)
!  -----------------------------
do 220 jjj = 0 , (n-1)*inc , 2*jstep
ja = istart + jjj
!
!     "transverse" loop
!     -----------------
do 215 nu = 1 , inq
jb = ja + jstepl
if (jb.lt.istart) jb = jb + ninc
j = 0
!
!  loop across transforms
!  ----------------------
#ifdef OLD_CRAY
!dir$ ivdep, shortloop
#endif
do 210 l = 1 , nvex
aja = a(ja+j)
ajb = a(jb+j)
t0 = aja - ajb
a(ja+j) = aja + ajb
a(jb+j) = t0
bja = b(ja+j)
bjb = b(jb+j)
u0 = bja - bjb
b(ja+j) = bja + bjb
b(jb+j) = u0
j = j + jump
210 continue
!-----(end of loop across transforms)
ja = ja + jstepx
if (ja.lt.istart) ja = ja + ninc
215 continue
220 continue
!
!  finished if n2=2
!  ----------------
if (n2.eq.2) go to 490
!
kk = 2 * la
!
!  loop on nonzero k
!  -----------------
do 260 k = ink , jstep - ink , ink
co1 = trigs(kk+1)
si1 = s*trigs(kk+2)
!
!  loop along transforms
!  ---------------------
do 250 jjj = k , (n-1)*inc , 2*jstep
ja = istart + jjj
!
!     "transverse" loop
!     -----------------
do 245 nu = 1 , inq
jb = ja + jstepl
if (jb.lt.istart) jb = jb + ninc
j = 0
!
!  loop across transforms
!  ----------------------
if (kk.eq.n2/2) then
#ifdef OLD_CRAY
!dir$ ivdep, shortloop
#endif
do 230 l = 1 , nvex
aja = a(ja+j)
ajb = a(jb+j)
t0 = ss * ( aja - ajb )
a(ja+j) = aja + ajb
bjb = b(jb+j)
bja = b(ja+j)
a(jb+j) = ss * ( bjb - bja )
b(ja+j) = bja + bjb
b(jb+j) = t0
j = j + jump
230 continue
!
else
!
#ifdef OLD_CRAY
!dir$ ivdep, shortloop
#endif
do 240 l = 1 , nvex
aja = a(ja+j)
ajb = a(jb+j)
t0 = aja - ajb
a(ja+j) = aja + ajb
bja = b(ja+j)
bjb = b(jb+j)
u0 = bja - bjb
b(ja+j) = bja + bjb
a(jb+j) = co1*t0 - si1*u0
b(jb+j) = si1*t0 + co1*u0
j = j + jump
240 continue
!
endif
!
!-----(end of loop across transforms)
ja = ja + jstepx
if (ja.lt.istart) ja = ja + ninc
245 continue
250 continue
!-----(end of loop along transforms)
kk = kk + 2 * la
260 continue
!-----(end of loop on nonzero k)
!-----(end of radix-2 pass)
!
la = 2 * la
go to 400
!
!  central radix-8 pass
!  --------------------
300 continue
if (m8.eq.0) go to 400
jstep = (n*inc) / (8*la)
jstepl = jstep - ninc
mu = mod(inq,8)
if (isign.eq.-1) mu = 8 - mu
c1 = 1.0_dp
if (mu.eq.3.or.mu.eq.7) c1 = -1.0_dp
c2 = sqrt(0.5_dp)
if (mu.eq.3.or.mu.eq.5) c2 = -c2
c3 = c1 * c2
!
!  stage 1
!  -------
do 320 k = 0 , jstep - ink , ink
do 315 jjj = k , (n-1)*inc , 8*jstep
ja = istart + jjj
!
!     "transverse" loop
!     -----------------
do 312 nu = 1 , inq
jb = ja + jstepl
if (jb.lt.istart) jb = jb + ninc
jc = jb + jstepl
if (jc.lt.istart) jc = jc + ninc
jd = jc + jstepl
if (jd.lt.istart) jd = jd + ninc
je = jd + jstepl
if (je.lt.istart) je = je + ninc
jf = je + jstepl
if (jf.lt.istart) jf = jf + ninc
jg = jf + jstepl
if (jg.lt.istart) jg = jg + ninc
jh = jg + jstepl
if (jh.lt.istart) jh = jh + ninc
j = 0
#ifdef OLD_CRAY
!dir$ ivdep, shortloop
#endif
do 310 l = 1 , nvex
aja = a(ja+j)
aje = a(je+j)
t0 = aja - aje
a(ja+j) = aja + aje
ajc = a(jc+j)
ajg = a(jg+j)
t1 = c1 * ( ajc - ajg )
a(je+j) = ajc + ajg
ajb = a(jb+j)
ajf = a(jf+j)
t2 = ajb - ajf
a(jc+j) = ajb + ajf
ajd = a(jd+j)
ajh = a(jh+j)
t3 = ajd - ajh
a(jg+j) = ajd + ajh
a(jb+j) = t0
a(jf+j) = t1
a(jd+j) = c2 * ( t2 - t3 )
a(jh+j) = c3 * ( t2 + t3 )
bja = b(ja+j)
bje = b(je+j)
u0 = bja - bje
b(ja+j) = bja + bje
bjc = b(jc+j)
bjg = b(jg+j)
u1 = c1 * ( bjc - bjg )
b(je+j) = bjc + bjg
bjb = b(jb+j)
bjf = b(jf+j)
u2 = bjb - bjf
b(jc+j) = bjb + bjf
bjd = b(jd+j)
bjh = b(jh+j)
u3 = bjd - bjh
b(jg+j) = bjd + bjh
b(jb+j) = u0
b(jf+j) = u1
b(jd+j) = c2 * ( u2 - u3 )
b(jh+j) = c3 * ( u2 + u3 )
j = j + jump
310 continue
ja = ja + jstepx
if (ja.lt.istart) ja = ja + ninc
312 continue
315 continue
320 continue
!
!  stage 2
!  -------
!
!  k=0 (no twiddle factors)
!  ------------------------
do 330 jjj = 0 , (n-1)*inc , 8*jstep
ja = istart + jjj
!
!     "transverse" loop
!     -----------------
do 328 nu = 1 , inq
jb = ja + jstepl
if (jb.lt.istart) jb = jb + ninc
jc = jb + jstepl
if (jc.lt.istart) jc = jc + ninc
jd = jc + jstepl
if (jd.lt.istart) jd = jd + ninc
je = jd + jstepl
if (je.lt.istart) je = je + ninc
jf = je + jstepl
if (jf.lt.istart) jf = jf + ninc
jg = jf + jstepl
if (jg.lt.istart) jg = jg + ninc
jh = jg + jstepl
if (jh.lt.istart) jh = jh + ninc
j = 0
#ifdef OLD_CRAY
!dir$ ivdep, shortloop
#endif
do 325 l = 1 , nvex
aja = a(ja+j)
aje = a(je+j)
t0 = aja + aje
t2 = aja - aje
ajc = a(jc+j)
ajg = a(jg+j)
t1 = ajc + ajg
t3 = c1 * ( ajc - ajg )
bja = b(ja+j)
bje = b(je+j)
u0 = bja + bje
u2 = bja - bje
bjc = b(jc+j)
bjg = b(jg+j)
u1 = bjc + bjg
u3 = c1 * ( bjc - bjg )
a(ja+j) = t0 + t1
a(je+j) = t0 - t1
b(ja+j) = u0 + u1
b(je+j) = u0 - u1
a(jc+j) = t2 - u3
a(jg+j) = t2 + u3
b(jc+j) = u2 + t3
b(jg+j) = u2 - t3
ajb = a(jb+j)
ajd = a(jd+j)
t0 = ajb + ajd
t2 = ajb - ajd
ajf = a(jf+j)
ajh = a(jh+j)
t1 = ajf - ajh
t3 = ajf + ajh
bjb = b(jb+j)
bjd = b(jd+j)
u0 = bjb + bjd
u2 = bjb - bjd
bjf = b(jf+j)
bjh = b(jh+j)
u1 = bjf - bjh
u3 = bjf + bjh
a(jb+j) = t0 - u3
a(jh+j) = t0 + u3
b(jb+j) = u0 + t3
b(jh+j) = u0 - t3
a(jd+j) = t2 + u1
a(jf+j) = t2 - u1
b(jd+j) = u2 - t1
b(jf+j) = u2 + t1
j = j + jump
325 continue
ja = ja + jstepx
if (ja.lt.istart) ja = ja + ninc
328 continue
330 continue
!
if (n2.eq.8) go to 490
!
!  loop on nonzero k
!  -----------------
kk = 2 * la
!
do 350 k = ink , jstep - ink , ink
!
co1 = trigs(kk+1)
si1 = s * trigs(kk+2)
co2 = trigs(2*kk+1)
si2 = s * trigs(2*kk+2)
co3 = trigs(3*kk+1)
si3 = s * trigs(3*kk+2)
co4 = trigs(4*kk+1)
si4 = s * trigs(4*kk+2)
co5 = trigs(5*kk+1)
si5 = s * trigs(5*kk+2)
co6 = trigs(6*kk+1)
si6 = s * trigs(6*kk+2)
co7 = trigs(7*kk+1)
si7 = s * trigs(7*kk+2)
!
do 345 jjj = k , (n-1)*inc , 8*jstep
ja = istart + jjj
!
!     "transverse" loop
!     -----------------
do 342 nu = 1 , inq
jb = ja + jstepl
if (jb.lt.istart) jb = jb + ninc
jc = jb + jstepl
if (jc.lt.istart) jc = jc + ninc
jd = jc + jstepl
if (jd.lt.istart) jd = jd + ninc
je = jd + jstepl
if (je.lt.istart) je = je + ninc
jf = je + jstepl
if (jf.lt.istart) jf = jf + ninc
jg = jf + jstepl
if (jg.lt.istart) jg = jg + ninc
jh = jg + jstepl
if (jh.lt.istart) jh = jh + ninc
j = 0
#ifdef OLD_CRAY
!dir$ ivdep, shortloop
#endif
do 340 l = 1 , nvex
aja = a(ja+j)
aje = a(je+j)
t0 = aja + aje
t2 = aja - aje
ajc = a(jc+j)
ajg = a(jg+j)
t1 = ajc + ajg
t3 = c1 * ( ajc - ajg )
bja = b(ja+j)
bje = b(je+j)
u0 = bja + bje
u2 = bja - bje
bjc = b(jc+j)
bjg = b(jg+j)
u1 = bjc + bjg
u3 = c1 * ( bjc - bjg )
a(ja+j) = t0 + t1
b(ja+j) = u0 + u1
a(je+j) = co4*(t0-t1) - si4*(u0-u1)
b(je+j) = si4*(t0-t1) + co4*(u0-u1)
a(jc+j) = co2*(t2-u3) - si2*(u2+t3)
b(jc+j) = si2*(t2-u3) + co2*(u2+t3)
a(jg+j) = co6*(t2+u3) - si6*(u2-t3)
b(jg+j) = si6*(t2+u3) + co6*(u2-t3)
ajb = a(jb+j)
ajd = a(jd+j)
t0 = ajb + ajd
t2 = ajb - ajd
ajf = a(jf+j)
ajh = a(jh+j)
t1 = ajf - ajh
t3 = ajf + ajh
bjb = b(jb+j)
bjd = b(jd+j)
u0 = bjb + bjd
u2 = bjb - bjd
bjf = b(jf+j)
bjh = b(jh+j)
u1 = bjf - bjh
u3 = bjf + bjh
a(jb+j) = co1*(t0-u3) - si1*(u0+t3)
b(jb+j) = si1*(t0-u3) + co1*(u0+t3)
a(jh+j) = co7*(t0+u3) - si7*(u0-t3)
b(jh+j) = si7*(t0+u3) + co7*(u0-t3)
a(jd+j) = co3*(t2+u1) - si3*(u2-t1)
b(jd+j) = si3*(t2+u1) + co3*(u2-t1)
a(jf+j) = co5*(t2-u1) - si5*(u2+t1)
b(jf+j) = si5*(t2-u1) + co5*(u2+t1)
j = j + jump
340 continue
ja = ja + jstepx
if (ja.lt.istart) ja = ja + ninc
342 continue
345 continue
kk = kk + 2 * la
350 continue
!
la = 8 * la
!
!  loop on type II radix-4 passes
!  ------------------------------
400 continue
mu = mod(inq,4)
if (isign.eq.-1) mu = 4 - mu
ss = 1.0_dp
if (mu.eq.3) ss = -1.0_dp
!
do 480 ipass = mh+1 , m
jstep = (n*inc) / (4*la)
jstepl = jstep - ninc
laincl = la * ink - ninc
!
!  k=0 loop (no twiddle factors)
!  -----------------------------
do 430 ll = 0 , (la-1)*ink , 4*jstep
!
do 420 jjj = ll , (n-1)*inc , 4*la*ink
ja = istart + jjj
!
!     "transverse" loop
!     -----------------
do 415 nu = 1 , inq
jb = ja + jstepl
if (jb.lt.istart) jb = jb + ninc
jc = jb + jstepl
if (jc.lt.istart) jc = jc + ninc
jd = jc + jstepl
if (jd.lt.istart) jd = jd + ninc
je = ja + laincl
if (je.lt.istart) je = je + ninc
jf = je + jstepl
if (jf.lt.istart) jf = jf + ninc
jg = jf + jstepl
if (jg.lt.istart) jg = jg + ninc
jh = jg + jstepl
if (jh.lt.istart) jh = jh + ninc
ji = je + laincl
if (ji.lt.istart) ji = ji + ninc
jj = ji + jstepl
if (jj.lt.istart) jj = jj + ninc
jk = jj + jstepl
if (jk.lt.istart) jk = jk + ninc
jl = jk + jstepl
if (jl.lt.istart) jl = jl + ninc
jm = ji + laincl
if (jm.lt.istart) jm = jm + ninc
jn = jm + jstepl
if (jn.lt.istart) jn = jn + ninc
jo = jn + jstepl
if (jo.lt.istart) jo = jo + ninc
jp = jo + jstepl
if (jp.lt.istart) jp = jp + ninc
j = 0
!
!  loop across transforms
!  ----------------------
#ifdef OLD_CRAY
!dir$ ivdep, shortloop
#endif
do 410 l = 1 , nvex
aja = a(ja+j)
ajc = a(jc+j)
t0 = aja + ajc
t2 = aja - ajc
ajb = a(jb+j)
ajd = a(jd+j)
t1 = ajb + ajd
t3 = ss * ( ajb - ajd )
aji = a(ji+j)
ajc =  aji
bja = b(ja+j)
bjc = b(jc+j)
u0 = bja + bjc
u2 = bja - bjc
bjb = b(jb+j)
bjd = b(jd+j)
u1 = bjb + bjd
u3 = ss * ( bjb - bjd )
aje = a(je+j)
ajb =  aje
a(ja+j) = t0 + t1
a(ji+j) = t0 - t1
b(ja+j) = u0 + u1
bjc =  u0 - u1
bjm = b(jm+j)
bjd =  bjm
a(je+j) = t2 - u3
ajd =  t2 + u3
bjb =  u2 + t3
b(jm+j) = u2 - t3
!----------------------
ajg = a(jg+j)
t0 = ajb + ajg
t2 = ajb - ajg
ajf = a(jf+j)
ajh = a(jh+j)
t1 = ajf + ajh
t3 = ss * ( ajf - ajh )
ajj = a(jj+j)
ajg =  ajj
bje = b(je+j)
bjg = b(jg+j)
u0 = bje + bjg
u2 = bje - bjg
bjf = b(jf+j)
bjh = b(jh+j)
u1 = bjf + bjh
u3 = ss * ( bjf - bjh )
b(je+j) = bjb
a(jb+j) = t0 + t1
a(jj+j) = t0 - t1
bjj = b(jj+j)
bjg =  bjj
b(jb+j) = u0 + u1
b(jj+j) = u0 - u1
a(jf+j) = t2 - u3
ajh =  t2 + u3
b(jf+j) = u2 + t3
bjh =  u2 - t3
!----------------------
ajk = a(jk+j)
t0 = ajc + ajk
t2 = ajc - ajk
ajl = a(jl+j)
t1 = ajg + ajl
t3 = ss * ( ajg - ajl )
bji = b(ji+j)
bjk = b(jk+j)
u0 = bji + bjk
u2 = bji - bjk
ajo = a(jo+j)
ajl =  ajo
bjl = b(jl+j)
u1 = bjg + bjl
u3 = ss * ( bjg - bjl )
b(ji+j) = bjc
a(jc+j) = t0 + t1
a(jk+j) = t0 - t1
bjo = b(jo+j)
bjl =  bjo
b(jc+j) = u0 + u1
b(jk+j) = u0 - u1
a(jg+j) = t2 - u3
a(jo+j) = t2 + u3
b(jg+j) = u2 + t3
b(jo+j) = u2 - t3
!----------------------
ajm = a(jm+j)
t0 = ajm + ajl
t2 = ajm - ajl
ajn = a(jn+j)
ajp = a(jp+j)
t1 = ajn + ajp
t3 = ss * ( ajn - ajp )
a(jm+j) = ajd
u0 = bjd + bjl
u2 = bjd - bjl
bjn = b(jn+j)
bjp = b(jp+j)
u1 = bjn + bjp
u3 = ss * ( bjn - bjp )
a(jn+j) = ajh
a(jd+j) = t0 + t1
a(jl+j) = t0 - t1
b(jd+j) = u0 + u1
b(jl+j) = u0 - u1
b(jn+j) = bjh
a(jh+j) = t2 - u3
a(jp+j) = t2 + u3
b(jh+j) = u2 + t3
b(jp+j) = u2 - t3
j = j + jump
410 continue
!-----( end of loop across transforms )
ja = ja + jstepx
if (ja.lt.istart) ja = ja + ninc
415 continue
420 continue
430 continue
!-----( end of double loop for k=0 )
!
!  finished if last pass
!  ---------------------
if (ipass.eq.m) go to 490
!
kk = 2*la
!
!     loop on nonzero k
!     -----------------
do 470 k = ink , jstep-ink , ink
co1 = trigs(kk+1)
si1 = s*trigs(kk+2)
co2 = trigs(2*kk+1)
si2 = s*trigs(2*kk+2)
co3 = trigs(3*kk+1)
si3 = s*trigs(3*kk+2)
!
!  double loop along first transform in block
!  ------------------------------------------
do 460 ll = k , (la-1)*ink , 4*jstep
!
do 450 jjj = ll , (n-1)*inc , 4*la*ink
ja = istart + jjj
!
!     "transverse" loop
!     -----------------
do 445 nu = 1 , inq
jb = ja + jstepl
if (jb.lt.istart) jb = jb + ninc
jc = jb + jstepl
if (jc.lt.istart) jc = jc + ninc
jd = jc + jstepl
if (jd.lt.istart) jd = jd + ninc
je = ja + laincl
if (je.lt.istart) je = je + ninc
jf = je + jstepl
if (jf.lt.istart) jf = jf + ninc
jg = jf + jstepl
if (jg.lt.istart) jg = jg + ninc
jh = jg + jstepl
if (jh.lt.istart) jh = jh + ninc
ji = je + laincl
if (ji.lt.istart) ji = ji + ninc
jj = ji + jstepl
if (jj.lt.istart) jj = jj + ninc
jk = jj + jstepl
if (jk.lt.istart) jk = jk + ninc
jl = jk + jstepl
if (jl.lt.istart) jl = jl + ninc
jm = ji + laincl
if (jm.lt.istart) jm = jm + ninc
jn = jm + jstepl
if (jn.lt.istart) jn = jn + ninc
jo = jn + jstepl
if (jo.lt.istart) jo = jo + ninc
jp = jo + jstepl
if (jp.lt.istart) jp = jp + ninc
j = 0
!
!  loop across transforms
!  ----------------------
#ifdef OLD_CRAY
!dir$ ivdep, shortloop
#endif
do 440 l = 1 , nvex
aja = a(ja+j)
ajc = a(jc+j)
t0 = aja + ajc
t2 = aja - ajc
ajb = a(jb+j)
ajd = a(jd+j)
t1 = ajb + ajd
t3 = ss * ( ajb - ajd )
aji = a(ji+j)
ajc =  aji
bja = b(ja+j)
bjc = b(jc+j)
u0 = bja + bjc
u2 = bja - bjc
bjb = b(jb+j)
bjd = b(jd+j)
u1 = bjb + bjd
u3 = ss * ( bjb - bjd )
aje = a(je+j)
ajb =  aje
a(ja+j) = t0 + t1
b(ja+j) = u0 + u1
a(je+j) = co1*(t2-u3) - si1*(u2+t3)
bjb =  si1*(t2-u3) + co1*(u2+t3)
bjm = b(jm+j)
bjd =  bjm
a(ji+j) = co2*(t0-t1) - si2*(u0-u1)
bjc =  si2*(t0-t1) + co2*(u0-u1)
ajd =  co3*(t2+u3) - si3*(u2-t3)
b(jm+j) = si3*(t2+u3) + co3*(u2-t3)
!----------------------------------------
ajg = a(jg+j)
t0 = ajb + ajg
t2 = ajb - ajg
ajf = a(jf+j)
ajh = a(jh+j)
t1 = ajf + ajh
t3 = ss * ( ajf - ajh )
ajj = a(jj+j)
ajg =  ajj
bje = b(je+j)
bjg = b(jg+j)
u0 = bje + bjg
u2 = bje - bjg
bjf = b(jf+j)
bjh = b(jh+j)
u1 = bjf + bjh
u3 = ss * ( bjf - bjh )
b(je+j) = bjb
a(jb+j) = t0 + t1
b(jb+j) = u0 + u1
bjj = b(jj+j)
bjg =  bjj
a(jf+j) = co1*(t2-u3) - si1*(u2+t3)
b(jf+j) = si1*(t2-u3) + co1*(u2+t3)
a(jj+j) = co2*(t0-t1) - si2*(u0-u1)
b(jj+j) = si2*(t0-t1) + co2*(u0-u1)
ajh =  co3*(t2+u3) - si3*(u2-t3)
bjh =  si3*(t2+u3) + co3*(u2-t3)
!----------------------------------------
ajk = a(jk+j)
t0 = ajc + ajk
t2 = ajc - ajk
ajl = a(jl+j)
t1 = ajg + ajl
t3 = ss * ( ajg - ajl )
bji = b(ji+j)
bjk = b(jk+j)
u0 = bji + bjk
u2 = bji - bjk
ajo = a(jo+j)
ajl =  ajo
bjl = b(jl+j)
u1 = bjg + bjl
u3 = ss * ( bjg - bjl )
b(ji+j) = bjc
a(jc+j) = t0 + t1
b(jc+j) = u0 + u1
bjo = b(jo+j)
bjl =  bjo
a(jg+j) = co1*(t2-u3) - si1*(u2+t3)
b(jg+j) = si1*(t2-u3) + co1*(u2+t3)
a(jk+j) = co2*(t0-t1) - si2*(u0-u1)
b(jk+j) = si2*(t0-t1) + co2*(u0-u1)
a(jo+j) = co3*(t2+u3) - si3*(u2-t3)
b(jo+j) = si3*(t2+u3) + co3*(u2-t3)
!----------------------------------------
ajm = a(jm+j)
t0 = ajm + ajl
t2 = ajm - ajl
ajn = a(jn+j)
ajp = a(jp+j)
t1 = ajn + ajp
t3 = ss * ( ajn - ajp )
a(jm+j) = ajd
u0 = bjd + bjl
u2 = bjd - bjl
a(jn+j) = ajh
bjn = b(jn+j)
bjp = b(jp+j)
u1 = bjn + bjp
u3 = ss * ( bjn - bjp )
b(jn+j) = bjh
a(jd+j) = t0 + t1
b(jd+j) = u0 + u1
a(jh+j) = co1*(t2-u3) - si1*(u2+t3)
b(jh+j) = si1*(t2-u3) + co1*(u2+t3)
a(jl+j) = co2*(t0-t1) - si2*(u0-u1)
b(jl+j) = si2*(t0-t1) + co2*(u0-u1)
a(jp+j) = co3*(t2+u3) - si3*(u2-t3)
b(jp+j) = si3*(t2+u3) + co3*(u2-t3)
j = j + jump
440 continue
!-----(end of loop across transforms)
ja = ja + jstepx
if (ja.lt.istart) ja = ja + ninc
445 continue
450 continue
460 continue
!-----( end of double loop for this k )
kk = kk + 2*la
470 continue
!-----( end of loop over values of k )
la = 4*la
480 continue
!-----( end of loop on type II radix-4 passes )
!-----( nvex transforms completed)
490 continue
istart = istart + nvex * jump
500 continue
!-----( end of loop on blocks of transforms )
!
return
end subroutine gpfa2f

!******************************************************************

!     fortran version of *gpfa3* -
!     radix-3 section of self-sorting, in-place
!        generalized PFA
!
!-------------------------------------------------------------------
!
subroutine gpfa3f(a,b,trigs,inc,jump,n,mm,lot,isign)

real(wp) ::     a(*), b(*)
real(dp)     ::     trigs(*)
integer inc, jump, n, mm, lot, isign

real(dp), parameter :: sin60 = 0.866025403784437_dp

integer      :: je, jf, jg, jh, laincl, ll, ji
integer      :: n3, inq, jstepx, ninc, ink, mu, m, mh, &
                nblox, left, istart, nb, nvex, la, &
                ipass, jstep, jstepl, jjj, ja, nu, jb, &
                jc, j, l, kk, k, jd

real(dp) :: s, ajb, ajc, t1, aja, t2, t3, bjb, bjc, &
                u1, bja, u2, u3, co1, si1, co2, si2, ajd, &
                bjd
real(dp) :: c1, aje, ajg, ajf, ajh, bje, &
                bjf, bjg, bjh, aji, bji


integer, parameter :: lvr = 128
!
!     ***************************************************************
!     *                                                             *
!     *  N.B. LVR = LENGTH OF VECTOR REGISTERS, SET TO 128 FOR C90. *
!     *  RESET TO 64 FOR OTHER CRAY MACHINES, OR TO ANY LARGE VALUE *
!     *  (GREATER THAN OR EQUAL TO LOT) FOR A SCALAR COMPUTER.      *
!     *                                                             *
!     ***************************************************************
!
n3 = 3**mm
inq = n/n3
jstepx = (n3-n) * inc
ninc = n * inc
ink = inc * inq
mu = mod(inq,3)
if (isign.eq.-1) mu = 3-mu
m = mm
mh = (m+1)/2
s = real(isign,kind=dp)
c1 = sin60
if (mu.eq.2) c1 = -c1
!
nblox = 1 + (lot-1)/lvr
left = lot
s = real(isign,kind=dp)
istart = 1
!
!  loop on blocks of lvr transforms
!  --------------------------------
do 500 nb = 1 , nblox
!
if (left.le.lvr) then
   nvex = left
else if (left.lt.(2*lvr)) then
   nvex = left/2
   nvex = nvex + mod(nvex,2)
else
   nvex = lvr
endif
left = left - nvex
!
la = 1
!
!  loop on type I radix-3 passes
!  -----------------------------
do 160 ipass = 1 , mh
jstep = (n*inc) / (3*la)
jstepl = jstep - ninc
!
!  k = 0 loop (no twiddle factors)
!  -------------------------------
do 120 jjj = 0 , (n-1)*inc , 3*jstep
ja = istart + jjj
!
!  "transverse" loop
!  -----------------
do 115 nu = 1 , inq
jb = ja + jstepl
if (jb.lt.istart) jb = jb + ninc
jc = jb + jstepl
if (jc.lt.istart) jc = jc + ninc
j = 0
!
!  loop across transforms
!  ----------------------
#ifdef OLD_CRAY
!dir$ ivdep, shortloop
#endif
do 110 l = 1 , nvex
ajb = a(jb+j)
ajc = a(jc+j)
t1 = ajb + ajc
aja = a(ja+j)
t2 = aja - 0.5_dp * t1
t3 = c1 * ( ajb - ajc )
bjb = b(jb+j)
bjc = b(jc+j)
u1 = bjb + bjc
bja = b(ja+j)
u2 = bja - 0.5_dp * u1
u3 = c1 * ( bjb - bjc )
a(ja+j) = aja + t1
b(ja+j) = bja + u1
a(jb+j) = t2 - u3
b(jb+j) = u2 + t3
a(jc+j) = t2 + u3
b(jc+j) = u2 - t3
j = j + jump
110 continue
ja = ja + jstepx
if (ja.lt.istart) ja = ja + ninc
115 continue
120 continue
!
!  finished if n3 = 3
!  ------------------
if (n3.eq.3) go to 490
kk = 2 * la
!
!  loop on nonzero k
!  -----------------
do 150 k = ink , jstep-ink , ink
co1 = trigs(kk+1)
si1 = s*trigs(kk+2)
co2 = trigs(2*kk+1)
si2 = s*trigs(2*kk+2)
!
!  loop along transform
!  --------------------
do 140 jjj = k , (n-1)*inc , 3*jstep
ja = istart + jjj
!
!  "transverse" loop
!  -----------------
do 135 nu = 1 , inq
jb = ja + jstepl
if (jb.lt.istart) jb = jb + ninc
jc = jb + jstepl
if (jc.lt.istart) jc = jc + ninc
j = 0
!
!  loop across transforms
!  ----------------------
#ifdef OLD_CRAY
!dir$ ivdep, shortloop
#endif
do 130 l = 1 , nvex
ajb = a(jb+j)
ajc = a(jc+j)
t1 = ajb + ajc
aja = a(ja+j)
t2 = aja - 0.5_dp * t1
t3 = c1 * ( ajb - ajc )
bjb = b(jb+j)
bjc = b(jc+j)
u1 = bjb + bjc
bja = b(ja+j)
u2 = bja - 0.5_dp * u1
u3 = c1 * ( bjb - bjc )
a(ja+j) = aja + t1
b(ja+j) = bja + u1
a(jb+j) = co1*(t2-u3) - si1*(u2+t3)
b(jb+j) = si1*(t2-u3) + co1*(u2+t3)
a(jc+j) = co2*(t2+u3) - si2*(u2-t3)
b(jc+j) = si2*(t2+u3) + co2*(u2-t3)
j = j + jump
130 continue
!-----( end of loop across transforms )
ja = ja + jstepx
if (ja.lt.istart) ja = ja + ninc
135 continue
140 continue
!-----( end of loop along transforms )
kk = kk + 2*la
150 continue
!-----( end of loop on nonzero k )
la = 3*la
160 continue
!-----( end of loop on type I radix-3 passes)
!
!  loop on type II radix-3 passes
!  ------------------------------
400 continue
!
do 480 ipass = mh+1 , m
jstep = (n*inc) / (3*la)
jstepl = jstep - ninc
laincl = la*ink - ninc
!
!  k=0 loop (no twiddle factors)
!  -----------------------------
do 430 ll = 0 , (la-1)*ink , 3*jstep
!
do 420 jjj = ll , (n-1)*inc , 3*la*ink
ja = istart + jjj
!
!  "transverse" loop
!  -----------------
do 415 nu = 1 , inq
jb = ja + jstepl
if (jb.lt.istart) jb = jb + ninc
jc = jb + jstepl
if (jc.lt.istart) jc = jc + ninc
jd = ja + laincl
if (jd.lt.istart) jd = jd + ninc
je = jd + jstepl
if (je.lt.istart) je = je + ninc
jf = je + jstepl
if (jf.lt.istart) jf = jf + ninc
jg = jd + laincl
if (jg.lt.istart) jg = jg + ninc
jh = jg + jstepl
if (jh.lt.istart) jh = jh + ninc
ji = jh + jstepl
if (ji.lt.istart) ji = ji + ninc
j = 0
!
!  loop across transforms
!  ----------------------
#ifdef OLD_CRAY
!dir$ ivdep, shortloop
#endif
do 410 l = 1 , nvex
ajb = a(jb+j)
ajc = a(jc+j)
t1 = ajb + ajc
aja = a(ja+j)
t2 = aja - 0.5_dp * t1
t3 = c1 * ( ajb - ajc )
ajd = a(jd+j)
ajb =  ajd
bjb = b(jb+j)
bjc = b(jc+j)
u1 = bjb + bjc
bja = b(ja+j)
u2 = bja - 0.5_dp * u1
u3 = c1 * ( bjb - bjc )
bjd = b(jd+j)
bjb =  bjd
a(ja+j) = aja + t1
b(ja+j) = bja + u1
a(jd+j) = t2 - u3
b(jd+j) = u2 + t3
ajc =  t2 + u3
bjc =  u2 - t3
!----------------------
aje = a(je+j)
ajf = a(jf+j)
t1 = aje + ajf
t2 = ajb - 0.5_dp * t1
t3 = c1 * ( aje - ajf )
ajh = a(jh+j)
ajf =  ajh
bje = b(je+j)
bjf = b(jf+j)
u1 = bje + bjf
u2 = bjb - 0.5_dp * u1
u3 = c1 * ( bje - bjf )
bjh = b(jh+j)
bjf =  bjh
a(jb+j) = ajb + t1
b(jb+j) = bjb + u1
a(je+j) = t2 - u3
b(je+j) = u2 + t3
a(jh+j) = t2 + u3
b(jh+j) = u2 - t3
!----------------------
aji = a(ji+j)
t1 = ajf + aji
ajg = a(jg+j)
t2 = ajg - 0.5_dp * t1
t3 = c1 * ( ajf - aji )
t1 = ajg + t1
a(jg+j) = ajc
bji = b(ji+j)
u1 = bjf + bji
bjg = b(jg+j)
u2 = bjg - 0.5_dp * u1
u3 = c1 * ( bjf - bji )
u1 = bjg + u1
b(jg+j) = bjc
a(jc+j) = t1
b(jc+j) = u1
a(jf+j) = t2 - u3
b(jf+j) = u2 + t3
a(ji+j) = t2 + u3
b(ji+j) = u2 - t3
j = j + jump
410 continue
!-----( end of loop across transforms )
ja = ja + jstepx
if (ja.lt.istart) ja = ja + ninc
415 continue
420 continue
430 continue
!-----( end of double loop for k=0 )
!
!  finished if last pass
!  ---------------------
if (ipass.eq.m) go to 490
!
kk = 2*la
!
!     loop on nonzero k
!     -----------------
do 470 k = ink , jstep-ink , ink
co1 = trigs(kk+1)
si1 = s*trigs(kk+2)
co2 = trigs(2*kk+1)
si2 = s*trigs(2*kk+2)
!
!  double loop along first transform in block
!  ------------------------------------------
do 460 ll = k , (la-1)*ink , 3*jstep
!
do 450 jjj = ll , (n-1)*inc , 3*la*ink
ja = istart + jjj
!
!  "transverse" loop
!  -----------------
do 445 nu = 1 , inq
jb = ja + jstepl
if (jb.lt.istart) jb = jb + ninc
jc = jb + jstepl
if (jc.lt.istart) jc = jc + ninc
jd = ja + laincl
if (jd.lt.istart) jd = jd + ninc
je = jd + jstepl
if (je.lt.istart) je = je + ninc
jf = je + jstepl
if (jf.lt.istart) jf = jf + ninc
jg = jd + laincl
if (jg.lt.istart) jg = jg + ninc
jh = jg + jstepl
if (jh.lt.istart) jh = jh + ninc
ji = jh + jstepl
if (ji.lt.istart) ji = ji + ninc
j = 0
!
!  loop across transforms
!  ----------------------
#ifdef OLD_CRAY
!dir$ ivdep, shortloop
#endif
do 440 l = 1 , nvex
ajb = a(jb+j)
ajc = a(jc+j)
t1 = ajb + ajc
aja = a(ja+j)
t2 = aja - 0.5_dp * t1
t3 = c1 * ( ajb - ajc )
ajd = a(jd+j)
ajb =  ajd
bjb = b(jb+j)
bjc = b(jc+j)
u1 = bjb + bjc
bja = b(ja+j)
u2 = bja - 0.5_dp * u1
u3 = c1 * ( bjb - bjc )
bjd = b(jd+j)
bjb =  bjd
a(ja+j) = aja + t1
b(ja+j) = bja + u1
a(jd+j) = co1*(t2-u3) - si1*(u2+t3)
b(jd+j) = si1*(t2-u3) + co1*(u2+t3)
ajc =  co2*(t2+u3) - si2*(u2-t3)
bjc =  si2*(t2+u3) + co2*(u2-t3)
!----------------------
aje = a(je+j)
ajf = a(jf+j)
t1 = aje + ajf
t2 = ajb - 0.5_dp * t1
t3 = c1 * ( aje - ajf )
ajh = a(jh+j)
ajf =  ajh
bje = b(je+j)
bjf = b(jf+j)
u1 = bje + bjf
u2 = bjb - 0.5_dp * u1
u3 = c1 * ( bje - bjf )
bjh = b(jh+j)
bjf =  bjh
a(jb+j) = ajb + t1
b(jb+j) = bjb + u1
a(je+j) = co1*(t2-u3) - si1*(u2+t3)
b(je+j) = si1*(t2-u3) + co1*(u2+t3)
a(jh+j) = co2*(t2+u3) - si2*(u2-t3)
b(jh+j) = si2*(t2+u3) + co2*(u2-t3)
!----------------------
aji = a(ji+j)
t1 = ajf + aji
ajg = a(jg+j)
t2 = ajg - 0.5_dp * t1
t3 = c1 * ( ajf - aji )
t1 = ajg + t1
a(jg+j) = ajc
bji = b(ji+j)
u1 = bjf + bji
bjg = b(jg+j)
u2 = bjg - 0.5_dp * u1
u3 = c1 * ( bjf - bji )
u1 = bjg + u1
b(jg+j) = bjc
a(jc+j) = t1
b(jc+j) = u1
a(jf+j) = co1*(t2-u3) - si1*(u2+t3)
b(jf+j) = si1*(t2-u3) + co1*(u2+t3)
a(ji+j) = co2*(t2+u3) - si2*(u2-t3)
b(ji+j) = si2*(t2+u3) + co2*(u2-t3)
j = j + jump
440 continue
!-----(end of loop across transforms)
ja = ja + jstepx
if (ja.lt.istart) ja = ja + ninc
445 continue
450 continue
460 continue
!-----( end of double loop for this k )
kk = kk + 2*la
470 continue
!-----( end of loop over values of k )
la = 3*la
480 continue
!-----( end of loop on type II radix-3 passes )
!-----( nvex transforms completed)
490 continue
istart = istart + nvex * jump
500 continue
!-----( end of loop on blocks of transforms )
!
return
end subroutine gpfa3f

!*******************************************************************

!     fortran version of *gpfa5* -
!     radix-5 section of self-sorting, in-place,
!        generalized pfa
!
!-------------------------------------------------------------------
!
subroutine gpfa5f(a,b,trigs,inc,jump,n,mm,lot,isign)

real(wp)     ::     a(*), b(*)
real(dp)     ::     trigs(*)
integer inc, jump, n, mm, lot, isign

real(dp), parameter :: sin36 = 0.587785252292473_dp, &
                       sin72 = 0.951056516295154_dp, &
                       qrt5  = 0.559016994374947_dp
integer, parameter  :: lvr = 128

integer      ::  inq, jstepx, ninc, ink, mu, m, mh, &
                 nblox, n5, left, istart, nb, nvex, la, &
                 ipass, jstep, jstepl, kk, k, jjj, ja, &
                 nu, jb, jc, jd, je, j, laincl, ll, l, &
                 jf, jg, jh, ji, jj, jk, jl, jm, jn, jo, &
                 jp, jq, jr, js, jt, ju, jv, jw, jx, jy

real(dp) ::  s, c1, c2, c3, co1, si1, co2, si2, co3, &
                 si3, co4, si4, ajb, aje, t1, ajc, ajd, &
                 t2, t3, t4, t5, t6, aja, t7, t8, t9, t10, &
                 t11, bjb, bje, u1, bjc, bjd, u2, u3, u4, &
                 u5, u6, bja, u7, u8, u9, u10, u11, ajf, &
                 ajk, bjf, bjk, ajg, ajj, ajh, aji, ajl, &
                 ajq, bjg, bjj, bjh, bji, bjl, bjq, ajo, &
                 ajm, ajn, ajr, ajw, bjo, bjm, bjn, bjr, &
                 bjw, ajt, ajs, ajx, ajp, ax, bjt, bjs, &
                 bjx, bjp, bx, ajv, ajy, aju, bjv, bjy, &
                 bju
!
!     ***************************************************************
!     *                                                             *
!     *  N.B. LVR = LENGTH OF VECTOR REGISTERS, SET TO 128 FOR C90. *
!     *  RESET TO 64 FOR OTHER CRAY MACHINES, OR TO ANY LARGE VALUE *
!     *  (GREATER THAN OR EQUAL TO LOT) FOR A SCALAR COMPUTER.      *
!     *                                                             *
!     ***************************************************************
!
n5 = 5 ** mm
inq = n / n5
jstepx = (n5-n) * inc
ninc = n * inc
ink = inc * inq
mu = mod(inq,5)
if (isign.eq.-1) mu = 5 - mu
!
m = mm
mh = (m+1)/2
s = real(isign,kind=dp)
c1 = qrt5
c2 = sin72
c3 = sin36
if (mu.eq.2.or.mu.eq.3) then
   c1 = -c1
   c2 = sin36
   c3 = sin72
endif
if (mu.eq.3.or.mu.eq.4) c2 = -c2
if (mu.eq.2.or.mu.eq.4) c3 = -c3
!
nblox = 1 + (lot-1)/lvr
left = lot
s = real(isign,kind=dp)
istart = 1
!
!  loop on blocks of lvr transforms
!  --------------------------------
do 500 nb = 1 , nblox
!
if (left.le.lvr) then
   nvex = left
else if (left.lt.(2*lvr)) then
   nvex = left/2
   nvex = nvex + mod(nvex,2)
else
   nvex = lvr
endif
left = left - nvex
!
la = 1
!
!  loop on type I radix-5 passes
!  -----------------------------
do 160 ipass = 1 , mh
jstep = (n*inc) / (5*la)
jstepl = jstep - ninc
kk = 0
!
!  loop on k
!  ---------
do 150 k = 0 , jstep-ink , ink
!
if (k.gt.0) then
co1 = trigs(kk+1)
si1 = s*trigs(kk+2)
co2 = trigs(2*kk+1)
si2 = s*trigs(2*kk+2)
co3 = trigs(3*kk+1)
si3 = s*trigs(3*kk+2)
co4 = trigs(4*kk+1)
si4 = s*trigs(4*kk+2)
endif
!
!  loop along transform
!  --------------------
do 140 jjj = k , (n-1)*inc , 5*jstep
ja = istart + jjj
!
!     "transverse" loop
!     -----------------
do 135 nu = 1 , inq
jb = ja + jstepl
if (jb.lt.istart) jb = jb + ninc
jc = jb + jstepl
if (jc.lt.istart) jc = jc + ninc
jd = jc + jstepl
if (jd.lt.istart) jd = jd + ninc
je = jd + jstepl
if (je.lt.istart) je = je + ninc
j = 0
!
!  loop across transforms
!  ----------------------
if (k.eq.0) then
!
#ifdef OLD_CRAY
!dir$ ivdep, shortloop
#endif
do 110 l = 1 , nvex
ajb = a(jb+j)
aje = a(je+j)
t1 = ajb + aje
ajc = a(jc+j)
ajd = a(jd+j)
t2 = ajc + ajd
t3 = ajb - aje
t4 = ajc - ajd
t5 = t1 + t2
t6 = c1 * ( t1 - t2 )
aja = a(ja+j)
t7 = aja - 0.25_dp * t5
a(ja+j) = aja + t5
t8 = t7 + t6
t9 = t7 - t6
t10 = c3 * t3 - c2 * t4
t11 = c2 * t3 + c3 * t4
bjb = b(jb+j)
bje = b(je+j)
u1 = bjb + bje
bjc = b(jc+j)
bjd = b(jd+j)
u2 = bjc + bjd
u3 = bjb - bje
u4 = bjc - bjd
u5 = u1 + u2
u6 = c1 * ( u1 - u2 )
bja = b(ja+j)
u7 = bja - 0.25_dp * u5
b(ja+j) = bja + u5
u8 = u7 + u6
u9 = u7 - u6
u10 = c3 * u3 - c2 * u4
u11 = c2 * u3 + c3 * u4
a(jb+j) = t8 - u11
b(jb+j) = u8 + t11
a(je+j) = t8 + u11
b(je+j) = u8 - t11
a(jc+j) = t9 - u10
b(jc+j) = u9 + t10
a(jd+j) = t9 + u10
b(jd+j) = u9 - t10
j = j + jump
110 continue
!
else
!
#ifdef OLD_CRAY
!dir$ ivdep, shortloop
#endif
do 130 l = 1 , nvex
ajb = a(jb+j)
aje = a(je+j)
t1 = ajb + aje
ajc = a(jc+j)
ajd = a(jd+j)
t2 = ajc + ajd
t3 = ajb - aje
t4 = ajc - ajd
t5 = t1 + t2
t6 = c1 * ( t1 - t2 )
aja = a(ja+j)
t7 = aja - 0.25_dp * t5
a(ja+j) = aja + t5
t8 = t7 + t6
t9 = t7 - t6
t10 = c3 * t3 - c2 * t4
t11 = c2 * t3 + c3 * t4
bjb = b(jb+j)
bje = b(je+j)
u1 = bjb + bje
bjc = b(jc+j)
bjd = b(jd+j)
u2 = bjc + bjd
u3 = bjb - bje
u4 = bjc - bjd
u5 = u1 + u2
u6 = c1 * ( u1 - u2 )
bja = b(ja+j)
u7 = bja - 0.25_dp * u5
b(ja+j) = bja + u5
u8 = u7 + u6
u9 = u7 - u6
u10 = c3 * u3 - c2 * u4
u11 = c2 * u3 + c3 * u4
a(jb+j) = co1*(t8-u11) - si1*(u8+t11)
b(jb+j) = si1*(t8-u11) + co1*(u8+t11)
a(je+j) = co4*(t8+u11) - si4*(u8-t11)
b(je+j) = si4*(t8+u11) + co4*(u8-t11)
a(jc+j) = co2*(t9-u10) - si2*(u9+t10)
b(jc+j) = si2*(t9-u10) + co2*(u9+t10)
a(jd+j) = co3*(t9+u10) - si3*(u9-t10)
b(jd+j) = si3*(t9+u10) + co3*(u9-t10)
j = j + jump
130 continue
!
endif
!
!-----( end of loop across transforms )
!
ja = ja + jstepx
if (ja.lt.istart) ja = ja + ninc
135 continue
140 continue
!-----( end of loop along transforms )
kk = kk + 2*la
150 continue
!-----( end of loop on nonzero k )
la = 5*la
160 continue
!-----( end of loop on type I radix-5 passes)
!
if (n.eq.5) go to 490
!
!  loop on type II radix-5 passes
!  ------------------------------
400 continue
!
do 480 ipass = mh+1 , m
jstep = (n*inc) / (5*la)
jstepl = jstep - ninc
laincl = la * ink - ninc
kk = 0
!
!     loop on k
!     ---------
do 470 k = 0 , jstep-ink , ink
!
if (k.gt.0) then
co1 = trigs(kk+1)
si1 = s*trigs(kk+2)
co2 = trigs(2*kk+1)
si2 = s*trigs(2*kk+2)
co3 = trigs(3*kk+1)
si3 = s*trigs(3*kk+2)
co4 = trigs(4*kk+1)
si4 = s*trigs(4*kk+2)
endif
!
!  double loop along first transform in block
!  ------------------------------------------
do 460 ll = k , (la-1)*ink , 5*jstep
!
do 450 jjj = ll , (n-1)*inc , 5*la*ink
ja = istart + jjj
!
!     "transverse" loop
!     -----------------
do 445 nu = 1 , inq
jb = ja + jstepl
if (jb.lt.istart) jb = jb + ninc
jc = jb + jstepl
if (jc.lt.istart) jc = jc + ninc
jd = jc + jstepl
if (jd.lt.istart) jd = jd + ninc
je = jd + jstepl
if (je.lt.istart) je = je + ninc
jf = ja + laincl
if (jf.lt.istart) jf = jf + ninc
jg = jf + jstepl
if (jg.lt.istart) jg = jg + ninc
jh = jg + jstepl
if (jh.lt.istart) jh = jh + ninc
ji = jh + jstepl
if (ji.lt.istart) ji = ji + ninc
jj = ji + jstepl
if (jj.lt.istart) jj = jj + ninc
jk = jf + laincl
if (jk.lt.istart) jk = jk + ninc
jl = jk + jstepl
if (jl.lt.istart) jl = jl + ninc
jm = jl + jstepl
if (jm.lt.istart) jm = jm + ninc
jn = jm + jstepl
if (jn.lt.istart) jn = jn + ninc
jo = jn + jstepl
if (jo.lt.istart) jo = jo + ninc
jp = jk + laincl
if (jp.lt.istart) jp = jp + ninc
jq = jp + jstepl
if (jq.lt.istart) jq = jq + ninc
jr = jq + jstepl
if (jr.lt.istart) jr = jr + ninc
js = jr + jstepl
if (js.lt.istart) js = js + ninc
jt = js + jstepl
if (jt.lt.istart) jt = jt + ninc
ju = jp + laincl
if (ju.lt.istart) ju = ju + ninc
jv = ju + jstepl
if (jv.lt.istart) jv = jv + ninc
jw = jv + jstepl
if (jw.lt.istart) jw = jw + ninc
jx = jw + jstepl
if (jx.lt.istart) jx = jx + ninc
jy = jx + jstepl
if (jy.lt.istart) jy = jy + ninc
j = 0
!
!  loop across transforms
!  ----------------------
if (k.eq.0) then
!
#ifdef OLD_CRAY
!dir$ ivdep, shortloop
#endif
do 410 l = 1 , nvex
ajb = a(jb+j)
aje = a(je+j)
t1 = ajb + aje
ajc = a(jc+j)
ajd = a(jd+j)
t2 = ajc + ajd
t3 = ajb - aje
t4 = ajc - ajd
ajf = a(jf+j)
ajb =  ajf
t5 = t1 + t2
t6 = c1 * ( t1 - t2 )
aja = a(ja+j)
t7 = aja - 0.25_dp * t5
a(ja+j) = aja + t5
t8 = t7 + t6
t9 = t7 - t6
ajk = a(jk+j)
ajc =  ajk
t10 = c3 * t3 - c2 * t4
t11 = c2 * t3 + c3 * t4
bjb = b(jb+j)
bje = b(je+j)
u1 = bjb + bje
bjc = b(jc+j)
bjd = b(jd+j)
u2 = bjc + bjd
u3 = bjb - bje
u4 = bjc - bjd
bjf = b(jf+j)
bjb =  bjf
u5 = u1 + u2
u6 = c1 * ( u1 - u2 )
bja = b(ja+j)
u7 = bja - 0.25_dp * u5
b(ja+j) = bja + u5
u8 = u7 + u6
u9 = u7 - u6
bjk = b(jk+j)
bjc =  bjk
u10 = c3 * u3 - c2 * u4
u11 = c2 * u3 + c3 * u4
a(jf+j) = t8 - u11
b(jf+j) = u8 + t11
aje =  t8 + u11
bje =  u8 - t11
a(jk+j) = t9 - u10
b(jk+j) = u9 + t10
ajd =  t9 + u10
bjd =  u9 - t10
!----------------------
ajg = a(jg+j)
ajj = a(jj+j)
t1 = ajg + ajj
ajh = a(jh+j)
aji = a(ji+j)
t2 = ajh + aji
t3 = ajg - ajj
t4 = ajh - aji
ajl = a(jl+j)
ajh =  ajl
t5 = t1 + t2
t6 = c1 * ( t1 - t2 )
t7 = ajb - 0.25_dp * t5
a(jb+j) = ajb + t5
t8 = t7 + t6
t9 = t7 - t6
ajq = a(jq+j)
aji =  ajq
t10 = c3 * t3 - c2 * t4
t11 = c2 * t3 + c3 * t4
bjg = b(jg+j)
bjj = b(jj+j)
u1 = bjg + bjj
bjh = b(jh+j)
bji = b(ji+j)
u2 = bjh + bji
u3 = bjg - bjj
u4 = bjh - bji
bjl = b(jl+j)
bjh =  bjl
u5 = u1 + u2
u6 = c1 * ( u1 - u2 )
u7 = bjb - 0.25_dp * u5
b(jb+j) = bjb + u5
u8 = u7 + u6
u9 = u7 - u6
bjq = b(jq+j)
bji =  bjq
u10 = c3 * u3 - c2 * u4
u11 = c2 * u3 + c3 * u4
a(jg+j) = t8 - u11
b(jg+j) = u8 + t11
ajj =  t8 + u11
bjj =  u8 - t11
a(jl+j) = t9 - u10
b(jl+j) = u9 + t10
a(jq+j) = t9 + u10
b(jq+j) = u9 - t10
!----------------------
ajo = a(jo+j)
t1 = ajh + ajo
ajm = a(jm+j)
ajn = a(jn+j)
t2 = ajm + ajn
t3 = ajh - ajo
t4 = ajm - ajn
ajr = a(jr+j)
ajn =  ajr
t5 = t1 + t2
t6 = c1 * ( t1 - t2 )
t7 = ajc - 0.25_dp * t5
a(jc+j) = ajc + t5
t8 = t7 + t6
t9 = t7 - t6
ajw = a(jw+j)
ajo =  ajw
t10 = c3 * t3 - c2 * t4
t11 = c2 * t3 + c3 * t4
bjo = b(jo+j)
u1 = bjh + bjo
bjm = b(jm+j)
bjn = b(jn+j)
u2 = bjm + bjn
u3 = bjh - bjo
u4 = bjm - bjn
bjr = b(jr+j)
bjn =  bjr
u5 = u1 + u2
u6 = c1 * ( u1 - u2 )
u7 = bjc - 0.25_dp * u5
b(jc+j) = bjc + u5
u8 = u7 + u6
u9 = u7 - u6
bjw = b(jw+j)
bjo =  bjw
u10 = c3 * u3 - c2 * u4
u11 = c2 * u3 + c3 * u4
a(jh+j) = t8 - u11
b(jh+j) = u8 + t11
a(jw+j) = t8 + u11
b(jw+j) = u8 - t11
a(jm+j) = t9 - u10
b(jm+j) = u9 + t10
a(jr+j) = t9 + u10
b(jr+j) = u9 - t10
!----------------------
ajt = a(jt+j)
t1 = aji + ajt
ajs = a(js+j)
t2 = ajn + ajs
t3 = aji - ajt
t4 = ajn - ajs
ajx = a(jx+j)
ajt =  ajx
t5 = t1 + t2
t6 = c1 * ( t1 - t2 )
ajp = a(jp+j)
t7 = ajp - 0.25_dp * t5
ax = ajp + t5
t8 = t7 + t6
t9 = t7 - t6
a(jp+j) = ajd
t10 = c3 * t3 - c2 * t4
t11 = c2 * t3 + c3 * t4
a(jd+j) = ax
bjt = b(jt+j)
u1 = bji + bjt
bjs = b(js+j)
u2 = bjn + bjs
u3 = bji - bjt
u4 = bjn - bjs
bjx = b(jx+j)
bjt =  bjx
u5 = u1 + u2
u6 = c1 * ( u1 - u2 )
bjp = b(jp+j)
u7 = bjp - 0.25_dp * u5
bx = bjp + u5
u8 = u7 + u6
u9 = u7 - u6
b(jp+j) = bjd
u10 = c3 * u3 - c2 * u4
u11 = c2 * u3 + c3 * u4
b(jd+j) = bx
a(ji+j) = t8 - u11
b(ji+j) = u8 + t11
a(jx+j) = t8 + u11
b(jx+j) = u8 - t11
a(jn+j) = t9 - u10
b(jn+j) = u9 + t10
a(js+j) = t9 + u10
b(js+j) = u9 - t10
!----------------------
ajv = a(jv+j)
ajy = a(jy+j)
t1 = ajv + ajy
t2 = ajo + ajt
t3 = ajv - ajy
t4 = ajo - ajt
a(jv+j) = ajj
t5 = t1 + t2
t6 = c1 * ( t1 - t2 )
aju = a(ju+j)
t7 = aju - 0.25_dp * t5
ax = aju + t5
t8 = t7 + t6
t9 = t7 - t6
a(ju+j) = aje
t10 = c3 * t3 - c2 * t4
t11 = c2 * t3 + c3 * t4
a(je+j) = ax
bjv = b(jv+j)
bjy = b(jy+j)
u1 = bjv + bjy
u2 = bjo + bjt
u3 = bjv - bjy
u4 = bjo - bjt
b(jv+j) = bjj
u5 = u1 + u2
u6 = c1 * ( u1 - u2 )
bju = b(ju+j)
u7 = bju - 0.25_dp * u5
bx = bju + u5
u8 = u7 + u6
u9 = u7 - u6
b(ju+j) = bje
u10 = c3 * u3 - c2 * u4
u11 = c2 * u3 + c3 * u4
b(je+j) = bx
a(jj+j) = t8 - u11
b(jj+j) = u8 + t11
a(jy+j) = t8 + u11
b(jy+j) = u8 - t11
a(jo+j) = t9 - u10
b(jo+j) = u9 + t10
a(jt+j) = t9 + u10
b(jt+j) = u9 - t10
j = j + jump
410 continue
!
else
!
#ifdef OLD_CRAY
!dir$ ivdep, shortloop
#endif
do 440 l = 1 , nvex
ajb = a(jb+j)
aje = a(je+j)
t1 = ajb + aje
ajc = a(jc+j)
ajd = a(jd+j)
t2 = ajc + ajd
t3 = ajb - aje
t4 = ajc - ajd
ajf = a(jf+j)
ajb =  ajf
t5 = t1 + t2
t6 = c1 * ( t1 - t2 )
aja = a(ja+j)
t7 = aja - 0.25_dp * t5
a(ja+j) = aja + t5
t8 = t7 + t6
t9 = t7 - t6
ajk = a(jk+j)
ajc =  ajk
t10 = c3 * t3 - c2 * t4
t11 = c2 * t3 + c3 * t4
bjb = b(jb+j)
bje = b(je+j)
u1 = bjb + bje
bjc = b(jc+j)
bjd = b(jd+j)
u2 = bjc + bjd
u3 = bjb - bje
u4 = bjc - bjd
bjf = b(jf+j)
bjb =  bjf
u5 = u1 + u2
u6 = c1 * ( u1 - u2 )
bja = b(ja+j)
u7 = bja - 0.25_dp * u5
b(ja+j) = bja + u5
u8 = u7 + u6
u9 = u7 - u6
bjk = b(jk+j)
bjc =  bjk
u10 = c3 * u3 - c2 * u4
u11 = c2 * u3 + c3 * u4
a(jf+j) = co1*(t8-u11) - si1*(u8+t11)
b(jf+j) = si1*(t8-u11) + co1*(u8+t11)
aje =  co4*(t8+u11) - si4*(u8-t11)
bje =  si4*(t8+u11) + co4*(u8-t11)
a(jk+j) = co2*(t9-u10) - si2*(u9+t10)
b(jk+j) = si2*(t9-u10) + co2*(u9+t10)
ajd =  co3*(t9+u10) - si3*(u9-t10)
bjd =  si3*(t9+u10) + co3*(u9-t10)
!----------------------
ajg = a(jg+j)
ajj = a(jj+j)
t1 = ajg + ajj
ajh = a(jh+j)
aji = a(ji+j)
t2 = ajh + aji
t3 = ajg - ajj
t4 = ajh - aji
ajl = a(jl+j)
ajh =  ajl
t5 = t1 + t2
t6 = c1 * ( t1 - t2 )
t7 = ajb - 0.25_dp * t5
a(jb+j) = ajb + t5
t8 = t7 + t6
t9 = t7 - t6
ajq = a(jq+j)
aji =  ajq
t10 = c3 * t3 - c2 * t4
t11 = c2 * t3 + c3 * t4
bjg = b(jg+j)
bjj = b(jj+j)
u1 = bjg + bjj
bjh = b(jh+j)
bji = b(ji+j)
u2 = bjh + bji
u3 = bjg - bjj
u4 = bjh - bji
bjl = b(jl+j)
bjh =  bjl
u5 = u1 + u2
u6 = c1 * ( u1 - u2 )
u7 = bjb - 0.25_dp * u5
b(jb+j) = bjb + u5
u8 = u7 + u6
u9 = u7 - u6
bjq = b(jq+j)
bji =  bjq
u10 = c3 * u3 - c2 * u4
u11 = c2 * u3 + c3 * u4
a(jg+j) = co1*(t8-u11) - si1*(u8+t11)
b(jg+j) = si1*(t8-u11) + co1*(u8+t11)
ajj =  co4*(t8+u11) - si4*(u8-t11)
bjj =  si4*(t8+u11) + co4*(u8-t11)
a(jl+j) = co2*(t9-u10) - si2*(u9+t10)
b(jl+j) = si2*(t9-u10) + co2*(u9+t10)
a(jq+j) = co3*(t9+u10) - si3*(u9-t10)
b(jq+j) = si3*(t9+u10) + co3*(u9-t10)
!----------------------
ajo = a(jo+j)
t1 = ajh + ajo
ajm = a(jm+j)
ajn = a(jn+j)
t2 = ajm + ajn
t3 = ajh - ajo
t4 = ajm - ajn
ajr = a(jr+j)
ajn =  ajr
t5 = t1 + t2
t6 = c1 * ( t1 - t2 )
t7 = ajc - 0.25_dp * t5
a(jc+j) = ajc + t5
t8 = t7 + t6
t9 = t7 - t6
ajw = a(jw+j)
ajo =  ajw
t10 = c3 * t3 - c2 * t4
t11 = c2 * t3 + c3 * t4
bjo = b(jo+j)
u1 = bjh + bjo
bjm = b(jm+j)
bjn = b(jn+j)
u2 = bjm + bjn
u3 = bjh - bjo
u4 = bjm - bjn
bjr = b(jr+j)
bjn =  bjr
u5 = u1 + u2
u6 = c1 * ( u1 - u2 )
u7 = bjc - 0.25_dp * u5
b(jc+j) = bjc + u5
u8 = u7 + u6
u9 = u7 - u6
bjw = b(jw+j)
bjo =  bjw
u10 = c3 * u3 - c2 * u4
u11 = c2 * u3 + c3 * u4
a(jh+j) = co1*(t8-u11) - si1*(u8+t11)
b(jh+j) = si1*(t8-u11) + co1*(u8+t11)
a(jw+j) = co4*(t8+u11) - si4*(u8-t11)
b(jw+j) = si4*(t8+u11) + co4*(u8-t11)
a(jm+j) = co2*(t9-u10) - si2*(u9+t10)
b(jm+j) = si2*(t9-u10) + co2*(u9+t10)
a(jr+j) = co3*(t9+u10) - si3*(u9-t10)
b(jr+j) = si3*(t9+u10) + co3*(u9-t10)
!----------------------
ajt = a(jt+j)
t1 = aji + ajt
ajs = a(js+j)
t2 = ajn + ajs
t3 = aji - ajt
t4 = ajn - ajs
ajx = a(jx+j)
ajt =  ajx
t5 = t1 + t2
t6 = c1 * ( t1 - t2 )
ajp = a(jp+j)
t7 = ajp - 0.25_dp * t5
ax = ajp + t5
t8 = t7 + t6
t9 = t7 - t6
a(jp+j) = ajd
t10 = c3 * t3 - c2 * t4
t11 = c2 * t3 + c3 * t4
a(jd+j) = ax
bjt = b(jt+j)
u1 = bji + bjt
bjs = b(js+j)
u2 = bjn + bjs
u3 = bji - bjt
u4 = bjn - bjs
bjx = b(jx+j)
bjt =  bjx
u5 = u1 + u2
u6 = c1 * ( u1 - u2 )
bjp = b(jp+j)
u7 = bjp - 0.25_dp * u5
bx = bjp + u5
u8 = u7 + u6
u9 = u7 - u6
b(jp+j) = bjd
u10 = c3 * u3 - c2 * u4
u11 = c2 * u3 + c3 * u4
b(jd+j) = bx
a(ji+j) = co1*(t8-u11) - si1*(u8+t11)
b(ji+j) = si1*(t8-u11) + co1*(u8+t11)
a(jx+j) = co4*(t8+u11) - si4*(u8-t11)
b(jx+j) = si4*(t8+u11) + co4*(u8-t11)
a(jn+j) = co2*(t9-u10) - si2*(u9+t10)
b(jn+j) = si2*(t9-u10) + co2*(u9+t10)
a(js+j) = co3*(t9+u10) - si3*(u9-t10)
b(js+j) = si3*(t9+u10) + co3*(u9-t10)
!----------------------
ajv = a(jv+j)
ajy = a(jy+j)
t1 = ajv + ajy
t2 = ajo + ajt
t3 = ajv - ajy
t4 = ajo - ajt
a(jv+j) = ajj
t5 = t1 + t2
t6 = c1 * ( t1 - t2 )
aju = a(ju+j)
t7 = aju - 0.25_dp * t5
ax = aju + t5
t8 = t7 + t6
t9 = t7 - t6
a(ju+j) = aje
t10 = c3 * t3 - c2 * t4
t11 = c2 * t3 + c3 * t4
a(je+j) = ax
bjv = b(jv+j)
bjy = b(jy+j)
u1 = bjv + bjy
u2 = bjo + bjt
u3 = bjv - bjy
u4 = bjo - bjt
b(jv+j) = bjj
u5 = u1 + u2
u6 = c1 * ( u1 - u2 )
bju = b(ju+j)
u7 = bju - 0.25_dp * u5
bx = bju + u5
u8 = u7 + u6
u9 = u7 - u6
b(ju+j) = bje
u10 = c3 * u3 - c2 * u4
u11 = c2 * u3 + c3 * u4
b(je+j) = bx
a(jj+j) = co1*(t8-u11) - si1*(u8+t11)
b(jj+j) = si1*(t8-u11) + co1*(u8+t11)
a(jy+j) = co4*(t8+u11) - si4*(u8-t11)
b(jy+j) = si4*(t8+u11) + co4*(u8-t11)
a(jo+j) = co2*(t9-u10) - si2*(u9+t10)
b(jo+j) = si2*(t9-u10) + co2*(u9+t10)
a(jt+j) = co3*(t9+u10) - si3*(u9-t10)
b(jt+j) = si3*(t9+u10) + co3*(u9-t10)
j = j + jump
440 continue
!
endif
!
!-----(end of loop across transforms)
!
ja = ja + jstepx
if (ja.lt.istart) ja = ja + ninc
445 continue
450 continue
460 continue
!-----( end of double loop for this k )
kk = kk + 2*la
470 continue
!-----( end of loop over values of k )
la = 5*la
480 continue
!-----( end of loop on type II radix-5 passes )
!-----( nvex transforms completed)
490 continue
istart = istart + nvex * jump
500 continue
!-----( end of loop on blocks of transforms )
!
return
end subroutine gpfa5f

end module gridxc_gpfa_core_sp


module gridxc_gpfa_core_dp
    use gridxc_sys, only: die
!
!     1d fft routine based on Clive Temperton's GPFA package
!
! Vectors to be transformed are in DOUBLE precision (wp=dp)

implicit none

! In this module, trigs twiddle factors and intermediate
! variables are kept in double precision.

integer, parameter :: dp = selected_real_kind(10,100)
integer, parameter :: sp = selected_real_kind(6,10)
integer, parameter :: wp = dp

interface gpfa
   module procedure gpfa_
end interface gpfa

public :: gpfa
private

CONTAINS

!--------------------------------------------------------------
!
!  What follows is the original code by Temperton (save setgpfa)
!  with explicit declarations of variables
!
! In this module, trigs twiddle factors and intermediate
! variables are kept in double precision.

!  For arbitrary-precision support the parameter constants might
!  be computed instead of inserted explicitly.
!
!  For example: sin60 = sin(2.0_wp*pi/3.0_wp), where wp is the working
!                       precision, and
!               pi = 4.0_wp * atan(1.0_wp), or
!               twopi = 4.0_wp * asin(1.0_wp)
!
!*********************************************************************

!        SUBROUTINE 'GPFA'
!        SELF-SORTING IN-PLACE GENERALIZED PRIME FACTOR (COMPLEX) FFT
!
!        *** THIS IS THE ALL-FORTRAN VERSION ***
!            -------------------------------
!
!        CALL GPFA(A,B,TRIGS,INC,JUMP,N,LOT,ISIGN)
!
!        A IS FIRST REAL INPUT/OUTPUT VECTOR
!        B IS FIRST IMAGINARY INPUT/OUTPUT VECTOR
!        TRIGS IS A TABLE OF TWIDDLE FACTORS, PRECALCULATED
!              BY CALLING SUBROUTINE 'SETGPFA'
!        INC IS THE INCREMENT WITHIN EACH DATA VECTOR
!        JUMP IS THE INCREMENT BETWEEN DATA VECTORS
!        N IS THE LENGTH OF THE TRANSFORMS:
!          -----------------------------------
!            N = (2**IP) * (3**IQ) * (5**IR)
!          -----------------------------------
!        LOT IS THE NUMBER OF TRANSFORMS
!        ISIGN = +1 FOR FORWARD TRANSFORM
!              = -1 FOR INVERSE TRANSFORM
!
!        WRITTEN BY CLIVE TEMPERTON
!        RECHERCHE EN PREVISION NUMERIQUE
!        ATMOSPHERIC ENVIRONMENT SERVICE, CANADA
!
!----------------------------------------------------------------------
!
!        DEFINITION OF TRANSFORM
!        -----------------------
!
!        X(J) = SUM(K=0,...,N-1)(C(K)*EXP(ISIGN*2*I*J*K*PI/N))
!
!---------------------------------------------------------------------
!
!        FOR A MATHEMATICAL DEVELOPMENT OF THE ALGORITHM USED,
!        SEE:
!
!        C TEMPERTON : "A GENERALIZED PRIME FACTOR FFT ALGORITHM
!          FOR ANY N = (2**P)(3**Q)(5**R)",
!          SIAM J. SCI. STAT. COMP., MAY 1992.
!

SUBROUTINE GPFA_(A,B,TRIGS,INC,JUMP,N,LOT,ISIGN)

IMPLICIT NONE
!
REAL(wp) ::     A(:), B(:) 
REAL(dp)  TRIGS(*)
INTEGER INC, JUMP, N, LOT, ISIGN
!
INTEGER &
  NJ(3), NN, IFAC, LL, KK, IP, IQ, IR, I

character(len=20) :: msg
!
!     DECOMPOSE N INTO FACTORS 2,3,5
!     ------------------------------
NN = N
IFAC = 2
!
DO 30 LL = 1 , 3
KK = 0
10 CONTINUE
IF (MOD(NN,IFAC).NE.0) GO TO 20
KK = KK + 1
NN = NN / IFAC
GO TO 10
20 CONTINUE
NJ(LL) = KK
IFAC = IFAC + LL
30 CONTINUE
!
IF (NN.NE.1) THEN
   write(msg,"(i0)") N
   call die('GPFA: '//trim(msg)//' IS NOT A LEGAL VALUE OF N')
ENDIF
!
IP = NJ(1)
IQ = NJ(2)
IR = NJ(3)
!
!     COMPUTE THE TRANSFORM
!     ---------------------
I = 1
IF (IP.GT.0) THEN
   CALL GPFA2F(A,B,TRIGS,INC,JUMP,N,IP,LOT,ISIGN)
   I = I + 2 * ( 2**IP)
ENDIF
IF (IQ.GT.0) THEN
   CALL GPFA3F(A,B,TRIGS(I),INC,JUMP,N,IQ,LOT,ISIGN)
   I = I + 2 * (3**IQ)
ENDIF
IF (IR.GT.0) THEN
   CALL GPFA5F(A,B,TRIGS(I),INC,JUMP,N,IR,LOT,ISIGN)
ENDIF
!
RETURN
END SUBROUTINE GPFA_


!*********************************************************************

!     fortran version of *gpfa2* -
!     radix-2 section of self-sorting, in-place, generalized pfa
!     central radix-2 and radix-8 passes included
!      so that transform length can be any power of 2
!

subroutine gpfa2f(a,b,trigs,inc,jump,n,mm,lot,isign)

real(wp) ::     a(*), b(*)
real(dp)     ::     trigs(*)
integer inc, jump, n, mm, lot, isign

integer  n2, inq, jstepx, ninc, ink, m2, m8, &
         m, mh, nblox, left, istart, nb, nvex, &
         la, mu, ipass, jstep, jstepl, jjj, ja, &
         nu, jb, jc, jd, j, l, kk, k, je, jf, &
         jg, jh, laincl, ll, ji, jj, jk, jl, jm, &
         jn, jo, jp

real(dp) :: s, aja, ajc, t0, t2, ajb, ajd, &
                t1, t3, bja, bjc, u0, u2, bjb, &
                bjd, u1, u3, co1, si1, co2, si2, &
                co3, si3, ss, c1, c2, c3, aje, &
                ajf, ajg, ajh, bje, bjf, bjg, &
                bjh, co4, si4, co5, si5, co6, si6, &
                co7, si7, aji, bjm, ajj, bjj, ajk, &
                ajl, bji, bjk, ajo, bjl, bjo, ajm, &
                ajn, ajp, bjn, bjp

#ifdef OLD_CRAY
integer, parameter :: lvr = CRAY_LVR_PARAMETER
#else
integer, parameter :: lvr = 1024
#endif
!
!     ***************************************************************
!     *                                                             *
!     *  N.B. LVR = LENGTH OF VECTOR REGISTERS, SET TO 128 FOR C90. *
!     *  RESET TO 64 FOR OTHER CRAY MACHINES, OR TO ANY LARGE VALUE *
!     *  (GREATER THAN OR EQUAL TO LOT) FOR A SCALAR COMPUTER.      *
!     *                                                             *
!     ***************************************************************
!
n2 = 2**mm
inq = n/n2
jstepx = (n2-n) * inc
ninc = n * inc
ink = inc * inq
!
m2 = 0
m8 = 0
if (mod(mm,2).eq.0) then
   m = mm/2
else if (mod(mm,4).eq.1) then
   m = (mm-1)/2
   m2 = 1
else if (mod(mm,4).eq.3) then
   m = (mm-3)/2
   m8 = 1
endif
mh = (m+1)/2
!
nblox = 1 + (lot-1)/lvr
left = lot
s = real(isign,kind=dp)
istart = 1
!
!  loop on blocks of lvr transforms
!  --------------------------------
do 500 nb = 1 , nblox
!
if (left.le.lvr) then
   nvex = left
else if (left.lt.(2*lvr)) then
   nvex = left/2
   nvex = nvex + mod(nvex,2)
else
   nvex = lvr
endif
left = left - nvex
!
la = 1
!
!  loop on type I radix-4 passes
!  -----------------------------
mu = mod(inq,4)
if (isign.eq.-1) mu = 4 - mu
ss = 1.0_dp
if (mu.eq.3) ss = -1.0_dp
!
if (mh.eq.0) go to 200
!
do 160 ipass = 1 , mh
jstep = (n*inc) / (4*la)
jstepl = jstep - ninc
!
!  k = 0 loop (no twiddle factors)
!  -------------------------------
do 120 jjj = 0 , (n-1)*inc , 4*jstep
ja = istart + jjj
!
!     "transverse" loop
!     -----------------
do 115 nu = 1 , inq
jb = ja + jstepl
if (jb.lt.istart) jb = jb + ninc
jc = jb + jstepl
if (jc.lt.istart) jc = jc + ninc
jd = jc + jstepl
if (jd.lt.istart) jd = jd + ninc
j = 0
!
!  loop across transforms
!  ----------------------
#ifdef OLD_CRAY
!dir$ ivdep, shortloop
#endif
do 110 l = 1 , nvex
aja = a(ja+j)
ajc = a(jc+j)
t0 = aja + ajc
t2 = aja - ajc
ajb = a(jb+j)
ajd = a(jd+j)
t1 = ajb + ajd
t3 = ss * ( ajb - ajd )
bja = b(ja+j)
bjc = b(jc+j)
u0 = bja + bjc
u2 = bja - bjc
bjb = b(jb+j)
bjd = b(jd+j)
u1 = bjb + bjd
u3 = ss * ( bjb - bjd )
a(ja+j) = t0 + t1
a(jc+j) = t0 - t1
b(ja+j) = u0 + u1
b(jc+j) = u0 - u1
a(jb+j) = t2 - u3
a(jd+j) = t2 + u3
b(jb+j) = u2 + t3
b(jd+j) = u2 - t3
j = j + jump
110 continue
ja = ja + jstepx
if (ja.lt.istart) ja = ja + ninc
115 continue
120 continue
!
!  finished if n2 = 4
!  ------------------
if (n2.eq.4) go to 490
kk = 2 * la
!
!  loop on nonzero k
!  -----------------
do 150 k = ink , jstep-ink , ink
co1 = trigs(kk+1)
si1 = s*trigs(kk+2)
co2 = trigs(2*kk+1)
si2 = s*trigs(2*kk+2)
co3 = trigs(3*kk+1)
si3 = s*trigs(3*kk+2)
!
!  loop along transform
!  --------------------
do 140 jjj = k , (n-1)*inc , 4*jstep
ja = istart + jjj
!
!     "transverse" loop
!     -----------------
do 135 nu = 1 , inq
jb = ja + jstepl
if (jb.lt.istart) jb = jb + ninc
jc = jb + jstepl
if (jc.lt.istart) jc = jc + ninc
jd = jc + jstepl
if (jd.lt.istart) jd = jd + ninc
j = 0
!
!  loop across transforms
!  ----------------------
#ifdef OLD_CRAY
!dir$ ivdep, shortloop
#endif
do 130 l = 1 , nvex
aja = a(ja+j)
ajc = a(jc+j)
t0 = aja + ajc
t2 = aja - ajc
ajb = a(jb+j)
ajd = a(jd+j)
t1 = ajb + ajd
t3 = ss * ( ajb - ajd )
bja = b(ja+j)
bjc = b(jc+j)
u0 = bja + bjc
u2 = bja - bjc
bjb = b(jb+j)
bjd = b(jd+j)
u1 = bjb + bjd
u3 = ss * ( bjb - bjd )
a(ja+j) = t0 + t1
b(ja+j) = u0 + u1
a(jb+j) = co1*(t2-u3) - si1*(u2+t3)
b(jb+j) = si1*(t2-u3) + co1*(u2+t3)
a(jc+j) = co2*(t0-t1) - si2*(u0-u1)
b(jc+j) = si2*(t0-t1) + co2*(u0-u1)
a(jd+j) = co3*(t2+u3) - si3*(u2-t3)
b(jd+j) = si3*(t2+u3) + co3*(u2-t3)
j = j + jump
130 continue
!-----( end of loop across transforms )
ja = ja + jstepx
if (ja.lt.istart) ja = ja + ninc
135 continue
140 continue
!-----( end of loop along transforms )
kk = kk + 2*la
150 continue
!-----( end of loop on nonzero k )
la = 4*la
160 continue
!-----( end of loop on type I radix-4 passes)
!
!  central radix-2 pass
!  --------------------
200 continue
if (m2.eq.0) go to 300
!
jstep = (n*inc) / (2*la)
jstepl = jstep - ninc
!
!  k=0 loop (no twiddle factors)
!  -----------------------------
do 220 jjj = 0 , (n-1)*inc , 2*jstep
ja = istart + jjj
!
!     "transverse" loop
!     -----------------
do 215 nu = 1 , inq
jb = ja + jstepl
if (jb.lt.istart) jb = jb + ninc
j = 0
!
!  loop across transforms
!  ----------------------
#ifdef OLD_CRAY
!dir$ ivdep, shortloop
#endif
do 210 l = 1 , nvex
aja = a(ja+j)
ajb = a(jb+j)
t0 = aja - ajb
a(ja+j) = aja + ajb
a(jb+j) = t0
bja = b(ja+j)
bjb = b(jb+j)
u0 = bja - bjb
b(ja+j) = bja + bjb
b(jb+j) = u0
j = j + jump
210 continue
!-----(end of loop across transforms)
ja = ja + jstepx
if (ja.lt.istart) ja = ja + ninc
215 continue
220 continue
!
!  finished if n2=2
!  ----------------
if (n2.eq.2) go to 490
!
kk = 2 * la
!
!  loop on nonzero k
!  -----------------
do 260 k = ink , jstep - ink , ink
co1 = trigs(kk+1)
si1 = s*trigs(kk+2)
!
!  loop along transforms
!  ---------------------
do 250 jjj = k , (n-1)*inc , 2*jstep
ja = istart + jjj
!
!     "transverse" loop
!     -----------------
do 245 nu = 1 , inq
jb = ja + jstepl
if (jb.lt.istart) jb = jb + ninc
j = 0
!
!  loop across transforms
!  ----------------------
if (kk.eq.n2/2) then
#ifdef OLD_CRAY
!dir$ ivdep, shortloop
#endif
do 230 l = 1 , nvex
aja = a(ja+j)
ajb = a(jb+j)
t0 = ss * ( aja - ajb )
a(ja+j) = aja + ajb
bjb = b(jb+j)
bja = b(ja+j)
a(jb+j) = ss * ( bjb - bja )
b(ja+j) = bja + bjb
b(jb+j) = t0
j = j + jump
230 continue
!
else
!
#ifdef OLD_CRAY
!dir$ ivdep, shortloop
#endif
do 240 l = 1 , nvex
aja = a(ja+j)
ajb = a(jb+j)
t0 = aja - ajb
a(ja+j) = aja + ajb
bja = b(ja+j)
bjb = b(jb+j)
u0 = bja - bjb
b(ja+j) = bja + bjb
a(jb+j) = co1*t0 - si1*u0
b(jb+j) = si1*t0 + co1*u0
j = j + jump
240 continue
!
endif
!
!-----(end of loop across transforms)
ja = ja + jstepx
if (ja.lt.istart) ja = ja + ninc
245 continue
250 continue
!-----(end of loop along transforms)
kk = kk + 2 * la
260 continue
!-----(end of loop on nonzero k)
!-----(end of radix-2 pass)
!
la = 2 * la
go to 400
!
!  central radix-8 pass
!  --------------------
300 continue
if (m8.eq.0) go to 400
jstep = (n*inc) / (8*la)
jstepl = jstep - ninc
mu = mod(inq,8)
if (isign.eq.-1) mu = 8 - mu
c1 = 1.0_dp
if (mu.eq.3.or.mu.eq.7) c1 = -1.0_dp
c2 = sqrt(0.5_dp)
if (mu.eq.3.or.mu.eq.5) c2 = -c2
c3 = c1 * c2
!
!  stage 1
!  -------
do 320 k = 0 , jstep - ink , ink
do 315 jjj = k , (n-1)*inc , 8*jstep
ja = istart + jjj
!
!     "transverse" loop
!     -----------------
do 312 nu = 1 , inq
jb = ja + jstepl
if (jb.lt.istart) jb = jb + ninc
jc = jb + jstepl
if (jc.lt.istart) jc = jc + ninc
jd = jc + jstepl
if (jd.lt.istart) jd = jd + ninc
je = jd + jstepl
if (je.lt.istart) je = je + ninc
jf = je + jstepl
if (jf.lt.istart) jf = jf + ninc
jg = jf + jstepl
if (jg.lt.istart) jg = jg + ninc
jh = jg + jstepl
if (jh.lt.istart) jh = jh + ninc
j = 0
#ifdef OLD_CRAY
!dir$ ivdep, shortloop
#endif
do 310 l = 1 , nvex
aja = a(ja+j)
aje = a(je+j)
t0 = aja - aje
a(ja+j) = aja + aje
ajc = a(jc+j)
ajg = a(jg+j)
t1 = c1 * ( ajc - ajg )
a(je+j) = ajc + ajg
ajb = a(jb+j)
ajf = a(jf+j)
t2 = ajb - ajf
a(jc+j) = ajb + ajf
ajd = a(jd+j)
ajh = a(jh+j)
t3 = ajd - ajh
a(jg+j) = ajd + ajh
a(jb+j) = t0
a(jf+j) = t1
a(jd+j) = c2 * ( t2 - t3 )
a(jh+j) = c3 * ( t2 + t3 )
bja = b(ja+j)
bje = b(je+j)
u0 = bja - bje
b(ja+j) = bja + bje
bjc = b(jc+j)
bjg = b(jg+j)
u1 = c1 * ( bjc - bjg )
b(je+j) = bjc + bjg
bjb = b(jb+j)
bjf = b(jf+j)
u2 = bjb - bjf
b(jc+j) = bjb + bjf
bjd = b(jd+j)
bjh = b(jh+j)
u3 = bjd - bjh
b(jg+j) = bjd + bjh
b(jb+j) = u0
b(jf+j) = u1
b(jd+j) = c2 * ( u2 - u3 )
b(jh+j) = c3 * ( u2 + u3 )
j = j + jump
310 continue
ja = ja + jstepx
if (ja.lt.istart) ja = ja + ninc
312 continue
315 continue
320 continue
!
!  stage 2
!  -------
!
!  k=0 (no twiddle factors)
!  ------------------------
do 330 jjj = 0 , (n-1)*inc , 8*jstep
ja = istart + jjj
!
!     "transverse" loop
!     -----------------
do 328 nu = 1 , inq
jb = ja + jstepl
if (jb.lt.istart) jb = jb + ninc
jc = jb + jstepl
if (jc.lt.istart) jc = jc + ninc
jd = jc + jstepl
if (jd.lt.istart) jd = jd + ninc
je = jd + jstepl
if (je.lt.istart) je = je + ninc
jf = je + jstepl
if (jf.lt.istart) jf = jf + ninc
jg = jf + jstepl
if (jg.lt.istart) jg = jg + ninc
jh = jg + jstepl
if (jh.lt.istart) jh = jh + ninc
j = 0
#ifdef OLD_CRAY
!dir$ ivdep, shortloop
#endif
do 325 l = 1 , nvex
aja = a(ja+j)
aje = a(je+j)
t0 = aja + aje
t2 = aja - aje
ajc = a(jc+j)
ajg = a(jg+j)
t1 = ajc + ajg
t3 = c1 * ( ajc - ajg )
bja = b(ja+j)
bje = b(je+j)
u0 = bja + bje
u2 = bja - bje
bjc = b(jc+j)
bjg = b(jg+j)
u1 = bjc + bjg
u3 = c1 * ( bjc - bjg )
a(ja+j) = t0 + t1
a(je+j) = t0 - t1
b(ja+j) = u0 + u1
b(je+j) = u0 - u1
a(jc+j) = t2 - u3
a(jg+j) = t2 + u3
b(jc+j) = u2 + t3
b(jg+j) = u2 - t3
ajb = a(jb+j)
ajd = a(jd+j)
t0 = ajb + ajd
t2 = ajb - ajd
ajf = a(jf+j)
ajh = a(jh+j)
t1 = ajf - ajh
t3 = ajf + ajh
bjb = b(jb+j)
bjd = b(jd+j)
u0 = bjb + bjd
u2 = bjb - bjd
bjf = b(jf+j)
bjh = b(jh+j)
u1 = bjf - bjh
u3 = bjf + bjh
a(jb+j) = t0 - u3
a(jh+j) = t0 + u3
b(jb+j) = u0 + t3
b(jh+j) = u0 - t3
a(jd+j) = t2 + u1
a(jf+j) = t2 - u1
b(jd+j) = u2 - t1
b(jf+j) = u2 + t1
j = j + jump
325 continue
ja = ja + jstepx
if (ja.lt.istart) ja = ja + ninc
328 continue
330 continue
!
if (n2.eq.8) go to 490
!
!  loop on nonzero k
!  -----------------
kk = 2 * la
!
do 350 k = ink , jstep - ink , ink
!
co1 = trigs(kk+1)
si1 = s * trigs(kk+2)
co2 = trigs(2*kk+1)
si2 = s * trigs(2*kk+2)
co3 = trigs(3*kk+1)
si3 = s * trigs(3*kk+2)
co4 = trigs(4*kk+1)
si4 = s * trigs(4*kk+2)
co5 = trigs(5*kk+1)
si5 = s * trigs(5*kk+2)
co6 = trigs(6*kk+1)
si6 = s * trigs(6*kk+2)
co7 = trigs(7*kk+1)
si7 = s * trigs(7*kk+2)
!
do 345 jjj = k , (n-1)*inc , 8*jstep
ja = istart + jjj
!
!     "transverse" loop
!     -----------------
do 342 nu = 1 , inq
jb = ja + jstepl
if (jb.lt.istart) jb = jb + ninc
jc = jb + jstepl
if (jc.lt.istart) jc = jc + ninc
jd = jc + jstepl
if (jd.lt.istart) jd = jd + ninc
je = jd + jstepl
if (je.lt.istart) je = je + ninc
jf = je + jstepl
if (jf.lt.istart) jf = jf + ninc
jg = jf + jstepl
if (jg.lt.istart) jg = jg + ninc
jh = jg + jstepl
if (jh.lt.istart) jh = jh + ninc
j = 0
#ifdef OLD_CRAY
!dir$ ivdep, shortloop
#endif
do 340 l = 1 , nvex
aja = a(ja+j)
aje = a(je+j)
t0 = aja + aje
t2 = aja - aje
ajc = a(jc+j)
ajg = a(jg+j)
t1 = ajc + ajg
t3 = c1 * ( ajc - ajg )
bja = b(ja+j)
bje = b(je+j)
u0 = bja + bje
u2 = bja - bje
bjc = b(jc+j)
bjg = b(jg+j)
u1 = bjc + bjg
u3 = c1 * ( bjc - bjg )
a(ja+j) = t0 + t1
b(ja+j) = u0 + u1
a(je+j) = co4*(t0-t1) - si4*(u0-u1)
b(je+j) = si4*(t0-t1) + co4*(u0-u1)
a(jc+j) = co2*(t2-u3) - si2*(u2+t3)
b(jc+j) = si2*(t2-u3) + co2*(u2+t3)
a(jg+j) = co6*(t2+u3) - si6*(u2-t3)
b(jg+j) = si6*(t2+u3) + co6*(u2-t3)
ajb = a(jb+j)
ajd = a(jd+j)
t0 = ajb + ajd
t2 = ajb - ajd
ajf = a(jf+j)
ajh = a(jh+j)
t1 = ajf - ajh
t3 = ajf + ajh
bjb = b(jb+j)
bjd = b(jd+j)
u0 = bjb + bjd
u2 = bjb - bjd
bjf = b(jf+j)
bjh = b(jh+j)
u1 = bjf - bjh
u3 = bjf + bjh
a(jb+j) = co1*(t0-u3) - si1*(u0+t3)
b(jb+j) = si1*(t0-u3) + co1*(u0+t3)
a(jh+j) = co7*(t0+u3) - si7*(u0-t3)
b(jh+j) = si7*(t0+u3) + co7*(u0-t3)
a(jd+j) = co3*(t2+u1) - si3*(u2-t1)
b(jd+j) = si3*(t2+u1) + co3*(u2-t1)
a(jf+j) = co5*(t2-u1) - si5*(u2+t1)
b(jf+j) = si5*(t2-u1) + co5*(u2+t1)
j = j + jump
340 continue
ja = ja + jstepx
if (ja.lt.istart) ja = ja + ninc
342 continue
345 continue
kk = kk + 2 * la
350 continue
!
la = 8 * la
!
!  loop on type II radix-4 passes
!  ------------------------------
400 continue
mu = mod(inq,4)
if (isign.eq.-1) mu = 4 - mu
ss = 1.0_dp
if (mu.eq.3) ss = -1.0_dp
!
do 480 ipass = mh+1 , m
jstep = (n*inc) / (4*la)
jstepl = jstep - ninc
laincl = la * ink - ninc
!
!  k=0 loop (no twiddle factors)
!  -----------------------------
do 430 ll = 0 , (la-1)*ink , 4*jstep
!
do 420 jjj = ll , (n-1)*inc , 4*la*ink
ja = istart + jjj
!
!     "transverse" loop
!     -----------------
do 415 nu = 1 , inq
jb = ja + jstepl
if (jb.lt.istart) jb = jb + ninc
jc = jb + jstepl
if (jc.lt.istart) jc = jc + ninc
jd = jc + jstepl
if (jd.lt.istart) jd = jd + ninc
je = ja + laincl
if (je.lt.istart) je = je + ninc
jf = je + jstepl
if (jf.lt.istart) jf = jf + ninc
jg = jf + jstepl
if (jg.lt.istart) jg = jg + ninc
jh = jg + jstepl
if (jh.lt.istart) jh = jh + ninc
ji = je + laincl
if (ji.lt.istart) ji = ji + ninc
jj = ji + jstepl
if (jj.lt.istart) jj = jj + ninc
jk = jj + jstepl
if (jk.lt.istart) jk = jk + ninc
jl = jk + jstepl
if (jl.lt.istart) jl = jl + ninc
jm = ji + laincl
if (jm.lt.istart) jm = jm + ninc
jn = jm + jstepl
if (jn.lt.istart) jn = jn + ninc
jo = jn + jstepl
if (jo.lt.istart) jo = jo + ninc
jp = jo + jstepl
if (jp.lt.istart) jp = jp + ninc
j = 0
!
!  loop across transforms
!  ----------------------
#ifdef OLD_CRAY
!dir$ ivdep, shortloop
#endif
do 410 l = 1 , nvex
aja = a(ja+j)
ajc = a(jc+j)
t0 = aja + ajc
t2 = aja - ajc
ajb = a(jb+j)
ajd = a(jd+j)
t1 = ajb + ajd
t3 = ss * ( ajb - ajd )
aji = a(ji+j)
ajc =  aji
bja = b(ja+j)
bjc = b(jc+j)
u0 = bja + bjc
u2 = bja - bjc
bjb = b(jb+j)
bjd = b(jd+j)
u1 = bjb + bjd
u3 = ss * ( bjb - bjd )
aje = a(je+j)
ajb =  aje
a(ja+j) = t0 + t1
a(ji+j) = t0 - t1
b(ja+j) = u0 + u1
bjc =  u0 - u1
bjm = b(jm+j)
bjd =  bjm
a(je+j) = t2 - u3
ajd =  t2 + u3
bjb =  u2 + t3
b(jm+j) = u2 - t3
!----------------------
ajg = a(jg+j)
t0 = ajb + ajg
t2 = ajb - ajg
ajf = a(jf+j)
ajh = a(jh+j)
t1 = ajf + ajh
t3 = ss * ( ajf - ajh )
ajj = a(jj+j)
ajg =  ajj
bje = b(je+j)
bjg = b(jg+j)
u0 = bje + bjg
u2 = bje - bjg
bjf = b(jf+j)
bjh = b(jh+j)
u1 = bjf + bjh
u3 = ss * ( bjf - bjh )
b(je+j) = bjb
a(jb+j) = t0 + t1
a(jj+j) = t0 - t1
bjj = b(jj+j)
bjg =  bjj
b(jb+j) = u0 + u1
b(jj+j) = u0 - u1
a(jf+j) = t2 - u3
ajh =  t2 + u3
b(jf+j) = u2 + t3
bjh =  u2 - t3
!----------------------
ajk = a(jk+j)
t0 = ajc + ajk
t2 = ajc - ajk
ajl = a(jl+j)
t1 = ajg + ajl
t3 = ss * ( ajg - ajl )
bji = b(ji+j)
bjk = b(jk+j)
u0 = bji + bjk
u2 = bji - bjk
ajo = a(jo+j)
ajl =  ajo
bjl = b(jl+j)
u1 = bjg + bjl
u3 = ss * ( bjg - bjl )
b(ji+j) = bjc
a(jc+j) = t0 + t1
a(jk+j) = t0 - t1
bjo = b(jo+j)
bjl =  bjo
b(jc+j) = u0 + u1
b(jk+j) = u0 - u1
a(jg+j) = t2 - u3
a(jo+j) = t2 + u3
b(jg+j) = u2 + t3
b(jo+j) = u2 - t3
!----------------------
ajm = a(jm+j)
t0 = ajm + ajl
t2 = ajm - ajl
ajn = a(jn+j)
ajp = a(jp+j)
t1 = ajn + ajp
t3 = ss * ( ajn - ajp )
a(jm+j) = ajd
u0 = bjd + bjl
u2 = bjd - bjl
bjn = b(jn+j)
bjp = b(jp+j)
u1 = bjn + bjp
u3 = ss * ( bjn - bjp )
a(jn+j) = ajh
a(jd+j) = t0 + t1
a(jl+j) = t0 - t1
b(jd+j) = u0 + u1
b(jl+j) = u0 - u1
b(jn+j) = bjh
a(jh+j) = t2 - u3
a(jp+j) = t2 + u3
b(jh+j) = u2 + t3
b(jp+j) = u2 - t3
j = j + jump
410 continue
!-----( end of loop across transforms )
ja = ja + jstepx
if (ja.lt.istart) ja = ja + ninc
415 continue
420 continue
430 continue
!-----( end of double loop for k=0 )
!
!  finished if last pass
!  ---------------------
if (ipass.eq.m) go to 490
!
kk = 2*la
!
!     loop on nonzero k
!     -----------------
do 470 k = ink , jstep-ink , ink
co1 = trigs(kk+1)
si1 = s*trigs(kk+2)
co2 = trigs(2*kk+1)
si2 = s*trigs(2*kk+2)
co3 = trigs(3*kk+1)
si3 = s*trigs(3*kk+2)
!
!  double loop along first transform in block
!  ------------------------------------------
do 460 ll = k , (la-1)*ink , 4*jstep
!
do 450 jjj = ll , (n-1)*inc , 4*la*ink
ja = istart + jjj
!
!     "transverse" loop
!     -----------------
do 445 nu = 1 , inq
jb = ja + jstepl
if (jb.lt.istart) jb = jb + ninc
jc = jb + jstepl
if (jc.lt.istart) jc = jc + ninc
jd = jc + jstepl
if (jd.lt.istart) jd = jd + ninc
je = ja + laincl
if (je.lt.istart) je = je + ninc
jf = je + jstepl
if (jf.lt.istart) jf = jf + ninc
jg = jf + jstepl
if (jg.lt.istart) jg = jg + ninc
jh = jg + jstepl
if (jh.lt.istart) jh = jh + ninc
ji = je + laincl
if (ji.lt.istart) ji = ji + ninc
jj = ji + jstepl
if (jj.lt.istart) jj = jj + ninc
jk = jj + jstepl
if (jk.lt.istart) jk = jk + ninc
jl = jk + jstepl
if (jl.lt.istart) jl = jl + ninc
jm = ji + laincl
if (jm.lt.istart) jm = jm + ninc
jn = jm + jstepl
if (jn.lt.istart) jn = jn + ninc
jo = jn + jstepl
if (jo.lt.istart) jo = jo + ninc
jp = jo + jstepl
if (jp.lt.istart) jp = jp + ninc
j = 0
!
!  loop across transforms
!  ----------------------
#ifdef OLD_CRAY
!dir$ ivdep, shortloop
#endif
do 440 l = 1 , nvex
aja = a(ja+j)
ajc = a(jc+j)
t0 = aja + ajc
t2 = aja - ajc
ajb = a(jb+j)
ajd = a(jd+j)
t1 = ajb + ajd
t3 = ss * ( ajb - ajd )
aji = a(ji+j)
ajc =  aji
bja = b(ja+j)
bjc = b(jc+j)
u0 = bja + bjc
u2 = bja - bjc
bjb = b(jb+j)
bjd = b(jd+j)
u1 = bjb + bjd
u3 = ss * ( bjb - bjd )
aje = a(je+j)
ajb =  aje
a(ja+j) = t0 + t1
b(ja+j) = u0 + u1
a(je+j) = co1*(t2-u3) - si1*(u2+t3)
bjb =  si1*(t2-u3) + co1*(u2+t3)
bjm = b(jm+j)
bjd =  bjm
a(ji+j) = co2*(t0-t1) - si2*(u0-u1)
bjc =  si2*(t0-t1) + co2*(u0-u1)
ajd =  co3*(t2+u3) - si3*(u2-t3)
b(jm+j) = si3*(t2+u3) + co3*(u2-t3)
!----------------------------------------
ajg = a(jg+j)
t0 = ajb + ajg
t2 = ajb - ajg
ajf = a(jf+j)
ajh = a(jh+j)
t1 = ajf + ajh
t3 = ss * ( ajf - ajh )
ajj = a(jj+j)
ajg =  ajj
bje = b(je+j)
bjg = b(jg+j)
u0 = bje + bjg
u2 = bje - bjg
bjf = b(jf+j)
bjh = b(jh+j)
u1 = bjf + bjh
u3 = ss * ( bjf - bjh )
b(je+j) = bjb
a(jb+j) = t0 + t1
b(jb+j) = u0 + u1
bjj = b(jj+j)
bjg =  bjj
a(jf+j) = co1*(t2-u3) - si1*(u2+t3)
b(jf+j) = si1*(t2-u3) + co1*(u2+t3)
a(jj+j) = co2*(t0-t1) - si2*(u0-u1)
b(jj+j) = si2*(t0-t1) + co2*(u0-u1)
ajh =  co3*(t2+u3) - si3*(u2-t3)
bjh =  si3*(t2+u3) + co3*(u2-t3)
!----------------------------------------
ajk = a(jk+j)
t0 = ajc + ajk
t2 = ajc - ajk
ajl = a(jl+j)
t1 = ajg + ajl
t3 = ss * ( ajg - ajl )
bji = b(ji+j)
bjk = b(jk+j)
u0 = bji + bjk
u2 = bji - bjk
ajo = a(jo+j)
ajl =  ajo
bjl = b(jl+j)
u1 = bjg + bjl
u3 = ss * ( bjg - bjl )
b(ji+j) = bjc
a(jc+j) = t0 + t1
b(jc+j) = u0 + u1
bjo = b(jo+j)
bjl =  bjo
a(jg+j) = co1*(t2-u3) - si1*(u2+t3)
b(jg+j) = si1*(t2-u3) + co1*(u2+t3)
a(jk+j) = co2*(t0-t1) - si2*(u0-u1)
b(jk+j) = si2*(t0-t1) + co2*(u0-u1)
a(jo+j) = co3*(t2+u3) - si3*(u2-t3)
b(jo+j) = si3*(t2+u3) + co3*(u2-t3)
!----------------------------------------
ajm = a(jm+j)
t0 = ajm + ajl
t2 = ajm - ajl
ajn = a(jn+j)
ajp = a(jp+j)
t1 = ajn + ajp
t3 = ss * ( ajn - ajp )
a(jm+j) = ajd
u0 = bjd + bjl
u2 = bjd - bjl
a(jn+j) = ajh
bjn = b(jn+j)
bjp = b(jp+j)
u1 = bjn + bjp
u3 = ss * ( bjn - bjp )
b(jn+j) = bjh
a(jd+j) = t0 + t1
b(jd+j) = u0 + u1
a(jh+j) = co1*(t2-u3) - si1*(u2+t3)
b(jh+j) = si1*(t2-u3) + co1*(u2+t3)
a(jl+j) = co2*(t0-t1) - si2*(u0-u1)
b(jl+j) = si2*(t0-t1) + co2*(u0-u1)
a(jp+j) = co3*(t2+u3) - si3*(u2-t3)
b(jp+j) = si3*(t2+u3) + co3*(u2-t3)
j = j + jump
440 continue
!-----(end of loop across transforms)
ja = ja + jstepx
if (ja.lt.istart) ja = ja + ninc
445 continue
450 continue
460 continue
!-----( end of double loop for this k )
kk = kk + 2*la
470 continue
!-----( end of loop over values of k )
la = 4*la
480 continue
!-----( end of loop on type II radix-4 passes )
!-----( nvex transforms completed)
490 continue
istart = istart + nvex * jump
500 continue
!-----( end of loop on blocks of transforms )
!
return
end subroutine gpfa2f

!******************************************************************

!     fortran version of *gpfa3* -
!     radix-3 section of self-sorting, in-place
!        generalized PFA
!
!-------------------------------------------------------------------
!
subroutine gpfa3f(a,b,trigs,inc,jump,n,mm,lot,isign)

real(wp) ::     a(*), b(*)
real(dp)     ::     trigs(*)
integer inc, jump, n, mm, lot, isign

real(dp), parameter :: sin60 = 0.866025403784437_dp

integer      :: je, jf, jg, jh, laincl, ll, ji
integer      :: n3, inq, jstepx, ninc, ink, mu, m, mh, &
                nblox, left, istart, nb, nvex, la, &
                ipass, jstep, jstepl, jjj, ja, nu, jb, &
                jc, j, l, kk, k, jd

real(dp) :: s, ajb, ajc, t1, aja, t2, t3, bjb, bjc, &
                u1, bja, u2, u3, co1, si1, co2, si2, ajd, &
                bjd
real(dp) :: c1, aje, ajg, ajf, ajh, bje, &
                bjf, bjg, bjh, aji, bji


integer, parameter :: lvr = 128
!
!     ***************************************************************
!     *                                                             *
!     *  N.B. LVR = LENGTH OF VECTOR REGISTERS, SET TO 128 FOR C90. *
!     *  RESET TO 64 FOR OTHER CRAY MACHINES, OR TO ANY LARGE VALUE *
!     *  (GREATER THAN OR EQUAL TO LOT) FOR A SCALAR COMPUTER.      *
!     *                                                             *
!     ***************************************************************
!
n3 = 3**mm
inq = n/n3
jstepx = (n3-n) * inc
ninc = n * inc
ink = inc * inq
mu = mod(inq,3)
if (isign.eq.-1) mu = 3-mu
m = mm
mh = (m+1)/2
s = real(isign,kind=dp)
c1 = sin60
if (mu.eq.2) c1 = -c1
!
nblox = 1 + (lot-1)/lvr
left = lot
s = real(isign,kind=dp)
istart = 1
!
!  loop on blocks of lvr transforms
!  --------------------------------
do 500 nb = 1 , nblox
!
if (left.le.lvr) then
   nvex = left
else if (left.lt.(2*lvr)) then
   nvex = left/2
   nvex = nvex + mod(nvex,2)
else
   nvex = lvr
endif
left = left - nvex
!
la = 1
!
!  loop on type I radix-3 passes
!  -----------------------------
do 160 ipass = 1 , mh
jstep = (n*inc) / (3*la)
jstepl = jstep - ninc
!
!  k = 0 loop (no twiddle factors)
!  -------------------------------
do 120 jjj = 0 , (n-1)*inc , 3*jstep
ja = istart + jjj
!
!  "transverse" loop
!  -----------------
do 115 nu = 1 , inq
jb = ja + jstepl
if (jb.lt.istart) jb = jb + ninc
jc = jb + jstepl
if (jc.lt.istart) jc = jc + ninc
j = 0
!
!  loop across transforms
!  ----------------------
#ifdef OLD_CRAY
!dir$ ivdep, shortloop
#endif
do 110 l = 1 , nvex
ajb = a(jb+j)
ajc = a(jc+j)
t1 = ajb + ajc
aja = a(ja+j)
t2 = aja - 0.5_dp * t1
t3 = c1 * ( ajb - ajc )
bjb = b(jb+j)
bjc = b(jc+j)
u1 = bjb + bjc
bja = b(ja+j)
u2 = bja - 0.5_dp * u1
u3 = c1 * ( bjb - bjc )
a(ja+j) = aja + t1
b(ja+j) = bja + u1
a(jb+j) = t2 - u3
b(jb+j) = u2 + t3
a(jc+j) = t2 + u3
b(jc+j) = u2 - t3
j = j + jump
110 continue
ja = ja + jstepx
if (ja.lt.istart) ja = ja + ninc
115 continue
120 continue
!
!  finished if n3 = 3
!  ------------------
if (n3.eq.3) go to 490
kk = 2 * la
!
!  loop on nonzero k
!  -----------------
do 150 k = ink , jstep-ink , ink
co1 = trigs(kk+1)
si1 = s*trigs(kk+2)
co2 = trigs(2*kk+1)
si2 = s*trigs(2*kk+2)
!
!  loop along transform
!  --------------------
do 140 jjj = k , (n-1)*inc , 3*jstep
ja = istart + jjj
!
!  "transverse" loop
!  -----------------
do 135 nu = 1 , inq
jb = ja + jstepl
if (jb.lt.istart) jb = jb + ninc
jc = jb + jstepl
if (jc.lt.istart) jc = jc + ninc
j = 0
!
!  loop across transforms
!  ----------------------
#ifdef OLD_CRAY
!dir$ ivdep, shortloop
#endif
do 130 l = 1 , nvex
ajb = a(jb+j)
ajc = a(jc+j)
t1 = ajb + ajc
aja = a(ja+j)
t2 = aja - 0.5_dp * t1
t3 = c1 * ( ajb - ajc )
bjb = b(jb+j)
bjc = b(jc+j)
u1 = bjb + bjc
bja = b(ja+j)
u2 = bja - 0.5_dp * u1
u3 = c1 * ( bjb - bjc )
a(ja+j) = aja + t1
b(ja+j) = bja + u1
a(jb+j) = co1*(t2-u3) - si1*(u2+t3)
b(jb+j) = si1*(t2-u3) + co1*(u2+t3)
a(jc+j) = co2*(t2+u3) - si2*(u2-t3)
b(jc+j) = si2*(t2+u3) + co2*(u2-t3)
j = j + jump
130 continue
!-----( end of loop across transforms )
ja = ja + jstepx
if (ja.lt.istart) ja = ja + ninc
135 continue
140 continue
!-----( end of loop along transforms )
kk = kk + 2*la
150 continue
!-----( end of loop on nonzero k )
la = 3*la
160 continue
!-----( end of loop on type I radix-3 passes)
!
!  loop on type II radix-3 passes
!  ------------------------------
400 continue
!
do 480 ipass = mh+1 , m
jstep = (n*inc) / (3*la)
jstepl = jstep - ninc
laincl = la*ink - ninc
!
!  k=0 loop (no twiddle factors)
!  -----------------------------
do 430 ll = 0 , (la-1)*ink , 3*jstep
!
do 420 jjj = ll , (n-1)*inc , 3*la*ink
ja = istart + jjj
!
!  "transverse" loop
!  -----------------
do 415 nu = 1 , inq
jb = ja + jstepl
if (jb.lt.istart) jb = jb + ninc
jc = jb + jstepl
if (jc.lt.istart) jc = jc + ninc
jd = ja + laincl
if (jd.lt.istart) jd = jd + ninc
je = jd + jstepl
if (je.lt.istart) je = je + ninc
jf = je + jstepl
if (jf.lt.istart) jf = jf + ninc
jg = jd + laincl
if (jg.lt.istart) jg = jg + ninc
jh = jg + jstepl
if (jh.lt.istart) jh = jh + ninc
ji = jh + jstepl
if (ji.lt.istart) ji = ji + ninc
j = 0
!
!  loop across transforms
!  ----------------------
#ifdef OLD_CRAY
!dir$ ivdep, shortloop
#endif
do 410 l = 1 , nvex
ajb = a(jb+j)
ajc = a(jc+j)
t1 = ajb + ajc
aja = a(ja+j)
t2 = aja - 0.5_dp * t1
t3 = c1 * ( ajb - ajc )
ajd = a(jd+j)
ajb =  ajd
bjb = b(jb+j)
bjc = b(jc+j)
u1 = bjb + bjc
bja = b(ja+j)
u2 = bja - 0.5_dp * u1
u3 = c1 * ( bjb - bjc )
bjd = b(jd+j)
bjb =  bjd
a(ja+j) = aja + t1
b(ja+j) = bja + u1
a(jd+j) = t2 - u3
b(jd+j) = u2 + t3
ajc =  t2 + u3
bjc =  u2 - t3
!----------------------
aje = a(je+j)
ajf = a(jf+j)
t1 = aje + ajf
t2 = ajb - 0.5_dp * t1
t3 = c1 * ( aje - ajf )
ajh = a(jh+j)
ajf =  ajh
bje = b(je+j)
bjf = b(jf+j)
u1 = bje + bjf
u2 = bjb - 0.5_dp * u1
u3 = c1 * ( bje - bjf )
bjh = b(jh+j)
bjf =  bjh
a(jb+j) = ajb + t1
b(jb+j) = bjb + u1
a(je+j) = t2 - u3
b(je+j) = u2 + t3
a(jh+j) = t2 + u3
b(jh+j) = u2 - t3
!----------------------
aji = a(ji+j)
t1 = ajf + aji
ajg = a(jg+j)
t2 = ajg - 0.5_dp * t1
t3 = c1 * ( ajf - aji )
t1 = ajg + t1
a(jg+j) = ajc
bji = b(ji+j)
u1 = bjf + bji
bjg = b(jg+j)
u2 = bjg - 0.5_dp * u1
u3 = c1 * ( bjf - bji )
u1 = bjg + u1
b(jg+j) = bjc
a(jc+j) = t1
b(jc+j) = u1
a(jf+j) = t2 - u3
b(jf+j) = u2 + t3
a(ji+j) = t2 + u3
b(ji+j) = u2 - t3
j = j + jump
410 continue
!-----( end of loop across transforms )
ja = ja + jstepx
if (ja.lt.istart) ja = ja + ninc
415 continue
420 continue
430 continue
!-----( end of double loop for k=0 )
!
!  finished if last pass
!  ---------------------
if (ipass.eq.m) go to 490
!
kk = 2*la
!
!     loop on nonzero k
!     -----------------
do 470 k = ink , jstep-ink , ink
co1 = trigs(kk+1)
si1 = s*trigs(kk+2)
co2 = trigs(2*kk+1)
si2 = s*trigs(2*kk+2)
!
!  double loop along first transform in block
!  ------------------------------------------
do 460 ll = k , (la-1)*ink , 3*jstep
!
do 450 jjj = ll , (n-1)*inc , 3*la*ink
ja = istart + jjj
!
!  "transverse" loop
!  -----------------
do 445 nu = 1 , inq
jb = ja + jstepl
if (jb.lt.istart) jb = jb + ninc
jc = jb + jstepl
if (jc.lt.istart) jc = jc + ninc
jd = ja + laincl
if (jd.lt.istart) jd = jd + ninc
je = jd + jstepl
if (je.lt.istart) je = je + ninc
jf = je + jstepl
if (jf.lt.istart) jf = jf + ninc
jg = jd + laincl
if (jg.lt.istart) jg = jg + ninc
jh = jg + jstepl
if (jh.lt.istart) jh = jh + ninc
ji = jh + jstepl
if (ji.lt.istart) ji = ji + ninc
j = 0
!
!  loop across transforms
!  ----------------------
#ifdef OLD_CRAY
!dir$ ivdep, shortloop
#endif
do 440 l = 1 , nvex
ajb = a(jb+j)
ajc = a(jc+j)
t1 = ajb + ajc
aja = a(ja+j)
t2 = aja - 0.5_dp * t1
t3 = c1 * ( ajb - ajc )
ajd = a(jd+j)
ajb =  ajd
bjb = b(jb+j)
bjc = b(jc+j)
u1 = bjb + bjc
bja = b(ja+j)
u2 = bja - 0.5_dp * u1
u3 = c1 * ( bjb - bjc )
bjd = b(jd+j)
bjb =  bjd
a(ja+j) = aja + t1
b(ja+j) = bja + u1
a(jd+j) = co1*(t2-u3) - si1*(u2+t3)
b(jd+j) = si1*(t2-u3) + co1*(u2+t3)
ajc =  co2*(t2+u3) - si2*(u2-t3)
bjc =  si2*(t2+u3) + co2*(u2-t3)
!----------------------
aje = a(je+j)
ajf = a(jf+j)
t1 = aje + ajf
t2 = ajb - 0.5_dp * t1
t3 = c1 * ( aje - ajf )
ajh = a(jh+j)
ajf =  ajh
bje = b(je+j)
bjf = b(jf+j)
u1 = bje + bjf
u2 = bjb - 0.5_dp * u1
u3 = c1 * ( bje - bjf )
bjh = b(jh+j)
bjf =  bjh
a(jb+j) = ajb + t1
b(jb+j) = bjb + u1
a(je+j) = co1*(t2-u3) - si1*(u2+t3)
b(je+j) = si1*(t2-u3) + co1*(u2+t3)
a(jh+j) = co2*(t2+u3) - si2*(u2-t3)
b(jh+j) = si2*(t2+u3) + co2*(u2-t3)
!----------------------
aji = a(ji+j)
t1 = ajf + aji
ajg = a(jg+j)
t2 = ajg - 0.5_dp * t1
t3 = c1 * ( ajf - aji )
t1 = ajg + t1
a(jg+j) = ajc
bji = b(ji+j)
u1 = bjf + bji
bjg = b(jg+j)
u2 = bjg - 0.5_dp * u1
u3 = c1 * ( bjf - bji )
u1 = bjg + u1
b(jg+j) = bjc
a(jc+j) = t1
b(jc+j) = u1
a(jf+j) = co1*(t2-u3) - si1*(u2+t3)
b(jf+j) = si1*(t2-u3) + co1*(u2+t3)
a(ji+j) = co2*(t2+u3) - si2*(u2-t3)
b(ji+j) = si2*(t2+u3) + co2*(u2-t3)
j = j + jump
440 continue
!-----(end of loop across transforms)
ja = ja + jstepx
if (ja.lt.istart) ja = ja + ninc
445 continue
450 continue
460 continue
!-----( end of double loop for this k )
kk = kk + 2*la
470 continue
!-----( end of loop over values of k )
la = 3*la
480 continue
!-----( end of loop on type II radix-3 passes )
!-----( nvex transforms completed)
490 continue
istart = istart + nvex * jump
500 continue
!-----( end of loop on blocks of transforms )
!
return
end subroutine gpfa3f

!*******************************************************************

!     fortran version of *gpfa5* -
!     radix-5 section of self-sorting, in-place,
!        generalized pfa
!
!-------------------------------------------------------------------
!
subroutine gpfa5f(a,b,trigs,inc,jump,n,mm,lot,isign)

real(wp)     ::     a(*), b(*)
real(dp)     ::     trigs(*)
integer inc, jump, n, mm, lot, isign

real(dp), parameter :: sin36 = 0.587785252292473_dp, &
                       sin72 = 0.951056516295154_dp, &
                       qrt5  = 0.559016994374947_dp
integer, parameter  :: lvr = 128

integer      ::  inq, jstepx, ninc, ink, mu, m, mh, &
                 nblox, n5, left, istart, nb, nvex, la, &
                 ipass, jstep, jstepl, kk, k, jjj, ja, &
                 nu, jb, jc, jd, je, j, laincl, ll, l, &
                 jf, jg, jh, ji, jj, jk, jl, jm, jn, jo, &
                 jp, jq, jr, js, jt, ju, jv, jw, jx, jy

real(dp) ::  s, c1, c2, c3, co1, si1, co2, si2, co3, &
                 si3, co4, si4, ajb, aje, t1, ajc, ajd, &
                 t2, t3, t4, t5, t6, aja, t7, t8, t9, t10, &
                 t11, bjb, bje, u1, bjc, bjd, u2, u3, u4, &
                 u5, u6, bja, u7, u8, u9, u10, u11, ajf, &
                 ajk, bjf, bjk, ajg, ajj, ajh, aji, ajl, &
                 ajq, bjg, bjj, bjh, bji, bjl, bjq, ajo, &
                 ajm, ajn, ajr, ajw, bjo, bjm, bjn, bjr, &
                 bjw, ajt, ajs, ajx, ajp, ax, bjt, bjs, &
                 bjx, bjp, bx, ajv, ajy, aju, bjv, bjy, &
                 bju
!
!     ***************************************************************
!     *                                                             *
!     *  N.B. LVR = LENGTH OF VECTOR REGISTERS, SET TO 128 FOR C90. *
!     *  RESET TO 64 FOR OTHER CRAY MACHINES, OR TO ANY LARGE VALUE *
!     *  (GREATER THAN OR EQUAL TO LOT) FOR A SCALAR COMPUTER.      *
!     *                                                             *
!     ***************************************************************
!
n5 = 5 ** mm
inq = n / n5
jstepx = (n5-n) * inc
ninc = n * inc
ink = inc * inq
mu = mod(inq,5)
if (isign.eq.-1) mu = 5 - mu
!
m = mm
mh = (m+1)/2
s = real(isign,kind=dp)
c1 = qrt5
c2 = sin72
c3 = sin36
if (mu.eq.2.or.mu.eq.3) then
   c1 = -c1
   c2 = sin36
   c3 = sin72
endif
if (mu.eq.3.or.mu.eq.4) c2 = -c2
if (mu.eq.2.or.mu.eq.4) c3 = -c3
!
nblox = 1 + (lot-1)/lvr
left = lot
s = real(isign,kind=dp)
istart = 1
!
!  loop on blocks of lvr transforms
!  --------------------------------
do 500 nb = 1 , nblox
!
if (left.le.lvr) then
   nvex = left
else if (left.lt.(2*lvr)) then
   nvex = left/2
   nvex = nvex + mod(nvex,2)
else
   nvex = lvr
endif
left = left - nvex
!
la = 1
!
!  loop on type I radix-5 passes
!  -----------------------------
do 160 ipass = 1 , mh
jstep = (n*inc) / (5*la)
jstepl = jstep - ninc
kk = 0
!
!  loop on k
!  ---------
do 150 k = 0 , jstep-ink , ink
!
if (k.gt.0) then
co1 = trigs(kk+1)
si1 = s*trigs(kk+2)
co2 = trigs(2*kk+1)
si2 = s*trigs(2*kk+2)
co3 = trigs(3*kk+1)
si3 = s*trigs(3*kk+2)
co4 = trigs(4*kk+1)
si4 = s*trigs(4*kk+2)
endif
!
!  loop along transform
!  --------------------
do 140 jjj = k , (n-1)*inc , 5*jstep
ja = istart + jjj
!
!     "transverse" loop
!     -----------------
do 135 nu = 1 , inq
jb = ja + jstepl
if (jb.lt.istart) jb = jb + ninc
jc = jb + jstepl
if (jc.lt.istart) jc = jc + ninc
jd = jc + jstepl
if (jd.lt.istart) jd = jd + ninc
je = jd + jstepl
if (je.lt.istart) je = je + ninc
j = 0
!
!  loop across transforms
!  ----------------------
if (k.eq.0) then
!
#ifdef OLD_CRAY
!dir$ ivdep, shortloop
#endif
do 110 l = 1 , nvex
ajb = a(jb+j)
aje = a(je+j)
t1 = ajb + aje
ajc = a(jc+j)
ajd = a(jd+j)
t2 = ajc + ajd
t3 = ajb - aje
t4 = ajc - ajd
t5 = t1 + t2
t6 = c1 * ( t1 - t2 )
aja = a(ja+j)
t7 = aja - 0.25_dp * t5
a(ja+j) = aja + t5
t8 = t7 + t6
t9 = t7 - t6
t10 = c3 * t3 - c2 * t4
t11 = c2 * t3 + c3 * t4
bjb = b(jb+j)
bje = b(je+j)
u1 = bjb + bje
bjc = b(jc+j)
bjd = b(jd+j)
u2 = bjc + bjd
u3 = bjb - bje
u4 = bjc - bjd
u5 = u1 + u2
u6 = c1 * ( u1 - u2 )
bja = b(ja+j)
u7 = bja - 0.25_dp * u5
b(ja+j) = bja + u5
u8 = u7 + u6
u9 = u7 - u6
u10 = c3 * u3 - c2 * u4
u11 = c2 * u3 + c3 * u4
a(jb+j) = t8 - u11
b(jb+j) = u8 + t11
a(je+j) = t8 + u11
b(je+j) = u8 - t11
a(jc+j) = t9 - u10
b(jc+j) = u9 + t10
a(jd+j) = t9 + u10
b(jd+j) = u9 - t10
j = j + jump
110 continue
!
else
!
#ifdef OLD_CRAY
!dir$ ivdep, shortloop
#endif
do 130 l = 1 , nvex
ajb = a(jb+j)
aje = a(je+j)
t1 = ajb + aje
ajc = a(jc+j)
ajd = a(jd+j)
t2 = ajc + ajd
t3 = ajb - aje
t4 = ajc - ajd
t5 = t1 + t2
t6 = c1 * ( t1 - t2 )
aja = a(ja+j)
t7 = aja - 0.25_dp * t5
a(ja+j) = aja + t5
t8 = t7 + t6
t9 = t7 - t6
t10 = c3 * t3 - c2 * t4
t11 = c2 * t3 + c3 * t4
bjb = b(jb+j)
bje = b(je+j)
u1 = bjb + bje
bjc = b(jc+j)
bjd = b(jd+j)
u2 = bjc + bjd
u3 = bjb - bje
u4 = bjc - bjd
u5 = u1 + u2
u6 = c1 * ( u1 - u2 )
bja = b(ja+j)
u7 = bja - 0.25_dp * u5
b(ja+j) = bja + u5
u8 = u7 + u6
u9 = u7 - u6
u10 = c3 * u3 - c2 * u4
u11 = c2 * u3 + c3 * u4
a(jb+j) = co1*(t8-u11) - si1*(u8+t11)
b(jb+j) = si1*(t8-u11) + co1*(u8+t11)
a(je+j) = co4*(t8+u11) - si4*(u8-t11)
b(je+j) = si4*(t8+u11) + co4*(u8-t11)
a(jc+j) = co2*(t9-u10) - si2*(u9+t10)
b(jc+j) = si2*(t9-u10) + co2*(u9+t10)
a(jd+j) = co3*(t9+u10) - si3*(u9-t10)
b(jd+j) = si3*(t9+u10) + co3*(u9-t10)
j = j + jump
130 continue
!
endif
!
!-----( end of loop across transforms )
!
ja = ja + jstepx
if (ja.lt.istart) ja = ja + ninc
135 continue
140 continue
!-----( end of loop along transforms )
kk = kk + 2*la
150 continue
!-----( end of loop on nonzero k )
la = 5*la
160 continue
!-----( end of loop on type I radix-5 passes)
!
if (n.eq.5) go to 490
!
!  loop on type II radix-5 passes
!  ------------------------------
400 continue
!
do 480 ipass = mh+1 , m
jstep = (n*inc) / (5*la)
jstepl = jstep - ninc
laincl = la * ink - ninc
kk = 0
!
!     loop on k
!     ---------
do 470 k = 0 , jstep-ink , ink
!
if (k.gt.0) then
co1 = trigs(kk+1)
si1 = s*trigs(kk+2)
co2 = trigs(2*kk+1)
si2 = s*trigs(2*kk+2)
co3 = trigs(3*kk+1)
si3 = s*trigs(3*kk+2)
co4 = trigs(4*kk+1)
si4 = s*trigs(4*kk+2)
endif
!
!  double loop along first transform in block
!  ------------------------------------------
do 460 ll = k , (la-1)*ink , 5*jstep
!
do 450 jjj = ll , (n-1)*inc , 5*la*ink
ja = istart + jjj
!
!     "transverse" loop
!     -----------------
do 445 nu = 1 , inq
jb = ja + jstepl
if (jb.lt.istart) jb = jb + ninc
jc = jb + jstepl
if (jc.lt.istart) jc = jc + ninc
jd = jc + jstepl
if (jd.lt.istart) jd = jd + ninc
je = jd + jstepl
if (je.lt.istart) je = je + ninc
jf = ja + laincl
if (jf.lt.istart) jf = jf + ninc
jg = jf + jstepl
if (jg.lt.istart) jg = jg + ninc
jh = jg + jstepl
if (jh.lt.istart) jh = jh + ninc
ji = jh + jstepl
if (ji.lt.istart) ji = ji + ninc
jj = ji + jstepl
if (jj.lt.istart) jj = jj + ninc
jk = jf + laincl
if (jk.lt.istart) jk = jk + ninc
jl = jk + jstepl
if (jl.lt.istart) jl = jl + ninc
jm = jl + jstepl
if (jm.lt.istart) jm = jm + ninc
jn = jm + jstepl
if (jn.lt.istart) jn = jn + ninc
jo = jn + jstepl
if (jo.lt.istart) jo = jo + ninc
jp = jk + laincl
if (jp.lt.istart) jp = jp + ninc
jq = jp + jstepl
if (jq.lt.istart) jq = jq + ninc
jr = jq + jstepl
if (jr.lt.istart) jr = jr + ninc
js = jr + jstepl
if (js.lt.istart) js = js + ninc
jt = js + jstepl
if (jt.lt.istart) jt = jt + ninc
ju = jp + laincl
if (ju.lt.istart) ju = ju + ninc
jv = ju + jstepl
if (jv.lt.istart) jv = jv + ninc
jw = jv + jstepl
if (jw.lt.istart) jw = jw + ninc
jx = jw + jstepl
if (jx.lt.istart) jx = jx + ninc
jy = jx + jstepl
if (jy.lt.istart) jy = jy + ninc
j = 0
!
!  loop across transforms
!  ----------------------
if (k.eq.0) then
!
#ifdef OLD_CRAY
!dir$ ivdep, shortloop
#endif
do 410 l = 1 , nvex
ajb = a(jb+j)
aje = a(je+j)
t1 = ajb + aje
ajc = a(jc+j)
ajd = a(jd+j)
t2 = ajc + ajd
t3 = ajb - aje
t4 = ajc - ajd
ajf = a(jf+j)
ajb =  ajf
t5 = t1 + t2
t6 = c1 * ( t1 - t2 )
aja = a(ja+j)
t7 = aja - 0.25_dp * t5
a(ja+j) = aja + t5
t8 = t7 + t6
t9 = t7 - t6
ajk = a(jk+j)
ajc =  ajk
t10 = c3 * t3 - c2 * t4
t11 = c2 * t3 + c3 * t4
bjb = b(jb+j)
bje = b(je+j)
u1 = bjb + bje
bjc = b(jc+j)
bjd = b(jd+j)
u2 = bjc + bjd
u3 = bjb - bje
u4 = bjc - bjd
bjf = b(jf+j)
bjb =  bjf
u5 = u1 + u2
u6 = c1 * ( u1 - u2 )
bja = b(ja+j)
u7 = bja - 0.25_dp * u5
b(ja+j) = bja + u5
u8 = u7 + u6
u9 = u7 - u6
bjk = b(jk+j)
bjc =  bjk
u10 = c3 * u3 - c2 * u4
u11 = c2 * u3 + c3 * u4
a(jf+j) = t8 - u11
b(jf+j) = u8 + t11
aje =  t8 + u11
bje =  u8 - t11
a(jk+j) = t9 - u10
b(jk+j) = u9 + t10
ajd =  t9 + u10
bjd =  u9 - t10
!----------------------
ajg = a(jg+j)
ajj = a(jj+j)
t1 = ajg + ajj
ajh = a(jh+j)
aji = a(ji+j)
t2 = ajh + aji
t3 = ajg - ajj
t4 = ajh - aji
ajl = a(jl+j)
ajh =  ajl
t5 = t1 + t2
t6 = c1 * ( t1 - t2 )
t7 = ajb - 0.25_dp * t5
a(jb+j) = ajb + t5
t8 = t7 + t6
t9 = t7 - t6
ajq = a(jq+j)
aji =  ajq
t10 = c3 * t3 - c2 * t4
t11 = c2 * t3 + c3 * t4
bjg = b(jg+j)
bjj = b(jj+j)
u1 = bjg + bjj
bjh = b(jh+j)
bji = b(ji+j)
u2 = bjh + bji
u3 = bjg - bjj
u4 = bjh - bji
bjl = b(jl+j)
bjh =  bjl
u5 = u1 + u2
u6 = c1 * ( u1 - u2 )
u7 = bjb - 0.25_dp * u5
b(jb+j) = bjb + u5
u8 = u7 + u6
u9 = u7 - u6
bjq = b(jq+j)
bji =  bjq
u10 = c3 * u3 - c2 * u4
u11 = c2 * u3 + c3 * u4
a(jg+j) = t8 - u11
b(jg+j) = u8 + t11
ajj =  t8 + u11
bjj =  u8 - t11
a(jl+j) = t9 - u10
b(jl+j) = u9 + t10
a(jq+j) = t9 + u10
b(jq+j) = u9 - t10
!----------------------
ajo = a(jo+j)
t1 = ajh + ajo
ajm = a(jm+j)
ajn = a(jn+j)
t2 = ajm + ajn
t3 = ajh - ajo
t4 = ajm - ajn
ajr = a(jr+j)
ajn =  ajr
t5 = t1 + t2
t6 = c1 * ( t1 - t2 )
t7 = ajc - 0.25_dp * t5
a(jc+j) = ajc + t5
t8 = t7 + t6
t9 = t7 - t6
ajw = a(jw+j)
ajo =  ajw
t10 = c3 * t3 - c2 * t4
t11 = c2 * t3 + c3 * t4
bjo = b(jo+j)
u1 = bjh + bjo
bjm = b(jm+j)
bjn = b(jn+j)
u2 = bjm + bjn
u3 = bjh - bjo
u4 = bjm - bjn
bjr = b(jr+j)
bjn =  bjr
u5 = u1 + u2
u6 = c1 * ( u1 - u2 )
u7 = bjc - 0.25_dp * u5
b(jc+j) = bjc + u5
u8 = u7 + u6
u9 = u7 - u6
bjw = b(jw+j)
bjo =  bjw
u10 = c3 * u3 - c2 * u4
u11 = c2 * u3 + c3 * u4
a(jh+j) = t8 - u11
b(jh+j) = u8 + t11
a(jw+j) = t8 + u11
b(jw+j) = u8 - t11
a(jm+j) = t9 - u10
b(jm+j) = u9 + t10
a(jr+j) = t9 + u10
b(jr+j) = u9 - t10
!----------------------
ajt = a(jt+j)
t1 = aji + ajt
ajs = a(js+j)
t2 = ajn + ajs
t3 = aji - ajt
t4 = ajn - ajs
ajx = a(jx+j)
ajt =  ajx
t5 = t1 + t2
t6 = c1 * ( t1 - t2 )
ajp = a(jp+j)
t7 = ajp - 0.25_dp * t5
ax = ajp + t5
t8 = t7 + t6
t9 = t7 - t6
a(jp+j) = ajd
t10 = c3 * t3 - c2 * t4
t11 = c2 * t3 + c3 * t4
a(jd+j) = ax
bjt = b(jt+j)
u1 = bji + bjt
bjs = b(js+j)
u2 = bjn + bjs
u3 = bji - bjt
u4 = bjn - bjs
bjx = b(jx+j)
bjt =  bjx
u5 = u1 + u2
u6 = c1 * ( u1 - u2 )
bjp = b(jp+j)
u7 = bjp - 0.25_dp * u5
bx = bjp + u5
u8 = u7 + u6
u9 = u7 - u6
b(jp+j) = bjd
u10 = c3 * u3 - c2 * u4
u11 = c2 * u3 + c3 * u4
b(jd+j) = bx
a(ji+j) = t8 - u11
b(ji+j) = u8 + t11
a(jx+j) = t8 + u11
b(jx+j) = u8 - t11
a(jn+j) = t9 - u10
b(jn+j) = u9 + t10
a(js+j) = t9 + u10
b(js+j) = u9 - t10
!----------------------
ajv = a(jv+j)
ajy = a(jy+j)
t1 = ajv + ajy
t2 = ajo + ajt
t3 = ajv - ajy
t4 = ajo - ajt
a(jv+j) = ajj
t5 = t1 + t2
t6 = c1 * ( t1 - t2 )
aju = a(ju+j)
t7 = aju - 0.25_dp * t5
ax = aju + t5
t8 = t7 + t6
t9 = t7 - t6
a(ju+j) = aje
t10 = c3 * t3 - c2 * t4
t11 = c2 * t3 + c3 * t4
a(je+j) = ax
bjv = b(jv+j)
bjy = b(jy+j)
u1 = bjv + bjy
u2 = bjo + bjt
u3 = bjv - bjy
u4 = bjo - bjt
b(jv+j) = bjj
u5 = u1 + u2
u6 = c1 * ( u1 - u2 )
bju = b(ju+j)
u7 = bju - 0.25_dp * u5
bx = bju + u5
u8 = u7 + u6
u9 = u7 - u6
b(ju+j) = bje
u10 = c3 * u3 - c2 * u4
u11 = c2 * u3 + c3 * u4
b(je+j) = bx
a(jj+j) = t8 - u11
b(jj+j) = u8 + t11
a(jy+j) = t8 + u11
b(jy+j) = u8 - t11
a(jo+j) = t9 - u10
b(jo+j) = u9 + t10
a(jt+j) = t9 + u10
b(jt+j) = u9 - t10
j = j + jump
410 continue
!
else
!
#ifdef OLD_CRAY
!dir$ ivdep, shortloop
#endif
do 440 l = 1 , nvex
ajb = a(jb+j)
aje = a(je+j)
t1 = ajb + aje
ajc = a(jc+j)
ajd = a(jd+j)
t2 = ajc + ajd
t3 = ajb - aje
t4 = ajc - ajd
ajf = a(jf+j)
ajb =  ajf
t5 = t1 + t2
t6 = c1 * ( t1 - t2 )
aja = a(ja+j)
t7 = aja - 0.25_dp * t5
a(ja+j) = aja + t5
t8 = t7 + t6
t9 = t7 - t6
ajk = a(jk+j)
ajc =  ajk
t10 = c3 * t3 - c2 * t4
t11 = c2 * t3 + c3 * t4
bjb = b(jb+j)
bje = b(je+j)
u1 = bjb + bje
bjc = b(jc+j)
bjd = b(jd+j)
u2 = bjc + bjd
u3 = bjb - bje
u4 = bjc - bjd
bjf = b(jf+j)
bjb =  bjf
u5 = u1 + u2
u6 = c1 * ( u1 - u2 )
bja = b(ja+j)
u7 = bja - 0.25_dp * u5
b(ja+j) = bja + u5
u8 = u7 + u6
u9 = u7 - u6
bjk = b(jk+j)
bjc =  bjk
u10 = c3 * u3 - c2 * u4
u11 = c2 * u3 + c3 * u4
a(jf+j) = co1*(t8-u11) - si1*(u8+t11)
b(jf+j) = si1*(t8-u11) + co1*(u8+t11)
aje =  co4*(t8+u11) - si4*(u8-t11)
bje =  si4*(t8+u11) + co4*(u8-t11)
a(jk+j) = co2*(t9-u10) - si2*(u9+t10)
b(jk+j) = si2*(t9-u10) + co2*(u9+t10)
ajd =  co3*(t9+u10) - si3*(u9-t10)
bjd =  si3*(t9+u10) + co3*(u9-t10)
!----------------------
ajg = a(jg+j)
ajj = a(jj+j)
t1 = ajg + ajj
ajh = a(jh+j)
aji = a(ji+j)
t2 = ajh + aji
t3 = ajg - ajj
t4 = ajh - aji
ajl = a(jl+j)
ajh =  ajl
t5 = t1 + t2
t6 = c1 * ( t1 - t2 )
t7 = ajb - 0.25_dp * t5
a(jb+j) = ajb + t5
t8 = t7 + t6
t9 = t7 - t6
ajq = a(jq+j)
aji =  ajq
t10 = c3 * t3 - c2 * t4
t11 = c2 * t3 + c3 * t4
bjg = b(jg+j)
bjj = b(jj+j)
u1 = bjg + bjj
bjh = b(jh+j)
bji = b(ji+j)
u2 = bjh + bji
u3 = bjg - bjj
u4 = bjh - bji
bjl = b(jl+j)
bjh =  bjl
u5 = u1 + u2
u6 = c1 * ( u1 - u2 )
u7 = bjb - 0.25_dp * u5
b(jb+j) = bjb + u5
u8 = u7 + u6
u9 = u7 - u6
bjq = b(jq+j)
bji =  bjq
u10 = c3 * u3 - c2 * u4
u11 = c2 * u3 + c3 * u4
a(jg+j) = co1*(t8-u11) - si1*(u8+t11)
b(jg+j) = si1*(t8-u11) + co1*(u8+t11)
ajj =  co4*(t8+u11) - si4*(u8-t11)
bjj =  si4*(t8+u11) + co4*(u8-t11)
a(jl+j) = co2*(t9-u10) - si2*(u9+t10)
b(jl+j) = si2*(t9-u10) + co2*(u9+t10)
a(jq+j) = co3*(t9+u10) - si3*(u9-t10)
b(jq+j) = si3*(t9+u10) + co3*(u9-t10)
!----------------------
ajo = a(jo+j)
t1 = ajh + ajo
ajm = a(jm+j)
ajn = a(jn+j)
t2 = ajm + ajn
t3 = ajh - ajo
t4 = ajm - ajn
ajr = a(jr+j)
ajn =  ajr
t5 = t1 + t2
t6 = c1 * ( t1 - t2 )
t7 = ajc - 0.25_dp * t5
a(jc+j) = ajc + t5
t8 = t7 + t6
t9 = t7 - t6
ajw = a(jw+j)
ajo =  ajw
t10 = c3 * t3 - c2 * t4
t11 = c2 * t3 + c3 * t4
bjo = b(jo+j)
u1 = bjh + bjo
bjm = b(jm+j)
bjn = b(jn+j)
u2 = bjm + bjn
u3 = bjh - bjo
u4 = bjm - bjn
bjr = b(jr+j)
bjn =  bjr
u5 = u1 + u2
u6 = c1 * ( u1 - u2 )
u7 = bjc - 0.25_dp * u5
b(jc+j) = bjc + u5
u8 = u7 + u6
u9 = u7 - u6
bjw = b(jw+j)
bjo =  bjw
u10 = c3 * u3 - c2 * u4
u11 = c2 * u3 + c3 * u4
a(jh+j) = co1*(t8-u11) - si1*(u8+t11)
b(jh+j) = si1*(t8-u11) + co1*(u8+t11)
a(jw+j) = co4*(t8+u11) - si4*(u8-t11)
b(jw+j) = si4*(t8+u11) + co4*(u8-t11)
a(jm+j) = co2*(t9-u10) - si2*(u9+t10)
b(jm+j) = si2*(t9-u10) + co2*(u9+t10)
a(jr+j) = co3*(t9+u10) - si3*(u9-t10)
b(jr+j) = si3*(t9+u10) + co3*(u9-t10)
!----------------------
ajt = a(jt+j)
t1 = aji + ajt
ajs = a(js+j)
t2 = ajn + ajs
t3 = aji - ajt
t4 = ajn - ajs
ajx = a(jx+j)
ajt =  ajx
t5 = t1 + t2
t6 = c1 * ( t1 - t2 )
ajp = a(jp+j)
t7 = ajp - 0.25_dp * t5
ax = ajp + t5
t8 = t7 + t6
t9 = t7 - t6
a(jp+j) = ajd
t10 = c3 * t3 - c2 * t4
t11 = c2 * t3 + c3 * t4
a(jd+j) = ax
bjt = b(jt+j)
u1 = bji + bjt
bjs = b(js+j)
u2 = bjn + bjs
u3 = bji - bjt
u4 = bjn - bjs
bjx = b(jx+j)
bjt =  bjx
u5 = u1 + u2
u6 = c1 * ( u1 - u2 )
bjp = b(jp+j)
u7 = bjp - 0.25_dp * u5
bx = bjp + u5
u8 = u7 + u6
u9 = u7 - u6
b(jp+j) = bjd
u10 = c3 * u3 - c2 * u4
u11 = c2 * u3 + c3 * u4
b(jd+j) = bx
a(ji+j) = co1*(t8-u11) - si1*(u8+t11)
b(ji+j) = si1*(t8-u11) + co1*(u8+t11)
a(jx+j) = co4*(t8+u11) - si4*(u8-t11)
b(jx+j) = si4*(t8+u11) + co4*(u8-t11)
a(jn+j) = co2*(t9-u10) - si2*(u9+t10)
b(jn+j) = si2*(t9-u10) + co2*(u9+t10)
a(js+j) = co3*(t9+u10) - si3*(u9-t10)
b(js+j) = si3*(t9+u10) + co3*(u9-t10)
!----------------------
ajv = a(jv+j)
ajy = a(jy+j)
t1 = ajv + ajy
t2 = ajo + ajt
t3 = ajv - ajy
t4 = ajo - ajt
a(jv+j) = ajj
t5 = t1 + t2
t6 = c1 * ( t1 - t2 )
aju = a(ju+j)
t7 = aju - 0.25_dp * t5
ax = aju + t5
t8 = t7 + t6
t9 = t7 - t6
a(ju+j) = aje
t10 = c3 * t3 - c2 * t4
t11 = c2 * t3 + c3 * t4
a(je+j) = ax
bjv = b(jv+j)
bjy = b(jy+j)
u1 = bjv + bjy
u2 = bjo + bjt
u3 = bjv - bjy
u4 = bjo - bjt
b(jv+j) = bjj
u5 = u1 + u2
u6 = c1 * ( u1 - u2 )
bju = b(ju+j)
u7 = bju - 0.25_dp * u5
bx = bju + u5
u8 = u7 + u6
u9 = u7 - u6
b(ju+j) = bje
u10 = c3 * u3 - c2 * u4
u11 = c2 * u3 + c3 * u4
b(je+j) = bx
a(jj+j) = co1*(t8-u11) - si1*(u8+t11)
b(jj+j) = si1*(t8-u11) + co1*(u8+t11)
a(jy+j) = co4*(t8+u11) - si4*(u8-t11)
b(jy+j) = si4*(t8+u11) + co4*(u8-t11)
a(jo+j) = co2*(t9-u10) - si2*(u9+t10)
b(jo+j) = si2*(t9-u10) + co2*(u9+t10)
a(jt+j) = co3*(t9+u10) - si3*(u9-t10)
b(jt+j) = si3*(t9+u10) + co3*(u9-t10)
j = j + jump
440 continue
!
endif
!
!-----(end of loop across transforms)
!
ja = ja + jstepx
if (ja.lt.istart) ja = ja + ninc
445 continue
450 continue
460 continue
!-----( end of double loop for this k )
kk = kk + 2*la
470 continue
!-----( end of loop over values of k )
la = 5*la
480 continue
!-----( end of loop on type II radix-5 passes )
!-----( nvex transforms completed)
490 continue
istart = istart + nvex * jump
500 continue
!-----( end of loop on blocks of transforms )
!
return
end subroutine gpfa5f

end module gridxc_gpfa_core_dp




module gridxc_fft_gpfa
 use gridxc_sys, only: die
!
!     1d fft routine based on Clive Temperton's GPFA package
!
use gridxc_gpfa_core_sp, only: gpfa
use gridxc_gpfa_core_dp, only: gpfa

implicit none

integer, parameter :: dp = selected_real_kind(10,100)
integer, parameter :: sp = selected_real_kind(6,10)

  ! This module is not thread safe due to the use of
  ! these global variables.
  ! To make it thread-safe, and to have more control over
  ! the re-use of the auxiliary twiddle factors, you might
  ! define a derived type to hold them and call the wrapper routines
  ! with it as one of the arguments.

real(dp), allocatable, save :: trigs(:)
integer, save :: nold = -1
  !----------------------------------------------------------
! auxiliary variable
character(len=20) :: msg

public :: nfft            ! Generates N compatible with the fft

interface fft_gpfa_ez
   module procedure fft_gpfa_ez_dp
   module procedure fft_gpfa_ez_sp
end interface fft_gpfa_ez

interface fft_gpfa
   module procedure fft_gpfa_dp
   module procedure fft_gpfa_sp
end interface fft_gpfa

public :: fft_gpfa_ez     ! Simple version with complex array
public :: fft_gpfa        ! General version with strides,
                          ! multiple vectors, etc

! Wrapper for setgpfa which returns proper length of work array
public :: setgpfa_check

! Access to the standard legacy routines, if needed
public :: gpfa, setgpfa

private 

CONTAINS

SUBROUTINE nfft( N )

integer, intent(inout) :: N

! CHANGES N INTO THE NEXT INTEGER ALLOWED BY THE FFT ROUTINE
! WRITTEN BY J.M.SOLER. MAY/95.
! Modified by A. Garcia, May 2015

integer :: np, nmax, nmin, nrem, ip
! no limits with huge, but subtract 2 to avoid 'overflow' warning
parameter (NP = 3, NMAX = huge(N)-2)  
integer :: IPRIME(NP)
data IPRIME / 2, 3, 5 /

NMIN = N
DO N = NMIN, NMAX
  NREM = N
  DO IP = 1,NP
10     CONTINUE 
    IF ( MODULO( NREM, IPRIME(IP) ) .EQ. 0 ) THEN
      NREM = NREM / IPRIME(IP)
      GOTO 10
    ENDIF
  ENDDO
  IF (NREM .EQ. 1) RETURN
ENDDO
write(msg,"(i0)") NMIN
call die('NFFT: NO SUITABLE INTEGER FOUND FOR N =' // trim(msg))
END SUBROUTINE nfft

!----------------------------------------------------
subroutine fft_gpfa_ez_sp(data,n,isign)

! packed complex array in a real array twice as long

integer, intent(in)     :: n
real(sp), intent(inout) :: data(2*n)
integer, intent(in)     :: isign

!        ISIGN = +1 FOR FORWARD TRANSFORM
!              = -1 FOR INVERSE TRANSFORM

  ! If n has changed since the last use,
  ! set trigs array, used by 1D-FFT routine gpfa

  ! The routine setgpfa_alloc is a special version
  ! of setgpfa which (re)allocates the trigs argument
  ! if needed, and re-fills it with new twiddle factors

if (n /= nold) then
   call setgpfa_alloc( trigs, n )
end if 

  ! FFT. Arguments of gpfa are:                                
  ! gpfa( realData(*), imagData(*), trigs(*),                    
  !       dataSpan, vectorSpan, vectorSize, numVectors, fftDir )              
  !
  ! Note dataSpan=2 since we are packing the real and imaginary
  ! parts in the same vector.

call gpfa( data(1:), data(2:), trigs, &
           2, 1, n, 1, isign )

nold = n

end subroutine fft_gpfa_ez_sp

!----------------------------------------------------
subroutine fft_gpfa_ez_dp(data,n,isign)

! packed complex array in a real array twice as long

integer, intent(in)     :: n
real(dp), intent(inout) :: data(2*n)
integer, intent(in)     :: isign

!        ISIGN = +1 FOR FORWARD TRANSFORM
!              = -1 FOR INVERSE TRANSFORM

  ! If n has changed since the last use,
  ! set trigs array, used by 1D-FFT routine gpfa

  ! The routine setgpfa_alloc is a special version
  ! of setgpfa which (re)allocates the trigs argument
  ! if needed, and re-fills it with new twiddle factors

if (n /= nold) then
   call setgpfa_alloc( trigs, n )
end if 

  ! FFT. Arguments of gpfa are:                                
  ! gpfa( realData(*), imagData(*), trigs(*),                    
  !       dataSpan, vectorSpan, vectorSize, numVectors, fftDir )              
  !
  ! Note dataSpan=2 since we are packing the real and imaginary
  ! parts in the same vector.

call gpfa( data(1:), data(2:), trigs, &
           2, 1, n, 1, isign )

nold = n

end subroutine fft_gpfa_ez_dp

!----------------------------------------------------------------------
subroutine fft_gpfa_sp(realData, imagData, &
                    dataSpan, vectorSpan, N, numVectors, &
                    isign ) 

! A wrapper for the GPFA routine which handles the
! work array automatically

real(sp), intent(inout) :: realData(:), imagData(:)
integer, intent(in)     :: dataSpan, vectorSpan, N, numVectors
integer, intent(in)     :: isign

!        ISIGN = +1 FOR FORWARD TRANSFORM
!              = -1 FOR INVERSE TRANSFORM

  ! Set trigs array, used by 1D-FFT routine gpfa
  ! The routine setgpfa_alloc is a special version
  ! of setgpfa which (re)allocates the trigs argument
  ! if needed, and re-fills it with new twiddle factors
  ! if n has changed since the last use.

if (n /= nold) then
   call setgpfa_alloc( trigs, n )
end if 

call gpfa(realData, imagData, trigs, &
          dataSpan, vectorSpan, N, numVectors, isign)

nold = n

end subroutine fft_gpfa_sp
!----------------------------------------------------------------------
subroutine fft_gpfa_dp(realData, imagData, &
                    dataSpan, vectorSpan, N, numVectors, &
                    isign ) 

! A wrapper for the GPFA routine which handles the
! work array automatically

real(dp), intent(inout) :: realData(:), imagData(:)
integer, intent(in)     :: dataSpan, vectorSpan, N, numVectors
integer, intent(in)     :: isign

!        ISIGN = +1 FOR FORWARD TRANSFORM
!              = -1 FOR INVERSE TRANSFORM

  ! Set trigs array, used by 1D-FFT routine gpfa
  ! The routine setgpfa_alloc is a special version
  ! of setgpfa which (re)allocates the trigs argument
  ! if needed, and re-fills it with new twiddle factors
  ! if n has changed since the last use.

if (n /= nold) then
   call setgpfa_alloc( trigs, n )
end if 

call gpfa(realData, imagData, trigs, &
          dataSpan, vectorSpan, N, numVectors, isign)

nold = n

end subroutine fft_gpfa_dp
!------------------------------------------------------------------
subroutine  setgpfa_alloc( trigs, n )
real(dp), allocatable, intent(inout) :: trigs(:)
integer, intent(in)                  :: n

integer :: ntrigs

if (.not. allocated(trigs)) then
   allocate(trigs(100))
endif
call setgpfa_check(trigs,size(trigs),ntrigs,n)

if (size(trigs) < ntrigs) then
   deallocate(trigs)
   allocate(trigs(ntrigs))
   call setgpfa_check(trigs,size(trigs),ntrigs,n)
   if (size(trigs) < ntrigs) STOP "ntrigs error"
endif

end subroutine setgpfa_alloc
!
SUBROUTINE SETGPFA_check(TRIGS,maxtrigs,ntrigs,N)
!
integer, intent(in)  :: maxtrigs  ! The current size of trigs
REAL(dp)  TRIGS(maxtrigs)
integer, intent(out) :: ntrigs    ! The needed size for trigs
integer, intent(in)  :: N

INTEGER NJ(3)
integer       :: nn, ifac, ll, kk, ip, iq, ir, &
                 i, ni, irot, kink, k
real(dp)      :: angle, twopi, del
!
!     DECOMPOSE N INTO FACTORS 2,3,5
!     ------------------------------
NN = N
IFAC = 2
!
DO 30 LL = 1 , 3
KK = 0
10 CONTINUE
IF (MOD(NN,IFAC).NE.0) GO TO 20
KK = KK + 1
NN = NN / IFAC
GO TO 10
20 CONTINUE
NJ(LL) = KK
IFAC = IFAC + LL
30 CONTINUE
!
IF (NN.NE.1) THEN
   write(msg,"(i0)") N
   call die('GPFA: '//trim(msg)//' IS NOT A LEGAL VALUE OF N')
ENDIF
!
IP = NJ(1)
IQ = NJ(2)
IR = NJ(3)
!
!     COMPUTE LIST OF ROTATED TWIDDLE FACTORS
!     ---------------------------------------
NJ(1) = 2**IP
NJ(2) = 3**IQ
NJ(3) = 5**IR
!
TWOPI = 4.0_dp * ASIN(1.0_dp)
I = 1
!
DO 60 LL = 1 , 3
NI = NJ(LL)
IF (NI.EQ.1) GO TO 60
!
DEL = TWOPI / real(NI,kind=dp)
IROT = N / NI
KINK = MOD(IROT,NI)
KK = 0
!
DO 50 K = 1 , NI
ANGLE = real(KK,kind=dp) * DEL
if (i.lt.maxtrigs) then
  TRIGS(I) = COS(ANGLE)
  TRIGS(I+1) = SIN(ANGLE)
endif
I = I + 2
KK = KK + KINK
IF (KK.GT.NI) KK = KK - NI
50 CONTINUE
60 CONTINUE
ntrigs = i - 1  ! note boundary. i is even
!
RETURN
END SUBROUTINE SETGPFA_check

!
!        SUBROUTINE 'SETGPFA'
!        SETUP ROUTINE FOR SELF-SORTING IN-PLACE
!            GENERALIZED PRIME FACTOR (COMPLEX) FFT [GPFA]
!
!        CALL SETGPFA(TRIGS,N)
!
!        INPUT :
!        -----
!        N IS THE LENGTH OF THE TRANSFORMS. N MUST BE OF THE FORM:
!          -----------------------------------
!            N = (2**IP) * (3**IQ) * (5**IR)
!          -----------------------------------
!
!        OUTPUT:
!        ------
!        TRIGS IS A TABLE OF TWIDDLE FACTORS,
!          OF LENGTH 2*IPQR (REAL) WORDS, WHERE:
!          --------------------------------------
!            IPQR = (2**IP) + (3**IQ) + (5**IR)
!          --------------------------------------
!
!        WRITTEN BY CLIVE TEMPERTON 1990
!
!*********************************************************************
!
SUBROUTINE SETGPFA(TRIGS,N)
!

INTEGER NJ(3)
REAL(dp) TRIGS(*)

integer       :: nn, n, ifac, ll, kk, ip, iq, ir, &
                 i, ni, irot, kink, k
real(dp)      :: angle, twopi, del
!
!     DECOMPOSE N INTO FACTORS 2,3,5
!     ------------------------------
NN = N
IFAC = 2
!
DO 30 LL = 1 , 3
KK = 0
10 CONTINUE
IF (MOD(NN,IFAC).NE.0) GO TO 20
KK = KK + 1
NN = NN / IFAC
GO TO 10
20 CONTINUE
NJ(LL) = KK
IFAC = IFAC + LL
30 CONTINUE
!
IF (NN.NE.1) THEN
   write(msg,"(i0)") N
   call die('GPFA: '//trim(msg)//' IS NOT A LEGAL VALUE OF N')
ENDIF
!
IP = NJ(1)
IQ = NJ(2)
IR = NJ(3)
!
!     COMPUTE LIST OF ROTATED TWIDDLE FACTORS
!     ---------------------------------------
NJ(1) = 2**IP
NJ(2) = 3**IQ
NJ(3) = 5**IR
!
TWOPI = 4.0_dp * ASIN(1.0_dp)
I = 1
!
DO 60 LL = 1 , 3
NI = NJ(LL)
IF (NI.EQ.1) GO TO 60
!
DEL = TWOPI / real(NI,kind=dp)
IROT = N / NI
KINK = MOD(IROT,NI)
KK = 0
!
DO 50 K = 1 , NI
ANGLE = real(KK,kind=dp) * DEL
TRIGS(I) = COS(ANGLE)
TRIGS(I+1) = SIN(ANGLE)
I = I + 2
KK = KK + KINK
IF (KK.GT.NI) KK = KK - NI
50 CONTINUE
60 CONTINUE
!
RETURN
END SUBROUTINE SETGPFA

end module gridxc_fft_gpfa

#if defined HAVE_CONFIG_H
#include "config.h"
#endif

PROGRAM gridXCtest4

  ! Compares the energy and potential calculated by atomXC and cellXC.
  ! J.M.Soler. Sept.2009

  ! Used module procedures
  USE gridXC, only: atomXC => gridxc_atomXC
  USE gridXC, only: gridxc_init
  USE gridXC, only: cellXC => gridxc_cellXC
  USE gridXC, only: setXC  => gridxc_setXC

  ! Used module parameters
  USE gridXC, only: dp
  USE gridXC, only: gp => grid_p

! Used MPI types
#ifdef HAVE_MPI
  USE mpi
#endif

  implicit none

  ! Tester parameters
  integer, parameter:: irel  =  0 ! Relativistic? 0=>no, 1=>yes
  integer, parameter:: nSpin =  2 ! Number of spin components
  integer, parameter:: nfTot = 19 ! Number of functionals
  integer, parameter:: nr = 501   ! Number of radial points
  integer, parameter:: nx = 60    ! Number of grid points per lattice vector
  integer, parameter:: n1cut = 8  ! Cutoff parameter
  integer, parameter:: n2cut = 2  ! Cutoff parameter:
                                  !    fCut(r)=(1-(r/rMax)**n1cut)**n2cut
  real(dp),parameter:: dWidth = 2._dp ! Width of density distribution, in Bohr
  real(dp),parameter:: Qtot = 10._dp  ! Integral of density distribution
  real(dp),parameter:: spinPol= 2._dp ! Integral of densUp - densDown
  real(dp),parameter:: rMax = 12._dp  ! Cutoff radius, in Bohr
  real(dp),parameter:: rBuff = 3._dp  ! Radial buffer of zero density, in Bohr
  real(dp),parameter:: densMin  = 1.e-9_dp  ! Min. density to proceed

  ! List of functionals to be tested
!  integer, parameter:: nf = nfTot-4   ! Number of tested functionals
!  integer:: indexf(nf) = (/1,2,3,4,5,6,7,8,9,10,11,12,13,14,  18/) 
!                         ! Indexes from list below (only one VDW allowed)

  ! Same to test a single functional
  integer, parameter:: nf = 1        ! Number of tested functionals
  integer:: indexf(nf) = (/18/)      ! Indexes from list below

  ! All functionals available
  !                  1,           2,          3,           4,   
  !                  5,           6,          7,           8, 
  !                  9,          10,         11,          12,
  !                 13,          14,         15,          16,
  !                 17,          18,         19
  character(len=3):: &
    func(nfTot)=(/'LDA',       'LDA',       'GGA',       'GGA', &
                  'GGA',       'GGA',       'GGA',       'GGA', &
                  'GGA',       'GGA',       'GGA',       'GGA', &
                  'GGA',       'GGA',       'VDW',       'VDW', &
                  'VDW',       'VDW',       'VDW'       /)
  character(len=10):: &
    auth(nfTot)=(/'PZ        ','PW92      ','PW91      ','PBE       ', &
                  'RPBE      ','revPBE    ','LYP       ','WC        ', &
                  'PBEJsJrLO ','PBEJsJrHEG','PBEGcGxLO ','PBEGcGxHEG', &
                  'PBESOL    ','AM05      ','DRSLL     ','LMKLL     ', &
                  'C09       ','BH        ','VV        '/) 

  ! Tester variables and arrays
  integer :: cellMesh(3) = (/nx,nx,nx/)
  integer :: i1, i1max, i2, i2max, i3, i3max, ir, irmax, &
             lb1, lb2, lb3, mSpin, myNode, nNodes, one, two, ub1, ub2, ub3
  real(dp):: atomDens(nr,nSpin), atomEc, atomEx, atomDc, atomDx, &
             atomVxc(nr,nSpin), avgDiffVxc, &
             cell(3,3), cellEc, cellEx, cellDc, cellDx, &
             d0, d0s(nSpin), diffVxc(nSpin), dr, dx, Ecut, kCut, &
             latConst, maxDiffVxc, pi, r, recCell(3,3), rMesh(nr), &
             stress(3,3), sumDiffVxc, tmp, Vxc(nSpin), &
             wc(nfTot), wr, wx(nfTot), x(3), x0(3)
  real(gp),allocatable:: cellDens(:,:,:,:), cellVxc(:,:,:,:)

#ifdef HAVE_MPI
  ! MPI-related variables
  integer :: MPIerror
  integer :: nLarger, nxNode
#endif

#ifdef HAVE_MPI
  ! Initialize MPI and get myNode and nNodes
  call MPI_Init( MPIerror )
  call MPI_Comm_Rank( MPI_Comm_World, myNode, MPIerror )
  call MPI_Comm_Size( MPI_Comm_World, nNodes, MPIerror )
#else
  myNode = 0
  nNodes = 1
#endif
#ifdef HAVE_MPI
  ! Initialize mpi
  call gridxc_init(comm=MPI_Comm_World)
#else
  call gridxc_init()
#endif

  ! Initialize hybrid XC functional with all tested functionals
  mSpin = min( nSpin, 2 )
  wx = 1._dp / nf
  wc = 1._dp / nf
  call setXC( nf, func(indexf), auth(indexf), wx(indexf), wc(indexf) )

  ! Find radial mesh points and gaussian density
  pi = acos(-1._dp)
  d0 = Qtot / (2*pi*dWidth**2)**1.5_dp    ! Total density at origin
  if (nSpin==1) then
    d0s(1) = d0
  else
    one = 1   ! A silly thing to satisfy the compiler when nSpin=1
    two = 2
    d0s(one) = d0 * (Qtot + spinPol) / Qtot / 2 ! Spin up density at origin
    d0s(two) = d0 * (Qtot - spinPol) / Qtot / 2 ! Spin down density at origin
  end if
  dr = rmax / (nr-1)                      ! Interval between radial points
  do ir = 1,nr
    rMesh(ir) = dr * (ir-1)               ! Radial point values
    atomDens(ir,:) = DensOfR( d0s(:), rMesh(ir) )
  end do

  ! All processors do the same thing here
  ! Find exchange and correlation energy and potential from radial density
  call atomXC( irel, nr, nr, rMesh, nSpin, atomDens, &
               atomEx, atomEc, atomDx, atomDc, atomVxc )

  ! Define fcc unit cell, such that a sphere of radius rMax+rBuff fits in it
  latConst = (rMax+rBuff) * 2*sqrt(2._dp)
  cell(:,1) = (/ 0.0_dp, 0.5_dp, 0.5_dp /)
  cell(:,2) = (/ 0.5_dp, 0.0_dp, 0.5_dp /)
  cell(:,3) = (/ 0.5_dp, 0.5_dp, 0.0_dp /)
  cell(:,:) = cell(:,:) * latConst

  ! Define reciprocal unit cell
  recCell(:,1) = (/-1.0_dp, 1.0_dp, 1.0_dp /)
  recCell(:,2) = (/ 1.0_dp,-1.0_dp, 1.0_dp /)
  recCell(:,3) = (/ 1.0_dp, 1.0_dp,-1.0_dp /)
  recCell(:,:) = recCell(:,:) * 2*pi/latConst
  kCut = cellMesh(1) * sqrt(sum(recCell(:,1)**2)) / 2  ! Max. wave vector
  Ecut = kCut**2                                       ! Mesh cutoff, in Ry
  dx = pi / kCut                                 ! Dist. between mesh planes

  ! Find the box of mesh points owned by my processor
#ifdef HAVE_MPI
  ! Do simplest thing: divide only along first axis
  nxNode = Nx / nNodes          ! Points per node along first vector
  nLarger = nx - nxNode*nNodes  ! Number of nodes with one more point
  if (myNode<nLarger) then      ! My node has nx+1 points
    lb1 = (nxNode+1)*(myNode-1)
    ub1 = (nxNode+1)*(myNode-1) - 1
  else                          ! My node has nx points
    lb1 = (nxNode+1)*nLarger + nxNode*(myNode-nLarger)
    ub1 = (nxNode+1)*nLarger + nxNode*(myNode-nLarger+1) - 1
  end if
#else
  ! All points belong to the only processor
  lb1 = 0
  ub1 = nx-1
#endif
  lb2 = 0
  lb3 = 0
  ub2 = nx-1
  ub3 = nx-1

  ! Allocate arrays for density and potential
  allocate( cellDens(lb1:ub1,lb2:ub2,lb3:ub3,nSpin), &
             cellVxc(lb1:ub1,lb2:ub2,lb3:ub3,nSpin) )

  ! Find density at mesh points
  x0(:) = sum(cell,2) / 2     ! Center of cell
  do i3 = lb3,ub3
  do i2 = lb2,ub2
  do i1 = lb1,ub1
    x(:) = i1*cell(:,1)/cellMesh(1) &   ! Mesh point position
         + i2*cell(:,2)/cellMesh(2) &
         + i3*cell(:,3)/cellMesh(3)
    r = sqrt( sum((x-x0)**2) )          ! Distance to center of cell
    cellDens(i1,i2,i3,:) = DensOfR( d0s(:), r )
  end do ! i1
  end do ! i2
  end do ! i3

  ! Find exchange and correlation energy and potential from density in cell
  call cellXC( irel, cell, cellMesh, lb1, ub1, lb2, ub2, lb3, ub3, nSpin, &
               cellDens, cellEx, cellEc, cellDx, cellDc, stress, cellVxc )

  ! Print parameters
  if (myNode==0) then
    print'(/,a,10(a3,4x))', 'funcs= ', func(indexf)
    print  '(a,10(a6,1x))', 'auths= ', auth(indexf)
    print'(a,3f12.6)', 'dr, dx, Ecut = ', dr, dx, Ecut
    print'(a,2f12.6)', 'rMax, rBuff = ', rMax, rBuff
  end if

  ! Compare energies
  if (myNode==0) then
    print'(a,3f15.9)', 'atomEx, cellEx, diff =', atomEx, cellEx, atomEx-cellEx
    print'(a,3f15.9)', 'atomEc, cellEc, diff =', atomEc, cellEc, atomEc-cellEc
    print'(a,3f15.9)', 'atomDx, cellDx, diff =', atomDx, cellDx, atomDx-cellDx
    print'(a,3f15.9)', 'atomDc, cellDc, diff =', atomDc, cellDc, atomDc-cellDc
  end if

  ! Write potentials
  if (nNodes==1) then
    open( unit=44, file='atomVxc.out' )
    do ir = 1,nr
      if (sum(atomDens(ir,1:mSpin)) < densMin) cycle
      write(44,'(3f15.9)') rMesh(ir), atomVxc(ir,1), atomVxc(ir,mSpin)
    end do
    close( unit=44 )
    open( unit=44, file='cellVxc.out' )
    do i1 = cellMesh(1)/2,0,-1
      i2 = cellMesh(2) / 2
      i3 = cellMesh(3) / 2
      if (sum(cellDens(i1,i2,i3,1:mSpin)) < densMin) cycle
      x(:) = i1*cell(:,1)/cellMesh(1) &   ! Mesh point position
           + i2*cell(:,2)/cellMesh(2) &
           + i3*cell(:,3)/cellMesh(3)
      write(44,'(3f15.9)') &
        sqrt(sum((x-x0)**2)), cellVxc(i1,i2,i3,1), cellVxc(i1,i2,i3,mSpin)
    end do
    close( unit=44 )
  end if

  ! Compare potentials
  sumDiffVxc = 0
  maxDiffVxc = 0
  do i3 = lb3,ub3
  do i2 = lb2,ub2
  do i1 = lb1,ub1
    if (sum(cellDens(i1,i2,i3,1:mSpin)) < densMin) cycle
    x(:) = cell(:,1)*i1/cellMesh(1) &
         + cell(:,2)*i2/cellMesh(2) &
         + cell(:,3)*i3/cellMesh(3)
    r = sqrt(sum((x-x0)**2))
    if (r>=rMax) cycle
    ! Simplest thing: a linear interpolation of atomVxc (requires large nr)
    ir = r/dr + 1
    wr = (r - ir*dr) / dr
    Vxc(:) = atomVxc(ir,:)*(1-wr) + atomVxc(ir+1,:)*wr
    diffVxc(:) = abs(cellVxc(i1,i2,i3,:)-Vxc(:))
    if (maxval(diffVxc(:)) > maxDiffVxc) then
      i1max = i1
      i2max = i2
      i3max = i3
      irmax = ir
    end if
    sumDiffVxc = sumDiffVxc + sum(diffVxc(:)**2)
    maxDiffVxc = max( maxDiffVxc, maxval(diffVxc(:)) )
  end do ! i1
  end do ! i2
  end do ! i3
#ifdef HAVE_MPI
  ! Find sumDiffVxc and maxDiffVxc accross all processor nodes
  tmp = sumDiffVxc
  call MPI_AllReduce( tmp, sumDiffVxc, 1, MPI_double_precision, &
                      MPI_Sum, MPI_Comm_World, MPIerror )
  tmp = maxDiffVxc
  call MPI_AllReduce( tmp, maxDiffVxc, 1, MPI_double_precision, &
                      MPI_Max, MPI_Comm_World, MPIerror )
#endif
  avgDiffVxc = sumDiffVxc / nSpin / nx**3
  if (myNode==0) then
    print'(a,2f15.9)', 'avgDiffVxc, maxDiffVxc = ', avgDiffVxc, maxDiffVxc
!    print'(a,4i6)', 'i1max,i2max,i3max, irmax = ', i1max, i2max, i3max, irmax
  end if

! Finalize MPI
#ifdef HAVE_MPI
  call MPI_Finalize( MPIerror )
#endif

CONTAINS

FUNCTION DensOfR( d0, r )

  ! Returns a radial density distribution

  implicit none
  real(dp),intent(in):: d0(nSpin)  ! Density at center of charge distribution
  real(dp),intent(in):: r          ! Distance to center of charge distribution
  real(dp)           :: DensOfR(nSpin)  ! Electron density

  ! Use a simple gaussian distribution
  DensOfR = d0 * exp(-r**2/2/dWidth**2)

  ! Impose a smooth radial cutoff
  DensOfR = DensOfR * ( 1 - (r/rMax)**n1cut )**n2cut

END FUNCTION DensOfR

END PROGRAM gridXCtest4

#if defined HAVE_CONFIG_H
#include "config.h"
#endif

!!@LICENSE

module gridxc_sys

  ! This module contains interfaces to handler routines
  ! They can be provided by the user of the library
  ! through calls to associate the respective pointers
  ! Note that the alloc-related handlers are defined
  ! in the alloc module
  
  interface
    subroutine die_interf(str)
      character(len=*), intent(in)  :: str
    end subroutine die_interf
  end interface
  interface
    subroutine gridxc_timer_start_interf(str)
      character(len=*), intent(in)  :: str
    end subroutine gridxc_timer_start_interf
  end interface
  interface
    subroutine gridxc_timer_stop_interf(str)
      character(len=*), intent(in)  :: str
    end subroutine gridxc_timer_stop_interf
  end interface

 procedure(die_interf),pointer :: die => simple_die_routine
 procedure(gridxc_timer_start_interf),pointer :: gridxc_timer_start => dummy_timer_start
 procedure(gridxc_timer_stop_interf),pointer :: gridxc_timer_stop => dummy_timer_stop

CONTAINS

  subroutine set_die_routine(func)
    procedure(die_interf) :: func
    die => func
  end subroutine set_die_routine

! auxiliary routine to provide a non-zero exit code
  subroutine exit(code)
    use iso_c_binding, only: C_INT

    integer(C_INT), intent(in) :: code

    interface
       subroutine c_exit(code) bind(C,name="exit")
         use iso_c_binding, only: c_int
         integer(c_int), intent(in) :: code
       end subroutine c_exit
    end interface

    call c_exit(code)
  end subroutine exit

  subroutine simple_die_routine(str)
    character(len=*), intent(in)   :: str
    write(0,'(a,a)') "[libgridxc default error handler]: " // trim(str)
    write(6,'(a,a)') "[libgridxc default error handler]: " // trim(str)
    write(6,'(a)') "Use gridxc_set_error_handler(custom_handler) to configure"
    !
    call exit(1)
    ! alternatively
    ! stop
    ! In F2018:
    ! error stop 1
  end subroutine simple_die_routine
! --------------------------------
  subroutine set_timer_start_routine(func)
    procedure(gridxc_timer_start_interf) :: func
    gridxc_timer_start => func
  end subroutine set_timer_start_routine

  subroutine set_timer_stop_routine(func)
    procedure(gridxc_timer_stop_interf) :: func
    gridxc_timer_stop => func
  end subroutine set_timer_stop_routine

  subroutine dummy_timer_start(str)
    character(len=*), intent(in)   :: str
  end subroutine dummy_timer_start

  subroutine dummy_timer_stop(str)
    character(len=*), intent(in)   :: str
  end subroutine dummy_timer_stop
! --------------------------------

end module gridxc_sys

#if defined HAVE_CONFIG_H
#include "config.h"
#endif

!< Contains global (MPI-related) data and exports an
! initialization routine.

module gridxc_config
!
!  Contains global data for internal operation
!  of the library.
!  This makes it non-thread-safe for now
!
! MPI variables
#ifdef HAVE_MPI
  integer,             save :: gridxc_comm
  integer,public,      save :: gridxc_myNode= -1, gridxc_totNodes=-1
#else
  integer,public,      save :: gridxc_myNode= 0, gridxc_totNodes=1
#endif
!
CONTAINS

#ifdef HAVE_MPI
!< Initialization routine. The `comm` argument is not present in the
! serial version.  
SUBROUTINE gridxc_init(comm)

!> MPI communicator for the library
integer, intent(in)           :: comm   ! NOT optional

integer :: mpierr
#else
!< Initialization routine. Basically a no-op for the serial version.
! The MPI version has a `comm` argument.
SUBROUTINE gridxc_init()
#endif
  
#ifdef HAVE_MPI
   gridxc_comm = comm
   call MPI_Comm_Size(comm,gridxc_totNodes,mpierr)
   call MPI_Comm_Rank(comm,gridxc_myNode,mpierr)
   !
#else
   gridxc_myNode = 0
   gridxc_totNodes = 1
#endif

end subroutine gridxc_init

end module gridxc_config

#if defined HAVE_CONFIG_H
#include "config.h"
#endif

!!@LICENSE
!
module gridxc_precision
  !
  !     Precision handling
  !
#ifdef HAVE_MPI
  use mpi, only: MPI_real, MPI_double_precision
#endif

  implicit none

  public
  
  integer, parameter :: i8b = selected_int_kind(18)

  integer, parameter :: sp = selected_real_kind(6,30)
  integer, parameter :: dp = selected_real_kind(14,100)
  !
  !     Select precision of certain parts of the program
  !     These are set through preprocessor directives.
  !
#ifdef HAVE_MPI
#ifdef GRID_SP
  integer, parameter :: grid_p = sp
  integer, parameter :: MPI_grid_real = MPI_real
#elif defined(GRID_DP)
  integer, parameter :: grid_p = dp
  integer, parameter :: MPI_grid_real = MPI_double_precision
#else
  integer, parameter :: grid_p = dp
  integer, parameter :: MPI_grid_real = MPI_double_precision
#endif

#else   

#ifdef GRID_SP
  integer, parameter :: grid_p = sp
#elif defined(GRID_DP)
  integer, parameter :: grid_p = dp
#else
  integer, parameter :: grid_p = dp
#endif

#endif
end module gridxc_precision

#if defined HAVE_CONFIG_H
#include "config.h"
#endif

!!@LICENSE
!
!**********************************************************************
! module sorting
!
! Provides the following public procedures:
!   iorder  ! Orders elements of an integer array according to some index
!   ordix   ! Finds an order index of increasing array elements
!   order   ! Orders elements of a real array according to some index
!   ordvec  ! Orders a set of vectors in a well defined order
!**********************************************************************

MODULE gridxc_sorting

  use gridxc_precision, only: dp
  implicit none

  private
  public :: ordvec
  public :: ordix
  public :: order
  public :: iorder

CONTAINS

  SUBROUTINE ORDVEC( TOL, NX, NV, V, INDEX )

    ! **********************************************************************
    ! Orders a set of vectors in a well defined order: by last coordinate;
    ! if last coordinate is equal, by before-last corrdinate, etc.
    ! Written by J.Soler. October 1997.
    ! ************ INPUT ***************************************************
    ! REAL*8  TOL      : Tolerance to consider two coordinates equal.
    ! INTEGER NX       : Number of vector coordinates
    ! INTEGER NV       : Number of vectors
    ! REAL*8  V(NX,NV) : Vectors to be ordered
    ! ************ OUTPUT **************************************************
    ! REAL*8  V(NX,NV) : Ordered vectors
    ! INTEGER INDEX(NV): Order index such that Vout(IX,IV)=Vin(IX,INDEX(IV))
    ! **********************************************************************
    INTEGER, intent(in) :: NV, NX
    INTEGER, intent(out) :: INDEX(NV)
    REAL(dp), intent(in) :: TOL
    REAL(dp), intent(inout) :: V(NX,NV)

    INTEGER :: IV, IV0, IV1, IX, JX

    INTEGER :: IAUX(NV)           ! automatic array

    DO IV = 1,NV
      INDEX(IV) = IV
    END DO
    DO IX = NX,1,-1
      IV0 = 0
30    CONTINUE
      DO IV1 = IV0+1,NV-1
        DO JX = IX+1,NX
          IF (ABS(V(JX,IV1+1)-V(JX,IV1)) .GT. TOL) GOTO 60
        END DO
      END DO
      IV1 = NV
60    CONTINUE
      IF (IV1 .GT. IV0+1) THEN
        !JMS 2008_03_02
        !            CALL ORDIX(  V(IX:IX,IV0+1:), NX, IV1-IV0, IAUX )
        CALL ORDIX(  V(IX,IV0+1), NX, IV1-IV0, IAUX )
        CALL ORDER(  V(1,IV0+1),  NX, IV1-IV0, IAUX )
        CALL IORDER( INDEX(IV0+1), 1, IV1-IV0, IAUX )
      END IF
      IV0 = IV1
      IF (IV0 .LT. NV-1) GO TO 30
    END DO

  END SUBROUTINE ORDVEC


  SUBROUTINE ordix( x, m, n, indx )
    ! *******************************************************************
    ! SUBROUTINE ORDIX( X, M, N, INDX )
    ! Makes an index table of increasing array X, with size N and
    ! stride M using the heapsort algorithm.
    ! Written by J.M.Soler, May.2015
    ! *************** INPUT *********************************************
    ! REAL*8  X(M,N)   : Array with the values to be ordered
    ! INTEGER M, N     : Dimensions of array X
    ! *************** OUTPUT ********************************************
    ! INTEGER INDX(N)  : Array which gives the increasing order of X(1,I):
    !                    X(1,INDX(I)) .LE. X(1,INDX(I+1)) )
    ! *************** USAGE *********************************************
    ! Example to order atomic positions X(I,IA), I=1,3, IA=1,NA by
    ! increasing z coordinate:
    !    CALL ORDIX( X(3,1), 3, NA, INDEX )
    !    CALL ORDER( X(1,1), 3, NA, INDEX )
    ! *************** ALGORITHM *****************************************
    ! A hierarchical 'family tree' (heap) is generated, with each parent
    ! k older than its two children (2*k and 2*k+1). Persons k with k>np
    ! are children (np = highest power of 2 smaller than n). Persons with
    ! np/2<k<=np are parents (but only those with k<=n/2 have actually
    ! one or two children). Persons np/4<k<=np/2 are grandparents, etc.
    ! Then, the person with k=1 (the oldest) is removed and the tree is
    ! reconstructed. This is iterated until all members are picked.
    ! Ref: W.H.Press et al. Numerical Recipes, Cambridge Univ. Press.
    ! *******************************************************************
    integer, parameter  :: dp = kind(1.d0)
    real(dp),parameter  :: tol = 1.e-12_dp  ! tolerance for value comparisons

    integer, intent(in) :: m, n     ! Dimensions of array x
    real(dp),intent(in) :: x(m,n)   ! Array with the values to be ordered
    ! will order against the first element (m)
    integer, intent(out):: indx(n)  ! Increasing order of x(1,:)

    integer:: k, nFamily, parent
    real(dp):: ageTol

    ! Construct the heap (family tree)
    indx = (/(k,k=1,n)/)            ! initial array order, to be modified

    ageTol = tol*maxval(x(1,:)) - tol*minval(x(1,:))  ! tolerance for age comparisons

    ! Swap to create the actual parent tree

    nFamily = n                     ! number of persons in the family tree
    do parent = n/2,1,-1            ! sift 'parents' down the tree
      call siftDown(parent)         ! siftDown inherits age and indx arrays
    enddo

    ! Reduce the tree size, retiring its succesive patriarchs (first element)
    do nFamily = n-1,1,-1           ! nFamily is the new size of the tree
      call swap( indx(1), indx(nFamily+1) ) ! swap patriarch and youngest child
      call siftDown(1)              ! now recolocate child in tree
    enddo

  contains

    subroutine siftDown( person )   ! place person in family tree

      implicit none
      integer, intent(in) :: person

      ! Inherited from ordix: age(:), ageTol, indx(:), nFamily
      integer:: child, sw, parent

      ! initialize
      parent = person                    ! assume person is a parent
      child = 2 * parent                 ! first child of parent
      sw = parent                        ! sorted swap child
      do while ( child <= nFamily )      ! iterate the sift-down process
        ! check current child
        if ( x(1,indx(sw)) < x(1,indx(child)) - ageTol ) then
          sw = child
        end if
        ! Check neighbouring child
        if ( child < nFamily ) then
          if ( x(1,indx(sw)) < x(1,indx(child+1)) - ageTol ) then
            sw = child + 1
          end if
        end if
        if ( sw == parent ) then
          exit ! break
        else
          call swap( indx(parent) , indx(sw) )
          ! update for next sift
          parent = sw
          child = sw * 2
        end if
      end do

    end subroutine siftDown

    pure subroutine swap(i,j) ! exchange integers i and j
      integer, intent(inout) :: i,j
      integer:: k
      k = i
      i = j
      j = k
    end subroutine swap
    
  END SUBROUTINE ordix


  SUBROUTINE ORDER( X, M, N, INDX )
    ! *******************************************************************
    ! Orders array X(M,N) according to array INDEX(N), which may be
    !   generated by routine ORDIX.
    ! Written by J.M.Soler. May'96.
    ! *************** INPUT *********************************************
    ! INTEGER M, N     : Dimensions of array X
    ! INTEGER INDX(N)  : Array which gives the desired order
    ! *************** INPUT AND OUTPUT **********************************
    ! REAL*8  X(M,N) : Array(s) to be ordered: Xout(I,J) = Xin(I,INDEX(J))
    ! *******************************************************************
    INTEGER, intent(in) :: M, N, INDX(N)
    REAL(DP), intent(inout) :: X(M,N)
    X = X(:,INDX)
  END SUBROUTINE ORDER


  SUBROUTINE IORDER( IA, M, N, INDX )
    ! *******************************************************************
    ! Orders integer array IA(M,N) according to array INDEX(N), which
    !   may be generated by routine ORDIX.
    ! Written by J.M.Soler. May'96 and Oct'97.
    ! *************** INPUT *********************************************
    ! INTEGER M, N     : Dimensions of array IA
    ! INTEGER INDX(N)  : Array which gives the desired order
    ! *************** INPUT AND OUTPUT **********************************
    ! REAL*8  IA(M,N): Array(s) to be ordered: IAout(I,J) = IAin(I,INDEX(J))
    ! *******************************************************************
    INTEGER, intent(in) :: M, N
    INTEGER, intent(in) :: INDX(N)
    INTEGER, intent(inout) :: IA(M,N)
    IA = IA(:,INDX)
  END SUBROUTINE IORDER

END MODULE gridxc_sorting

module fruit_mpi
  use fruit
  use mpi
  implicit none
  private

  integer, parameter :: XML_OPEN = 20
  integer, parameter :: XML_WORK = 21
  character(len = *), parameter :: xml_filename = "result.xml"
  integer, parameter :: NUMBER_LENGTH = 10
  integer, parameter :: FN_LENGTH = 50

  public ::          fruit_init_mpi_xml
  interface          fruit_init_mpi_xml
    module procedure fruit_init_mpi_xml_
  end interface

  public ::          fruit_finalize_mpi
  interface          fruit_finalize_mpi
    module procedure fruit_finalize_mpi_
  end interface

  public ::          fruit_summary_mpi
  interface          fruit_summary_mpi
    module procedure fruit_summary_mpi_
  end interface

  public ::          fruit_summary_mpi_xml
  interface          fruit_summary_mpi_xml
    module procedure fruit_summary_mpi_xml_
  end interface
contains
  subroutine fruit_init_mpi_xml_(rank)
    integer, intent(in) :: rank
    character(len = FN_LENGTH) :: xml_filename_work

    write(xml_filename_work, '("result_tmp_", i5.5, ".xml")') rank
    call set_xml_filename_work(xml_filename_work)

    call init_fruit_xml(rank)
  end subroutine fruit_init_mpi_xml_

  subroutine     fruit_finalize_mpi_(size, rank)
    integer, intent(in) :: size, rank
    if (size < 0) print *, "size negative"
    if (rank < 0) print *, "rank negative"
    call         fruit_finalize
  end subroutine fruit_finalize_mpi_

  subroutine     fruit_summary_mpi_(size, rank)
    integer, intent(in) :: size, rank
    integer :: fail_assert_sum
    integer :: succ_assert_sum
    integer :: fail_case_sum
    integer :: succ_case_sum

    integer :: fail_assert
    integer :: succ_assert
    integer :: fail_case
    integer :: succ_case

    integer :: message_index
    integer :: num_msgs
    integer :: num_msgs_sum
    integer, allocatable :: num_msgs_rank(:)

    integer :: ierr
    integer :: i
    integer :: imsg
    integer :: status(MPI_STATUS_SIZE)

    integer, parameter :: MSG_LENGTH_HERE = 256
    character(len = MSG_LENGTH_HERE), allocatable :: msgs(:)
    character(len = MSG_LENGTH_HERE), allocatable :: msgs_all(:)

    call get_assert_and_case_count(&
    & fail_assert,  succ_assert, &
    & fail_case,    succ_case)

    call get_message_index(message_index)
    num_msgs = message_index - 1
    allocate(msgs(num_msgs))
    call get_message_array(msgs)

    allocate(num_msgs_rank(size))
    call MPI_Allgather(&
    & num_msgs,      1, MPI_INTEGER, &
    & num_msgs_rank, 1, MPI_INTEGER, MPI_COMM_WORLD, ierr)

    num_msgs_sum = sum(num_msgs_rank(:))
    allocate(msgs_all(num_msgs_sum))

    ! array msgs_all:
    !
    ! | msgs(:) of rank 0  | msgs(:) of rank 1   | msgs(:) of rank 2  |
    ! |                    |                     |                    |
    ! | num_msgs_rank(1)   |  num_msgs_rank(2)   | num_msgs_rank(3)   |
    ! |                    |                     |                    |
    ! |                    |                     |                    |
    !                       A                     A                  A
    !                       |                     |                  |
    !              sum(num_msgs_rank(1:1))+1      |             num_msgs_sum
    !                                    sum(num_msgs_rank(1:2))+1

    if (rank == 0) then
      msgs_all(1:num_msgs) = msgs(1:num_msgs)
      do i = 1, size - 1
        imsg = sum(num_msgs_rank(1:i)) + 1
        call MPI_RECV(&
        & msgs_all(imsg), &
        & num_msgs_rank(i + 1) * MSG_LENGTH_HERE, MPI_CHARACTER, &
        & i, 7, MPI_COMM_WORLD, status, ierr)
      enddo
    else
      call MPI_Send(&
      & msgs, &
      & num_msgs * MSG_LENGTH_HERE               , MPI_CHARACTER, &
      & 0, 7, MPI_COMM_WORLD, ierr)
    endif

    call MPI_REDUCE(&
    & fail_assert    , &
    & fail_assert_sum, 1, MPI_INTEGER, MPI_SUM, 0, MPI_COMM_WORLD, ierr)

    call MPI_REDUCE(&
    & succ_assert    , &
    & succ_assert_sum, 1, MPI_INTEGER, MPI_SUM, 0, MPI_COMM_WORLD, ierr)

    call MPI_REDUCE(&
    & fail_case    , &
    & fail_case_sum,   1, MPI_INTEGER, MPI_SUM, 0, MPI_COMM_WORLD, ierr)

    call MPI_REDUCE(&
    & succ_case    , &
    & succ_case_sum,   1, MPI_INTEGER, MPI_SUM, 0, MPI_COMM_WORLD, ierr)

    if (rank == 0) then
      write (*,*)
      write (*,*)
      write (*,*) '    Start of FRUIT summary: '
      write (*,*)

      if (fail_assert_sum > 0) then
         write (*,*) 'Some tests failed!'
      else
         write (*,*) 'SUCCESSFUL!'
      end if

      write (*,*)
      write (*,*) '  -- Failed assertion messages:'

      do i = 1, num_msgs_sum
        write (*, "(A)") '   '//trim(msgs_all(i))
      end do

      write (*, *) '  -- end of failed assertion messages.'
      write (*, *)

      if (succ_assert_sum + fail_assert_sum /= 0) then
        call fruit_summary_table(&
        & succ_assert_sum, fail_assert_sum, &
        & succ_case_sum  , fail_case_sum    &
        &)
      endif
      write(*, *) '  -- end of FRUIT summary'
    endif
  end subroutine fruit_summary_mpi_

  subroutine     fruit_summary_mpi_xml_(size, rank)
    integer, intent(in) :: size, rank

    character(len = 1000) :: whole_line
    character(len =  100) :: full_count
    character(len =  100) :: fail_count
    character(len = FN_LENGTH)              :: xml_filename_work
    character(len = FN_LENGTH), allocatable :: xml_filename_work_all(:)

    integer :: fail_assert    , succ_assert    , fail_case     , succ_case
    integer :: fail_assert_sum, succ_assert_sum, fail_case_sum , succ_case_sum
    integer :: i
    integer :: status(MPI_STATUS_SIZE)
    integer :: ierr

    call get_xml_filename_work(xml_filename_work)

    allocate(xml_filename_work_all(size))

    if (rank /= 0) then
    call MPI_Send(    xml_filename_work, &
    &     FN_LENGTH, MPI_CHARACTER,     0, 8, MPI_COMM_WORLD, ierr)
    endif
    if (rank == 0) then
      xml_filename_work_all(1) = xml_filename_work

      do i = 1+1, size
        call MPI_RECV(xml_filename_work_all(i), &
        & FN_LENGTH, MPI_CHARACTER, i - 1, 8, MPI_COMM_WORLD, status, ierr)
      enddo
    endif

    call get_assert_and_case_count(&
    & fail_assert,  succ_assert, &
    & fail_case,    succ_case)

    call MPI_REDUCE(&
    & fail_assert    , &
    & fail_assert_sum, 1, MPI_INTEGER, MPI_SUM, 0, MPI_COMM_WORLD, ierr)

    call MPI_REDUCE(&
    & succ_assert    , &
    & succ_assert_sum, 1, MPI_INTEGER, MPI_SUM, 0, MPI_COMM_WORLD, ierr)

    call MPI_REDUCE(&
    & fail_case    , &
    & fail_case_sum,   1, MPI_INTEGER, MPI_SUM, 0, MPI_COMM_WORLD, ierr)

    call MPI_REDUCE(&
    & succ_case    , &
    & succ_case_sum,   1, MPI_INTEGER, MPI_SUM, 0, MPI_COMM_WORLD, ierr)

    full_count = int_to_str(succ_case_sum + fail_case_sum)
    fail_count = int_to_str(                fail_case_sum)

    if (rank == 0) then
      open (XML_OPEN, file = xml_filename, action ="write", status = "replace")
        write(XML_OPEN, '("<?xml version=""1.0"" encoding=""UTF-8""?>")')
        write(XML_OPEN, '("<testsuites>")')
        write(XML_OPEN, '("  <testsuite errors=""0"" ")', advance = "no")
        write(XML_OPEN, '("tests=""", a, """ ")', advance = "no") &
        &  trim(full_count)
        write(XML_OPEN, '("failures=""", a, """ ")', advance = "no") &
        &  trim(fail_count)
        write(XML_OPEN, '("name=""", a, """ ")', advance = "no") &
        &  "name of test suite"
        write(XML_OPEN, '("id=""1"">")')

        do i = 1, size
          open (XML_WORK, FILE = xml_filename_work_all(i))
            do
              read(XML_WORK, '(a)', end = 999) whole_line
              write(XML_OPEN, '(a)') trim(whole_line)
            enddo
        999 continue
          close(XML_WORK)
        enddo

        write(XML_OPEN, '("  </testsuite>")')
        write(XML_OPEN, '("</testsuites>")')
      close(XML_OPEN)
    endif
    if (size < 0) print *, "size < 0"
  end subroutine fruit_summary_mpi_xml_

  function int_to_str(i)
    integer, intent(in) :: i
    character(LEN = NUMBER_LENGTH) :: int_to_str

    write(int_to_str, '(i10)') i
    int_to_str = adjustl(int_to_str)
  end function int_to_str
end module fruit_mpi

#if defined HAVE_CONFIG_H
#include "config.h"
#endif

!!@LICENSE
!
MODULE gridxc_debugXC

! Initializes output files for debug info. J.M.Soler. Jan'2008

USE gridxc_moreParallelSubs, only: nodeString    ! Returns a string with a node number
USE gridxc_moreParallelSubs, only: copyFile      ! Copies a file to another node
USE gridxc_io,             only: io_assign     ! Get and reserve an available IO unit

  implicit none

PUBLIC &
  setDebugOutputUnit,   &! Sets debug output unit and opens it for debug output
  closeDebugOutputFile, &! Close debug output file and copies it to node 0
  udebug                 ! Output file unit for debug info

PRIVATE ! Nothing is declared public beyond this point

  character(len=*),parameter:: filePrefix = 'debugXC' ! Prefix of file name
  character(len=32),    save:: fileName  ! Output file name
  integer,              save:: udebug=0  ! Output file unit for debug info

CONTAINS

!-----------------------------------------------------------------------------

subroutine setDebugOutputUnit(myNode)
  ! Sets debug output unit and opens file for debug output

  implicit none

  integer, intent(in) :: myNode

  ! If already initialized, do nothing
  if (udebug>0) return

  write(fileName,"(a,i0,a)") trim(filePrefix)//".",myNode,'.out'
  ! Find an available output unit
  call io_assign( udebug )

  ! Open file
  open( udebug, file=fileName )
end subroutine setDebugOutputUnit

!-----------------------------------------------------------------------------

#ifdef HAVE_MPI
subroutine closeDebugOutputFile(comm)
#else
subroutine closeDebugOutputFile()
#endif

  ! Closes debug output file and copies it to node 0

  implicit none

#ifdef HAVE_MPI
  integer, intent(in) :: comm
  integer             :: mpierr
#endif

  integer:: iNode
  character(len=32):: nodeFileName
  integer :: Nodes

  close( unit=udebug )

#ifdef HAVE_MPI
  call MPI_Comm_Size(comm,Nodes,mpierr)
#else
  Nodes = 1
#endif

  ! Copy all debug.out* files to root node. Notice that in each call to
  ! copyFile, only node iNode will actually send its file to node=0
  do iNode = 1,Nodes-1
    nodeFileName = filePrefix//'.node'//nodeString(iNode)
    call copyFile( srcNode=iNode, srcFile=nodeFileName, &
                   dstNode=0,     dstFile=nodeFileName, &
                   writeOption='overwrite' )
  end do

end subroutine closeDebugOutputFile

END MODULE gridxc_debugXC

#if defined HAVE_CONFIG_H
#include "config.h"
#endif

!!@LICENSE
!
!******************************************************************************
! MODULE m_vv_vdwxc
! Implements the nonlocal correlation energy part of the van der Waals density
! functional of O.A.Vydrov & T.vanVoorhis, JCP 133, 244103 (2010) (VV2010):
!   Enlc = (1/2) Int Int dr1 dr2 n(r1) phi(n1,gn1,n2,gn2,r12) n(r2)
! where r12=|r2-r1|, n(r) is the electron density at point r, gn(r) its 
! gradient, and phi is a universal function defined in Eqs.(2-6) and (9).
! To be used with module m_vdwxc
! Refs: O.A.Vydrov & T.vanVoorhis, JCP 133, 244103 (2010)
!       G.Roman-Perez and J.M.Soler, PRL 103, 096102 (2009)
! Written by J.M.Soler. July 2012
!------------------------------------------------------------------------------
! Used module procedures:
!  use gridxc_sys,         only: die               ! termination routine
!  use gridxc_mesh1D,      only: get_mesh          ! Returns the mesh points
!  use gridxc_radfft,    only: radfft            ! Radial fast Fourier transform
!  use gridxc_mesh1D,      only: set_mesh          ! Sets a 1D mesh
!  use interpolation, only: spline            ! Sets spline interpolation
!  use interpolation, only: splint            ! Calculates spline interpolation
!------------------------------------------------------------------------------
! Used module parameters:
!   use gridxc_precision,  only: dp                ! Real double precision type
!------------------------------------------------------------------------------
! Public procedures available from this module:
!   vv_vdw_beta      : Returns constant beta of eq.(13) of VV2010 JCP paper
!   vv_vdw_get_kmesh : Returns size and values of (kf,kg) mesh
!   vv_vdw_phi       : Finds phi(k) at (kf,kg) mesh points
!   vv_vdw_set_kcut  : Sets the planewave cutoff kc of the integration grid
!   vv_vdw_theta     : Finds function theta(n,gn) (eq.(8) of Roman-Soler PRL)
!------------------------------------------------------------------------------
! Public types, parameters, variables, and arrays:
!   None
!------------------------------------------------------------------------------
! Units: 
!   All lengths and energies in atomic units (Bohr, Hartree)
!******************************************************************************
! real(dp) function vv_vdw_beta()
!   Returns parameter beta=0.00497 of eq.(13) of VV2010 JCP paper
! Arguments:
!   none
! Sample usage:
!   real(dp):: beta
!   beta = vv_vdw_beta()
!------------------------------------------------------------------------------
! subroutine vdw_get_kmesh( nkf, nkg, kf, kg )
!   Returns size and values of the (kf,kg) interpolation mesh of the
!   Roman-Soler method. kf and kg are local Fermi- and gradient-wavevectors:
!   kf=(3*pi**2*n)**(1/3), kg=|grad(n)|/n
! Arguments:
!   integer,          intent(out) :: nkf    ! Number of kf mesh points
!   integer,          intent(out) :: nkg    ! Number of kg mesh points
!   real(dp),optional,intent(out) :: kf(:)  ! Mesh values of Fermi wavevect.
!   real(dp),optional,intent(out) :: kg(:)  ! Mesh values of grad(n)/n
! Sample usage:
!   integer :: nkf, nkg
!   real(dp),allocatable:: kf(:), kg(:)
!   call vv_vdw_get_kmesh( nkf, nkg )
!   allocate( kf(nkf), kg(nkg) )
!   call vv_vdw_get_kmesh( nkf, nkg, kf, kg )
! Notes:
! - If the size of arrays kf or kg is smaller than nkf and nkg, 
!   they are filled with the first size(kf) or size(kg) values
! - The size and values of the logarithmic k meshes are set by internal
!   parameters that can be changed only by editing them in this module:
!     nkf, nkg          : Number of kf and kg mesh points
!     kfcut=kfmesh(nkf) : Max. value of kf mesh
!     kgcut=kgmesh(nkg) : Max. value of kg mesh
!     dkfmaxdkfmin      : (kfmesh(nk) - kfmesh(nk-1)) / (kfmesh(2) - kfmesh(1))
!     dkgmaxdkgmin      : (kgmesh(nk) - kgmesh(nk-1)) / (kgmesh(2) - kgmesh(1))
!   Although the presently-set values have been found to yield good accuracy
!   in preliminary calculations, more tests may be required to guarantee
!   convergence in other systems. Larger nk's increase accuracy but CPU time 
!   increases between (nkf*nkg) and (nkf*nkg)**2.
!------------------------------------------------------------------------------
! subroutine vv_vdw_phi( k, phi, dphidk )
!   Finds phi(k1,k2,k) (Fourier transform of phi(k1,k2,r)) for all 
!   values of k1=(kf1,kg1) and k2=(kf2,kg2) of the (kf,kg) mesh. The mesh
!   indexes of kf and kg are combined into a single index ikfg=1,...,nkf*nkg
!   so that the size of phi and dphidk is (nkfg,nkfg), with nkfg=nkf*nkg.
!   In practice, it returns n1*n2*phi(k1,k2,k), where n1=kf1**3/(3*pi**2) and
!   n1=kf1**3/(3*pi**2) at the mesh values of kf1 and kf2. This is because
!   this function is smoother to interpolate than phi itself.
! Arguments:
!   real(dp),intent(in) :: k            ! Modulus of actual k vector
!   real(dp),intent(out):: phi(:,:)     ! phi(k1,k2,k) at given k, for all mesh
!                                       ! values of k1=(kf1,kg1) & k2=(kf2,kg2)
!   real(dp),intent(out):: dphidk(:,:)  ! dphi(k1,k2,k)/dk at given k
! Sample usage:
!   integer :: nkf, nkg
!   real(dp):: k, kcut
!   real(dp),allocatable:: phi(:,:), dphidk(:,:)
!   kcut = 10._dp ! 10 Bohr^-1 => 100 Ry (this should be adapted to your mesh)
!   call vv_vdw_set_kcut( kcut )
!   call vv_vdw_get_qmesh( nkf, nkg )
!   allocate( phi(nkf*nkg,nkf*nkg), dphidk(nkf*nkg,nkf*nkg) )
!   do k points
!     call vv_vdw_phi( k, phi, dphidk )
! Notes:
! - Requires a previous call to vv_vdw_set_kcut. Otherwise stops with an error.
! - Stops with an error message if size of array phi is smaller than
!   (nkf*nkg)**2.
!-----------------------------------------------------------------------------
! subroutine vv_vdw_set_kcut( kc )
!   Sets the reciprocal planewave cutoff kc of the integration grid, and finds 
!   the interpolation table to be used by vv_vdw_phi to obtain the vdW kernel 
!   phi at the reciprocal mesh wavevectors.
! Arguments:
!   real(dp),intent(in):: kc  ! Planewave cutoff: k>kcut => phi=0
! Sample usage:
!   real(dp):: kcut
!   kcut = 10._dp ! 10 Bohr^-1 => 100 Ry (this should be adapted to your mesh)
!   call vv_vdw_set_kcut( kcut )
!------------------------------------------------------------------------------
! subroutine vv_vdw_theta( nspin, rhos, grhos, theta, dtdrho, dtdgrho )
!   Finds the value and derivatives of function theta_ik(rho,grad_rho) 
!   of eq.(8) of the Roman-Soler PRL. ik is a combined index for the (kf,kg) 
!   interpolation mesh. 
!   In practice, it returns p_ik, rather than theta_ikgf=rho*p_ik, while
!   vv_vdw_phi returns rho1*rho2*phi, which is smoother to interpolate.
! Arguments:
!   integer, intent(in) :: nspin               ! Number of spin components
!   real(dp),intent(in) :: rhos(nspin)         ! Electron spin density
!   real(dp),intent(in) :: grhos(3,nspin)      ! Spin density gradient
!   real(dp),intent(out):: theta(nkf*nkg)      ! Function theta at mesh points
!   real(dp),intent(out):: dtdrho(nkf*nkg,nspin)     ! dtheta/drhos
!   real(dp),intent(out):: dtdgrho(3,nnkf*nkg,nspin) ! dtheta/dgrhos
! Sample usage:
!   integer,parameter:: nspin=1
!   integer,parameter:: nr=1000  ! number of mesh points in your system
!   integer :: nkf, nkg
!   real(dp):: n(nr), gn(3,nr)
!   real(dp),allocatable:: dtdn(:,:), dtdgn(:,:,:), theta(:,:)
!   call vv_vdw_get_qmesh( nkf, nkg )
!   nkfg = nkf*nkg
!   allocate( dtdn(nkfg,nr), dtdgn(3,nkfg,nr), theta(nkfg,nr) )
!   do ir ! mesh points
!     call vv_vdw_theta( nspin, n(ir), gn(:,ir), theta(:,ir), &
!                        dtdn(:,ir), dtdgn(:,:,ir) )
! Notes:
! - The values of kf(rho,grad_rho) and kg(rho,grad_rho) are saturated at
!   kfcut and kgcut (two internal parameters set below) to avoid incorrect 
!   'interpolation' of phi(k1,k2,r12) from (kf,kg) mesh points.
!******************************************************************************
! Algorithms:
!   Once we set the cutoff kcut (expressed as a wavevector), of the integration 
! mesh, to be used in evaluating the vdW nonlocal energy Enlc, we calculate and
! store (in memory) an interpolation table of phi(k1,k2,k) for all values 
! of k1=(kf1,kg1) and k2=(kf2,kg2) in the (kf,kg) mesh, and of k in a fine 
! radial grid of nk=nr points. This is done by first calculating phi(k1,k2,r) 
! in a radial grid in real space and then Fourier-transforming it to k space.
! This table is then used to interpolate phi(k1,k2,k) for any desired k.
! In practice, we interpolate (and return) rho1*rho2*phi(k1,k2,k) (which is 
! smoother than phi(k1,k2,k) itself), where rho=kf**3/(3*pi**2).
!   In order to ensure that values (kf,kg) are within the interpolation range,
! they are 'saturated' smoothly to cutoffs kfcut and kgcut. This implies an 
! approximation when either kf is very large (i.e. near the nucleus) or when 
! kg is very large, what tipically occurs in the tails of the electron density. 
! In the first case, Enlc is neglegible compared with Ex and the local part of 
! Ec. In the second case, it is neglegible because of the factor rho in the 
! integrand. Thus, the preliminary tests suggest that the presently-set values 
! of kfcut and kgcut give sufficiently accurate values.
!******************************************************************************

MODULE gridxc_vv_vdwxc

! Used module procedures
  use gridxc_sys,          only: die              ! Termination routine
  use gridxc_mesh1D,       only: get_mesh         ! Returns the mesh points
  use gridxc_radfft,       only: radfft           ! Radial fast Fourier transform
  use gridxc_alloc,        only: re_alloc         ! Re-allocation routine
  use gridxc_mesh1D,       only: set_mesh         ! Sets a 1D mesh
  use gridxc_interpolation,only: spline           ! Sets spline interpolation
  use gridxc_interpolation,only: splint           ! Calculates spline interpolation

! Used module parameters
  use gridxc_precision,    only: dp               ! Real double precision type

#ifdef DEBUG_XC
  use gridxc_debugXC,      only: udebug           ! File unit for debug output
!  use plot_module, only: plot
#endif /* DEBUG_XC */

  implicit none

! Called by m_vdwxc
PUBLIC ::            &
  vv_vdw_beta,       &! Returns parameter beta of the VV2010 functional
  vv_vdw_theta,      &! Finds function theta_ik(rho,grad_rho)
  vv_vdw_get_kmesh,  &! Returns size and values of (kf,kg) mesh
  vv_vdw_phi,        &! Finds and interpolates rho1*rho2*phi(k1,k2,k)
  vv_vdw_set_kcut     ! Sets the planewave cutoff kc of the integration grid

#ifdef DEBUG_XC
! Called by debugging test programs
PUBLIC :: &
  vv_vdw_phi_val,    &! Kernel phi(kf1,kf2,kg1,kg2,r12) with no interpolation
  vv_vdw_phiofr       ! Kernel phi(k1,k2,r) at tabulated k1,k2-mesh values
#endif /* DEBUG_XC */

PRIVATE  ! Nothing is declared public beyond this point

  ! Set parameters of the Vydrov-vanVoorhis functional,
  ! given in paragraph after eq.(27) of VV JCP 2010 paper
  real(dp),parameter:: vv_C = 0.0093
  real(dp),parameter:: vv_b = 5.9
  real(dp),parameter:: vv_beta = 0.00497

  ! Mesh parameters for table of phi(k1,k2,r) and its Fourier transform
  character(len=*),parameter:: kernelPrefactor='rho' ! Prefactor of the
                                             ! nonlocal kernel for interpolation
                                             ! ('kf'|'kf2'|'sqr_rho'|'rho')
  integer, parameter:: nr = 2048             ! Radial mesh points (power of 2)
  real(dp),parameter:: rcut = 100._dp        ! Radial cutoff: r>rcut => phi=0
  real(dp),parameter:: rmin = 1.e-6_dp       ! Min. radius as denominator
  integer, parameter:: nkf =  7              ! Number of Fermi wavevectors
  integer, parameter:: nkg =  5              ! Num. of grad(n)/n wavevectors
  integer, parameter:: nkfg = nkf*nkg        ! Num. of (kf,kg) mesh points
  real(dp),parameter:: kfcut = 5.0_dp        ! Max. Fermi wavevec.
  real(dp),parameter:: kgcut = 5.0_dp        ! Max. grad(n)/n
  real(dp),parameter:: dkfmaxdkfmin = 20.0_dp ! Last/first kf mesh interval
  real(dp),parameter:: dkgmaxdkgmin = 2.0_dp  ! Last/first kg mesh interval
  real(dp),parameter:: ktol = 1.e-12_dp      ! 'out of range' tolerance
  real(dp),parameter:: amin = 1.e-12_dp      ! tiny denominator to avoid /0
  real(dp),parameter:: rhoMin = 1.e-10_dp    ! Min. density for nonzero Vxc

  ! Parameters for cutoff function, used in radial Fourier transforms of phi
  integer, parameter:: ncut1 =  8      ! cutoff(x)=(1-x**ncut1)**ncut2
  integer, parameter:: ncut2 =  4

  ! Parameters for saturate function, used to enforce that q<qcut
  integer, parameter:: nsat = 15 ! h(x,xc)=1/(1/x**nsat+1/xc**nsat)**(1/nsat)
                                 ! nsat=15 approximately corresponds to 
                                 ! nsat=12 for eq.(5) of Roman-Soler PRL

  ! Private module variables and arrays
  logical, save:: kcut_set=.false.         ! Has kcut been set?
  logical, save:: kmesh_set=.false.        ! Has (kf,kg) mesh been set?
  logical, save:: phi_table_set=.false.    ! Has phi_table been set?
  integer, save:: nk                       ! Num. of radial mesh k-points
  real(dp),save:: dr                       ! r-mesh interval
  real(dp),save:: dk                       ! k-mesh interval
  real(dp),save:: kcut                     ! Planewave cutoff: k>kcut => phi=0
  real(dp),save:: kmax                     ! Max. k vector in Fourier transforms
  real(dp),save:: kfmesh(nkf)              ! Mesh points for Fermi wavevector
  real(dp),save:: kgmesh(nkg)              ! Mesh points for grad(n)/n
  real(dp),pointer,save:: &
                  phir(:,:,:)=>null(),    &! Table of phi(r)
                  phik(:,:,:)=>null(),    &! Table of phi(k)
                  d2phidr2(:,:,:)=>null(),&! Table of d^2(phi)/dr^2
                  d2phidk2(:,:,:)=>null()  ! Table of d^2(phi)/dk^2

CONTAINS

! -----------------------------------------------------------------------------

real(dp) function cutoff( x )

! Defines a smooth cutoff function that falls from y(0)=1 to y(1)=0

  implicit none
  real(dp),intent(in):: x

  if (x<=0._dp) then
    cutoff = 1
  else if (x>=1._dp) then
    cutoff = 0
  else
    cutoff = (1-x**ncut1)**ncut2
  end if

end function cutoff

!-----------------------------------------------------------------------------

subroutine iofk( kf, kg, ikf, ikg )

! Finds indexes ikf and ikg such that kfmesh(ikf) <= kf < kfmesh(ikf+1)
! and kgmesh(ikg) <= kg < kgmesh(ikg+1) in logarithmic meshes of the form
! k(ik) = b*(exp((ik-1)*a)-1)

  implicit none
  real(dp), intent(in) :: kf, kg
  integer,  intent(out):: ikf, ikg

  real(dp),save:: akf, akg, bkf, bkg
  logical, save:: first_call = .true.
  integer:: ik

  ! Mesh data initializations
  if (first_call) then
    ! Find logarithmic-mesh a & b parameters: x(j)=x(1)+b*(exp(a*(j-1))-1)
    akf = log( (kfmesh(nkf)-kfmesh(nkf-1)) / (kfmesh(2)-kfmesh(1)) ) / (nkf-2)
    akg = log( (kgmesh(nkg)-kgmesh(nkg-1)) / (kgmesh(2)-kgmesh(1)) ) / (nkg-2)
    akf = max( akf, amin )
    akg = max( akg, amin )
    bkf = (kfmesh(nkf) - kfmesh(1)) / (exp(akf*(nkf-1)) - 1)
    bkg = (kgmesh(nkg) - kgmesh(1)) / (exp(akg*(nkg-1)) - 1)
    ! Check that meshes are indeed logarithmic
    do ik = 1,nkf
      if (abs(kfmesh(ik)-kfmesh(1)-bkf*(exp(akf*(ik-1))-1))>ktol) &
         call die('vv_vdw_iofk ERROR: kfmesh not logarithmic')
    end do
    do ik = 1,nkg
      if (abs(kgmesh(ik)-kgmesh(1)-bkg*(exp(akg*(ik-1))-1))>ktol) &
         call die('vv_vdw_iofk ERROR: kgmesh not logarithmic')
    end do
    first_call = .false.
  end if

  ! Check that kf and kg are within interpolation range
  if (kf<kfmesh(1)-ktol .or. kf>kfmesh(nkf)+ktol .or. &
      kg<kgmesh(1)-ktol .or. kg>kgmesh(nkg)+ktol) then
     call die('vv_vdw_iofk ERROR: (kf,kg) out of range')
  endif

  ! Find interpolation mesh intervals
  ikf = 1 + int( log( 1 + (kf-kfmesh(1))/bkf ) / akf )
  ikg = 1 + int( log( 1 + (kg-kgmesh(1))/bkg ) / akg )
  ikf = max( 1, ikf )
  ikg = max( 1, ikg )
  ikf = min( nkf-1, ikf )
  ikg = min( nkg-1, ikg )

end subroutine iofk

! -----------------------------------------------------------------------------

subroutine kofn( n, gn, kf, kg, dkfdn, dkgdn, dkfdgn, dkgdgn )

! Finds Fermi and gradient wavevectors from density and gradient

  implicit none
  real(dp), intent(in) :: n          ! Electron density
  real(dp), intent(in) :: gn(3)      ! Density gradient
  real(dp), intent(out):: kf         ! Local Fermi wavevector
  real(dp), intent(out):: kg         ! |grad(n)|/n
  real(dp), intent(out):: dkfdn      ! dkf/dn
  real(dp), intent(out):: dkgdn      ! dkg/dn
  real(dp), intent(out):: dkfdgn(3)  ! dkf/dgn
  real(dp), intent(out):: dkgdgn(3)  ! dkg/dgn

  real(dp):: gn2, pi

! Trap exception for zero density
  if (n <= 1.e-30_dp) then
    kf = 0
    kg = 0
    dkfdn = 0
    dkfdgn = 0
    dkgdn = 0
    dkgdgn = 0
    return
  end if

! Find kf and kg
  pi = acos(-1._dp)
  kf = (3*pi**2*n)**(1._dp/3)
  gn2 = sum(gn**2)
  kg = sqrt(gn2)/n

! Find derivatives
  dkfdn = kf/n/3
  dkfdgn = 0
  dkgdn = -kg/n
  dkgdgn = kg*gn/gn2

end subroutine kofn

!-----------------------------------------------------------------------------

subroutine pofk( kf, kg, p, dpdkf, dpdkg )

! Finds the values and derivatives, at (kf,kg), of the bicubic polynomials 
! p_i(kf,kg) such that
!    y(kf,kg) = Sum_i p_i(kf,kg) * y_i
! is the bicubic spline interpolation at (kf,kg) of (any) function y with
! values y_i at mesh points (kfmesh,kgmesh)_i

  implicit none
  real(dp),intent(in) :: kf, kg ! point at which the polynomials are required
  real(dp),intent(out):: p(nkfg)      ! polynomial values at (kf,kg)
  real(dp),intent(out):: dpdkf(nkfg)  ! dp/dkf at (kf,kg)
  real(dp),intent(out):: dpdkg(nkfg)  ! dp/dkg at (kf,kg)

  integer :: ikf, ikg, ikfg, ikf0, ikg0
  real(dp):: a, b, dk, dkf0dkf, dkg0dkg, kf0, kg0
  real(dp):: pkf0(nkf), dpkfdkf0(nkf), pkg0(nkg), dpkgdkg0(nkg)
  logical, save :: first_call=.true.
  real(dp),save :: pkf(nkf,nkf), d2pkfdkf2(nkf,nkf)
  real(dp),save :: pkg(nkg,nkg), d2pkgdkg2(nkg,nkg)

! Set up spline polynomial basis
  if (first_call) then
    do ikf = 1,nkf
      pkf(:,ikf) = 0    ! ikf'th polynomial pkf(:,ikf) is one at kfmesh(ikf) 
      pkf(ikf,ikf) = 1  ! and zero at all other points
      call spline( kfmesh, pkf(:,ikf), nkf, 1.e30_dp, 1.e30_dp, &
                   d2pkfdkf2(:,ikf) )
!      call spline( kfmesh, pkf(:,ikf), nkf, 0._dp, 0._dp, d2pkfdkf2(:,ikf) )
    end do
    do ikg = 1,nkg
      pkg(:,ikg) = 0
      pkg(ikg,ikg) = 1
      call spline( kgmesh, pkg(:,ikg), nkg, 1.e30_dp, 1.e30_dp, &
                   d2pkgdkg2(:,ikg) )
!      call spline( kgmesh, pkg(:,ikg), nkg, 0._dp, 0._dp, d2pkgdkg2(:,ikg) )
    end do

!   DEBUG
    open(22,file='pkf.dat')
    do ikf = 1,nkf
      write(22,'(20e15.6)') kfmesh(ikf), pkf(:,ikf), d2pkfdkf2(:,ikf)
    end do
    close(22)
    open(22,file='pkg.dat')
    do ikg = 1,nkg
      write(22,'(20e15.6)') kgmesh(ikg), pkg(:,ikg), d2pkgdkg2(:,ikg)
    end do
    close(22)
!   END DEBUG

    first_call = .false.
  end if

! 'Saturate' (kf,kg) values to bring them to interpolation range
  call saturate( kf, kfcut, kf0, dkf0dkf )
  call saturate( kg, kgcut, kg0, dkg0dkg )

! Find interval of k mesh in which (kf0,kg0) point is included
  call iofk( kf0, kg0, ikf0, ikg0 )

! Evaluate pkf polynomials of spline basis at kf0
! The splint code is in-lined here because it is a hot point
  dk = kfmesh(ikf0+1) - kfmesh(ikf0)
  a = (kfmesh(ikf0+1) - kf0) / dk   ! dadkf0 = -1/dk
  b = (kf0 - kfmesh(ikf0)) / dk     ! dbdkf0 = +1/dk
  do ikf = 1,nkf
    pkf0(ikf) = a*pkf(ikf0,ikf) + b*pkf(ikf0+1,ikf) &
              + ((a**3-a)*d2pkfdkf2(ikf0,ikf) +     &
                 (b**3-b)*d2pkfdkf2(ikf0+1,ikf)) * dk**2/6
    dpkfdkf0(ikf) = - (pkf(ikf0,ikf) - pkf(ikf0+1,ikf)) / dk &
                    - ((3*a**2-1)*d2pkfdkf2(ikf0,ikf) -     &
                       (3*b**2-1)*d2pkfdkf2(ikf0+1,ikf)) * dk/6
  end do

! Evaluate pkg polynomials of spline basis at kg0
  dk = kgmesh(ikg0+1) - kgmesh(ikg0)
  a = (kgmesh(ikg0+1) - kg0) / dk   ! dadkg0 = -1/dk
  b = (kg0 - kgmesh(ikg0)) / dk     ! dbdkg0 = +1/dk
  do ikg = 1,nkg
    pkg0(ikg) = a*pkg(ikg0,ikg) + b*pkg(ikg0+1,ikg) &
              + ((a**3-a)*d2pkgdkg2(ikg0,ikg) +     &
                 (b**3-b)*d2pkgdkg2(ikg0+1,ikg)) * dk**2/6
    dpkgdkg0(ikg) = - (pkg(ikg0,ikg) - pkg(ikg0+1,ikg)) / dk &
                    - ((3*a**2-1)*d2pkgdkg2(ikg0,ikg) -     &
                       (3*b**2-1)*d2pkgdkg2(ikg0+1,ikg)) * dk/6
  end do

! Evaluate pkf*pkg polynomials at (kf0,kg0)
  ikfg = 0
  do ikg = 1,nkg
    do ikf = 1,nkf
      ikfg = ikfg+1
      p(ikfg) = pkf0(ikf) * pkg0(ikg)
      dpdkf(ikfg) = dpkfdkf0(ikf)*dkf0dkf * pkg0(ikg)
      dpdkg(ikfg) = pkf0(ikf) * dpkgdkg0(ikg)*dkg0dkg
    end do
  end do

end subroutine pofk

!-----------------------------------------------------------------------------

subroutine saturate( x, xc, y, dydx )

  ! Defines a function y(x,xc) = 1/(1/x^nsat+1/xc^nsat)^(1/nsat), where nsat
  ! is an integer set in the module header. This function is approximately
  ! equal to x for x<xc and it saturates to xc when x->infinity

  implicit none
  real(dp),intent(in) :: x     ! Independent variable
  real(dp),intent(in) :: xc    ! Saturation value
  real(dp),intent(out):: y     ! Function value
  real(dp),intent(out):: dydx  ! Derivative dy/dx

  real(dp):: z

  if (xc<=0._dp) then
    call die('vv_vdwxc_saturate ERROR: xc<=0')
  else if (x<0._dp) then
    call die('vv_vdwxc_saturate ERROR: x<0')
  else if (x==0._dp) then
    y = 0
    dydx = 1
  else
    z = 1/x**nsat + 1/xc**nsat
    y = 1/z**(1._dp/nsat)
    dydx = y/z/x**(nsat+1)
  end if

end subroutine saturate

!-----------------------------------------------------------------------------

subroutine saturate_inverse( y, xc, x, dxdy )

! Finds the inverse of the function defined in saturate subroutine:
!   y=1/(1/x^n+1/xc^n)^(1/n)  =>  x=1/(1/y^n-1/xc^n)^(1/n)

  implicit none
  real(dp),intent(in) :: y     ! Independent variable
  real(dp),intent(in) :: xc    ! Saturation value
  real(dp),intent(out):: x     ! Inverse function value
  real(dp),intent(out):: dxdy  ! Derivative dx/dy

  real(dp):: z

  if (xc<=0._dp) then
    call die('vv_vdwxc_saturate_inverse ERROR: xc<=0')
  else if (y<0._dp .or. y>=xc) then
    call die('vv_vdwxc_saturate_inverse ERROR: y out of range')
  else if (y==0._dp) then
    x = 0
    dxdy = 1
  else
    z = 1/y**nsat - 1/xc**nsat
    x = 1/z**(1._dp/nsat)
    dxdy = x/z/y**(nsat+1)
  end if

end subroutine saturate_inverse

!-----------------------------------------------------------------------------

subroutine set_kmesh()

! Sets mesh of q values

  implicit none
  integer :: mkf, mkg

  if (.not.kmesh_set) then
    call set_mesh( nkf, xmax=kfcut, dxndx1=dkfmaxdkfmin )
    call get_mesh( nkf, mkf, kfmesh )
    call set_mesh( nkg, xmax=kgcut, dxndx1=dkgmaxdkgmin )
    call get_mesh( nkg, mkg, kgmesh )
    kmesh_set = .true.
#ifdef DEBUG_XC
    write(udebug,'(/,a,/,(10f8.4))') 'vv_vdw_set_kmesh: kfmesh =', kfmesh
    write(udebug,'(/,a,/,(10f8.4))') 'vv_vdw_set_kmesh: kgmesh =', kgmesh
#endif /* DEBUG_XC */
  end if

end subroutine set_kmesh

! -----------------------------------------------------------------------------

subroutine set_phi_table()

! Finds and stores in memory the interpolation table (mesh points and 
! function values) for the kernel phi(k1,k2,k).

  implicit none
  character(len=*),parameter:: myName = 'vv_vdwxc/set_phi_table '
  integer :: ik, ikf1, ikf2, ikg1, ikg2, ik1, ik2, ir
  real(dp):: dkdk0, dphidk0, dphidkmax, dphidr0, dphidrmax, &
             k, kf1, kf2, kg1, kg2, pi, r(0:nr)

! Check that table was not set yet
  if (phi_table_set) return

! Check that kf, kg, r, and k meshes have been set
  if (.not.kmesh_set) call set_kmesh()
  if (.not.kcut_set) call die('vv_vdw_set_phi_table ERROR: kcut not set')
  forall(ir=0:nr) r(ir) = ir*dr
  pi = acos(-1.0_dp)

! Allocate arrays
  call re_alloc( phir,     0,nr, 1,nkfg, 1,nkfg, myName//'phir' )
  call re_alloc( phik,     0,nr, 1,nkfg, 1,nkfg, myName//'phik' )
  call re_alloc( d2phidr2, 0,nr, 1,nkfg, 1,nkfg, myName//'d2phidr2' )
  call re_alloc( d2phidk2, 0,nr, 1,nkfg, 1,nkfg, myName//'d2phidk2' )

! Loop on (k1,k2) mesh points
  do ikg2 = 1,nkg                    ! loop on kg2
    do ikf2 = 1,nkf                  ! loop on kf2
      ik2 = ikf2 + nkf*(ikg2-1)      ! combined (ikf2,ikg2) index
      do ikg1 = 1,nkg                ! loop on kg1
        do ikf1 = 1,nkf              ! loop on kf1
          ik1 = ikf1 + nkf*(ikg1-1)  ! combined (ikf1,ikg1) index
          if (ik1>ik2) cycle         ! since we will symmetrize at the end

          ! Saturated (kf,kg) values
          kf1 = kfmesh(ikf1)
          kf2 = kfmesh(ikf2)
          kg1 = kgmesh(ikg1)
          kg2 = kgmesh(ikg2)

          ! Find original (unsaturated) kf anf kg values
          ! call saturate_inverse( kfmesh(ikf1), kfcut, kf1, dkdk0 )
          ! call saturate_inverse( kfmesh(ikf2), kfcut, kf2, dkdk0 )
          ! call saturate_inverse( kgmesh(ikg1), kgcut, kg1, dkdk0 )
          ! call saturate_inverse( kgmesh(ikg2), kgcut, kg2, dkdk0 )

          ! Find kernel as a function of r12
          do ir = 0,nr
            phir(ir,ik1,ik2) = vv_vdw_phi_val( kf1, kf2, kg1, kg2, r(ir) )
          end do

          ! Kill kernel smoothly at r=rcut
          do ir = 0,nr
            phir(ir,ik1,ik2) = phir(ir,ik1,ik2) * cutoff( r(ir)/rcut )
          end do

          ! Find kernel in reciprocal space
          call radfft( 0, nr, rcut, phir(:,ik1,ik2), phik(:,ik1,ik2) )
          phik(:,ik1,ik2) = phik(:,ik1,ik2) * (2*pi)**1.5_dp

          ! Filter out above kcut
          phik(nk:nr,ik1,ik2) = 0

          ! Soft filter below kcut
          do ik = 1,nk
            k = ik * dk
            phik(ik,ik1,ik2) = phik(ik,ik1,ik2) * cutoff(k/kcut)
          end do

          ! Find filtered kernel in real space
          call radfft( 0, nr, kmax, phik(:,ik1,ik2), phir(:,ik1,ik2) )
          phir(:,ik1,ik2) = phir(:,ik1,ik2) / (2*pi)**1.5_dp

          ! Set up spline interpolation tables
          dphidr0 = 0      ! since phi(k1,k2,r) is even in r
          dphidk0 = 0      ! and therefore phi(k1,k2,k) is also even in k
          dphidrmax = 0    ! since phi->0 for r->infty
          dphidkmax = 0    ! and also when k->infty
          call spline( dr, phir(:,ik1,ik2), nr+1, dphidr0, dphidrmax, &
                       d2phidr2(:,ik1,ik2) )
          call spline( dk, phik(:,ik1,ik2), nk+1, dphidk0, dphidkmax, &
                       d2phidk2(:,ik1,ik2) )

          ! Fill symmetric elements
          phir(:,ik2,ik1) = phir(:,ik1,ik2)
          phik(:,ik2,ik1) = phik(:,ik1,ik2)
          d2phidr2(:,ik2,ik1) = d2phidr2(:,ik1,ik2)
          d2phidk2(:,ik2,ik1) = d2phidk2(:,ik1,ik2)

!#ifdef DEBUG_XC
!          if (.false. .and. ik1==ik2) then
!            print*, 'vv_vdw_set_kcut: ik1,ik2=', ik1, ik2
!            call window( 0._dp, 5._dp, -1._dp, 4._dp, 0 )
!            call axes( 0._dp, 1._dp, 0._dp, 1._dp )
!            call plot( nr+1, r, phi, phir(:,ik1,ik2) )
!            call window( 0._dp, 10._dp, -0.05_dp, 0.15_dp, 0 )
!            call axes( 0._dp, 1._dp, 0._dp, 0.05_dp )
!            call plot( nr+1, r, r**2*phi, r**2*phir(:,ik1,ik2))
!            call show()
!          end if
!#endif /* DEBUG_XC */

        end do ! ikf1
      end do ! ikg1
    end do ! ikf2
  end do ! ikg2

!#ifdef DEBUG_XC
!  open(17,file='vv_phi.table')
!  write(17,'(3a6,2a12,/,(3i6,2f15.9))') &
!    'ik1', 'ik2', 'ir', 'phi', 'd2phi/dk2', &
!!    (((ik1,ik2,ir,phir(ir,ik1,ik2),d2phidr2(ir,ik1,ik2), &
!    (((ik1,ik2,ir,phik(ir,ik1,ik2),d2phidk2(ir,ik1,ik2), &
!       ir=0,100),ik2=1,nkfg),ik1=1,nkfg)
!  close(17)
!#endif /* DEBUG_XC */

! Mark table as set
  phi_table_set = .true.

end subroutine set_phi_table

! -----------------------------------------------------------------------------

real(dp) function vv_vdw_phi_val( kf1, kf2, kg1, kg2, r12 )

! vdW energy kernel of Vydrov-vanVoorhis, eq.(2) of JCP 133, 244103 (2010)
! This subroutine calculates the 'raw' kernel directly, without interpolarions
! In practice, it returns n1*n2*phi(k1,k2,r12), which is smooth for kf->0
! Input:
!   real(dp):: kf1, kf2 ! Fermi wavevectors at points 1 and 2
!   real(dp):: kg1, kg2 ! |grad(n)|/n at points 1 and 2
!   real(dp):: r12      ! distance between points 1 and 2

! Arguments
  implicit none
  real(dp),intent(in) :: kf1, kf2, kg1, kg2, r12

! Internal variables
  real(dp):: g1, g2, kappa1, kappa2, kf1m, kf2m, n1, n2, &
             phi, pi, w01, w02, wg1, wg2, wp1, wp2

! Avoid dividing by zero when kf=0 
  kf1m = max(kf1,ktol)
  kf2m = max(kf2,ktol)

! Find kernel
  pi = acos(-1.0_dp)
  n1 = kf1m**3/(3*pi**2)          ! electron density at point 1
  n2 = kf2m**3/(3*pi**2)          ! electron density at point 2
  wp1 = sqrt(4*pi*n1)             ! local plasma frequency at point 1
  wp2 = sqrt(4*pi*n2)             ! local plasma frequency at point 2
  wg1 = sqrt(vv_C*kg1**4)         ! local band gap at point 1
  wg2 = sqrt(vv_C*kg2**4)         ! local band gap at point 2
  kappa1 = vv_b*kf1m**2/wp1       ! local VV kappa variable (eq.(9)) at point 1
  kappa2 = vv_b*kf2m**2/wp2       ! kappa variable at point 2
  w01 = sqrt(wg1**2+wp1**2/3)     ! local w0 frequency (eq.(5)) at point 1
  w02 = sqrt(wg2**2+wp2**2/3)     ! local w0 frequency at point 2
  g1 = w01*r12**2 + kappa1        ! local g variable (eq.(3)) at point 1
  g2 = w02*r12**2 + kappa2        ! local g variable at point 2
  phi = -1.5_dp/g1/g2/(g1+g2)     ! VV kernel phi (eq.(2))

  if (kernelPrefactor=='rho') then
    ! Return whole integrand of eq.(1)
    vv_vdw_phi_val = n1*n2*phi
  else if (kernelPrefactor=='kf') then
    ! Return kf1*kf2*phi
    vv_vdw_phi_val = kf1*kf2*phi
  else if (kernelPrefactor=='kf2') then
    ! Return (kf1*kf2)**2*phi
    vv_vdw_phi_val = (kf1*kf2)**2*phi
  else if (kernelPrefactor=='sqr_rho') then
    ! Find and return sqrt(n1*n2)*phi
    vv_vdw_phi_val = sqrt(n1*n2)*phi
  else
    call die('vv_vdw_phi_val ERROR: unknown kernelPrefactor')
  end if

end function vv_vdw_phi_val

! -----------------------------------------------------------------------------

real(dp) function vv_vdw_beta()

! Returns parameter beta of VV functional

  implicit none
  vv_vdw_beta = vv_beta

end function vv_vdw_beta

!-----------------------------------------------------------------------------

subroutine vv_vdw_get_kmesh( mkf, mkg, kf, kg )

! Returns size and values of (kf,kg) mesh

  implicit none
  integer,          intent(out) :: mkf    ! Number of kf mesh points
  integer,          intent(out) :: mkg    ! Number of kg mesh points
  real(dp),optional,intent(out) :: kf(:)  ! Values of kf mesh points
  real(dp),optional,intent(out) :: kg(:)  ! Values of kg mesh points
  integer:: nmax
  if (.not.kmesh_set) call set_kmesh()
  mkf = nkf
  mkg = nkg
  if (present(kf)) then
    nmax = max( nkf, size(kf) )
    kf(1:nmax) = kfmesh(1:nmax)
  end if
  if (present(kg)) then
    nmax = max( nkg, size(kg) )
    kg(1:nmax) = kgmesh(1:nmax)
  end if
end subroutine vv_vdw_get_kmesh

! -----------------------------------------------------------------------------

subroutine vv_vdw_phi( k, phi, dphidk )

! Finds by interpolation phi(k1,k2,k) (Fourier transform of phi(k1,k2,r)),
! with k1=(kf1,kg1), k2=(kf2,kg2) for all mesh values of kf (Fermi 
! wavevector) and kg (grad(n)/n). If the interpolation table does not exist,
! it is calculated in the first call to vv_vdw_phi. It requires a previous 
! call to vv_vdw_set_kc to set k mesh.

  implicit none
  real(dp),intent(in) :: k            ! Modulus of actual k vector
  real(dp),intent(out):: phi(:,:)     ! phi(k1,k2,k) at given k
                                      ! for all k1,k2 in (kf,kg) mesh
  real(dp),intent(out):: dphidk(:,:)  ! dphi(k1,k2,k)/dk at given k

  integer :: ik, ik1, ik2
  real(dp):: a, a2, a3, b, b2, b3

! Set interpolation table
  if (.not.phi_table_set) call set_phi_table()

! Check argument sizes
  if (size(phi,1)<nkfg .or. size(phi,2)<nkfg) &
    call die('vv_vdw_phi: ERROR: size(phi) too small')

! Find phi values at point k
  if (k >= kcut) then
    phi(:,:) = 0
    dphidk(:,:) = 0
  else
    ! Expand interpolation inline since this is the hottest point in VdW
    ik = int(k/dk)
    a = ((ik+1)*dk-k)/dk
    b = 1 - a
    a2 = (3*a**2 -1) * dk / 6
    b2 = (3*b**2 -1) * dk / 6
    a3 = (a**3 - a) * dk**2 / 6
    b3 = (b**3 - b) * dk**2 / 6
    do ik2 = 1,nkfg
      do ik1 = 1,ik2
!        call splint( dk, phik(:,ik1,ik2), d2phidk2(:,ik1,ik2), &
!                     nk+1, k, phi(ik1,ik2), dphidk(ik1,ik2), pr )
        phi(ik1,ik2) = a*phik(ik,ik1,ik2) + b*phik(ik+1,ik1,ik2) &
                + a3*d2phidk2(ik,ik1,ik2) + b3*d2phidk2(ik+1,ik1,ik2)
        dphidk(ik1,ik2) = (-phik(ik,ik1,ik2) &
                               +phik(ik+1,ik1,ik2) )/dk &
                - a2*d2phidk2(ik,ik1,ik2) + b2*d2phidk2(ik+1,ik1,ik2)
        phi(ik2,ik1) = phi(ik1,ik2)
        dphidk(ik2,ik1) = dphidk(ik1,ik2)
      end do
    end do
  end if

end subroutine vv_vdw_phi

!-----------------------------------------------------------------------------

subroutine vv_vdw_phiofr( r, phi )

! Finds phi(k1,k2,r) with k1=(kf1,kg1), k2=(kf2,kg2) for mesh values of
! kf's (Fermi wavevectors) and kg's (grad(n)/n)

  implicit none
  real(dp),intent(in) :: r
  real(dp),intent(out):: phi(:,:)

  integer :: ikf1, ikf2, ikg1, ikg2, ik1, ik2
  real(dp):: dphidr

  if (size(phi,1)<nkfg .or. size(phi,2)<nkfg) &
    call die('vv_phiofr: ERROR: size(phi) too small')
  if (.not.phi_table_set) call set_phi_table()

  if (r >= rcut) then
    phi(:,:) = 0
  else
    do ik2 = 1,nkfg
      do ik1 = 1,ik2
        call splint( dr, phir(:,ik1,ik2), d2phidr2(:,ik1,ik2), &
                     nr+1, r, phi(ik1,ik2), dphidr )
        phi(ik2,ik1) = phi(ik1,ik2)
      end do ! ik1
    end do ! ik2
  end if ! (r>=rcut)

end subroutine vv_vdw_phiofr

!-----------------------------------------------------------------------------

subroutine vv_vdw_set_kcut( kc )

! Sets the reciprocal planewave cutoff kc of the integration grid, and finds 
! the interpolation table to be used by vdw_phi to obtain the vdW kernel phi
! at the reciprocal mesh wavevectors.

  implicit none
  real(dp),intent(in):: kc  ! Planewave cutoff: k>kcut => phi=0

  real(dp):: pi

  ! Set kcut and radial mesh parameters, if not already set
  if (.not. kc==kcut) then
    kcut = kc
    pi = acos(-1._dp)
    dr = rcut / nr
    dk = pi / rcut
    kmax = pi / dr
    nk = int(kcut/dk) + 1
    if (nk>nr) call die('vv_vdw_set_kcut: ERROR: nk>nr')
    kcut_set = .true.
#ifdef DEBUG_XC
    write(udebug,'(a,5f8.3)') 'vv_vdw_set_kcut: kfcut,kgcut,rcut,kcut,kmax=', &
      kfcut, kgcut, rcut, kc, kmax
#endif /* DEBUG_XC */
  end if

  ! Set (kf,kg) mesh and phi table
  call set_kmesh()
  call set_phi_table()

end subroutine vv_vdw_set_kcut

!-----------------------------------------------------------------------------

subroutine vv_vdw_theta( nspin, rhos, grhos, theta, dtdrho, dtdgrho )

! Finds the value and derivatives of theta_i(rho,grad_rho) of eq.(8)
! of Roman-Soler PRL 2009. In practice, theta_i=p_i rather than rho*p_i,
! beacuse p_i is used here to expand rho1*rho2*phi rather than only phi.

  implicit none
  integer, intent(in) :: nspin                 ! Number of spin components
  real(dp),intent(in) :: rhos(nspin)           ! Electron spin density
  real(dp),intent(in) :: grhos(3,nspin)        ! Spin density gradient
  real(dp),intent(out):: theta(nkfg)           ! Exp. polynomials at (kf,kg)
  real(dp),intent(out):: dtdrho(nkfg,nspin)    ! dtheta(ik)/drhos
  real(dp),intent(out):: dtdgrho(3,nkfg,nspin) ! dtheta(ik)/dgrhos(ix)

  integer :: is, ix, ns
  real(dp):: rho, grho(3), dpdkf(nkfg), dpdkg(nkfg), dkfdrho, dkfdgrho(3), &
             dkgdrho, dkgdgrho(3), kf, kg, p(nkfg)

  ! Sum spin components of electron density
  ns = min(nspin,2)     ! num. of diagonal spin components (if noncollinear)
  rho = sum(rhos(1:ns))            ! local electron density
  grho = sum(grhos(:,1:ns),dim=2)  ! local density gradient

  ! If density is between threshold, return zero
  if (rho<rhoMin) then
    theta = 0
    dtdrho = 0
    dtdgrho = 0
    return
  end if

  ! Find local Fermi and gradient wavevectors, and their derivatives
  call kofn( rho, grho, kf, kg, dkfdrho, dkgdrho, dkfdgrho, dkgdgrho )

  ! Find expansion polynomials of integrand kernel of nonlocal vdW energy
  call pofk( kf, kg, p, dpdkf, dpdkg )

  ! Find theta functions and their derivatives with respect to rho and grho
  if (kernelPrefactor=='rho') then
    ! This is the right code if vv_vdw_phi_val returns rho1*rho2*phi
    theta(1:nkfg) = p(1:nkfg)
    do is = 1,ns
      dtdrho(1:nkfg,is) = dpdkf(1:nkfg)*dkfdrho + dpdkg(1:nkfg)*dkgdrho
      do ix = 1,3
        dtdgrho(ix,1:nkfg,is) = dpdkf(1:nkfg)*dkfdgrho(ix) &
                              + dpdkg(1:nkfg)*dkgdgrho(ix)
      end do
    end do
  else if (kernelPrefactor=='kf') then
    ! This is the right code if vv_vdw_phi_val returns kf1*kf2*phi
    kf = max(kf,ktol)
    theta(1:nkfg) = p(1:nkfg)*rho/kf
    do is = 1,ns
      dtdrho(1:nkfg,is) = (dpdkf(1:nkfg)*dkfdrho &
                          +dpdkg(1:nkfg)*dkgdrho)*rho/kf &
                        + p(1:nkfg)*(1/kf-rho/kf**2*dkfdrho)
      do ix = 1,3
        dtdgrho(ix,1:nkfg,is) = (dpdkf(1:nkfg)*dkfdgrho(ix) &
                                +dpdkg(1:nkfg)*dkgdgrho(ix))*rho/kf
      end do
    end do
  else if (kernelPrefactor=='kf2') then
    ! This is the right code if vv_vdw_phi_val returns (kf1*kf2)**2*phi
    kf = max(kf,ktol)
    theta(1:nkfg) = p(1:nkfg)*rho/kf**2
    do is = 1,ns
      dtdrho(1:nkfg,is) = (dpdkf(1:nkfg)*dkfdrho &
                          +dpdkg(1:nkfg)*dkgdrho)*rho/kf**2 &
                        + p(1:nkfg)*(1/kf**2-2*rho/kf**3*dkfdrho)
      do ix = 1,3
        dtdgrho(ix,1:nkfg,is) = (dpdkf(1:nkfg)*dkfdgrho(ix) &
                                +dpdkg(1:nkfg)*dkgdgrho(ix))*rho/kf**2
      end do
    end do
  else if (kernelPrefactor=='sqr_rho') then
    ! This is the right code if vv_vdw_phi_val returns sqrt(rho1*rho2)*phi
    rho = max(rho,1.e-12_dp)  ! to avoid division by zero
    theta(1:nkfg) = p(1:nkfg) * sqrt(rho)
    do is = 1,ns
      dtdrho(1:nkfg,is) = ( dpdkf(1:nkfg)*dkfdrho &
                          + dpdkg(1:nkfg)*dkgdrho ) * sqrt(rho) &
                        + p(1:nkfg) * 0.5/sqrt(rho)
      do ix = 1,3
        dtdgrho(ix,1:nkfg,is) = dpdkf(1:nkfg)*dkfdgrho(ix) * sqrt(rho) &
                              + dpdkg(1:nkfg)*dkgdgrho(ix) * sqrt(rho)
      end do
    end do
  else
    call die('vv_vdw_theta ERROR: unknown kernelPrefactor')
  end if ! (kernelPrefactor=='rho')

end subroutine vv_vdw_theta

END MODULE gridxc_vv_vdwxc

#if defined HAVE_CONFIG_H
#include "config.h"
#endif

!!@LICENSE

module gridxc_bessph

  implicit none

  private

  public :: bessph

contains

  function bessph(L,X) result(B)

    ! RETURNS THE SPHERICAL BESSEL FUNCTION JL(X).
    ! REF: ABRAMOWITZ AND STEGUN, FORMULAS 10.1.2 AND 10.1.19
    ! WRITTEN BY J.SOLER. NOV/89.
    ! F90 conversion, by Nick Papior, feb/2018
    use gridxc_precision, only: dp
    use gridxc_sys, only: die

    integer, intent(in)  :: L
    real(dp), intent(in) :: X
    real(dp) :: B
    
    integer, parameter :: nterms = 100
    real(dp), parameter :: zero = 0.0_dp, one = 1.0_dp, tiny=1.0e-15_dp

    integer :: i, n
    real(dp) :: switch, term, x2, y, fnm1, fn, fnp1
    character(len=128):: msg

    if ( abs(x) < max(1, 2*L - 1) ) then
      ! Use power series
      TERM = ONE
      do I = 1 , L
        TERM = TERM * X/(2*I+1)
      end do
      X2 = X * X
      FN = ZERO
      do I = 1 , NTERMS
        FN = FN + TERM
        TERM = -TERM * X2 / (4._dp * I * (I + L + 0.5_dp))
        if ( abs(TERM) < tiny ) exit
      end do
      if ( abs(TERM) > tiny ) then
        write(msg,*) 'BESSPH: SERIES HAS NOT CONVERGED. L,X=',L,X
        call die(trim(msg))
      end if
      B = FN
      
    else
      
      ! Use explicit expressions or recurrence relation
      select case ( L )
      case ( 0 )
        
        B = sin(X) / X
        
      case ( 1 )
        
        B = (sin(X) / X - cos(X) ) / X
        
      case default
        
        Y = ONE / X
        fnm1 = sin(X) * Y
        fn = (fnm1 - cos(X)) * Y
        DO N = 1 , L-1
          FNP1 = (2 * N + 1) * Y * fn - fnm1
          FNM1 = FN
          FN = FNP1
        end do
        B = fn
        
      end select
      
    end if
            
  end function bessph
  
end module gridxc_bessph

#if defined HAVE_CONFIG_H
#include "config.h"
#endif

!<
!```
! Provides the following main XC routines:
!
!   gridxc_init     ! Initialization
!
!   gridxc_atomXC   ! XC for a spherical charge distribution
!   gridxc_cellXC   ! XC for a periodic unit cell
!   gridxc_setXC    ! Sets XC functional(s) to be used by atomXC and/or cellXC
!
!   (For the latter there are two simpler alternatives:
!   gridxc_setxc_family_authors(family,authors)
!   gridxc_setxc_libxc_ids(nfuncs,libxc_ids)
!   )
!
!   gridxc_getXC    ! Returns the XC functional(s) being used
!
! Real kinds (precision) of arguments to call atomxc and cellxc
!   grid_p ! Precision for grid arrays to call cellxc

! Secondary entry points for testers and lower-level programming
!   gridxc_ldaxc    ! LDA-XC functionals
!   gridxc_ggaxc    ! GGA-XC functionals

! Extra utilities placed here for non-siesta users
! See correspondig modules in the source for usage documentation
!
!   gridxc_nfft          ! Get allowed sizes for FFTs (for VDW functionals)
!   setMeshDistr         ! Set a distribution of mesh points over processors
!   myMeshBox            ! Get my processor mesh box
!
!   setDebugOutputUnit   ! Initialize debug report
!   closeDebugOutputFile ! Print debug report
!```

MODULE gridXC

! Real kinds (precision) of arguments

  USE gridxc_precision, only: dp      ! Standard real-kind (double) precision
  USE gridxc_precision, only: grid_p  ! Precision for grid arrays

! Main entry routines of gridXC library
!--------------------------------------------------------------
  use gridxc_config, only: gridxc_init  ! initialization

  ! XC for a spherical charge distribution
  USE gridxc_atom,     only: gridxc_atomXC => atomXC ! XC for a radial grid
  USE gridxc_cell,     only: gridxc_cellXC => cellXC ! XC for a periodic unit cell

  USE gridxc_xcmod,    only: gridxc_getXC => getXC   ! Returns XC functional(s)
  USE gridxc_xcmod,    only: gridxc_setXC => setXC   ! Sets XC functional(s)
#ifdef HAVE_LIBXC
  USE gridxc_xcmod,    only: gridxc_setXC_libxc => setXC_libxc_ids   ! Sets XC functional(s)
#endif

! Secondary entry points for testers and lower-level programming
  USE gridxc_lda,  only: gridxc_ldaxc => ldaxc    ! LDA-XC functionals
  USE gridxc_gga,  only: gridxc_ggaxc => ggaxc    ! GGA-XC functionals

! Extra utilities placed here for convenience
! See correspondig modules for usage documentation
  USE gridxc_fft_gpfa,    only: gridxc_nfft => nfft  ! Get allowed sizes for FFTs
!----------------------------------------------------------------------
!-----------------------------------
#ifdef DEBUG_XC
  USE gridxc_debugXC,  only: setDebugOutputUnit   ! Set debug report
  USE gridxc_debugXC,  only: closeDebugOutputFile ! Print debug report
#endif
  USE gridxc_mesh3D,   only: myMeshBox            ! Get my processor mesh box
  USE gridxc_mesh3D,   only: setMeshDistr         ! Set a distribution of mesh
                                                  ! points over parallel processors

! Handlers

  USE gridxc_sys,      only: gridxc_set_error_handler => set_die_routine
  USE gridxc_sys,      only: gridxc_set_timer_start_handler => set_timer_start_routine
  USE gridxc_sys,      only: gridxc_set_timer_stop_handler => set_timer_stop_routine
  USE gridxc_alloc,    only: gridxc_set_alloc_event_handler => set_alloc_event_handler
  USE gridxc_alloc,    only: gridxc_set_alloc_error_handler => set_alloc_error_handler

  PUBLIC

END MODULE gridXC
  

#if defined HAVE_CONFIG_H
#include "config.h"
#endif

!!@LICENSE
!
!******************************************************************************
! MODULE fftr
! Handles 3-D fast Fourier transform of real functions
! Written by J.M.Soler. Feb.2008
!******************************************************************************
!
!   PUBLIC procedures available from this module:
! fftr2k : 3-D FFT transform from real to reciprocal space of a real function
! fftk2r : 3-D FFT transform from reciprocal to real space
!
!   PUBLIC parameters, types, and variables available from this module:
! none
!
!******************************************************************************
!
!   USED module procedures:
! use gridxc_fft3d, only: fft3d         ! 3D FFT of a complex function
! use gridxc_mesh3D,  only: myMeshBox     ! Returns the mesh box of my processor
! use gridxc_mesh3D,  only: setMeshDistr  ! Sets a new mesh distribution
! use gridxc_mesh3D,  only: fftMeshDistr  ! Sets a mesh distr. for FFTs
! use gridxc_mesh3D,  only: freeMeshDistr ! Frees a mesh distribution ID
! use gridxc_mesh3D,  only: copyMeshData  ! Copies data in a box of mesh points
! use gridxc_alloc,   only: de_alloc      ! De-allocation routine
! use gridxc_alloc,   only: re_alloc      ! Re-allocation routine
! use gridxc_sys,     only: die           ! Termination routine
!
!   USED module parameters:
! use gridxc_precision,  only: dp              ! Real double precision type
! use gridxc_precision,  only: gp=>grid_p      ! Real precision type of mesh arrays
!
!   EXTERNAL procedures used:
! none
!
!******************************************************************************
!
! SUBROUTINE fftr2k( nMesh, rDistr, f )

! 3-D fast Fourier transform from real to reciprocal space of a real function.
! On input, f must contain a real function in a box of grid points.
! On output, it contains the real part of its discrete Fourier transform 
! (if grid_index(k)<grid_index(-k)) or its imaginary part (if 
! grid_index(k)>grid_index(-k)) in a box of k mesh points. The real space box
! is determined by rDistr. The k-box is determined by kDistr, as returned by
! routine fftMeshDistr. See module mesh3D for details. In serial execution, 
! f contains the function at all mesh points in both r and k space
!------------------------------ INPUT -----------------------------------------
! integer nMesh(3)       : Total num. of mesh points in each axis
! integer rDistr         : Distribution ID of real-space mesh
!----------------------- INPUT and OUTPUT -------------------------------------
! real(gp) f(0:,0:,0:,:) : Functions to be Fourier transformed
!                          Array shape must be enough to contain
!                          both real- and k-space mesh boxes
!----------------------------- UNITS ------------------------------------------
! Units of f are arbitrary
!----------------------------- USAGE ------------------------------------------
!   Sample usage to find the electrostatic Hartree potential:
! use gridxc_precision, only: gp=>grid_p
! use gridxc_fftr,      only: fftk2r, fftr2k
! use gridxc_mesh3D,    only: fftMeshDistr, myMeshBox, setMeshDistr
! integer:: kBox(2,3), kDistr, kMesh(3), maxMesh(3), nMesh(3), &
!           rBox(2,3), rDistr, rMesh(3)
! real(dp):: rCell(3,3), kCell(3,3), kVec(3), pi
! real(gp),allocatable:: f(:,:,:,:)
! ...Find rCell, kCell, nMesh, pi
! call setMeshDistr( rDistr, nMesh )
! call fftMeshDistr( nMesh, kDistr )
! call myMeshBox( nMesh, rDistr, rBox )
! call myMeshBox( nMesh, kDistr, kBox )
! rMesh(:) = rBox(2,:)-rBox(1,:)+1
! kMesh(:) = kBox(2,:)-kBox(1,:)+1
! maxMesh(:) = max( rMesh(:), kMesh(:) )
! allocate( f(0:maxMesh(1)-1,0:maxMesh(2)-1,0:maxMesh(3)-1,1) )
! f(0:rMesh(1)-1,0:rMesh(2)-1,0:rMesh(3)-1,1) = my_density
! call fftr2k( nMesh, rDistr, f )
! do k3 = kBox(1,3),kBox(2,3)
! do k2 = kBox(1,2),kBox(2,2)
! do k1 = kBox(1,1),kBox(2,1)
!   i1 = k1 - kBox(1,1)
!   i2 = k2 - kBox(1,2)
!   i3 = k3 - kBox(1,3)
!   kVec(:) = kCell(:,1)*k1 + kCell(:,2)*k2 + kCell(:,3)*k3
!   f(i1,i2,i3,1) = f(i1,i2,i3,1) * 4*pi/sum(kVec**2)
! end do
! end do
! end do
! call fftk2r( nMesh, rDistr, f )
! my_Vhartree = f(0:rMesh(1)-1,0:rMesh(2)-1,0:rMesh(3)-1,1)
!---------------------------- BEHAVIOUR ---------------------------------------
! If shape of f is not enough to contain my processor's mesh box in both real
!   and reciprocal space, it stops with an error warning.
!--------------------------- ALGORITHMS ---------------------------------------
! The real function array is copied into a complex array.
! The complex array data is redistributed from rDistr to kDistr using 
!   copyMeshData
! The complex array is Fourier transformed using fft3d
! The real imaginary parts of f, in reciprocal space, are stored in pairs of
!   (k,-k) values. The real part goes into whatever k or -k has a lower
!   mesh point index. The imaginary part to the higher-index one.
!
!******************************************************************************
!
! Subroutine fftk2r( nMesh, rDistr, f )
!
! 3-D fast Fourier transform from reciprocal to real space of a real function.
! On input, f must contain, in a box of reciprocal grid points, either the
! real part (if grid_index(k)<grid_index(-k)) or the imaginary part 
! (if grid_index(k)>grid_index(-k)) of a function that is real in r space. 
! On output, it contains its inverse Fourier transform, i.e. the function in 
! a box of real space mesh points.
!------------------------------ INPUT -----------------------------------------
! integer nMesh(3)    : Total num. of mesh points in each axis
! integer rDistr      : Distribution ID of real-space mesh
!----------------------- INPUT and OUTPUT -------------------------------------
! real(gp) f(0:,0:,0:,:) : Functions to be Fourier transformed
!                          Array shape must be enough to contain
!                          both real- and k-space mesh boxes
!----------------------------- UNITS ------------------------------------------
! Units of f are arbitrary
!----------------------------- USAGE ------------------------------------------
! See usage section in fftr2k
!---------------------------- BEHAVIOUR ---------------------------------------
! If shape of f is not enough to contain my processor's mesh box in both real
!   and reciprocal space, it stops with an error warning.
!--------------------------- ALGORITHMS ---------------------------------------
! The reciprocal-space values of f, at -k values, are obtained using 
!   copyMeshData, for the negative image of my processor's kBox
! The real and imaginary parts of f, at all my kBox points, is obtained from 
!   the values of f at k and -k.
! The complex function is back Fourier transformed to real space.
! The real part of the complex function, in real space, is redistributed and
!   copied to the output array within my processor's rBox, using copyMeshData.
!
!******************************************************************************

MODULE gridxc_fftr

  use gridxc_precision, only: dp            ! Double precision real type
  use gridxc_precision, only: gp=>grid_p    ! Real precision type of mesh arrays
  use gridxc_alloc,     only: de_alloc      ! De-allocates arrays
  use gridxc_alloc,     only: re_alloc      ! Re-allocates arrays
  use gridxc_fft3d,   only: fft3d         ! 3D FFT of a complex function
  use gridxc_mesh3D,    only: associateMeshTask ! Associates commun. tasks and distr.
  use gridxc_mesh3D,    only: myMeshBox     ! Returns the mesh box of my processor
  use gridxc_mesh3D,    only: setMeshDistr  ! Sets a new mesh distribution
  use gridxc_mesh3D,    only: fftMeshDistr  ! Sets a mesh distr. for FFTs
  use gridxc_mesh3D,    only: freeMeshDistr ! Frees a mesh distribution ID
  use gridxc_mesh3D,    only: copyMeshData  ! Copies data in a box of mesh points
  use gridxc_sys,       only: die           ! Terminates execution
#ifdef DEBUG_XC
!  use gridxc_debugXC,   only: udebug        ! File unit for debug output
#endif /* DEBUG_XC */

  implicit none

PUBLIC::    &
  fftk2r,   &! k->r (inverse) Fourier transform
  fftr2k     ! r->k (direct) Fourier transform

PRIVATE ! Nothing is declared public beyond this point

  integer,save:: k2r=-1         ! ID of task to change from k to r distribs.
  integer,save:: kDistr=-1      ! k-mesh distribution ID
  integer,save:: mk2k=-1        ! ID of task to change from -k to k data
  integer,save:: r2k=-1         ! ID of task to change from r to k distribs.
  integer,save:: theMesh(3)=0   ! Number of mesh points in each axis

CONTAINS

!------------------------------------------------------------------------------

subroutine fftr2k( nMesh, rDistr, f )

! 3-D fast Fourier transform from real to reciprocal space of a real function.

  implicit none

  integer, intent(in)   :: nMesh(3)    ! Total num. of mesh points in each axis
  integer, intent(in)   :: rDistr      ! Distribution ID of real-space mesh
  real(gp),intent(inout):: f(0:,0:,0:,:) ! Functions to be Fourier transformed
                                       ! Array shape must be enough to contain
                                       ! both real- and k-space mesh boxes

  character(len=*),parameter:: myName='fftr2k '
  integer:: ib1, ib2, ib3, ic, ic1, ic2, ic3, ip, jc1, jc2, jc3, jf, jp, &
            kBox(2,3), mkBox(2,3), myKmesh(3), myRmesh(3), rBox(2,3)
  real(gp),pointer:: fc(:,:,:,:)=>null()

! Find box of real-space mesh points corresponding to this node
  call myMeshBox( nMesh, rDistr, rBox )
  myRmesh(:) = rBox(2,:) - rBox(1,:) + 1

! Find box of k-space mesh points corresponding to this node
  call fftMeshDistr( nMesh, kDistr )
  call myMeshBox( nMesh, kDistr, kBox )
  myKmesh(:) = kBox(2,:) - kBox(1,:) + 1

! Associate communication tasks to mesh distributions
  call associateMeshTask( r2k, rDistr, kDistr )

! Check that input array is large enough
  do ic = 1,3
    if (size(f,ic) < max(myRmesh(ic),myKmesh(ic))) &
      call die(myName//'ERROR: size of input array f too small')
  end do

! Allocate complex array for fft
  call re_alloc( fc, kBox(1,1),kBox(2,1), &
                     kBox(1,2),kBox(2,2), &
                     kBox(1,3),kBox(2,3), 1,2, myName//'fc' )

! Loop on functions to be Fourier transformed
  do jf = 1,size(f,4)

    ! Copy real function to complex array
    call copyMeshData( nMesh, rDistr, f(:,:,:,jf:jf), kBox, fc(:,:,:,1:1), r2k )
    fc(:,:,:,2) = 0

    ! Perform Fourier transform
    call fft3d( fc, kDistr, nMesh, +1 )

    ! Store real and imaginary parts in pairs of k and -k vectors
    ! Real part goes to that of k,-k with lowest point index in cell
    ! Imaginary part goes to that with highest point index
    f(:,:,:,jf) = 0
    do ic3 = kBox(1,3),kBox(2,3)   ! Mesh indexes relative to cell origin
    do ic2 = kBox(1,2),kBox(2,2)
    do ic1 = kBox(1,1),kBox(2,1)
      ib1 = ic1 - kBox(1,1)        ! Mesh indexes relative to box origin
      ib2 = ic2 - kBox(1,2)
      ib3 = ic3 - kBox(1,3)
      ip = 1 + ic1 + nMesh(1)*ic2 + nMesh(1)*nMesh(2)*ic3  ! k point index
      ! Find indexes of -k vector in unit cell
      jc1 = modulo(-ic1,nMesh(1))
      jc2 = modulo(-ic2,nMesh(2))
      jc3 = modulo(-ic3,nMesh(3))
      jp = 1 + jc1 + nMesh(1)*jc2 + nMesh(1)*nMesh(2)*jc3  ! -k point index
      ! Fill f(k) with real or imaginary part of (k,-k) pair
      if (ip<=jp) then ! Store f(k) = Re(fc(k)) = Re(fc(-k))
        f(ib1,ib2,ib3,jf) = fc(ic1,ic2,ic3,1)
      else  ! (ip>jp) => Store f(k) = Im(fc(-k)) = -Im(fc(k))
        f(ib1,ib2,ib3,jf) = -fc(ic1,ic2,ic3,2)
      end if ! (ip<=jp)
    end do ! ic1
    end do ! ic2
    end do ! ic3

  end do ! jf

! Deallocate temporary array
  call de_alloc( fc, myname//'fc' )

end subroutine fftr2k

!------------------------------------------------------------------------------

subroutine fftk2r( nMesh, rDistr, f )

! 3-D fast Fourier transform from reciprocal to real space of a real function.

  implicit none

  integer, intent(in)   :: nMesh(3)    ! Total num. of mesh points in each axis
  integer, intent(in)   :: rDistr      ! Distribution ID of real-space mesh
  real(gp),intent(inout):: f(0:,0:,0:,:) ! Functions to be Fourier transformed
                                       ! Array shape must be enough to contain
                                       ! both real- and k-space mesh boxes

  character(len=*),parameter:: myName='fftk2r '
  integer:: ib1, ib2, ib3, ic, ic1, ic2, ic3, ip, jc1, jc2, jc3, jf, jp, &
            kBox(2,3), mkBox(2,3), myKmesh(3), myRmesh(3), rBox(2,3)
  real(gp),pointer:: fmk(:,:,:,:)=>null(), fc(:,:,:,:)=>null()

! Find box of real-space mesh points corresponding to this node
  call myMeshBox( nMesh, rDistr, rBox )
  myRmesh(:) = rBox(2,:) - rBox(1,:) + 1

! Find box of k-space mesh points corresponding to this node
  call fftMeshDistr( nMesh, kDistr )
  call myMeshBox( nMesh, kDistr, kBox )
  myKmesh(:) = kBox(2,:) - kBox(1,:) + 1

! Check that input array is large enough
  do ic = 1,3
    if (size(f,ic) < max(myRmesh(ic),myKmesh(ic))) &
      call die(myName//'ERROR: size of input array f too small')
  end do

! Allocate a complex array for FFT and another to hold f(-k)
  call re_alloc( fc, kBox(1,1),kBox(2,1), &
                     kBox(1,2),kBox(2,2), &
                     kBox(1,3),kBox(2,3), 1,2, myName//'fc' )
  if (kDistr/=0) then  ! f distributed over parallel processors
    mkBox(1,:) = -kBox(2,:)
    mkBox(2,:) = -kBox(1,:)
    call re_alloc( fmk, mkBox(1,1),mkBox(2,1), &
                        mkBox(1,2),mkBox(2,2), &
                        mkBox(1,3),mkBox(2,3), 1,1, myName//'fmk' )
  end if ! (kDistr/=0)

! Associate communication tasks to mesh distributions
  call associateMeshTask( k2r, rDistr, kDistr )
  call associateMeshTask( mk2k, kDistr )

! Loop on functions to be transformed
  do jf = 1,size(f,4)

    ! Get f vales at -k mesh points
    if (kDistr/=0) &
      call copyMeshData( nMesh, kDistr, f(:,:,:,jf:jf), mkBox, fmk, mk2k )

    ! Retrieve real and imaginary parts from pairs of k and -k vectors
    do ic3 = kBox(1,3),kBox(2,3)   ! Mesh indexes relative to cell origin
    do ic2 = kBox(1,2),kBox(2,2)
    do ic1 = kBox(1,1),kBox(2,1)
      ib1 = ic1 - kBox(1,1)        ! Mesh indexes relative to box origin
      ib2 = ic2 - kBox(1,2)
      ib3 = ic3 - kBox(1,3)
      ip = 1 + ic1 + nMesh(1)*ic2 + nMesh(1)*nMesh(2)*ic3
      ! Find indexes of -k vector in unit cell
      jc1 = modulo(-ic1,nMesh(1))
      jc2 = modulo(-ic2,nMesh(2))
      jc3 = modulo(-ic3,nMesh(3))
      jp = 1 + jc1 + nMesh(1)*jc2 + nMesh(1)*nMesh(2)*jc3
      ! Retrieve real and imaginary parts from (k,-k) pair
      if (ip==jp) then      ! -k=k+G  =>  fc(k) is real
        fc(ic1,ic2,ic3,1) = f(ib1,ib2,ib3,jf)
        fc(ic1,ic2,ic3,2) = 0
      else if (ip<jp) then  ! fc(k) = cmplx(f(k),f(-k))
        fc(ic1,ic2,ic3,1) = f(ib1,ib2,ib3,jf)
        if (kDistr==0) then ! f array not distributed
          fc(ic1,ic2,ic3,2) = f(jc1,jc2,jc3,jf)
        else                ! f array distributed over parallel processors
          fc(ic1,ic2,ic3,2) = fmk(-ic1,-ic2,-ic3,1)
        end if
      else ! (ip>jp)   =>     fc(k) = conjg(fc(-k)) = conjg(f(-k),f(k))
        if (kDistr==0) then
          fc(ic1,ic2,ic3,1) = f(jc1,jc2,jc3,jf)
        else
          fc(ic1,ic2,ic3,1) = fmk(-ic1,-ic2,-ic3,1)
        end if
        fc(ic1,ic2,ic3,2) = -f(ib1,ib2,ib3,jf)
      end if ! (ip==jp)
    end do ! ic1
    end do ! ic2
    end do ! ic3

    ! Perform inverse Fourier transform
    call fft3d( fc, kDistr, nMesh, -1 )

    ! Copy real function from complex to output array
    call copyMeshData( nMesh, kDistr, fc(:,:,:,1:1), rBox, f(:,:,:,jf:jf), k2r )

  end do ! jf

! Deallocate temporay arrays
  if (kDistr/=0) call de_alloc( fmk, myName//'fmk' )
  call de_alloc( fc, myname//'fc' )

end subroutine fftk2r

END MODULE gridxc_fftr

#if defined HAVE_CONFIG_H
#include "config.h"
#endif

PROGRAM gridXCtest3

  ! Tester of cellXC. Compares the potential and stress with the numerical
  ! (finite-difference) derivatives of the energy. J.M.Soler. Sept.2009

  ! Used module procedures
  USE gridXC, only: cellXC => gridxc_cellXC
  USE gridXC, only: gridxc_init
  USE gridXC, only: myMeshBox 
  USE gridXC, only: nfft => gridxc_nfft
  USE gridXC, only: setMeshDistr
  USE gridXC, only: setXC => gridxc_setXC

  ! Used module parameters
  USE gridXC, only: dp
  USE gridXC, only: gp => grid_p

! Used MPI procedures and types
#ifdef HAVE_MPI
  USE mpi
#endif

  implicit none

  ! Tester parameters
  integer, parameter:: irel  = 0         ! Relativistic? 0=>no, 1=>yes
  integer, parameter:: nSpin = 2         ! Number of spin components
  integer, parameter:: nfTot = 19        ! Number of functionals available
  integer, parameter:: nRan =  6         ! Number of random points for test
  real(dp),parameter:: latConst = 10._dp ! Lattice constant, in Bohr
  real(dp),parameter:: Ecut = 30._dp     ! Planewave cutoff of the mesh
  real(dp),parameter:: Qtot = 10._dp     ! Integral of density distribution
  real(dp),parameter:: D1byD0 = 0.99_dp  ! Fractional change of density
  real(dp),parameter:: spinPol= 2._dp    ! Integral of densUp - densDown
  real(dp),parameter:: latCons= 10._dp   ! Lattice constant in Bohr
  real(dp),parameter:: asym = 0.5_dp     ! Orthorhombic asymetry 
  real(dp),parameter:: deltaDens = 1.e-6_dp ! Used for numerical derivatives
  real(dp),parameter:: deltaStrain = 1.e-4_dp ! Used for numerical derivatives

  ! List of functionals to be tested
!  integer, parameter:: nf = nfTot-4   ! Number of tested functionals
!  integer:: indexf(nf) = (/1,2,3,4,5,6,7,8,9,10,11,12,13,14,  18/) 
!                         ! Indexes from list below (only one VDW allowed)

  ! Same to test a single functional
  integer, parameter:: nf = 1        ! Number of tested functionals
  integer:: indexf(nf) = (/18/)      ! Indexes from list below

  ! All functionals available
  !                  1,           2,          3,           4,   
  !                  5,           6,          7,           8, 
  !                  9,          10,         11,          12,
  !                 13,          14,         15,          16,
  !                 17,          18,         19
  character(len=3):: &
    func(nfTot)=(/'LDA',       'LDA',       'GGA',       'GGA', &
                  'GGA',       'GGA',       'GGA',       'GGA', &
                  'GGA',       'GGA',       'GGA',       'GGA', &
                  'GGA',       'GGA',       'VDW',       'VDW', &
                  'VDW',       'VDW',       'VDW'       /)
  character(len=10):: &
    auth(nfTot)=(/'PZ        ','PW92      ','PW91      ','PBE       ', &
                  'RPBE      ','revPBE    ','LYP       ','WC        ', &
                  'PBEJsJrLO ','PBEJsJrHEG','PBEGcGxLO ','PBEGcGxHEG', &
                  'PBESOL    ','AM05      ','DRSLL     ','LMKLL     ', &
                  'C09       ','BH        ','VV        '/) 

  ! A few random numbers
  real(dp):: ran(nRan) = (/0.749218032_dp, 0.928517579_dp, 0.043866380_dp, &
                           0.669289084_dp, 0.392851044_dp, 0.502184791_dp /)

  ! Tester variables and arrays
  logical :: pointIsMine
  integer :: i, i1, i2, i3, ic, iDelta, ip, iRan, iSpin, lb1, lb2, lb3, &
             myBox(2,3), myDistr, myNode, &
             nMesh(3), nNodes, np, ub1, ub2, ub3
  real(dp):: cell(3,3), cell0(3,3), d0(nSpin), Dc, Dc0, &
             dEdDens, dEdStrain(3,3), dVol, Dx, Dx0, dxMax, &
             Ec, Ec0, Ex, Ex0, kCut, pi, &
             strain(3,3), stress(3,3), stress0(3,3), &
             tmp, volume, VxcSpin, wc(nfTot), wx(nfTot), x(3)
  real(gp),allocatable:: dens(:,:,:,:), dens0(:,:,:,:), &
                         Vxc(:,:,:,:), Vxc0(:,:,:,:)

#ifdef HAVE_MPI
  ! MPI-related variables
  integer:: MPIerror
#endif

  ! Initialize hybrid XC functional with all tested functionals
  wx = 1._dp / nf
  wc = 1._dp / nf
  call setXC( nf, func(indexf), auth(indexf), wx(indexf), wc(indexf) )

  ! Define a near-orthorhombic unit cell
  ! This is just to assume orthorhombicity in calculating nMesh from Ecut
  cell(:,:) = 0
  cell(1,1) = 1 - asym
  cell(2,2) = 1
  cell(3,3) = 1 + asym
  cell(:,1) = cell(:,1) + (/ 0.000_dp,  0.120_dp, -0.175_dp /)
  cell(:,2) = cell(:,2) + (/ 0.221_dp,  0.000_dp,  0.030_dp /)
  cell(:,3) = cell(:,3) + (/ 0.116_dp, -0.231_dp,  0.000_dp /)
  cell = cell * latConst
  volume = ( cell(2,1)*cell(3,2) - cell(3,1)*cell(2,2) ) * cell(1,3)  &
         + ( cell(3,1)*cell(1,2) - cell(1,1)*cell(3,2) ) * cell(2,3)  &
         + ( cell(1,1)*cell(2,2) - cell(2,1)*cell(1,2) ) * cell(3,3)

#ifdef HAVE_MPI
  ! Initialize MPI and get myNode and nNodes
  call MPI_Init( MPIerror )
  call MPI_Comm_Rank( MPI_Comm_World, myNode, MPIerror )
  call MPI_Comm_Size( MPI_Comm_World, nNodes, MPIerror )
#else
  myNode = 0
  nNodes = 1
#endif

  ! Find the number of mesh points in each direction
  pi = acos(-1._dp)
  kCut = sqrt(Ecut)
  dxMax = pi / kCut
  do ic = 1,3
    nMesh(ic) = ceiling( cell(ic,ic) / dxMax )
    call nfft( nMesh(ic) )
  end do

  ! Print parameters
  if (myNode==0) then
    print'(/,a,10(a3,4x))', 'funcs= ', func(indexf)
    print  '(a,10(a6,1x))', 'auths= ', auth(indexf)
    print'(a,3i6,f12.6)', 'nMesh, Ecut =', nMesh, Ecut
  end if

#ifdef HAVE_MPI
  ! Initialize mpi
  call gridxc_init(comm=MPI_Comm_World)
#else
  call gridxc_init()
#endif
  ! Find the box of mesh points own by my processor
  call setMeshDistr( myDistr, nMesh )
  call myMeshBox( nMesh, myDistr, myBox )
  lb1 = myBox(1,1)
  ub1 = myBox(2,1)
  lb2 = myBox(1,2)
  ub2 = myBox(2,2)
  lb3 = myBox(1,3)
  ub3 = myBox(2,3)

  ! Allocate arrays for density and potential
  allocate( dens(lb1:ub1,lb2:ub2,lb3:ub3,nSpin), &
           dens0(lb1:ub1,lb2:ub2,lb3:ub3,nSpin), &
             Vxc(lb1:ub1,lb2:ub2,lb3:ub3,nSpin), &
            Vxc0(lb1:ub1,lb2:ub2,lb3:ub3,nSpin) )

  ! Find density at mesh points
  np = product(nMesh)
  dVol = volume / np
  if (nSpin==1) then
    d0(1) = Qtot / volume
  else
    d0(1) = (Qtot+spinPol) / 2 / volume
    d0(2) = (Qtot-spinPol) / 2 / volume
  end if
  do i3 = lb3,ub3
  do i2 = lb2,ub2
  do i1 = lb1,ub1
    x(:) = cell(:,1)*i1/nMesh(1) &   ! Mesh point position
         + cell(:,2)*i2/nMesh(2) &
         + cell(:,3)*i3/nMesh(3)
    dens(i1,i2,i3,:) = d0(:) * (1 + D1byD0 * cos( 2*pi*x(1)/cell(1,1) ) &
                                           * cos( 2*pi*x(2)/cell(2,2) ) &
                                           * cos( 2*pi*x(3)/cell(3,3) ) )
  end do ! i1
  end do ! i2
  end do ! i3

  ! Find exchange and correlation energy and potential from density in cell
  call cellXC( irel, cell, nMesh, lb1, ub1, lb2, ub2, lb3, ub3, nSpin, &
               dens, Ex, Ec, Dx, Dc, stress, Vxc )

  ! Print total energies
  if (myNode==0) then
    print'(a,2f15.9)', 'Ex, Ec =', Ex, Ec
    print'(a,2f15.9)', 'Dx, Dc =', Dx, Dc
  end if

  ! Store unperturbed magnitudes
  cell0 = cell
  dens0 = dens
  Ex0 = Ex
  Ec0 = Ec
  Dx0 = Dx
  Dc0 = Dc
  stress0 = stress
  Vxc0 = Vxc

  ! Compare Vxc with numerical derivative of d(Ex+Ec)/dDens
  do iRan = 1,nRan

    ! Choose one spin component
    if (ran(iRan)< 0.5_dp) iSpin = 1
    if (ran(iRan)>=0.5_dp) iSpin = 2
    ran(iRan) = 2*mod(ran(iRan),0.5_dp)  ! ran(iRan) again in range (0:1)

    ! Choose one mesh point. Notice that index ranges are (0:nMesh-1)
    ip = np * ran(iRan)
    i3 = ip / nMesh(1) / nMesh(2)  ! Undo ip=i1+nMesh(1)*i2+nMesh(1)*nMesh(2)*i3
    ip = ip - nMesh(1) * nMesh(2) * i3
    i2 = ip / nMesh(1)
    i1 = ip - nMesh(1) * i2
    ! Find if point i1,i2,i3 is in my box
    pointIsMine = (lb1<=i1 .and. i1<=ub1 .and. &
                   lb2<=i2 .and. i2<=ub2 .and. &
                   lb3<=i3 .and. i3<=ub3)

    ! Find energies with dens(i1,i2,i3,iSpin)+/-delta
    dEdDens = 0
    do iDelta = -1,1,2
      dens = dens0
      if (pointIsMine) &
        dens(i1,i2,i3,iSpin) = dens0(i1,i2,i3,iSpin) + iDelta*deltaDens
      call cellXC( irel, cell, nMesh, lb1, ub1, lb2, ub2, lb3, ub3, nSpin, &
               dens, Ex, Ec, Dx, Dc, stress, Vxc )
      dEdDens = dEdDens + iDelta*(Ex+Ec)/(2*deltaDens)
    end do ! iDelta

#ifdef HAVE_MPI
    ! Send Vxc(i1,i2,i3,iSpin) to other nodes
    if (pointIsMine) then
      VxcSpin = Vxc0(i1,i2,i3,iSpin)
    else
      VxcSpin = 0
    end if
    tmp = VxcSpin
    call MPI_AllReduce( tmp, VxcSpin, 1, MPI_double_precision, &
                        MPI_Sum, MPI_Comm_World, MPIerror )
#else
    VxcSpin = Vxc0(i1,i2,i3,iSpin)
#endif
    if (myNode==0) then
      if (iRan==1) print'(4a6,3a15)', &
        'i1','i2','i3','iSpin','Vxc','dExc/dDens','diff'
      print'(4i6,3f15.9)', &
        i1, i2, i3, iSpin, VxcSpin, dEdDens/dVol, VxcSpin-dEdDens/dVol
    end if

  end do ! iRan

  ! Compare stress with numerical derivative of dE/dStrain
  dens = dens0
  do i2 = 1,3
    do i1 = 1,3
      dEdStrain(i1,i2) = 0
      do iDelta = -1,1,2
        strain(:,:) = 0
        forall(i=1:3) strain(i,i) = 1
        strain(i1,i2) = strain(i1,i2) + iDelta*deltaStrain
        cell = matmul( strain, cell0 )
        call cellXC( irel, cell, nMesh, lb1, ub1, lb2, ub2, lb3, ub3, nSpin, &
               dens, Ex, Ec, Dx, Dc, stress, Vxc )
        dEdStrain(i1,i2) = dEdStrain(i1,i2) + iDelta*(Ex+Ec)/(2*deltaStrain)
      end do ! iDelta
    end do ! i1
  end do ! i2
  if (myNode==0) then
    print'(a,/,(3f15.9))', 'xc stress * volume =', stress0*volume
    print'(a,/,(3f15.9))', 'dExc/dStrain =', dEdStrain
    print'(a,/,(3f15.9))', 'diff =', (stress0*volume-dEdStrain)
  end if

! Finalize MPI
#ifdef HAVE_MPI
      call MPI_Finalize( MPIerror )
#endif

END PROGRAM gridXCtest3

#if defined HAVE_CONFIG_H
#include "config.h"
#endif

PROGRAM test_match_hse06

  ! Program to compare the built-in and the libxc
  ! numerical results for HSE06
  ! It uses a radial charge density, and atomxc as driver

  ! NOTE: Neither the libxc functional number below (428), nor
  ! the exact conditions for its use or any other needed parameters,
  ! have been thoroughly checked.
  ! nSpin has been set to 1 in this test.


  ! nspin and the relativistic flag are hard-wired
  
  ! Used module procedures
  USE gridXC, only: atomXC => gridxc_atomXC
  USE gridXC, only: setXC  => gridxc_setXC, setXC_libxc => gridxc_setXC_libxc
  USE gridXC, only: gridxc_init

  ! Used module parameters
  USE gridXC, only: dp

  implicit none

  ! Tester parameters
  integer, parameter:: irel  =  0 ! Relativistic? 0=>no, 1=>yes
  integer, parameter:: nSpin =  1 ! Number of spin components
  integer, parameter:: nr    = 101 ! Number of radial points
  integer, parameter:: n1cut =  8 ! Cutoff parameter
  integer, parameter:: n2cut =  2 ! Cutoff parameter:
                                  !    fCut(r)=(1-(r/rMax)**n1cut)**n2cut
  real(dp),parameter:: dWidth = 2._dp ! Width of density distribution, in Bohr
  real(dp),parameter:: Qtot = 10._dp  ! Integral of density distribution
  real(dp),parameter:: spinPol= 2._dp ! Integral of densUp - densDown
  real(dp),parameter:: rMax = 20._dp  ! Cutoff radius, in Bohr
  real(dp),parameter:: deltaDens = 1.e-8_dp  ! Finite diff. change
  real(dp),parameter:: densMin  = 1.e-9_dp  ! Min. density to proceed


  ! Tester variables and arrays
  integer :: iDelta, ir, irmax, ismax, iSpin, one, two
  real(dp):: avgDiffVxc, dDensdr, dens(nr,nSpin), dens0(nr,nSpin), &
             d0tot, d0(nSpin), dEdDens, dDens, diffVxc, &
             Dc, Dc0, dr, dVol, Dx, Dx0, Ec, Ec0, Ex, Ex0, &
             kf, kg, maxDiffVxc, pi, r, rMesh(nr), &
             Vxc(nr,nSpin), Vxc0(nr,nSpin),  wr

  
  ! Find radial mesh points and gaussian density
  pi = acos(-1._dp)
  d0tot = Qtot / (2*pi*dWidth**2)**1.5_dp    ! Total density at origin
  if (nSpin==1) then
    d0(1) = d0tot
  else
    one = 1   ! A silly thing to satisfy the compiler when nSpin=1
    two = 2
    d0(one) = d0tot * (Qtot + spinPol) / Qtot / 2 ! Spin up density at origin
    d0(two) = d0tot * (Qtot - spinPol) / Qtot / 2 ! Spin down density at origin
  end if
  dr = rmax / (nr-1)                      ! Interval between radial points
  do ir = 1,nr
    rMesh(ir) = dr * (ir-1)               ! Radial point values
    dens0(ir,:) = DensOfR( d0(:), rMesh(ir) )
  end do

  ! Find exchange and correlation energy and potential from radial density
  call setXC(1,['GGA'],['HSE06'], [1.0_dp], [1.0_dp])

  call atomXC( irel, nr, nr, rMesh, nSpin, dens0, Ex0, Ec0, Dx0, Dc0, Vxc0 )
  print "(a,3f16.8)", "Built-in Ex, Ec, sum: ", Ex0, Ec0, Ex0+Ec0
  print "(6f10.5)",  Vxc0

  call setXC_libxc(1,[428])
  
  call atomXC( irel, nr, nr, rMesh, nSpin, dens0, Ex0, Ec0, Dx0, Dc0, Vxc0 )
  print "(a,3f16.8)", "libxc Ex, Ec, sum: ", Ex0, Ec0, Ex0+Ec0
  print "(6f10.5)",  Vxc0
  
  
CONTAINS

FUNCTION DensOfR( d0, r )

  ! Returns a radial density distribution

  implicit none
  real(dp),intent(in):: d0(nSpin)  ! Density at center of charge distribution
  real(dp),intent(in):: r          ! Distance to center of charge distribution
  real(dp)           :: DensOfR(nSpin)  ! Electron density

  ! Use a simple gaussian distribution
  DensOfR = d0 * exp(-r**2/2/dWidth**2)

  ! Impose a smooth radial cutoff
  DensOfR = DensOfR * ( 1 - (r/rMax)**n1cut )**n2cut

END FUNCTION DensOfR

END PROGRAM test_match_hse06

#if defined HAVE_CONFIG_H
#include "config.h"
#endif

module gridxc_am05
! $Header:$
!**********************************************************************
! Armiento Mattsson am05 functional for exchange and correlation,
!  
! Spin polarization type: exchange index scales with the separate 
! spin densities; correlation index and prefactor both scales with
! the separate spin densities. (xscss)
! 
! Version: 7 (xscss, web)
!
! The latest version of this subroutine file is available at
!   http://dft.sandia.gov/functionals/AM05.html
!
!
! Usage:
!
! Below follows first a number of usage examples on how to calculate energy
! and potential in codes that use different schemes for calculating
! the potential, and therefore uses different input quantities. After the
! usage examples follows the main am05 routine.
!
! Examples for the following schemes are included:
!
!   am05trads : The traditional scheme used e.g. by PRB 33, 8800 (1986).
!   am05wbs : The White and Bird scheme [PRB 50, 4954 (1994)].
!   am05pgjs : The Pople, Gill, and Johnson scheme [CPL 199, 557 (1992)].
!   am05wbnums : The White and Bird scheme with numerical derivatives.
!
!
! Citation request: 
!
! When using this functional, please cite:
! "R. Armiento and A. E. Mattsson, PRB 72, 085108 (2005);
!  R. Armiento and A. E. Mattsson (unpublished)."
! (The first paper for the AM05 functional, the second for the
! spin-polarized version)
!
!
! License and copyright:
!
! (c) Rickard Armiento 2005-2008
!
! Permission is hereby granted, free of charge, to any person obtaining 
! a copy of this software and associated documentation files (the 
! "Software"), to deal in the Software without restriction, including 
! without limitation the rights to use, copy, modify, merge, publish, 
! distribute, sublicense, and/or sell copies of the Software, and to 
! permit persons to whom the Software is furnished to do so, subject 
! to the following conditions:
!
! The above copyright notice and this permission notice shall be 
! included in all copies or substantial portions of the Software.
!
! THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, 
! EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES 
! OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND 
! NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT 
! HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, 
! WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING 
! FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR 
! OTHER DEALINGS IN THE SOFTWARE.
!
!**********************************************************************
  use gridxc_precision, only : dp
  use gridxc_sys,       only : die

  implicit none

  public :: am05wbs

CONTAINS

!**********************************************************************
! saferecp
! Helper function for making divisions with built in cutoff 
! for very small denominators
!
! output
!   set   variable to assign the value of the reciprocal
!
! input
!   nom   nominator
!   denom denominator
!**********************************************************************

  subroutine saferecp(set, nom, denom)

!     ** Input parameters
  real(dp) nom, denom

!     ** Output parameters
  real(dp) set

  if (denom .ge. 1e-30) then
    set = nom/denom
  elseif (nom .le. 1e-30) then
    set = 0.0_dp
  elseif (nom .ge. 1e-30) then
    set = 1d30
  endif

  return
  end subroutine saferecp

!**********************************************************************
! am05wbs
! Usage example for White and Bird scheme [PRB 50, 4954 (1994)].
!
! input
!   nup    electron density [bohr**(-3)]
!   ndn    electron density [bohr**(-3)]
!   gup    abs of gradient of upspin density, |grad(nup)| [bohr**(-4)]
!   gdn    abs of gradient of downspin density, |grad(ndn)| [bohr**(-4)]
!
! output
!   fxc       exchange-correlation energy density [hartree]
!   dfxcup    d(fxc)/dnup [hartree]
!   dfxcdn    d(fxc)/dndn [hartree]
!   dfxcdgup  d(fxc)/d(|grad(nup)|) [hartree * bohr] 
!   dfxcdgdn  d(fxc)/d(|grad(ndn)|) [hartree * bohr] 
!
! Note that dfxcdgtot = d(fxc)/d(|grad(nup+ndn)|) = 0      
!
!**********************************************************************

  subroutine am05wbs(nup, ndn, gup, gdn, fx, fc, &
        dfxup, dfxdn, dfcup, dfcdn, dfxdgup, dfxdgdn, dfcdgup, dfcdgdn)

  implicit none

! ** Input parameters
  real(dp) nup, gup
  real(dp) ndn, gdn

! ** Output parameters
  real(dp) fx, fc, dfxup, dfxdn, dfcup, dfcdn
  real(dp) dfxdgup,dfxdgdn,dfcdgup,dfcdgdn

! ** Internal parameters
  real(dp) kFup, sup
  real(dp) kFdn, sdn
  real(dp) ex,ec 

  integer pot
  real(dp) pi
  parameter (pi = 3.141592653589793238462643383279502884197_dp)

! ** Dummy parameters (not used)
  real(dp) uup, udn, tup, tdn, vxup, vxdn, vcup, vcdn, stot

  kFup = (3.0_dp*pi**2*2.0_dp*nup)**(1.0_dp/3.0_dp)
  kFdn = (3.0_dp*pi**2*2.0_dp*ndn)**(1.0_dp/3.0_dp)
  call saferecp(sup,gup,(2.0_dp*kFup*nup))
  call saferecp(sdn,gdn,(2.0_dp*kFdn*ndn))

! ** Not needed input for pot=1
  pot = 1 
  stot = 0.0_dp
  uup = 0.0_dp
  udn = 0.0_dp
  tup = 0.0_dp
  tdn = 0.0_dp

  call am05_xscss(nup,ndn,sup,sdn,stot,uup,udn,tup,tdn, &
                  fx,fc,vxup,vxdn,vcup,vcdn, &
                  dfxup,dfxdgup,dfcup,dfcdgup, &
                  dfxdn,dfxdgdn,dfcdn,dfcdgdn,pot)

!     ** Form the output 
!     For SIESTA don't multiply by gradient since we need to divide
!     by this quantity on return to get components.
!      dfxdgup = gup*dfxdgup
!      dfxdgdn = gdn*dfxdgdn
!      dfcdgup = gup*dfcdgup
!      dfcdgdn = gdn*dfcdgdn

  return
  end subroutine am05wbs

!**********************************************************************
! am05
! Calculate the Armiento Mattsson AM05 exchange-correlation energy 
! functional and various functional derivatives for different
! potential schemes.
!
! Spin polarization type: exchange index scales with the separate 
! spin densities; correlation index and prefactor both scales with
! the separate spin densities. (xscss)
!
! Input:
!   nup     electron upspin density [bohr**(-3)]
!   ndn     electron downspin density [bohr**(-3)]
!
!   sup      scaled gradient of upspin-density
!   sdn      scaled gradient of downspin-density
!   stot     scaled gradient of total density
!
!   uup      scaled grad nup * grad | grad nup |
!   udn      scaled grad ndn * grad | grad ndn |
!
!   tup      scaled laplacian of upspin-density
!   tdn      scaled laplacian of downspin-density
!
!   pot      integer: 
!              2 = calculate potential in the traditional scheme
!                  (all input needed and all output well defined)
!              1 = calculate quantities for the White and Bird,
!                  and the Pople, Gill, and Johnson schemes for
!                  potentials (u and t and stot are never touched
!                  and vx and vc give undefined output)
!              0 = don't calculate potential (u and t and stot are never 
!                  touched and only ex and ec output are well defined)
!
! Output:
!
!   fx          exchange energy density [hartree], 
!                 Total exchange Ex = Integrate[fx]
!   fc          correlation energy density [hartree]
!                 Total correlation Ec = Integrate[fc]
!    
! if pot = 1 or 2:
!
!   dfxup     d(fx)/d(nup)
!   dfxdn     d(fx)/d(ndn)
!   dfcup     d(fc)/d(nup)
!   dfcdn     d(fc)/d(ndn)
!   dfxdgup   d(fx)/d(|grad(nup)|) * 1/|grad(nup)|
!   dfxdgdn   d(fx)/d(|grad(ndn)|) * 1/|grad(ndn)|
!   dfcdgup   d(fc)/d(|grad(nup)|) * 1/|grad(nup)|
!   dfcdgdn   d(fc)/d(|grad(ndn)|) * 1/|grad(ndn)|
!
! Note that dfxcdgtot = d(fxc)/d(|grad(nup+ndn)|) * 1/|grad(nup+ndn)| = 0
!
! if pot = 2:
!
!   vxup      upspin exchange potential
!   vxdn      downspin exchange potential
!   vcup      upspin correlation potential
!   vcdn      downspin correlation potential
!
! Citation request: when using this functional, please cite:
! "R. Armiento and A. E. Mattsson, PRB 72, 085108 (2005);
!  R. Armiento and A. E. Mattsson (unpublished)."
!
! (The first paper for the AM05 functional, the second for the
! spin-polarized version)
!
!**********************************************************************
  subroutine am05_xscss(nup,ndn,sup,sdn,stot,uup,udn,tup,tdn, &
                        fx,fc,vxup,vxdn,vcup,vcdn, &
                        dfxup,dfxdgup,dfcup,dfcdgup, &
                        dfxdn,dfxdgdn,dfcdn,dfcdgdn,pot)

! ** Input parameters
  real(dp) nup,ndn,sup,sdn,stot,uup,udn,tup,tdn
  integer pot

! ** Output parameters
  real(dp) fx,fc,vxup,vxdn,vcup,vcdn
  real(dp) dfxup,dfxdgup,dfcup,dfcdgup
  real(dp) dfxdn,dfxdgdn,dfcdn,dfcdgdn

! ** Constants
  real(dp) pi, g, a, c
  parameter (pi = 3.141592653589793238462643383279502884197_dp)
  parameter (g = 0.8098_dp, a = 2.804_dp)
  parameter (c = 0.7168_dp)

! ** Local variables
  real(dp) s2, kF, nn, ntot
  real(dp) n(2), s(2), t(2), u(2)
  real(dp) dfx(2), dfxdg(2), dfc(2), dfcdg(2), vx(2), vc(2)
  real(dp) exlda, vxlda, eclda, vclda(2), X(2), Xsos, Xsossos
  real(dp) Hx, Hxsos, Hxsossos, Hc(2), Hcsos, Hcsossos
  real(dp) F, Fsos, s2Fsossos 
  real(dp) szsoz, mixder
  real(dp) denom, denomsos, sdenomsoss
  real(dp) zfac, zosn, w

  integer i

! ** Initialization
  fx = 0.0_dp
  fc = 0.0_dp

  n(1) = nup
  n(2) = ndn
  s(1) = sup
  s(2) = sdn
  t(1) = tup
  t(2) = tdn
  u(1) = uup
  u(2) = udn

  ntot = DMAX1(n(1)+n(2),1e-16+n(2),n(1)+1e-16)

  do i = 1,2

    dfx(i) = 0.0_dp
    dfxdg(i) = 0.0_dp
    dfc(i) = 0.0_dp 
    dfcdg(i) = 0.0_dp 
    vx(i) = 0.0_dp
    vc(i) = 0.0_dp

!   ** Avoid floating point exceptions
    if(s(i) .ge. 1.0d12) then
      X(i) = 0.0_dp
      Hc(i) = g
    elseif(s(i) .le. 1.0d-30) then
      X(i) = 1.0_dp
      Hc(i) = 1.0_dp
    else
      X(i) = 1.0_dp/(1.0_dp + a*s(i)**2)
      Hc(i) = X(i) + g*(1.0_dp - X(i))
    endif
  enddo

! *******************
!   LDA correlation
! *******************
  call am05_xscss_ldapwc(n,eclda,vclda)

! ** Loop over spin up and down
  do 20 i = 1,2

! *************
!    Cutoffs
! *************
    if (n(i) .le. 1.0d-16) then
!
!     ** specifically handle a small density in the LDA limit (s=0) n->0
!     ** A small s in AM05 is always indication that we are in the
!     ** interior LDA limit, regardless of what density we have
      if (s(i) .le. 1.0d-30) then
! The following line is the original code
!       fc = fc + n(i)*eclda
! The following line is in the form needed for SIESTA
        fc = fc + n(i)*eclda/ntot
        vc(i) = vclda(i)*Hc(3-i) + eclda*(1-Hc(3-i))
        dfc(i) = vclda(i)*Hc(3-i) + eclda*(1-Hc(3-i))
        goto 20
      endif

!     ** otherwise, go on as usual but with a lowest cutoff density
      n(i) = 1.0d-16
    endif

!   ** Scaling density and gradient
!   ** Ex = 0.5 * (Ex[2*spin up n] + Ex[2*spin down n] ) 
    nn = 2.0_dp*n(i)
    s2 = s(i)**2
    kF = (3.0_dp*pi**2*2.0_dp*n(i))**(1.0_dp/3.0_dp)
     
!   *******************
!     LDA exchange
!   *******************
    call am05_xscss_ldax(nn,exlda,vxlda)

!   *****************************
!     Exchange energy density
!   *****************************

!   ** Airy LAA refinement function
    call am05_xscss_lambertw(s(i)**(3.0_dp/2.0_dp)/sqrt(24.0_dp),w)

!   ** am05_lambertw give back argument if it is < 1.0e-20
!   ** (1.0e-14)^{3/2} = 1.0e-21 => give  low s limit for z/s
!   ** zosn = normalized z/s
    if (s(i) < 1.0e-14) then
      zosn = 1.0_dp
    else
      zosn = 24.0_dp**(1.0_dp/3.0_dp)*w**(2.0_dp/3.0_dp)/s(i)
    end if
    zfac = s2*(zosn*27.0_dp/32.0_dp/pi**2)**2

!   ** denom = denominator of Airy LAA refinement function
    denom = 1.0_dp + c*s2*zosn*(1.0_dp + zfac)**(1.0_dp/4.0_dp)
    F = (c*s2 + 1.0_dp)/denom
      
!   ** Exchange refinement function
    Hx = X(i) + (1.0_dp - X(i))*F

!   ** Exchange energy density, Ex = Integrate[fx]
    fx = fx + 0.5_dp*nn*exlda*Hx

!   ********************
!      Correlation
!   ********************

!   ** Correlation energy density, Ec = Integrate[fc]
! The following line is the original code
!   fc = fc + 0.5_dp*nn*eclda*Hc(i)
! The following line is in the form needed for SIESTA
   fc = fc + 0.5_dp*nn*eclda*Hc(i)/ntot

!   ** goto next spin if we are only calculating energies
    if (pot .eq. 0) goto 20

!   ***************************
!     Exchange derivatives for White and Bird and 
!     Pople, Gill, and Johnson schemes
!   ***************************

!   ** Interpolation index derivatives: 1/s dX/ds
    Xsos = -2.0_dp*a*X(i)**2

!   ** Airy LAA refinement function derivatives, 1/s dF/ds 
!   ** szsoz = s*(dz/ds)/z
    szsoz = 1.0_dp/(1.0_dp + w)
         
    Fsos = c/denom**2*(2.0_dp - zosn* &
              ((1.0_dp - c*s2)*(1.0_dp + zfac)**(1.0_dp/4.0_dp) + &
              (1.0_dp + c*s2)*(1.0_dp + 3.0_dp/2.0_dp*zfac)/ &
              (1.0_dp + zfac)**(3.0_dp/4.0_dp)*szsoz))

!   ** Refinement function derivatives, 1/s dHx/ds
!   ** We use that (1 - X) = a*X*s2
    Hxsos = (1.0_dp - X(i))*Fsos - (F - 1.0_dp)*Xsos

    dfx(i) = vxlda*Hx - 4.0_dp/3.0_dp*exlda*s2*Hxsos
    dfxdg(i) = exlda*Hxsos/((2.0_dp*kF)**2*n(i))

!   *****************************
!     Correlation derivatives for White and Bird and 
!     Pople, Gill, and Johnson schemes
!   *****************************

!   ** Correlation refinement function derivatives, 1/s dF/ds 
    Hcsos = Xsos*(1.0_dp - g)

!   ** Note: n(3-i) gives the density of the *other* spin, etc.
    dfc(i) = vclda(i)/ntot*(n(1)*Hc(1)+n(2)*Hc(2)) + &
              eclda*n(3-i)/ntot*(Hc(i) - Hc(3-i)) -  &
              4.0_dp/3.0_dp*eclda*s2*Hcsos

    dfcdg(i) = eclda*Hcsos/((2.0_dp*kF)**2*n(i))

!   ** goto next spin if only doing W&B/Pople et. al.
    if (pot .eq. 1) goto 20

!   ***************************
!     Exchange potential in traditional scheme
!   ***************************
!
!   ** Interpolation index derivatives: 1/s d/ds(1/s dX/ds)                   
    Xsossos = 8.0_dp*a**2*X(i)**3

!   ** Airy LAA refinement function derivatives s^2 1/s d/ds (1/s dF/ds) 
!   **  mixder = szsoz + s^2*(d^2z/ds^2)/z
    mixder = (2.0_dp - w)/(2.0_dp*(1.0_dp + w)**3)

!   ** denomsos = 1/s d(denom)/ds,  sdenomsoss = s*d/ds(1/s d(denom)/ds))
    denomsos = c*zosn/(1.0_dp + zfac)**(3.0_dp/4.0_dp)* &
              (1.0_dp + zfac + (1.0_dp + 3.0_dp/2.0_dp*zfac)*szsoz)

    sdenomsoss = c*zosn/(1.0_dp + zfac)**(7.0_dp/4.0_dp)* &
              (-1.0_dp - zfac*(2.0_dp + zfac) &
              + (1.0_dp + zfac/2.0_dp*(5.0_dp + 3.0_dp*zfac))*mixder &
              + 3.0_dp/2.0_dp*zfac*(1.0_dp + zfac/2.0_dp)*szsoz**2)

    s2Fsossos = (-4.0_dp*c*s2*denom*denomsos + (c*s2 + 1.0_dp)* &
              (2.0_dp*s2*denomsos**2 - denom*sdenomsoss))/denom**3

!   ** Refinement function derivatives 1/s d/ds (1/s dHx/ds) 
!   ** We use that (1 - X) = a*X*s2
    Hxsossos = - 2.0_dp*Fsos*Xsos + a*X(i)*s2Fsossos - (F - 1.0_dp)*Xsossos

!   ** vx formula for gradient dependent functional,
    vx(i) = vxlda*(Hx - s2*Hxsos) + &
              exlda*((4.0_dp/3.0_dp*s2-t(i))*Hxsos +  &
              (4.0_dp/3.0_dp*s(i)**3-u(i))*s(i)*Hxsossos)

!   *****************************
!     Correlation potential in traditional scheme
!   *****************************
         
!   ** Correlation refinement function derivatives, 1/s d/ds (1/s dHc/ds)
    Hcsossos = Xsossos*(1.0_dp - g)

!   ** vc formula for gradient dependent functional,
    vc(i) = vclda(i)*(Hc(i) - s2*Hcsos) + &
              eclda*((4.0_dp/3.0_dp*s2 - t(i))*Hcsos +  &
              (4.0_dp/3.0_dp*s(i)**3-u(i))*s(i)*Hcsossos) + &
           (eclda-vclda(i))*n(3-i)/ntot* &
              (Hc(i)-Hc(3-i)-s(i)**2*Hcsos)+ &
           (eclda-vclda(3-i))* &
              0.5_dp* &
             (stot**2*ntot**(8.0_dp/3.0_dp)*0.5_dp**(2.0_dp/3.0_dp) -  &
                s(1)**2*n(1)**(8.0_dp/3.0_dp) -  &
                s(2)**2*n(2)**(8.0_dp/3.0_dp))/ &
             (n(i)**(5.0_dp/3.0_dp))/ntot*Hcsos

 20 continue

  dfxup = dfx(1)
  dfxdgup = dfxdg(1)
  dfcup = dfc(1)
  dfcdgup = dfcdg(1)
  dfxdn = dfx(2)
  dfxdgdn = dfxdg(2)
  dfcdn = dfc(2)
  dfcdgdn = dfcdg(2)

  vxup = vx(1) 
  vxdn = vx(2)
  vcup = vc(1) 
  vcdn = vc(2)

  return
  end subroutine am05_xscss

! ******************************************
!   Local density approximation exchange
!
!   input
!   n        electron density [bohr**(-3)]
!
!   output
!   ex       exchange energy per electron [hartree]
!   vx       exchange potential [hartree]
!
!   Copyright (c) 2005, Rickard Armiento
! ******************************************

  subroutine am05_xscss_ldax(n,ex,vx)
! ** Input parameters
  real(dp) n

! ** Output parameters
  real(dp) ex, vx

! ** Constants
  real(dp) pi
  parameter (pi = 3.141592653589793238462643383279502884197_dp)

  vx = -(3.0_dp*n/pi)**(1.0_dp/3.0_dp)
  ex = (3.0_dp/4.0_dp*vx)

  return
  end subroutine am05_xscss_ldax

! ***********************************************
! Local density approximation correlation
!
! input
! n(2)     electron upspin/downspin density [bohr**(-3)]
!
! output
! ec       correlation energy per electron [hartree]
! vc(2)    correlation upspin/downspin potential [hartree]
!
! As parameterized by Perdew Wang,
!   Phys. Rev. B 45, 13244 (1992) 
! Based on Monte Carlo data by Ceperley Alder, 
!   Phys. Rev. Lett. 45, 566 (1980)
!
! (Clean room implementation from paper)
!
! Copyright (c) 2005, Rickard Armiento
! ***********************************************
  subroutine am05_xscss_ldapwc(n,ec,vc)

! ** Input parameters
  real(dp) n(2)

! ** Output parameters
  real(dp) ec, vc(2)

! ** Constants
  real(dp) pi
  real(dp) A0,a01,b01,b02,b03,b04
  real(dp) A1,a11,b11,b12,b13,b14
  real(dp) Aa,aa1,ba1,ba2,ba3,ba4
  parameter (pi = 3.141592653589793238462643383279502884197_dp)
  parameter (a01 = 0.21370_dp)
  parameter (b01 = 7.5957_dp)
  parameter (b02 = 3.5876_dp)
  parameter (b03 = 1.6382_dp)
  parameter (b04 = 0.49294_dp)
  parameter (a11 = 0.20548_dp)
  parameter (b11 = 14.1189_dp)
  parameter (b12 = 6.1977_dp)
  parameter (b13 = 3.3662_dp)
  parameter (b14 = 0.62517_dp)
  parameter (aa1 = 0.11125_dp)
  parameter (ba1 = 10.357_dp)
  parameter (ba2 = 3.6231_dp)
  parameter (ba3 = 0.88026_dp)
  parameter (ba4 = 0.49671_dp)
! ** Paper actually use this:
! parameter (A0 = 0.031091_dp)
! parameter (A1 = 0.015545_dp)
! parameter (Aa = 0.016887_dp)
! ** But routines now "defacto standard" was distributed using:
  parameter (A0 = 0.0310907_dp)
  parameter (A1 = 0.01554535_dp)
  parameter (Aa = 0.0168869_dp)

! ** Local variables
  real(dp) xi, rsq, f, fp, fb0, mac, ec0, ec1, ecrs, ecxi
  real(dp) Q0, Q1, Q1p, ec0rs, ec1rs, acrs, fdenom

! ** Actual values from paper
! fdenom = (2.0_dp**(4.0_dp/3.0_dp)-2.0_dp)
! fb0 = 4.0_dp/(9.0_dp*(2.0_dp**(1.0_dp/3.0_dp)-1.0_dp))
! ** Replaced with "defacto standard" approximations
  fdenom = 0.5198421_dp
  fb0 = 1.709921_dp

! ** Cutoff
  if((n(1)+n(2)) .le. 1e-30) then
    ec = 0.0_dp
    vc(1) = 0.0_dp
    vc(2) = 0.0_dp
    return
  endif

  xi = (n(1)-n(2))/(n(1)+n(2))
  rsq = (3.0_dp/(4.0_dp*pi*(n(1)+n(2))))**(1.0_dp/6.0_dp)
  f = ((1.0_dp+xi)**(4.0_dp/3.0_dp)+(1.0_dp-xi)**(4.0_dp/3.0_dp)-2.0_dp)/fdenom

  mac = -2.0_dp*Aa*(1.0_dp + aa1*rsq**2)*log(1.0_dp + 1.0_dp/ &
           (2.0_dp*Aa*rsq*(ba1 + rsq*(ba2 + rsq*(ba3 + ba4*rsq)))))

  ec0 = -2.0_dp*A0*(1.0_dp + a01*rsq**2)*log(1.0_dp + 1.0_dp/ &
           (2.0_dp*A0*rsq*(b01 + rsq*(b02 + rsq*(b03 + b04*rsq)))))

  ec1 = -2.0_dp*A1*(1.0_dp + a11*rsq**2)*log(1.0_dp + 1.0_dp/ &
           (2.0_dp*A1*rsq*(b11 + rsq*(b12 + rsq*(b13 + b14*rsq)))))

  ec = ec0 - mac*f/fb0*(1.0_dp-xi**4) + (ec1-ec0)*f*xi**4

  Q0 = -2.0_dp*A0*(1.0_dp + a01*rsq**2)
  Q1 = 2.0_dp*A0*rsq*(b01 + rsq*(b02 + rsq*(b03 + b04*rsq)))
  Q1p = A0*(b01/rsq+2.0_dp*b02+3.0_dp*b03*rsq+4.0_dp*b04*rsq**2)
  ec0rs = -2.0_dp*A0*a01*log(1.0_dp + 1.0_dp/Q1)-Q0*Q1p/(Q1**2+Q1)

  Q0 = -2.0_dp*A1*(1.0_dp + a11*rsq**2)
  Q1 = 2.0_dp*A1*rsq*(b11 + rsq*(b12 + rsq*(b13 + b14*rsq)))
  Q1p = A1*(b11/rsq+2.0_dp*b12+3.0_dp*b13*rsq+4.0_dp*b14*rsq**2)
  ec1rs = -2.0_dp*A1*a11*log(1.0_dp + 1.0_dp/Q1)-Q0*Q1p/(Q1**2+Q1)

  Q0 = -2.0_dp*Aa*(1.0_dp + aa1*rsq**2)
  Q1 = 2.0_dp*Aa*rsq*(ba1 + rsq*(ba2 + rsq*(ba3 + ba4*rsq)))
  Q1p = Aa*(ba1/rsq+2.0_dp*ba2+3.0_dp*ba3*rsq+4.0_dp*ba4*rsq**2)
  acrs = -2.0_dp*Aa*aa1*log(1.0_dp + 1.0_dp/Q1)-Q0*Q1p/(Q1**2+Q1)

  ecrs = ec0rs*(1.0_dp - f*xi**4) + ec1rs*f*xi**4 - acrs*f/fb0*(1.0_dp - xi**4)
  fp = 4.0_dp/3.0_dp*((1.0_dp+xi)**(1.0_dp/3.0_dp) - (1.0_dp-xi)**(1.0_dp/3.0_dp))/fdenom
  ecxi = 4.0_dp*xi**3*f*(ec1-ec0+mac/fb0)+fp*(xi**4*ec1-xi**4*ec0+ (1.0_dp-xi**4)*(-mac)/fb0)

  vc(1)=ec - rsq**2/3.0_dp*ecrs - (xi-1.0_dp)*ecxi
  vc(2)=ec - rsq**2/3.0_dp*ecrs - (xi+1.0_dp)*ecxi
  
  end subroutine am05_xscss_ldapwc


! ***********************************************
! LambertW function. 
!
! Corless, Gonnet, Hare, Jeffrey, and Knuth (1996), 
!   Adv. in Comp. Math. 5(4):329-359. 
! Implementation approach loosely inspired by the 
! GNU Octave version by N. N. Schraudolph, but this 
! implementation is only for real values and 
! principal branch.
!
! Copyright (c) 2005, Rickard Armiento
! ***********************************************

  subroutine am05_xscss_lambertw(z,result)
! input
  real(dp) z
! output
  real(dp) result
! local variables
  real(dp) e,t,p    
  integer i

! ** If z too low, go with the first term of the power expansion, z
  if( z .lt. 1.0d-20) then
    result = z
    return
  endif

  e = exp(1.0_dp)

! ** Inital guess
  if( abs(z + 1.0_dp/e) .gt. 1.45_dp ) then
!   ** Asymptotic expansion at 0 and Inf
    result = log(z)
    result = result - log(result)
  else
!   ** Series expansion about -1/e to first order
    result = 1.0_dp*sqrt(2.0_dp*e*z + 2.0_dp) - 1.0_dp
  endif

! ** Find result through iteration
  do i = 1,10
    p = exp(result)
    t = result*p - z
    if ( result .ne. -1.0_dp ) then
      t = t/(p*(result + 1.0_dp) - 0.5_dp*(result + 2.0_dp)*t/(result + 1.0_dp))
    else
      t = 0.0_dp
    endif
    result = result - t
    if (abs(t) < (2.48_dp*1.0d-14)*(1.0_dp + abs(result))) then
      return
    endif
  enddo

! ** This should never happen!;
  call die('am05_xscss_lambertw: iteration limit reached.')

  return
  end subroutine am05_xscss_lambertw

end module gridxc_am05

#if defined HAVE_CONFIG_H
#include "config.h"
#endif

program test_ldaxc

  use fruit
  use ldaxc_basket

  implicit none

  call init_fruit()
  call init_fruit_xml()

  call fruit_basket()

  call fruit_summary()
  call fruit_summary_xml()
  call fruit_finalize()

end program test_ldaxc

#if defined HAVE_CONFIG_H
#include "config.h"
#endif

!!@LICENSE
!
!******************************************************************************
! MODULE m_vdwxc
! Implements the nonlocal correlation energy part of the van der Waals density
! functional of M.Dion et al, PRL 92, 246401 (2004):
!   Enlc = (1/2) Int Int dr1 dr2 rho(r1) phi(q1*r12,q2*r12) rho(r2)
! with r12=|r2-r1|, q1=q0(rho(r1),grad_rho(r1)), q2=q0(rho(r2),grad_rho(r2)),
! where rho(r) is the electron density at point r, grad_rho(r) its gradient,
! and q0(rho,grad_rho) and phi(d1,d2) are universal functions defined in 
! Eqs.(11-12) and (14-16) of Dion et al.
! Using separate module m_vv_vdwxc, it implements also the similar functional
! of Vydrov and Van Voorhis. See that module for more information.
! Refs: M.Dion et al, PRL 92, 246401 (2004)
!       J.Klimes et al, JPCM 22, 022201 (2009)
!       V.R.Cooper, PRB 81, 161104(R) (2010)
!       K.Lee et al, PRB 82, 081101 (2010)
!       O.A.Vydrov and T.VanVoorhis, JCP 133, 244103 (2010)
!       G.Roman-Perez and J.M.Soler, PRL 103, 096102 (2009)
! Written by J.M.Soler. July 2007 - April 2010 and July 2012.
!------------------------------------------------------------------------------
! Used module procedures:
!  use gridxc_sys,         only: die               ! termination routine
!  use gridxc_mesh1D,      only: derivative        ! Derivative of a function in a mesh
!  use gridxc_gga      only: ggaxc             ! General GGA XC routine
!  use gridxc_lda,     only: ldaxc             ! General LDA XC routine
!  use gridxc_mesh1D,      only: integral          ! Integral of a function in a mesh
!  use gridxc_mesh1D,      only: get_mesh          ! Returns the mesh points
!  use gridxc_mesh1D,      only: get_n             ! Returns the number of mesh points
!  use gridxc_radfft,    only: radfft            ! Radial fast Fourier transform
!  use gridxc_mesh1D,      only: set_interpolation ! Sets interpolation method
!  use gridxc_mesh1D,      only: set_mesh          ! Sets a 1D mesh
!  use interpolation, only: spline            ! Sets spline interpolation
!  use interpolation, only: splint            ! Calculates spline interpolation
!  use gridxc_vv_vdwxc,  only: vv_vdw_beta       ! Parameter beta of VV2010 functionl
!  use gridxc_vv_vdwxc,  only: vv_vdw_theta      ! Func. theta of VV2010 functional
!  use gridxc_vv_vdwxc,  only: vv_vdw_get_kmesh  ! Size and values of (kf,kg) mesh
!  use gridxc_vv_vdwxc,  only: vv_vdw_phi        ! Interpolate rho1*rho2*phi(k1,k2,k)
!  use gridxc_vv_vdwxc,  only: vv_vdw_set_kcut   ! Sets the planewave cutoff kc
!------------------------------------------------------------------------------
! Used module parameters:
!   use gridxc_precision,  only: dp                ! Real double precision type
!------------------------------------------------------------------------------
! Public procedures available from this module:
!   vdw_decusp    : Energy due to the softening of the VdW kernel cusp
!   vdw_get_qmesh : Returns size and values of q-mesh
!   vdw_localxc   : LDA/GGA xc part apropriate for the used vdW flavour
!   vdw_phi       : Finds and interpolates phi(q1,q2,k)
!   vdw_set_author: Sets the vdW functional flavour (author initials)
!   vdw_set_kcut  : Sets the planewave cutoff kc of the integration grid
!   vdw_theta     : Finds function theta_q(rho,grad_rho)
!------------------------------------------------------------------------------
! Public types, parameters, variables, and arrays:
!   None
!------------------------------------------------------------------------------
! Units: 
!   All lengths and energies in atomic units (Bohr, Hartree)
!******************************************************************************
! subroutine vdw_decusp( nspin, rhos, grhos, eps, dedrho, dedgrho )
!   Finds the local energy correction due to the softening of the VdW kernel
!   cusp, defined as eps(rho,grad_rho) =
!   (1/2) * rho * Int 4*pi*r**2*dr * (phi(q1*r,q2*r) - phi_soft(q1*r,q2*r))
!   where q1=q2=q0(rho,grad_rho). Notice that grad_rho is included in the value 
!   of q0 at the origin but not in the change of rho(r) in the integrand.
!   phi_soft(d1,d2) is a softened version of the nonlocal VdW kernel phi(d1,d2)
!   (Eq.(14) of Dion et al) in which the logarithmic divergence at d1=d2=0 is
!   substituted by a smooth analytic function of the form defined in vdw_phi
! Arguments:
!   integer, intent(in) :: nspin            ! Number of spin components
!   real(dp),intent(in) :: rhos(nspin)      ! Electron spin density
!   real(dp),intent(in) :: grhos(3,nspin)   ! Spin density gradient
!   real(dp),intent(out):: eps              ! Energy correction per electron
!   real(dp),intent(out):: dedrho(nspin)    ! d(rho*eps)/d(rho)
!   real(dp),intent(out):: dedgrho(3,nspin) ! d(rho*eps)/d(grad_rho)
! Notes:
! - Requires a previous call to vdw_set_kcut. Otherwise stops with an error msg.
!------------------------------------------------------------------------------
! subroutine vdw_exchng( iRel, nSpin, D, GD, epsX, dEXdD, dEXdGD )
!   Finds the exchange energy density and its derivatives, using the GGA
!   functional apropriate for the previously-set vdW functional flavour
! Arguments:
!   integer, intent(in) :: iRel            ! Relativistic exchange? 0=no, 1=yes
!   integer, intent(in) :: nSpin           ! Number of spin components
!   real(dp),intent(in) :: D(nSpin)        ! Local electron (spin) density
!   real(dp),intent(in) :: GD(3,nSpin)     ! Gradient of electron density
!   real(dp),intent(out):: epsX            ! Exchange energy per electron
!   real(dp),intent(out):: dEXdD(nSpin)    ! dEx/dDens, Ex=Int(dens*epsX)
!   real(dp),intent(out):: dEXdGD(3,nSpin) ! dEx/dGrad(Dens)
! Sample usage:
!   integer,parameter:: iRel=0, nSpin=2
!   real(dp):: D(nSpin), dEXdD(nSpin), dEXdGD(3,nSpin), epsX, GD(3,nSpin)
!   call vdw_set_author('DRSLL')
!   do r points
!     Find D and GD at r
!     call vdw_exchng( iRel, nSpin, D, GD, epsX, dEXdD, dEXdGD )
!     Ex = Ex + dVolume*sum(D)*epsX
!   end do
!------------------------------------------------------------------------------
! subroutine vdw_get_qmesh( n, q )
!   Returns size and values of q-mesh
! Arguments:
!   integer,          intent(out) :: n      ! Number of q mesh points
!   real(dp),optional,intent(out) :: q(:)   ! Values of q mesh points
! Sample usage:
!   integer :: nq
!   real(dp):: kcut
!   real(dp),allocatable:: qmesh(:)
!   kcut = 10._dp ! 10 Bohr^-1 => 100 Ry (this should be adapted to your mesh)
!   call vdw_set_kcut( kcut )
!   call vdw_get_qmesh( nq )
!   allocate( qmesh(nq) )
!   call vdw_get_qmesh( nq, qmesh )
! Notes:
! - Requires a previous call to vdw_set_kcut. Otherwise stops with an error msg.
! - If the size of array q is smaller than that of the stored qmesh, it is 
!   filled with the first size(q) values of qmesh
! - The size and values of the logarithmic q mesh are set by internal
!   parameters that can be changed only by editing them in this module:
!     nq             : Number of q mesh points
!     qcut=qmesh(nq) : Max. value of q mesh
!     dqmaxdqmin     : (qmesh(nq) - qmesh(nq-1)) / (qmesh(2) - qmesh(1))
!   Although the presently-set values have been found to yield good accuracy
!   in preliminary calculations, more tests may be required to guarantee
!   convergence in other systems. The value of nq is particularly important:
!   larger nq increases accuracy but CPU time increases between nq and nq**2.
!------------------------------------------------------------------------------
! subroutine vdw_phi( k, phi, dphidk )
!   Finds phi_soft(q1,q2,k) (Fourier transform of phi_soft(q1,q2,r)) for all 
!   values of q1 and q2 in qmesh. The q's are local wavevectors defined in 
!   eqs.(11-12), and phi_soft is a smoothed version of Eq.(14) of Dion et al,
!   defined as phi_soft(d1,d2) = phi_soft(d,a) = phi0 + phi2*d**2 + phi4*d**4, 
!   where phi0 is a parameter, d=sqrt(d1**2+d2**2), a=atan(d2/d1), and phi2, 
!   phi4 are chosen so that phi_soft(d,a) matches phi(d,a) in value and slope
!   at d=dsoft (another parameter).
! Arguments:
!   real(dp),intent(in) :: k            ! Modulus of actual k vector
!   real(dp),intent(out):: phi(:,:)     ! phi(q1,q2,k) at given k
!                                       ! for all q1,q2 in qmesh
!   real(dp),intent(out):: dphidk(:,:)  ! dphi(q1,q2,k)/dk at given k
! Sample usage:
!   integer :: nq
!   real(dp):: k, kcut
!   real(dp),allocatable:: phi(:,:), dphidk(:,:)
!   kcut = 10._dp ! 10 Bohr^-1 => 100 Ry (this should be adapted to your mesh)
!   call vdw_set_kcut( kcut )
!   call vdw_get_qmesh( nq )
!   allocate( phi(nq,nq), dphidk(nq,nq) )
!   do k points
!     call vdw_phi( k, phi, dphidk )
! Notes:
! - Requires a previous call to vdw_set_kcut. Otherwise stops with an error msg.
! - Stops with an error message if size of array phi is smaller than nq*nq.
!-----------------------------------------------------------------------------
! subroutine vdw_set_author( author )
!   Sets the functional flavour (author initials) and subsequent parameters
! Arguments:
!   character(len=*),intent(in):: author ! Functnl flavour 
!                                     ('DRSLL'|'LMKLL'|'KBM'|'C09'|'BH'|'VV')
! Notes:
! - If vdw_set_author is not called, author='DRSLL' is set by default
! - Stops with an error message if author has not an allowed value
!-----------------------------------------------------------------------------
! subroutine vdw_set_kcut( kc )
!   Sets the reciprocal planewave cutoff kc of the integration grid, and finds 
!   the interpolation table to be used by vdw_phi to obtain the vdW kernel phi
!   at the reciprocal mesh wavevectors.
! Arguments:
!   real(dp),intent(in):: kc  ! Planewave cutoff: k>kcut => phi=0
! Notes:
! - An interpolation table to calculate the VdW kernel phi is read from file 
!   'vdw_kernel.table'. If the file does not exist, the table is calculated
!   and the file written when vdw_set_kcut is called.
!------------------------------------------------------------------------------
! subroutine vdw_theta( nspin, rhos, grhos, theta, dtdrho, dtdgrho )
!   Finds the value and derivatives of theta_i(rho,grad_rho) = rho*p_i(q0), 
!   where q0(rho,grad_rho) is the local wavevector defined in eqs.(11-12) 
!   of Dion et al, PRL 92, 246401 (2004). 
!   p_i(q0) are the cubic polynomials such that
!     y(q0) = Sum_i p_i(q0) * y_i
!   is the cubic spline interpolation at q0 of (any) function y(q) with
!   values y_i at mesh points qmesh_i
! Arguments:
!   integer, intent(in) :: nspin               ! Number of spin components
!   real(dp),intent(in) :: rhos(nspin)         ! Electron spin density
!   real(dp),intent(in) :: grhos(3,nspin)      ! Spin density gradient
!   real(dp),intent(out):: theta(nq)           ! Expansion of rho*q in qmesh
!   real(dp),intent(out):: dtdrho(nq,nspin)    ! dtheta(iq)/drhos
!   real(dp),intent(out):: dtdgrho(3,nq,nspin) ! dtheta(iq)/dgrhos(ix)
! Notes:
! - Requires a previous call to vdw_set_kcut
! - The value of q0(rho,grad_rho) is saturated at qmesh(nq)=qcut (a parameter)
!   to avoid incorrect 'interpolation' of phi(q1,q2,r12) from qmesh points.
!******************************************************************************
! Algorithms:
!   Although Eqs.(14-16) of Dion et al provide a straightforward definition of
! the nonlocal VdW kernel phi(d1,d2), its direct evaluation with the required 
! accuracy turns out to be too time consuming. In addition, the kernel has a 
! logarithmic divergence at d1=d2=0, which prevents its direct numerical 
! Fourier transform. Therefore, an elaborate layered procedure is followed:
!   A smoothed version of phi(d1,d2) is defined as 
!     phi_soft(d1,d2) = phi_soft(d,a) = phi0 + phi2*d**2 + phi4*d**4, 
! where phi0 is a parameter, d=sqrt(d1**2+d2**2), a=atan(d2/d1), and phi2, 
! phi4 are chosen so that phi_soft(d,a) matches phi(d,a) in value and slope
! at d=dsoft (another parameter).
!   The difference in energy between phi_soft and the right phi (called DEcusp) 
! is approximated in a local-density approximation as eps(rho,grad_rho) =
!   (1/2) * rho * Int 4*pi*r**2*dr * (phi(q1*r,q2*r) - phi_soft(q1*r,q2*r))
! where q1=q2=q0(rho,grad_rho). Notice that grad_rho is included in the value 
! of q0 at the origin but not in the change of rho(r) in the integrand. This
! could be improved in the future, although preliminary tests suggest that
! the corrections would be quite small.
!   A one-dimensional table of phi(d,d) is first calculated and stored as a
! function of d. Then, phi(d1,d2) is calculated as phi(dmax,dmax)+dphi(d1,d2),
! with dmax=max(d1,d2). The reason is that dphi converges better for large d,
! and therefore it requires smaller integration limits in Eq.(14) of Dion et al,
! while phi(dmax,dmax) is interpolated from the stored table.
!   Using the above methods, a two-dimensional table of phi_soft(d1,d2) is
! calculated and stored for all values of d1 and d2 in a logarithmic dmesh
! of size nd with a cutoff dcut (two internal parameters). This table is 
! written on disk file 'vdw_kernel.table' for reuse in subsequent runs.  
! If the file exists already, the table is simply read and stored in memory.
!   Once we set the cutoff kcut (expressed as a wavevector), of the integration 
! mesh to be used in evaluating the VdW nonlocal energy Enlc, we calculate and
! store (in memory) another interpolation table of phi_soft(q1,q2,k) for all
! values of q1 and q2 in qmesh, and of k in a fine radial grid of nk=nr points.
! This is done by first calculating phi_soft(q1,q2,r)=phi_soft(q1*r,q2*r) in a
! radial grid in real space and then Fourier-transforming it to k space.
! This table is then used to interpolate phi_soft(q1,q2,k) for any desired k.
!   In order to ensure that values of q are within the interpolation range,
! they are 'saturated' smoothly to a cutoff qcut=qmesh(nq). This implies an 
! approximation when either rho is very large (i.e. near the nucleus) or when 
! (grad_rho/rho)**2/kF -> infinity, what tipically occurs in the tails of
! the electron density. In the first case, Enlc is neglegible compared with
! Ex and the local part of Ec. In the second case, it is neglegible because of
! the factor rho in the integrand. Thus, the preliminary tests suggest that the
! presently-set value of qcut gives sufficiently accurate values.
!******************************************************************************

MODULE gridxc_vdwxc

! Used module procedures
  use gridxc_sys,         only: die               ! termination routine
  use gridxc_mesh1D,      only: derivative        ! Derivative of a function in a mesh
  use gridxc_mesh1D,      only: integral          ! Integral of a function in a mesh
  use gridxc_mesh1D,      only: get_mesh          ! Returns the mesh points
  use gridxc_mesh1D,      only: get_n             ! Returns the number of mesh points
  use gridxc_gga,         only: ggaxc             ! General GGA XC routine
  use gridxc_lda    ,     only: ldaxc             ! General LDA XC routine
  use gridxc_radfft,    only: radfft            ! Radial fast Fourier transform
  use gridxc_alloc,       only: re_alloc          ! Re-allocation routine
  use gridxc_mesh1D,      only: set_interpolation ! Sets interpolation method
  use gridxc_mesh1D,      only: set_mesh          ! Sets a 1D mesh
  use gridxc_interpolation,only: spline           ! Sets spline interpolation
  use gridxc_interpolation,only: splint           ! Calculates spline interpolation
  use gridxc_vv_vdwxc,  only: vv_vdw_beta       ! Parameter beta of VV2010 functional
  use gridxc_vv_vdwxc,  only: vv_vdw_theta      ! Func. theta of VV2010 functional
  use gridxc_vv_vdwxc,  only: vv_vdw_get_kmesh  ! Size and values of (kf,kg) mesh
  use gridxc_vv_vdwxc,  only: vv_vdw_phi        ! Interpolates rho1*rho2*phi(k1,k2,k)
  use gridxc_vv_vdwxc,  only: vv_vdw_set_kcut   ! Sets the planewave cutoff kc

! Used module parameters
  use gridxc_precision,   only: dp                ! Real double precision type

#ifdef DEBUG_XC
  use gridxc_vv_vdwxc,  only: vv_vdw_phiofr     ! Interpolates rho1*rho2*phi(k1,k2,r)
  use gridxc_debugXC,     only: udebug     ! File unit for debug output
!  use plot_module, only: plot
#endif /* DEBUG_XC */

  implicit none

! Called by xc routines
PUBLIC ::         &
  vdw_decusp,     &! Energy due to the softening of the VdW kernel cusp
  vdw_get_qmesh,  &! Returns size and values of q-mesh
  vdw_localxc,    &! LDA/GGA exchange-corr apropriate for the used vdW flavour
  vdw_phi,        &! Finds and interpolates phi(q1,q2,k)
  vdw_set_author, &! Sets the vdW functional flavour (author initials)
  vdw_set_kcut,   &! Sets the planewave cutoff kc of the integration grid
  vdw_theta        ! Finds function theta_q(rho,grad_rho)

#ifdef DEBUG_XC
! Called by debugging test programs
PUBLIC ::     &
  phiofr,     &! Finds the kernel phi(q1,q2,r) at tabulated q-mesh values
  phi_interp, &! Finds soft phi(d1,d2) kernel by interpolation of phi_table
  phi_soft,   &! Finds phi(d1,d2) softened near d1=d2=0
  phi_val,    &! Finds kernel phi(d1,d2) by direct integration
  pofq,       &! Finds polynomials p(q) from cubic spline interpolation
  qofrho       ! Finds the local wavevector parameter q(rho,grad_rho)
#endif /* DEBUG_XC */

PRIVATE  ! Nothing is declared public beyond this point

!  integer, parameter:: dp = kind(1.d0)

  ! Precision parameters for the integral defining phi in routine phi_val
  real(dp),parameter:: acutmin = 10.0_dp   ! Upper integration limit
  real(dp),parameter:: acutbyd  = 30.0_dp  ! Upper integration limit / d
  real(dp),parameter:: damax = 0.5_dp      ! Max. integration interval
  real(dp),parameter:: damin = 1.e-2_dp    ! Min. integration interval
  real(dp),parameter:: dabyd = 0.1_dp      ! Min. integration interval / d

  ! Precision parameter for the integral in routine dphi
  real(dp),parameter:: ashortbyd = 2.5_dp  ! Shorter integration limit / d

  ! Parameters for phi_soft. Some recommended pairs of values are
  ! (dsoft,phi0_soft)=(0.5,0.8)|(0.7|0.6)|(1.0|0.4)|(1.5,0.22)|(2.0,0.12)
  real(dp),parameter:: dsoft = 1.0_dp       ! Softening matching radius
  real(dp),parameter:: phi0_soft = 0.40_dp  ! phi_soft(0,0) (depends on dsoft)
  real(dp),parameter:: dd = 0.01_dp         ! Delta(d) for derivatives

  ! Mesh parameters for table phi(d1,d2)
  integer, parameter:: nd = 20               ! Number of d mesh points
  real(dp),parameter:: dcut = 30.0_dp        ! Max. value of d mesh
  real(dp),parameter:: ddmaxddmin = 20.0_dp  ! Last d mesh interval / first one

  ! Use routine dphi for better efficiency in setting phi table?
  logical,parameter:: use_dphi =.true. !(.true.=>efficiency|.false.=>accuracy)

  ! Set derivation methods to use for interpolation table
  character(len=*),parameter:: deriv_method = 'numeric'  !('numeric'|'interp')
  character(len=*),parameter:: interp_method= 'Spline' !('Lagrange'|'Spline')

  ! Parameters to find numerical derivatives of phi, to set interpolation
  real(dp),parameter:: ddbyd = 0.01_dp       ! Delta to find phi derivs / d
  real(dp),parameter:: ddmin = 0.001_dp      ! Min. delta to find phi derivs

  ! Mesh parameters for table of phi(q1,q2,r) and its Fourier transform
  integer, parameter:: nr = 2048             ! Radial mesh points (power of 2)
  integer, parameter:: mq = 30               ! Total number of q mesh points
!  integer, parameter:: nq = mq-1             ! Effective number of q mesh points
  real(dp),parameter:: qcut = 5.0_dp         ! Max. value of q mesh
  real(dp),parameter:: dqmaxdqmin = 20.0_dp  ! Last q mesh interval / first one
  real(dp),parameter:: rcut = 100._dp        ! Radial cutoff: r>rcut => phi=0
  real(dp),parameter:: rmin = 1.e-6_dp       ! Min. radius as denominator
  real(dp),parameter:: rsoft = 0.0_dp        ! Soften kernel in r<rsoft

  ! Parameters for cutoff function, used in radial Fourier transforms of phi
  integer, parameter:: ncut1 =  8      ! cutoff(x)=(1-x**ncut1)**ncut2
  integer, parameter:: ncut2 =  4

  ! Parameters for saturate function, used to enforce that q<qcut
  integer, parameter:: nsat  = 12      ! xsat(x)=1-exp(-sum_n=1:nsat x**n/n)

  ! Parameters for saturate_inverse function
  real(dp),parameter:: xmaxbyxc = 1.5_dp   ! qmax/qcut
  real(dp),parameter:: ytol = 1.e-15_dp     ! Tol. for saturated q

  ! Private module variables and arrays
  character(len=5),save:: vdw_author='DRSLL' ! Functional 'flavour' name
  real(dp),save:: dmesh(nd)                ! Mesh points for phi(d1,d2) table
  real(dp),save:: qmesh(mq)                ! Mesh points for phi(q1,q2,r)
  real(dp),save:: phi_table(0:3,0:3,nd,nd) ! Coefs. for bicubic interpolation
  logical, save:: phi_table_set=.false.    ! Has phi_table been set?
  logical, save:: qmesh_set=.false.        ! Has qmesh been set?
  logical, save:: kcut_set=.false.         ! Has kcut been set?
  real(dp),save:: dr                       ! r-mesh interval
  real(dp),save:: dk                       ! k-mesh interval
  real(dp),save:: kcut                     ! Planewave cutoff: k>kcut => phi=0
  integer, save:: nk                       ! # k points within kcut
  real(dp),save:: zab=-0.8491_dp           ! Parameter of the vdW functional
  real(dp),pointer,save:: &
                  phir(:,:,:)=>null(),    &! Table of phi(r)
                  phik(:,:,:)=>null(),    &! Table of phi(k)
                  d2phidr2(:,:,:)=>null(),&! Table of d^2(phi)/dr^2
                  d2phidk2(:,:,:)=>null()  ! Table of d^2(phi)/dk^2

!  real(dp),save:: dqmaxdqmin, qcut

CONTAINS

! -----------------------------------------------------------------------------

SUBROUTINE bcucof( n1, n2, x1, x2, y, dydx1, dydx2, d2ydx1dx2, c )
! Finds coefficients for bicubic interpolation
! Adapted from Numerical recipes
  IMPLICIT NONE
  INTEGER, INTENT(IN) :: n1, n2
  REAL(dp),INTENT(IN) :: x1(n1)
  REAL(dp),INTENT(IN) :: x2(n2)
  REAL(dp),INTENT(IN) :: y(n1,n2)
  REAL(dp),INTENT(IN) :: dydx1(n1,n2)
  REAL(dp),INTENT(IN) :: dydx2(n1,n2)
  REAL(dp),INTENT(IN) :: d2ydx1dx2(n1,n2)
  REAL(dp),INTENT(OUT):: c(0:3,0:3,n1,n2)

  INTEGER  :: i1, i11, i12, i13, i14, i2, i21, i22, i23, i24
  REAL(dp) :: dx1, dx2, wt(16,16), z(16)
  DATA wt /1,0,-3,2,4*0,-3,0,9,-6,2,0,-6,4,&
    8*0,3,0,-9,6,-2,0,6,-4,10*0,9,-6,2*0,-6,4,2*0,3,-2,6*0,-9,6,&
    2*0,6,-4,4*0,1,0,-3,2,-2,0,6,-4,1,0,-3,2,8*0,-1,0,3,-2,1,0,-3,&
    2,10*0,-3,2,2*0,3,-2,6*0,3,-2,2*0,-6,4,2*0,3,-2,0,1,-2,1,5*0,&
    -3,6,-3,0,2,-4,2,9*0,3,-6,3,0,-2,4,-2,10*0,-3,3,2*0,2,-2,2*0,&
    -1,1,6*0,3,-3,2*0,-2,2,5*0,1,-2,1,0,-2,4,-2,0,1,-2,1,9*0,-1,2,&
    -1,0,1,-2,1,10*0,1,-1,2*0,-1,1,6*0,-1,1,2*0,2,-2,2*0,-1,1/

! Set coefs. for i1<n1 and i2<n2
  do i2 = 1,n2-1
    do i1 = 1,n1-1
      dx1 = x1(i1+1) - x1(i1)
      dx2 = x2(i2+1) - x2(i2)
      i11 = i1
      i12 = i1+1
      i13 = i1+1
      i14 = i1
      i21 = i2
      i22 = i2
      i23 = i2+1
      i24 = i2+1
      z( 1) = y(i11,i21)
      z( 2) = y(i12,i22)
      z( 3) = y(i13,i23)
      z( 4) = y(i14,i24)
      z( 5) = dydx1(i11,i21) * dx1
      z( 6) = dydx1(i12,i22) * dx1
      z( 7) = dydx1(i13,i23) * dx1
      z( 8) = dydx1(i14,i24) * dx1
      z( 9) = dydx2(i11,i21) * dx2
      z(10) = dydx2(i12,i22) * dx2
      z(11) = dydx2(i13,i23) * dx2
      z(12) = dydx2(i14,i24) * dx2
      z(13) = d2ydx1dx2(i11,i21) * dx1 * dx2
      z(14) = d2ydx1dx2(i12,i22) * dx1 * dx2
      z(15) = d2ydx1dx2(i13,i23) * dx1 * dx2
      z(16) = d2ydx1dx2(i14,i24) * dx1 * dx2
      z = matmul(wt,z)
      c(0:3,0:3,i1,i2) = reshape(z,(/4,4/),order=(/2,1/))
    end do ! i1
  end do ! i2

! Set c for i1=n1 and i2=n2 (valid only at the very border) using
! sum_i,j c(i,j,n1,i2) * 0**i * x2**j = sum_i,j c(i,j,n1-1,i2) * 1**i * x2**j
! sum_i,j c(i,j,i1,n2) * x1**i * 0**j = sum_i,j c(i,j,i1,n2-1) * x1**i * 1**j
! sum_i,j c(i,j,n1,n2) * 0**i * 0**j = sum_i,j c(i,j,n1-1,n2-1) * 1**i * 1**j
  c(:,:,n1,:) = 0
  c(:,:,:,n2) = 0
  c(0,:,n1,1:n2-1) = sum(c(:,:,n1-1,1:n2-1),dim=1)
  c(:,0,1:n1-1,n2) = sum(c(:,:,1:n1-1,n2-1),dim=2)
  c(0,0,n1,n2) = sum(c(:,:,n1-1,n2-1))

END SUBROUTINE bcucof

! -----------------------------------------------------------------------------

function cutoff( x )

  implicit none
  real(dp),intent(in):: x
  real(dp)           :: cutoff

  if (x<=0._dp) then
    cutoff = 1
  else if (x>=1._dp) then
    cutoff = 0
  else
    cutoff = (1-x**ncut1)**ncut2
  end if

end function cutoff

!-----------------------------------------------------------------------------

real(dp) function dphi( d1, d2 )

! Finds phi(d1,d2) - phi(dmax,dmax), with dmax=max(d1,d2)

  real(dp),intent(in) :: d1, d2

  integer  :: ia, ib, n, nmesh, nshort
  real(dp) :: a, acut, b, da1, dan, deff, dmax, dmin, gamma, &
              pi, t, t0, w
  real(dp),allocatable :: amesh(:), c(:), dphida(:), dphidb(:), &
                          s(:), nu0(:), nu1(:), nu2(:)

! Find integration mesh
  dmax = max( abs(d1), abs(d2) )
  dmin = min( abs(d1), abs(d2) )
  deff = dmax
!  deff = sqrt(d1**2+d2**2)
  acut = max( acutmin, acutbyd * deff )
  da1 = min( damax, dabyd * deff )
  da1 = max( da1, damin )
  dan = damax
  n = get_n( 0._dp, acut, da1, dan )
  allocate( amesh(n), c(n), dphida(n), dphidb(n), s(n), &
            nu0(n), nu1(n), nu2(n) )
  call set_mesh( n, xmax=acut, dxndx1=dan/da1 )
  call get_mesh( n, nmesh, amesh )

! Find limit of shorter mesh
  nshort = n
  do ia = n-1,1,-1
    if (amesh(ia) > ashortbyd*deff) nshort = ia
  end do

! Find cos(a), sin(a), nu1(a), and nu2(a)
  pi = acos(-1._dp)
  gamma = 4*pi/9
  do ia = 1,n
    a = amesh(ia)
    c(ia) = cos(a)
    s(ia) = sin(a)
    if (a==0._dp) then
      nu0(ia) = dmax**2 / 2 / gamma
      nu1(ia) = d1**2 / 2 / gamma
      nu2(ia) = d2**2 / 2 / gamma
    else ! (a/=0)
      if (d1==0._dp) then
        nu1(ia) = a*a / 2
      else
        nu1(ia) = a*a / 2 / (1-exp(-gamma*(a/d1)**2))
      end if
      if (d2==0._dp) then
        nu2(ia) = a*a / 2
      else
        nu2(ia) = a*a / 2 / (1-exp(-gamma*(a/d2)**2))
      end if
      if (dmax<=0._dp) then
        nu0(ia) = a*a / 2
      else
        nu0(ia) = a*a / 2 / (1-exp(-gamma*(a/dmax)**2))
      end if
    end if ! (a==0)
  end do

! Make integral on variable a
  dphida(1) = 0
  do ia = 2,nshort
    a = amesh(ia)

    ! Make integral on variable b
    dphidb(1) = 0
    do ib = 2,n
      b = amesh(ib)

      w = 2*( (3-a*a)*b*c(ib)*s(ia) + (3-b*b)*a*c(ia)*s(ib) &
            + (a*a+b*b-3)*s(ia)*s(ib) - 3*a*b*c(ia)*c(ib) )/(a*b)**3

      t = 0.5_dp * ( 1/(nu1(ia)+nu1(ib)) + 1/(nu2(ia)+nu2(ib)) ) &
                 * ( 1/(nu1(ia)+nu2(ia))/(nu1(ib)+nu2(ib)) &
                   + 1/(nu1(ia)+nu2(ib))/(nu2(ia)+nu1(ib)) )

      t0 = 0.5_dp * ( 1/(nu0(ia)+nu0(ib)) + 1/(nu0(ia)+nu0(ib)) ) &
                  * ( 1/(nu0(ia)+nu0(ia))/(nu0(ib)+nu0(ib)) &
                    + 1/(nu0(ia)+nu0(ib))/(nu0(ia)+nu0(ib)) )

      dphidb(ib) = a*a * b*b * w * (t-t0)

    end do ! ib
    dphida(ia) = integral( n, dphidb ) - integral( ia, dphidb )

  end do ! ia
  dphi = 2/pi**2 * 2*integral( nshort, dphida )

  deallocate( amesh, c, dphida, dphidb, s, nu0, nu1, nu2 )

#ifdef DEBUG_XC
!  print'(a,2f12.6,i8,f12.6)', 'dphi: d1,d2, na, phi =', d1, d2, n, dphi
#endif /* DEBUG_XC */

end function dphi

! -----------------------------------------------------------------------------

function dphi_fast( d1, d2 )

! Finds phi(d1,d2)-phi(dmax,dmax), with dmax=max(d1,d2), by 
!  - Direct integration if d < dsoft, where d=sqrt(d1**2+d2**2)
!  - Interpolation of phi_table if d > dsoft

  implicit none
  real(dp),intent(in) :: d1, d2
  real(dp)            :: dphi_fast

  real(dp):: d, dmax

  if (.not.phi_table_set) call set_phi_table()

  d = sqrt( d1**2 + d2**2 )
  dmax = max( d1, d2 )

  if (d < dsoft) then
    dphi_fast = dphi( d1, d2 )
  else
    dphi_fast = phi_interp( d1, d2 ) - phi_interp( dmax, dmax )
  end if

end function dphi_fast

! -----------------------------------------------------------------------------

function dphi_soft( d1, d2 )

! Finds phi_soft(d1,d2)-phi_soft(dmax,dmax), with dmax=max(d1,d2)

  implicit none
  real(dp),intent(in) :: d1, d2
  real(dp)            :: dphi_soft

  real(dp):: d, dmax

  d = sqrt( d1**2 + d2**2 )
  dmax = max( d1, d2 )

  if (d < dsoft) then
    dphi_soft = phi_soft( d1, d2 ) - phi_soft( dmax, dmax )
  else
    dphi_soft = dphi( d1, d2 )
  end if

end function dphi_soft

!-----------------------------------------------------------------------------

integer function iofd( d )

! Finds index i such that dmesh(i) <= d < dmesh(i+1)

  implicit none
  real(dp), intent(in) :: d

  real(dp),parameter :: amin = 1.e-12_dp
  real(dp),save:: a, b
  logical, save:: first_call = .true.

  if (first_call) then
    a = log( (dmesh(nd)-dmesh(nd-1)) / (dmesh(2)-dmesh(1)) ) / (nd-2)
    a = max( a, amin )
    b = (dmesh(2) - dmesh(1)) / (exp(a) - 1)
    first_call = .false.
  end if

  iofd = 1 + log( 1 + (d-dmesh(1))/b ) / a
  iofd = max( 1, iofd )
  iofd = min( nd-1, iofd )

end function iofd

!-----------------------------------------------------------------------------

integer function iofq( q )

! Finds index i such that qmesh(i) <= q < qmesh(i+1)

  implicit none
  real(dp), intent(in) :: q

  real(dp),parameter :: amin = 1.e-12_dp
  real(dp),save:: a, b
  logical, save:: first_call = .true.

  if (first_call) then
    a = log( (qmesh(mq)-qmesh(mq-1)) / (qmesh(2)-qmesh(1)) ) / (mq-2)
    a = max( a, amin )
    b = (qmesh(2) - qmesh(1)) / (exp(a) - 1)
    first_call = .false.
  end if

  iofq = 1 + log( 1 + (q-qmesh(1))/b ) / a
  iofq = max( 1, iofq )
  iofq = min( mq-1, iofq )

end function iofq

! -----------------------------------------------------------------------------

function phi_fast( d1, d2 )

! Finds hard phi(d1,d2) kernel by 
!  - Direct integration if d < dsoft, where d=sqrt(d1**2+d2**2)
!  - Interpolation of phi_table if d > dsoft

  implicit none
  real(dp),intent(in) :: d1, d2
  real(dp)            :: phi_fast

  real(dp):: d

  if (.not.phi_table_set) call set_phi_table()

  d = sqrt( d1**2 + d2**2 )

  if (d < dsoft) then
    phi_fast = phi_val( d1, d2 )
  else
    phi_fast = phi_interp( d1, d2 )
  end if

end function phi_fast

! -----------------------------------------------------------------------------

function phi_interp( d1, d2 )

! Finds soft phi(d1,d2) kernel by interpolation of phi_table

  implicit none
  real(dp),intent(in) :: d1, d2
  real(dp)            :: phi_interp

  integer :: i1, i2, id1, id2
  real(dp):: dd1(0:3), dd2(0:3)

  if (.not.phi_table_set) call set_phi_table()

  if (d1>=dcut .or. d2>=dcut) then
    phi_interp = 0
    return
  end if

  id1 = iofd( d1 )
  id2 = iofd( d2 )

  dd1(0) = 1
  dd2(0) = 1
  dd1(1) = (d1 - dmesh(id1)) / (dmesh(id1+1) - dmesh(id1))
  dd2(1) = (d2 - dmesh(id2)) / (dmesh(id2+1) - dmesh(id2))
  dd1(2) = dd1(1)**2
  dd2(2) = dd2(1)**2
  dd1(3) = dd1(1)**3
  dd2(3) = dd2(1)**3

  phi_interp = 0
  do i2 = 0,3
    do i1 = 0,3
      phi_interp = phi_interp + phi_table(i1,i2,id1,id2) * dd1(i1) * dd2(i2)
    end do
  end do

end function phi_interp

! -----------------------------------------------------------------------------

subroutine phiofr( r, phi )

! Finds phi(q1,q2,r) = phi(q1*r,q2*r) with q1=qmesh(iq1), q2=qmesh(iq2), 
! by interpolation from phi_table
! Notice that q is a density parameter, related to the Fermi wavevector

  implicit none
  real(dp),intent(in) :: r
  real(dp),intent(out):: phi(:,:)

  integer :: iq1, iq2
  real(dp):: dphidr

  ! Trap VV-version exception
#ifdef DEBUG_XC
  if (vdw_author=='VV') then
    call vv_vdw_phiofr( r, phi )
    return
  end if
#endif /* DEBUG_XC */

  if (size(phi,1)<mq .or. size(phi,2)<mq) &
    call die('phiofr: ERROR: size(phi) too small')
  if (.not.qmesh_set) call set_qmesh()

  if (r >= rcut) then
    phi(:,:) = 0
  else
    do iq2 = 1,mq
      do iq1 = 1,iq2
        ! Use unfiltered kernel
!        phi(iq1,iq2) = phi_interp( qmesh(iq1)*r, qmesh(iq2)*r )
        ! Use filtered kernel
        call splint( dr, phir(:,iq1,iq2), d2phidr2(:,iq1,iq2), nr+1, r, &
                     phi(iq1,iq2), dphidr )
        phi(iq2,iq1) = phi(iq1,iq2)
      end do ! iq1
    end do ! iq2
  end if ! (r>=rcut)

end subroutine phiofr

!-----------------------------------------------------------------------------

function phi_soft( d1, d2 )

! Finds phi(d1,d2) softened near d1=d2=0

  implicit none
  real(dp),intent(in) :: d1, d2
  real(dp)            :: phi_soft

  real(dp):: d, d1m, d1p, d2m, d2p, dphidd, &
             phi, phi0, phi2, phi4, phim, phip

  d = sqrt( d1**2 + d2**2 )

  if (d<=0._dp) then
    phi_soft = phi0_soft
  else if (d > dsoft) then
    phi_soft = phi_val( d1, d2 )
  else ! (0<d<dsoft)

    d1p = d1/d * (dsoft+dd)
    d2p = d2/d * (dsoft+dd)
    d1m = d1/d * (dsoft-dd)
    d2m = d2/d * (dsoft-dd)
    phip = phi_val( d1p, d2p )
    phim = phi_val( d1m, d2m )
    phi = (phip + phim) / 2
    dphidd = (phip - phim) / (2*dd)
!    phi0 = phi - dphidd*dsoft/2
    phi0 = phi0_soft
    phi2 = (4*(phi-phi0) - dphidd*dsoft) / (2*dsoft**2)
    phi4 = (2*(phi0-phi) + dphidd*dsoft) / (2*dsoft**4)
    phi_soft = phi0 + phi2*d**2 + phi4*d**4
#ifdef DEBUG_XC
!    print'(a,5f8.3)', 'phi_soft: d,delta,phi0,phi2,phi4=', &
!      d, (d1-d2)/(d1+d2), phi0, phi2, phi4
#endif /* DEBUG_XC */

  end if ! (d<=0)

end function phi_soft

! -----------------------------------------------------------------------------

real(dp) function phi_val( d1, d2 )

! Finds kernel phi by direct integration of Eq.(14) of 
! Dion et al, PRL 92, 246401 (2004)

  real(dp),intent(in) :: d1, d2

  integer  :: ia, ib, n, nmesh
  real(dp) :: a, acut, b, da1, dan, deff, dmax, dmin, gamma, &
              pi, t, w
  real(dp),allocatable :: amesh(:), c(:), dphida(:), dphidb(:), &
                          s(:), nu1(:), nu2(:)

! Find integration mesh
  dmax = max( abs(d1), abs(d2) )
  dmin = min( abs(d1), abs(d2) )
!  deff = dmax
  deff = sqrt(d1**2+d2**2)
  acut = max( acutmin, acutbyd * deff )
  da1 = min( damax, dabyd * deff )
  da1 = max( da1, damin )
  dan = damax
  n = get_n( 0._dp, acut, da1, dan )
  allocate( amesh(n), c(n), dphida(n), dphidb(n), s(n), nu1(n), nu2(n) )
  call set_mesh( n, xmax=acut, dxndx1=dan/da1 )
  call get_mesh( n, nmesh, amesh )

#ifdef DEBUG_XC
!  print'(a,i6,/,(10f8.3))', 'phi_val: size, amesh =', n, amesh
#endif /* DEBUG_XC */

! Find cos(a), sin(a), nu1(a), and nu2(a)
  pi = acos(-1._dp)
  gamma = 4*pi/9
  do ia = 1,n
    a = amesh(ia)
    c(ia) = cos(a)
    s(ia) = sin(a)
    if (a==0._dp) then
      nu1(ia) = d1**2 / 2 / gamma
      nu2(ia) = d2**2 / 2 / gamma
    else ! (a/=0)
      if (d1==0._dp) then
        nu1(ia) = a*a / 2
      else
        nu1(ia) = a*a / 2 / (1-exp(-gamma*(a/d1)**2))
      end if
      if (d2==0._dp) then
        nu2(ia) = a*a / 2
      else
        nu2(ia) = a*a / 2 / (1-exp(-gamma*(a/d2)**2))
      end if
    end if ! (a==0)
  end do

! Make integral on variable a
  dphida(1) = 0
  do ia = 2,n
    a = amesh(ia)

    ! Make integral on variable b
    dphidb(1) = 0
    do ib = 2,n
      b = amesh(ib)

      w = 2*( (3-a*a)*b*c(ib)*s(ia) + (3-b*b)*a*c(ia)*s(ib) &
            + (a*a+b*b-3)*s(ia)*s(ib) - 3*a*b*c(ia)*c(ib) )/(a*b)**3

      t = 0.5_dp * ( 1/(nu1(ia)+nu1(ib)) + 1/(nu2(ia)+nu2(ib)) ) &
                 * ( 1/(nu1(ia)+nu2(ia))/(nu1(ib)+nu2(ib)) &
                   + 1/(nu1(ia)+nu2(ib))/(nu2(ia)+nu1(ib)) )

      dphidb(ib) = a*a * b*b * w * t

    end do ! ib
    dphida(ia) = integral( n, dphidb )

  end do ! ia
  phi_val = 2/pi**2 * integral( n, dphida )

  deallocate( amesh, c, dphida, dphidb, s, nu1, nu2 )

#ifdef DEBUG_XC
!  print'(a,2f12.6,i8,f12.6)', 'phi_val: d1,d2, na, phi =', d1, d2, n, phi_val
#endif /* DEBUG_XC */

end function phi_val

! -----------------------------------------------------------------------------

subroutine pofq( q0, p0, dp0dq0 )

! Finds the values and derivatives, at q0, of the cubic polynomials 
! p_i(q0) such that
!    y(q0) = Sum_i p_i(q0) * y_i
! is the cubic spline interpolation at q0 of (any) function y(q) with
! values y_i at mesh points qmesh_i

  implicit none
  real(dp),intent(in) :: q0
  real(dp),intent(out):: p0(mq)
  real(dp),intent(out):: dp0dq0(mq)

  integer :: iq, iq0
  real(dp):: a, b, dq
  logical, save :: first_call=.true.
  real(dp),save :: p(mq,mq), d2pdq2(mq,mq)

! Set up spline polynomial basis
  if (first_call) then
    p = 0
    do iq = 1,mq
      p(iq,iq) = 1
      call spline( qmesh, p(:,iq), mq, 1.e30_dp, 1.e30_dp, d2pdq2(:,iq) )
!      call spline( qmesh, p(:,iq), mq, 0._dp, 0._dp, d2pdq2(:,iq) )
    end do
    first_call = .false.
  end if

! Find interval of qmesh in which q0 is included
  if (q0>qmesh(mq)) then   ! q0 out of range
    p0 = 0
    dp0dq0 = 0
    return
  end if
  iq0 = iofq( q0 )

! Evaluate polynomials of spline basis
  dq = qmesh(iq0+1) - qmesh(iq0)
  a = (qmesh(iq0+1) - q0) / dq   ! dadq0 = -1/dq
  b = (q0 - qmesh(iq0)) / dq     ! dbdq0 = +1/dq
  do iq = 1,mq
    p0(iq) = a*p(iq0,iq) + b*p(iq0+1,iq) &
      + ((a**3-a)*d2pdq2(iq0,iq) + (b**3-b)*d2pdq2(iq0+1,iq)) * dq**2/6
    dp0dq0(iq) = - (p(iq0,iq) - p(iq0+1,iq)) / dq &
      - ((3*a**2-1)*d2pdq2(iq0,iq) - (3*b**2-1)*d2pdq2(iq0+1,iq)) * dq/6
  end do

end subroutine pofq

!-----------------------------------------------------------------------------

subroutine qofrho( rho, grho, q, dqdrho, dqdgrho )

! Finds the local wavevector parameter q0 defined in eqs.(11-12) of
! M.Dion et al, PRL 92, 246401 (2004)

  implicit none
  real(dp), intent(in) :: rho        ! Electron density
  real(dp), intent(in) :: grho(3)    ! Density gradient
  real(dp), intent(out):: q          ! Local wave vector parameter q0
  real(dp), intent(out):: dqdrho     ! d_q/d_rho
  real(dp), intent(out):: dqdgrho(3) ! d_q/d_grho

  character(len=*),parameter :: author = 'PW92'  ! Perdew-Wang'92 for LDA
  integer,         parameter :: irel   = 0       ! Non-relativistic exchange
  integer,         parameter :: nspin  = 1       ! Unpolarized electron gas
  real(dp):: decdrho, dexdrho, dkfdrho, dq0dgrho(3), dq0dgrho2, dq0drho, &
             dqdq0, dvxdrho(nspin), dvcdrho(nspin), ex, ec, grho2, &
             kf, pi, q0, rhos(nspin), vx(nspin), vc(nspin)

! Trap exception for zero density
  if (rho <= 1.e-15_dp) then
    q = qcut
    dqdrho = 0
    dqdgrho = 0
    return
  end if

  pi = acos(-1._dp)
  kf = (3*pi**2 * rho)**(1._dp/3)

! Find exchange and correlation energy densities
  rhos(1) = rho
  call ldaxc( author, irel, nspin, rhos, ex, ec, vx, vc, dvxdrho, dvcdrho )

! Find q
  grho2 = sum(grho**2)
  q0 = ( 1 + ec/ex - zab/9 * grho2 / (2*kf*rho)**2 ) * kf

! Find derivatives
  dkfdrho = kf / (3*rho)
  dexdrho = (vx(1) - ex) / rho  ! Since vx = d(rho*ex)/d_rho = ex + rho*dexdrho
  decdrho = (vc(1) - ec) / rho
  dq0drho = ( decdrho/ex - ec/ex**2*dexdrho + 2 * zab/9 * grho2 / &
              (2*kf*rho)**3 * (2*dkfdrho*rho + 2*kf) ) * kf &
            + q0/kf * dkfdrho
  dq0dgrho2 = -(zab/9) / (2*kf*rho)**2 * kf
  dq0dgrho(:) = dq0dgrho2 * 2*grho(:)  ! Since d(vector**2)/d_vector = 2*vector

! Saturate q to qcut smoothly
  call saturate( q0, qcut, q, dqdq0 )
  dqdrho = dqdq0 * dq0drho
  dqdgrho = dqdq0 * dq0dgrho

end subroutine qofrho

!-----------------------------------------------------------------------------

subroutine saturate( x, xc, y, dydx )

  ! Defines a function y(x) = xc * (1 - exp(-Sum_n=1:nsat (x/xc)**n/n))
  ! It is approx. equal to x for x<xc and it saturates to xc when x->infinity

  implicit none
  real(dp),intent(in) :: x     ! Independent variable
  real(dp),intent(in) :: xc    ! Saturation value
  real(dp),intent(out):: y     ! Function value
  real(dp),intent(out):: dydx  ! Derivative dy/dx

  integer :: n
  real(dp):: dpdx, p

  if (nsat >= 100) then
    if (x < xc) then
      y = x
      dydx = 1
    else ! (x >= xc)
      y = xc
      dydx = 0
    end if ! (x < xc)
  else ! (nsat < 100)
!    This is the straightforward polynomial evaluation
!    p = x/xc
!    dpdx = 1/xc
!    do n = 2,nsat
!      p = p + (x/xc)**n / n
!      dpdx = dpdx + (x/xc)**(n-1) / xc
!    end do
!   And this is a more accurate way to evaluate it
    p = (x/xc)/nsat
    dpdx = 1._dp/xc
    do n = nsat-1,1,-1
      p = (p + 1._dp/n) * x/xc
      dpdx = (dpdx*x + 1) / xc
    end do
    y = xc * (1 - exp(-p))
    dydx = xc * dpdx * exp(-p)
  end if ! (nsat >= 100)

end subroutine saturate

!-----------------------------------------------------------------------------

subroutine saturate_inverse( y, xc, x, dydx )

! Finds the inverse of the function defined in saturate subroutine

  implicit none
  real(dp),intent(in) :: y     ! Independent variable
  real(dp),intent(in) :: xc    ! Saturation value
  real(dp),intent(out):: x     ! Inverse function value
  real(dp),intent(out):: dydx  ! Derivative dy/dx

  real(dp):: x1, x2, yx

  if (y<0._dp .or. y>xc) call die('vdw:saturate_inverse: y out of range')
  x1 = 0
  x2 = xmaxbyxc * xc
  do
    x = (x1+x2)/2
    call saturate( x, xc, yx, dydx )
    if (abs(y-yx)<ytol) then
      return
    else if (yx < y) then
      x1 = x
    else
      x2 = x
    end if
  end do

end subroutine saturate_inverse

!-----------------------------------------------------------------------------

subroutine set_phi_table()

! Finds and writes in disk the interpolation table (mesh points and function 
! values) for the kernel phi(d1,d2). If the table file already exists, it is
! simply read and stored in memory.

  implicit none

  logical :: file_found
  integer :: id, id1, id2, nmesh
  real(dp):: d, d1, d1m, d1p, d2, d2m, d2p, dd, &
             dphidd1(nd,nd), dphidd2(nd,nd), d2phidd1dd2(nd,nd), &
             phi(nd,nd), phi1, phim, phip, phimm, phimp, phipm, phipp

! Read file with table, if present
  inquire( file='vdw_kernel.table', exist=file_found )
  if (file_found) then
    open( unit=1, file='vdw_kernel.table', form='unformatted' )
    read(1,end=1) nmesh
    if (nmesh==nd) then
      read(1,end=1) dmesh
      read(1,end=1) phi_table
    end if
    close( unit=1 )
    phi_table_set = .true.
    return
  end if
1 continue ! Come here if end-of-file found

! Set d-mesh points
  call set_mesh( nd, xmax=dcut, dxndx1=ddmaxddmin )
  call get_mesh( nd, nmesh, dmesh )
#ifdef DEBUG_XC
  write(udebug,'(a,/,(10f8.4))') 'set_phi_table: dmesh =', dmesh
#endif /* DEBUG_XC */

! Find function at mesh points
  do id1 = 1,nd
    d1 = dmesh(id1)
    phi1 = phi_soft( d1, d1 )
    phi(id1,id1) = phi1
    do id2 = 1,id1-1
      d2 = dmesh(id2)
      d = sqrt( d1**2 + d2**2 )
      if (d < dsoft) then
        phi(id1,id2) = phi_soft( d1, d2 )
      else
        if (use_dphi) then ! Use dphi for better efficiency
          phi(id1,id2) = phi1 + dphi( d1, d2 )
        else ! Use only phi_val, to eliminate uncertainties
          phi(id1,id2) = phi_val( d1, d2 )
        end if
      end if
      phi(id2,id1) = phi(id1,id2)
    end do ! id2
  end do ! id1

#ifdef DEBUG_XC
!  open( unit=44, file='phi.out' )
!  do id2 = 1,nd
!    write(44,'(/,(f12.6))') phi(:,id2)
!  end do
!  close( unit=44 )
#endif /* DEBUG_XC */

  if (deriv_method == 'numeric') then
!    print*, 'set_phi_table: Using numerical derivatives'

    ! Find derivatives at mesh points
     do id1 = 1,nd
      d1 = dmesh(id1)
      dd = ddbyd * d1
      dd = max( dd, ddmin )
!      d1 = max( d1, dd )
      d1m = d1 - dd
      d1p = d1 + dd
      phim = phi_soft( d1m, d1m )
      phip = phi_soft( d1p, d1p )
      do id2 = 1,id1
        d2  = dmesh(id2)
!        d2 = max( d2, dd )
        d = sqrt( d1**2 + d2**2 )
        d1m = d1 - dd
        d1p = d1 + dd
        d2m = d2 - dd
        d2p = d2 + dd

        if (d < dsoft) then
          phimm = phi_soft( d1m, d2m )
          phipm = phi_soft( d1p, d2m )
          phipp = phi_soft( d1p, d2p )
          phimp = phi_soft( d1m, d2p )
        else ! (d>dsoft)
          if (use_dphi) then
            phimm = phim + dphi( d1m, d2m )
            phipm = phip + dphi( d1p, d2m )
            phipp = phip + dphi( d1p, d2p )
            if (id1==id2) then
              phimp = phip + dphi( d1m, d2p )
            else
              phimp = phim + dphi( d1m, d2p )
            end if
          else ! (.not.use_dphi)
            phimm = phi_val( d1m, d2m )
            phipm = phi_val( d1p, d2m )
            phipp = phi_val( d1p, d2p )
            phimp = phi_val( d1m, d2p )
          end if ! (use_dphi)
        end if ! (d<dsoft)

        dphidd1(id1,id2)     = (phipp+phipm-phimp-phimm) / (4*dd)
        dphidd2(id1,id2)     = (phipp-phipm+phimp-phimm) / (4*dd)
        d2phidd1dd2(id1,id2) = (phipp-phipm-phimp+phimm) / (2*dd)**2
        dphidd1(id2,id1)     = dphidd2(id1,id2)
        dphidd2(id2,id1)     = dphidd1(id1,id2)
        d2phidd1dd2(id2,id1) = d2phidd1dd2(id1,id2)

      end do ! id2
    end do ! id1

  else if (deriv_method == 'interp') then
!    print*, 'set_phi_table: Using interpolation for derivatives'

    ! Reset mesh, which has been changed by phi_val
    call set_mesh( nd, xmax=dcut, dxndx1=ddmaxddmin )

    ! Set interpolation method
    if (interp_method=='Lagrange') then
      call set_interpolation( 'Lagrange' )
    else if (interp_method=='Spline') then
!      call set_interpolation( 'Spline', huge(phi), huge(phi) )
      call set_interpolation( 'Spline', 0._dp, 0._dp )
    else
      call die('set_phi_val: ERROR: Unknown interp_method')
    end if

    ! Find first partial derivative d_phi/d_d1
    do id = 1,nd
      dphidd1(:,id) = derivative( nd, phi(:,id) )
      dphidd2(id,:) = dphidd1(:,id)
    end do

    ! Find second cross partial derivative d_phi/d_d1/d_d2
    do id = 1,nd
      d2phidd1dd2(id,:) = derivative( nd, dphidd1(id,:) )
    end do

    ! Symmetrize d_phi/d_d1/d_d2
    do id2 = 2,nd
      do id1 = 1,id2-1
        d2phidd1dd2(id1,id2) = (d2phidd1dd2(id1,id2) + &
                                d2phidd1dd2(id2,id1)) / 2
        d2phidd1dd2(id2,id1) = d2phidd1dd2(id1,id2) 
      end do
    end do

  else
    call die('set_phi_table: ERROR: Unknown deriv_method')
  end if ! (deriv_method)

! Make values and derivatives strictly zero when d1=dmax or d2=dmax
  phi(:,nd) = 0
  phi(nd,:) = 0
  dphidd1(:,nd) = 0
  dphidd1(nd,:) = 0
  dphidd2(:,nd) = 0
  dphidd2(nd,:) = 0
  d2phidd1dd2(:,nd) = 0
  d2phidd1dd2(nd,:) = 0

! Make dphi(d1,d2)/dd1=0 for d1=0 and dphi(d1,d2)/dd2=0 for d2=0
  dphidd1(1,:) = 0
  dphidd2(:,1) = 0
  d2phidd1dd2(:,1) = 0
  d2phidd1dd2(1,:) = 0

#ifdef DEBUG_XC
! Print values and derivatives for debugging
!  print'(a,/,2a10,4a15)', &
!   'set_phi_table:', 'd1', 'd2', 'phi', 'dphi/dd1', 'dphi/dd2', 'd2phi/dd1dd2'
!  do id1 = 1,nd
!    do id2 = id1,nd
!      d1 = dmesh(id1)
!      d2 = dmesh(id2)
!      print'(2f10.6,4e15.6)', d1, d2, phi(id1,id2), &
!        dphidd1(id1,id2), dphidd2(id1,id2), d2phidd1dd2(id1,id2)
!    end do
!  end do
#endif /* DEBUG_XC */

! Set up bicubic interpolation coefficients
  call bcucof( nd, nd, dmesh, dmesh, phi, dphidd1, dphidd2, d2phidd1dd2, &
               phi_table )

! Save phi_table in file
  open( unit=1, file='vdw_kernel.table', form='unformatted' )
  write(1) nd
  write(1) dmesh
  write(1) phi_table
  close( unit=1 )

#ifdef DEBUG_XC
! Save phi_table also in formatted file
  open( unit=1, file='vdw_kernel.table.formatted', form='formatted' )
  write(1,*) nd
  write(1,*) dmesh
  do id2 = 1,nd
    do id1 = 1,nd
      write(1,*) phi_table(:,:,id1,id2)
    end do
  end do
  close( unit=1 )
#endif /* DEBUG_XC */

! Mark table as set
  phi_table_set = .true.

end subroutine set_phi_table

! -----------------------------------------------------------------------------

subroutine set_qmesh()

! Sets mesh of q values

  implicit none
  integer :: nmesh

  call set_mesh( mq, xmax=qcut, dxndx1=dqmaxdqmin )
  call get_mesh( mq, nmesh, qmesh )
  qmesh_set = .true.

#ifdef DEBUG_XC
  write(udebug,'(/,a,/,(10f8.4))') 'vdw:set_qmesh: qmesh =', qmesh
#endif /* DEBUG_XC */

end subroutine set_qmesh

! -----------------------------------------------------------------------------

subroutine vdw_decusp( nspin, rhos, grhos, eps, dedrho, dedgrho )

! Finds the local energy correction due to the softening of the VdW kernel
! cusp, defined as DEcusp(rho,grad_rho) = 
!   (1/2) * rho**2 * Int 4*pi*r**2*dr * (phi(q1*r,q2*r) - phi_soft(q1*r,q2*r))
! where q1=q2=q0(rho,grad_rho). Notice that grad_rho is included in the value 
! of q0 at the origin but not in the change of rho(r) in the integrand.

  implicit none
  integer, intent(in) :: nspin            ! Number of spin components
  real(dp),intent(in) :: rhos(nspin)      ! Electron spin density
  real(dp),intent(in) :: grhos(3,nspin)   ! Spin density gradient
  real(dp),intent(out):: eps              ! Energy correction per electron
  real(dp),intent(out):: dedrho(nspin)    ! d(rho*eps)/d(rho)
  real(dp),intent(out):: dedgrho(3,nspin) ! d(rho*eps)/d(grad_rho)

  logical, save:: initialized=.false.
  real(dp),save:: table(mq,mq)
  integer :: iq1, iq2, ir, is, ix, ns
  real(dp):: dptpdq, dpdq(mq), dqdrho, dqdgrho(3), grho(3), p(mq), &
             ptp, phi22, phi(mq,mq), pi, pt(mq), q, r, rho

  ! Trap VV-version exception
  if (vdw_author=='VV') then
    eps = vv_vdw_beta()
    dedrho = eps
    dedgrho = 0
    return
  end if

  if (.not.initialized) then

    if (.not.phi_table_set) call set_phi_table()
    if (.not.kcut_set) call die('vdw_decusp: ERROR: kcut has not been set')

    pi = acos(-1._dp)
    table = 0
    do ir = 1,nr
      r = ir * dr
      call phiofr( r, phi )
      do iq2 = 1,mq
        do iq1 = 1,iq2
          table(iq1,iq2) = table(iq1,iq2) - 2*pi*dr * r**2 * phi(iq1,iq2)
        end do ! iq1
      end do ! iq2
    end do

    do iq2 = 2,mq
      do iq1 = 1,iq2-1
        table(iq2,iq1) = table(iq1,iq2)
      end do
    end do

    initialized = .true.

  end if ! (.not.initialized)

  ns = min(nspin,2)
  rho = sum(rhos(1:ns))
  do ix = 1,3
    grho(ix) = sum(grhos(ix,1:ns))
  end do

  call qofrho( rho, grho, q, dqdrho, dqdgrho )
  call pofq( q, p, dpdq )

  pt = matmul(p,table)
  ptp = sum( pt * p )
  dptpdq = 2 * sum( pt * dpdq )
  eps = rho * ptp
  dedrho(:) = 2 * rho * ptp + rho**2 * dptpdq * dqdrho
  do ix = 1,3
    dedgrho(ix,:) = rho**2 * dptpdq * dqdgrho(ix)
  end do

end subroutine vdw_decusp

!-----------------------------------------------------------------------------

subroutine vdw_get_qmesh( n, q )

! Returns size and values of q-mesh

  implicit none
  integer,          intent(out) :: n     ! Number of qmesh points
  real(dp),optional,intent(out) :: q(:)  ! Values of qmesh points
  integer:: nmax, nkf, nkg

  ! Trap VV-version exception
  if (vdw_author=='VV') then
    call vv_vdw_get_kmesh( nkf, nkg )
    n = nkf*nkg
    if (present(q)) &
      call die('vdw_get_qmesh: ERROR q-mesh not available for author=VV')
    return
  end if

  if (.not.qmesh_set) call set_qmesh()
  n = mq
  if (present(q)) then
    nmax = max( mq, size(q) )
    q(1:nmax) = qmesh(1:nmax)
  end if
end subroutine vdw_get_qmesh

! -----------------------------------------------------------------------------

subroutine vdw_localxc( iRel, nSpin, D, GD, epsX, epsC, &
                        dEXdD, dECdD, dEXdGD, dECdGD )

! Finds the (semi)local part of the correlation energy density and its 
! derivatives, using the GGA functional apropriate for the previously-set
! vdW functional flavour

  implicit none
  integer, intent(in) :: iRel            ! Relativistic exchange? 0=no, 1=yes
  integer, intent(in) :: nSpin           ! Number of spin components
  real(dp),intent(in) :: D(nSpin)        ! Local electron (spin) density
  real(dp),intent(in) :: GD(3,nSpin)     ! Gradient of electron density
  real(dp),intent(out):: epsX            ! Local exchange energy per electron
  real(dp),intent(out):: epsC            ! Local correlation energy per electron
  real(dp),intent(out):: dEXdD(nSpin)    ! dEx/dDens, Ex=Int(dens*epsX)
  real(dp),intent(out):: dECdD(nSpin)    ! dEc/dDens, Ec=Int(dens*epsC)
  real(dp),intent(out):: dEXdGD(3,nSpin) ! dEx/dGrad(Dens)
  real(dp),intent(out):: dECdGD(3,nSpin) ! dEc/dGrad(Dens)

! Internal variables and arrays
  real(dp):: epsAux, dEdDaux(nSpin), dEdGDaux(3,nSpin)
  real(dp):: dVXdD(nSpin,nSpin), dVCdD(nSpin,nSpin)

! Initialize output
  epsX = 0
  epsC = 0
  dEXdD = 0
  dECdD = 0
  dEXdGD = 0
  dECdGD = 0

! Call the appropriate GGA functional.
! Use aux arrays to avoid overwritting the wrong ones
  if (vdw_author=='DRSLL' .or. vdw_author=='drsll' .or. &
      vdw_author=='DF1' .or. vdw_author=='df1') then
    ! Dion et al, PRL 92, 246401 (2004)
    ! GGA exchange and LDA correlation (we choose PW92 for the later)
    call GGAxc( 'revPBE', iRel, nSpin, D, GD, epsX, epsAux, &
                 dEXdD, dEdDaux, dEXdGD, dEdGDaux )
    call LDAxc( 'PW92', iRel, nSpin, D, epsAux, epsC,  &
                dEdDaux, dECdD, dVXdD, dVCdD )
  else if (vdw_author=='LMKLL' .or. vdw_author=='lmkll' .or. &
           vdw_author=='DF2' .or. vdw_author=='df2') then
    ! Lee et al, PRB 82, 081101 (2010)
    call GGAxc( 'PW86R', iRel, nSpin, D, GD, epsX, epsAux, &
                 dEXdD, dEdDaux, dEXdGD, dEdGDaux )
    call LDAxc( 'PW92', iRel, nSpin, D, epsAux, epsC,  &
                dEdDaux, dECdD, dVXdD, dVCdD )
  else if (vdw_author=='KBM' .or. vdw_author=='kbm') then
    ! optB88-vdW of Klimes et al, JPCM 22, 022201 (2009)
    call GGAxc( 'B88KBM', iRel, nSpin, D, GD, epsX, epsAux, &
                 dEXdD, dEdDaux, dEXdGD, dEdGDaux )
    call LDAxc( 'PW92', iRel, nSpin, D, epsAux, epsC,  &
                dEdDaux, dECdD, dVXdD, dVCdD )
  else if (vdw_author=='C09' .or. vdw_author=='c09') then
    ! C09x-vdWc of Cooper, PRB 81, 161104(R) (2010)
    call GGAxc( 'C09', iRel, nSpin, D, GD, epsX, epsAux, &
                 dEXdD, dEdDaux, dEXdGD, dEdGDaux )
    call LDAxc( 'PW92', iRel, nSpin, D, epsAux, epsC,  &
                dEdDaux, dECdD, dVXdD, dVCdD )
  else if (vdw_author=='BH' .or. vdw_author=='bh') then
    ! Berland and Hyldgaard, PRB 89, 035412 (2014)
    call GGAxc( 'BH', iRel, nSpin, D, GD, epsX, epsAux, &
                dEXdD, dEdDaux, dEXdGD, dEdGDaux )
    call LDAxc( 'PW92', iRel, nSpin, D, epsAux, epsC,  &
                dEdDaux, dECdD, dVXdD, dVCdD )
  else if (vdw_author=='VV' .or. vdw_author=='vv') then
    ! Vydrov and VanVoorhis, JCP 133, 244103 (2010)
    ! GGA for both exchange and correlation, but with different flavours
    call GGAxc( 'PW86R', iRel, nSpin, D, GD, epsX, epsAux, &
                dEXdD, dEdDaux, dEXdGD, dEdGDaux )
    call GGAxc( 'PBE', iRel, nSpin, D, GD, epsAux, epsC, &
                dEdDaux, dECdD, dEdGDaux, dECdGD )
  else
    call die('vdw_exchng ERROR: unknown author')
  end if

end subroutine vdw_localxc

!-----------------------------------------------------------------------------

subroutine vdw_phi( k, phi, dphidk )

! Finds by interpolation phi(q1,q2,k) (Fourier transform of phi(q1,q2,r)) 
! for all values of q1 and q2 in qmesh. If the interpolation table does not
! exist, it is calculated in the first call to vdw_phi. It requires a 
! previous call to vdw_set_kc to set qmesh.

  implicit none
  real(dp),intent(in) :: k            ! Modulus of actual k vector
  real(dp),intent(out):: phi(:,:)     ! phi(q1,q2,k) at given k
                                      ! for all q1,q2 in qmesh
  real(dp),intent(out):: dphidk(:,:)  ! dphi(q1,q2,k)/dk at given k

  integer :: ik, iq1, iq2
  real(dp):: a, a2, a3, b, b2, b3

  ! Trap VV-version exception
  if (vdw_author=='VV') then
    call vv_vdw_phi( k, phi, dphidk )
    return
  end if

  if (.not.kcut_set) call die('vdw_phi: ERROR: kcut must be previously set')

! Check argument sizes
  if (size(phi,1)<mq .or. size(phi,2)<mq) &
    call die('vdw_phi: ERROR: size(phi) too small')

! Find phi values at point k
  if (k >= kcut) then
    phi(:,:) = 0
  else
    ! Expand interpolation inline since this is the hottest point in VdW
    ik = k/dk
    a = ((ik+1)*dk-k)/dk
    b = 1 - a
    a2 = (3*a**2 -1) * dk / 6
    b2 = (3*b**2 -1) * dk / 6
    a3 = (a**3 - a) * dk**2 / 6
    b3 = (b**3 - b) * dk**2 / 6
    do iq2 = 1,mq
      do iq1 = 1,iq2
!        call splint( dk, phik(:,iq1,iq2), d2phidk2(:,iq1,iq2), nk+1, k, &
!                     phi(iq1,iq2), dphidk(iq1,iq2), pr )
        phi(iq1,iq2) = a*phik(ik,iq1,iq2) + b*phik(ik+1,iq1,iq2) &
                + a3*d2phidk2(ik,iq1,iq2) + b3*d2phidk2(ik+1,iq1,iq2)
        dphidk(iq1,iq2) = (-phik(ik,iq1,iq2) + phik(ik+1,iq1,iq2)) / dk &
                   - a2*d2phidk2(ik,iq1,iq2) + b2*d2phidk2(ik+1,iq1,iq2)
        phi(iq2,iq1) = phi(iq1,iq2)
        dphidk(iq2,iq1) = dphidk(iq1,iq2)
      end do
    end do
  end if

end subroutine vdw_phi

!-----------------------------------------------------------------------------

subroutine vdw_set_author( author )

! Sets the functional flavour (author initials) and subsequent parameters

  implicit none
  character(len=*),intent(in):: author ! Functional flavour 
                                   ! ('DRSLL'|'LMKLL'|'KBM'|'C09'|'BH'|'VV')

  if (author=='DRSLL') then
    ! Dion et al, PRL 92, 246401 (2004)
    zab = -0.8491_dp
  else if (author=='LMKLL') then
    ! Lee et al, PRB 82, 081101 (2010)
    zab = -1.887_dp
  else if (author=='KBM') then
    ! optB88-vdW of Klimes et al, JPCM 22, 022201 (2009)
    zab = -0.8491_dp
  else if (author=='C09') then
    ! Cooper, PRB 81, 161104(R) (2010)
    zab = -0.8491_dp
  else if (author=='BH') then
    ! Berland and Hyldgaard, PRB 89, 035412 (2014)
    zab = -0.8491_dp
  else if (author=='VV') then
    ! Vydrov and Van Voorhis, JCP 133, 244103 (2010)
  else
    call die('vdw_set_author: ERROR: author not known')
  end if
  vdw_author = author

end subroutine vdw_set_author

!-----------------------------------------------------------------------------

subroutine vdw_set_kcut( kc )

! Sets the reciprocal planewave cutoff kc of the integration grid, and finds 
! the interpolation table to be used by vdw_phi to obtain the vdW kernel phi
! at the reciprocal mesh wavevectors.

  implicit none
  real(dp),intent(in):: kc  ! Planewave cutoff: k>kcut => phi=0

  character(len=*),parameter:: myName = 'vdw_set_kcut '
  integer :: ik, iq1, iq2, ir, nrs
  real(dp):: dphids, dphidk0, dphidkmax, dphidr0, dphidrmax, dqdq0, &
             k, kmax, phi(0:nr), phi0, phi2, phis, pi, q1, q2, r(0:nr), rs

  ! Trap VV-version exception
  if (vdw_author=='VV') then
    call vv_vdw_set_kcut( kc )
    return
  end if

  if (kc == kcut) return   ! Work alredy done
  if (.not.qmesh_set) call set_qmesh()

  ! Allocate arrays
  call re_alloc( phir,     0,nr, 1,mq, 1,mq, myName//'phir' )
  call re_alloc( phik,     0,nr, 1,mq, 1,mq, myName//'phik' )
  call re_alloc( d2phidr2, 0,nr, 1,mq, 1,mq, myName//'d2phidr2' )
  call re_alloc( d2phidk2, 0,nr, 1,mq, 1,mq, myName//'d2phidk2' )

  pi = acos(-1._dp)
  dr = rcut / nr
  dk = pi / rcut
  kmax = pi / dr
  nk = int(kc/dk) + 1
  nrs = nint(rsoft/dr)
  rs = nrs * dr
  if (nk>nr) call die('vdw_set_kcut: ERROR: nk>nr')

#ifdef DEBUG_XC
  write(udebug,'(a,5f8.3)') 'vdw_set_kcut: dcut,qcut,rcut,kcut,kmax=', &
    dcut, qcut, rcut, kc, kmax
#endif /* DEBUG_XC */

  ! For each pair of values q1 and q2
  do iq2 = 1,mq
    do iq1 = 1,iq2
!      print*, 'vdw_set_kcut: iq1,iq2=', iq1, iq2

!     Saturated q values
!      q1 = qmesh(iq1)
!      q2 = qmesh(iq2)

!     Find original (unsaturated) q values
      call saturate_inverse( qmesh(iq1), qcut, q1, dqdq0 )
      call saturate_inverse( qmesh(iq2), qcut, q2, dqdq0 )

      ! Find kernel in real space
      do ir = 0,nr
        r(ir) = ir * dr
        phir(ir,iq1,iq2) = phi_interp( q1*r(ir), q2*r(ir) )
      end do
      phi(:) = phir(:,iq1,iq2)

      ! Change kernel near origin to a parabola matching at rs
      if (nrs>0) then
        phis = phi(nrs)
        dphids = (phi(nrs+1) - phi(nrs-1)) / (2*dr)
        phi0 = phis - dphids * rs/2
        phi2 = dphids / (2*rs)
        do ir = 0,nrs
          phir(ir,iq1,iq2) = phi0 + phi2 * r(ir)**2
        end do
      end if ! (nrs>0)

      ! Kill kernel smoothly at r=rcut
      do ir = 0,nr
        phir(ir,iq1,iq2) = phir(ir,iq1,iq2) * cutoff( r(ir)/rcut )
      end do

      ! Optimized filter (warning: inaccurate for very large kcut*rcut)
!      call filter( 0, nr+1, r(:), phir(:,iq1,iq2), kc, 0 )

      ! Find kernel in reciprocal space
      call radfft( 0, nr, rcut, phir(:,iq1,iq2), phik(:,iq1,iq2) )
      phik(:,iq1,iq2) = phik(:,iq1,iq2) * (2*pi)**1.5_dp

      ! Filter out above kcut
      phik(nk:nr,iq1,iq2) = 0

      ! Soft filter below kcut
      do ik = 1,nk
        k = ik * dk
        phik(ik,iq1,iq2) = phik(ik,iq1,iq2) * cutoff(k/kc)
      end do

      ! Find filtered kernel in real space
      call radfft( 0, nr, kmax, phik(:,iq1,iq2), phir(:,iq1,iq2) )
      phir(:,iq1,iq2) = phir(:,iq1,iq2) / (2*pi)**1.5_dp

      ! Set up spline interpolation tables
      dphidr0 = 0
      dphidrmax = 0
      dphidk0 = 0
      dphidkmax = 0
      call spline( dr, phir(:,iq1,iq2), nr+1, dphidr0, dphidrmax, &
                   d2phidr2(:,iq1,iq2) )
      call spline( dk, phik(:,iq1,iq2), nk+1, dphidk0, dphidkmax, &
                   d2phidk2(:,iq1,iq2) )

      ! Fill symmetric elements
      phir(:,iq2,iq1) = phir(:,iq1,iq2)
      phik(:,iq2,iq1) = phik(:,iq1,iq2)
      d2phidr2(:,iq2,iq1) = d2phidr2(:,iq1,iq2)
      d2phidk2(:,iq2,iq1) = d2phidk2(:,iq1,iq2)

!      if (.false. .and. iq1==iq2) then
!        print*, 'vdw_set_kcut: iq1,iq2=', iq1, iq2
!        call window( 0._dp, 5._dp, -1._dp, 4._dp, 0 )
!        call axes( 0._dp, 1._dp, 0._dp, 1._dp )
!        call plot( nr+1, r, phi, phir(:,iq1,iq2) )
!        call window( 0._dp, 10._dp, -0.05_dp, 0.15_dp, 0 )
!        call axes( 0._dp, 1._dp, 0._dp, 0.05_dp )
!        call plot( nr+1, r, q1*q2*r**2*phi, q1*q2*r**2*phir(:,iq1,iq2) )
!        call show()
!      end if

    end do ! iq1
  end do ! iq2

!  print'(a,/,(2i6,f12.6))', 'vdw_set_kcut: iq1, iq2, phir(0,iq1,iq2) =', &
!    ((iq1,iq2,phir(0,iq1,iq2),iq1=2,iq2),iq2=2,mq)

  kcut = kc
  kcut_set = .true.

end subroutine vdw_set_kcut

!-----------------------------------------------------------------------------

subroutine vdw_theta( nspin, rhos, grhos, theta, dtdrho, dtdgrho )

! Finds the value and derivatives of theta_i(rho,grad_rho) = rho*p_i(q0), 
! where q0(rho,grad_rho) is the local wavevector defined in eqs.(11-12) 
! of Dion et al. p_i(q0) are the cubic polynomials such that
!     y(q0) = Sum_i p_i(q0) * y_i
! is the cubic spline interpolation at q0 of (any) function y(q) with
! values y_i at mesh points qmesh_i

  implicit none
  integer, intent(in) :: nspin               ! Number of spin components
  real(dp),intent(in) :: rhos(nspin)         ! Electron spin density
  real(dp),intent(in) :: grhos(3,nspin)      ! Spin density gradient
  real(dp),intent(out):: theta(:)            ! Expansion of rho*q in qmesh
  real(dp),intent(out):: dtdrho(:,:)         ! dtheta(iq)/drhos
  real(dp),intent(out):: dtdgrho(:,:,:)      ! dtheta(iq)/dgrhos(ix)
!  real(dp),intent(out):: theta(mq)           ! Expansion of rho*q in qmesh
!  real(dp),intent(out):: dtdrho(mq,nspin)    ! dtheta(iq)/drhos
!  real(dp),intent(out):: dtdgrho(3,mq,nspin) ! dtheta(iq)/dgrhos(ix)

  integer :: is, ix, ns
  real(dp):: rho, grho(3), dpdq(mq), dqdrho, dqdgrho(3), p(mq), q

  ! Trap VV-version exception
  if (vdw_author=='VV') then
    call vv_vdw_theta( nspin, rhos, grhos, theta, dtdrho, dtdgrho )
    return
  end if

  ns = min(nspin,2)
  rho = sum(rhos(1:ns))
  do ix = 1,3
    grho(ix) = sum(grhos(ix,1:ns))
  end do

  call qofrho( rho, grho, q, dqdrho, dqdgrho )
  call pofq( q, p, dpdq )

  theta(1:mq) = rho * p(1:mq)
  dtdrho(:,:) = 0
  dtdgrho(:,:,:) = 0
  do is = 1,ns
    dtdrho(1:mq,is) = p(1:mq) + rho * dpdq(1:mq) * dqdrho
    do ix = 1,3
      dtdgrho(ix,1:mq,is) = rho * dpdq(1:mq) * dqdgrho(ix)
    end do
  end do

end subroutine vdw_theta

END MODULE gridxc_vdwxc

#if defined HAVE_CONFIG_H
#include "config.h"
#endif
#ifdef HAVE_LIBXC
#include "xc_version.h"
#endif

!< Stores the information about the XC functional to use,
! and provides routines to set and to get it.
!
! Note: data is currently global. In future, it will be put into a derived type and
! initialized and passed around in a single handle.
!
module gridxc_xcmod

  use gridxc_precision, only: dp              ! Double precision real kind
  use gridxc_sys,       only: die             ! Termination routine
  use gridxc_vdwxc,   only: vdw_set_author  ! Sets vdW functional flavour

  implicit none

public:: &
  setXC_family_authors, &! Sets single XC functional in family/author style
  setXC, &! Sets XC functional(s) to be used (comprehensive)
  getXC   ! Returns the XC functional(s) being used

#ifdef HAVE_LIBXC
public :: setXC_libxc_ids! Sets XC functionals using libxc ids
#endif

private ! Nothing is declared public beyond this point

! These data should be put into a derived type and
! initialized and passed around in a single handle, instead
! of being global

  integer, parameter :: maxFunc = 20
  integer,           save :: nXCfunc=0
  character(len=50), save :: XCauth(MaxFunc), XCfunc(MaxFunc)
  real(dp),          save :: XCweightX(MaxFunc), XCweightC(MaxFunc)

contains

  
!< Sets the xc functional(s) to be used by atomxc and/or cellxc. 
! The allowed functional/author values can be seen [here](|url|/page/02_user_guide/02_api/functionals.html).
  
!< Usage example:
!  
!     call setXC( 1, (/'GGA'/), (/'PBE'/), (/1._dp/), (/1._dp/) )
!  
!    Stops with an error message if n is larger than the internal module parameter maxFunc


  subroutine setXC( n, func, auth, wx, wc )
    implicit none

    !> Number of functionals to use
    integer,         intent(in):: n
    !> Functional family labels (LDA, GGA, etc)
    character(len=*),intent(in):: func(n) 
    !> Functional author labels
    character(len=*),intent(in):: auth(n) 
    !> Functional weights for exchange  (sum(wx) must be 1)
    real(dp),        intent(in):: wx(n)   
    !> Functional weights for correlation (sum(wc) must be 1)
    real(dp),        intent(in):: wc(n)

    integer:: i, j

    if (n>maxFunc) call die('setXC: ERROR: parameter maxFunc too small')
    nXCfunc = n
    XCfunc(1:n) = func(1:n)
    XCauth(1:n) = auth(1:n)
    XCweightX(1:n) = wx(1:n)
    XCweightC(1:n) = wc(1:n)
    do i = 1,n
      if (XCfunc(i)=='VDW' .or. XCfunc(i)=='vdw' .or. XCfunc(i)=='vdW') then
        XCfunc(i) = 'VDW'
        do j = 1,i-1
          if (XCfunc(j)=='VDW' .and. XCauth(j)/=XCauth(i)) &
            call die('setXC ERROR: mixing different VDW authors not allowed')
        end do ! j
        call vdw_set_author( XCauth(i) )
      end if ! (XCfunc(i)=='VDW')
     
      if (XCauth(i)(1:6) == "LIBXC-") then
         call process_libxc_spec(XCfunc(i),XCauth(i))
      endif
      
    end do ! i
   
  end subroutine setXC

  !< Sets a single XC functional in family/author style.
  !  It can only be used for built-in functionals and
  !  'XC' libXC functionals
  subroutine setXC_family_authors( family, auth )

    implicit none
    character(len=*),intent(in):: family
    character(len=*),intent(in):: auth

    call setXC(1, [family], [auth], [1.0_dp], [1.0_dp])
  end subroutine setXC_family_authors

#ifdef HAVE_LIBXC
!< Sets the XC info using libxc numerical codes.
!  It can only be used if LibXC support is compiled in
  
  subroutine setXC_libxc_ids( nfuncs, libxc_ids)
#if XC_MAJOR_VERSION >= 4
    use xc_f03_lib_m
#else 
    use xc_f90_types_m
    use xc_f90_lib_m
#endif

    implicit none
    !> number of functionals
    integer, intent(in) :: nfuncs
    !> numerical libxc codes
    integer, intent(in) :: libxc_ids(nfuncs)

    ! automatic arrays
    character(len=11)   :: family(nfuncs), auth(nfuncs)
    real(dp)            :: weight_x(nfuncs), weight_c(nfuncs)
    
#if XC_MAJOR_VERSION >= 4
    type(xc_f03_func_t) :: xc_func
    type(xc_f03_func_info_t) :: xc_info
#else
    type(xc_f90_pointer_t) :: xc_func, xc_info
#endif
    integer :: xc_ispin
    integer :: kind, ifamily
    integer :: i

    do i = 1, nfuncs
       !
       ! Determine the kind of functional to assign weights correctly
       !
       xc_ispin = XC_UNPOLARIZED 
       ! 'unpolarized' is the least stringent option: for non-polarized
       ! functionals, the other option might result in an error
#if XC_MAJOR_VERSION >= 4
       call xc_f03_func_init(xc_func, libxc_ids(i), xc_ispin)
       xc_info = xc_f03_func_get_info(xc_func)
       kind = xc_f03_func_info_get_kind(xc_info)
       ifamily = xc_f03_func_info_get_family(xc_info)
#else
       call xc_f90_func_init(xc_func, xc_info, libxc_ids(i), xc_ispin)
       kind = xc_f90_info_kind(xc_info)
       ifamily = xc_f90_family_from_id(libxc_ids(i))
#endif
       
       select case (kind)
       case (XC_CORRELATION)
          weight_x(i) = 0.0_dp
          weight_c(i) = 1.0_dp
       case (XC_EXCHANGE)
          weight_x(i) = 1.0_dp
          weight_c(i) = 0.0_dp
       case (XC_EXCHANGE_CORRELATION)
          weight_x(i) = 1.0_dp
          weight_c(i) = 1.0_dp
       case default
          call die("Functional kind not supported")
       end select
#if XC_MAJOR_VERSION >= 4
       call xc_f03_func_end(xc_func)
#else
       call xc_f90_func_end(xc_func)
#endif

       select case ( ifamily )
       case (XC_FAMILY_LDA)
          family(i) = "LDA"
       case (XC_FAMILY_GGA)
          family(i) = "GGA"
       case (XC_FAMILY_HYB_GGA)
          family(i) = "GGA"
       ! There is probably a (negative) case for bad id ...
       case (XC_FAMILY_UNKNOWN)
          call die("Bad libxc functional code")
       case default
          family(i) = "other"
       end select
       write(auth(i),"(a,i5.5)") "LIBXC-", libxc_ids(i)
    end do

    if (sum(weight_x(1:nfuncs)) /= 1.0_dp) then
       call die("Wrong exchange weights")
    endif
    if (sum(weight_c(1:nfuncs)) /= 1.0_dp) then
       call die("Wrong correlation weights")
    endif
    
    call setXC(nfuncs, family, auth, weight_x, weight_c)
    
  end subroutine setXC_libxc_ids
# endif /* HAVE_LIBXC */

!< Returns the xc functional(s) information previously set and stored
!  in the module variables.
  
  subroutine getXC( n, func, auth, wx, wc )
    implicit none
    !> Number of functionals
    integer,         optional,intent(out):: n       
    !> Functional name labels
    character(len=*),optional,intent(out):: func(:) 
    !> Functional author labels
    character(len=*),optional,intent(out):: auth(:) 
    !> Functl weights for exchange
    real(dp),        optional,intent(out):: wx(:)   
    !> Functl weights for correlation
    real(dp),        optional,intent(out):: wc(:)   

    integer:: nf
    nf = nXCfunc
    if (present(n)) n = nf
    if (present(func)) then
       if (size(func)>=nf) func(1:nf) = XCfunc(1:nf)
    end if
    if (present(auth)) then
       if (size(auth)>=nf) auth(1:nf) = XCauth(1:nf)
    end if
    if (present(wx)) then
       if (size(wx)  >=nf) wx(1:nf)   = XCweightX(1:nf)
    end if
    if (present(wc)) then
       if (size(wc)  >=nf) wc(1:nf)   = XCweightC(1:nf)
    end if
  end subroutine getXC

#ifndef HAVE_LIBXC               
  subroutine process_libxc_spec(func,auth)
    character(len=*), intent(in)    :: func
    character(len=*), intent(inout) ::  auth

    call die("Libxc not compiled in. Cannot handle " //  &
              trim(func) // " " // trim(auth))
  end subroutine process_libxc_spec
  
#else
  
  subroutine process_libxc_spec(func,auth)

#if XC_MAJOR_VERSION >= 4
    use xc_f03_lib_m
#else
    use xc_f90_types_m
    use xc_f90_lib_m
#endif

    character(len=*), intent(in)    :: func
    character(len=*), intent(inout) ::  auth

    integer :: iostat, xc_id, idx, xc_id_from_symbol
    integer :: family
    character(len=50) :: symbolic_name

    ! Fields are of the form LIBXC-XXXX-SYMBOL
    ! where -SYMBOL is optional if XXXX is a meaningful code
    idx = index(auth(7:),"-")
    if (idx /= 0) then
      ! We have code and symbol fields
      read(auth(7:7+idx-2),iostat=iostat,fmt=*) xc_id
      symbolic_name = auth(7+idx:)
#if XC_MAJOR_VERSION >= 4
      xc_id_from_symbol = xc_f03_functional_get_number(symbolic_name)
#else
      xc_id_from_symbol = xc_f90_functional_get_number(symbolic_name)
#endif
      if (xc_id == 0) then
        ! A zero in the code field signals that we want
        ! to fall back on the symbolic name field 
        if (xc_id_from_symbol < 0) then
          call die("Cannot get xc_id from " // &
              trim(symbolic_name))
        else
          xc_id = xc_id_from_symbol
        endif
      else
        ! Check consistency
        if (xc_id /= xc_id_from_symbol) then
          call die("Conflicting code field for " // &
              trim(symbolic_name))
        endif
      endif
      ! Normalize the internal representation 
      write(auth,"(a,i5.5,'-',a)") &
          "LIBXC-",xc_id, trim(symbolic_name)
    else
      ! Just a code field
      read(auth(7:),iostat=iostat,fmt=*) xc_id
      if (iostat /= 0) call die("Bad libxc code in " &
          // trim(auth))
      ! Normalize the internal representation 
      write(auth,"(a,i5.5)") "LIBXC-",xc_id
    endif

#if XC_MAJOR_VERSION >= 4
    family = xc_f03_family_from_id (xc_id)
#else
    family = xc_f90_family_from_id (xc_id)
#endif

    select case ( family )
    case (XC_FAMILY_LDA)
      if (func /= "LDA") call die("Family mismatch in " // &
          trim(func) // " " // trim(auth))
    case (XC_FAMILY_GGA, XC_FAMILY_HYB_GGA)
      if (func /= "GGA") call die("Family mismatch in " // &
          trim(func) // " " // trim(auth))
    case default
      call die("Unsupported Libxc family or functional")
    end select

  end subroutine process_libxc_spec

#endif
  
end module gridxc_xcmod

#if defined HAVE_CONFIG_H
#include "config.h"
#endif

#ifdef HAVE_LIBXC
#include "xc_version.h"
#endif

MODULE gridxc_atom

  implicit none

  PUBLIC:: atomXC  ! Exchange and correlation of a spherical density

  PRIVATE ! Nothing is declared public beyond this point

CONTAINS

!< Finds total exchange-correlation energy and potential for a
! spherical electron density distribution.
!```  
! This version implements the Local (spin) Density Approximation and
! the Generalized-Gradient-Aproximation with the 'explicit mesh 
! functional' approach of White & Bird, PRB 50, 4954 (1994).
! Gradients are 'defined' by numerical derivatives, using 2*nn+1 mesh
!   points, where nn is a parameter defined below
! Ref: L.C.Balbas et al, PRB 64, 165110 (2001)
! Written by J.M.Soler using algorithms developed by 
!   L.C.Balbas, J.L.Martins and J.M.Soler, Dec.1996
! Van der Waals functional added by J.M.Soler, Jul.2008, as explained in
!   G.Roman-Perez and J.M.Soler, PRL 103, 096102 (2009)
! ************************* INPUT ***********************************
! INTEGER irel         : Relativistic exchange? (0=>no, 1=>yes)
! INTEGER nr           : Number of radial mesh points
! INTEGER maxr         : Physical first dimension of Dens and Vxc
! REAL*8  rmesh(nr)    : Radial mesh points. Must be nr.le.maxr
! INTEGER nSpin        : nSpin=1 => unpolarized; nSpin=2 => polarized
! REAL*8  Dens(maxr,nSpin) : Total (nSpin=1) or spin (nSpin=2) electron
!                            density at mesh points
! ************************* OUTPUT **********************************
! REAL*8  Ex              : Total exchange energy
! REAL*8  Ec              : Total correlation energy
! REAL*8  Dx              : IntegralOf( rho * (eps_x - v_x) )
! REAL*8  Dc              : IntegralOf( rho * (eps_c - v_c) )
! REAL*8  Vxc(maxr,nSpin) : (Spin) exch-corr potential
! ************************ UNITS ************************************
! Distances in atomic units (Bohr).
! Densities in atomic units (electrons/Bohr**3)
! Energy unit depending of parameter Eunit below (currently Rydberg)
!```

subroutine atomXC( irel, nr, maxr, rmesh, nSpin, Dens, Ex, Ec, Dx, Dc, Vxc )

! Module routines
  use gridxc_alloc,   only: alloc_default ! Sets (re)allocation defaults
  use gridxc_alloc,   only: de_alloc      ! Deallocates arrays
  use gridxc_mesh1D,  only: derivative    ! Performs numerical derivative
  use gridxc_sys,     only: die           ! Termination routine
  use gridxc_xcmod,   only: getXC         ! Returns the XC functional to be used
  use gridxc_gga,     only: ggaxc         ! General GGA XC routine
  use gridxc_mesh1D,  only: interpolation=>interpolation_local ! Interpolation routine
  use gridxc_lda,     only: ldaxc         ! General LDA XC routine
!  use gridxc_filter,only: kcPhi         ! Finds planewave cutoff of a radial func.
  use gridxc_radfft,  only: radfft        ! Radial fast Fourier transform
  use gridxc_alloc,   only: re_alloc      ! Reallocates arrays
  use gridxc_mesh1D,  only: set_mesh      ! Sets a one-dimensional mesh
  use gridxc_mesh1D,  only: set_interpolation  ! Sets the interpolation method
  use gridxc_vdwxc, only: vdw_decusp    ! Cusp correction to VDW energy
  use gridxc_vdwxc, only: vdw_localxc   ! Local LDA/GGA xc apropriate for vdW flavour
  use gridxc_vdwxc, only: vdw_get_qmesh ! Returns q-mesh for VDW integrals
  use gridxc_vdwxc, only: vdw_phi       ! Returns VDW functional kernel
  use gridxc_vdwxc, only: vdw_set_kcut  ! Fixes k-cutoff in VDW integrals
  use gridxc_vdwxc, only: vdw_theta     ! Returns VDW theta function

! Module types and variables
  use gridxc_precision, only: dp          ! Double precision real type
  use gridxc_alloc,   only: allocDefaults ! Derived type for allocation defaults
  use gridxc_config, only: myNode => gridxc_myNode

#ifdef DEBUG_XC
!  use gridxc_vdwxc, only: qofrho        ! Returns q(rho,grad_rho)

  use gridxc_debugXC, only: udebug        ! Output file unit for debug info
  use gridxc_debugXC, only: setDebugOutputUnit  ! Sets udebug
#endif /* DEBUG_XC */

#ifdef HAVE_LIBXC
#if XC_MAJOR_VERSION >= 4
    use xc_f03_lib_m
#else
    use xc_f90_types_m
    use xc_f90_lib_m
#endif
#endif /* HAVE_LIBXC */

  implicit none

! Argument types and dimensions
  integer, intent(in) :: irel       ! Relativistic exchange? (0=>no, 1=>yes)
  integer, intent(in) :: maxr       ! First dimension of arrays dens and Vxc
  integer, intent(in) :: nr               ! Number of radial mesh points
  integer, intent(in) :: nSpin            ! Number of spin components
  real(dp),intent(in) :: Dens(maxr,nSpin) ! (spin) Density at mesh points
  real(dp),intent(in) :: rmesh(nr)        ! Radial mesh points
  real(dp),intent(out):: Ex               ! Total exchange energy 
  real(dp),intent(out):: Ec               ! Total correlation energy
  real(dp),intent(out):: Dx               ! IntegralOf(rho*(eps_x-v_x))
  real(dp),intent(out):: Dc               ! IntegralOf(rho*(eps_c-v_c))
  real(dp),intent(out):: Vxc(maxr,nSpin)  ! (spin) xc potential

! Subroutine name
  character(len=*),parameter :: myName = 'atomXC '
  character(len=*),parameter :: errHead = myName//'ERROR: '

! Fix energy unit:  Eunit=1.0 => Hartrees,
!                   Eunit=0.5 => Rydbergs,
!                   Eunit=0.03674903 => eV
  real(dp),  parameter   :: Eunit = 0.5_dp

! Fix order of the numerical derivatives: used radial points = 2*nn+1
  integer, parameter :: nn = 5

! Fix number of points for radial FFTs (VDW only)
  integer, parameter :: nk = 512

! Fix the interpolation method to change to the uniform FFT mesh (VDW only)
  character(len=*),parameter:: interp_method = 'lagrange' !('lagrange'|'spline')

! Fix kin. energy leak to find the planewave cutoff of the radial density (VDW)
!  real(dp), parameter :: EtolKc = 0.003_dp ! Ry

! Fix limits to the planewave cutoff of the radial density (VDW only)
  real(dp), parameter :: kcMin  = 20._dp   ! Bohr^-1
  real(dp), parameter :: kcMax  = 50._dp   ! Bohr^-1
  real(dp), parameter :: Dmin   = 1.e-9_dp ! Min density when estimating kc
  real(dp), parameter :: Dcut   = 1.e-9_dp ! Min density for nonzero Vxc

! Fix the maximum number of functionals to be combined
  integer, parameter :: maxFunc = 10

! Max number of spin components
  integer, parameter :: maxSpin = 4

! Local variables and arrays
  logical :: &
    GGA, GGAfunc, VDW, VDWfunc
  integer :: &
    ik, in, in1, in2, iq, ir, is, ix, jn, ndSpin, nf, nq, nXCfunc
  real(dp) :: & 
    dEcdD(maxSpin), dEcdGD(3,maxSpin), dEcuspdD(maxSpin), &
    dExdD(maxSpin), dExdGD(3,maxSpin), dEdDaux(maxSpin),  &
    dEcuspdGD(3,maxSpin), dVcdD(maxSpin,maxSpin), dVxdD(maxSpin,maxSpin)
  real(dp) :: & 
    dGdm(-nn:nn), d2ydx2, dk, dr, Dtot, &
    Eaux, Ecut, epsC, epsCusp, epsNL, epsX, f1, f2, &  
    k(0:nk), kc, kmax, pi, r(0:nk), rmax, x0, xm, xp, y0, ym, yp, &
    XCweightC(maxFunc), XCweightX(maxFunc)
  character(len=20):: &
    XCauth(maxFunc), XCfunc(maxFunc)

  real(dp), pointer :: &
    D(:,:)=>null(), dGDdD(:,:)=>null(), drdm(:)=>null(), dVol(:)=>null(), &
    GD(:,:,:)=>null()
  real(dp), pointer:: &
    dphidk(:,:)=>null(), dtdgd(:,:,:)=>null(), dtdd(:,:)=>null(), &
    phi(:,:)=>null(), tk(:,:)=>null(), tr(:,:)=>null(), &
    uk(:,:)=>null(), ur(:,:)=>null()
  type(allocDefaults):: &
    prevAllocDefaults
#ifdef DEBUG_XC
!  real(dp):: q, dqdrho, dqdgrho(3)
!  real(dp):: epsCtmp, dEcdDtmp(nSpin), dEcdGDtmp(3,nSpin)
!   integer:: fileUnit
!   logical:: fileOpened
!   character(len=32):: fileName
#endif /* DEBUG_XC */

#ifdef HAVE_LIBXC
#if XC_MAJOR_VERSION >= 4
      type(xc_f03_func_t), allocatable :: xc_func(:)
      type(xc_f03_func_info_t), allocatable :: xc_info(:)
#else
      type(xc_f90_pointer_t), allocatable :: xc_func(:), xc_info(:)
#endif
      logical, allocatable                :: is_libxc(:)
      integer :: xc_ispin, xc_id, iostat
#endif
  
#ifdef DEBUG_XC
  call setDebugOutputUnit(myNode)   ! Initialize udebug variable
#endif /* DEBUG_XC */

! Check dimension of arrays Dens and Vxc
  if (maxr<nr) call die(errHead//'maxr<nr')

! Find number of diagonal spin components
  ndSpin = min( nSpin, 2 )

! Get the functional(s) to be used
  call getXC( nXCfunc, XCfunc, XCauth, XCweightX, XCweightC )

  ! Set GGA and VDW switches
  GGA = .false.
  VDW = .false.
  do nf = 1,nXCfunc
    if ( XCfunc(nf).eq.'VDW' .or. XCfunc(nf).eq.'vdw') then
      VDW = .true.
      GGA = .true.
    else if ( XCfunc(nf).eq.'GGA' .or. XCfunc(nf).eq.'gga') then
      GGA = .true.
    else if ( XCfunc(nf).ne.'LDA' .and. XCfunc(nf).ne.'lda' .and. &
              XCfunc(nf).ne.'LSD' .and. XCfunc(nf).ne.'lsd' ) then
      call die(errHead//'Unknown functional '//XCfunc(nf))
    endif
  enddo ! nf

  ! Set the possible libxc objects to avoid call overhead in grid
#ifdef HAVE_LIBXC
  allocate(is_libxc(nXCfunc))
  is_libxc(:) = .false.
  allocate(xc_func(nXCfunc), xc_info(nXCfunc))
#endif
  
  do nf = 1,nXCfunc
      if ( XCauth(nf)(1:5) == 'LIBXC') then
#ifdef HAVE_LIBXC
      read(XCauth(nf)(7:11),iostat=iostat,fmt=*) xc_id
      if (iostat /= 0) call die("Bad libxc code in " // XCauth(nf))
        IF (nspin == 1) THEN
          xc_ispin = XC_UNPOLARIZED
        ELSE
          xc_ispin = XC_POLARIZED
        ENDIF

#if XC_MAJOR_VERSION >= 4           
        if ((irel == 1) .and. (xc_id == 1)) then
           ! Change LDA_X to LDA_X_REL (532)
           ! This was introduced in libXC v4
           xc_id = 532
        endif
        call xc_f03_func_init(xc_func(nf), xc_id, xc_ispin)
        xc_info(nf) = xc_f03_func_get_info(xc_func(nf))
#else
        call xc_f90_func_init(xc_func(nf), xc_info(nf), xc_id, xc_ispin)
        if ((irel == 1) .and. (xc_id == 1)) then
          ! To set the relativistic flag we need to call this
          ! general function, and include the default 4/3 factor
          ! that gives standard exchange (implicit in the above
          ! initialization call)
           call xc_f90_lda_x_set_par(xc_func(nf), 4.0_dp/3.0_dp,   &
                                    XC_RELATIVISTIC, 0.0_dp)
        endif
#endif
        is_libxc(nf) = .true.
#else
        call die("Libxc not compiled in. Cannot handle "// trim(XCauth(nf)))
#endif /* HAVE_LIBXC */
     endif
  enddo ! nf

! Set routine name for allocations
!  call alloc_default( old=prevAllocDefaults, routine=myName )

! Allocate temporary arrays
  call re_alloc( D,       1,nSpin, 1,nr, myName//'D' )
  call re_alloc( dGDdD,    -nn,nn, 1,nr, myName//'dGDdD' )
  call re_alloc( drdm,             1,nr, myName//'drdm'  )
  call re_alloc( dVol,             1,nr, myName//'dVol'  )
  call re_alloc( GD, 1,3, 1,nSpin, 1,nr, myName//'GD' )

! Find some parameters for the FFT mesh
  pi = 4.0_dp * atan(1.0_dp)
  rmax = rmesh(nr)
  dr = rmax / nk
  kmax = pi / dr
  dk = kmax / nk

! Find density and gradient of density at mesh points
  do ir = 1,nr

    ! Find interval of neighbour points to calculate derivatives
    in1 = max(  1, ir-nn ) - ir
    in2 = min( nr, ir+nn ) - ir

    ! Find weights of numerical derivation, dGdm = d(dF(n)/dn)/dF_m, 
    ! from Lagrange interpolation formula:
    ! F(n) = Sum_m F_m * Prod_{j/=m} (n-j)/(m-j)
    ! dF(n)/dn = Sum_m F_m * Prod_{j/=m,j/=n} (n-j) / Prod_{j/=m} (m-j)
    do in = in1,in2
      if (in==0) then
        dGdm(in) = 0
        do jn = in1,in2
          if (jn/=0) dGdm(in) = dGdm(in) + 1._dp / (0 - jn)
        enddo
      else
        f1 = 1
        f2 = 1
        do jn = in1,in2
          if (jn/=in .and. jn/=0) f1 = f1 * (0  - jn)
          if (jn/=in)             f2 = f2 * (in - jn)
        enddo
        dGdm(in) = f1 / f2
      endif
    enddo

    ! Find dr(m)/dm
    drdm(ir) = 0.0_dp
    do in = in1,in2
      drdm(ir) = drdm(ir) + rmesh(ir+in) * dGdm(in)
    enddo

    ! Find differential of volume. Use trapezoidal integration rule
    dVol(ir) = 4.0_dp * pi * rmesh(ir)**2 * drdm(ir)
    if (ir==1 .or. ir==nr) dVol(ir) = 0.5_dp*dVol(ir)

    ! Find the weights for the derivative d(gradF(n))/d(F(m)), of
    ! the gradient at point n with respect to the value at point m
    ! dGDdD = d((dD(r)/dr)(n)/dD_m = d( (dD(n)/dn) / (dr(n)/dn) ) / dD_m
    !       = d(dD(n)/dn)/dD_m / (dr(n)/dn)
    if (GGA) then
      do in = in1,in2
        dGDdD(in,ir) = dGdm(in) / drdm(ir)
      enddo
    endif

    ! Find density and gradient of density at this point
    do is = 1,nSpin
      D(is,ir) = Dens(ir,is)
    enddo
    if (GGA) then
      do is = 1,nSpin
        GD(1:3,is,ir) = 0.0_dp
        do in = in1,in2
          GD(3,is,ir) = GD(3,is,ir) + dGDdD(in,ir) * Dens(ir+in,is)
        enddo
      enddo
    endif ! GGA

  end do ! ir

! Van der Waals initializations
  if (VDW) then

    ! Allocate VdW arrays
    call vdw_get_qmesh( nq )
    call re_alloc( dtdd,         1,nq, 1,nSpin, myName//'dtdd'  )
    call re_alloc( dtdgd,   1,3, 1,nq, 1,nSpin, myName//'dtdgd' )
    call re_alloc( dphidk, 1,nq, 1,nq,          myName//'dphidk')
    call re_alloc( phi,    1,nq, 1,nq,          myName//'phi'   )
    call re_alloc( tk,     0,nk, 1,nq,          myName//'tk'    )
    call re_alloc( tr,     1,nr, 1,nq,          myName//'tr'    )
    call re_alloc( uk,     0,nk, 1,nq,          myName//'uk'    )
    call re_alloc( ur,     1,nr, 1,nq,          myName//'ur'    )

    ! Find planewave cutoff of density
!    kc = kcPhi( 0, nr, rmesh(:), sum(dens(:,1:ndSpin),2), EtolKc )
!    kc = min( kc, kcmax )
#ifdef DEBUG_XC
!   write(udebug,'(a,f12.6)') myName//'kc =', kc
#endif /* DEBUG_XC */

    ! Estimate the planewave cutoff of the density
    Ecut = 0
    do ir = 2,nr-1
      Dtot = sum(dens(ir,1:ndSpin))
      if (Dtot < Dmin) cycle
      xm = rmesh(ir-1)
      x0 = rmesh(ir)
      xp = rmesh(ir+1)
      ym = rmesh(ir-1)*sum(dens(ir-1,1:ndSpin))
      y0 = rmesh(ir)  *sum(dens(ir  ,1:ndSpin))
      yp = rmesh(ir+1)*sum(dens(ir+1,1:ndSpin))
      d2ydx2 = ( (yp-y0)/(xp-x0) - (y0-ym)/(x0-xm) ) * 2 / (xp-xm)
      Ecut = max( Ecut, abs(d2ydx2/y0) )
    end do ! ir
    kc = sqrt(Ecut)
    kc = max( kc, kcMin )
    kc = min( kc, kcMax )
#ifdef DEBUG_XC
!   write(udebug,'(a,f12.6)') myName//'kc =', kc
#endif /* DEBUG_XC */

    ! Set mesh cutoff to filter VdW kernel
    call vdw_set_kcut( kc )

    ! Find expansion of theta(q(ir))
    do ir = 1,nr
      call vdw_theta( nSpin, D(:,ir), GD(:,:,ir), tr(ir,1:nq), dtdd, dtdgd )
    end do ! ir

    ! Find uniform meshes for FFTs
    forall(ir=0:nk) r(ir) = ir*dr
    forall(ik=0:nk) k(ik) = ik*dk

    ! Find theta_iq(r) in a uniform radial mesh
    call set_interpolation( interp_method )
    call set_mesh( nr, rmesh )  ! 'From' mesh of tr array
    do iq = 1,nq
      tk(0:nk,iq) = interpolation( nk+1, r(0:nk), nr, tr(1:nr,iq) )
    end do

#ifdef DEBUG_XC
!    ! Write density
!    open(1,file='d.out')
!    do ir = 1,nr
!      write(1,'(3f15.9)') rmesh(ir), D(:,ir)
!    end do
!    close(1)
!    ! Write q(rho,grad_rho)
!    open(1,file='q.out')
!    do ir = 1,nr
!      call qofrho( sum(d(:,ir)), sum(gd(:,:,ir),2), q, dqdrho, dqdgrho )
!      write(1,'(3f15.9)') rmesh(ir), q
!    end do
!    close(1)
!    ! Write theta
!    open(1,file='trmesh.out')
!    do ir = 1,nr
!      write(1,'(30f15.9)') rmesh(ir), tr(ir,1:nq)
!    end do
!    close(1)
!    open(1,file='tr.out')
!    do ir = 0,nk
!      write(1,'(30f15.9)') r(ir), tk(ir,1:nq)
!    end do
!    close(1)
#endif /* DEBUG_XC */

    ! Fourier-transform theta_iq(r) for each iq
    do iq = 1,nq
      call radfft( 0, nk, rmax, tk(0:nk,iq), tk(0:nk,iq) )
    end do ! iq

    ! Find u_iq(r) = Sum_iq' Int_dr' phi_iq_iq'(r,r')*theta_iq'(r')
    ! by convolution in reciprocal space
    do ik = 0,nk
      ! Find Fourier transform of VdW kernel phi_iq_iq'(r,r')
      call vdw_phi( k(ik), phi, dphidk )
      ! Find Fourier transform of u_iq(r)
      uk(ik,1:nq) = matmul( tk(ik,1:nq), phi(1:nq,1:nq) )
    end do ! ik

    ! Inverse Fourier transform of u_iq(r) for each iq
    do iq = 1,nq
      call radfft( 0, nk, kmax, uk(0:nk,iq), uk(0:nk,iq) )
    end do ! iq

    ! Find u_iq(r) in the original radial mesh
    call set_mesh( nk+1, xmin=0._dp, xmax=rmax )  ! 'From' mesh of uk array
    do iq = 1,nq
      ur(1:nr,iq) = interpolation( nr, rmesh(1:nr), nk+1, uk(0:nk,iq) )
    end do ! iq

#ifdef DEBUG_XC
!    ! Write u
!    open(1,file='ur.out')
!    do ir = 0,nk
!      write(1,'(30f15.9)') r(ir), uk(ir,1:nq)
!    end do
!    close(1)
!    open(1,file='urmesh.out')
!    do ir = 1,nr
!      write(1,'(30f15.9)') rmesh(ir), ur(ir,1:nq)
!    end do
!    close(1)
#endif /* DEBUG_XC */

  end if ! (VDW)

! Initialize output
  Ex = 0.0_dp
  Ec = 0.0_dp
  Dx = 0.0_dp
  Dc = 0.0_dp
  Vxc(1:nr,1:nSpin) = 0.0_dp

! Loop over mesh points
  do ir = 1,nr

    ! Find interval of neighbour points to calculate derivatives
    in1 = max(  1, ir-nn ) - ir
    in2 = min( nr, ir+nn ) - ir

    ! Loop over exchange-correlation functions
    do nf = 1,nXCfunc
      ! Is this a GGA or VDW?
      if (XCfunc(nf).eq.'VDW' .or. XCfunc(nf).eq.'vdw') then
        VDWfunc = .true.
        GGAfunc = .true.
      else if (XCfunc(nf).eq.'GGA' .or. XCfunc(nf).eq.'gga') then
        VDWfunc = .false.
        GGAfunc = .true.
      else
        VDWfunc = .false.
        GGAfunc = .false.
      endif

      ! Find exchange and correlation energy densities and their 
      ! derivatives with respect to density and density gradient
      if (VDWfunc) then

        ! Local exchange-corr. part from the apropriate LDA/GGA functional
        call vdw_localxc( irel, nSpin, D(:,ir), GD(:,:,ir), epsX, epsC, &
                          dExdD, dEcdD, dExdGD, dEcdGD )

#ifdef DEBUG_XC
!        ! Select only non local correlation energy and potential
!        epsX = 0
!        epsC = 0
!        dExdD = 0
!        dEcdD = 0
!        dExdGD = 0
!        dEcdGD = 0
#endif /* DEBUG_XC */

        ! Local cusp correction to nonlocal VdW energy integral
        call vdw_decusp( nSpin, D(:,ir), GD(:,:,ir), &
                         epsCusp, dEcuspdD, dEcuspdGD )

#ifdef DEBUG_XC
!        ! Select only non local correlation energy and potential
!        epsCusp = 0
!        dEcuspdD = 0
!        dEcuspdGD = 0
#endif /* DEBUG_XC */

        ! Find expansion of theta(q(r)) for VdW
        call vdw_theta( nSpin, D(:,ir), GD(:,:,ir), tr(ir,1:nq), dtdd, dtdgd )

        ! Add nonlocal VdW energy contribution and its derivatives
        Dtot = sum(D(1:ndSpin,ir))
        epsNL = epsCusp + 0.5_dp*sum(ur(ir,1:nq)*tr(ir,1:nq))/(Dtot+tiny(Dtot))
        epsC = epsC + epsNL
        do is = 1,nSpin
          dEcdD(is) = dEcdD(is) + dEcuspdD(is) &
                    + sum(ur(ir,1:nq)*dtdd(1:nq,is))
          do ix = 1,3
            dEcdGD(ix,is) = dEcdGD(ix,is) + dEcuspdGD(ix,is) &
                          + sum(ur(ir,1:nq)*dtdgd(ix,1:nq,is))
          end do ! ix
        end do ! is

      else if (GGAfunc) then

        if ( XCauth(nf) .eq. 'HSE06' .or. &
             XCauth(nf) .eq. 'hse06' .or. &
             XCauth(nf) .eq. 'PBE0' .or. &
             XCauth(nf) .eq. 'pbe0' ) then
          call ggaxc( 'PBE', irel, nSpin, D(:,ir), GD(:,:,ir),    &
                        epsX, epsC, dExdD, dEcdD, dExdGD, dEcdGD  &
#ifdef HAVE_LIBXC
                    , is_libxc(nf), xc_func(nf), xc_info(nf) )
#else
                    )
#endif
        else
          call ggaxc( XCauth(nf), irel, nSpin, D(:,ir), GD(:,:,ir),  &
                      epsX, epsC, dExdD, dEcdD, dExdGD, dEcdGD       &
#ifdef HAVE_LIBXC
                    , is_libxc(nf), xc_func(nf), xc_info(nf) )
#else
                    )
#endif
        endif
                    
#ifdef DEBUG_XC
!        call ldaxc( 'PW92', irel, nSpin, D(:,ir), Eaux, epsC,  &
!                    dEdDaux, dEcdD, dVxdD, dVcdD )
!        call ggaxc( XCauth(nf), irel, nSpin, D(:,ir), GD(:,:,ir),  &
!                    epsX, epsCtmp, dExdD, dEcdDtmp, dExdGD, dEcdGDtmp )
#endif /* DEBUG_XC */
      else
        call ldaxc( XCauth(nf), irel, nSpin, D(:,ir), epsX, epsC, &
                    dExdD, dEcdD, dVxdD, dVcdD                    &
#ifdef HAVE_LIBXC
                    , is_libxc(nf), xc_func(nf), xc_info(nf) )
#else
                    )
#endif
      endif

      ! Scale terms by weights
      epsX = epsX*XCweightX(nf)
      epsC = epsC*XCweightC(nf)
      dExdD(1:nSpin) = dExdD(1:nSpin)*XCweightX(nf)
      dEcdD(1:nSpin) = dEcdD(1:nSpin)*XCweightC(nf)
      if (GGAfunc) then
        dExdGD(1:3,1:nSpin) = dExdGD(1:3,1:nSpin)*XCweightX(nf)
        dEcdGD(1:3,1:nSpin) = dEcdGD(1:3,1:nSpin)*XCweightC(nf)
      endif

      ! Add contributions to exchange-correlation energy and its
      ! derivatives with respect to density at all points
      do is = 1,nSpin
        Ex = Ex + dVol(ir)*D(is,ir)*epsX
        Ec = Ec + dVol(ir)*D(is,ir)*epsC
        Dx = Dx + dVol(ir)*D(is,ir)*(epsX - dExdD(is))
        Dc = Dc + dVol(ir)*D(is,ir)*(epsC - dEcdD(is))
        Vxc(ir,is) = Vxc(ir,is) + dVol(ir)*(dExdD(is) + dEcdD(is))
        if (GGAfunc) then
          do in = in1,in2
            Dx= Dx - dVol(ir)*D(is,ir+in)*dExdGD(3,is)*dGDdD(in,ir)
            Dc= Dc - dVol(ir)*D(is,ir+in)*dEcdGD(3,is)*dGDdD(in,ir)
            Vxc(ir+in,is) = Vxc(ir+in,is) + &
              dVol(ir)*(dExdGD(3,is) + dEcdGD(3,is))*dGDdD(in,ir)
          enddo ! in
        endif ! (GGAfunc)
      enddo ! is

    enddo ! nf

  enddo ! ir

#ifdef HAVE_LIBXC
  do nf = 1,nXCfunc
    if (is_libxc(nf)) then
#if XC_MAJOR_VERSION >= 4
      call xc_f03_func_end(xc_func(nf))
#else
      call xc_f90_func_end(xc_func(nf))
#endif
    endif
  enddo
  deallocate(xc_func,xc_info,is_libxc)
#endif

! Divide by volume element to obtain the potential (per electron)
  do is = 1,nSpin
    ! Avoid ir=1 => r=0 => dVol=0
    Vxc(2:nr,is) = Vxc(2:nr,is) / dVol(2:nr)
    ! Extrapolate to the origin from first two points, requiring dVxc/di=0
    Vxc(1,is) = (4*Vxc(2,is) - Vxc(3,is)) / 3
  enddo ! is

! Make Vxc=0 if VDWfunctl and Dens<Dcut, to avoid singularities
  if (VDW) then
    do ir = 1,nr
      Dtot = sum(Dens(ir,1:ndSpin))
      if (Dtot<Dcut) Vxc(ir,:) = 0
    end do
  end if ! (VDWfunctl)

! Divide by energy unit
  Ex = Ex / Eunit
  Ec = Ec / Eunit
  Dx = Dx / Eunit
  Dc = Dc / Eunit
  Vxc(1:nr,1:nSpin) = Vxc(1:nr,1:nSpin) / Eunit

#ifdef DEBUG_XC
!    ! Write potential
!    open(1,file='v.out')
!    do ir = 1,nr
!      write(1,'(3f15.9)') rmesh(ir), Vxc(ir,1:nSpin)
!    end do
!    close(1)
#endif /* DEBUG_XC */

! Deallocate VDW-related arrays
  if (VDW) then
    call de_alloc( ur,       myName//'ur' )
    call de_alloc( uk,       myName//'uk' )
    call de_alloc( tr,       myName//'tr' )
    call de_alloc( tk,       myName//'tk' )
    call de_alloc( phi,      myName//'phi' )
    call de_alloc( dphidk,   myName//'dphidk' )
    call de_alloc( dtdgd,    myName//'dtdgd' )
    call de_alloc( dtdd,     myName//'dtdd' )
  endif ! (VDW)

! Deallocate temporary arrays
  call de_alloc( GD,    myName//'GD' )
  call de_alloc( dVol,  myName//'dVol' )
  call de_alloc( drdm,  myName//'drdm' )
  call de_alloc( dGDdD, myName//'dGDdD' )
  call de_alloc( D,     myName//'D' )

! Restore previous allocation defaults
!  call alloc_default( restore=prevAllocDefaults )

#ifdef DEBUG_XC
!  fileUnit = 57
!  fileName = 'atomxc.vxc'
!  inquire(file=fileName,opened=fileOpened)
!  if (.not.fileOpened) open(unit=fileUnit,file=fileName)
!  write(fileUnit,*) nr, nSpin
!  do ir = 1,nr
!    write(fileUnit,'(5e15.6)') &
!      rmesh(ir), Dens(ir,1:nSpin), Vxc(ir,1:nSpin)
!  end do
#endif /* DEBUG_XC */

end subroutine atomXC

END MODULE gridxc_atom

#!/bin/bash
#
# Copyright (C) 2015 Y. Pouillon
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation; either version 3 of the License, or 
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
#
#

# Note: this script is temporary and will be removed upon release.

# Set # of procs for make
test -n "${make_nprocs}" || make_nprocs="8"

# Init modules if required
export LMOD_PAGER="none"
type module >/dev/null 2>&1
if test "$?" != "0"; then
  for pfx in /usr /usr/local /opt /opt/local; do
    lmod_init="${pfx}/share/lmod/lmod/init/bash"
    if test -s "${lmod_init}"; then
      . "${lmod_init}"
      break
    fi
  done
fi

# Make LibXC available
export LD_LIBRARY_PATH="${HOME}/esl/install/lib:${LD_LIBRARY_PATH}"
export PATH="${HOME}/esl/install/bin:${PATH}"

# Stop at first error and echo commands
set -ev

# Check that we are in the correct directory
test -s "configure.ac" -a -s "src/atomxc.F90" || exit 0

# Fix permissions
chmod -R u+w .

# Init build parameters
export CC="gcc"
export CFLAGS="-O0 -g3 -ggdb -Wall -Wextra -fbounds-check -fno-inline"
export FC="gfortran"
export FCFLAGS="-O0 -g3 -ggdb -Wall -Wextra -fbounds-check -fno-inline"

# Prepare source tree
./wipeout.sh
./autogen.sh

# Check minimal build
mkdir tmp-minimal
cd tmp-minimal
../configure \
  --disable-debug \
  --disable-multiconfig \
  --disable-single-precision \
  --without-libxc \
  --without-mpi
sleep 3
make dist -j${make_nprocs}
make -j${make_nprocs}
make clean && make -j${make_nprocs}
make check -j${make_nprocs}
mkdir install-test
make install DESTDIR="${PWD}/install-test"
ls -lR install-test >install-test.log
libname_ok=`find install-test/usr/local/lib -name 'libgridxc.*'`
test "${libname_ok}" != ""
modname_ok=`find install-test/usr/local/include -name 'gridxc'`
test "${modname_ok}" != ""
cd ..

# Build with LibXC support
mkdir tmp-libxc
cd tmp-libxc
../configure \
  --disable-debug \
  --with-libxc \
  --without-mpi
sleep 3
make -j${make_nprocs}
make check -j${make_nprocs}
mkdir install-test
make install DESTDIR="${PWD}/install-test"
libname_ok=`find install-test/usr/local/lib -name 'libgridxc.*'`
modname_ok=`find install-test/usr/local/include -name 'gridxc'`
test "${libname_ok}" != ""
cd ..

# Build with debugging features
mkdir tmp-debug
cd tmp-debug
../configure \
  --enable-debug \
  --disable-single-precision \
  --with-libxc \
  --without-mpi
sleep 3
make -j${make_nprocs}
make check -j${make_nprocs}
mkdir install-test
make install DESTDIR="${PWD}/install-test"
libname_ok=`find install-test/usr/local/lib -name 'libgridxc.*'`
test "${libname_ok}" != ""
cd ..

# Build with single precision
# FIXME: fails to build because of interface mismatch in fft3d.F90
#mkdir tmp-single
#cd tmp-single
#../configure \
#  --enable-debug \
#  --enable-single-precision \
#  --with-libxc \
#  --without-mpi
#sleep 3
#make -j${make_nprocs}
#make check -j${make_nprocs}
#mkdir install-test
#make install DESTDIR="${PWD}/install-test"
#libname_ok=`find install-test/usr/local/lib -name 'libgridxc.*'`
#test "${libname_ok}" != ""
#cd ..

# Build with MPI support
export CC="mpicc"
export FC="mpifort"
export F77="mpifort"
mkdir tmp-mpi
cd tmp-mpi
../configure \
  --disable-debug \
  --with-libxc \
  --with-mpi
sleep 3
make -j${make_nprocs}
make check -j${make_nprocs}
mkdir install-test
make install DESTDIR="${PWD}/install-test"
libname_ok=`find install-test/usr/local/lib -name 'libgridxc.*'`
test "${libname_ok}" != ""
cd ..

# Check the use of --enable-multiconfig
mkdir tmp-multiconfig
cd tmp-multiconfig
../configure \
  --disable-debug \
  --enable-multiconfig \
  --with-libxc \
  --with-mpi
sleep 3
make -j${make_nprocs}
make check -j${make_nprocs}
mkdir install-test
make install DESTDIR="${PWD}/install-test"
libname_ok=`find install-test/usr/local/lib -name 'libgridxc_dp_mpi.*'`
modname_ok=`find install-test/usr/local/include -name 'gridxc_dp_mpi'`
test "${libname_ok}" != ""
test "${modname_ok}" != ""
cd ..

# Make distcheck
mkdir tmp-distcheck
cd tmp-distcheck
../configure
sleep 3
make distcheck -j${make_nprocs}
make distcleancheck
cd ..

# Clean-up the mess
rm -rf tmp-minimal tmp-libxc tmp-single tmp-debug tmp-mpi tmp-multiconfig tmp-distcheck

#!/bin/sh
#
# This script harnesses the standard libGridXC makefile to build an
# alternative hierarchy of the form (Note simplified version 2021)
#
#                PREFIX/
#                      gridxc.mk
#                      libxc.mk
#                      serial/
#                            lib/
#                            include/
#                      mpi/
#                            lib/
#                            include/
#
# The 'mpi' section is optional, depending on the command issued.
#
# Usage:
#
# WITH_LIBXC=X  WITH_MPI=Y PREFIX=Z sh build.sh
#
# If Y is empty, only the 'serial' section is built, otherwise both
# 'serial' and 'mpi' sections are created. If X is non-empty, libXC
# support is compiled in. Note that there are no extra sections
# devoted to libXC/MPI combinations yet. The user should use separate
# top-levels for this.
#
# If PREFIX is empty, the hierarchy is rooted in the current directory.
# 
# The top-level gridxc.mk has special logic to dispatch the
# appropriate variables depending on the setting of WITH_MPI in client
# makefiles.
#
# Set to "." if empty or unset
inPREFIX=${PREFIX:-.}
#
mkdir -p ${inPREFIX}
#
if [ "${WITH_LIBXC}" != "" ]
then

    #   Install copy of libxc.mk file at the top
    #   and define LIBXC_MK symbol for makefile
    #
    libxc_major_version=$(grep XC_MAJOR_VERSION ${LIBXC_ROOT}/include/xc_version.h | awk '{print $NF}')
    if test ${libxc_major_version} -ge 4
    then
	LIBXC_MK=libxc.mk
	cp -p libxc.mk ${inPREFIX}/libxc.mk
    else
	LIBXC_MK=libxc-pre4.mk
	cp -p libxc-pre4.mk ${inPREFIX}/libxc.mk
    fi
fi

# Build first without MPI
#
echo "==> make LIBXC_MK=${LIBXC_MK} WITH_LIBXC=${WITH_LIBXC} WITH_MPI= PREFIX=${inPREFIX}/serial"
sleep 1
make clean
make LIBXC_MK=${LIBXC_MK} WITH_LIBXC=${WITH_LIBXC} WITH_MPI= PREFIX=${inPREFIX}/serial
#
# Install the top-level gridxc.mk
#
if [ "${WITH_LIBXC}" != "" ]
then
    sed 's/GRIDXC_USES_LIBXC=0/GRIDXC_USES_LIBXC=1/g' top.gridxc.mk.in \
	                    > ${inPREFIX}/gridxc.mk

else
    cp -p top.gridxc.mk.in ${inPREFIX}/gridxc.mk
fi
#
# Build with MPI if requested
#
if [ "${WITH_MPI}" != "" ]
then
   echo "==> make LIBXC_MK=${LIBXC_MK} WITH_LIBXC=${WITH_LIBXC} WITH_MPI=1 PREFIX=${inPREFIX}/mpi"
   sleep 1
   make clean
   make LIBXC_MK=${LIBXC_MK} WITH_LIBXC=${WITH_LIBXC} WITH_MPI=1 PREFIX=${inPREFIX}/mpi
#
# Install the top-level gridxc.mk
#
   if [ "${WITH_LIBXC}" != "" ]
   then
       sed 's/GRIDXC_USES_LIBXC=0/GRIDXC_USES_LIBXC=1/g' top.gridxc.mk.in | \
	   sed 's/GRIDXC_USES_MPI=0/GRIDXC_USES_MPI=1/g'  > ${inPREFIX}/gridxc.mk
   else
       sed 's/GRIDXC_USES_MPI=0/GRIDXC_USES_MPI=1/g' top.gridxc.mk.in \
	                         > ${inPREFIX}/gridxc.mk
   fi
fi
#

#!/bin/bash

## Copyright (C) 2010-2019 Yann Pouillon
##
## This file is part of the LibGridXC software package. For license information,
## please see the COPYING file in the top-level directory of the source
## distribution.

#
# IMPORTANT NOTE:
#
#   For maintainer use only!
#
#   PLEASE DO NOT EDIT THIS FILE, AS IT COULD CAUSE A SERIOUS LOSS OF DATA.
#   *** YOU HAVE BEEN WARNED! ***
#

# Check that we are in the right directory
if test ! -s "./configure.ac" -o ! -s "src/atomxc.F90"; then
  echo "wipeout: Cowardly refusing to remove something from here!"
  exit 1
fi

# Fix permissions
chmod -R u+w .

# Remove temporary directories and files
echo "Removing temporary directories and files..."
rm -rf tmp*
find . -depth -name 'tmp-*' -exec rm -rf {} \;
find src -name '*.~[0-9]~' -exec rm -f {} \;
find docs -name '*~' -exec rm -f {} \;
echo "done."

# Remove autotools files
echo "Removing autotools files..."
find src -depth -name '.deps' -exec rm -rf {} \;
find src -depth -name '.libs' -exec rm -rf {} \;
find . -name '*.pc' -exec rm {} \;
rm -f core config.log config.status stamp-h1 config.h config.h.in*
rm -rf aclocal.m4 autom4te.cache configure confstat*
(test -d config/data && cd config/data && rm -f gridxc.mk libgridxc-config.yml libgridxc.pc libxc.mk)
(test -d config/gnu && cd config/gnu && rm -f compile config.guess config.sub depcomp install-sh ltmain.sh missing test-driver)
(test -d config/m4 && cd config/m4 && rm -f libtool.m4 ltoptions.m4 ltsugar.m4 ltversion.m4 lt~obsolete.m4)
echo "done."

# Remove Makefiles and machine-generated files
echo "Removing generated makefiles and libtool scripts..."
rm -f libtool
find . -name Makefile -exec rm {} \;
find . -name Makefile.in -exec rm {} \;
echo "done."

# Remove object files, libraries and programs
echo "Removing object files, libraries and programs..."
for subdir in Testers src; do
  find "${subdir}" -name '*.a' -o -name '*.o' -exec rm {} \;
  find "${subdir}" -name '*.la' -o -name '*.lo' -exec rm {} \;
  find "${subdir}" -name '*.mod' -exec rm {} \;
  find "${subdir}" -name '*.x' -exec rm {} \;
done
echo "done."

# Remove script-generated documentation
echo "Removing script-generated documentation..."
rm -rf doc/developers/latex doc/developers/source
echo "done."

# Remove test-related files
echo "Removing files produced by the test suite..."
for prog in test1 test2 test3 test4 test5 test6 test_libxc test_libxc2 test_match; do
  (cd Testers && rm -f ${prog} ${prog}.Vxc ${prog}.log ${prog}.trs)
done
(cd Testers && rm -rf .libs test-suite.log vdw_kernel.table)
echo "done."

# Remove distribution files
echo "Removing distribution files..."
rm -rf libgridxc-[0-9].[0-9].[0-9]*
echo "done."

#!/bin/sh

# Helper script to install the full range of flavors of libgridxc (assuming libxc functionality).
# It uses the '--enable-multiconfig' feature to tag the different flavors appropriately in the
# installation directory.

# These variables should be defined, either through environmental variables or as script arguments.

#GRIDXC_PREFIX=/tmp/GXC_MULTI

#CC=gcc
#FC=gfortran
#MPIFC=mpif90
#MPICC=mpicc

#LIBXC_ROOT  # Installation location of libxc.
#MPI_ROOT    # Installation location of the mpi framework.
if test "x$MPI_ROOT" != "x" ; then
    _config_mpi="--with-mpi=$MPI_ROOT"
else
    _config_mpi="--with-mpi"
fi

# Default options
_with_mpi=1
if test "x$MPIFC" = "x" ; then
    echo "Will not build MPI variants!"
    _with_mpi=0
fi

# Now parse options from user
while test $# -gt 0 ; do
    opt=$1 ; shift
    case $opt in
	--prefix|-p)
	    GRIDXC_PREFIX=$1 ; shift
	    ;;
	--libxc-root)
	    LIBXC_ROOT=$1 ; shift
	    ;;
	--with-mpi)
	    _with_mpi=1
	    ;;
	--without-mpi)
	    _with_mpi=0
	    ;;
	--help|-h)
	    echo " $0 --help shows this message"
	    echo ""
	    echo "These options are available:"
	    echo ""
	    echo "  --prefix|-p <>: specify the installation directory of libgridxc"
	    echo "  --libxc-root <>: specify directory where libxc is installed (default: $LIBXC_ROOT)"
	    echo "  --with-mpi: force MPI builds, requires MPIFC and MPICC are set"
	    echo "  --without-mpi: do not build MPI libraries"
	    echo "  --help|-h: show this help"
	    echo ""
	    exit 0
	    ;;
    esac
done


if [ "x$GRIDXC_PREFIX" = "x" ]; then
    echo "You have not specified an installation directory (GRIDXC_PREFIX)"
    echo "Please provide an installation directory:"
    echo "  GRIDXC_PREFIX=<directory> $0"
    echo "or"
    echo "  $0 --prefix <directory>"
    exit 2
fi

if [ "x$LIBXC_ROOT" = "x" ]; then
    echo "You have not specified a libxc installation directory (LIBXC_ROOT)"
    echo "Please provide a directory of a previous libxc installation directory:"
    echo "  LIBXC_ROOT=<directory> $0"
    echo "or"
    echo "  $0 --libxc-root <directory>"
    exit 3
fi


# ensure libtool does not grab a wrong env-var
unset F77
unset F90

##########
# Double #
#   MPI  #
##########
if test $_with_mpi -eq 1 ; then
    rm -rf build_dp_mpi; mkdir build_dp_mpi; cd build_dp_mpi
    FC=$MPIFC CC=$MPICC ../configure --enable-multiconfig $_config_mpi --with-libxc=${LIBXC_ROOT} --prefix=${GRIDXC_PREFIX}
    test $? -ne 0 && exit 1
    make
    test $? -ne 0 && exit 1
    make check > gridxc_dp_mpi.check
    test $? -ne 0 && exit 1
    make install
    test $? -ne 0 && exit 1
    mv gridxc_dp_mpi.check $GRIDXC_PREFIX/
    cd ..
fi

##########
# Double #
##########
rm -rf build_dp; mkdir build_dp; cd build_dp
../configure --enable-multiconfig --without-mpi --with-libxc=${LIBXC_ROOT} --prefix=${GRIDXC_PREFIX}
test $? -ne 0 && exit 1
make
test $? -ne 0 && exit 1
make check > gridxc_dp.check
test $? -ne 0 && exit 1
make install
test $? -ne 0 && exit 1
mv gridxc_dp.check $GRIDXC_PREFIX/
cd ..

##########
# Single #
#   MPI  #
##########
if test $_with_mpi -eq 1 ; then
    rm -rf build_sp_mpi; mkdir build_sp_mpi; cd build_sp_mpi
    FC=$MPIFC CC=$MPICC ../configure --enable-multiconfig $_config_mpi --enable-single-precision --with-libxc=${LIBXC_ROOT} --prefix=${GRIDXC_PREFIX}
    test $? -ne 0 && exit 1
    make
    test $? -ne 0 && exit 1
    make check > gridxc_sp_mpi.check
    test $? -ne 0 && exit 1
    make install
    test $? -ne 0 && exit 1
    mv gridxc_sp_mpi.check $GRIDXC_PREFIX/
    cd ..
fi

##########
# Single #
##########
rm -rf build_sp ; mkdir build_sp; cd build_sp
../configure --enable-multiconfig --without-mpi --enable-single-precision --with-libxc=${LIBXC_ROOT} --prefix=${GRIDXC_PREFIX}
test $? -ne 0 && exit 1
make
test $? -ne 0 && exit 1
make check > gridxc_sp.check
test $? -ne 0 && exit 1
make install
test $? -ne 0 && exit 1
mv gridxc_sp.check $GRIDXC_PREFIX/
cd ..

#!/bin/sh
#
##set -x
#
# Get absolute path of this script, as that will be the Src directory to use
# as reference when copying files.
# 
#
srcdir=$(
cd -P -- "$(dirname -- "$0")" &&
pwd -P
)
# The above construct is more robust than:  srcdir=$(dirname $0)
# (It will work if $0 is "../Src", since we want an *absolute* path
#
# Get also the absolute path of the object directory
#
objdir=$(
cd -P -- "$(pwd)" &&
pwd -P
)
#
destdir=$objdir
#
# Copy test material
#
(cd $srcdir; cd .. ; cp -rp Testers ${destdir} )
#
# Copy and change name of makefiles. The '.alt' suffix was used to avoid
# clashes with the auto-tools automatically-generated files.
#
(
 cp $srcdir/makefile.alt $destdir/makefile
 cd $destdir/Testers; mv makefile.alt makefile
)
#
# Copy other needed top-level files
#
cp -p $srcdir/build.sh ${destdir}
cp -p $srcdir/libxc.mk ${destdir}
cp -p $srcdir/libxc-pre4.mk ${destdir}
cp -p $srcdir/top.gridxc.mk.in ${destdir}
#
# Set the appropiate variables in the build makefile
#
sed "s#VPATH=\.#VPATH=${srcdir}#g" ${srcdir}/makefile.alt | \
sed "s#MAIN_OBJDIR=\.#MAIN_OBJDIR=${objdir}#g" > ${destdir}/makefile

#
echo " *** Compilation setup done. "

#!/bin/bash

## Copyright (C) 2017-2019 Yann Pouillon

# This file is part of the LibGridXC software package. For license information,
# please see the COPYING file in the top-level directory of the source
# distribution.
#

# Stop at first error encountered
set -e

# Check that we are in the right directory
if test ! -s "./configure.ac" -o ! -s "src/atomxc.F90"; then
  echo "This is not a LibGridXC source tree - aborting now"
  exit 1
fi

# Create possibly missing directories
mkdir -p config/gnu config/m4

# Generate libtool scripts
echo "Generating libtool scripts..."
libtoolize --automake --copy --force
echo "done."

# Generate M4 includes
echo "Generating aclocal.m4..."
aclocal -I config/m4
echo "done."

# Generate configure auxiliary files
echo "Generating config.h.in..."
autoheader
echo "done."

# Generate configure
echo "Generating configure script..."
autoconf
echo "done."

# Generate makefile inputs
# Do not use "automake --force-missing", as it overwrites the INSTALL file.
echo "Generating Makefile.in for each directory..."
automake --add-missing --copy
echo "done."

title: Overview

The libGridXC library started life as SiestaXC, a collection of
modules within Siesta to compute the exchange-correlation energy and
potential in DFT calculations for atomic and periodic systems. The
''grid'' part of the name refers to the discretization for charge
density and potential used in those calculations. The original code
included a set of low-level routines to compute \(\epsilon_{xc}({\bf
r})\) and \(V_{xc}({\bf r})\) at a point for LDA and GGA functionals
(i.e., a subset of the functionality now offered by LibXC), and two
high-level routines to handle the computations in the whole domain,
with radial or 3D-periodic grids), including any needed computations
of gradients, integrations, etc.

In addition, SiestaXC pioneered the implementation of efficient and
practical algorithms for support of van der Waals functionals, which
are typically the sum of three pieces: an exchange energy from a
suitable GGA functional, an LDA correlation energy, and a non-local
correlation term

$$\begin{align}
E_{\mathrm{xc}}[n] = E_{\mathrm x}^{\mathrm{GGA}}[n] + E_{\mathrm
c}^{\mathrm{LDA}}[n] + E_{\mathrm{c}}^{\mathrm{nl}}[n].
\end{align}
$$

The last term is a double integral over a kernel function
\(\phi(\mathbf r, \mathbf r')\):

$$
\begin{align}
E_{\mathrm{c}}^{\mathrm{nl}}[n] = \frac12 \iint
n(\mathbf r) \phi(\mathbf r, \mathbf r') n(\mathbf r') \, \mathrm d
\mathbf r \, \mathrm d \mathbf r'.
\end{align}
$$

whose computation was made affordable by the techniques described in
[the work by Roman-Perez and Soler](https://link.aps.org/doi/10.1103/PhysRevLett.103.096102).

The current libGridXC retains most of the SiestaXC functionality, and
enhances it by offering an interface to [LibXC](https://www.tddft.org/programs/libxc/)
that supports a much wider selection of XC functionals. The code has been streamlined and
re-packaged into a proper stand-alone library, with an automatic
build-system.

title: libGridXC User Guide

The library provides, in essence:

*  Routines to select the [functionals](02_api/functionals.html) to use.
*  Workhorse routines to compute the XC energies and potentials.
   See the [API description](02_api/index.html) for reference.

The library is written in modern Fortran. 

A typical serial program call is:

```fortran
  use precision, only : dp

  use gridxc, only: grid_p
  use gridxc,     only: gridxc_setXC_family_authors, gridxc_cellxc

  integer  :: nMesh(3), nSpin
  real(dp) :: cell(3,3), Dc, Dx, Ec, Ex, stress(3,3), 
  real(grid_p),allocatable :: dens(:,:,:,:), Vxc(:,:,:,:)
  
!    Find nSpin, cell(:,:), and nMesh(:)
  allocate( dens(nMesh(1),nMesh(2),nMesh(3),nSpin), &
             Vxc(nMesh(1),nMesh(2),nMesh(3),nSpin)) )

!    Find dens(:,:,:,:) at all mesh points
  call gridxc_setXC_family_authors( 1, 'GGA', 'PBE' )
  call gridxc_cellXC( 0, cell, nMesh, 1,nMesh(1), 1,nMesh(2), 1,nMesh(3), &
               nSpin, dens, Ex, Ex, Dx, Dc, stress, Vxc )
```

A typical parallel program call is:

```fortran
  use precision, only : dp

  use gridxc, only: grid_p
  use gridxc,     only: gridxc_setXC_family_authors, gridxc_cellxc
  
  integer  :: iSpin, myBox(2,3), nMesh(3), nSpin
  real(dp) :: cell(3,3), Dc, Dx, Ec, Ex, stress(3,3), 
  real(grid_p),allocatable :: dens(:,:,:,:), Vxc(:,:,:,:)

!    Find nSpin, cell(:,:), nMesh(:), and myBox(:,:)

 allocate( dens(myBox(1,1):myBox(2,1),        &
                 myBox(1,2):myBox(2,2),        &
                 myBox(1,3):myBox(2,3),nSpin), &
             Vxc(myBox(1,1):myBox(2,1),        &
                 myBox(1,2):myBox(2,2),        &
                 myBox(1,3):myBox(2,3),nSpin) )
  do i3 = myBox(1,3),myBox(2,3)
  do i2 = myBox(1,2),myBox(2,2)
  do i1 = myBox(1,1),myBox(2,1)
    do iSpin = 1,nSpin
      dens(i1,i2,i3,iSpin) =    !  (spin)density at point (i1,i2,i3)
    end do
  end do
  end do
  end do
  call gridxc_setXC_family_authors( 1, 'GGA', 'PBE' )
  call gridxc_cellXC( 0, cell, nMesh, myBox(1,1), myBox(2,1), &
                               myBox(1,2), myBox(2,2), &
                               myBox(1,3), myBox(2,3), &
               nSpin, dens, Ex, Ex, Dx, Dc, stress, Vxc )
```

For the radial grid interface, a typical call sequence is:

```fortran
   use ...
   integer  :: nr, nSpin
   real(dp) :: Dc, Dx, Ec, Ex
   real(dp),allocatable :: dens(:,:), rMesh(:,:), Vxc(:,:)
   
   !  (Find nr and nSpin)
   allocate( dens(nr,nSpin), rMesh(nr), Vxc(nr,nSpin) )

   ! (Find rMesh(:) and dens(:,:) at all mesh points)
   call gridxc_setXC_family_authors( 1, 'GGA', 'PBE' )
   call gridxc_atomXC( 0, nr, nr, rmesh, nSpin, Dens, Ex, Ec, Dx, Dc, Vxc )
```

title: libGridXC API

[TOC]

Access to the library's functionality is provided by importing the [[gridxc(module)]] module:

```
use gridxc
```

which exports the interfaces to the public user-level routines and other symbols.

@note most routines and symbols
are **prefixed** by `gridxc` for export, whereas internally the `gridxc` prefix is not currently used. This means that
this API reference will have cross-references to routine names without the prefix.
@endnote

## Exported types and parameters

The library exports the kind parameter `grid_p` appropriate for the
arrays passed to a from the [[cellxc(proc)]] routine. This is
controlled by the setting of the `--enable-single-precision` configure
option (by default, a double-precision kind is returned).

## Initialization routine

It is necessary to call the [[gridxc_init(proc)]] routine before any other operations. Currently, this routine just
sets a few internal variables. If working in parallel, the MPI communicator is passed in this call.

## Selection of XC functionals

* The routine [[setxc(proc)]] and its simpler variants [[setxc_libxc_ids(proc)]] and [[setxc_family_authors(proc)]] select the
functionals to use.   The available functionals and the syntax for their
specification are discussed in the [Guide to functionals](./functionals.html).
This information is currently stored in global
module variables, and can be retrieved with the [[getXC(proc)]] routine.

## Main routines

### Atomic (spherical) grids

* Routine [[atomxc(proc)]] computes the exchange-correlation energies and potential for a spherical charge density, as given
  in a radial grid.

### Box (periodical) grids

* Routine [[cellxc(proc)]] is the major workhorse of the library. It
  computes the exchange-correlation energies and potential for a
  periodical charge density, represented in a (possibly distributed in parallel) parallepipedic grid.

## Other exported functionality

(See the source for full documentation)

### Setter routines for allocation, timing, and error reporting event handlers

* gridxc_set_error_handler
* gridxc_set_timer_start_handler
* gridxc_set_timer_stop_handler
* gridxc_set_alloc_event_handler
* gridxc_set_alloc_error_handler

### Convenience utilities

A few routines are exported for convenience to some user programs:

* nfft_gridxc: When VDW functionals are used, the library employs internally FFT routines that need the mesh sizes to be multiples of 2, 3, or 5. This routine (see the source) will help to determine the appropriate values.

* setmeshdistr/meshBox: These routines can be used to select an appropriate data distribution in parallel. See the source for more information. These are in the process of refactoring to make them truly stand-alone.

### Lower level entry points

* gridxc_ldaxc
* gridxc_ggaxc

---
project: libGridXC
summary: Library to compute exchange-correlation energies and potentials
author: Jose Soler, Alberto Garcia
project_dir: src
page_dir: docs/pages
output_dir: /tmp/gridxc-docs
exclude: alloc.F90
         am05.F90
         array.F90
         bessph.F90
	 build.sh
         cellsubs.F90
         chkgmx.F90
	 config.sh
         debugxc.F90
         fft3d.F90
         fftr.F90
         ggaxc.F90
         gpfa_core.F
         interpolation.f90
         ldaxc.F90
         gridxc_fft_gpfa.F
         m_io.F90
         m_walltime.f90
         mesh1d.f90
         mesh3d.F90
         minvec.F90
         moreParallelSubs.F90
         precision.F90
         radfft.F90
         setgpfa.f
         sorting.F90
         sys.F90
         vdwxc.F90
         vv_vdwxc.F90
preprocessor: gfortran -E -P
preprocess: true
macro: HAVE_LIBXC
       HAVE_MPI
project_website: http://gitlab.com/siesta-project/libraries/libgridxc
email: albertog@icmab.es
extensions: f90
            F90
docmark: +	    
docmark_alt: *
predocmark: >
predocmark_alt: <
media_dir: ./media
source: false
graph: false
search: false
license: bsd
display: public
	 protected
extra_filetypes: sh #
md_extensions: markdown.extensions.toc
---

The library provides an API for computing the XC energies and
potentials for radial and box grids.

For more information, check out the [Overview](./page/index.html).

title: Guide to functionals

The library provides a collection of built-in functionals, coded by
J.M. Soler and C. Balbás, and an interface to the [LibXC](https://www.tddft.org/programs/libxc/) library for a
wider selection of semi-local (LDA and GGA) functionals. Support for
the MGGA functionals in LibXC is being implemented.

## Built-in functionals

The built-in functionals are classified by `family` (LDA (or LSD), GGA, VDW) and `authors`:

### LDA/LSD

```
     'CA' or 'PZ' => LSD Perdew & Zunger, PRB 23, 5075 (1981)
           'PW92' => LSD Perdew & Wang, PRB, 45, 13244 (1992)
```

### GGA

```
           'PW91' => GGA Perdew & Wang, JCP, 100, 1290 (1994) 
            'PBE' => GGA Perdew, Burke & Ernzerhof, PRL 77, 3865 (1996)
           'RPBE' => GGA Hammer, Hansen & Norskov, PRB 59, 7413 (1999)
         'revPBE' => GGA Zhang & Yang, PRL 80,890(1998)
            'LYP' => GGA Becke-Lee-Yang-Parr (see subroutine blypxc)
             'WC' => GGA Wu-Cohen (see subroutine wcxc)
         'PBESOL' => GGA Perdew et al, PRL, 100, 136406 (2008)
           'AM05' => GGA Mattsson & Armiento, PRB, 79, 155101 (2009)
      'PBEJsJrLO' => GGA Reparametrizations of the PBE functional by
     'PBEJsJrHEG' => GGA   L.S.Pedroza et al, PRB 79, 201106 (2009) and
      'PBEGcGxLO' => GGA   M.M.Odashima et al, JCTC 5, 798 (2009)
     'PBEGcGxHEG' => GGA using 4 different combinations of criteria
```

### (HYB) GGA

These are the semi-local components used in some exact-exchange calculations:

```
           'HSE6' => (Heyd–Scuseria–Ernzerhof) J. of Chemical Physics 120, 16 (2004) 
           'PBE0' => J. Chem. Phys. 110, 6158 (1999)
	             https://doi.org/10.1063/1.478522
```

### VDW

```
          'DRSLL' => VDW Dion et al, PRL 92, 246401 (2004)
          'LMKLL' => VDW K.Lee et al, PRB 82, 081101 (2010)
            'KBM' => VDW optB88-vdW of J.Klimes et al, JPCM 22, 022201 (2010)
            'C09' => VDW V.R. Cooper, PRB 81, 161104 (2010)
             'BH' => VDW K. Berland and Per Hyldgaard, PRB 89, 035412 (2014)
             'VV' => VDW Vydrov-VanVoorhis, JCP 133, 244103 (2010)
```

To access these functionals, one can simply call the [[setxc_family_authors(proc)]] routine:
```
  call setxc_family_authors('GGA', 'PBE')
```

The library offers also an expanded version of this routine that is
able to describe *cocktail mixings* of functionals, each with its
appropriate weight. For example,

```
   call setXC( 2, (/'GGA','GGA'/), (/'PBE','WC'/), (/1.0_dp, 0.0_dp/), (/0.75_dp,0.25_dp/) )
```
will use a cocktail of PBE and WC in which the exchange part is 100% PBE, and the correlation part is 75% PBE and 25% WC.



## LibXC interface

In [LibXC](https://www.tddft.org/programs/libxc/functionals), most
functionals are split by exchange and correlation parts. For example,
there are separate functionals for the exchange and corrrelation parts
of PBE, respectively XC_GGA_X_PBE (id 101) and XC_GGA_C_PBE (id
130). The *id* or functional number, while not human friendly, is the
recommended way of identification for full compatibility.

To tell libGridXC that a PBE functional from LibXC is desired, we can use the call:

```
  call setXC_libxc_ids ( 2, (/ 101, 130 /) )
```

Note that this combination of exchange and correlation parts can be seen as a special kind of *cocktail mixing*. Hence
the same result could be obtained by the call:

```
   call setXC( 2, (/'GGA','GGA'/), (/'LIBXC-101','LIBXC-130'/), (/1.0_dp, 0.0_dp/), (/0.0_dp,1.0_dp/) )
```

where the "author" field is a special string of the form
`LIBXC-XXXX-SYMBOL` where `-SYMBOL` is optional if `XXXX` is a valid
libXC functional id. Accepted symbols are those for which the
`functional_get_number` routines of LibXC return a valid functional
id, and are of the form `FAMILY_TYPE_NAME` (for example, `GGA_X_PBE`
-- see the complete list in the `xc_funcs.h` file generated at the
time of compilation of libXC, noting that the initial `XC_` has to be
removed). If the LibXC id is not known, it can be set to 0 and leave
the specification to the symbolic part. For example, the following
forms are equivalent:

```
LIBXC-101
LIBXC-0101
LIBXC-0-GGA_X_PBE
LIBXC-101-GGA_X_PBE
```

This form is more cumbersome, but it can be generalized if desired to extra
mixings (even with non-libxc functionals).


A handful of LibXC functionals are "exchange-correlation". For them, the specification can simply be, for example
(XC_LDA_XC_TETER93 functional, id=20):

```
  call setXC_libxc_ids ( 1, (/ 20 /) )
```

title: Installation

## Pre-requisites

* The [LibXC library](https://gitlab.com/libxc/libxc/-/tags) (optional but strongly recommended).
  Versions 3.X, 4.X, and 5.X of libxc are supported.

## Installation of libGridXC with autotools

Assuming that LibXC is installed in `${LIBXC_ROOT}` and that the
MPI-extended Fortran and C compilers are given by MPIFC and MPICC,
respectively, the following sequences of commands will install appropriate flavors of libGridXC in the
`${GRIDXC_ROOT}` installation directory:

### Serial version

```
    ./configure --with-libxc=${LIBXC_ROOT}  --prefix=${GRIDXC_ROOT}
    make
    make check
    make install
```

### MPI version

```
    FC=$MPIFC CC=$MPICC ../configure --with-mpi=${MPI_ROOT} --with-libxc=${LIBXC_ROOT}  --prefix=${GRIDXC_ROOT}
    make
    make check
    make install
```

### Single-precision version

This affects only the arrays handled by `gridxc_cellxc`. The spherical-grid interface always works in double-precision.

```
    ../configure  --enable-single-precision --with-libxc=${LIBXC_ROOT}  --prefix=${GRIDXC_ROOT}
    make
    make check
    make install
```

The above buildings will result in installation directories with the following structure:

```
${GRIDXC_ROOT}:
├── include
│   └── gridxc
│       ├── debugxc.mod
        .... (other .mod files)
│       └── xcmod.mod
├── lib
        ...
│   ├── libgridxc.a
        ...
```

so that to have different versions installed at the same time one
would have to specify different names (e.g., gridxc, gridxc-mpi,
gridxc-sp, gridxc-sp-mpi, etc) for the installation directory. An
alternative, more compact way, is presented in the next section.

### Multi-configuration installation

Using the `--enable-multiconfig` configure option, multiple
flavors of the library with different options can coexist in the
same root installation directory. For example,

```
    ./configure --enable-multiconfig --with-libxc=${LIBXC_ROOT}  --prefix=${GRIDXC_ROOT}
    make
    make check
    make install

    FC=$MPIFC CC=$MPICC ../configure --enable-multiconfig  --with-mpi=${MPI_ROOT} --with-libxc=${LIBXC_ROOT}  --prefix=${GRIDXC_ROOT}
    make
    make check
    make install
```

will result in

```
${GRIDXC_ROOT}:
├── include
│   ├── gridxc_dp
│   │   ├── gridxc.mod
        ...
│   └── gridxc_dp_mpi
│       ├── gridxc.mod
        ...
├── lib
        ...
│   ├── libgridxc_dp.a
│   ├── libgridxc_dp_mpi.a
```

This idea can be extended to the single/double precision options. The
script `multiconfig-build.sh` in the top level of the distribution can
be used to configure, compile, and install all available flavors of the library:
```
gridxc_dp
gridxc_dp_mpi
gridxc_sp
gridxc_sp_mpi
```

This is recommended procedure for production versions of the library. The script should be invoked with
the appropriate variables in the environment. For example: (note the escaped newlines):
```
FC=gfortran  MPIFC=mpif90  MPICC=mpicc \
LIBXC_ROOT=/path/to/libxc/installation \
MPI_ROOT=/path/to/mpi/installation \
GRIDXC_PREFIX=/path/to/desired/installation  sh multiconfig-build.sh
```

### Compiling user programs

Using the multi-config option discussed above, the appropriate modules
will be in `$GRIDXC_ROOT/include/gridxc_<flavor>`, and the library
file will be `$GRIDXC_ROOT/lib/libgridxc_<flavor>.a`, where `$GRIDXC_ROOT` is the value
of the `GRIDXC_PREFIX` installation option above.

## Installation of libGridXC with CMake

A single version of the library will be installed, with features determined by the settings of the options (defaults shown):

```
option(WITH_MPI "Whether libgridxc should support MPI-parallelism" FALSE)
option(WITH_GRID_SP "Whether libgridxc has a single-precision (cellxc only) interface" FALSE)
```

For example, a double precision MPI version can be built and installed with
```
cmake -S. -B_build -DWITH_MPI=ON -DCMAKE_INSTALL_PREFIX=/path/to/installation
cmake --build _build
cmake --build _build --target test  # Optional
cmake --install _build
```

In addition, libxc support can be enabled with ``-DWITH_LIBXC=ON``, and the location of libxc should be added to the search path:

```
CMAKE_PREFIX_PATH=$LIBXC_ROOT cmake -S. -B_build -DWITH_MPI=ON -DWITH_LIBXC=ON -DCMAKE_INSTALL_PREFIX=/path/to/installation
```

### Compiling user programs using the CMake-installed version

Just use the standard CMake idiom in your CMakeLists.txt file:

```
    add_executable(your_program your_sources)
    find_package(libgridxc REQUIRED)
    target_link_libraries(your_program libgridxc::libgridxc)
```

The above assumes that the installation directory for libgridxc can
be found by CMake. This can be achieved by adding it to the CMAKE_PREFIX_PATH
CMake or enviroment variable:

```
    cmake -S. -B_your_build -DCMAKE_PREFIX_PATH=$GRIDXC_ROOT .......
    CMAKE_PREFIX_PATH=$GRIDXC_ROOT cmake -S. -B_your_build .......
```

Depending on your system and options, you might need to provide also the path to the libxc installation.
